
// This is opencascade.js.

var opencascade = (function() {
  var _scriptDir = typeof document !== 'undefined' && document.currentScript ? document.currentScript.src : undefined;
  if (typeof __filename !== 'undefined') _scriptDir = _scriptDir || __filename;
  return (
function(opencascade) {
  opencascade = opencascade || {};

var Module=typeof opencascade!=="undefined"?opencascade:{};var readyPromiseResolve,readyPromiseReject;Module["ready"]=new Promise(function(resolve,reject){readyPromiseResolve=resolve;readyPromiseReject=reject});var moduleOverrides={};var key;for(key in Module){if(Module.hasOwnProperty(key)){moduleOverrides[key]=Module[key]}}var arguments_=[];var thisProgram="./this.program";var quit_=function(status,toThrow){throw toThrow};var ENVIRONMENT_IS_WEB=false;var ENVIRONMENT_IS_WORKER=false;var ENVIRONMENT_IS_NODE=false;var ENVIRONMENT_IS_SHELL=false;ENVIRONMENT_IS_WEB=typeof window==="object";ENVIRONMENT_IS_WORKER=typeof importScripts==="function";ENVIRONMENT_IS_NODE=typeof process==="object"&&typeof process.versions==="object"&&typeof process.versions.node==="string";ENVIRONMENT_IS_SHELL=!ENVIRONMENT_IS_WEB&&!ENVIRONMENT_IS_NODE&&!ENVIRONMENT_IS_WORKER;var scriptDirectory="";function locateFile(path){if(Module["locateFile"]){return Module["locateFile"](path,scriptDirectory)}return scriptDirectory+path}var read_,readAsync,readBinary,setWindowTitle;var nodeFS;var nodePath;if(ENVIRONMENT_IS_NODE){if(ENVIRONMENT_IS_WORKER){scriptDirectory=require("path").dirname(scriptDirectory)+"/"}else{scriptDirectory=__dirname+"/"}read_=function shell_read(filename,binary){if(!nodeFS)nodeFS=require("fs");if(!nodePath)nodePath=require("path");filename=nodePath["normalize"](filename);return nodeFS["readFileSync"](filename,binary?null:"utf8")};readBinary=function readBinary(filename){var ret=read_(filename,true);if(!ret.buffer){ret=new Uint8Array(ret)}assert(ret.buffer);return ret};if(process["argv"].length>1){thisProgram=process["argv"][1].replace(/\\/g,"/")}arguments_=process["argv"].slice(2);process["on"]("uncaughtException",function(ex){if(!(ex instanceof ExitStatus)){throw ex}});process["on"]("unhandledRejection",abort);quit_=function(status){process["exit"](status)};Module["inspect"]=function(){return"[Emscripten Module object]"}}else if(ENVIRONMENT_IS_SHELL){if(typeof read!="undefined"){read_=function shell_read(f){return read(f)}}readBinary=function readBinary(f){var data;if(typeof readbuffer==="function"){return new Uint8Array(readbuffer(f))}data=read(f,"binary");assert(typeof data==="object");return data};if(typeof scriptArgs!="undefined"){arguments_=scriptArgs}else if(typeof arguments!="undefined"){arguments_=arguments}if(typeof quit==="function"){quit_=function(status){quit(status)}}if(typeof print!=="undefined"){if(typeof console==="undefined")console={};console.log=print;console.warn=console.error=typeof printErr!=="undefined"?printErr:print}}else if(ENVIRONMENT_IS_WEB||ENVIRONMENT_IS_WORKER){if(ENVIRONMENT_IS_WORKER){scriptDirectory=self.location.href}else if(document.currentScript){scriptDirectory=document.currentScript.src}if(_scriptDir){scriptDirectory=_scriptDir}if(scriptDirectory.indexOf("blob:")!==0){scriptDirectory=scriptDirectory.substr(0,scriptDirectory.lastIndexOf("/")+1)}else{scriptDirectory=""}{read_=function shell_read(url){var xhr=new XMLHttpRequest;xhr.open("GET",url,false);xhr.send(null);return xhr.responseText};if(ENVIRONMENT_IS_WORKER){readBinary=function readBinary(url){var xhr=new XMLHttpRequest;xhr.open("GET",url,false);xhr.responseType="arraybuffer";xhr.send(null);return new Uint8Array(xhr.response)}}readAsync=function readAsync(url,onload,onerror){var xhr=new XMLHttpRequest;xhr.open("GET",url,true);xhr.responseType="arraybuffer";xhr.onload=function xhr_onload(){if(xhr.status==200||xhr.status==0&&xhr.response){onload(xhr.response);return}onerror()};xhr.onerror=onerror;xhr.send(null)}}setWindowTitle=function(title){document.title=title}}else{}var out=Module["print"]||console.log.bind(console);var err=Module["printErr"]||console.warn.bind(console);for(key in moduleOverrides){if(moduleOverrides.hasOwnProperty(key)){Module[key]=moduleOverrides[key]}}moduleOverrides=null;if(Module["arguments"])arguments_=Module["arguments"];if(Module["thisProgram"])thisProgram=Module["thisProgram"];if(Module["quit"])quit_=Module["quit"];var STACK_ALIGN=16;function alignMemory(size,factor){if(!factor)factor=STACK_ALIGN;return Math.ceil(size/factor)*factor}var tempRet0=0;var setTempRet0=function(value){tempRet0=value};var getTempRet0=function(){return tempRet0};var wasmBinary;if(Module["wasmBinary"])wasmBinary=Module["wasmBinary"];var noExitRuntime;if(Module["noExitRuntime"])noExitRuntime=Module["noExitRuntime"];if(typeof WebAssembly!=="object"){abort("no native wasm support detected")}var wasmMemory;var wasmTable=new WebAssembly.Table({"initial":32517,"maximum":32517+0,"element":"anyfunc"});var ABORT=false;var EXITSTATUS=0;function assert(condition,text){if(!condition){abort("Assertion failed: "+text)}}var UTF8Decoder=typeof TextDecoder!=="undefined"?new TextDecoder("utf8"):undefined;function UTF8ArrayToString(heap,idx,maxBytesToRead){var endIdx=idx+maxBytesToRead;var endPtr=idx;while(heap[endPtr]&&!(endPtr>=endIdx))++endPtr;if(endPtr-idx>16&&heap.subarray&&UTF8Decoder){return UTF8Decoder.decode(heap.subarray(idx,endPtr))}else{var str="";while(idx<endPtr){var u0=heap[idx++];if(!(u0&128)){str+=String.fromCharCode(u0);continue}var u1=heap[idx++]&63;if((u0&224)==192){str+=String.fromCharCode((u0&31)<<6|u1);continue}var u2=heap[idx++]&63;if((u0&240)==224){u0=(u0&15)<<12|u1<<6|u2}else{u0=(u0&7)<<18|u1<<12|u2<<6|heap[idx++]&63}if(u0<65536){str+=String.fromCharCode(u0)}else{var ch=u0-65536;str+=String.fromCharCode(55296|ch>>10,56320|ch&1023)}}}return str}function UTF8ToString(ptr,maxBytesToRead){return ptr?UTF8ArrayToString(HEAPU8,ptr,maxBytesToRead):""}function stringToUTF8Array(str,heap,outIdx,maxBytesToWrite){if(!(maxBytesToWrite>0))return 0;var startIdx=outIdx;var endIdx=outIdx+maxBytesToWrite-1;for(var i=0;i<str.length;++i){var u=str.charCodeAt(i);if(u>=55296&&u<=57343){var u1=str.charCodeAt(++i);u=65536+((u&1023)<<10)|u1&1023}if(u<=127){if(outIdx>=endIdx)break;heap[outIdx++]=u}else if(u<=2047){if(outIdx+1>=endIdx)break;heap[outIdx++]=192|u>>6;heap[outIdx++]=128|u&63}else if(u<=65535){if(outIdx+2>=endIdx)break;heap[outIdx++]=224|u>>12;heap[outIdx++]=128|u>>6&63;heap[outIdx++]=128|u&63}else{if(outIdx+3>=endIdx)break;heap[outIdx++]=240|u>>18;heap[outIdx++]=128|u>>12&63;heap[outIdx++]=128|u>>6&63;heap[outIdx++]=128|u&63}}heap[outIdx]=0;return outIdx-startIdx}function stringToUTF8(str,outPtr,maxBytesToWrite){return stringToUTF8Array(str,HEAPU8,outPtr,maxBytesToWrite)}function lengthBytesUTF8(str){var len=0;for(var i=0;i<str.length;++i){var u=str.charCodeAt(i);if(u>=55296&&u<=57343)u=65536+((u&1023)<<10)|str.charCodeAt(++i)&1023;if(u<=127)++len;else if(u<=2047)len+=2;else if(u<=65535)len+=3;else len+=4}return len}function allocateUTF8(str){var size=lengthBytesUTF8(str)+1;var ret=_malloc(size);if(ret)stringToUTF8Array(str,HEAP8,ret,size);return ret}function writeArrayToMemory(array,buffer){HEAP8.set(array,buffer)}function writeAsciiToMemory(str,buffer,dontAddNull){for(var i=0;i<str.length;++i){HEAP8[buffer++>>0]=str.charCodeAt(i)}if(!dontAddNull)HEAP8[buffer>>0]=0}var WASM_PAGE_SIZE=65536;function alignUp(x,multiple){if(x%multiple>0){x+=multiple-x%multiple}return x}var buffer,HEAP8,HEAPU8,HEAP16,HEAPU16,HEAP32,HEAPU32,HEAPF32,HEAPF64;function updateGlobalBufferAndViews(buf){buffer=buf;Module["HEAP8"]=HEAP8=new Int8Array(buf);Module["HEAP16"]=HEAP16=new Int16Array(buf);Module["HEAP32"]=HEAP32=new Int32Array(buf);Module["HEAPU8"]=HEAPU8=new Uint8Array(buf);Module["HEAPU16"]=HEAPU16=new Uint16Array(buf);Module["HEAPU32"]=HEAPU32=new Uint32Array(buf);Module["HEAPF32"]=HEAPF32=new Float32Array(buf);Module["HEAPF64"]=HEAPF64=new Float64Array(buf)}var DYNAMIC_BASE=7945024,DYNAMICTOP_PTR=2701984;var INITIAL_INITIAL_MEMORY=Module["INITIAL_MEMORY"]||67108864;if(Module["wasmMemory"]){wasmMemory=Module["wasmMemory"]}else{wasmMemory=new WebAssembly.Memory({"initial":INITIAL_INITIAL_MEMORY/WASM_PAGE_SIZE,"maximum":2147483648/WASM_PAGE_SIZE})}if(wasmMemory){buffer=wasmMemory.buffer}INITIAL_INITIAL_MEMORY=buffer.byteLength;updateGlobalBufferAndViews(buffer);HEAP32[DYNAMICTOP_PTR>>2]=DYNAMIC_BASE;function callRuntimeCallbacks(callbacks){while(callbacks.length>0){var callback=callbacks.shift();if(typeof callback=="function"){callback(Module);continue}var func=callback.func;if(typeof func==="number"){if(callback.arg===undefined){Module["dynCall_v"](func)}else{Module["dynCall_vi"](func,callback.arg)}}else{func(callback.arg===undefined?null:callback.arg)}}}var __ATPRERUN__=[];var __ATINIT__=[];var __ATMAIN__=[];var __ATPOSTRUN__=[];var runtimeInitialized=false;var runtimeExited=false;function preRun(){if(Module["preRun"]){if(typeof Module["preRun"]=="function")Module["preRun"]=[Module["preRun"]];while(Module["preRun"].length){addOnPreRun(Module["preRun"].shift())}}callRuntimeCallbacks(__ATPRERUN__)}function initRuntime(){runtimeInitialized=true;if(!Module["noFSInit"]&&!FS.init.initialized)FS.init();TTY.init();callRuntimeCallbacks(__ATINIT__)}function preMain(){FS.ignorePermissions=false;callRuntimeCallbacks(__ATMAIN__)}function exitRuntime(){runtimeExited=true}function postRun(){if(Module["postRun"]){if(typeof Module["postRun"]=="function")Module["postRun"]=[Module["postRun"]];while(Module["postRun"].length){addOnPostRun(Module["postRun"].shift())}}callRuntimeCallbacks(__ATPOSTRUN__)}function addOnPreRun(cb){__ATPRERUN__.unshift(cb)}function addOnPreMain(cb){__ATMAIN__.unshift(cb)}function addOnPostRun(cb){__ATPOSTRUN__.unshift(cb)}var Math_abs=Math.abs;var Math_ceil=Math.ceil;var Math_floor=Math.floor;var Math_min=Math.min;var runDependencies=0;var runDependencyWatcher=null;var dependenciesFulfilled=null;function getUniqueRunDependency(id){return id}function addRunDependency(id){runDependencies++;if(Module["monitorRunDependencies"]){Module["monitorRunDependencies"](runDependencies)}}function removeRunDependency(id){runDependencies--;if(Module["monitorRunDependencies"]){Module["monitorRunDependencies"](runDependencies)}if(runDependencies==0){if(runDependencyWatcher!==null){clearInterval(runDependencyWatcher);runDependencyWatcher=null}if(dependenciesFulfilled){var callback=dependenciesFulfilled;dependenciesFulfilled=null;callback()}}}Module["preloadedImages"]={};Module["preloadedAudios"]={};function abort(what){if(Module["onAbort"]){Module["onAbort"](what)}what+="";err(what);ABORT=true;EXITSTATUS=1;what="abort("+what+"). Build with -s ASSERTIONS=1 for more info.";var e=new WebAssembly.RuntimeError(what);readyPromiseReject(e);throw e}function hasPrefix(str,prefix){return String.prototype.startsWith?str.startsWith(prefix):str.indexOf(prefix)===0}var dataURIPrefix="data:application/octet-stream;base64,";function isDataURI(filename){return hasPrefix(filename,dataURIPrefix)}var fileURIPrefix="file://";function isFileURI(filename){return hasPrefix(filename,fileURIPrefix)}var wasmBinaryFile="opencascade.wasm.wasm";if(!isDataURI(wasmBinaryFile)){wasmBinaryFile=locateFile(wasmBinaryFile)}function getBinary(){try{if(wasmBinary){return new Uint8Array(wasmBinary)}if(readBinary){return readBinary(wasmBinaryFile)}else{throw"both async and sync fetching of the wasm failed"}}catch(err){abort(err)}}function getBinaryPromise(){if(!wasmBinary&&(ENVIRONMENT_IS_WEB||ENVIRONMENT_IS_WORKER)&&typeof fetch==="function"&&!isFileURI(wasmBinaryFile)){return fetch(wasmBinaryFile,{credentials:"same-origin"}).then(function(response){if(!response["ok"]){throw"failed to load wasm binary file at '"+wasmBinaryFile+"'"}return response["arrayBuffer"]()}).catch(function(){return getBinary()})}return new Promise(function(resolve,reject){resolve(getBinary())})}function createWasm(){var info={"a":asmLibraryArg};function receiveInstance(instance,module){var exports=instance.exports;Module["asm"]=exports;removeRunDependency("wasm-instantiate")}addRunDependency("wasm-instantiate");function receiveInstantiatedSource(output){receiveInstance(output["instance"])}function instantiateArrayBuffer(receiver){return getBinaryPromise().then(function(binary){return WebAssembly.instantiate(binary,info)}).then(receiver,function(reason){err("failed to asynchronously prepare wasm: "+reason);abort(reason)})}function instantiateAsync(){if(!wasmBinary&&typeof WebAssembly.instantiateStreaming==="function"&&!isDataURI(wasmBinaryFile)&&!isFileURI(wasmBinaryFile)&&typeof fetch==="function"){fetch(wasmBinaryFile,{credentials:"same-origin"}).then(function(response){var result=WebAssembly.instantiateStreaming(response,info);return result.then(receiveInstantiatedSource,function(reason){err("wasm streaming compile failed: "+reason);err("falling back to ArrayBuffer instantiation");return instantiateArrayBuffer(receiveInstantiatedSource)})})}else{return instantiateArrayBuffer(receiveInstantiatedSource)}}if(Module["instantiateWasm"]){try{var exports=Module["instantiateWasm"](info,receiveInstance);return exports}catch(e){err("Module.instantiateWasm callback failed with error: "+e);return false}}instantiateAsync();return{}}var tempDouble;var tempI64;__ATINIT__.push({func:function(){___wasm_call_ctors()}});function demangle(func){return func}function demangleAll(text){var regex=/\b_Z[\w\d_]+/g;return text.replace(regex,function(x){var y=demangle(x);return x===y?x:y+" ["+x+"]"})}function jsStackTrace(){var err=new Error;if(!err.stack){try{throw new Error}catch(e){err=e}if(!err.stack){return"(no stack trace available)"}}return err.stack.toString()}function stackTrace(){var js=jsStackTrace();if(Module["extraStackTrace"])js+="\n"+Module["extraStackTrace"]();return demangleAll(js)}function ___cxa_allocate_exception(size){return _malloc(size)}function _atexit(func,arg){}var ___exception_infos={};var ___exception_caught=[];function ___exception_addRef(ptr){if(!ptr)return;var info=___exception_infos[ptr];info.refcount++}function ___exception_deAdjust(adjusted){if(!adjusted||___exception_infos[adjusted])return adjusted;for(var key in ___exception_infos){var ptr=+key;var adj=___exception_infos[ptr].adjusted;var len=adj.length;for(var i=0;i<len;i++){if(adj[i]===adjusted){return ptr}}}return adjusted}function ___cxa_begin_catch(ptr){var info=___exception_infos[ptr];if(info&&!info.caught){info.caught=true;__ZSt18uncaught_exceptionv.uncaught_exceptions--}if(info)info.rethrown=false;___exception_caught.push(ptr);___exception_addRef(___exception_deAdjust(ptr));return ptr}var ___exception_last=0;function ___cxa_free_exception(ptr){return _free(ptr)}function ___exception_decRef(ptr){if(!ptr)return;var info=___exception_infos[ptr];info.refcount--;if(info.refcount===0&&!info.rethrown){if(info.destructor){Module["dynCall_ii"](info.destructor,ptr)}delete ___exception_infos[ptr];___cxa_free_exception(ptr)}}function ___cxa_end_catch(){_setThrew(0);var ptr=___exception_caught.pop();if(ptr){___exception_decRef(___exception_deAdjust(ptr));___exception_last=0}}function ___cxa_find_matching_catch_2(){var thrown=___exception_last;if(!thrown){return(setTempRet0(0),0)|0}var info=___exception_infos[thrown];var throwntype=info.type;if(!throwntype){return(setTempRet0(0),thrown)|0}var typeArray=Array.prototype.slice.call(arguments);var pointer=___cxa_is_pointer_type(throwntype);var buffer=0;HEAP32[buffer>>2]=thrown;thrown=buffer;for(var i=0;i<typeArray.length;i++){if(typeArray[i]&&___cxa_can_catch(typeArray[i],throwntype,thrown)){thrown=HEAP32[thrown>>2];info.adjusted.push(thrown);return(setTempRet0(typeArray[i]),thrown)|0}}thrown=HEAP32[thrown>>2];return(setTempRet0(throwntype),thrown)|0}function ___cxa_find_matching_catch_3(){var thrown=___exception_last;if(!thrown){return(setTempRet0(0),0)|0}var info=___exception_infos[thrown];var throwntype=info.type;if(!throwntype){return(setTempRet0(0),thrown)|0}var typeArray=Array.prototype.slice.call(arguments);var pointer=___cxa_is_pointer_type(throwntype);var buffer=0;HEAP32[buffer>>2]=thrown;thrown=buffer;for(var i=0;i<typeArray.length;i++){if(typeArray[i]&&___cxa_can_catch(typeArray[i],throwntype,thrown)){thrown=HEAP32[thrown>>2];info.adjusted.push(thrown);return(setTempRet0(typeArray[i]),thrown)|0}}thrown=HEAP32[thrown>>2];return(setTempRet0(throwntype),thrown)|0}function ___cxa_find_matching_catch_4(){var thrown=___exception_last;if(!thrown){return(setTempRet0(0),0)|0}var info=___exception_infos[thrown];var throwntype=info.type;if(!throwntype){return(setTempRet0(0),thrown)|0}var typeArray=Array.prototype.slice.call(arguments);var pointer=___cxa_is_pointer_type(throwntype);var buffer=0;HEAP32[buffer>>2]=thrown;thrown=buffer;for(var i=0;i<typeArray.length;i++){if(typeArray[i]&&___cxa_can_catch(typeArray[i],throwntype,thrown)){thrown=HEAP32[thrown>>2];info.adjusted.push(thrown);return(setTempRet0(typeArray[i]),thrown)|0}}thrown=HEAP32[thrown>>2];return(setTempRet0(throwntype),thrown)|0}function ___cxa_find_matching_catch_5(){var thrown=___exception_last;if(!thrown){return(setTempRet0(0),0)|0}var info=___exception_infos[thrown];var throwntype=info.type;if(!throwntype){return(setTempRet0(0),thrown)|0}var typeArray=Array.prototype.slice.call(arguments);var pointer=___cxa_is_pointer_type(throwntype);var buffer=0;HEAP32[buffer>>2]=thrown;thrown=buffer;for(var i=0;i<typeArray.length;i++){if(typeArray[i]&&___cxa_can_catch(typeArray[i],throwntype,thrown)){thrown=HEAP32[thrown>>2];info.adjusted.push(thrown);return(setTempRet0(typeArray[i]),thrown)|0}}thrown=HEAP32[thrown>>2];return(setTempRet0(throwntype),thrown)|0}function ___cxa_rethrow(){var ptr=___exception_caught.pop();ptr=___exception_deAdjust(ptr);if(!___exception_infos[ptr].rethrown){___exception_caught.push(ptr);___exception_infos[ptr].rethrown=true}___exception_last=ptr;throw ptr}function ___cxa_thread_atexit(a0,a1){return _atexit(a0,a1)}function ___cxa_throw(ptr,type,destructor){___exception_infos[ptr]={ptr:ptr,adjusted:[ptr],type:type,destructor:destructor,refcount:0,caught:false,rethrown:false};___exception_last=ptr;if(!("uncaught_exception"in __ZSt18uncaught_exceptionv)){__ZSt18uncaught_exceptionv.uncaught_exceptions=1}else{__ZSt18uncaught_exceptionv.uncaught_exceptions++}throw ptr}function setErrNo(value){HEAP32[___errno_location()>>2]=value;return value}function ___map_file(pathname,size){setErrNo(63);return-1}function ___resumeException(ptr){if(!___exception_last){___exception_last=ptr}throw ptr}var PATH={splitPath:function(filename){var splitPathRe=/^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;return splitPathRe.exec(filename).slice(1)},normalizeArray:function(parts,allowAboveRoot){var up=0;for(var i=parts.length-1;i>=0;i--){var last=parts[i];if(last==="."){parts.splice(i,1)}else if(last===".."){parts.splice(i,1);up++}else if(up){parts.splice(i,1);up--}}if(allowAboveRoot){for(;up;up--){parts.unshift("..")}}return parts},normalize:function(path){var isAbsolute=path.charAt(0)==="/",trailingSlash=path.substr(-1)==="/";path=PATH.normalizeArray(path.split("/").filter(function(p){return!!p}),!isAbsolute).join("/");if(!path&&!isAbsolute){path="."}if(path&&trailingSlash){path+="/"}return(isAbsolute?"/":"")+path},dirname:function(path){var result=PATH.splitPath(path),root=result[0],dir=result[1];if(!root&&!dir){return"."}if(dir){dir=dir.substr(0,dir.length-1)}return root+dir},basename:function(path){if(path==="/")return"/";var lastSlash=path.lastIndexOf("/");if(lastSlash===-1)return path;return path.substr(lastSlash+1)},extname:function(path){return PATH.splitPath(path)[3]},join:function(){var paths=Array.prototype.slice.call(arguments,0);return PATH.normalize(paths.join("/"))},join2:function(l,r){return PATH.normalize(l+"/"+r)}};var PATH_FS={resolve:function(){var resolvedPath="",resolvedAbsolute=false;for(var i=arguments.length-1;i>=-1&&!resolvedAbsolute;i--){var path=i>=0?arguments[i]:FS.cwd();if(typeof path!=="string"){throw new TypeError("Arguments to path.resolve must be strings")}else if(!path){return""}resolvedPath=path+"/"+resolvedPath;resolvedAbsolute=path.charAt(0)==="/"}resolvedPath=PATH.normalizeArray(resolvedPath.split("/").filter(function(p){return!!p}),!resolvedAbsolute).join("/");return(resolvedAbsolute?"/":"")+resolvedPath||"."},relative:function(from,to){from=PATH_FS.resolve(from).substr(1);to=PATH_FS.resolve(to).substr(1);function trim(arr){var start=0;for(;start<arr.length;start++){if(arr[start]!=="")break}var end=arr.length-1;for(;end>=0;end--){if(arr[end]!=="")break}if(start>end)return[];return arr.slice(start,end-start+1)}var fromParts=trim(from.split("/"));var toParts=trim(to.split("/"));var length=Math.min(fromParts.length,toParts.length);var samePartsLength=length;for(var i=0;i<length;i++){if(fromParts[i]!==toParts[i]){samePartsLength=i;break}}var outputParts=[];for(var i=samePartsLength;i<fromParts.length;i++){outputParts.push("..")}outputParts=outputParts.concat(toParts.slice(samePartsLength));return outputParts.join("/")}};var TTY={ttys:[],init:function(){},shutdown:function(){},register:function(dev,ops){TTY.ttys[dev]={input:[],output:[],ops:ops};FS.registerDevice(dev,TTY.stream_ops)},stream_ops:{open:function(stream){var tty=TTY.ttys[stream.node.rdev];if(!tty){throw new FS.ErrnoError(43)}stream.tty=tty;stream.seekable=false},close:function(stream){stream.tty.ops.flush(stream.tty)},flush:function(stream){stream.tty.ops.flush(stream.tty)},read:function(stream,buffer,offset,length,pos){if(!stream.tty||!stream.tty.ops.get_char){throw new FS.ErrnoError(60)}var bytesRead=0;for(var i=0;i<length;i++){var result;try{result=stream.tty.ops.get_char(stream.tty)}catch(e){throw new FS.ErrnoError(29)}if(result===undefined&&bytesRead===0){throw new FS.ErrnoError(6)}if(result===null||result===undefined)break;bytesRead++;buffer[offset+i]=result}if(bytesRead){stream.node.timestamp=Date.now()}return bytesRead},write:function(stream,buffer,offset,length,pos){if(!stream.tty||!stream.tty.ops.put_char){throw new FS.ErrnoError(60)}try{for(var i=0;i<length;i++){stream.tty.ops.put_char(stream.tty,buffer[offset+i])}}catch(e){throw new FS.ErrnoError(29)}if(length){stream.node.timestamp=Date.now()}return i}},default_tty_ops:{get_char:function(tty){if(!tty.input.length){var result=null;if(ENVIRONMENT_IS_NODE){var BUFSIZE=256;var buf=Buffer.alloc?Buffer.alloc(BUFSIZE):new Buffer(BUFSIZE);var bytesRead=0;try{bytesRead=nodeFS.readSync(process.stdin.fd,buf,0,BUFSIZE,null)}catch(e){if(e.toString().indexOf("EOF")!=-1)bytesRead=0;else throw e}if(bytesRead>0){result=buf.slice(0,bytesRead).toString("utf-8")}else{result=null}}else if(typeof window!="undefined"&&typeof window.prompt=="function"){result=window.prompt("Input: ");if(result!==null){result+="\n"}}else if(typeof readline=="function"){result=readline();if(result!==null){result+="\n"}}if(!result){return null}tty.input=intArrayFromString(result,true)}return tty.input.shift()},put_char:function(tty,val){if(val===null||val===10){out(UTF8ArrayToString(tty.output,0));tty.output=[]}else{if(val!=0)tty.output.push(val)}},flush:function(tty){if(tty.output&&tty.output.length>0){out(UTF8ArrayToString(tty.output,0));tty.output=[]}}},default_tty1_ops:{put_char:function(tty,val){if(val===null||val===10){err(UTF8ArrayToString(tty.output,0));tty.output=[]}else{if(val!=0)tty.output.push(val)}},flush:function(tty){if(tty.output&&tty.output.length>0){err(UTF8ArrayToString(tty.output,0));tty.output=[]}}}};var MEMFS={ops_table:null,mount:function(mount){return MEMFS.createNode(null,"/",16384|511,0)},createNode:function(parent,name,mode,dev){if(FS.isBlkdev(mode)||FS.isFIFO(mode)){throw new FS.ErrnoError(63)}if(!MEMFS.ops_table){MEMFS.ops_table={dir:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr,lookup:MEMFS.node_ops.lookup,mknod:MEMFS.node_ops.mknod,rename:MEMFS.node_ops.rename,unlink:MEMFS.node_ops.unlink,rmdir:MEMFS.node_ops.rmdir,readdir:MEMFS.node_ops.readdir,symlink:MEMFS.node_ops.symlink},stream:{llseek:MEMFS.stream_ops.llseek}},file:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr},stream:{llseek:MEMFS.stream_ops.llseek,read:MEMFS.stream_ops.read,write:MEMFS.stream_ops.write,allocate:MEMFS.stream_ops.allocate,mmap:MEMFS.stream_ops.mmap,msync:MEMFS.stream_ops.msync}},link:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr,readlink:MEMFS.node_ops.readlink},stream:{}},chrdev:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr},stream:FS.chrdev_stream_ops}}}var node=FS.createNode(parent,name,mode,dev);if(FS.isDir(node.mode)){node.node_ops=MEMFS.ops_table.dir.node;node.stream_ops=MEMFS.ops_table.dir.stream;node.contents={}}else if(FS.isFile(node.mode)){node.node_ops=MEMFS.ops_table.file.node;node.stream_ops=MEMFS.ops_table.file.stream;node.usedBytes=0;node.contents=null}else if(FS.isLink(node.mode)){node.node_ops=MEMFS.ops_table.link.node;node.stream_ops=MEMFS.ops_table.link.stream}else if(FS.isChrdev(node.mode)){node.node_ops=MEMFS.ops_table.chrdev.node;node.stream_ops=MEMFS.ops_table.chrdev.stream}node.timestamp=Date.now();if(parent){parent.contents[name]=node}return node},getFileDataAsRegularArray:function(node){if(node.contents&&node.contents.subarray){var arr=[];for(var i=0;i<node.usedBytes;++i)arr.push(node.contents[i]);return arr}return node.contents},getFileDataAsTypedArray:function(node){if(!node.contents)return new Uint8Array(0);if(node.contents.subarray)return node.contents.subarray(0,node.usedBytes);return new Uint8Array(node.contents)},expandFileStorage:function(node,newCapacity){var prevCapacity=node.contents?node.contents.length:0;if(prevCapacity>=newCapacity)return;var CAPACITY_DOUBLING_MAX=1024*1024;newCapacity=Math.max(newCapacity,prevCapacity*(prevCapacity<CAPACITY_DOUBLING_MAX?2:1.125)>>>0);if(prevCapacity!=0)newCapacity=Math.max(newCapacity,256);var oldContents=node.contents;node.contents=new Uint8Array(newCapacity);if(node.usedBytes>0)node.contents.set(oldContents.subarray(0,node.usedBytes),0);return},resizeFileStorage:function(node,newSize){if(node.usedBytes==newSize)return;if(newSize==0){node.contents=null;node.usedBytes=0;return}if(!node.contents||node.contents.subarray){var oldContents=node.contents;node.contents=new Uint8Array(newSize);if(oldContents){node.contents.set(oldContents.subarray(0,Math.min(newSize,node.usedBytes)))}node.usedBytes=newSize;return}if(!node.contents)node.contents=[];if(node.contents.length>newSize)node.contents.length=newSize;else while(node.contents.length<newSize)node.contents.push(0);node.usedBytes=newSize},node_ops:{getattr:function(node){var attr={};attr.dev=FS.isChrdev(node.mode)?node.id:1;attr.ino=node.id;attr.mode=node.mode;attr.nlink=1;attr.uid=0;attr.gid=0;attr.rdev=node.rdev;if(FS.isDir(node.mode)){attr.size=4096}else if(FS.isFile(node.mode)){attr.size=node.usedBytes}else if(FS.isLink(node.mode)){attr.size=node.link.length}else{attr.size=0}attr.atime=new Date(node.timestamp);attr.mtime=new Date(node.timestamp);attr.ctime=new Date(node.timestamp);attr.blksize=4096;attr.blocks=Math.ceil(attr.size/attr.blksize);return attr},setattr:function(node,attr){if(attr.mode!==undefined){node.mode=attr.mode}if(attr.timestamp!==undefined){node.timestamp=attr.timestamp}if(attr.size!==undefined){MEMFS.resizeFileStorage(node,attr.size)}},lookup:function(parent,name){throw FS.genericErrors[44]},mknod:function(parent,name,mode,dev){return MEMFS.createNode(parent,name,mode,dev)},rename:function(old_node,new_dir,new_name){if(FS.isDir(old_node.mode)){var new_node;try{new_node=FS.lookupNode(new_dir,new_name)}catch(e){}if(new_node){for(var i in new_node.contents){throw new FS.ErrnoError(55)}}}delete old_node.parent.contents[old_node.name];old_node.name=new_name;new_dir.contents[new_name]=old_node;old_node.parent=new_dir},unlink:function(parent,name){delete parent.contents[name]},rmdir:function(parent,name){var node=FS.lookupNode(parent,name);for(var i in node.contents){throw new FS.ErrnoError(55)}delete parent.contents[name]},readdir:function(node){var entries=[".",".."];for(var key in node.contents){if(!node.contents.hasOwnProperty(key)){continue}entries.push(key)}return entries},symlink:function(parent,newname,oldpath){var node=MEMFS.createNode(parent,newname,511|40960,0);node.link=oldpath;return node},readlink:function(node){if(!FS.isLink(node.mode)){throw new FS.ErrnoError(28)}return node.link}},stream_ops:{read:function(stream,buffer,offset,length,position){var contents=stream.node.contents;if(position>=stream.node.usedBytes)return 0;var size=Math.min(stream.node.usedBytes-position,length);if(size>8&&contents.subarray){buffer.set(contents.subarray(position,position+size),offset)}else{for(var i=0;i<size;i++)buffer[offset+i]=contents[position+i]}return size},write:function(stream,buffer,offset,length,position,canOwn){if(buffer.buffer===HEAP8.buffer){canOwn=false}if(!length)return 0;var node=stream.node;node.timestamp=Date.now();if(buffer.subarray&&(!node.contents||node.contents.subarray)){if(canOwn){node.contents=buffer.subarray(offset,offset+length);node.usedBytes=length;return length}else if(node.usedBytes===0&&position===0){node.contents=buffer.slice(offset,offset+length);node.usedBytes=length;return length}else if(position+length<=node.usedBytes){node.contents.set(buffer.subarray(offset,offset+length),position);return length}}MEMFS.expandFileStorage(node,position+length);if(node.contents.subarray&&buffer.subarray){node.contents.set(buffer.subarray(offset,offset+length),position)}else{for(var i=0;i<length;i++){node.contents[position+i]=buffer[offset+i]}}node.usedBytes=Math.max(node.usedBytes,position+length);return length},llseek:function(stream,offset,whence){var position=offset;if(whence===1){position+=stream.position}else if(whence===2){if(FS.isFile(stream.node.mode)){position+=stream.node.usedBytes}}if(position<0){throw new FS.ErrnoError(28)}return position},allocate:function(stream,offset,length){MEMFS.expandFileStorage(stream.node,offset+length);stream.node.usedBytes=Math.max(stream.node.usedBytes,offset+length)},mmap:function(stream,address,length,position,prot,flags){assert(address===0);if(!FS.isFile(stream.node.mode)){throw new FS.ErrnoError(43)}var ptr;var allocated;var contents=stream.node.contents;if(!(flags&2)&&contents.buffer===buffer){allocated=false;ptr=contents.byteOffset}else{if(position>0||position+length<contents.length){if(contents.subarray){contents=contents.subarray(position,position+length)}else{contents=Array.prototype.slice.call(contents,position,position+length)}}allocated=true;ptr=FS.mmapAlloc(length);if(!ptr){throw new FS.ErrnoError(48)}HEAP8.set(contents,ptr)}return{ptr:ptr,allocated:allocated}},msync:function(stream,buffer,offset,length,mmapFlags){if(!FS.isFile(stream.node.mode)){throw new FS.ErrnoError(43)}if(mmapFlags&2){return 0}var bytesWritten=MEMFS.stream_ops.write(stream,buffer,0,length,offset,false);return 0}}};var FS={root:null,mounts:[],devices:{},streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,trackingDelegate:{},tracking:{openFlags:{READ:1,WRITE:2}},ErrnoError:null,genericErrors:{},filesystems:null,syncFSRequests:0,handleFSError:function(e){if(!(e instanceof FS.ErrnoError))throw e+" : "+stackTrace();return setErrNo(e.errno)},lookupPath:function(path,opts){path=PATH_FS.resolve(FS.cwd(),path);opts=opts||{};if(!path)return{path:"",node:null};var defaults={follow_mount:true,recurse_count:0};for(var key in defaults){if(opts[key]===undefined){opts[key]=defaults[key]}}if(opts.recurse_count>8){throw new FS.ErrnoError(32)}var parts=PATH.normalizeArray(path.split("/").filter(function(p){return!!p}),false);var current=FS.root;var current_path="/";for(var i=0;i<parts.length;i++){var islast=i===parts.length-1;if(islast&&opts.parent){break}current=FS.lookupNode(current,parts[i]);current_path=PATH.join2(current_path,parts[i]);if(FS.isMountpoint(current)){if(!islast||islast&&opts.follow_mount){current=current.mounted.root}}if(!islast||opts.follow){var count=0;while(FS.isLink(current.mode)){var link=FS.readlink(current_path);current_path=PATH_FS.resolve(PATH.dirname(current_path),link);var lookup=FS.lookupPath(current_path,{recurse_count:opts.recurse_count});current=lookup.node;if(count++>40){throw new FS.ErrnoError(32)}}}}return{path:current_path,node:current}},getPath:function(node){var path;while(true){if(FS.isRoot(node)){var mount=node.mount.mountpoint;if(!path)return mount;return mount[mount.length-1]!=="/"?mount+"/"+path:mount+path}path=path?node.name+"/"+path:node.name;node=node.parent}},hashName:function(parentid,name){var hash=0;for(var i=0;i<name.length;i++){hash=(hash<<5)-hash+name.charCodeAt(i)|0}return(parentid+hash>>>0)%FS.nameTable.length},hashAddNode:function(node){var hash=FS.hashName(node.parent.id,node.name);node.name_next=FS.nameTable[hash];FS.nameTable[hash]=node},hashRemoveNode:function(node){var hash=FS.hashName(node.parent.id,node.name);if(FS.nameTable[hash]===node){FS.nameTable[hash]=node.name_next}else{var current=FS.nameTable[hash];while(current){if(current.name_next===node){current.name_next=node.name_next;break}current=current.name_next}}},lookupNode:function(parent,name){var errCode=FS.mayLookup(parent);if(errCode){throw new FS.ErrnoError(errCode,parent)}var hash=FS.hashName(parent.id,name);for(var node=FS.nameTable[hash];node;node=node.name_next){var nodeName=node.name;if(node.parent.id===parent.id&&nodeName===name){return node}}return FS.lookup(parent,name)},createNode:function(parent,name,mode,rdev){var node=new FS.FSNode(parent,name,mode,rdev);FS.hashAddNode(node);return node},destroyNode:function(node){FS.hashRemoveNode(node)},isRoot:function(node){return node===node.parent},isMountpoint:function(node){return!!node.mounted},isFile:function(mode){return(mode&61440)===32768},isDir:function(mode){return(mode&61440)===16384},isLink:function(mode){return(mode&61440)===40960},isChrdev:function(mode){return(mode&61440)===8192},isBlkdev:function(mode){return(mode&61440)===24576},isFIFO:function(mode){return(mode&61440)===4096},isSocket:function(mode){return(mode&49152)===49152},flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:function(str){var flags=FS.flagModes[str];if(typeof flags==="undefined"){throw new Error("Unknown file open mode: "+str)}return flags},flagsToPermissionString:function(flag){var perms=["r","w","rw"][flag&3];if(flag&512){perms+="w"}return perms},nodePermissions:function(node,perms){if(FS.ignorePermissions){return 0}if(perms.indexOf("r")!==-1&&!(node.mode&292)){return 2}else if(perms.indexOf("w")!==-1&&!(node.mode&146)){return 2}else if(perms.indexOf("x")!==-1&&!(node.mode&73)){return 2}return 0},mayLookup:function(dir){var errCode=FS.nodePermissions(dir,"x");if(errCode)return errCode;if(!dir.node_ops.lookup)return 2;return 0},mayCreate:function(dir,name){try{var node=FS.lookupNode(dir,name);return 20}catch(e){}return FS.nodePermissions(dir,"wx")},mayDelete:function(dir,name,isdir){var node;try{node=FS.lookupNode(dir,name)}catch(e){return e.errno}var errCode=FS.nodePermissions(dir,"wx");if(errCode){return errCode}if(isdir){if(!FS.isDir(node.mode)){return 54}if(FS.isRoot(node)||FS.getPath(node)===FS.cwd()){return 10}}else{if(FS.isDir(node.mode)){return 31}}return 0},mayOpen:function(node,flags){if(!node){return 44}if(FS.isLink(node.mode)){return 32}else if(FS.isDir(node.mode)){if(FS.flagsToPermissionString(flags)!=="r"||flags&512){return 31}}return FS.nodePermissions(node,FS.flagsToPermissionString(flags))},MAX_OPEN_FDS:4096,nextfd:function(fd_start,fd_end){fd_start=fd_start||0;fd_end=fd_end||FS.MAX_OPEN_FDS;for(var fd=fd_start;fd<=fd_end;fd++){if(!FS.streams[fd]){return fd}}throw new FS.ErrnoError(33)},getStream:function(fd){return FS.streams[fd]},createStream:function(stream,fd_start,fd_end){if(!FS.FSStream){FS.FSStream=function(){};FS.FSStream.prototype={object:{get:function(){return this.node},set:function(val){this.node=val}},isRead:{get:function(){return(this.flags&2097155)!==1}},isWrite:{get:function(){return(this.flags&2097155)!==0}},isAppend:{get:function(){return this.flags&1024}}}}var newStream=new FS.FSStream;for(var p in stream){newStream[p]=stream[p]}stream=newStream;var fd=FS.nextfd(fd_start,fd_end);stream.fd=fd;FS.streams[fd]=stream;return stream},closeStream:function(fd){FS.streams[fd]=null},chrdev_stream_ops:{open:function(stream){var device=FS.getDevice(stream.node.rdev);stream.stream_ops=device.stream_ops;if(stream.stream_ops.open){stream.stream_ops.open(stream)}},llseek:function(){throw new FS.ErrnoError(70)}},major:function(dev){return dev>>8},minor:function(dev){return dev&255},makedev:function(ma,mi){return ma<<8|mi},registerDevice:function(dev,ops){FS.devices[dev]={stream_ops:ops}},getDevice:function(dev){return FS.devices[dev]},getMounts:function(mount){var mounts=[];var check=[mount];while(check.length){var m=check.pop();mounts.push(m);check.push.apply(check,m.mounts)}return mounts},syncfs:function(populate,callback){if(typeof populate==="function"){callback=populate;populate=false}FS.syncFSRequests++;if(FS.syncFSRequests>1){err("warning: "+FS.syncFSRequests+" FS.syncfs operations in flight at once, probably just doing extra work")}var mounts=FS.getMounts(FS.root.mount);var completed=0;function doCallback(errCode){FS.syncFSRequests--;return callback(errCode)}function done(errCode){if(errCode){if(!done.errored){done.errored=true;return doCallback(errCode)}return}if(++completed>=mounts.length){doCallback(null)}}mounts.forEach(function(mount){if(!mount.type.syncfs){return done(null)}mount.type.syncfs(mount,populate,done)})},mount:function(type,opts,mountpoint){var root=mountpoint==="/";var pseudo=!mountpoint;var node;if(root&&FS.root){throw new FS.ErrnoError(10)}else if(!root&&!pseudo){var lookup=FS.lookupPath(mountpoint,{follow_mount:false});mountpoint=lookup.path;node=lookup.node;if(FS.isMountpoint(node)){throw new FS.ErrnoError(10)}if(!FS.isDir(node.mode)){throw new FS.ErrnoError(54)}}var mount={type:type,opts:opts,mountpoint:mountpoint,mounts:[]};var mountRoot=type.mount(mount);mountRoot.mount=mount;mount.root=mountRoot;if(root){FS.root=mountRoot}else if(node){node.mounted=mount;if(node.mount){node.mount.mounts.push(mount)}}return mountRoot},unmount:function(mountpoint){var lookup=FS.lookupPath(mountpoint,{follow_mount:false});if(!FS.isMountpoint(lookup.node)){throw new FS.ErrnoError(28)}var node=lookup.node;var mount=node.mounted;var mounts=FS.getMounts(mount);Object.keys(FS.nameTable).forEach(function(hash){var current=FS.nameTable[hash];while(current){var next=current.name_next;if(mounts.indexOf(current.mount)!==-1){FS.destroyNode(current)}current=next}});node.mounted=null;var idx=node.mount.mounts.indexOf(mount);node.mount.mounts.splice(idx,1)},lookup:function(parent,name){return parent.node_ops.lookup(parent,name)},mknod:function(path,mode,dev){var lookup=FS.lookupPath(path,{parent:true});var parent=lookup.node;var name=PATH.basename(path);if(!name||name==="."||name===".."){throw new FS.ErrnoError(28)}var errCode=FS.mayCreate(parent,name);if(errCode){throw new FS.ErrnoError(errCode)}if(!parent.node_ops.mknod){throw new FS.ErrnoError(63)}return parent.node_ops.mknod(parent,name,mode,dev)},create:function(path,mode){mode=mode!==undefined?mode:438;mode&=4095;mode|=32768;return FS.mknod(path,mode,0)},mkdir:function(path,mode){mode=mode!==undefined?mode:511;mode&=511|512;mode|=16384;return FS.mknod(path,mode,0)},mkdirTree:function(path,mode){var dirs=path.split("/");var d="";for(var i=0;i<dirs.length;++i){if(!dirs[i])continue;d+="/"+dirs[i];try{FS.mkdir(d,mode)}catch(e){if(e.errno!=20)throw e}}},mkdev:function(path,mode,dev){if(typeof dev==="undefined"){dev=mode;mode=438}mode|=8192;return FS.mknod(path,mode,dev)},symlink:function(oldpath,newpath){if(!PATH_FS.resolve(oldpath)){throw new FS.ErrnoError(44)}var lookup=FS.lookupPath(newpath,{parent:true});var parent=lookup.node;if(!parent){throw new FS.ErrnoError(44)}var newname=PATH.basename(newpath);var errCode=FS.mayCreate(parent,newname);if(errCode){throw new FS.ErrnoError(errCode)}if(!parent.node_ops.symlink){throw new FS.ErrnoError(63)}return parent.node_ops.symlink(parent,newname,oldpath)},rename:function(old_path,new_path){var old_dirname=PATH.dirname(old_path);var new_dirname=PATH.dirname(new_path);var old_name=PATH.basename(old_path);var new_name=PATH.basename(new_path);var lookup,old_dir,new_dir;try{lookup=FS.lookupPath(old_path,{parent:true});old_dir=lookup.node;lookup=FS.lookupPath(new_path,{parent:true});new_dir=lookup.node}catch(e){throw new FS.ErrnoError(10)}if(!old_dir||!new_dir)throw new FS.ErrnoError(44);if(old_dir.mount!==new_dir.mount){throw new FS.ErrnoError(75)}var old_node=FS.lookupNode(old_dir,old_name);var relative=PATH_FS.relative(old_path,new_dirname);if(relative.charAt(0)!=="."){throw new FS.ErrnoError(28)}relative=PATH_FS.relative(new_path,old_dirname);if(relative.charAt(0)!=="."){throw new FS.ErrnoError(55)}var new_node;try{new_node=FS.lookupNode(new_dir,new_name)}catch(e){}if(old_node===new_node){return}var isdir=FS.isDir(old_node.mode);var errCode=FS.mayDelete(old_dir,old_name,isdir);if(errCode){throw new FS.ErrnoError(errCode)}errCode=new_node?FS.mayDelete(new_dir,new_name,isdir):FS.mayCreate(new_dir,new_name);if(errCode){throw new FS.ErrnoError(errCode)}if(!old_dir.node_ops.rename){throw new FS.ErrnoError(63)}if(FS.isMountpoint(old_node)||new_node&&FS.isMountpoint(new_node)){throw new FS.ErrnoError(10)}if(new_dir!==old_dir){errCode=FS.nodePermissions(old_dir,"w");if(errCode){throw new FS.ErrnoError(errCode)}}try{if(FS.trackingDelegate["willMovePath"]){FS.trackingDelegate["willMovePath"](old_path,new_path)}}catch(e){err("FS.trackingDelegate['willMovePath']('"+old_path+"', '"+new_path+"') threw an exception: "+e.message)}FS.hashRemoveNode(old_node);try{old_dir.node_ops.rename(old_node,new_dir,new_name)}catch(e){throw e}finally{FS.hashAddNode(old_node)}try{if(FS.trackingDelegate["onMovePath"])FS.trackingDelegate["onMovePath"](old_path,new_path)}catch(e){err("FS.trackingDelegate['onMovePath']('"+old_path+"', '"+new_path+"') threw an exception: "+e.message)}},rmdir:function(path){var lookup=FS.lookupPath(path,{parent:true});var parent=lookup.node;var name=PATH.basename(path);var node=FS.lookupNode(parent,name);var errCode=FS.mayDelete(parent,name,true);if(errCode){throw new FS.ErrnoError(errCode)}if(!parent.node_ops.rmdir){throw new FS.ErrnoError(63)}if(FS.isMountpoint(node)){throw new FS.ErrnoError(10)}try{if(FS.trackingDelegate["willDeletePath"]){FS.trackingDelegate["willDeletePath"](path)}}catch(e){err("FS.trackingDelegate['willDeletePath']('"+path+"') threw an exception: "+e.message)}parent.node_ops.rmdir(parent,name);FS.destroyNode(node);try{if(FS.trackingDelegate["onDeletePath"])FS.trackingDelegate["onDeletePath"](path)}catch(e){err("FS.trackingDelegate['onDeletePath']('"+path+"') threw an exception: "+e.message)}},readdir:function(path){var lookup=FS.lookupPath(path,{follow:true});var node=lookup.node;if(!node.node_ops.readdir){throw new FS.ErrnoError(54)}return node.node_ops.readdir(node)},unlink:function(path){var lookup=FS.lookupPath(path,{parent:true});var parent=lookup.node;var name=PATH.basename(path);var node=FS.lookupNode(parent,name);var errCode=FS.mayDelete(parent,name,false);if(errCode){throw new FS.ErrnoError(errCode)}if(!parent.node_ops.unlink){throw new FS.ErrnoError(63)}if(FS.isMountpoint(node)){throw new FS.ErrnoError(10)}try{if(FS.trackingDelegate["willDeletePath"]){FS.trackingDelegate["willDeletePath"](path)}}catch(e){err("FS.trackingDelegate['willDeletePath']('"+path+"') threw an exception: "+e.message)}parent.node_ops.unlink(parent,name);FS.destroyNode(node);try{if(FS.trackingDelegate["onDeletePath"])FS.trackingDelegate["onDeletePath"](path)}catch(e){err("FS.trackingDelegate['onDeletePath']('"+path+"') threw an exception: "+e.message)}},readlink:function(path){var lookup=FS.lookupPath(path);var link=lookup.node;if(!link){throw new FS.ErrnoError(44)}if(!link.node_ops.readlink){throw new FS.ErrnoError(28)}return PATH_FS.resolve(FS.getPath(link.parent),link.node_ops.readlink(link))},stat:function(path,dontFollow){var lookup=FS.lookupPath(path,{follow:!dontFollow});var node=lookup.node;if(!node){throw new FS.ErrnoError(44)}if(!node.node_ops.getattr){throw new FS.ErrnoError(63)}return node.node_ops.getattr(node)},lstat:function(path){return FS.stat(path,true)},chmod:function(path,mode,dontFollow){var node;if(typeof path==="string"){var lookup=FS.lookupPath(path,{follow:!dontFollow});node=lookup.node}else{node=path}if(!node.node_ops.setattr){throw new FS.ErrnoError(63)}node.node_ops.setattr(node,{mode:mode&4095|node.mode&~4095,timestamp:Date.now()})},lchmod:function(path,mode){FS.chmod(path,mode,true)},fchmod:function(fd,mode){var stream=FS.getStream(fd);if(!stream){throw new FS.ErrnoError(8)}FS.chmod(stream.node,mode)},chown:function(path,uid,gid,dontFollow){var node;if(typeof path==="string"){var lookup=FS.lookupPath(path,{follow:!dontFollow});node=lookup.node}else{node=path}if(!node.node_ops.setattr){throw new FS.ErrnoError(63)}node.node_ops.setattr(node,{timestamp:Date.now()})},lchown:function(path,uid,gid){FS.chown(path,uid,gid,true)},fchown:function(fd,uid,gid){var stream=FS.getStream(fd);if(!stream){throw new FS.ErrnoError(8)}FS.chown(stream.node,uid,gid)},truncate:function(path,len){if(len<0){throw new FS.ErrnoError(28)}var node;if(typeof path==="string"){var lookup=FS.lookupPath(path,{follow:true});node=lookup.node}else{node=path}if(!node.node_ops.setattr){throw new FS.ErrnoError(63)}if(FS.isDir(node.mode)){throw new FS.ErrnoError(31)}if(!FS.isFile(node.mode)){throw new FS.ErrnoError(28)}var errCode=FS.nodePermissions(node,"w");if(errCode){throw new FS.ErrnoError(errCode)}node.node_ops.setattr(node,{size:len,timestamp:Date.now()})},ftruncate:function(fd,len){var stream=FS.getStream(fd);if(!stream){throw new FS.ErrnoError(8)}if((stream.flags&2097155)===0){throw new FS.ErrnoError(28)}FS.truncate(stream.node,len)},utime:function(path,atime,mtime){var lookup=FS.lookupPath(path,{follow:true});var node=lookup.node;node.node_ops.setattr(node,{timestamp:Math.max(atime,mtime)})},open:function(path,flags,mode,fd_start,fd_end){if(path===""){throw new FS.ErrnoError(44)}flags=typeof flags==="string"?FS.modeStringToFlags(flags):flags;mode=typeof mode==="undefined"?438:mode;if(flags&64){mode=mode&4095|32768}else{mode=0}var node;if(typeof path==="object"){node=path}else{path=PATH.normalize(path);try{var lookup=FS.lookupPath(path,{follow:!(flags&131072)});node=lookup.node}catch(e){}}var created=false;if(flags&64){if(node){if(flags&128){throw new FS.ErrnoError(20)}}else{node=FS.mknod(path,mode,0);created=true}}if(!node){throw new FS.ErrnoError(44)}if(FS.isChrdev(node.mode)){flags&=~512}if(flags&65536&&!FS.isDir(node.mode)){throw new FS.ErrnoError(54)}if(!created){var errCode=FS.mayOpen(node,flags);if(errCode){throw new FS.ErrnoError(errCode)}}if(flags&512){FS.truncate(node,0)}flags&=~(128|512|131072);var stream=FS.createStream({node:node,path:FS.getPath(node),flags:flags,seekable:true,position:0,stream_ops:node.stream_ops,ungotten:[],error:false},fd_start,fd_end);if(stream.stream_ops.open){stream.stream_ops.open(stream)}if(Module["logReadFiles"]&&!(flags&1)){if(!FS.readFiles)FS.readFiles={};if(!(path in FS.readFiles)){FS.readFiles[path]=1;err("FS.trackingDelegate error on read file: "+path)}}try{if(FS.trackingDelegate["onOpenFile"]){var trackingFlags=0;if((flags&2097155)!==1){trackingFlags|=FS.tracking.openFlags.READ}if((flags&2097155)!==0){trackingFlags|=FS.tracking.openFlags.WRITE}FS.trackingDelegate["onOpenFile"](path,trackingFlags)}}catch(e){err("FS.trackingDelegate['onOpenFile']('"+path+"', flags) threw an exception: "+e.message)}return stream},close:function(stream){if(FS.isClosed(stream)){throw new FS.ErrnoError(8)}if(stream.getdents)stream.getdents=null;try{if(stream.stream_ops.close){stream.stream_ops.close(stream)}}catch(e){throw e}finally{FS.closeStream(stream.fd)}stream.fd=null},isClosed:function(stream){return stream.fd===null},llseek:function(stream,offset,whence){if(FS.isClosed(stream)){throw new FS.ErrnoError(8)}if(!stream.seekable||!stream.stream_ops.llseek){throw new FS.ErrnoError(70)}if(whence!=0&&whence!=1&&whence!=2){throw new FS.ErrnoError(28)}stream.position=stream.stream_ops.llseek(stream,offset,whence);stream.ungotten=[];return stream.position},read:function(stream,buffer,offset,length,position){if(length<0||position<0){throw new FS.ErrnoError(28)}if(FS.isClosed(stream)){throw new FS.ErrnoError(8)}if((stream.flags&2097155)===1){throw new FS.ErrnoError(8)}if(FS.isDir(stream.node.mode)){throw new FS.ErrnoError(31)}if(!stream.stream_ops.read){throw new FS.ErrnoError(28)}var seeking=typeof position!=="undefined";if(!seeking){position=stream.position}else if(!stream.seekable){throw new FS.ErrnoError(70)}var bytesRead=stream.stream_ops.read(stream,buffer,offset,length,position);if(!seeking)stream.position+=bytesRead;return bytesRead},write:function(stream,buffer,offset,length,position,canOwn){if(length<0||position<0){throw new FS.ErrnoError(28)}if(FS.isClosed(stream)){throw new FS.ErrnoError(8)}if((stream.flags&2097155)===0){throw new FS.ErrnoError(8)}if(FS.isDir(stream.node.mode)){throw new FS.ErrnoError(31)}if(!stream.stream_ops.write){throw new FS.ErrnoError(28)}if(stream.seekable&&stream.flags&1024){FS.llseek(stream,0,2)}var seeking=typeof position!=="undefined";if(!seeking){position=stream.position}else if(!stream.seekable){throw new FS.ErrnoError(70)}var bytesWritten=stream.stream_ops.write(stream,buffer,offset,length,position,canOwn);if(!seeking)stream.position+=bytesWritten;try{if(stream.path&&FS.trackingDelegate["onWriteToFile"])FS.trackingDelegate["onWriteToFile"](stream.path)}catch(e){err("FS.trackingDelegate['onWriteToFile']('"+stream.path+"') threw an exception: "+e.message)}return bytesWritten},allocate:function(stream,offset,length){if(FS.isClosed(stream)){throw new FS.ErrnoError(8)}if(offset<0||length<=0){throw new FS.ErrnoError(28)}if((stream.flags&2097155)===0){throw new FS.ErrnoError(8)}if(!FS.isFile(stream.node.mode)&&!FS.isDir(stream.node.mode)){throw new FS.ErrnoError(43)}if(!stream.stream_ops.allocate){throw new FS.ErrnoError(138)}stream.stream_ops.allocate(stream,offset,length)},mmap:function(stream,address,length,position,prot,flags){if((prot&2)!==0&&(flags&2)===0&&(stream.flags&2097155)!==2){throw new FS.ErrnoError(2)}if((stream.flags&2097155)===1){throw new FS.ErrnoError(2)}if(!stream.stream_ops.mmap){throw new FS.ErrnoError(43)}return stream.stream_ops.mmap(stream,address,length,position,prot,flags)},msync:function(stream,buffer,offset,length,mmapFlags){if(!stream||!stream.stream_ops.msync){return 0}return stream.stream_ops.msync(stream,buffer,offset,length,mmapFlags)},munmap:function(stream){return 0},ioctl:function(stream,cmd,arg){if(!stream.stream_ops.ioctl){throw new FS.ErrnoError(59)}return stream.stream_ops.ioctl(stream,cmd,arg)},readFile:function(path,opts){opts=opts||{};opts.flags=opts.flags||"r";opts.encoding=opts.encoding||"binary";if(opts.encoding!=="utf8"&&opts.encoding!=="binary"){throw new Error('Invalid encoding type "'+opts.encoding+'"')}var ret;var stream=FS.open(path,opts.flags);var stat=FS.stat(path);var length=stat.size;var buf=new Uint8Array(length);FS.read(stream,buf,0,length,0);if(opts.encoding==="utf8"){ret=UTF8ArrayToString(buf,0)}else if(opts.encoding==="binary"){ret=buf}FS.close(stream);return ret},writeFile:function(path,data,opts){opts=opts||{};opts.flags=opts.flags||"w";var stream=FS.open(path,opts.flags,opts.mode);if(typeof data==="string"){var buf=new Uint8Array(lengthBytesUTF8(data)+1);var actualNumBytes=stringToUTF8Array(data,buf,0,buf.length);FS.write(stream,buf,0,actualNumBytes,undefined,opts.canOwn)}else if(ArrayBuffer.isView(data)){FS.write(stream,data,0,data.byteLength,undefined,opts.canOwn)}else{throw new Error("Unsupported data type")}FS.close(stream)},cwd:function(){return FS.currentPath},chdir:function(path){var lookup=FS.lookupPath(path,{follow:true});if(lookup.node===null){throw new FS.ErrnoError(44)}if(!FS.isDir(lookup.node.mode)){throw new FS.ErrnoError(54)}var errCode=FS.nodePermissions(lookup.node,"x");if(errCode){throw new FS.ErrnoError(errCode)}FS.currentPath=lookup.path},createDefaultDirectories:function(){FS.mkdir("/tmp");FS.mkdir("/home");FS.mkdir("/home/web_user")},createDefaultDevices:function(){FS.mkdir("/dev");FS.registerDevice(FS.makedev(1,3),{read:function(){return 0},write:function(stream,buffer,offset,length,pos){return length}});FS.mkdev("/dev/null",FS.makedev(1,3));TTY.register(FS.makedev(5,0),TTY.default_tty_ops);TTY.register(FS.makedev(6,0),TTY.default_tty1_ops);FS.mkdev("/dev/tty",FS.makedev(5,0));FS.mkdev("/dev/tty1",FS.makedev(6,0));var random_device;if(typeof crypto==="object"&&typeof crypto["getRandomValues"]==="function"){var randomBuffer=new Uint8Array(1);random_device=function(){crypto.getRandomValues(randomBuffer);return randomBuffer[0]}}else if(ENVIRONMENT_IS_NODE){try{var crypto_module=require("crypto");random_device=function(){return crypto_module["randomBytes"](1)[0]}}catch(e){}}else{}if(!random_device){random_device=function(){abort("random_device")}}FS.createDevice("/dev","random",random_device);FS.createDevice("/dev","urandom",random_device);FS.mkdir("/dev/shm");FS.mkdir("/dev/shm/tmp")},createSpecialDirectories:function(){FS.mkdir("/proc");FS.mkdir("/proc/self");FS.mkdir("/proc/self/fd");FS.mount({mount:function(){var node=FS.createNode("/proc/self","fd",16384|511,73);node.node_ops={lookup:function(parent,name){var fd=+name;var stream=FS.getStream(fd);if(!stream)throw new FS.ErrnoError(8);var ret={parent:null,mount:{mountpoint:"fake"},node_ops:{readlink:function(){return stream.path}}};ret.parent=ret;return ret}};return node}},{},"/proc/self/fd")},createStandardStreams:function(){if(Module["stdin"]){FS.createDevice("/dev","stdin",Module["stdin"])}else{FS.symlink("/dev/tty","/dev/stdin")}if(Module["stdout"]){FS.createDevice("/dev","stdout",null,Module["stdout"])}else{FS.symlink("/dev/tty","/dev/stdout")}if(Module["stderr"]){FS.createDevice("/dev","stderr",null,Module["stderr"])}else{FS.symlink("/dev/tty1","/dev/stderr")}var stdin=FS.open("/dev/stdin","r");var stdout=FS.open("/dev/stdout","w");var stderr=FS.open("/dev/stderr","w")},ensureErrnoError:function(){if(FS.ErrnoError)return;FS.ErrnoError=function ErrnoError(errno,node){this.node=node;this.setErrno=function(errno){this.errno=errno};this.setErrno(errno);this.message="FS error"};FS.ErrnoError.prototype=new Error;FS.ErrnoError.prototype.constructor=FS.ErrnoError;[44].forEach(function(code){FS.genericErrors[code]=new FS.ErrnoError(code);FS.genericErrors[code].stack="<generic error, no stack>"})},staticInit:function(){FS.ensureErrnoError();FS.nameTable=new Array(4096);FS.mount(MEMFS,{},"/");FS.createDefaultDirectories();FS.createDefaultDevices();FS.createSpecialDirectories();FS.filesystems={"MEMFS":MEMFS}},init:function(input,output,error){FS.init.initialized=true;FS.ensureErrnoError();Module["stdin"]=input||Module["stdin"];Module["stdout"]=output||Module["stdout"];Module["stderr"]=error||Module["stderr"];FS.createStandardStreams()},quit:function(){FS.init.initialized=false;var fflush=Module["_fflush"];if(fflush)fflush(0);for(var i=0;i<FS.streams.length;i++){var stream=FS.streams[i];if(!stream){continue}FS.close(stream)}},getMode:function(canRead,canWrite){var mode=0;if(canRead)mode|=292|73;if(canWrite)mode|=146;return mode},joinPath:function(parts,forceRelative){var path=PATH.join.apply(null,parts);if(forceRelative&&path[0]=="/")path=path.substr(1);return path},absolutePath:function(relative,base){return PATH_FS.resolve(base,relative)},standardizePath:function(path){return PATH.normalize(path)},findObject:function(path,dontResolveLastLink){var ret=FS.analyzePath(path,dontResolveLastLink);if(ret.exists){return ret.object}else{setErrNo(ret.error);return null}},analyzePath:function(path,dontResolveLastLink){try{var lookup=FS.lookupPath(path,{follow:!dontResolveLastLink});path=lookup.path}catch(e){}var ret={isRoot:false,exists:false,error:0,name:null,path:null,object:null,parentExists:false,parentPath:null,parentObject:null};try{var lookup=FS.lookupPath(path,{parent:true});ret.parentExists=true;ret.parentPath=lookup.path;ret.parentObject=lookup.node;ret.name=PATH.basename(path);lookup=FS.lookupPath(path,{follow:!dontResolveLastLink});ret.exists=true;ret.path=lookup.path;ret.object=lookup.node;ret.name=lookup.node.name;ret.isRoot=lookup.path==="/"}catch(e){ret.error=e.errno}return ret},createFolder:function(parent,name,canRead,canWrite){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);var mode=FS.getMode(canRead,canWrite);return FS.mkdir(path,mode)},createPath:function(parent,path,canRead,canWrite){parent=typeof parent==="string"?parent:FS.getPath(parent);var parts=path.split("/").reverse();while(parts.length){var part=parts.pop();if(!part)continue;var current=PATH.join2(parent,part);try{FS.mkdir(current)}catch(e){}parent=current}return current},createFile:function(parent,name,properties,canRead,canWrite){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);var mode=FS.getMode(canRead,canWrite);return FS.create(path,mode)},createDataFile:function(parent,name,data,canRead,canWrite,canOwn){var path=name?PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name):parent;var mode=FS.getMode(canRead,canWrite);var node=FS.create(path,mode);if(data){if(typeof data==="string"){var arr=new Array(data.length);for(var i=0,len=data.length;i<len;++i)arr[i]=data.charCodeAt(i);data=arr}FS.chmod(node,mode|146);var stream=FS.open(node,"w");FS.write(stream,data,0,data.length,0,canOwn);FS.close(stream);FS.chmod(node,mode)}return node},createDevice:function(parent,name,input,output){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);var mode=FS.getMode(!!input,!!output);if(!FS.createDevice.major)FS.createDevice.major=64;var dev=FS.makedev(FS.createDevice.major++,0);FS.registerDevice(dev,{open:function(stream){stream.seekable=false},close:function(stream){if(output&&output.buffer&&output.buffer.length){output(10)}},read:function(stream,buffer,offset,length,pos){var bytesRead=0;for(var i=0;i<length;i++){var result;try{result=input()}catch(e){throw new FS.ErrnoError(29)}if(result===undefined&&bytesRead===0){throw new FS.ErrnoError(6)}if(result===null||result===undefined)break;bytesRead++;buffer[offset+i]=result}if(bytesRead){stream.node.timestamp=Date.now()}return bytesRead},write:function(stream,buffer,offset,length,pos){for(var i=0;i<length;i++){try{output(buffer[offset+i])}catch(e){throw new FS.ErrnoError(29)}}if(length){stream.node.timestamp=Date.now()}return i}});return FS.mkdev(path,mode,dev)},createLink:function(parent,name,target,canRead,canWrite){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);return FS.symlink(target,path)},forceLoadFile:function(obj){if(obj.isDevice||obj.isFolder||obj.link||obj.contents)return true;var success=true;if(typeof XMLHttpRequest!=="undefined"){throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.")}else if(read_){try{obj.contents=intArrayFromString(read_(obj.url),true);obj.usedBytes=obj.contents.length}catch(e){success=false}}else{throw new Error("Cannot load without read() or XMLHttpRequest.")}if(!success)setErrNo(29);return success},createLazyFile:function(parent,name,url,canRead,canWrite){function LazyUint8Array(){this.lengthKnown=false;this.chunks=[]}LazyUint8Array.prototype.get=function LazyUint8Array_get(idx){if(idx>this.length-1||idx<0){return undefined}var chunkOffset=idx%this.chunkSize;var chunkNum=idx/this.chunkSize|0;return this.getter(chunkNum)[chunkOffset]};LazyUint8Array.prototype.setDataGetter=function LazyUint8Array_setDataGetter(getter){this.getter=getter};LazyUint8Array.prototype.cacheLength=function LazyUint8Array_cacheLength(){var xhr=new XMLHttpRequest;xhr.open("HEAD",url,false);xhr.send(null);if(!(xhr.status>=200&&xhr.status<300||xhr.status===304))throw new Error("Couldn't load "+url+". Status: "+xhr.status);var datalength=Number(xhr.getResponseHeader("Content-length"));var header;var hasByteServing=(header=xhr.getResponseHeader("Accept-Ranges"))&&header==="bytes";var usesGzip=(header=xhr.getResponseHeader("Content-Encoding"))&&header==="gzip";var chunkSize=1024*1024;if(!hasByteServing)chunkSize=datalength;var doXHR=function(from,to){if(from>to)throw new Error("invalid range ("+from+", "+to+") or no bytes requested!");if(to>datalength-1)throw new Error("only "+datalength+" bytes available! programmer error!");var xhr=new XMLHttpRequest;xhr.open("GET",url,false);if(datalength!==chunkSize)xhr.setRequestHeader("Range","bytes="+from+"-"+to);if(typeof Uint8Array!="undefined")xhr.responseType="arraybuffer";if(xhr.overrideMimeType){xhr.overrideMimeType("text/plain; charset=x-user-defined")}xhr.send(null);if(!(xhr.status>=200&&xhr.status<300||xhr.status===304))throw new Error("Couldn't load "+url+". Status: "+xhr.status);if(xhr.response!==undefined){return new Uint8Array(xhr.response||[])}else{return intArrayFromString(xhr.responseText||"",true)}};var lazyArray=this;lazyArray.setDataGetter(function(chunkNum){var start=chunkNum*chunkSize;var end=(chunkNum+1)*chunkSize-1;end=Math.min(end,datalength-1);if(typeof lazyArray.chunks[chunkNum]==="undefined"){lazyArray.chunks[chunkNum]=doXHR(start,end)}if(typeof lazyArray.chunks[chunkNum]==="undefined")throw new Error("doXHR failed!");return lazyArray.chunks[chunkNum]});if(usesGzip||!datalength){chunkSize=datalength=1;datalength=this.getter(0).length;chunkSize=datalength;out("LazyFiles on gzip forces download of the whole file when length is accessed")}this._length=datalength;this._chunkSize=chunkSize;this.lengthKnown=true};if(typeof XMLHttpRequest!=="undefined"){if(!ENVIRONMENT_IS_WORKER)throw"Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc";var lazyArray=new LazyUint8Array;Object.defineProperties(lazyArray,{length:{get:function(){if(!this.lengthKnown){this.cacheLength()}return this._length}},chunkSize:{get:function(){if(!this.lengthKnown){this.cacheLength()}return this._chunkSize}}});var properties={isDevice:false,contents:lazyArray}}else{var properties={isDevice:false,url:url}}var node=FS.createFile(parent,name,properties,canRead,canWrite);if(properties.contents){node.contents=properties.contents}else if(properties.url){node.contents=null;node.url=properties.url}Object.defineProperties(node,{usedBytes:{get:function(){return this.contents.length}}});var stream_ops={};var keys=Object.keys(node.stream_ops);keys.forEach(function(key){var fn=node.stream_ops[key];stream_ops[key]=function forceLoadLazyFile(){if(!FS.forceLoadFile(node)){throw new FS.ErrnoError(29)}return fn.apply(null,arguments)}});stream_ops.read=function stream_ops_read(stream,buffer,offset,length,position){if(!FS.forceLoadFile(node)){throw new FS.ErrnoError(29)}var contents=stream.node.contents;if(position>=contents.length)return 0;var size=Math.min(contents.length-position,length);if(contents.slice){for(var i=0;i<size;i++){buffer[offset+i]=contents[position+i]}}else{for(var i=0;i<size;i++){buffer[offset+i]=contents.get(position+i)}}return size};node.stream_ops=stream_ops;return node},createPreloadedFile:function(parent,name,url,canRead,canWrite,onload,onerror,dontCreateFile,canOwn,preFinish){Browser.init();var fullname=name?PATH_FS.resolve(PATH.join2(parent,name)):parent;var dep=getUniqueRunDependency("cp "+fullname);function processData(byteArray){function finish(byteArray){if(preFinish)preFinish();if(!dontCreateFile){FS.createDataFile(parent,name,byteArray,canRead,canWrite,canOwn)}if(onload)onload();removeRunDependency(dep)}var handled=false;Module["preloadPlugins"].forEach(function(plugin){if(handled)return;if(plugin["canHandle"](fullname)){plugin["handle"](byteArray,fullname,finish,function(){if(onerror)onerror();removeRunDependency(dep)});handled=true}});if(!handled)finish(byteArray)}addRunDependency(dep);if(typeof url=="string"){Browser.asyncLoad(url,function(byteArray){processData(byteArray)},onerror)}else{processData(url)}},indexedDB:function(){return window.indexedDB||window.mozIndexedDB||window.webkitIndexedDB||window.msIndexedDB},DB_NAME:function(){return"EM_FS_"+window.location.pathname},DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:function(paths,onload,onerror){onload=onload||function(){};onerror=onerror||function(){};var indexedDB=FS.indexedDB();try{var openRequest=indexedDB.open(FS.DB_NAME(),FS.DB_VERSION)}catch(e){return onerror(e)}openRequest.onupgradeneeded=function openRequest_onupgradeneeded(){out("creating db");var db=openRequest.result;db.createObjectStore(FS.DB_STORE_NAME)};openRequest.onsuccess=function openRequest_onsuccess(){var db=openRequest.result;var transaction=db.transaction([FS.DB_STORE_NAME],"readwrite");var files=transaction.objectStore(FS.DB_STORE_NAME);var ok=0,fail=0,total=paths.length;function finish(){if(fail==0)onload();else onerror()}paths.forEach(function(path){var putRequest=files.put(FS.analyzePath(path).object.contents,path);putRequest.onsuccess=function putRequest_onsuccess(){ok++;if(ok+fail==total)finish()};putRequest.onerror=function putRequest_onerror(){fail++;if(ok+fail==total)finish()}});transaction.onerror=onerror};openRequest.onerror=onerror},loadFilesFromDB:function(paths,onload,onerror){onload=onload||function(){};onerror=onerror||function(){};var indexedDB=FS.indexedDB();try{var openRequest=indexedDB.open(FS.DB_NAME(),FS.DB_VERSION)}catch(e){return onerror(e)}openRequest.onupgradeneeded=onerror;openRequest.onsuccess=function openRequest_onsuccess(){var db=openRequest.result;try{var transaction=db.transaction([FS.DB_STORE_NAME],"readonly")}catch(e){onerror(e);return}var files=transaction.objectStore(FS.DB_STORE_NAME);var ok=0,fail=0,total=paths.length;function finish(){if(fail==0)onload();else onerror()}paths.forEach(function(path){var getRequest=files.get(path);getRequest.onsuccess=function getRequest_onsuccess(){if(FS.analyzePath(path).exists){FS.unlink(path)}FS.createDataFile(PATH.dirname(path),PATH.basename(path),getRequest.result,true,true,true);ok++;if(ok+fail==total)finish()};getRequest.onerror=function getRequest_onerror(){fail++;if(ok+fail==total)finish()}});transaction.onerror=onerror};openRequest.onerror=onerror},mmapAlloc:function(size){var alignedSize=alignMemory(size,16384);var ptr=_malloc(alignedSize);while(size<alignedSize)HEAP8[ptr+size++]=0;return ptr}};var SYSCALLS={mappings:{},DEFAULT_POLLMASK:5,umask:511,calculateAt:function(dirfd,path){if(path[0]!=="/"){var dir;if(dirfd===-100){dir=FS.cwd()}else{var dirstream=FS.getStream(dirfd);if(!dirstream)throw new FS.ErrnoError(8);dir=dirstream.path}path=PATH.join2(dir,path)}return path},doStat:function(func,path,buf){try{var stat=func(path)}catch(e){if(e&&e.node&&PATH.normalize(path)!==PATH.normalize(FS.getPath(e.node))){return-54}throw e}HEAP32[buf>>2]=stat.dev;HEAP32[buf+4>>2]=0;HEAP32[buf+8>>2]=stat.ino;HEAP32[buf+12>>2]=stat.mode;HEAP32[buf+16>>2]=stat.nlink;HEAP32[buf+20>>2]=stat.uid;HEAP32[buf+24>>2]=stat.gid;HEAP32[buf+28>>2]=stat.rdev;HEAP32[buf+32>>2]=0;tempI64=[stat.size>>>0,(tempDouble=stat.size,+Math_abs(tempDouble)>=1?tempDouble>0?(Math_min(+Math_floor(tempDouble/4294967296),4294967295)|0)>>>0:~~+Math_ceil((tempDouble-+(~~tempDouble>>>0))/4294967296)>>>0:0)],HEAP32[buf+40>>2]=tempI64[0],HEAP32[buf+44>>2]=tempI64[1];HEAP32[buf+48>>2]=4096;HEAP32[buf+52>>2]=stat.blocks;HEAP32[buf+56>>2]=stat.atime.getTime()/1e3|0;HEAP32[buf+60>>2]=0;HEAP32[buf+64>>2]=stat.mtime.getTime()/1e3|0;HEAP32[buf+68>>2]=0;HEAP32[buf+72>>2]=stat.ctime.getTime()/1e3|0;HEAP32[buf+76>>2]=0;tempI64=[stat.ino>>>0,(tempDouble=stat.ino,+Math_abs(tempDouble)>=1?tempDouble>0?(Math_min(+Math_floor(tempDouble/4294967296),4294967295)|0)>>>0:~~+Math_ceil((tempDouble-+(~~tempDouble>>>0))/4294967296)>>>0:0)],HEAP32[buf+80>>2]=tempI64[0],HEAP32[buf+84>>2]=tempI64[1];return 0},doMsync:function(addr,stream,len,flags,offset){var buffer=HEAPU8.slice(addr,addr+len);FS.msync(stream,buffer,offset,len,flags)},doMkdir:function(path,mode){path=PATH.normalize(path);if(path[path.length-1]==="/")path=path.substr(0,path.length-1);FS.mkdir(path,mode,0);return 0},doMknod:function(path,mode,dev){switch(mode&61440){case 32768:case 8192:case 24576:case 4096:case 49152:break;default:return-28}FS.mknod(path,mode,dev);return 0},doReadlink:function(path,buf,bufsize){if(bufsize<=0)return-28;var ret=FS.readlink(path);var len=Math.min(bufsize,lengthBytesUTF8(ret));var endChar=HEAP8[buf+len];stringToUTF8(ret,buf,bufsize+1);HEAP8[buf+len]=endChar;return len},doAccess:function(path,amode){if(amode&~7){return-28}var node;var lookup=FS.lookupPath(path,{follow:true});node=lookup.node;if(!node){return-44}var perms="";if(amode&4)perms+="r";if(amode&2)perms+="w";if(amode&1)perms+="x";if(perms&&FS.nodePermissions(node,perms)){return-2}return 0},doDup:function(path,flags,suggestFD){var suggest=FS.getStream(suggestFD);if(suggest)FS.close(suggest);return FS.open(path,flags,0,suggestFD,suggestFD).fd},doReadv:function(stream,iov,iovcnt,offset){var ret=0;for(var i=0;i<iovcnt;i++){var ptr=HEAP32[iov+i*8>>2];var len=HEAP32[iov+(i*8+4)>>2];var curr=FS.read(stream,HEAP8,ptr,len,offset);if(curr<0)return-1;ret+=curr;if(curr<len)break}return ret},doWritev:function(stream,iov,iovcnt,offset){var ret=0;for(var i=0;i<iovcnt;i++){var ptr=HEAP32[iov+i*8>>2];var len=HEAP32[iov+(i*8+4)>>2];var curr=FS.write(stream,HEAP8,ptr,len,offset);if(curr<0)return-1;ret+=curr}return ret},varargs:undefined,get:function(){SYSCALLS.varargs+=4;var ret=HEAP32[SYSCALLS.varargs-4>>2];return ret},getStr:function(ptr){var ret=UTF8ToString(ptr);return ret},getStreamFromFD:function(fd){var stream=FS.getStream(fd);if(!stream)throw new FS.ErrnoError(8);return stream},get64:function(low,high){return low}};function ___sys_access(path,amode){try{path=SYSCALLS.getStr(path);return SYSCALLS.doAccess(path,amode)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___sys_chmod(path,mode){try{path=SYSCALLS.getStr(path);FS.chmod(path,mode);return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___sys_fcntl64(fd,cmd,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(fd);switch(cmd){case 0:{var arg=SYSCALLS.get();if(arg<0){return-28}var newStream;newStream=FS.open(stream.path,stream.flags,0,arg);return newStream.fd}case 1:case 2:return 0;case 3:return stream.flags;case 4:{var arg=SYSCALLS.get();stream.flags|=arg;return 0}case 12:{var arg=SYSCALLS.get();var offset=0;HEAP16[arg+offset>>1]=2;return 0}case 13:case 14:return 0;case 16:case 8:return-28;case 9:setErrNo(28);return-1;default:{return-28}}}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___sys_fstat64(fd,buf){try{var stream=SYSCALLS.getStreamFromFD(fd);return SYSCALLS.doStat(FS.stat,stream.path,buf)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___sys_ioctl(fd,op,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(fd);switch(op){case 21509:case 21505:{if(!stream.tty)return-59;return 0}case 21510:case 21511:case 21512:case 21506:case 21507:case 21508:{if(!stream.tty)return-59;return 0}case 21519:{if(!stream.tty)return-59;var argp=SYSCALLS.get();HEAP32[argp>>2]=0;return 0}case 21520:{if(!stream.tty)return-59;return-28}case 21531:{var argp=SYSCALLS.get();return FS.ioctl(stream,op,argp)}case 21523:{if(!stream.tty)return-59;return 0}case 21524:{if(!stream.tty)return-59;return 0}default:abort("bad ioctl syscall "+op)}}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function syscallMmap2(addr,len,prot,flags,fd,off){off<<=12;var ptr;var allocated=false;if((flags&16)!==0&&addr%16384!==0){return-28}if((flags&32)!==0){ptr=_memalign(16384,len);if(!ptr)return-48;_memset(ptr,0,len);allocated=true}else{var info=FS.getStream(fd);if(!info)return-8;var res=FS.mmap(info,addr,len,off,prot,flags);ptr=res.ptr;allocated=res.allocated}SYSCALLS.mappings[ptr]={malloc:ptr,len:len,allocated:allocated,fd:fd,prot:prot,flags:flags,offset:off};return ptr}function ___sys_mmap2(addr,len,prot,flags,fd,off){try{return syscallMmap2(addr,len,prot,flags,fd,off)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function syscallMunmap(addr,len){if((addr|0)===-1||len===0){return-28}var info=SYSCALLS.mappings[addr];if(!info)return 0;if(len===info.len){var stream=FS.getStream(info.fd);if(info.prot&2){SYSCALLS.doMsync(addr,stream,len,info.flags,info.offset)}FS.munmap(stream);SYSCALLS.mappings[addr]=null;if(info.allocated){_free(info.malloc)}}return 0}function ___sys_munmap(addr,len){try{return syscallMunmap(addr,len)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___sys_open(path,flags,varargs){SYSCALLS.varargs=varargs;try{var pathname=SYSCALLS.getStr(path);var mode=SYSCALLS.get();var stream=FS.open(pathname,flags,mode);return stream.fd}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___sys_stat64(path,buf){try{path=SYSCALLS.getStr(path);return SYSCALLS.doStat(FS.stat,path,buf)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___sys_uname(buf){try{if(!buf)return-21;var layout={"sysname":0,"nodename":65,"domainname":325,"machine":260,"version":195,"release":130,"__size__":390};var copyString=function(element,value){var offset=layout[element];writeAsciiToMemory(value,buf+offset)};copyString("sysname","Emscripten");copyString("nodename","emscripten");copyString("release","1.0");copyString("version","#1");copyString("machine","x86-JS");return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function _abort(){abort()}var _emscripten_get_now;if(ENVIRONMENT_IS_NODE){_emscripten_get_now=function(){var t=process["hrtime"]();return t[0]*1e3+t[1]/1e6}}else if(typeof dateNow!=="undefined"){_emscripten_get_now=dateNow}else _emscripten_get_now=function(){return performance.now()};var _emscripten_get_now_is_monotonic=true;function _clock_gettime(clk_id,tp){var now;if(clk_id===0){now=Date.now()}else if((clk_id===1||clk_id===4)&&_emscripten_get_now_is_monotonic){now=_emscripten_get_now()}else{setErrNo(28);return-1}HEAP32[tp>>2]=now/1e3|0;HEAP32[tp+4>>2]=now%1e3*1e3*1e3|0;return 0}function _longjmp(env,value){_setThrew(env,value||1);throw"longjmp"}function _emscripten_longjmp(env,value){_longjmp(env,value)}function _emscripten_memcpy_big(dest,src,num){HEAPU8.copyWithin(dest,src,src+num)}function _emscripten_get_heap_size(){return HEAPU8.length}function emscripten_realloc_buffer(size){try{wasmMemory.grow(size-buffer.byteLength+65535>>>16);updateGlobalBufferAndViews(wasmMemory.buffer);return 1}catch(e){}}function _emscripten_resize_heap(requestedSize){requestedSize=requestedSize>>>0;var oldSize=_emscripten_get_heap_size();var PAGE_MULTIPLE=65536;var maxHeapSize=2147483648;if(requestedSize>maxHeapSize){return false}var minHeapSize=16777216;for(var cutDown=1;cutDown<=4;cutDown*=2){var overGrownHeapSize=oldSize*(1+.2/cutDown);overGrownHeapSize=Math.min(overGrownHeapSize,requestedSize+100663296);var newSize=Math.min(maxHeapSize,alignUp(Math.max(minHeapSize,requestedSize,overGrownHeapSize),PAGE_MULTIPLE));var replacement=emscripten_realloc_buffer(newSize);if(replacement){return true}}return false}var ENV={};function __getExecutableName(){return thisProgram||"./this.program"}function getEnvStrings(){if(!getEnvStrings.strings){var lang=(typeof navigator==="object"&&navigator.languages&&navigator.languages[0]||"C").replace("-","_")+".UTF-8";var env={"USER":"web_user","LOGNAME":"web_user","PATH":"/","PWD":"/","HOME":"/home/web_user","LANG":lang,"_":__getExecutableName()};for(var x in ENV){env[x]=ENV[x]}var strings=[];for(var x in env){strings.push(x+"="+env[x])}getEnvStrings.strings=strings}return getEnvStrings.strings}function _environ_get(__environ,environ_buf){var bufSize=0;getEnvStrings().forEach(function(string,i){var ptr=environ_buf+bufSize;HEAP32[__environ+i*4>>2]=ptr;writeAsciiToMemory(string,ptr);bufSize+=string.length+1});return 0}function _environ_sizes_get(penviron_count,penviron_buf_size){var strings=getEnvStrings();HEAP32[penviron_count>>2]=strings.length;var bufSize=0;strings.forEach(function(string){bufSize+=string.length+1});HEAP32[penviron_buf_size>>2]=bufSize;return 0}function _exit(status){exit(status)}function _fd_close(fd){try{var stream=SYSCALLS.getStreamFromFD(fd);FS.close(stream);return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return e.errno}}function _fd_fdstat_get(fd,pbuf){try{var stream=SYSCALLS.getStreamFromFD(fd);var type=stream.tty?2:FS.isDir(stream.mode)?3:FS.isLink(stream.mode)?7:4;HEAP8[pbuf>>0]=type;return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return e.errno}}function _fd_read(fd,iov,iovcnt,pnum){try{var stream=SYSCALLS.getStreamFromFD(fd);var num=SYSCALLS.doReadv(stream,iov,iovcnt);HEAP32[pnum>>2]=num;return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return e.errno}}function _fd_seek(fd,offset_low,offset_high,whence,newOffset){try{var stream=SYSCALLS.getStreamFromFD(fd);var HIGH_OFFSET=4294967296;var offset=offset_high*HIGH_OFFSET+(offset_low>>>0);var DOUBLE_LIMIT=9007199254740992;if(offset<=-DOUBLE_LIMIT||offset>=DOUBLE_LIMIT){return-61}FS.llseek(stream,offset,whence);tempI64=[stream.position>>>0,(tempDouble=stream.position,+Math_abs(tempDouble)>=1?tempDouble>0?(Math_min(+Math_floor(tempDouble/4294967296),4294967295)|0)>>>0:~~+Math_ceil((tempDouble-+(~~tempDouble>>>0))/4294967296)>>>0:0)],HEAP32[newOffset>>2]=tempI64[0],HEAP32[newOffset+4>>2]=tempI64[1];if(stream.getdents&&offset===0&&whence===0)stream.getdents=null;return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return e.errno}}function _fd_write(fd,iov,iovcnt,pnum){try{var stream=SYSCALLS.getStreamFromFD(fd);var num=SYSCALLS.doWritev(stream,iov,iovcnt);HEAP32[pnum>>2]=num;return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return e.errno}}function _getTempRet0(){return getTempRet0()|0}function __inet_pton4_raw(str){var b=str.split(".");for(var i=0;i<4;i++){var tmp=Number(b[i]);if(isNaN(tmp))return null;b[i]=tmp}return(b[0]|b[1]<<8|b[2]<<16|b[3]<<24)>>>0}function jstoi_q(str){return parseInt(str)}function __inet_pton6_raw(str){var words;var w,offset,z;var valid6regx=/^((?=.*::)(?!.*::.+::)(::)?([\dA-F]{1,4}:(:|\b)|){5}|([\dA-F]{1,4}:){6})((([\dA-F]{1,4}((?!\3)::|:\b|$))|(?!\2\3)){2}|(((2[0-4]|1\d|[1-9])?\d|25[0-5])\.?\b){4})$/i;var parts=[];if(!valid6regx.test(str)){return null}if(str==="::"){return[0,0,0,0,0,0,0,0]}if(str.indexOf("::")===0){str=str.replace("::","Z:")}else{str=str.replace("::",":Z:")}if(str.indexOf(".")>0){str=str.replace(new RegExp("[.]","g"),":");words=str.split(":");words[words.length-4]=jstoi_q(words[words.length-4])+jstoi_q(words[words.length-3])*256;words[words.length-3]=jstoi_q(words[words.length-2])+jstoi_q(words[words.length-1])*256;words=words.slice(0,words.length-2)}else{words=str.split(":")}offset=0;z=0;for(w=0;w<words.length;w++){if(typeof words[w]==="string"){if(words[w]==="Z"){for(z=0;z<8-words.length+1;z++){parts[w+z]=0}offset=z-1}else{parts[w+offset]=_htons(parseInt(words[w],16))}}else{parts[w+offset]=words[w]}}return[parts[1]<<16|parts[0],parts[3]<<16|parts[2],parts[5]<<16|parts[4],parts[7]<<16|parts[6]]}var DNS={address_map:{id:1,addrs:{},names:{}},lookup_name:function(name){var res=__inet_pton4_raw(name);if(res!==null){return name}res=__inet_pton6_raw(name);if(res!==null){return name}var addr;if(DNS.address_map.addrs[name]){addr=DNS.address_map.addrs[name]}else{var id=DNS.address_map.id++;assert(id<65535,"exceeded max address mappings of 65535");addr="172.29."+(id&255)+"."+(id&65280);DNS.address_map.names[addr]=name;DNS.address_map.addrs[name]=addr}return addr},lookup_addr:function(addr){if(DNS.address_map.names[addr]){return DNS.address_map.names[addr]}return null}};function _gethostbyname(name){name=UTF8ToString(name);var ret=_malloc(20);var nameBuf=_malloc(name.length+1);stringToUTF8(name,nameBuf,name.length+1);HEAP32[ret>>2]=nameBuf;var aliasesBuf=_malloc(4);HEAP32[aliasesBuf>>2]=0;HEAP32[ret+4>>2]=aliasesBuf;var afinet=2;HEAP32[ret+8>>2]=afinet;HEAP32[ret+12>>2]=4;var addrListBuf=_malloc(12);HEAP32[addrListBuf>>2]=addrListBuf+8;HEAP32[addrListBuf+4>>2]=0;HEAP32[addrListBuf+8>>2]=__inet_pton4_raw(DNS.lookup_name(name));HEAP32[ret+16>>2]=addrListBuf;return ret}function _getpwnam(){throw"getpwnam: TODO"}function _gettimeofday(ptr){var now=Date.now();HEAP32[ptr>>2]=now/1e3|0;HEAP32[ptr+4>>2]=now%1e3*1e3|0;return 0}function _llvm_eh_typeid_for(type){return type}var ___tm_current=2702e3;var ___tm_timezone=(stringToUTF8("GMT",2702048,4),2702048);function _tzset(){if(_tzset.called)return;_tzset.called=true;HEAP32[__get_timezone()>>2]=(new Date).getTimezoneOffset()*60;var currentYear=(new Date).getFullYear();var winter=new Date(currentYear,0,1);var summer=new Date(currentYear,6,1);HEAP32[__get_daylight()>>2]=Number(winter.getTimezoneOffset()!=summer.getTimezoneOffset());function extractZone(date){var match=date.toTimeString().match(/\(([A-Za-z ]+)\)$/);return match?match[1]:"GMT"}var winterName=extractZone(winter);var summerName=extractZone(summer);var winterNamePtr=allocateUTF8(winterName);var summerNamePtr=allocateUTF8(summerName);if(summer.getTimezoneOffset()<winter.getTimezoneOffset()){HEAP32[__get_tzname()>>2]=winterNamePtr;HEAP32[__get_tzname()+4>>2]=summerNamePtr}else{HEAP32[__get_tzname()>>2]=summerNamePtr;HEAP32[__get_tzname()+4>>2]=winterNamePtr}}function _localtime_r(time,tmPtr){_tzset();var date=new Date(HEAP32[time>>2]*1e3);HEAP32[tmPtr>>2]=date.getSeconds();HEAP32[tmPtr+4>>2]=date.getMinutes();HEAP32[tmPtr+8>>2]=date.getHours();HEAP32[tmPtr+12>>2]=date.getDate();HEAP32[tmPtr+16>>2]=date.getMonth();HEAP32[tmPtr+20>>2]=date.getFullYear()-1900;HEAP32[tmPtr+24>>2]=date.getDay();var start=new Date(date.getFullYear(),0,1);var yday=(date.getTime()-start.getTime())/(1e3*60*60*24)|0;HEAP32[tmPtr+28>>2]=yday;HEAP32[tmPtr+36>>2]=-(date.getTimezoneOffset()*60);var summerOffset=new Date(date.getFullYear(),6,1).getTimezoneOffset();var winterOffset=start.getTimezoneOffset();var dst=(summerOffset!=winterOffset&&date.getTimezoneOffset()==Math.min(winterOffset,summerOffset))|0;HEAP32[tmPtr+32>>2]=dst;var zonePtr=HEAP32[__get_tzname()+(dst?4:0)>>2];HEAP32[tmPtr+40>>2]=zonePtr;return tmPtr}function _localtime(time){return _localtime_r(time,___tm_current)}function _pthread_create(){return 6}function _pthread_detach(){}function _pthread_join(){}function _pthread_mutexattr_destroy(){}function _pthread_mutexattr_init(){}function _pthread_mutexattr_settype(){}function _setTempRet0($i){setTempRet0($i|0)}function __isLeapYear(year){return year%4===0&&(year%100!==0||year%400===0)}function __arraySum(array,index){var sum=0;for(var i=0;i<=index;sum+=array[i++]){}return sum}var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date,days){var newDate=new Date(date.getTime());while(days>0){var leap=__isLeapYear(newDate.getFullYear());var currentMonth=newDate.getMonth();var daysInCurrentMonth=(leap?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR)[currentMonth];if(days>daysInCurrentMonth-newDate.getDate()){days-=daysInCurrentMonth-newDate.getDate()+1;newDate.setDate(1);if(currentMonth<11){newDate.setMonth(currentMonth+1)}else{newDate.setMonth(0);newDate.setFullYear(newDate.getFullYear()+1)}}else{newDate.setDate(newDate.getDate()+days);return newDate}}return newDate}function _strftime(s,maxsize,format,tm){var tm_zone=HEAP32[tm+40>>2];var date={tm_sec:HEAP32[tm>>2],tm_min:HEAP32[tm+4>>2],tm_hour:HEAP32[tm+8>>2],tm_mday:HEAP32[tm+12>>2],tm_mon:HEAP32[tm+16>>2],tm_year:HEAP32[tm+20>>2],tm_wday:HEAP32[tm+24>>2],tm_yday:HEAP32[tm+28>>2],tm_isdst:HEAP32[tm+32>>2],tm_gmtoff:HEAP32[tm+36>>2],tm_zone:tm_zone?UTF8ToString(tm_zone):""};var pattern=UTF8ToString(format);var EXPANSION_RULES_1={"%c":"%a %b %d %H:%M:%S %Y","%D":"%m/%d/%y","%F":"%Y-%m-%d","%h":"%b","%r":"%I:%M:%S %p","%R":"%H:%M","%T":"%H:%M:%S","%x":"%m/%d/%y","%X":"%H:%M:%S","%Ec":"%c","%EC":"%C","%Ex":"%m/%d/%y","%EX":"%H:%M:%S","%Ey":"%y","%EY":"%Y","%Od":"%d","%Oe":"%e","%OH":"%H","%OI":"%I","%Om":"%m","%OM":"%M","%OS":"%S","%Ou":"%u","%OU":"%U","%OV":"%V","%Ow":"%w","%OW":"%W","%Oy":"%y"};for(var rule in EXPANSION_RULES_1){pattern=pattern.replace(new RegExp(rule,"g"),EXPANSION_RULES_1[rule])}var WEEKDAYS=["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"];var MONTHS=["January","February","March","April","May","June","July","August","September","October","November","December"];function leadingSomething(value,digits,character){var str=typeof value==="number"?value.toString():value||"";while(str.length<digits){str=character[0]+str}return str}function leadingNulls(value,digits){return leadingSomething(value,digits,"0")}function compareByDay(date1,date2){function sgn(value){return value<0?-1:value>0?1:0}var compare;if((compare=sgn(date1.getFullYear()-date2.getFullYear()))===0){if((compare=sgn(date1.getMonth()-date2.getMonth()))===0){compare=sgn(date1.getDate()-date2.getDate())}}return compare}function getFirstWeekStartDate(janFourth){switch(janFourth.getDay()){case 0:return new Date(janFourth.getFullYear()-1,11,29);case 1:return janFourth;case 2:return new Date(janFourth.getFullYear(),0,3);case 3:return new Date(janFourth.getFullYear(),0,2);case 4:return new Date(janFourth.getFullYear(),0,1);case 5:return new Date(janFourth.getFullYear()-1,11,31);case 6:return new Date(janFourth.getFullYear()-1,11,30)}}function getWeekBasedYear(date){var thisDate=__addDays(new Date(date.tm_year+1900,0,1),date.tm_yday);var janFourthThisYear=new Date(thisDate.getFullYear(),0,4);var janFourthNextYear=new Date(thisDate.getFullYear()+1,0,4);var firstWeekStartThisYear=getFirstWeekStartDate(janFourthThisYear);var firstWeekStartNextYear=getFirstWeekStartDate(janFourthNextYear);if(compareByDay(firstWeekStartThisYear,thisDate)<=0){if(compareByDay(firstWeekStartNextYear,thisDate)<=0){return thisDate.getFullYear()+1}else{return thisDate.getFullYear()}}else{return thisDate.getFullYear()-1}}var EXPANSION_RULES_2={"%a":function(date){return WEEKDAYS[date.tm_wday].substring(0,3)},"%A":function(date){return WEEKDAYS[date.tm_wday]},"%b":function(date){return MONTHS[date.tm_mon].substring(0,3)},"%B":function(date){return MONTHS[date.tm_mon]},"%C":function(date){var year=date.tm_year+1900;return leadingNulls(year/100|0,2)},"%d":function(date){return leadingNulls(date.tm_mday,2)},"%e":function(date){return leadingSomething(date.tm_mday,2," ")},"%g":function(date){return getWeekBasedYear(date).toString().substring(2)},"%G":function(date){return getWeekBasedYear(date)},"%H":function(date){return leadingNulls(date.tm_hour,2)},"%I":function(date){var twelveHour=date.tm_hour;if(twelveHour==0)twelveHour=12;else if(twelveHour>12)twelveHour-=12;return leadingNulls(twelveHour,2)},"%j":function(date){return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900)?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,date.tm_mon-1),3)},"%m":function(date){return leadingNulls(date.tm_mon+1,2)},"%M":function(date){return leadingNulls(date.tm_min,2)},"%n":function(){return"\n"},"%p":function(date){if(date.tm_hour>=0&&date.tm_hour<12){return"AM"}else{return"PM"}},"%S":function(date){return leadingNulls(date.tm_sec,2)},"%t":function(){return"\t"},"%u":function(date){return date.tm_wday||7},"%U":function(date){var janFirst=new Date(date.tm_year+1900,0,1);var firstSunday=janFirst.getDay()===0?janFirst:__addDays(janFirst,7-janFirst.getDay());var endDate=new Date(date.tm_year+1900,date.tm_mon,date.tm_mday);if(compareByDay(firstSunday,endDate)<0){var februaryFirstUntilEndMonth=__arraySum(__isLeapYear(endDate.getFullYear())?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,endDate.getMonth()-1)-31;var firstSundayUntilEndJanuary=31-firstSunday.getDate();var days=firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();return leadingNulls(Math.ceil(days/7),2)}return compareByDay(firstSunday,janFirst)===0?"01":"00"},"%V":function(date){var janFourthThisYear=new Date(date.tm_year+1900,0,4);var janFourthNextYear=new Date(date.tm_year+1901,0,4);var firstWeekStartThisYear=getFirstWeekStartDate(janFourthThisYear);var firstWeekStartNextYear=getFirstWeekStartDate(janFourthNextYear);var endDate=__addDays(new Date(date.tm_year+1900,0,1),date.tm_yday);if(compareByDay(endDate,firstWeekStartThisYear)<0){return"53"}if(compareByDay(firstWeekStartNextYear,endDate)<=0){return"01"}var daysDifference;if(firstWeekStartThisYear.getFullYear()<date.tm_year+1900){daysDifference=date.tm_yday+32-firstWeekStartThisYear.getDate()}else{daysDifference=date.tm_yday+1-firstWeekStartThisYear.getDate()}return leadingNulls(Math.ceil(daysDifference/7),2)},"%w":function(date){return date.tm_wday},"%W":function(date){var janFirst=new Date(date.tm_year,0,1);var firstMonday=janFirst.getDay()===1?janFirst:__addDays(janFirst,janFirst.getDay()===0?1:7-janFirst.getDay()+1);var endDate=new Date(date.tm_year+1900,date.tm_mon,date.tm_mday);if(compareByDay(firstMonday,endDate)<0){var februaryFirstUntilEndMonth=__arraySum(__isLeapYear(endDate.getFullYear())?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,endDate.getMonth()-1)-31;var firstMondayUntilEndJanuary=31-firstMonday.getDate();var days=firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();return leadingNulls(Math.ceil(days/7),2)}return compareByDay(firstMonday,janFirst)===0?"01":"00"},"%y":function(date){return(date.tm_year+1900).toString().substring(2)},"%Y":function(date){return date.tm_year+1900},"%z":function(date){var off=date.tm_gmtoff;var ahead=off>=0;off=Math.abs(off)/60;off=off/60*100+off%60;return(ahead?"+":"-")+String("0000"+off).slice(-4)},"%Z":function(date){return date.tm_zone},"%%":function(){return"%"}};for(var rule in EXPANSION_RULES_2){if(pattern.indexOf(rule)>=0){pattern=pattern.replace(new RegExp(rule,"g"),EXPANSION_RULES_2[rule](date))}}var bytes=intArrayFromString(pattern,false);if(bytes.length>maxsize){return 0}writeArrayToMemory(bytes,s);return bytes.length-1}function _strftime_l(s,maxsize,format,tm){return _strftime(s,maxsize,format,tm)}function _sysconf(name){switch(name){case 30:return 16384;case 85:var maxHeapSize=2147483648;return maxHeapSize/16384;case 132:case 133:case 12:case 137:case 138:case 15:case 235:case 16:case 17:case 18:case 19:case 20:case 149:case 13:case 10:case 236:case 153:case 9:case 21:case 22:case 159:case 154:case 14:case 77:case 78:case 139:case 80:case 81:case 82:case 68:case 67:case 164:case 11:case 29:case 47:case 48:case 95:case 52:case 51:case 46:case 79:return 200809;case 27:case 246:case 127:case 128:case 23:case 24:case 160:case 161:case 181:case 182:case 242:case 183:case 184:case 243:case 244:case 245:case 165:case 178:case 179:case 49:case 50:case 168:case 169:case 175:case 170:case 171:case 172:case 97:case 76:case 32:case 173:case 35:return-1;case 176:case 177:case 7:case 155:case 8:case 157:case 125:case 126:case 92:case 93:case 129:case 130:case 131:case 94:case 91:return 1;case 74:case 60:case 69:case 70:case 4:return 1024;case 31:case 42:case 72:return 32;case 87:case 26:case 33:return 2147483647;case 34:case 1:return 47839;case 38:case 36:return 99;case 43:case 37:return 2048;case 0:return 2097152;case 3:return 65536;case 28:return 32768;case 44:return 32767;case 75:return 16384;case 39:return 1e3;case 89:return 700;case 71:return 256;case 40:return 255;case 2:return 100;case 180:return 64;case 25:return 20;case 5:return 16;case 6:return 6;case 73:return 4;case 84:{if(typeof navigator==="object")return navigator["hardwareConcurrency"]||1;return 1}}setErrNo(28);return-1}function _times(buffer){if(buffer!==0){_memset(buffer,0,16)}return 0}var FSNode=function(parent,name,mode,rdev){if(!parent){parent=this}this.parent=parent;this.mount=parent.mount;this.mounted=null;this.id=FS.nextInode++;this.name=name;this.mode=mode;this.node_ops={};this.stream_ops={};this.rdev=rdev};var readMode=292|73;var writeMode=146;Object.defineProperties(FSNode.prototype,{read:{get:function(){return(this.mode&readMode)===readMode},set:function(val){val?this.mode|=readMode:this.mode&=~readMode}},write:{get:function(){return(this.mode&writeMode)===writeMode},set:function(val){val?this.mode|=writeMode:this.mode&=~writeMode}},isFolder:{get:function(){return FS.isDir(this.mode)}},isDevice:{get:function(){return FS.isChrdev(this.mode)}}});FS.FSNode=FSNode;FS.staticInit();function intArrayFromString(stringy,dontAddNull,length){var len=length>0?length:lengthBytesUTF8(stringy)+1;var u8array=new Array(len);var numBytesWritten=stringToUTF8Array(stringy,u8array,0,u8array.length);if(dontAddNull)u8array.length=numBytesWritten;return u8array}var asmLibraryArg={"p":___cxa_allocate_exception,"Z":___cxa_begin_catch,"pa":___cxa_end_catch,"d":___cxa_find_matching_catch_2,"f":___cxa_find_matching_catch_3,"lc":___cxa_find_matching_catch_4,"Fe":___cxa_find_matching_catch_5,"q":___cxa_free_exception,"ej":___cxa_rethrow,"wf":___cxa_thread_atexit,"t":___cxa_throw,"rh":___map_file,"i":___resumeException,"vh":___sys_access,"nh":___sys_chmod,"Je":___sys_fcntl64,"oh":___sys_fstat64,"uh":___sys_ioctl,"ph":___sys_mmap2,"qh":___sys_munmap,"Ff":___sys_open,"Ef":___sys_stat64,"sh":___sys_uname,"Df":_abort,"tf":_clock_gettime,"x":_emscripten_longjmp,"ih":_emscripten_memcpy_big,"jh":_emscripten_resize_heap,"lh":_environ_get,"mh":_environ_sizes_get,"bj":_exit,"Ke":_fd_close,"Hf":_fd_fdstat_get,"th":_fd_read,"gh":_fd_seek,"Gf":_fd_write,"c":_getTempRet0,"Qi":_gethostbyname,"Pi":_getpwnam,"tc":_gettimeofday,"Pa":invoke_d,"Q":invoke_dd,"H":invoke_ddd,"ba":invoke_dddd,"vc":invoke_ddddd,"Tg":invoke_ddii,"o":invoke_di,"D":invoke_did,"hc":invoke_didd,"ob":invoke_diddd,"Yf":invoke_didddddidi,"me":invoke_didddidi,"Ta":invoke_diddi,"id":invoke_diddidii,"vb":invoke_didi,"ii":invoke_dididd,"gf":invoke_didii,"Ld":invoke_didiidii,"gi":invoke_didiidiiddi,"Cg":invoke_didiiiiidi,"v":invoke_dii,"Da":invoke_diid,"yc":invoke_diidd,"yb":invoke_diiddd,"Zf":invoke_diiddi,"Kc":invoke_diidi,"ad":invoke_diidii,"_i":invoke_diidiiii,"$":invoke_diii,"Zg":invoke_diiid,"jg":invoke_diiiddi,"Ae":invoke_diiidii,"Kd":invoke_diiidiiddi,"sb":invoke_diiidiii,"Yi":invoke_diiidiiii,"Sb":invoke_diiii,"Cc":invoke_diiiidd,"Xi":invoke_diiiidii,"Cb":invoke_diiiii,"wd":invoke_diiiiii,"Gb":invoke_diiiiiidiiii,"ch":invoke_diiiiiii,"m":invoke_i,"Pc":invoke_iddddiid,"Ud":invoke_idddii,"Lh":invoke_iddid,"jf":invoke_iddiddiiiii,"bh":invoke_iddii,"Rc":invoke_iddiii,"sc":invoke_iddiiiiii,"Yg":invoke_iddiiiiiii,"ff":invoke_idi,"Oc":invoke_idid,"gc":invoke_idii,"Fb":invoke_idiid,"kd":invoke_idiiddii,"Og":invoke_idiiididii,"Hd":invoke_idiiiii,"Ub":invoke_idiiiiii,"b":invoke_ii,"F":invoke_iid,"sa":invoke_iidd,"Aa":invoke_iiddd,"eh":invoke_iidddd,"_h":invoke_iiddddd,"Kf":invoke_iiddddddd,"ye":invoke_iiddddddddiii,"Ph":invoke_iiddddddiiii,"xe":invoke_iiddddi,"oe":invoke_iiddddii,"rf":invoke_iidddi,"Hh":invoke_iidddidd,"Jf":invoke_iidddiii,"Ag":invoke_iidddiiiiii,"Bg":invoke_iidddiiiiiiiii,"yh":invoke_iidddiiiiiiiiii,"Ia":invoke_iiddi,"Ti":invoke_iiddid,"Be":invoke_iiddiddidii,"Rb":invoke_iiddii,"Sf":invoke_iiddiid,"Mi":invoke_iiddiiid,"Qh":invoke_iiddiiiii,"of":invoke_iiddiiiiii,"Di":invoke_iiddiiiiiiiiii,"V":invoke_iidi,"fd":invoke_iidid,"ji":invoke_iididd,"Hi":invoke_iididdii,"Gi":invoke_iididi,"df":invoke_iididiii,"na":invoke_iidii,"ai":invoke_iidiiddii,"Ja":invoke_iidiii,"$b":invoke_iidiiid,"Qc":invoke_iidiiidd,"Sc":invoke_iidiiii,"qd":invoke_iidiiiidiiiiii,"ve":invoke_iidiiiiii,"pe":invoke_iidiiiiiiiii,"e":invoke_iii,"N":invoke_iiid,"O":invoke_iiidd,"Nb":invoke_iiiddd,"Bb":invoke_iiidddd,"xf":invoke_iiiddddd,"hb":invoke_iiidddddd,"Xf":invoke_iiidddddddddd,"ec":invoke_iiidddddiii,"vd":invoke_iiiddddi,"Th":invoke_iiiddddid,"ra":invoke_iiiddddii,"Ve":invoke_iiiddddiii,"Wd":invoke_iiidddi,"ah":invoke_iiidddid,"Re":invoke_iiidddiid,"Pd":invoke_iiidddiiiii,"Ba":invoke_iiiddi,"Jb":invoke_iiiddid,"_a":invoke_iiiddidd,"Qb":invoke_iiiddidddd,"wh":invoke_iiiddidi,"G":invoke_iiiddii,"Yh":invoke_iiiddiidd,"Ii":invoke_iiiddiii,"Ue":invoke_iiiddiiii,"S":invoke_iiidi,"Ob":invoke_iiidid,"Md":invoke_iiididdii,"Uh":invoke_iiididi,"Ga":invoke_iiidii,"Of":invoke_iiidiid,"Lf":invoke_iiidiidiid,"qa":invoke_iiidiii,"kg":invoke_iiidiiiid,"rd":invoke_iiidiiiii,"bd":invoke_iiidiiiiii,"k":invoke_iiii,"K":invoke_iiiid,"ka":invoke_iiiidd,"Pb":invoke_iiiiddd,"Bc":invoke_iiiidddd,"Zd":invoke_iiiidddddd,"cj":invoke_iiiidddddddddd,"Nh":invoke_iiiiddddddi,"Fi":invoke_iiiiddddddii,"sd":invoke_iiiiddddi,"zd":invoke_iiiiddddidd,"oc":invoke_iiiidddi,"ya":invoke_iiiidddid,"ei":invoke_iiiidddiiii,"Rd":invoke_iiiidddiiiii,"Tb":invoke_iiiiddi,"vg":invoke_iiiiddiddiiii,"ab":invoke_iiiiddii,"Lg":invoke_iiiiddiid,"Te":invoke_iiiiddiii,"yd":invoke_iiiiddiiii,"Qa":invoke_iiiidi,"Ji":invoke_iiiidid,"lj":invoke_iiiididi,"uc":invoke_iiiidii,"wb":invoke_iiiidiii,"ni":invoke_iiiidiiid,"vi":invoke_iiiidiiiddddddd,"Li":invoke_iiiidiiii,"Mh":invoke_iiiidiiiii,"Mg":invoke_iiiidiiiiiid,"n":invoke_iiiii,"ma":invoke_iiiiid,"Va":invoke_iiiiidd,"md":invoke_iiiiiddd,"aj":invoke_iiiiidddd,"bf":invoke_iiiiiddddi,"Ac":invoke_iiiiiddi,"hd":invoke_iiiiiddidi,"zb":invoke_iiiiiddii,"od":invoke_iiiiiddiiddidiii,"pd":invoke_iiiiiddiididii,"If":invoke_iiiiiddiii,"di":invoke_iiiiiddiiiiiii,"ic":invoke_iiiiidi,"Xa":invoke_iiiiididi,"qe":invoke_iiiiidii,"xb":invoke_iiiiidiidd,"vf":invoke_iiiiidiii,"kj":invoke_iiiiidiiidi,"Qf":invoke_iiiiidiiiiii,"y":invoke_iiiiii,"ia":invoke_iiiiiid,"Dc":invoke_iiiiiidd,"Ai":invoke_iiiiiidddii,"fi":invoke_iiiiiiddi,"Mf":invoke_iiiiiiddiddiii,"zg":invoke_iiiiiiddiddiiiii,"Yb":invoke_iiiiiiddiiddidii,"ce":invoke_iiiiiiddiiiii,"Sh":invoke_iiiiiidi,"Td":invoke_iiiiiidiii,"nb":invoke_iiiiiidiiidd,"wi":invoke_iiiiiidiiiii,"u":invoke_iiiiiii,"Ra":invoke_iiiiiiid,"Jh":invoke_iiiiiiiddi,"xg":invoke_iiiiiiiddiddiiiiii,"qi":invoke_iiiiiiiddidii,"ri":invoke_iiiiiiididi,"w":invoke_iiiiiiii,"ki":invoke_iiiiiiiid,"af":invoke_iiiiiiiidd,"Hc":invoke_iiiiiiiidddddddddiiddii,"pf":invoke_iiiiiiiidddddiiidddd,"xd":invoke_iiiiiiiiddi,"Dg":invoke_iiiiiiiiddidi,"Wb":invoke_iiiiiiiiddii,"Jd":invoke_iiiiiiiiddiiii,"Wc":invoke_iiiiiiiiddiiiii,"xh":invoke_iiiiiiiididd,"Ni":invoke_iiiiiiiidiii,"fa":invoke_iiiiiiiii,"pb":invoke_iiiiiiiiid,"Ad":invoke_iiiiiiiiidddd,"$i":invoke_iiiiiiiiiddddii,"mi":invoke_iiiiiiiiiddiiii,"uf":invoke_iiiiiiiiidi,"ue":invoke_iiiiiiiiidiii,"Ye":invoke_iiiiiiiiidiiii,"J":invoke_iiiiiiiiii,"Xe":invoke_iiiiiiiiiid,"Gg":invoke_iiiiiiiiiidddiiiiiiiiii,"mf":invoke_iiiiiiiiiiddidd,"Hg":invoke_iiiiiiiiiidiiiiiiiiii,"Za":invoke_iiiiiiiiiii,"bg":invoke_iiiiiiiiiiiddddiiiiiiiiii,"Le":invoke_iiiiiiiiiiiddddiiiiiiiiiii,"Fd":invoke_iiiiiiiiiiidi,"Sa":invoke_iiiiiiiiiiii,"Bd":invoke_iiiiiiiiiiiid,"Od":invoke_iiiiiiiiiiiiddddiiiiiiiii,"Yc":invoke_iiiiiiiiiiiiddddiiiiiiiiiiiiii,"jd":invoke_iiiiiiiiiiiiddiiiiii,"Kb":invoke_iiiiiiiiiiiii,"Qg":invoke_iiiiiiiiiiiiid,"wc":invoke_iiiiiiiiiiiiii,"je":invoke_iiiiiiiiiiiiiid,"We":invoke_iiiiiiiiiiiiiiddi,"mg":invoke_iiiiiiiiiiiiiii,"re":invoke_iiiiiiiiiiiiiiiddddiiiiiiiii,"te":invoke_iiiiiiiiiiiiiiiddddiiiiiiiiii,"kc":invoke_iiiiiiiiiiiiiiii,"Wh":invoke_iiiiiiiiiiiiiiiii,"qg":invoke_iiiiiiiiiiiiiiiiidddiiiiiiiii,"fc":invoke_iiiiiiiiiiiiiiiiii,"ng":invoke_iiiiiiiiiiiiiiiiiiddddiiiiiiiiii,"pg":invoke_iiiiiiiiiiiiiiiiiiddddiiiiiiiiiii,"Qd":invoke_iiiiiiiiiiiiiiiiiiii,"Xh":invoke_iiiiiiiiiiiiiiiiiiiiiiiii,"_f":invoke_iiiiiiiiiiiiiiiiiiiiiiiiiii,"hh":invoke_iiji,"R":invoke_v,"Vd":invoke_vddd,"Pe":invoke_vddddiiiiiiiiiiii,"mb":invoke_vdddii,"Lc":invoke_vdddiii,"hg":invoke_vdddiiii,"cg":invoke_vdddiiiiiiiii,"Na":invoke_vddi,"pi":invoke_vddiddi,"Ab":invoke_vddiddiii,"Mb":invoke_vddidiii,"Db":invoke_vddii,"dh":invoke_vddiii,"ib":invoke_vddiiii,"pc":invoke_vddiiiiiii,"Wf":invoke_vddiiiiiiiiiiiiiii,"le":invoke_vddiiiiiiiiiiiiiiiii,"Vf":invoke_vddiiiiiiiiiiiiiiiiiiii,"Uf":invoke_vddiiiiiiiiiiiiiiiiiiiiiiii,"zc":invoke_vdi,"fb":invoke_vdiddddi,"Ic":invoke_vdiddii,"Zb":invoke_vdiddiiii,"dd":invoke_vdiddiiiiii,"ub":invoke_vdidii,"ed":invoke_vdiii,"ne":invoke_vdiiii,"Ua":invoke_vdiiiii,"Eb":invoke_vdiiiiiiii,"eb":invoke_vdiiiiiiiii,"ze":invoke_vdiiiiiiiiii,"Wg":invoke_vdiiiiiiiiiii,"a":invoke_vi,"A":invoke_vid,"da":invoke_vidd,"wa":invoke_viddd,"Fa":invoke_vidddd,"Dh":invoke_viddddd,"Ib":invoke_vidddddd,"Sg":invoke_viddddddd,"Gc":invoke_vidddddddddddd,"qc":invoke_vidddddddii,"Ze":invoke_viddddddiii,"Ce":invoke_vidddddi,"Nd":invoke_vidddddiii,"xc":invoke_viddddi,"mc":invoke_viddddii,"Ie":invoke_viddddiid,"se":invoke_viddddiii,"ld":invoke_viddddiiii,"dj":invoke_viddddiiiii,"cb":invoke_vidddi,"Ne":invoke_vidddidddddd,"Ed":invoke_vidddii,"og":invoke_vidddiii,"Xc":invoke_vidddiiidi,"aa":invoke_viddi,"ac":invoke_viddid,"Yd":invoke_viddidd,"Fh":invoke_viddidddiiii,"jb":invoke_viddii,"Vc":invoke_viddiiddi,"Cf":invoke_viddiiddiii,"Bf":invoke_viddiididiiiiiiiiiiiiiiiiiii,"xi":invoke_viddiidiiidii,"P":invoke_viddiii,"$a":invoke_viddiiiiii,"he":invoke_viddiiiiiiiiii,"C":invoke_vidi,"Ka":invoke_vidid,"Lb":invoke_vididd,"Rf":invoke_vididdi,"lb":invoke_vididi,"I":invoke_vidii,"$h":invoke_vidiiddddii,"$g":invoke_vidiidii,"W":invoke_vidiii,"Ei":invoke_vidiiiddii,"_d":invoke_vidiiidi,"bc":invoke_vidiiii,"qj":invoke_vidiiiiidd,"de":invoke_vidiiiiii,"Vh":invoke_vidiiiiiiiiiii,"g":invoke_vii,"s":invoke_viid,"B":invoke_viidd,"ca":invoke_viiddd,"Ea":invoke_viidddd,"Fc":invoke_viiddddd,"ea":invoke_viidddddd,"Oe":invoke_viidddddddd,"dc":invoke_viidddddddiiii,"kf":invoke_viidddddi,"ig":invoke_viidddddiii,"we":invoke_viiddddi,"Se":invoke_viiddddidd,"Ig":invoke_viiddddiddd,"ag":invoke_viiddddiii,"db":invoke_viidddi,"eg":invoke_viidddii,"Xd":invoke_viidddiii,"X":invoke_viiddi,"hi":invoke_viiddid,"Ec":invoke_viiddidd,"Xg":invoke_viiddidi,"ja":invoke_viiddii,"bi":invoke_viiddiidiiiiii,"ud":invoke_viiddiii,"Sd":invoke_viiddiiii,"gd":invoke_viiddiiiiii,"Vb":invoke_viiddiiiiiiii,"Y":invoke_viidi,"ua":invoke_viidid,"fe":invoke_viididd,"Ki":invoke_viididdi,"Ee":invoke_viididi,"la":invoke_viidii,"Ci":invoke_viidiid,"qb":invoke_viidiii,"td":invoke_viidiiid,"zf":invoke_viidiiidddii,"Hb":invoke_viidiiiii,"Ge":invoke_viidiiiiii,"j":invoke_viii,"E":invoke_viiid,"T":invoke_viiidd,"tb":invoke_viiiddd,"Ma":invoke_viiidddd,"oi":invoke_viiiddddd,"gg":invoke_viiiddddi,"ug":invoke_viiiddddiddi,"Ug":invoke_viiiddddii,"Jg":invoke_viiidddi,"Oi":invoke_viiidddiii,"Oa":invoke_viiiddi,"zi":invoke_viiiddid,"ci":invoke_viiiddidiii,"lg":invoke_viiiddidiiiii,"rg":invoke_viiiddii,"_b":invoke_viiiddiiii,"Cd":invoke_viiiddiiiii,"Rh":invoke_viiiddiiiiiiiiiiiiii,"za":invoke_viiidi,"Ng":invoke_viiidid,"fj":invoke_viiididi,"ta":invoke_viiidii,"Zc":invoke_viiidiid,"Tc":invoke_viiidiii,"Kh":invoke_viiidiiii,"yi":invoke_viiidiiiiddiiiiii,"La":invoke_viiidiiiii,"yf":invoke_viiidiiiiiiiiii,"l":invoke_viiii,"L":invoke_viiiid,"oa":invoke_viiiidd,"Id":invoke_viiiidddd,"hf":invoke_viiiiddddd,"dg":invoke_viiiidddddd,"Af":invoke_viiiidddii,"fg":invoke_viiiidddiiiii,"cc":invoke_viiiiddi,"ha":invoke_viiiidi,"Ha":invoke_viiiidii,"Xb":invoke_viiiidiidi,"Dd":invoke_viiiidiii,"gj":invoke_viiiidiiidi,"Rg":invoke_viiiidiiii,"sg":invoke_viiiidiiiiiidiiiiiiiiiii,"r":invoke_viiiii,"U":invoke_viiiiid,"xa":invoke_viiiiidd,"Jc":invoke_viiiiiddd,"rc":invoke_viiiiidddd,"Ih":invoke_viiiiidddddddd,"Gd":invoke_viiiiiddddi,"yg":invoke_viiiiiddddiddi,"Mc":invoke_viiiiidddii,"Kg":invoke_viiiiidddiii,"Nc":invoke_viiiiiddi,"Eh":invoke_viiiiiddidd,"jj":invoke_viiiiiddii,"ge":invoke_viiiiiddiii,"Pg":invoke_viiiiiddiiii,"tg":invoke_viiiiiddiiiiii,"bb":invoke_viiiiidi,"ae":invoke_viiiiidii,"De":invoke_viiiiidiii,"z":invoke_viiiiii,"Ya":invoke_viiiiiid,"$e":invoke_viiiiiidd,"be":invoke_viiiiiiddddidd,"wg":invoke_viiiiiiddddiddi,"Pf":invoke_viiiiiidddi,"$c":invoke_viiiiiiddi,"Vi":invoke_viiiiiiddiii,"Zh":invoke_viiiiiiddiiii,"ij":invoke_viiiiiidi,"ef":invoke_viiiiiididi,"mj":invoke_viiiiiidii,"ee":invoke_viiiiiidiidid,"jc":invoke_viiiiiidiii,"M":invoke_viiiiiii,"li":invoke_viiiiiiid,"Oh":invoke_viiiiiiiddd,"Bh":invoke_viiiiiiiddii,"Ch":invoke_viiiiiiiddiiii,"He":invoke_viiiiiiidiiiidiii,"ga":invoke_viiiiiiii,"gb":invoke_viiiiiiiid,"Me":invoke_viiiiiiiiddi,"Si":invoke_viiiiiiiidii,"va":invoke_viiiiiiiii,"cf":invoke_viiiiiiiiid,"nd":invoke_viiiiiiiiidd,"nf":invoke_viiiiiiiiiddi,"kb":invoke_viiiiiiiiiddii,"Ca":invoke_viiiiiiiiii,"Nf":invoke_viiiiiiiiiid,"zh":invoke_viiiiiiiiiidddiii,"Ah":invoke_viiiiiiiiiidddiiiiii,"Qe":invoke_viiiiiiiiiiddi,"Wa":invoke_viiiiiiiiiii,"Gh":invoke_viiiiiiiiiiidd,"$d":invoke_viiiiiiiiiiidi,"rb":invoke_viiiiiiiiiiii,"nc":invoke_viiiiiiiiiiiidi,"Tf":invoke_viiiiiiiiiiiidii,"Uc":invoke_viiiiiiiiiiiii,"ke":invoke_viiiiiiiiiiiiidi,"_c":invoke_viiiiiiiiiiiiii,"ie":invoke_viiiiiiiiiiiiiidddd,"Eg":invoke_viiiiiiiiiiiiiidddiiiiiiiii,"Fg":invoke_viiiiiiiiiiiiiiddiiiiiiiii,"cd":invoke_viiiiiiiiiiiiiii,"$f":invoke_viiiiiiiiiiiiiiiii,"si":invoke_viiiiiiiiiiiiiiiiidddiiiiiiiiiiii,"hj":invoke_viiiiiiiiiiiiiiiiii,"qf":invoke_viiiiiiiiiiiiiiiiiii,"ti":invoke_viiiiiiiiiiiiiiiiiiidddiiiiiiiiii,"ui":invoke_viiiiiiiiiiiiiiiiiiiddiiiiiiiiii,"_g":invoke_viiiiiiiiiiiiiiiiiiiii,"_e":invoke_viiiiiiiiiiiiiiiiiiiiii,"fh":invoke_viiiiiiiiiiiiiiiiiiiiiii,"Ri":invoke_viiiiiiiiiiiiiiiiiiiiiiiii,"Vg":invoke_viiiiiiiiiiiiiiiiiiiiiiiiiii,"_":_llvm_eh_typeid_for,"Bi":_localtime,"memory":wasmMemory,"oj":_pthread_create,"sf":_pthread_detach,"nj":_pthread_join,"Ui":_pthread_mutexattr_destroy,"Zi":_pthread_mutexattr_init,"Wi":_pthread_mutexattr_settype,"h":_setTempRet0,"kh":_strftime_l,"pj":_sysconf,"table":wasmTable,"lf":_times};var asm=createWasm();var ___wasm_call_ctors=Module["___wasm_call_ctors"]=function(){return(___wasm_call_ctors=Module["___wasm_call_ctors"]=Module["asm"]["rj"]).apply(null,arguments)};var ___em_js__array_bounds_check_error=Module["___em_js__array_bounds_check_error"]=function(){return(___em_js__array_bounds_check_error=Module["___em_js__array_bounds_check_error"]=Module["asm"]["sj"]).apply(null,arguments)};var _emscripten_bind_Standard_Transient_get_type_name_0=Module["_emscripten_bind_Standard_Transient_get_type_name_0"]=function(){return(_emscripten_bind_Standard_Transient_get_type_name_0=Module["_emscripten_bind_Standard_Transient_get_type_name_0"]=Module["asm"]["tj"]).apply(null,arguments)};var _emscripten_bind_Standard_Transient_DynamicType_0=Module["_emscripten_bind_Standard_Transient_DynamicType_0"]=function(){return(_emscripten_bind_Standard_Transient_DynamicType_0=Module["_emscripten_bind_Standard_Transient_DynamicType_0"]=Module["asm"]["uj"]).apply(null,arguments)};var _emscripten_bind_Standard_Transient___destroy___0=Module["_emscripten_bind_Standard_Transient___destroy___0"]=function(){return(_emscripten_bind_Standard_Transient___destroy___0=Module["_emscripten_bind_Standard_Transient___destroy___0"]=Module["asm"]["vj"]).apply(null,arguments)};var _emscripten_bind_Geom_Geometry_get_type_name_0=Module["_emscripten_bind_Geom_Geometry_get_type_name_0"]=function(){return(_emscripten_bind_Geom_Geometry_get_type_name_0=Module["_emscripten_bind_Geom_Geometry_get_type_name_0"]=Module["asm"]["wj"]).apply(null,arguments)};var _emscripten_bind_Geom_Geometry_DynamicType_0=Module["_emscripten_bind_Geom_Geometry_DynamicType_0"]=function(){return(_emscripten_bind_Geom_Geometry_DynamicType_0=Module["_emscripten_bind_Geom_Geometry_DynamicType_0"]=Module["asm"]["xj"]).apply(null,arguments)};var _emscripten_bind_Geom_Geometry___destroy___0=Module["_emscripten_bind_Geom_Geometry___destroy___0"]=function(){return(_emscripten_bind_Geom_Geometry___destroy___0=Module["_emscripten_bind_Geom_Geometry___destroy___0"]=Module["asm"]["yj"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeShape_Build_0=Module["_emscripten_bind_BRepBuilderAPI_MakeShape_Build_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeShape_Build_0=Module["_emscripten_bind_BRepBuilderAPI_MakeShape_Build_0"]=Module["asm"]["zj"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeShape_Shape_0=Module["_emscripten_bind_BRepBuilderAPI_MakeShape_Shape_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeShape_Shape_0=Module["_emscripten_bind_BRepBuilderAPI_MakeShape_Shape_0"]=Module["asm"]["Aj"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeShape_IsDeleted_1=Module["_emscripten_bind_BRepBuilderAPI_MakeShape_IsDeleted_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeShape_IsDeleted_1=Module["_emscripten_bind_BRepBuilderAPI_MakeShape_IsDeleted_1"]=Module["asm"]["Bj"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeShape___destroy___0=Module["_emscripten_bind_BRepBuilderAPI_MakeShape___destroy___0"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeShape___destroy___0=Module["_emscripten_bind_BRepBuilderAPI_MakeShape___destroy___0"]=Module["asm"]["Cj"]).apply(null,arguments)};var _emscripten_bind_Geom_Surface_get_type_name_0=Module["_emscripten_bind_Geom_Surface_get_type_name_0"]=function(){return(_emscripten_bind_Geom_Surface_get_type_name_0=Module["_emscripten_bind_Geom_Surface_get_type_name_0"]=Module["asm"]["Dj"]).apply(null,arguments)};var _emscripten_bind_Geom_Surface_DynamicType_0=Module["_emscripten_bind_Geom_Surface_DynamicType_0"]=function(){return(_emscripten_bind_Geom_Surface_DynamicType_0=Module["_emscripten_bind_Geom_Surface_DynamicType_0"]=Module["asm"]["Ej"]).apply(null,arguments)};var _emscripten_bind_Geom_Surface___destroy___0=Module["_emscripten_bind_Geom_Surface___destroy___0"]=function(){return(_emscripten_bind_Geom_Surface___destroy___0=Module["_emscripten_bind_Geom_Surface___destroy___0"]=Module["asm"]["Fj"]).apply(null,arguments)};var _emscripten_bind_Geom_Curve_Reverse_0=Module["_emscripten_bind_Geom_Curve_Reverse_0"]=function(){return(_emscripten_bind_Geom_Curve_Reverse_0=Module["_emscripten_bind_Geom_Curve_Reverse_0"]=Module["asm"]["Gj"]).apply(null,arguments)};var _emscripten_bind_Geom_Curve_ReversedParameter_1=Module["_emscripten_bind_Geom_Curve_ReversedParameter_1"]=function(){return(_emscripten_bind_Geom_Curve_ReversedParameter_1=Module["_emscripten_bind_Geom_Curve_ReversedParameter_1"]=Module["asm"]["Hj"]).apply(null,arguments)};var _emscripten_bind_Geom_Curve_TransformedParameter_2=Module["_emscripten_bind_Geom_Curve_TransformedParameter_2"]=function(){return(_emscripten_bind_Geom_Curve_TransformedParameter_2=Module["_emscripten_bind_Geom_Curve_TransformedParameter_2"]=Module["asm"]["Ij"]).apply(null,arguments)};var _emscripten_bind_Geom_Curve_ParametricTransformation_1=Module["_emscripten_bind_Geom_Curve_ParametricTransformation_1"]=function(){return(_emscripten_bind_Geom_Curve_ParametricTransformation_1=Module["_emscripten_bind_Geom_Curve_ParametricTransformation_1"]=Module["asm"]["Jj"]).apply(null,arguments)};var _emscripten_bind_Geom_Curve_Reversed_0=Module["_emscripten_bind_Geom_Curve_Reversed_0"]=function(){return(_emscripten_bind_Geom_Curve_Reversed_0=Module["_emscripten_bind_Geom_Curve_Reversed_0"]=Module["asm"]["Kj"]).apply(null,arguments)};var _emscripten_bind_Geom_Curve_FirstParameter_0=Module["_emscripten_bind_Geom_Curve_FirstParameter_0"]=function(){return(_emscripten_bind_Geom_Curve_FirstParameter_0=Module["_emscripten_bind_Geom_Curve_FirstParameter_0"]=Module["asm"]["Lj"]).apply(null,arguments)};var _emscripten_bind_Geom_Curve_LastParameter_0=Module["_emscripten_bind_Geom_Curve_LastParameter_0"]=function(){return(_emscripten_bind_Geom_Curve_LastParameter_0=Module["_emscripten_bind_Geom_Curve_LastParameter_0"]=Module["asm"]["Mj"]).apply(null,arguments)};var _emscripten_bind_Geom_Curve_IsClosed_0=Module["_emscripten_bind_Geom_Curve_IsClosed_0"]=function(){return(_emscripten_bind_Geom_Curve_IsClosed_0=Module["_emscripten_bind_Geom_Curve_IsClosed_0"]=Module["asm"]["Nj"]).apply(null,arguments)};var _emscripten_bind_Geom_Curve_IsPeriodic_0=Module["_emscripten_bind_Geom_Curve_IsPeriodic_0"]=function(){return(_emscripten_bind_Geom_Curve_IsPeriodic_0=Module["_emscripten_bind_Geom_Curve_IsPeriodic_0"]=Module["asm"]["Oj"]).apply(null,arguments)};var _emscripten_bind_Geom_Curve_Period_0=Module["_emscripten_bind_Geom_Curve_Period_0"]=function(){return(_emscripten_bind_Geom_Curve_Period_0=Module["_emscripten_bind_Geom_Curve_Period_0"]=Module["asm"]["Pj"]).apply(null,arguments)};var _emscripten_bind_Geom_Curve_IsCN_1=Module["_emscripten_bind_Geom_Curve_IsCN_1"]=function(){return(_emscripten_bind_Geom_Curve_IsCN_1=Module["_emscripten_bind_Geom_Curve_IsCN_1"]=Module["asm"]["Qj"]).apply(null,arguments)};var _emscripten_bind_Geom_Curve_D0_2=Module["_emscripten_bind_Geom_Curve_D0_2"]=function(){return(_emscripten_bind_Geom_Curve_D0_2=Module["_emscripten_bind_Geom_Curve_D0_2"]=Module["asm"]["Rj"]).apply(null,arguments)};var _emscripten_bind_Geom_Curve_D1_3=Module["_emscripten_bind_Geom_Curve_D1_3"]=function(){return(_emscripten_bind_Geom_Curve_D1_3=Module["_emscripten_bind_Geom_Curve_D1_3"]=Module["asm"]["Sj"]).apply(null,arguments)};var _emscripten_bind_Geom_Curve_D2_4=Module["_emscripten_bind_Geom_Curve_D2_4"]=function(){return(_emscripten_bind_Geom_Curve_D2_4=Module["_emscripten_bind_Geom_Curve_D2_4"]=Module["asm"]["Tj"]).apply(null,arguments)};var _emscripten_bind_Geom_Curve_D3_5=Module["_emscripten_bind_Geom_Curve_D3_5"]=function(){return(_emscripten_bind_Geom_Curve_D3_5=Module["_emscripten_bind_Geom_Curve_D3_5"]=Module["asm"]["Uj"]).apply(null,arguments)};var _emscripten_bind_Geom_Curve_DN_2=Module["_emscripten_bind_Geom_Curve_DN_2"]=function(){return(_emscripten_bind_Geom_Curve_DN_2=Module["_emscripten_bind_Geom_Curve_DN_2"]=Module["asm"]["Vj"]).apply(null,arguments)};var _emscripten_bind_Geom_Curve_Value_1=Module["_emscripten_bind_Geom_Curve_Value_1"]=function(){return(_emscripten_bind_Geom_Curve_Value_1=Module["_emscripten_bind_Geom_Curve_Value_1"]=Module["asm"]["Wj"]).apply(null,arguments)};var _emscripten_bind_Geom_Curve___destroy___0=Module["_emscripten_bind_Geom_Curve___destroy___0"]=function(){return(_emscripten_bind_Geom_Curve___destroy___0=Module["_emscripten_bind_Geom_Curve___destroy___0"]=Module["asm"]["Xj"]).apply(null,arguments)};var _emscripten_bind_Geom2d_Curve_Period_0=Module["_emscripten_bind_Geom2d_Curve_Period_0"]=function(){return(_emscripten_bind_Geom2d_Curve_Period_0=Module["_emscripten_bind_Geom2d_Curve_Period_0"]=Module["asm"]["Yj"]).apply(null,arguments)};var _emscripten_bind_Geom2d_Curve_Value_1=Module["_emscripten_bind_Geom2d_Curve_Value_1"]=function(){return(_emscripten_bind_Geom2d_Curve_Value_1=Module["_emscripten_bind_Geom2d_Curve_Value_1"]=Module["asm"]["Zj"]).apply(null,arguments)};var _emscripten_bind_Geom2d_Curve___destroy___0=Module["_emscripten_bind_Geom2d_Curve___destroy___0"]=function(){return(_emscripten_bind_Geom2d_Curve___destroy___0=Module["_emscripten_bind_Geom2d_Curve___destroy___0"]=Module["asm"]["_j"]).apply(null,arguments)};var _emscripten_bind_Transfer_ProcessForTransient_Transfer_ProcessForTransient_0=Module["_emscripten_bind_Transfer_ProcessForTransient_Transfer_ProcessForTransient_0"]=function(){return(_emscripten_bind_Transfer_ProcessForTransient_Transfer_ProcessForTransient_0=Module["_emscripten_bind_Transfer_ProcessForTransient_Transfer_ProcessForTransient_0"]=Module["asm"]["$j"]).apply(null,arguments)};var _emscripten_bind_Transfer_ProcessForTransient_GetProgress_0=Module["_emscripten_bind_Transfer_ProcessForTransient_GetProgress_0"]=function(){return(_emscripten_bind_Transfer_ProcessForTransient_GetProgress_0=Module["_emscripten_bind_Transfer_ProcessForTransient_GetProgress_0"]=Module["asm"]["ak"]).apply(null,arguments)};var _emscripten_bind_Transfer_ProcessForTransient_SetProgress_1=Module["_emscripten_bind_Transfer_ProcessForTransient_SetProgress_1"]=function(){return(_emscripten_bind_Transfer_ProcessForTransient_SetProgress_1=Module["_emscripten_bind_Transfer_ProcessForTransient_SetProgress_1"]=Module["asm"]["bk"]).apply(null,arguments)};var _emscripten_bind_Transfer_ProcessForTransient___destroy___0=Module["_emscripten_bind_Transfer_ProcessForTransient___destroy___0"]=function(){return(_emscripten_bind_Transfer_ProcessForTransient___destroy___0=Module["_emscripten_bind_Transfer_ProcessForTransient___destroy___0"]=Module["asm"]["ck"]).apply(null,arguments)};var _emscripten_bind_Geom2d_Conic_Period_0=Module["_emscripten_bind_Geom2d_Conic_Period_0"]=function(){return(_emscripten_bind_Geom2d_Conic_Period_0=Module["_emscripten_bind_Geom2d_Conic_Period_0"]=Module["asm"]["dk"]).apply(null,arguments)};var _emscripten_bind_Geom2d_Conic_Value_1=Module["_emscripten_bind_Geom2d_Conic_Value_1"]=function(){return(_emscripten_bind_Geom2d_Conic_Value_1=Module["_emscripten_bind_Geom2d_Conic_Value_1"]=Module["asm"]["ek"]).apply(null,arguments)};var _emscripten_bind_Geom2d_Conic___destroy___0=Module["_emscripten_bind_Geom2d_Conic___destroy___0"]=function(){return(_emscripten_bind_Geom2d_Conic___destroy___0=Module["_emscripten_bind_Geom2d_Conic___destroy___0"]=Module["asm"]["fk"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Builder_MakeWire_1=Module["_emscripten_bind_TopoDS_Builder_MakeWire_1"]=function(){return(_emscripten_bind_TopoDS_Builder_MakeWire_1=Module["_emscripten_bind_TopoDS_Builder_MakeWire_1"]=Module["asm"]["gk"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Builder_MakeCompound_1=Module["_emscripten_bind_TopoDS_Builder_MakeCompound_1"]=function(){return(_emscripten_bind_TopoDS_Builder_MakeCompound_1=Module["_emscripten_bind_TopoDS_Builder_MakeCompound_1"]=Module["asm"]["hk"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Builder_Add_2=Module["_emscripten_bind_TopoDS_Builder_Add_2"]=function(){return(_emscripten_bind_TopoDS_Builder_Add_2=Module["_emscripten_bind_TopoDS_Builder_Add_2"]=Module["asm"]["ik"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Builder_Remove_2=Module["_emscripten_bind_TopoDS_Builder_Remove_2"]=function(){return(_emscripten_bind_TopoDS_Builder_Remove_2=Module["_emscripten_bind_TopoDS_Builder_Remove_2"]=Module["asm"]["jk"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Builder___destroy___0=Module["_emscripten_bind_TopoDS_Builder___destroy___0"]=function(){return(_emscripten_bind_TopoDS_Builder___destroy___0=Module["_emscripten_bind_TopoDS_Builder___destroy___0"]=Module["asm"]["kk"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape_TopoDS_Shape_0=Module["_emscripten_bind_TopoDS_Shape_TopoDS_Shape_0"]=function(){return(_emscripten_bind_TopoDS_Shape_TopoDS_Shape_0=Module["_emscripten_bind_TopoDS_Shape_TopoDS_Shape_0"]=Module["asm"]["lk"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape_TopoDS_Shape_1=Module["_emscripten_bind_TopoDS_Shape_TopoDS_Shape_1"]=function(){return(_emscripten_bind_TopoDS_Shape_TopoDS_Shape_1=Module["_emscripten_bind_TopoDS_Shape_TopoDS_Shape_1"]=Module["asm"]["mk"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape_IsNull_0=Module["_emscripten_bind_TopoDS_Shape_IsNull_0"]=function(){return(_emscripten_bind_TopoDS_Shape_IsNull_0=Module["_emscripten_bind_TopoDS_Shape_IsNull_0"]=Module["asm"]["nk"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape_Nullify_0=Module["_emscripten_bind_TopoDS_Shape_Nullify_0"]=function(){return(_emscripten_bind_TopoDS_Shape_Nullify_0=Module["_emscripten_bind_TopoDS_Shape_Nullify_0"]=Module["asm"]["ok"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape_Location_0=Module["_emscripten_bind_TopoDS_Shape_Location_0"]=function(){return(_emscripten_bind_TopoDS_Shape_Location_0=Module["_emscripten_bind_TopoDS_Shape_Location_0"]=Module["asm"]["pk"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape_Located_1=Module["_emscripten_bind_TopoDS_Shape_Located_1"]=function(){return(_emscripten_bind_TopoDS_Shape_Located_1=Module["_emscripten_bind_TopoDS_Shape_Located_1"]=Module["asm"]["qk"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape_Orientation_0=Module["_emscripten_bind_TopoDS_Shape_Orientation_0"]=function(){return(_emscripten_bind_TopoDS_Shape_Orientation_0=Module["_emscripten_bind_TopoDS_Shape_Orientation_0"]=Module["asm"]["rk"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape_Oriented_1=Module["_emscripten_bind_TopoDS_Shape_Oriented_1"]=function(){return(_emscripten_bind_TopoDS_Shape_Oriented_1=Module["_emscripten_bind_TopoDS_Shape_Oriented_1"]=Module["asm"]["sk"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape_ShapeType_0=Module["_emscripten_bind_TopoDS_Shape_ShapeType_0"]=function(){return(_emscripten_bind_TopoDS_Shape_ShapeType_0=Module["_emscripten_bind_TopoDS_Shape_ShapeType_0"]=Module["asm"]["tk"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape_Free_0=Module["_emscripten_bind_TopoDS_Shape_Free_0"]=function(){return(_emscripten_bind_TopoDS_Shape_Free_0=Module["_emscripten_bind_TopoDS_Shape_Free_0"]=Module["asm"]["uk"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape_Locked_0=Module["_emscripten_bind_TopoDS_Shape_Locked_0"]=function(){return(_emscripten_bind_TopoDS_Shape_Locked_0=Module["_emscripten_bind_TopoDS_Shape_Locked_0"]=Module["asm"]["vk"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape_Modified_0=Module["_emscripten_bind_TopoDS_Shape_Modified_0"]=function(){return(_emscripten_bind_TopoDS_Shape_Modified_0=Module["_emscripten_bind_TopoDS_Shape_Modified_0"]=Module["asm"]["wk"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape_Checked_0=Module["_emscripten_bind_TopoDS_Shape_Checked_0"]=function(){return(_emscripten_bind_TopoDS_Shape_Checked_0=Module["_emscripten_bind_TopoDS_Shape_Checked_0"]=Module["asm"]["xk"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape_Orientable_0=Module["_emscripten_bind_TopoDS_Shape_Orientable_0"]=function(){return(_emscripten_bind_TopoDS_Shape_Orientable_0=Module["_emscripten_bind_TopoDS_Shape_Orientable_0"]=Module["asm"]["yk"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape_Closed_0=Module["_emscripten_bind_TopoDS_Shape_Closed_0"]=function(){return(_emscripten_bind_TopoDS_Shape_Closed_0=Module["_emscripten_bind_TopoDS_Shape_Closed_0"]=Module["asm"]["zk"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape_Infinite_0=Module["_emscripten_bind_TopoDS_Shape_Infinite_0"]=function(){return(_emscripten_bind_TopoDS_Shape_Infinite_0=Module["_emscripten_bind_TopoDS_Shape_Infinite_0"]=Module["asm"]["Ak"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape_Convex_0=Module["_emscripten_bind_TopoDS_Shape_Convex_0"]=function(){return(_emscripten_bind_TopoDS_Shape_Convex_0=Module["_emscripten_bind_TopoDS_Shape_Convex_0"]=Module["asm"]["Bk"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape_Move_1=Module["_emscripten_bind_TopoDS_Shape_Move_1"]=function(){return(_emscripten_bind_TopoDS_Shape_Move_1=Module["_emscripten_bind_TopoDS_Shape_Move_1"]=Module["asm"]["Ck"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape_Moved_1=Module["_emscripten_bind_TopoDS_Shape_Moved_1"]=function(){return(_emscripten_bind_TopoDS_Shape_Moved_1=Module["_emscripten_bind_TopoDS_Shape_Moved_1"]=Module["asm"]["Dk"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape_Reverse_0=Module["_emscripten_bind_TopoDS_Shape_Reverse_0"]=function(){return(_emscripten_bind_TopoDS_Shape_Reverse_0=Module["_emscripten_bind_TopoDS_Shape_Reverse_0"]=Module["asm"]["Ek"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape_Reversed_0=Module["_emscripten_bind_TopoDS_Shape_Reversed_0"]=function(){return(_emscripten_bind_TopoDS_Shape_Reversed_0=Module["_emscripten_bind_TopoDS_Shape_Reversed_0"]=Module["asm"]["Fk"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape_Complement_0=Module["_emscripten_bind_TopoDS_Shape_Complement_0"]=function(){return(_emscripten_bind_TopoDS_Shape_Complement_0=Module["_emscripten_bind_TopoDS_Shape_Complement_0"]=Module["asm"]["Gk"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape_Complemented_0=Module["_emscripten_bind_TopoDS_Shape_Complemented_0"]=function(){return(_emscripten_bind_TopoDS_Shape_Complemented_0=Module["_emscripten_bind_TopoDS_Shape_Complemented_0"]=Module["asm"]["Hk"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape_Compose_1=Module["_emscripten_bind_TopoDS_Shape_Compose_1"]=function(){return(_emscripten_bind_TopoDS_Shape_Compose_1=Module["_emscripten_bind_TopoDS_Shape_Compose_1"]=Module["asm"]["Ik"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape_Composed_1=Module["_emscripten_bind_TopoDS_Shape_Composed_1"]=function(){return(_emscripten_bind_TopoDS_Shape_Composed_1=Module["_emscripten_bind_TopoDS_Shape_Composed_1"]=Module["asm"]["Jk"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape_NbChildren_0=Module["_emscripten_bind_TopoDS_Shape_NbChildren_0"]=function(){return(_emscripten_bind_TopoDS_Shape_NbChildren_0=Module["_emscripten_bind_TopoDS_Shape_NbChildren_0"]=Module["asm"]["Kk"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape_IsPartner_1=Module["_emscripten_bind_TopoDS_Shape_IsPartner_1"]=function(){return(_emscripten_bind_TopoDS_Shape_IsPartner_1=Module["_emscripten_bind_TopoDS_Shape_IsPartner_1"]=Module["asm"]["Lk"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape_IsSame_1=Module["_emscripten_bind_TopoDS_Shape_IsSame_1"]=function(){return(_emscripten_bind_TopoDS_Shape_IsSame_1=Module["_emscripten_bind_TopoDS_Shape_IsSame_1"]=Module["asm"]["Mk"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape_IsEqual_1=Module["_emscripten_bind_TopoDS_Shape_IsEqual_1"]=function(){return(_emscripten_bind_TopoDS_Shape_IsEqual_1=Module["_emscripten_bind_TopoDS_Shape_IsEqual_1"]=Module["asm"]["Nk"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape_IsNotEqual_1=Module["_emscripten_bind_TopoDS_Shape_IsNotEqual_1"]=function(){return(_emscripten_bind_TopoDS_Shape_IsNotEqual_1=Module["_emscripten_bind_TopoDS_Shape_IsNotEqual_1"]=Module["asm"]["Ok"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape_HashCode_1=Module["_emscripten_bind_TopoDS_Shape_HashCode_1"]=function(){return(_emscripten_bind_TopoDS_Shape_HashCode_1=Module["_emscripten_bind_TopoDS_Shape_HashCode_1"]=Module["asm"]["Pk"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape_EmptyCopy_0=Module["_emscripten_bind_TopoDS_Shape_EmptyCopy_0"]=function(){return(_emscripten_bind_TopoDS_Shape_EmptyCopy_0=Module["_emscripten_bind_TopoDS_Shape_EmptyCopy_0"]=Module["asm"]["Qk"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape_EmptyCopied_0=Module["_emscripten_bind_TopoDS_Shape_EmptyCopied_0"]=function(){return(_emscripten_bind_TopoDS_Shape_EmptyCopied_0=Module["_emscripten_bind_TopoDS_Shape_EmptyCopied_0"]=Module["asm"]["Rk"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shape___destroy___0=Module["_emscripten_bind_TopoDS_Shape___destroy___0"]=function(){return(_emscripten_bind_TopoDS_Shape___destroy___0=Module["_emscripten_bind_TopoDS_Shape___destroy___0"]=Module["asm"]["Sk"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakeOffsetShape_BRepOffsetAPI_MakeOffsetShape_0=Module["_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_BRepOffsetAPI_MakeOffsetShape_0"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_BRepOffsetAPI_MakeOffsetShape_0=Module["_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_BRepOffsetAPI_MakeOffsetShape_0"]=Module["asm"]["Tk"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformBySimple_2=Module["_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformBySimple_2"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformBySimple_2=Module["_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformBySimple_2"]=Module["asm"]["Uk"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformByJoin_3=Module["_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformByJoin_3"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformByJoin_3=Module["_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformByJoin_3"]=Module["asm"]["Vk"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformByJoin_4=Module["_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformByJoin_4"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformByJoin_4=Module["_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformByJoin_4"]=Module["asm"]["Wk"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformByJoin_5=Module["_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformByJoin_5"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformByJoin_5=Module["_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformByJoin_5"]=Module["asm"]["Xk"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformByJoin_6=Module["_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformByJoin_6"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformByJoin_6=Module["_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformByJoin_6"]=Module["asm"]["Yk"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformByJoin_7=Module["_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformByJoin_7"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformByJoin_7=Module["_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformByJoin_7"]=Module["asm"]["Zk"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformByJoin_8=Module["_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformByJoin_8"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformByJoin_8=Module["_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformByJoin_8"]=Module["asm"]["_k"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakeOffsetShape_Shape_0=Module["_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_Shape_0"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_Shape_0=Module["_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_Shape_0"]=Module["asm"]["$k"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakeOffsetShape___destroy___0=Module["_emscripten_bind_BRepOffsetAPI_MakeOffsetShape___destroy___0"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakeOffsetShape___destroy___0=Module["_emscripten_bind_BRepOffsetAPI_MakeOffsetShape___destroy___0"]=Module["asm"]["al"]).apply(null,arguments)};var _emscripten_bind_BRepFilletAPI_LocalOperation_Shape_0=Module["_emscripten_bind_BRepFilletAPI_LocalOperation_Shape_0"]=function(){return(_emscripten_bind_BRepFilletAPI_LocalOperation_Shape_0=Module["_emscripten_bind_BRepFilletAPI_LocalOperation_Shape_0"]=Module["asm"]["bl"]).apply(null,arguments)};var _emscripten_bind_BRepFilletAPI_LocalOperation___destroy___0=Module["_emscripten_bind_BRepFilletAPI_LocalOperation___destroy___0"]=function(){return(_emscripten_bind_BRepFilletAPI_LocalOperation___destroy___0=Module["_emscripten_bind_BRepFilletAPI_LocalOperation___destroy___0"]=Module["asm"]["cl"]).apply(null,arguments)};var _emscripten_bind_Geom_ElementarySurface_Location_0=Module["_emscripten_bind_Geom_ElementarySurface_Location_0"]=function(){return(_emscripten_bind_Geom_ElementarySurface_Location_0=Module["_emscripten_bind_Geom_ElementarySurface_Location_0"]=Module["asm"]["dl"]).apply(null,arguments)};var _emscripten_bind_Geom_ElementarySurface_get_type_name_0=Module["_emscripten_bind_Geom_ElementarySurface_get_type_name_0"]=function(){return(_emscripten_bind_Geom_ElementarySurface_get_type_name_0=Module["_emscripten_bind_Geom_ElementarySurface_get_type_name_0"]=Module["asm"]["el"]).apply(null,arguments)};var _emscripten_bind_Geom_ElementarySurface_DynamicType_0=Module["_emscripten_bind_Geom_ElementarySurface_DynamicType_0"]=function(){return(_emscripten_bind_Geom_ElementarySurface_DynamicType_0=Module["_emscripten_bind_Geom_ElementarySurface_DynamicType_0"]=Module["asm"]["fl"]).apply(null,arguments)};var _emscripten_bind_Geom_ElementarySurface___destroy___0=Module["_emscripten_bind_Geom_ElementarySurface___destroy___0"]=function(){return(_emscripten_bind_Geom_ElementarySurface___destroy___0=Module["_emscripten_bind_Geom_ElementarySurface___destroy___0"]=Module["asm"]["gl"]).apply(null,arguments)};var _emscripten_bind_Geom2d_BoundedCurve_Period_0=Module["_emscripten_bind_Geom2d_BoundedCurve_Period_0"]=function(){return(_emscripten_bind_Geom2d_BoundedCurve_Period_0=Module["_emscripten_bind_Geom2d_BoundedCurve_Period_0"]=Module["asm"]["hl"]).apply(null,arguments)};var _emscripten_bind_Geom2d_BoundedCurve_Value_1=Module["_emscripten_bind_Geom2d_BoundedCurve_Value_1"]=function(){return(_emscripten_bind_Geom2d_BoundedCurve_Value_1=Module["_emscripten_bind_Geom2d_BoundedCurve_Value_1"]=Module["asm"]["il"]).apply(null,arguments)};var _emscripten_bind_Geom2d_BoundedCurve___destroy___0=Module["_emscripten_bind_Geom2d_BoundedCurve___destroy___0"]=function(){return(_emscripten_bind_Geom2d_BoundedCurve___destroy___0=Module["_emscripten_bind_Geom2d_BoundedCurve___destroy___0"]=Module["asm"]["jl"]).apply(null,arguments)};var _emscripten_bind_XSControl_Reader_XSControl_Reader_0=Module["_emscripten_bind_XSControl_Reader_XSControl_Reader_0"]=function(){return(_emscripten_bind_XSControl_Reader_XSControl_Reader_0=Module["_emscripten_bind_XSControl_Reader_XSControl_Reader_0"]=Module["asm"]["kl"]).apply(null,arguments)};var _emscripten_bind_XSControl_Reader_XSControl_Reader_1=Module["_emscripten_bind_XSControl_Reader_XSControl_Reader_1"]=function(){return(_emscripten_bind_XSControl_Reader_XSControl_Reader_1=Module["_emscripten_bind_XSControl_Reader_XSControl_Reader_1"]=Module["asm"]["ll"]).apply(null,arguments)};var _emscripten_bind_XSControl_Reader_XSControl_Reader_2=Module["_emscripten_bind_XSControl_Reader_XSControl_Reader_2"]=function(){return(_emscripten_bind_XSControl_Reader_XSControl_Reader_2=Module["_emscripten_bind_XSControl_Reader_XSControl_Reader_2"]=Module["asm"]["ml"]).apply(null,arguments)};var _emscripten_bind_XSControl_Reader_SetNorm_1=Module["_emscripten_bind_XSControl_Reader_SetNorm_1"]=function(){return(_emscripten_bind_XSControl_Reader_SetNorm_1=Module["_emscripten_bind_XSControl_Reader_SetNorm_1"]=Module["asm"]["nl"]).apply(null,arguments)};var _emscripten_bind_XSControl_Reader_SetWS_1=Module["_emscripten_bind_XSControl_Reader_SetWS_1"]=function(){return(_emscripten_bind_XSControl_Reader_SetWS_1=Module["_emscripten_bind_XSControl_Reader_SetWS_1"]=Module["asm"]["ol"]).apply(null,arguments)};var _emscripten_bind_XSControl_Reader_SetWS_2=Module["_emscripten_bind_XSControl_Reader_SetWS_2"]=function(){return(_emscripten_bind_XSControl_Reader_SetWS_2=Module["_emscripten_bind_XSControl_Reader_SetWS_2"]=Module["asm"]["pl"]).apply(null,arguments)};var _emscripten_bind_XSControl_Reader_WS_0=Module["_emscripten_bind_XSControl_Reader_WS_0"]=function(){return(_emscripten_bind_XSControl_Reader_WS_0=Module["_emscripten_bind_XSControl_Reader_WS_0"]=Module["asm"]["ql"]).apply(null,arguments)};var _emscripten_bind_XSControl_Reader_ReadFile_1=Module["_emscripten_bind_XSControl_Reader_ReadFile_1"]=function(){return(_emscripten_bind_XSControl_Reader_ReadFile_1=Module["_emscripten_bind_XSControl_Reader_ReadFile_1"]=Module["asm"]["rl"]).apply(null,arguments)};var _emscripten_bind_XSControl_Reader_NbRootsForTransfer_0=Module["_emscripten_bind_XSControl_Reader_NbRootsForTransfer_0"]=function(){return(_emscripten_bind_XSControl_Reader_NbRootsForTransfer_0=Module["_emscripten_bind_XSControl_Reader_NbRootsForTransfer_0"]=Module["asm"]["sl"]).apply(null,arguments)};var _emscripten_bind_XSControl_Reader_TransferOneRoot_0=Module["_emscripten_bind_XSControl_Reader_TransferOneRoot_0"]=function(){return(_emscripten_bind_XSControl_Reader_TransferOneRoot_0=Module["_emscripten_bind_XSControl_Reader_TransferOneRoot_0"]=Module["asm"]["tl"]).apply(null,arguments)};var _emscripten_bind_XSControl_Reader_TransferOneRoot_1=Module["_emscripten_bind_XSControl_Reader_TransferOneRoot_1"]=function(){return(_emscripten_bind_XSControl_Reader_TransferOneRoot_1=Module["_emscripten_bind_XSControl_Reader_TransferOneRoot_1"]=Module["asm"]["ul"]).apply(null,arguments)};var _emscripten_bind_XSControl_Reader_TransferOne_1=Module["_emscripten_bind_XSControl_Reader_TransferOne_1"]=function(){return(_emscripten_bind_XSControl_Reader_TransferOne_1=Module["_emscripten_bind_XSControl_Reader_TransferOne_1"]=Module["asm"]["vl"]).apply(null,arguments)};var _emscripten_bind_XSControl_Reader_TransferRoots_0=Module["_emscripten_bind_XSControl_Reader_TransferRoots_0"]=function(){return(_emscripten_bind_XSControl_Reader_TransferRoots_0=Module["_emscripten_bind_XSControl_Reader_TransferRoots_0"]=Module["asm"]["wl"]).apply(null,arguments)};var _emscripten_bind_XSControl_Reader_ClearShapes_0=Module["_emscripten_bind_XSControl_Reader_ClearShapes_0"]=function(){return(_emscripten_bind_XSControl_Reader_ClearShapes_0=Module["_emscripten_bind_XSControl_Reader_ClearShapes_0"]=Module["asm"]["xl"]).apply(null,arguments)};var _emscripten_bind_XSControl_Reader_NbShapes_0=Module["_emscripten_bind_XSControl_Reader_NbShapes_0"]=function(){return(_emscripten_bind_XSControl_Reader_NbShapes_0=Module["_emscripten_bind_XSControl_Reader_NbShapes_0"]=Module["asm"]["yl"]).apply(null,arguments)};var _emscripten_bind_XSControl_Reader_Shape_0=Module["_emscripten_bind_XSControl_Reader_Shape_0"]=function(){return(_emscripten_bind_XSControl_Reader_Shape_0=Module["_emscripten_bind_XSControl_Reader_Shape_0"]=Module["asm"]["zl"]).apply(null,arguments)};var _emscripten_bind_XSControl_Reader_Shape_1=Module["_emscripten_bind_XSControl_Reader_Shape_1"]=function(){return(_emscripten_bind_XSControl_Reader_Shape_1=Module["_emscripten_bind_XSControl_Reader_Shape_1"]=Module["asm"]["Al"]).apply(null,arguments)};var _emscripten_bind_XSControl_Reader_OneShape_0=Module["_emscripten_bind_XSControl_Reader_OneShape_0"]=function(){return(_emscripten_bind_XSControl_Reader_OneShape_0=Module["_emscripten_bind_XSControl_Reader_OneShape_0"]=Module["asm"]["Bl"]).apply(null,arguments)};var _emscripten_bind_XSControl_Reader_PrintStatsTransfer_1=Module["_emscripten_bind_XSControl_Reader_PrintStatsTransfer_1"]=function(){return(_emscripten_bind_XSControl_Reader_PrintStatsTransfer_1=Module["_emscripten_bind_XSControl_Reader_PrintStatsTransfer_1"]=Module["asm"]["Cl"]).apply(null,arguments)};var _emscripten_bind_XSControl_Reader_PrintStatsTransfer_2=Module["_emscripten_bind_XSControl_Reader_PrintStatsTransfer_2"]=function(){return(_emscripten_bind_XSControl_Reader_PrintStatsTransfer_2=Module["_emscripten_bind_XSControl_Reader_PrintStatsTransfer_2"]=Module["asm"]["Dl"]).apply(null,arguments)};var _emscripten_bind_XSControl_Reader___destroy___0=Module["_emscripten_bind_XSControl_Reader___destroy___0"]=function(){return(_emscripten_bind_XSControl_Reader___destroy___0=Module["_emscripten_bind_XSControl_Reader___destroy___0"]=Module["asm"]["El"]).apply(null,arguments)};var _emscripten_bind_BRepAlgoAPI_BooleanOperation_Shape_0=Module["_emscripten_bind_BRepAlgoAPI_BooleanOperation_Shape_0"]=function(){return(_emscripten_bind_BRepAlgoAPI_BooleanOperation_Shape_0=Module["_emscripten_bind_BRepAlgoAPI_BooleanOperation_Shape_0"]=Module["asm"]["Fl"]).apply(null,arguments)};var _emscripten_bind_BRepAlgoAPI_BooleanOperation___destroy___0=Module["_emscripten_bind_BRepAlgoAPI_BooleanOperation___destroy___0"]=function(){return(_emscripten_bind_BRepAlgoAPI_BooleanOperation___destroy___0=Module["_emscripten_bind_BRepAlgoAPI_BooleanOperation___destroy___0"]=Module["asm"]["Gl"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeOneAxis_Build_0=Module["_emscripten_bind_BRepPrimAPI_MakeOneAxis_Build_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeOneAxis_Build_0=Module["_emscripten_bind_BRepPrimAPI_MakeOneAxis_Build_0"]=Module["asm"]["Hl"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeOneAxis_Face_0=Module["_emscripten_bind_BRepPrimAPI_MakeOneAxis_Face_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeOneAxis_Face_0=Module["_emscripten_bind_BRepPrimAPI_MakeOneAxis_Face_0"]=Module["asm"]["Il"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeOneAxis_Shell_0=Module["_emscripten_bind_BRepPrimAPI_MakeOneAxis_Shell_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeOneAxis_Shell_0=Module["_emscripten_bind_BRepPrimAPI_MakeOneAxis_Shell_0"]=Module["asm"]["Jl"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeOneAxis_Solid_0=Module["_emscripten_bind_BRepPrimAPI_MakeOneAxis_Solid_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeOneAxis_Solid_0=Module["_emscripten_bind_BRepPrimAPI_MakeOneAxis_Solid_0"]=Module["asm"]["Kl"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeOneAxis_Shape_0=Module["_emscripten_bind_BRepPrimAPI_MakeOneAxis_Shape_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeOneAxis_Shape_0=Module["_emscripten_bind_BRepPrimAPI_MakeOneAxis_Shape_0"]=Module["asm"]["Ll"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeOneAxis_IsDeleted_1=Module["_emscripten_bind_BRepPrimAPI_MakeOneAxis_IsDeleted_1"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeOneAxis_IsDeleted_1=Module["_emscripten_bind_BRepPrimAPI_MakeOneAxis_IsDeleted_1"]=Module["asm"]["Ml"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeOneAxis___destroy___0=Module["_emscripten_bind_BRepPrimAPI_MakeOneAxis___destroy___0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeOneAxis___destroy___0=Module["_emscripten_bind_BRepPrimAPI_MakeOneAxis___destroy___0"]=Module["asm"]["Nl"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_ModifyShape_Shape_0=Module["_emscripten_bind_BRepBuilderAPI_ModifyShape_Shape_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_ModifyShape_Shape_0=Module["_emscripten_bind_BRepBuilderAPI_ModifyShape_Shape_0"]=Module["asm"]["Ol"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_ModifyShape___destroy___0=Module["_emscripten_bind_BRepBuilderAPI_ModifyShape___destroy___0"]=function(){return(_emscripten_bind_BRepBuilderAPI_ModifyShape___destroy___0=Module["_emscripten_bind_BRepBuilderAPI_ModifyShape___destroy___0"]=Module["asm"]["Pl"]).apply(null,arguments)};var _emscripten_bind_Geom_Conic_Reverse_0=Module["_emscripten_bind_Geom_Conic_Reverse_0"]=function(){return(_emscripten_bind_Geom_Conic_Reverse_0=Module["_emscripten_bind_Geom_Conic_Reverse_0"]=Module["asm"]["Ql"]).apply(null,arguments)};var _emscripten_bind_Geom_Conic_ReversedParameter_1=Module["_emscripten_bind_Geom_Conic_ReversedParameter_1"]=function(){return(_emscripten_bind_Geom_Conic_ReversedParameter_1=Module["_emscripten_bind_Geom_Conic_ReversedParameter_1"]=Module["asm"]["Rl"]).apply(null,arguments)};var _emscripten_bind_Geom_Conic_TransformedParameter_2=Module["_emscripten_bind_Geom_Conic_TransformedParameter_2"]=function(){return(_emscripten_bind_Geom_Conic_TransformedParameter_2=Module["_emscripten_bind_Geom_Conic_TransformedParameter_2"]=Module["asm"]["Sl"]).apply(null,arguments)};var _emscripten_bind_Geom_Conic_ParametricTransformation_1=Module["_emscripten_bind_Geom_Conic_ParametricTransformation_1"]=function(){return(_emscripten_bind_Geom_Conic_ParametricTransformation_1=Module["_emscripten_bind_Geom_Conic_ParametricTransformation_1"]=Module["asm"]["Tl"]).apply(null,arguments)};var _emscripten_bind_Geom_Conic_Reversed_0=Module["_emscripten_bind_Geom_Conic_Reversed_0"]=function(){return(_emscripten_bind_Geom_Conic_Reversed_0=Module["_emscripten_bind_Geom_Conic_Reversed_0"]=Module["asm"]["Ul"]).apply(null,arguments)};var _emscripten_bind_Geom_Conic_FirstParameter_0=Module["_emscripten_bind_Geom_Conic_FirstParameter_0"]=function(){return(_emscripten_bind_Geom_Conic_FirstParameter_0=Module["_emscripten_bind_Geom_Conic_FirstParameter_0"]=Module["asm"]["Vl"]).apply(null,arguments)};var _emscripten_bind_Geom_Conic_LastParameter_0=Module["_emscripten_bind_Geom_Conic_LastParameter_0"]=function(){return(_emscripten_bind_Geom_Conic_LastParameter_0=Module["_emscripten_bind_Geom_Conic_LastParameter_0"]=Module["asm"]["Wl"]).apply(null,arguments)};var _emscripten_bind_Geom_Conic_IsClosed_0=Module["_emscripten_bind_Geom_Conic_IsClosed_0"]=function(){return(_emscripten_bind_Geom_Conic_IsClosed_0=Module["_emscripten_bind_Geom_Conic_IsClosed_0"]=Module["asm"]["Xl"]).apply(null,arguments)};var _emscripten_bind_Geom_Conic_IsPeriodic_0=Module["_emscripten_bind_Geom_Conic_IsPeriodic_0"]=function(){return(_emscripten_bind_Geom_Conic_IsPeriodic_0=Module["_emscripten_bind_Geom_Conic_IsPeriodic_0"]=Module["asm"]["Yl"]).apply(null,arguments)};var _emscripten_bind_Geom_Conic_Period_0=Module["_emscripten_bind_Geom_Conic_Period_0"]=function(){return(_emscripten_bind_Geom_Conic_Period_0=Module["_emscripten_bind_Geom_Conic_Period_0"]=Module["asm"]["Zl"]).apply(null,arguments)};var _emscripten_bind_Geom_Conic_IsCN_1=Module["_emscripten_bind_Geom_Conic_IsCN_1"]=function(){return(_emscripten_bind_Geom_Conic_IsCN_1=Module["_emscripten_bind_Geom_Conic_IsCN_1"]=Module["asm"]["_l"]).apply(null,arguments)};var _emscripten_bind_Geom_Conic_D0_2=Module["_emscripten_bind_Geom_Conic_D0_2"]=function(){return(_emscripten_bind_Geom_Conic_D0_2=Module["_emscripten_bind_Geom_Conic_D0_2"]=Module["asm"]["$l"]).apply(null,arguments)};var _emscripten_bind_Geom_Conic_D1_3=Module["_emscripten_bind_Geom_Conic_D1_3"]=function(){return(_emscripten_bind_Geom_Conic_D1_3=Module["_emscripten_bind_Geom_Conic_D1_3"]=Module["asm"]["am"]).apply(null,arguments)};var _emscripten_bind_Geom_Conic_D2_4=Module["_emscripten_bind_Geom_Conic_D2_4"]=function(){return(_emscripten_bind_Geom_Conic_D2_4=Module["_emscripten_bind_Geom_Conic_D2_4"]=Module["asm"]["bm"]).apply(null,arguments)};var _emscripten_bind_Geom_Conic_D3_5=Module["_emscripten_bind_Geom_Conic_D3_5"]=function(){return(_emscripten_bind_Geom_Conic_D3_5=Module["_emscripten_bind_Geom_Conic_D3_5"]=Module["asm"]["cm"]).apply(null,arguments)};var _emscripten_bind_Geom_Conic_DN_2=Module["_emscripten_bind_Geom_Conic_DN_2"]=function(){return(_emscripten_bind_Geom_Conic_DN_2=Module["_emscripten_bind_Geom_Conic_DN_2"]=Module["asm"]["dm"]).apply(null,arguments)};var _emscripten_bind_Geom_Conic_Value_1=Module["_emscripten_bind_Geom_Conic_Value_1"]=function(){return(_emscripten_bind_Geom_Conic_Value_1=Module["_emscripten_bind_Geom_Conic_Value_1"]=Module["asm"]["em"]).apply(null,arguments)};var _emscripten_bind_Geom_Conic___destroy___0=Module["_emscripten_bind_Geom_Conic___destroy___0"]=function(){return(_emscripten_bind_Geom_Conic___destroy___0=Module["_emscripten_bind_Geom_Conic___destroy___0"]=Module["asm"]["fm"]).apply(null,arguments)};var _emscripten_bind_Adaptor3d_Curve_FirstParameter_0=Module["_emscripten_bind_Adaptor3d_Curve_FirstParameter_0"]=function(){return(_emscripten_bind_Adaptor3d_Curve_FirstParameter_0=Module["_emscripten_bind_Adaptor3d_Curve_FirstParameter_0"]=Module["asm"]["gm"]).apply(null,arguments)};var _emscripten_bind_Adaptor3d_Curve_LastParameter_0=Module["_emscripten_bind_Adaptor3d_Curve_LastParameter_0"]=function(){return(_emscripten_bind_Adaptor3d_Curve_LastParameter_0=Module["_emscripten_bind_Adaptor3d_Curve_LastParameter_0"]=Module["asm"]["hm"]).apply(null,arguments)};var _emscripten_bind_Adaptor3d_Curve_IsClosed_0=Module["_emscripten_bind_Adaptor3d_Curve_IsClosed_0"]=function(){return(_emscripten_bind_Adaptor3d_Curve_IsClosed_0=Module["_emscripten_bind_Adaptor3d_Curve_IsClosed_0"]=Module["asm"]["im"]).apply(null,arguments)};var _emscripten_bind_Adaptor3d_Curve_IsPeriodic_0=Module["_emscripten_bind_Adaptor3d_Curve_IsPeriodic_0"]=function(){return(_emscripten_bind_Adaptor3d_Curve_IsPeriodic_0=Module["_emscripten_bind_Adaptor3d_Curve_IsPeriodic_0"]=Module["asm"]["jm"]).apply(null,arguments)};var _emscripten_bind_Adaptor3d_Curve_Period_0=Module["_emscripten_bind_Adaptor3d_Curve_Period_0"]=function(){return(_emscripten_bind_Adaptor3d_Curve_Period_0=Module["_emscripten_bind_Adaptor3d_Curve_Period_0"]=Module["asm"]["km"]).apply(null,arguments)};var _emscripten_bind_Adaptor3d_Curve_Value_1=Module["_emscripten_bind_Adaptor3d_Curve_Value_1"]=function(){return(_emscripten_bind_Adaptor3d_Curve_Value_1=Module["_emscripten_bind_Adaptor3d_Curve_Value_1"]=Module["asm"]["lm"]).apply(null,arguments)};var _emscripten_bind_Adaptor3d_Curve_D0_2=Module["_emscripten_bind_Adaptor3d_Curve_D0_2"]=function(){return(_emscripten_bind_Adaptor3d_Curve_D0_2=Module["_emscripten_bind_Adaptor3d_Curve_D0_2"]=Module["asm"]["mm"]).apply(null,arguments)};var _emscripten_bind_Adaptor3d_Curve_D1_3=Module["_emscripten_bind_Adaptor3d_Curve_D1_3"]=function(){return(_emscripten_bind_Adaptor3d_Curve_D1_3=Module["_emscripten_bind_Adaptor3d_Curve_D1_3"]=Module["asm"]["nm"]).apply(null,arguments)};var _emscripten_bind_Adaptor3d_Curve_D2_4=Module["_emscripten_bind_Adaptor3d_Curve_D2_4"]=function(){return(_emscripten_bind_Adaptor3d_Curve_D2_4=Module["_emscripten_bind_Adaptor3d_Curve_D2_4"]=Module["asm"]["om"]).apply(null,arguments)};var _emscripten_bind_Adaptor3d_Curve_D3_5=Module["_emscripten_bind_Adaptor3d_Curve_D3_5"]=function(){return(_emscripten_bind_Adaptor3d_Curve_D3_5=Module["_emscripten_bind_Adaptor3d_Curve_D3_5"]=Module["asm"]["pm"]).apply(null,arguments)};var _emscripten_bind_Adaptor3d_Curve_DN_2=Module["_emscripten_bind_Adaptor3d_Curve_DN_2"]=function(){return(_emscripten_bind_Adaptor3d_Curve_DN_2=Module["_emscripten_bind_Adaptor3d_Curve_DN_2"]=Module["asm"]["qm"]).apply(null,arguments)};var _emscripten_bind_Adaptor3d_Curve_Resolution_1=Module["_emscripten_bind_Adaptor3d_Curve_Resolution_1"]=function(){return(_emscripten_bind_Adaptor3d_Curve_Resolution_1=Module["_emscripten_bind_Adaptor3d_Curve_Resolution_1"]=Module["asm"]["rm"]).apply(null,arguments)};var _emscripten_bind_Adaptor3d_Curve_Line_0=Module["_emscripten_bind_Adaptor3d_Curve_Line_0"]=function(){return(_emscripten_bind_Adaptor3d_Curve_Line_0=Module["_emscripten_bind_Adaptor3d_Curve_Line_0"]=Module["asm"]["sm"]).apply(null,arguments)};var _emscripten_bind_Adaptor3d_Curve_Circle_0=Module["_emscripten_bind_Adaptor3d_Curve_Circle_0"]=function(){return(_emscripten_bind_Adaptor3d_Curve_Circle_0=Module["_emscripten_bind_Adaptor3d_Curve_Circle_0"]=Module["asm"]["tm"]).apply(null,arguments)};var _emscripten_bind_Adaptor3d_Curve_Degree_0=Module["_emscripten_bind_Adaptor3d_Curve_Degree_0"]=function(){return(_emscripten_bind_Adaptor3d_Curve_Degree_0=Module["_emscripten_bind_Adaptor3d_Curve_Degree_0"]=Module["asm"]["um"]).apply(null,arguments)};var _emscripten_bind_Adaptor3d_Curve_IsRational_0=Module["_emscripten_bind_Adaptor3d_Curve_IsRational_0"]=function(){return(_emscripten_bind_Adaptor3d_Curve_IsRational_0=Module["_emscripten_bind_Adaptor3d_Curve_IsRational_0"]=Module["asm"]["vm"]).apply(null,arguments)};var _emscripten_bind_Adaptor3d_Curve_NbPoles_0=Module["_emscripten_bind_Adaptor3d_Curve_NbPoles_0"]=function(){return(_emscripten_bind_Adaptor3d_Curve_NbPoles_0=Module["_emscripten_bind_Adaptor3d_Curve_NbPoles_0"]=Module["asm"]["wm"]).apply(null,arguments)};var _emscripten_bind_Adaptor3d_Curve_NbKnots_0=Module["_emscripten_bind_Adaptor3d_Curve_NbKnots_0"]=function(){return(_emscripten_bind_Adaptor3d_Curve_NbKnots_0=Module["_emscripten_bind_Adaptor3d_Curve_NbKnots_0"]=Module["asm"]["xm"]).apply(null,arguments)};var _emscripten_bind_Adaptor3d_Curve_Bezier_0=Module["_emscripten_bind_Adaptor3d_Curve_Bezier_0"]=function(){return(_emscripten_bind_Adaptor3d_Curve_Bezier_0=Module["_emscripten_bind_Adaptor3d_Curve_Bezier_0"]=Module["asm"]["ym"]).apply(null,arguments)};var _emscripten_bind_Adaptor3d_Curve_BSpline_0=Module["_emscripten_bind_Adaptor3d_Curve_BSpline_0"]=function(){return(_emscripten_bind_Adaptor3d_Curve_BSpline_0=Module["_emscripten_bind_Adaptor3d_Curve_BSpline_0"]=Module["asm"]["zm"]).apply(null,arguments)};var _emscripten_bind_Adaptor3d_Curve___destroy___0=Module["_emscripten_bind_Adaptor3d_Curve___destroy___0"]=function(){return(_emscripten_bind_Adaptor3d_Curve___destroy___0=Module["_emscripten_bind_Adaptor3d_Curve___destroy___0"]=Module["asm"]["Am"]).apply(null,arguments)};var _emscripten_bind_Geom_BoundedCurve_Reverse_0=Module["_emscripten_bind_Geom_BoundedCurve_Reverse_0"]=function(){return(_emscripten_bind_Geom_BoundedCurve_Reverse_0=Module["_emscripten_bind_Geom_BoundedCurve_Reverse_0"]=Module["asm"]["Bm"]).apply(null,arguments)};var _emscripten_bind_Geom_BoundedCurve_ReversedParameter_1=Module["_emscripten_bind_Geom_BoundedCurve_ReversedParameter_1"]=function(){return(_emscripten_bind_Geom_BoundedCurve_ReversedParameter_1=Module["_emscripten_bind_Geom_BoundedCurve_ReversedParameter_1"]=Module["asm"]["Cm"]).apply(null,arguments)};var _emscripten_bind_Geom_BoundedCurve_TransformedParameter_2=Module["_emscripten_bind_Geom_BoundedCurve_TransformedParameter_2"]=function(){return(_emscripten_bind_Geom_BoundedCurve_TransformedParameter_2=Module["_emscripten_bind_Geom_BoundedCurve_TransformedParameter_2"]=Module["asm"]["Dm"]).apply(null,arguments)};var _emscripten_bind_Geom_BoundedCurve_ParametricTransformation_1=Module["_emscripten_bind_Geom_BoundedCurve_ParametricTransformation_1"]=function(){return(_emscripten_bind_Geom_BoundedCurve_ParametricTransformation_1=Module["_emscripten_bind_Geom_BoundedCurve_ParametricTransformation_1"]=Module["asm"]["Em"]).apply(null,arguments)};var _emscripten_bind_Geom_BoundedCurve_Reversed_0=Module["_emscripten_bind_Geom_BoundedCurve_Reversed_0"]=function(){return(_emscripten_bind_Geom_BoundedCurve_Reversed_0=Module["_emscripten_bind_Geom_BoundedCurve_Reversed_0"]=Module["asm"]["Fm"]).apply(null,arguments)};var _emscripten_bind_Geom_BoundedCurve_FirstParameter_0=Module["_emscripten_bind_Geom_BoundedCurve_FirstParameter_0"]=function(){return(_emscripten_bind_Geom_BoundedCurve_FirstParameter_0=Module["_emscripten_bind_Geom_BoundedCurve_FirstParameter_0"]=Module["asm"]["Gm"]).apply(null,arguments)};var _emscripten_bind_Geom_BoundedCurve_LastParameter_0=Module["_emscripten_bind_Geom_BoundedCurve_LastParameter_0"]=function(){return(_emscripten_bind_Geom_BoundedCurve_LastParameter_0=Module["_emscripten_bind_Geom_BoundedCurve_LastParameter_0"]=Module["asm"]["Hm"]).apply(null,arguments)};var _emscripten_bind_Geom_BoundedCurve_IsClosed_0=Module["_emscripten_bind_Geom_BoundedCurve_IsClosed_0"]=function(){return(_emscripten_bind_Geom_BoundedCurve_IsClosed_0=Module["_emscripten_bind_Geom_BoundedCurve_IsClosed_0"]=Module["asm"]["Im"]).apply(null,arguments)};var _emscripten_bind_Geom_BoundedCurve_IsPeriodic_0=Module["_emscripten_bind_Geom_BoundedCurve_IsPeriodic_0"]=function(){return(_emscripten_bind_Geom_BoundedCurve_IsPeriodic_0=Module["_emscripten_bind_Geom_BoundedCurve_IsPeriodic_0"]=Module["asm"]["Jm"]).apply(null,arguments)};var _emscripten_bind_Geom_BoundedCurve_Period_0=Module["_emscripten_bind_Geom_BoundedCurve_Period_0"]=function(){return(_emscripten_bind_Geom_BoundedCurve_Period_0=Module["_emscripten_bind_Geom_BoundedCurve_Period_0"]=Module["asm"]["Km"]).apply(null,arguments)};var _emscripten_bind_Geom_BoundedCurve_IsCN_1=Module["_emscripten_bind_Geom_BoundedCurve_IsCN_1"]=function(){return(_emscripten_bind_Geom_BoundedCurve_IsCN_1=Module["_emscripten_bind_Geom_BoundedCurve_IsCN_1"]=Module["asm"]["Lm"]).apply(null,arguments)};var _emscripten_bind_Geom_BoundedCurve_D0_2=Module["_emscripten_bind_Geom_BoundedCurve_D0_2"]=function(){return(_emscripten_bind_Geom_BoundedCurve_D0_2=Module["_emscripten_bind_Geom_BoundedCurve_D0_2"]=Module["asm"]["Mm"]).apply(null,arguments)};var _emscripten_bind_Geom_BoundedCurve_D1_3=Module["_emscripten_bind_Geom_BoundedCurve_D1_3"]=function(){return(_emscripten_bind_Geom_BoundedCurve_D1_3=Module["_emscripten_bind_Geom_BoundedCurve_D1_3"]=Module["asm"]["Nm"]).apply(null,arguments)};var _emscripten_bind_Geom_BoundedCurve_D2_4=Module["_emscripten_bind_Geom_BoundedCurve_D2_4"]=function(){return(_emscripten_bind_Geom_BoundedCurve_D2_4=Module["_emscripten_bind_Geom_BoundedCurve_D2_4"]=Module["asm"]["Om"]).apply(null,arguments)};var _emscripten_bind_Geom_BoundedCurve_D3_5=Module["_emscripten_bind_Geom_BoundedCurve_D3_5"]=function(){return(_emscripten_bind_Geom_BoundedCurve_D3_5=Module["_emscripten_bind_Geom_BoundedCurve_D3_5"]=Module["asm"]["Pm"]).apply(null,arguments)};var _emscripten_bind_Geom_BoundedCurve_DN_2=Module["_emscripten_bind_Geom_BoundedCurve_DN_2"]=function(){return(_emscripten_bind_Geom_BoundedCurve_DN_2=Module["_emscripten_bind_Geom_BoundedCurve_DN_2"]=Module["asm"]["Qm"]).apply(null,arguments)};var _emscripten_bind_Geom_BoundedCurve_Value_1=Module["_emscripten_bind_Geom_BoundedCurve_Value_1"]=function(){return(_emscripten_bind_Geom_BoundedCurve_Value_1=Module["_emscripten_bind_Geom_BoundedCurve_Value_1"]=Module["asm"]["Rm"]).apply(null,arguments)};var _emscripten_bind_Geom_BoundedCurve___destroy___0=Module["_emscripten_bind_Geom_BoundedCurve___destroy___0"]=function(){return(_emscripten_bind_Geom_BoundedCurve___destroy___0=Module["_emscripten_bind_Geom_BoundedCurve___destroy___0"]=Module["asm"]["Sm"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeSweep_FirstShape_0=Module["_emscripten_bind_BRepPrimAPI_MakeSweep_FirstShape_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeSweep_FirstShape_0=Module["_emscripten_bind_BRepPrimAPI_MakeSweep_FirstShape_0"]=Module["asm"]["Tm"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeSweep_LastShape_0=Module["_emscripten_bind_BRepPrimAPI_MakeSweep_LastShape_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeSweep_LastShape_0=Module["_emscripten_bind_BRepPrimAPI_MakeSweep_LastShape_0"]=Module["asm"]["Um"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeSweep_Shape_0=Module["_emscripten_bind_BRepPrimAPI_MakeSweep_Shape_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeSweep_Shape_0=Module["_emscripten_bind_BRepPrimAPI_MakeSweep_Shape_0"]=Module["asm"]["Vm"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeSweep_IsDeleted_1=Module["_emscripten_bind_BRepPrimAPI_MakeSweep_IsDeleted_1"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeSweep_IsDeleted_1=Module["_emscripten_bind_BRepPrimAPI_MakeSweep_IsDeleted_1"]=Module["asm"]["Wm"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeSweep___destroy___0=Module["_emscripten_bind_BRepPrimAPI_MakeSweep___destroy___0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeSweep___destroy___0=Module["_emscripten_bind_BRepPrimAPI_MakeSweep___destroy___0"]=Module["asm"]["Xm"]).apply(null,arguments)};var _emscripten_bind_gp_OX_0=Module["_emscripten_bind_gp_OX_0"]=function(){return(_emscripten_bind_gp_OX_0=Module["_emscripten_bind_gp_OX_0"]=Module["asm"]["Ym"]).apply(null,arguments)};var _emscripten_bind_gp_DZ_0=Module["_emscripten_bind_gp_DZ_0"]=function(){return(_emscripten_bind_gp_DZ_0=Module["_emscripten_bind_gp_DZ_0"]=Module["asm"]["Zm"]).apply(null,arguments)};var _emscripten_bind_gp___destroy___0=Module["_emscripten_bind_gp___destroy___0"]=function(){return(_emscripten_bind_gp___destroy___0=Module["_emscripten_bind_gp___destroy___0"]=Module["asm"]["_m"]).apply(null,arguments)};var _emscripten_bind_Poly_Triangulation_Poly_Triangulation_1=Module["_emscripten_bind_Poly_Triangulation_Poly_Triangulation_1"]=function(){return(_emscripten_bind_Poly_Triangulation_Poly_Triangulation_1=Module["_emscripten_bind_Poly_Triangulation_Poly_Triangulation_1"]=Module["asm"]["$m"]).apply(null,arguments)};var _emscripten_bind_Poly_Triangulation_Poly_Triangulation_3=Module["_emscripten_bind_Poly_Triangulation_Poly_Triangulation_3"]=function(){return(_emscripten_bind_Poly_Triangulation_Poly_Triangulation_3=Module["_emscripten_bind_Poly_Triangulation_Poly_Triangulation_3"]=Module["asm"]["an"]).apply(null,arguments)};var _emscripten_bind_Poly_Triangulation_Copy_0=Module["_emscripten_bind_Poly_Triangulation_Copy_0"]=function(){return(_emscripten_bind_Poly_Triangulation_Copy_0=Module["_emscripten_bind_Poly_Triangulation_Copy_0"]=Module["asm"]["bn"]).apply(null,arguments)};var _emscripten_bind_Poly_Triangulation_Deflection_1=Module["_emscripten_bind_Poly_Triangulation_Deflection_1"]=function(){return(_emscripten_bind_Poly_Triangulation_Deflection_1=Module["_emscripten_bind_Poly_Triangulation_Deflection_1"]=Module["asm"]["cn"]).apply(null,arguments)};var _emscripten_bind_Poly_Triangulation_RemoveUVNodes_0=Module["_emscripten_bind_Poly_Triangulation_RemoveUVNodes_0"]=function(){return(_emscripten_bind_Poly_Triangulation_RemoveUVNodes_0=Module["_emscripten_bind_Poly_Triangulation_RemoveUVNodes_0"]=Module["asm"]["dn"]).apply(null,arguments)};var _emscripten_bind_Poly_Triangulation_NbNodes_0=Module["_emscripten_bind_Poly_Triangulation_NbNodes_0"]=function(){return(_emscripten_bind_Poly_Triangulation_NbNodes_0=Module["_emscripten_bind_Poly_Triangulation_NbNodes_0"]=Module["asm"]["en"]).apply(null,arguments)};var _emscripten_bind_Poly_Triangulation_NbTriangles_0=Module["_emscripten_bind_Poly_Triangulation_NbTriangles_0"]=function(){return(_emscripten_bind_Poly_Triangulation_NbTriangles_0=Module["_emscripten_bind_Poly_Triangulation_NbTriangles_0"]=Module["asm"]["fn"]).apply(null,arguments)};var _emscripten_bind_Poly_Triangulation_HasUVNodes_0=Module["_emscripten_bind_Poly_Triangulation_HasUVNodes_0"]=function(){return(_emscripten_bind_Poly_Triangulation_HasUVNodes_0=Module["_emscripten_bind_Poly_Triangulation_HasUVNodes_0"]=Module["asm"]["gn"]).apply(null,arguments)};var _emscripten_bind_Poly_Triangulation_Nodes_0=Module["_emscripten_bind_Poly_Triangulation_Nodes_0"]=function(){return(_emscripten_bind_Poly_Triangulation_Nodes_0=Module["_emscripten_bind_Poly_Triangulation_Nodes_0"]=Module["asm"]["hn"]).apply(null,arguments)};var _emscripten_bind_Poly_Triangulation_ChangeNodes_0=Module["_emscripten_bind_Poly_Triangulation_ChangeNodes_0"]=function(){return(_emscripten_bind_Poly_Triangulation_ChangeNodes_0=Module["_emscripten_bind_Poly_Triangulation_ChangeNodes_0"]=Module["asm"]["jn"]).apply(null,arguments)};var _emscripten_bind_Poly_Triangulation_Triangles_0=Module["_emscripten_bind_Poly_Triangulation_Triangles_0"]=function(){return(_emscripten_bind_Poly_Triangulation_Triangles_0=Module["_emscripten_bind_Poly_Triangulation_Triangles_0"]=Module["asm"]["kn"]).apply(null,arguments)};var _emscripten_bind_Poly_Triangulation_ChangeTriangles_0=Module["_emscripten_bind_Poly_Triangulation_ChangeTriangles_0"]=function(){return(_emscripten_bind_Poly_Triangulation_ChangeTriangles_0=Module["_emscripten_bind_Poly_Triangulation_ChangeTriangles_0"]=Module["asm"]["ln"]).apply(null,arguments)};var _emscripten_bind_Poly_Triangulation_HasNormals_0=Module["_emscripten_bind_Poly_Triangulation_HasNormals_0"]=function(){return(_emscripten_bind_Poly_Triangulation_HasNormals_0=Module["_emscripten_bind_Poly_Triangulation_HasNormals_0"]=Module["asm"]["mn"]).apply(null,arguments)};var _emscripten_bind_Poly_Triangulation_Normal_1=Module["_emscripten_bind_Poly_Triangulation_Normal_1"]=function(){return(_emscripten_bind_Poly_Triangulation_Normal_1=Module["_emscripten_bind_Poly_Triangulation_Normal_1"]=Module["asm"]["nn"]).apply(null,arguments)};var _emscripten_bind_Poly_Triangulation_SetNormal_2=Module["_emscripten_bind_Poly_Triangulation_SetNormal_2"]=function(){return(_emscripten_bind_Poly_Triangulation_SetNormal_2=Module["_emscripten_bind_Poly_Triangulation_SetNormal_2"]=Module["asm"]["on"]).apply(null,arguments)};var _emscripten_bind_Poly_Triangulation___destroy___0=Module["_emscripten_bind_Poly_Triangulation___destroy___0"]=function(){return(_emscripten_bind_Poly_Triangulation___destroy___0=Module["_emscripten_bind_Poly_Triangulation___destroy___0"]=Module["asm"]["pn"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shape_ShapeFix_Shape_0=Module["_emscripten_bind_ShapeFix_Shape_ShapeFix_Shape_0"]=function(){return(_emscripten_bind_ShapeFix_Shape_ShapeFix_Shape_0=Module["_emscripten_bind_ShapeFix_Shape_ShapeFix_Shape_0"]=Module["asm"]["qn"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shape_ShapeFix_Shape_1=Module["_emscripten_bind_ShapeFix_Shape_ShapeFix_Shape_1"]=function(){return(_emscripten_bind_ShapeFix_Shape_ShapeFix_Shape_1=Module["_emscripten_bind_ShapeFix_Shape_ShapeFix_Shape_1"]=Module["asm"]["rn"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shape_Init_1=Module["_emscripten_bind_ShapeFix_Shape_Init_1"]=function(){return(_emscripten_bind_ShapeFix_Shape_Init_1=Module["_emscripten_bind_ShapeFix_Shape_Init_1"]=Module["asm"]["sn"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shape_Perform_0=Module["_emscripten_bind_ShapeFix_Shape_Perform_0"]=function(){return(_emscripten_bind_ShapeFix_Shape_Perform_0=Module["_emscripten_bind_ShapeFix_Shape_Perform_0"]=Module["asm"]["tn"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shape_Perform_1=Module["_emscripten_bind_ShapeFix_Shape_Perform_1"]=function(){return(_emscripten_bind_ShapeFix_Shape_Perform_1=Module["_emscripten_bind_ShapeFix_Shape_Perform_1"]=Module["asm"]["un"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shape_Shape_0=Module["_emscripten_bind_ShapeFix_Shape_Shape_0"]=function(){return(_emscripten_bind_ShapeFix_Shape_Shape_0=Module["_emscripten_bind_ShapeFix_Shape_Shape_0"]=Module["asm"]["vn"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shape_FixShellTool_0=Module["_emscripten_bind_ShapeFix_Shape_FixShellTool_0"]=function(){return(_emscripten_bind_ShapeFix_Shape_FixShellTool_0=Module["_emscripten_bind_ShapeFix_Shape_FixShellTool_0"]=Module["asm"]["wn"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shape_Status_1=Module["_emscripten_bind_ShapeFix_Shape_Status_1"]=function(){return(_emscripten_bind_ShapeFix_Shape_Status_1=Module["_emscripten_bind_ShapeFix_Shape_Status_1"]=Module["asm"]["xn"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shape_SetPrecision_1=Module["_emscripten_bind_ShapeFix_Shape_SetPrecision_1"]=function(){return(_emscripten_bind_ShapeFix_Shape_SetPrecision_1=Module["_emscripten_bind_ShapeFix_Shape_SetPrecision_1"]=Module["asm"]["yn"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shape_SetMinTolerance_1=Module["_emscripten_bind_ShapeFix_Shape_SetMinTolerance_1"]=function(){return(_emscripten_bind_ShapeFix_Shape_SetMinTolerance_1=Module["_emscripten_bind_ShapeFix_Shape_SetMinTolerance_1"]=Module["asm"]["zn"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shape_SetMaxTolerance_1=Module["_emscripten_bind_ShapeFix_Shape_SetMaxTolerance_1"]=function(){return(_emscripten_bind_ShapeFix_Shape_SetMaxTolerance_1=Module["_emscripten_bind_ShapeFix_Shape_SetMaxTolerance_1"]=Module["asm"]["An"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shape_FixSolidMode_0=Module["_emscripten_bind_ShapeFix_Shape_FixSolidMode_0"]=function(){return(_emscripten_bind_ShapeFix_Shape_FixSolidMode_0=Module["_emscripten_bind_ShapeFix_Shape_FixSolidMode_0"]=Module["asm"]["Bn"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shape_FixFreeShellMode_0=Module["_emscripten_bind_ShapeFix_Shape_FixFreeShellMode_0"]=function(){return(_emscripten_bind_ShapeFix_Shape_FixFreeShellMode_0=Module["_emscripten_bind_ShapeFix_Shape_FixFreeShellMode_0"]=Module["asm"]["Cn"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shape_FixFreeFaceMode_0=Module["_emscripten_bind_ShapeFix_Shape_FixFreeFaceMode_0"]=function(){return(_emscripten_bind_ShapeFix_Shape_FixFreeFaceMode_0=Module["_emscripten_bind_ShapeFix_Shape_FixFreeFaceMode_0"]=Module["asm"]["Dn"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shape_FixFreeWireMode_0=Module["_emscripten_bind_ShapeFix_Shape_FixFreeWireMode_0"]=function(){return(_emscripten_bind_ShapeFix_Shape_FixFreeWireMode_0=Module["_emscripten_bind_ShapeFix_Shape_FixFreeWireMode_0"]=Module["asm"]["En"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shape_FixSameParameterMode_0=Module["_emscripten_bind_ShapeFix_Shape_FixSameParameterMode_0"]=function(){return(_emscripten_bind_ShapeFix_Shape_FixSameParameterMode_0=Module["_emscripten_bind_ShapeFix_Shape_FixSameParameterMode_0"]=Module["asm"]["Fn"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shape_FixVertexPositionMode_0=Module["_emscripten_bind_ShapeFix_Shape_FixVertexPositionMode_0"]=function(){return(_emscripten_bind_ShapeFix_Shape_FixVertexPositionMode_0=Module["_emscripten_bind_ShapeFix_Shape_FixVertexPositionMode_0"]=Module["asm"]["Gn"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shape_FixVertexTolMode_0=Module["_emscripten_bind_ShapeFix_Shape_FixVertexTolMode_0"]=function(){return(_emscripten_bind_ShapeFix_Shape_FixVertexTolMode_0=Module["_emscripten_bind_ShapeFix_Shape_FixVertexTolMode_0"]=Module["asm"]["Hn"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shape___destroy___0=Module["_emscripten_bind_ShapeFix_Shape___destroy___0"]=function(){return(_emscripten_bind_ShapeFix_Shape___destroy___0=Module["_emscripten_bind_ShapeFix_Shape___destroy___0"]=Module["asm"]["In"]).apply(null,arguments)};var _emscripten_bind_gp_Pnt_gp_Pnt_0=Module["_emscripten_bind_gp_Pnt_gp_Pnt_0"]=function(){return(_emscripten_bind_gp_Pnt_gp_Pnt_0=Module["_emscripten_bind_gp_Pnt_gp_Pnt_0"]=Module["asm"]["Jn"]).apply(null,arguments)};var _emscripten_bind_gp_Pnt_gp_Pnt_3=Module["_emscripten_bind_gp_Pnt_gp_Pnt_3"]=function(){return(_emscripten_bind_gp_Pnt_gp_Pnt_3=Module["_emscripten_bind_gp_Pnt_gp_Pnt_3"]=Module["asm"]["Kn"]).apply(null,arguments)};var _emscripten_bind_gp_Pnt_SetCoord_2=Module["_emscripten_bind_gp_Pnt_SetCoord_2"]=function(){return(_emscripten_bind_gp_Pnt_SetCoord_2=Module["_emscripten_bind_gp_Pnt_SetCoord_2"]=Module["asm"]["Ln"]).apply(null,arguments)};var _emscripten_bind_gp_Pnt_SetCoord_3=Module["_emscripten_bind_gp_Pnt_SetCoord_3"]=function(){return(_emscripten_bind_gp_Pnt_SetCoord_3=Module["_emscripten_bind_gp_Pnt_SetCoord_3"]=Module["asm"]["Mn"]).apply(null,arguments)};var _emscripten_bind_gp_Pnt_SetX_1=Module["_emscripten_bind_gp_Pnt_SetX_1"]=function(){return(_emscripten_bind_gp_Pnt_SetX_1=Module["_emscripten_bind_gp_Pnt_SetX_1"]=Module["asm"]["Nn"]).apply(null,arguments)};var _emscripten_bind_gp_Pnt_SetY_1=Module["_emscripten_bind_gp_Pnt_SetY_1"]=function(){return(_emscripten_bind_gp_Pnt_SetY_1=Module["_emscripten_bind_gp_Pnt_SetY_1"]=Module["asm"]["On"]).apply(null,arguments)};var _emscripten_bind_gp_Pnt_SetZ_1=Module["_emscripten_bind_gp_Pnt_SetZ_1"]=function(){return(_emscripten_bind_gp_Pnt_SetZ_1=Module["_emscripten_bind_gp_Pnt_SetZ_1"]=Module["asm"]["Pn"]).apply(null,arguments)};var _emscripten_bind_gp_Pnt_Coord_1=Module["_emscripten_bind_gp_Pnt_Coord_1"]=function(){return(_emscripten_bind_gp_Pnt_Coord_1=Module["_emscripten_bind_gp_Pnt_Coord_1"]=Module["asm"]["Qn"]).apply(null,arguments)};var _emscripten_bind_gp_Pnt_X_0=Module["_emscripten_bind_gp_Pnt_X_0"]=function(){return(_emscripten_bind_gp_Pnt_X_0=Module["_emscripten_bind_gp_Pnt_X_0"]=Module["asm"]["Rn"]).apply(null,arguments)};var _emscripten_bind_gp_Pnt_Y_0=Module["_emscripten_bind_gp_Pnt_Y_0"]=function(){return(_emscripten_bind_gp_Pnt_Y_0=Module["_emscripten_bind_gp_Pnt_Y_0"]=Module["asm"]["Sn"]).apply(null,arguments)};var _emscripten_bind_gp_Pnt_Z_0=Module["_emscripten_bind_gp_Pnt_Z_0"]=function(){return(_emscripten_bind_gp_Pnt_Z_0=Module["_emscripten_bind_gp_Pnt_Z_0"]=Module["asm"]["Tn"]).apply(null,arguments)};var _emscripten_bind_gp_Pnt_BaryCenter_3=Module["_emscripten_bind_gp_Pnt_BaryCenter_3"]=function(){return(_emscripten_bind_gp_Pnt_BaryCenter_3=Module["_emscripten_bind_gp_Pnt_BaryCenter_3"]=Module["asm"]["Un"]).apply(null,arguments)};var _emscripten_bind_gp_Pnt_IsEqual_2=Module["_emscripten_bind_gp_Pnt_IsEqual_2"]=function(){return(_emscripten_bind_gp_Pnt_IsEqual_2=Module["_emscripten_bind_gp_Pnt_IsEqual_2"]=Module["asm"]["Vn"]).apply(null,arguments)};var _emscripten_bind_gp_Pnt_Distance_1=Module["_emscripten_bind_gp_Pnt_Distance_1"]=function(){return(_emscripten_bind_gp_Pnt_Distance_1=Module["_emscripten_bind_gp_Pnt_Distance_1"]=Module["asm"]["Wn"]).apply(null,arguments)};var _emscripten_bind_gp_Pnt_SquareDistance_1=Module["_emscripten_bind_gp_Pnt_SquareDistance_1"]=function(){return(_emscripten_bind_gp_Pnt_SquareDistance_1=Module["_emscripten_bind_gp_Pnt_SquareDistance_1"]=Module["asm"]["Xn"]).apply(null,arguments)};var _emscripten_bind_gp_Pnt_Mirror_1=Module["_emscripten_bind_gp_Pnt_Mirror_1"]=function(){return(_emscripten_bind_gp_Pnt_Mirror_1=Module["_emscripten_bind_gp_Pnt_Mirror_1"]=Module["asm"]["Yn"]).apply(null,arguments)};var _emscripten_bind_gp_Pnt_Rotate_2=Module["_emscripten_bind_gp_Pnt_Rotate_2"]=function(){return(_emscripten_bind_gp_Pnt_Rotate_2=Module["_emscripten_bind_gp_Pnt_Rotate_2"]=Module["asm"]["Zn"]).apply(null,arguments)};var _emscripten_bind_gp_Pnt_Rotated_2=Module["_emscripten_bind_gp_Pnt_Rotated_2"]=function(){return(_emscripten_bind_gp_Pnt_Rotated_2=Module["_emscripten_bind_gp_Pnt_Rotated_2"]=Module["asm"]["_n"]).apply(null,arguments)};var _emscripten_bind_gp_Pnt_Scale_2=Module["_emscripten_bind_gp_Pnt_Scale_2"]=function(){return(_emscripten_bind_gp_Pnt_Scale_2=Module["_emscripten_bind_gp_Pnt_Scale_2"]=Module["asm"]["$n"]).apply(null,arguments)};var _emscripten_bind_gp_Pnt_Scaled_2=Module["_emscripten_bind_gp_Pnt_Scaled_2"]=function(){return(_emscripten_bind_gp_Pnt_Scaled_2=Module["_emscripten_bind_gp_Pnt_Scaled_2"]=Module["asm"]["ao"]).apply(null,arguments)};var _emscripten_bind_gp_Pnt_Transform_1=Module["_emscripten_bind_gp_Pnt_Transform_1"]=function(){return(_emscripten_bind_gp_Pnt_Transform_1=Module["_emscripten_bind_gp_Pnt_Transform_1"]=Module["asm"]["bo"]).apply(null,arguments)};var _emscripten_bind_gp_Pnt_Transformed_1=Module["_emscripten_bind_gp_Pnt_Transformed_1"]=function(){return(_emscripten_bind_gp_Pnt_Transformed_1=Module["_emscripten_bind_gp_Pnt_Transformed_1"]=Module["asm"]["co"]).apply(null,arguments)};var _emscripten_bind_gp_Pnt_Translated_1=Module["_emscripten_bind_gp_Pnt_Translated_1"]=function(){return(_emscripten_bind_gp_Pnt_Translated_1=Module["_emscripten_bind_gp_Pnt_Translated_1"]=Module["asm"]["eo"]).apply(null,arguments)};var _emscripten_bind_gp_Pnt_Translated_2=Module["_emscripten_bind_gp_Pnt_Translated_2"]=function(){return(_emscripten_bind_gp_Pnt_Translated_2=Module["_emscripten_bind_gp_Pnt_Translated_2"]=Module["asm"]["fo"]).apply(null,arguments)};var _emscripten_bind_gp_Pnt___destroy___0=Module["_emscripten_bind_gp_Pnt___destroy___0"]=function(){return(_emscripten_bind_gp_Pnt___destroy___0=Module["_emscripten_bind_gp_Pnt___destroy___0"]=Module["asm"]["go"]).apply(null,arguments)};var _emscripten_bind_TopLoc_Location_TopLoc_Location_0=Module["_emscripten_bind_TopLoc_Location_TopLoc_Location_0"]=function(){return(_emscripten_bind_TopLoc_Location_TopLoc_Location_0=Module["_emscripten_bind_TopLoc_Location_TopLoc_Location_0"]=Module["asm"]["ho"]).apply(null,arguments)};var _emscripten_bind_TopLoc_Location_TopLoc_Location_1=Module["_emscripten_bind_TopLoc_Location_TopLoc_Location_1"]=function(){return(_emscripten_bind_TopLoc_Location_TopLoc_Location_1=Module["_emscripten_bind_TopLoc_Location_TopLoc_Location_1"]=Module["asm"]["io"]).apply(null,arguments)};var _emscripten_bind_TopLoc_Location_Identity_0=Module["_emscripten_bind_TopLoc_Location_Identity_0"]=function(){return(_emscripten_bind_TopLoc_Location_Identity_0=Module["_emscripten_bind_TopLoc_Location_Identity_0"]=Module["asm"]["jo"]).apply(null,arguments)};var _emscripten_bind_TopLoc_Location_FirstPower_0=Module["_emscripten_bind_TopLoc_Location_FirstPower_0"]=function(){return(_emscripten_bind_TopLoc_Location_FirstPower_0=Module["_emscripten_bind_TopLoc_Location_FirstPower_0"]=Module["asm"]["ko"]).apply(null,arguments)};var _emscripten_bind_TopLoc_Location_NextLocation_0=Module["_emscripten_bind_TopLoc_Location_NextLocation_0"]=function(){return(_emscripten_bind_TopLoc_Location_NextLocation_0=Module["_emscripten_bind_TopLoc_Location_NextLocation_0"]=Module["asm"]["lo"]).apply(null,arguments)};var _emscripten_bind_TopLoc_Location_Transformation_0=Module["_emscripten_bind_TopLoc_Location_Transformation_0"]=function(){return(_emscripten_bind_TopLoc_Location_Transformation_0=Module["_emscripten_bind_TopLoc_Location_Transformation_0"]=Module["asm"]["mo"]).apply(null,arguments)};var _emscripten_bind_TopLoc_Location___destroy___0=Module["_emscripten_bind_TopLoc_Location___destroy___0"]=function(){return(_emscripten_bind_TopLoc_Location___destroy___0=Module["_emscripten_bind_TopLoc_Location___destroy___0"]=Module["asm"]["no"]).apply(null,arguments)};var _emscripten_bind_Bnd_OBB_Bnd_OBB_0=Module["_emscripten_bind_Bnd_OBB_Bnd_OBB_0"]=function(){return(_emscripten_bind_Bnd_OBB_Bnd_OBB_0=Module["_emscripten_bind_Bnd_OBB_Bnd_OBB_0"]=Module["asm"]["oo"]).apply(null,arguments)};var _emscripten_bind_Bnd_OBB_Bnd_OBB_1=Module["_emscripten_bind_Bnd_OBB_Bnd_OBB_1"]=function(){return(_emscripten_bind_Bnd_OBB_Bnd_OBB_1=Module["_emscripten_bind_Bnd_OBB_Bnd_OBB_1"]=Module["asm"]["po"]).apply(null,arguments)};var _emscripten_bind_Bnd_OBB_Bnd_OBB_7=Module["_emscripten_bind_Bnd_OBB_Bnd_OBB_7"]=function(){return(_emscripten_bind_Bnd_OBB_Bnd_OBB_7=Module["_emscripten_bind_Bnd_OBB_Bnd_OBB_7"]=Module["asm"]["qo"]).apply(null,arguments)};var _emscripten_bind_Bnd_OBB_ReBuild_2=Module["_emscripten_bind_Bnd_OBB_ReBuild_2"]=function(){return(_emscripten_bind_Bnd_OBB_ReBuild_2=Module["_emscripten_bind_Bnd_OBB_ReBuild_2"]=Module["asm"]["ro"]).apply(null,arguments)};var _emscripten_bind_Bnd_OBB_ReBuild_3=Module["_emscripten_bind_Bnd_OBB_ReBuild_3"]=function(){return(_emscripten_bind_Bnd_OBB_ReBuild_3=Module["_emscripten_bind_Bnd_OBB_ReBuild_3"]=Module["asm"]["so"]).apply(null,arguments)};var _emscripten_bind_Bnd_OBB_SetCenter_1=Module["_emscripten_bind_Bnd_OBB_SetCenter_1"]=function(){return(_emscripten_bind_Bnd_OBB_SetCenter_1=Module["_emscripten_bind_Bnd_OBB_SetCenter_1"]=Module["asm"]["to"]).apply(null,arguments)};var _emscripten_bind_Bnd_OBB_SetXComponent_2=Module["_emscripten_bind_Bnd_OBB_SetXComponent_2"]=function(){return(_emscripten_bind_Bnd_OBB_SetXComponent_2=Module["_emscripten_bind_Bnd_OBB_SetXComponent_2"]=Module["asm"]["uo"]).apply(null,arguments)};var _emscripten_bind_Bnd_OBB_SetYComponent_2=Module["_emscripten_bind_Bnd_OBB_SetYComponent_2"]=function(){return(_emscripten_bind_Bnd_OBB_SetYComponent_2=Module["_emscripten_bind_Bnd_OBB_SetYComponent_2"]=Module["asm"]["vo"]).apply(null,arguments)};var _emscripten_bind_Bnd_OBB_SetZComponent_2=Module["_emscripten_bind_Bnd_OBB_SetZComponent_2"]=function(){return(_emscripten_bind_Bnd_OBB_SetZComponent_2=Module["_emscripten_bind_Bnd_OBB_SetZComponent_2"]=Module["asm"]["wo"]).apply(null,arguments)};var _emscripten_bind_Bnd_OBB_XHSize_0=Module["_emscripten_bind_Bnd_OBB_XHSize_0"]=function(){return(_emscripten_bind_Bnd_OBB_XHSize_0=Module["_emscripten_bind_Bnd_OBB_XHSize_0"]=Module["asm"]["xo"]).apply(null,arguments)};var _emscripten_bind_Bnd_OBB_YHSize_0=Module["_emscripten_bind_Bnd_OBB_YHSize_0"]=function(){return(_emscripten_bind_Bnd_OBB_YHSize_0=Module["_emscripten_bind_Bnd_OBB_YHSize_0"]=Module["asm"]["yo"]).apply(null,arguments)};var _emscripten_bind_Bnd_OBB_ZHSize_0=Module["_emscripten_bind_Bnd_OBB_ZHSize_0"]=function(){return(_emscripten_bind_Bnd_OBB_ZHSize_0=Module["_emscripten_bind_Bnd_OBB_ZHSize_0"]=Module["asm"]["zo"]).apply(null,arguments)};var _emscripten_bind_Bnd_OBB_IsVoid_0=Module["_emscripten_bind_Bnd_OBB_IsVoid_0"]=function(){return(_emscripten_bind_Bnd_OBB_IsVoid_0=Module["_emscripten_bind_Bnd_OBB_IsVoid_0"]=Module["asm"]["Ao"]).apply(null,arguments)};var _emscripten_bind_Bnd_OBB_SetVoid_0=Module["_emscripten_bind_Bnd_OBB_SetVoid_0"]=function(){return(_emscripten_bind_Bnd_OBB_SetVoid_0=Module["_emscripten_bind_Bnd_OBB_SetVoid_0"]=Module["asm"]["Bo"]).apply(null,arguments)};var _emscripten_bind_Bnd_OBB_SetAABox_1=Module["_emscripten_bind_Bnd_OBB_SetAABox_1"]=function(){return(_emscripten_bind_Bnd_OBB_SetAABox_1=Module["_emscripten_bind_Bnd_OBB_SetAABox_1"]=Module["asm"]["Co"]).apply(null,arguments)};var _emscripten_bind_Bnd_OBB_IsAABox_0=Module["_emscripten_bind_Bnd_OBB_IsAABox_0"]=function(){return(_emscripten_bind_Bnd_OBB_IsAABox_0=Module["_emscripten_bind_Bnd_OBB_IsAABox_0"]=Module["asm"]["Do"]).apply(null,arguments)};var _emscripten_bind_Bnd_OBB_Enlarge_1=Module["_emscripten_bind_Bnd_OBB_Enlarge_1"]=function(){return(_emscripten_bind_Bnd_OBB_Enlarge_1=Module["_emscripten_bind_Bnd_OBB_Enlarge_1"]=Module["asm"]["Eo"]).apply(null,arguments)};var _emscripten_bind_Bnd_OBB_GetVertex_1=Module["_emscripten_bind_Bnd_OBB_GetVertex_1"]=function(){return(_emscripten_bind_Bnd_OBB_GetVertex_1=Module["_emscripten_bind_Bnd_OBB_GetVertex_1"]=Module["asm"]["Fo"]).apply(null,arguments)};var _emscripten_bind_Bnd_OBB_SquareExtent_0=Module["_emscripten_bind_Bnd_OBB_SquareExtent_0"]=function(){return(_emscripten_bind_Bnd_OBB_SquareExtent_0=Module["_emscripten_bind_Bnd_OBB_SquareExtent_0"]=Module["asm"]["Go"]).apply(null,arguments)};var _emscripten_bind_Bnd_OBB_IsOut_1=Module["_emscripten_bind_Bnd_OBB_IsOut_1"]=function(){return(_emscripten_bind_Bnd_OBB_IsOut_1=Module["_emscripten_bind_Bnd_OBB_IsOut_1"]=Module["asm"]["Ho"]).apply(null,arguments)};var _emscripten_bind_Bnd_OBB_IsCompletelyInside_1=Module["_emscripten_bind_Bnd_OBB_IsCompletelyInside_1"]=function(){return(_emscripten_bind_Bnd_OBB_IsCompletelyInside_1=Module["_emscripten_bind_Bnd_OBB_IsCompletelyInside_1"]=Module["asm"]["Io"]).apply(null,arguments)};var _emscripten_bind_Bnd_OBB_Add_1=Module["_emscripten_bind_Bnd_OBB_Add_1"]=function(){return(_emscripten_bind_Bnd_OBB_Add_1=Module["_emscripten_bind_Bnd_OBB_Add_1"]=Module["asm"]["Jo"]).apply(null,arguments)};var _emscripten_bind_Bnd_OBB___destroy___0=Module["_emscripten_bind_Bnd_OBB___destroy___0"]=function(){return(_emscripten_bind_Bnd_OBB___destroy___0=Module["_emscripten_bind_Bnd_OBB___destroy___0"]=Module["asm"]["Ko"]).apply(null,arguments)};var _emscripten_bind_TopTools_ListOfShape_TopTools_ListOfShape_0=Module["_emscripten_bind_TopTools_ListOfShape_TopTools_ListOfShape_0"]=function(){return(_emscripten_bind_TopTools_ListOfShape_TopTools_ListOfShape_0=Module["_emscripten_bind_TopTools_ListOfShape_TopTools_ListOfShape_0"]=Module["asm"]["Lo"]).apply(null,arguments)};var _emscripten_bind_TopTools_ListOfShape_Append_1=Module["_emscripten_bind_TopTools_ListOfShape_Append_1"]=function(){return(_emscripten_bind_TopTools_ListOfShape_Append_1=Module["_emscripten_bind_TopTools_ListOfShape_Append_1"]=Module["asm"]["Mo"]).apply(null,arguments)};var _emscripten_bind_TopTools_ListOfShape_First_0=Module["_emscripten_bind_TopTools_ListOfShape_First_0"]=function(){return(_emscripten_bind_TopTools_ListOfShape_First_0=Module["_emscripten_bind_TopTools_ListOfShape_First_0"]=Module["asm"]["No"]).apply(null,arguments)};var _emscripten_bind_TopTools_ListOfShape_Last_0=Module["_emscripten_bind_TopTools_ListOfShape_Last_0"]=function(){return(_emscripten_bind_TopTools_ListOfShape_Last_0=Module["_emscripten_bind_TopTools_ListOfShape_Last_0"]=Module["asm"]["Oo"]).apply(null,arguments)};var _emscripten_bind_TopTools_ListOfShape___destroy___0=Module["_emscripten_bind_TopTools_ListOfShape___destroy___0"]=function(){return(_emscripten_bind_TopTools_ListOfShape___destroy___0=Module["_emscripten_bind_TopTools_ListOfShape___destroy___0"]=Module["asm"]["Po"]).apply(null,arguments)};var _emscripten_bind_BRepAlgoAPI_Common_BRepAlgoAPI_Common_2=Module["_emscripten_bind_BRepAlgoAPI_Common_BRepAlgoAPI_Common_2"]=function(){return(_emscripten_bind_BRepAlgoAPI_Common_BRepAlgoAPI_Common_2=Module["_emscripten_bind_BRepAlgoAPI_Common_BRepAlgoAPI_Common_2"]=Module["asm"]["Qo"]).apply(null,arguments)};var _emscripten_bind_BRepAlgoAPI_Common_Shape_0=Module["_emscripten_bind_BRepAlgoAPI_Common_Shape_0"]=function(){return(_emscripten_bind_BRepAlgoAPI_Common_Shape_0=Module["_emscripten_bind_BRepAlgoAPI_Common_Shape_0"]=Module["asm"]["Ro"]).apply(null,arguments)};var _emscripten_bind_BRepAlgoAPI_Common___destroy___0=Module["_emscripten_bind_BRepAlgoAPI_Common___destroy___0"]=function(){return(_emscripten_bind_BRepAlgoAPI_Common___destroy___0=Module["_emscripten_bind_BRepAlgoAPI_Common___destroy___0"]=Module["asm"]["So"]).apply(null,arguments)};var _emscripten_bind_Geom_TrimmedCurve_Geom_TrimmedCurve_3=Module["_emscripten_bind_Geom_TrimmedCurve_Geom_TrimmedCurve_3"]=function(){return(_emscripten_bind_Geom_TrimmedCurve_Geom_TrimmedCurve_3=Module["_emscripten_bind_Geom_TrimmedCurve_Geom_TrimmedCurve_3"]=Module["asm"]["To"]).apply(null,arguments)};var _emscripten_bind_Geom_TrimmedCurve_Geom_TrimmedCurve_4=Module["_emscripten_bind_Geom_TrimmedCurve_Geom_TrimmedCurve_4"]=function(){return(_emscripten_bind_Geom_TrimmedCurve_Geom_TrimmedCurve_4=Module["_emscripten_bind_Geom_TrimmedCurve_Geom_TrimmedCurve_4"]=Module["asm"]["Uo"]).apply(null,arguments)};var _emscripten_bind_Geom_TrimmedCurve_Geom_TrimmedCurve_5=Module["_emscripten_bind_Geom_TrimmedCurve_Geom_TrimmedCurve_5"]=function(){return(_emscripten_bind_Geom_TrimmedCurve_Geom_TrimmedCurve_5=Module["_emscripten_bind_Geom_TrimmedCurve_Geom_TrimmedCurve_5"]=Module["asm"]["Vo"]).apply(null,arguments)};var _emscripten_bind_Geom_TrimmedCurve_Reverse_0=Module["_emscripten_bind_Geom_TrimmedCurve_Reverse_0"]=function(){return(_emscripten_bind_Geom_TrimmedCurve_Reverse_0=Module["_emscripten_bind_Geom_TrimmedCurve_Reverse_0"]=Module["asm"]["Wo"]).apply(null,arguments)};var _emscripten_bind_Geom_TrimmedCurve_ReversedParameter_1=Module["_emscripten_bind_Geom_TrimmedCurve_ReversedParameter_1"]=function(){return(_emscripten_bind_Geom_TrimmedCurve_ReversedParameter_1=Module["_emscripten_bind_Geom_TrimmedCurve_ReversedParameter_1"]=Module["asm"]["Xo"]).apply(null,arguments)};var _emscripten_bind_Geom_TrimmedCurve_SetTrim_2=Module["_emscripten_bind_Geom_TrimmedCurve_SetTrim_2"]=function(){return(_emscripten_bind_Geom_TrimmedCurve_SetTrim_2=Module["_emscripten_bind_Geom_TrimmedCurve_SetTrim_2"]=Module["asm"]["Yo"]).apply(null,arguments)};var _emscripten_bind_Geom_TrimmedCurve_SetTrim_3=Module["_emscripten_bind_Geom_TrimmedCurve_SetTrim_3"]=function(){return(_emscripten_bind_Geom_TrimmedCurve_SetTrim_3=Module["_emscripten_bind_Geom_TrimmedCurve_SetTrim_3"]=Module["asm"]["Zo"]).apply(null,arguments)};var _emscripten_bind_Geom_TrimmedCurve_SetTrim_4=Module["_emscripten_bind_Geom_TrimmedCurve_SetTrim_4"]=function(){return(_emscripten_bind_Geom_TrimmedCurve_SetTrim_4=Module["_emscripten_bind_Geom_TrimmedCurve_SetTrim_4"]=Module["asm"]["_o"]).apply(null,arguments)};var _emscripten_bind_Geom_TrimmedCurve_BasisCurve_0=Module["_emscripten_bind_Geom_TrimmedCurve_BasisCurve_0"]=function(){return(_emscripten_bind_Geom_TrimmedCurve_BasisCurve_0=Module["_emscripten_bind_Geom_TrimmedCurve_BasisCurve_0"]=Module["asm"]["$o"]).apply(null,arguments)};var _emscripten_bind_Geom_TrimmedCurve_IsCN_1=Module["_emscripten_bind_Geom_TrimmedCurve_IsCN_1"]=function(){return(_emscripten_bind_Geom_TrimmedCurve_IsCN_1=Module["_emscripten_bind_Geom_TrimmedCurve_IsCN_1"]=Module["asm"]["ap"]).apply(null,arguments)};var _emscripten_bind_Geom_TrimmedCurve_FirstParameter_0=Module["_emscripten_bind_Geom_TrimmedCurve_FirstParameter_0"]=function(){return(_emscripten_bind_Geom_TrimmedCurve_FirstParameter_0=Module["_emscripten_bind_Geom_TrimmedCurve_FirstParameter_0"]=Module["asm"]["bp"]).apply(null,arguments)};var _emscripten_bind_Geom_TrimmedCurve_IsClosed_0=Module["_emscripten_bind_Geom_TrimmedCurve_IsClosed_0"]=function(){return(_emscripten_bind_Geom_TrimmedCurve_IsClosed_0=Module["_emscripten_bind_Geom_TrimmedCurve_IsClosed_0"]=Module["asm"]["cp"]).apply(null,arguments)};var _emscripten_bind_Geom_TrimmedCurve_IsPeriodic_0=Module["_emscripten_bind_Geom_TrimmedCurve_IsPeriodic_0"]=function(){return(_emscripten_bind_Geom_TrimmedCurve_IsPeriodic_0=Module["_emscripten_bind_Geom_TrimmedCurve_IsPeriodic_0"]=Module["asm"]["dp"]).apply(null,arguments)};var _emscripten_bind_Geom_TrimmedCurve_Period_0=Module["_emscripten_bind_Geom_TrimmedCurve_Period_0"]=function(){return(_emscripten_bind_Geom_TrimmedCurve_Period_0=Module["_emscripten_bind_Geom_TrimmedCurve_Period_0"]=Module["asm"]["ep"]).apply(null,arguments)};var _emscripten_bind_Geom_TrimmedCurve_LastParameter_0=Module["_emscripten_bind_Geom_TrimmedCurve_LastParameter_0"]=function(){return(_emscripten_bind_Geom_TrimmedCurve_LastParameter_0=Module["_emscripten_bind_Geom_TrimmedCurve_LastParameter_0"]=Module["asm"]["fp"]).apply(null,arguments)};var _emscripten_bind_Geom_TrimmedCurve_StartPoint_0=Module["_emscripten_bind_Geom_TrimmedCurve_StartPoint_0"]=function(){return(_emscripten_bind_Geom_TrimmedCurve_StartPoint_0=Module["_emscripten_bind_Geom_TrimmedCurve_StartPoint_0"]=Module["asm"]["gp"]).apply(null,arguments)};var _emscripten_bind_Geom_TrimmedCurve_D0_2=Module["_emscripten_bind_Geom_TrimmedCurve_D0_2"]=function(){return(_emscripten_bind_Geom_TrimmedCurve_D0_2=Module["_emscripten_bind_Geom_TrimmedCurve_D0_2"]=Module["asm"]["hp"]).apply(null,arguments)};var _emscripten_bind_Geom_TrimmedCurve_D1_3=Module["_emscripten_bind_Geom_TrimmedCurve_D1_3"]=function(){return(_emscripten_bind_Geom_TrimmedCurve_D1_3=Module["_emscripten_bind_Geom_TrimmedCurve_D1_3"]=Module["asm"]["ip"]).apply(null,arguments)};var _emscripten_bind_Geom_TrimmedCurve_D2_4=Module["_emscripten_bind_Geom_TrimmedCurve_D2_4"]=function(){return(_emscripten_bind_Geom_TrimmedCurve_D2_4=Module["_emscripten_bind_Geom_TrimmedCurve_D2_4"]=Module["asm"]["jp"]).apply(null,arguments)};var _emscripten_bind_Geom_TrimmedCurve_D3_5=Module["_emscripten_bind_Geom_TrimmedCurve_D3_5"]=function(){return(_emscripten_bind_Geom_TrimmedCurve_D3_5=Module["_emscripten_bind_Geom_TrimmedCurve_D3_5"]=Module["asm"]["kp"]).apply(null,arguments)};var _emscripten_bind_Geom_TrimmedCurve_DN_2=Module["_emscripten_bind_Geom_TrimmedCurve_DN_2"]=function(){return(_emscripten_bind_Geom_TrimmedCurve_DN_2=Module["_emscripten_bind_Geom_TrimmedCurve_DN_2"]=Module["asm"]["lp"]).apply(null,arguments)};var _emscripten_bind_Geom_TrimmedCurve_Transform_1=Module["_emscripten_bind_Geom_TrimmedCurve_Transform_1"]=function(){return(_emscripten_bind_Geom_TrimmedCurve_Transform_1=Module["_emscripten_bind_Geom_TrimmedCurve_Transform_1"]=Module["asm"]["mp"]).apply(null,arguments)};var _emscripten_bind_Geom_TrimmedCurve_TransformedParameter_2=Module["_emscripten_bind_Geom_TrimmedCurve_TransformedParameter_2"]=function(){return(_emscripten_bind_Geom_TrimmedCurve_TransformedParameter_2=Module["_emscripten_bind_Geom_TrimmedCurve_TransformedParameter_2"]=Module["asm"]["np"]).apply(null,arguments)};var _emscripten_bind_Geom_TrimmedCurve_ParametricTransformation_1=Module["_emscripten_bind_Geom_TrimmedCurve_ParametricTransformation_1"]=function(){return(_emscripten_bind_Geom_TrimmedCurve_ParametricTransformation_1=Module["_emscripten_bind_Geom_TrimmedCurve_ParametricTransformation_1"]=Module["asm"]["op"]).apply(null,arguments)};var _emscripten_bind_Geom_TrimmedCurve_Reversed_0=Module["_emscripten_bind_Geom_TrimmedCurve_Reversed_0"]=function(){return(_emscripten_bind_Geom_TrimmedCurve_Reversed_0=Module["_emscripten_bind_Geom_TrimmedCurve_Reversed_0"]=Module["asm"]["pp"]).apply(null,arguments)};var _emscripten_bind_Geom_TrimmedCurve_Value_1=Module["_emscripten_bind_Geom_TrimmedCurve_Value_1"]=function(){return(_emscripten_bind_Geom_TrimmedCurve_Value_1=Module["_emscripten_bind_Geom_TrimmedCurve_Value_1"]=Module["asm"]["qp"]).apply(null,arguments)};var _emscripten_bind_Geom_TrimmedCurve___destroy___0=Module["_emscripten_bind_Geom_TrimmedCurve___destroy___0"]=function(){return(_emscripten_bind_Geom_TrimmedCurve___destroy___0=Module["_emscripten_bind_Geom_TrimmedCurve___destroy___0"]=Module["asm"]["rp"]).apply(null,arguments)};var _emscripten_bind_BRepGProp_LinearProperties_2=Module["_emscripten_bind_BRepGProp_LinearProperties_2"]=function(){return(_emscripten_bind_BRepGProp_LinearProperties_2=Module["_emscripten_bind_BRepGProp_LinearProperties_2"]=Module["asm"]["sp"]).apply(null,arguments)};var _emscripten_bind_BRepGProp_LinearProperties_3=Module["_emscripten_bind_BRepGProp_LinearProperties_3"]=function(){return(_emscripten_bind_BRepGProp_LinearProperties_3=Module["_emscripten_bind_BRepGProp_LinearProperties_3"]=Module["asm"]["tp"]).apply(null,arguments)};var _emscripten_bind_BRepGProp_LinearProperties_4=Module["_emscripten_bind_BRepGProp_LinearProperties_4"]=function(){return(_emscripten_bind_BRepGProp_LinearProperties_4=Module["_emscripten_bind_BRepGProp_LinearProperties_4"]=Module["asm"]["up"]).apply(null,arguments)};var _emscripten_bind_BRepGProp_SurfaceProperties_2=Module["_emscripten_bind_BRepGProp_SurfaceProperties_2"]=function(){return(_emscripten_bind_BRepGProp_SurfaceProperties_2=Module["_emscripten_bind_BRepGProp_SurfaceProperties_2"]=Module["asm"]["vp"]).apply(null,arguments)};var _emscripten_bind_BRepGProp_SurfaceProperties_3=Module["_emscripten_bind_BRepGProp_SurfaceProperties_3"]=function(){return(_emscripten_bind_BRepGProp_SurfaceProperties_3=Module["_emscripten_bind_BRepGProp_SurfaceProperties_3"]=Module["asm"]["wp"]).apply(null,arguments)};var _emscripten_bind_BRepGProp_SurfaceProperties_4=Module["_emscripten_bind_BRepGProp_SurfaceProperties_4"]=function(){return(_emscripten_bind_BRepGProp_SurfaceProperties_4=Module["_emscripten_bind_BRepGProp_SurfaceProperties_4"]=Module["asm"]["xp"]).apply(null,arguments)};var _emscripten_bind_BRepGProp_SurfaceProperties2_3=Module["_emscripten_bind_BRepGProp_SurfaceProperties2_3"]=function(){return(_emscripten_bind_BRepGProp_SurfaceProperties2_3=Module["_emscripten_bind_BRepGProp_SurfaceProperties2_3"]=Module["asm"]["yp"]).apply(null,arguments)};var _emscripten_bind_BRepGProp_SurfaceProperties2_4=Module["_emscripten_bind_BRepGProp_SurfaceProperties2_4"]=function(){return(_emscripten_bind_BRepGProp_SurfaceProperties2_4=Module["_emscripten_bind_BRepGProp_SurfaceProperties2_4"]=Module["asm"]["zp"]).apply(null,arguments)};var _emscripten_bind_BRepGProp_VolumeProperties_2=Module["_emscripten_bind_BRepGProp_VolumeProperties_2"]=function(){return(_emscripten_bind_BRepGProp_VolumeProperties_2=Module["_emscripten_bind_BRepGProp_VolumeProperties_2"]=Module["asm"]["Ap"]).apply(null,arguments)};var _emscripten_bind_BRepGProp_VolumeProperties_3=Module["_emscripten_bind_BRepGProp_VolumeProperties_3"]=function(){return(_emscripten_bind_BRepGProp_VolumeProperties_3=Module["_emscripten_bind_BRepGProp_VolumeProperties_3"]=Module["asm"]["Bp"]).apply(null,arguments)};var _emscripten_bind_BRepGProp_VolumeProperties_4=Module["_emscripten_bind_BRepGProp_VolumeProperties_4"]=function(){return(_emscripten_bind_BRepGProp_VolumeProperties_4=Module["_emscripten_bind_BRepGProp_VolumeProperties_4"]=Module["asm"]["Cp"]).apply(null,arguments)};var _emscripten_bind_BRepGProp_VolumeProperties_5=Module["_emscripten_bind_BRepGProp_VolumeProperties_5"]=function(){return(_emscripten_bind_BRepGProp_VolumeProperties_5=Module["_emscripten_bind_BRepGProp_VolumeProperties_5"]=Module["asm"]["Dp"]).apply(null,arguments)};var _emscripten_bind_BRepGProp_VolumeProperties2_3=Module["_emscripten_bind_BRepGProp_VolumeProperties2_3"]=function(){return(_emscripten_bind_BRepGProp_VolumeProperties2_3=Module["_emscripten_bind_BRepGProp_VolumeProperties2_3"]=Module["asm"]["Ep"]).apply(null,arguments)};var _emscripten_bind_BRepGProp_VolumeProperties2_4=Module["_emscripten_bind_BRepGProp_VolumeProperties2_4"]=function(){return(_emscripten_bind_BRepGProp_VolumeProperties2_4=Module["_emscripten_bind_BRepGProp_VolumeProperties2_4"]=Module["asm"]["Fp"]).apply(null,arguments)};var _emscripten_bind_BRepGProp_VolumeProperties2_5=Module["_emscripten_bind_BRepGProp_VolumeProperties2_5"]=function(){return(_emscripten_bind_BRepGProp_VolumeProperties2_5=Module["_emscripten_bind_BRepGProp_VolumeProperties2_5"]=Module["asm"]["Gp"]).apply(null,arguments)};var _emscripten_bind_BRepGProp_VolumePropertiesGK_2=Module["_emscripten_bind_BRepGProp_VolumePropertiesGK_2"]=function(){return(_emscripten_bind_BRepGProp_VolumePropertiesGK_2=Module["_emscripten_bind_BRepGProp_VolumePropertiesGK_2"]=Module["asm"]["Hp"]).apply(null,arguments)};var _emscripten_bind_BRepGProp_VolumePropertiesGK_3=Module["_emscripten_bind_BRepGProp_VolumePropertiesGK_3"]=function(){return(_emscripten_bind_BRepGProp_VolumePropertiesGK_3=Module["_emscripten_bind_BRepGProp_VolumePropertiesGK_3"]=Module["asm"]["Ip"]).apply(null,arguments)};var _emscripten_bind_BRepGProp_VolumePropertiesGK_4=Module["_emscripten_bind_BRepGProp_VolumePropertiesGK_4"]=function(){return(_emscripten_bind_BRepGProp_VolumePropertiesGK_4=Module["_emscripten_bind_BRepGProp_VolumePropertiesGK_4"]=Module["asm"]["Jp"]).apply(null,arguments)};var _emscripten_bind_BRepGProp_VolumePropertiesGK_5=Module["_emscripten_bind_BRepGProp_VolumePropertiesGK_5"]=function(){return(_emscripten_bind_BRepGProp_VolumePropertiesGK_5=Module["_emscripten_bind_BRepGProp_VolumePropertiesGK_5"]=Module["asm"]["Kp"]).apply(null,arguments)};var _emscripten_bind_BRepGProp_VolumePropertiesGK_6=Module["_emscripten_bind_BRepGProp_VolumePropertiesGK_6"]=function(){return(_emscripten_bind_BRepGProp_VolumePropertiesGK_6=Module["_emscripten_bind_BRepGProp_VolumePropertiesGK_6"]=Module["asm"]["Lp"]).apply(null,arguments)};var _emscripten_bind_BRepGProp_VolumePropertiesGK_7=Module["_emscripten_bind_BRepGProp_VolumePropertiesGK_7"]=function(){return(_emscripten_bind_BRepGProp_VolumePropertiesGK_7=Module["_emscripten_bind_BRepGProp_VolumePropertiesGK_7"]=Module["asm"]["Mp"]).apply(null,arguments)};var _emscripten_bind_BRepGProp_VolumePropertiesGK_8=Module["_emscripten_bind_BRepGProp_VolumePropertiesGK_8"]=function(){return(_emscripten_bind_BRepGProp_VolumePropertiesGK_8=Module["_emscripten_bind_BRepGProp_VolumePropertiesGK_8"]=Module["asm"]["Np"]).apply(null,arguments)};var _emscripten_bind_BRepGProp_VolumePropertiesGK2_3=Module["_emscripten_bind_BRepGProp_VolumePropertiesGK2_3"]=function(){return(_emscripten_bind_BRepGProp_VolumePropertiesGK2_3=Module["_emscripten_bind_BRepGProp_VolumePropertiesGK2_3"]=Module["asm"]["Op"]).apply(null,arguments)};var _emscripten_bind_BRepGProp_VolumePropertiesGK2_4=Module["_emscripten_bind_BRepGProp_VolumePropertiesGK2_4"]=function(){return(_emscripten_bind_BRepGProp_VolumePropertiesGK2_4=Module["_emscripten_bind_BRepGProp_VolumePropertiesGK2_4"]=Module["asm"]["Pp"]).apply(null,arguments)};var _emscripten_bind_BRepGProp_VolumePropertiesGK2_5=Module["_emscripten_bind_BRepGProp_VolumePropertiesGK2_5"]=function(){return(_emscripten_bind_BRepGProp_VolumePropertiesGK2_5=Module["_emscripten_bind_BRepGProp_VolumePropertiesGK2_5"]=Module["asm"]["Qp"]).apply(null,arguments)};var _emscripten_bind_BRepGProp_VolumePropertiesGK2_6=Module["_emscripten_bind_BRepGProp_VolumePropertiesGK2_6"]=function(){return(_emscripten_bind_BRepGProp_VolumePropertiesGK2_6=Module["_emscripten_bind_BRepGProp_VolumePropertiesGK2_6"]=Module["asm"]["Rp"]).apply(null,arguments)};var _emscripten_bind_BRepGProp_VolumePropertiesGK2_7=Module["_emscripten_bind_BRepGProp_VolumePropertiesGK2_7"]=function(){return(_emscripten_bind_BRepGProp_VolumePropertiesGK2_7=Module["_emscripten_bind_BRepGProp_VolumePropertiesGK2_7"]=Module["asm"]["Sp"]).apply(null,arguments)};var _emscripten_bind_BRepGProp_VolumePropertiesGK2_8=Module["_emscripten_bind_BRepGProp_VolumePropertiesGK2_8"]=function(){return(_emscripten_bind_BRepGProp_VolumePropertiesGK2_8=Module["_emscripten_bind_BRepGProp_VolumePropertiesGK2_8"]=Module["asm"]["Tp"]).apply(null,arguments)};var _emscripten_bind_BRepGProp_VolumePropertiesGK2_9=Module["_emscripten_bind_BRepGProp_VolumePropertiesGK2_9"]=function(){return(_emscripten_bind_BRepGProp_VolumePropertiesGK2_9=Module["_emscripten_bind_BRepGProp_VolumePropertiesGK2_9"]=Module["asm"]["Up"]).apply(null,arguments)};var _emscripten_bind_BRepGProp___destroy___0=Module["_emscripten_bind_BRepGProp___destroy___0"]=function(){return(_emscripten_bind_BRepGProp___destroy___0=Module["_emscripten_bind_BRepGProp___destroy___0"]=Module["asm"]["Vp"]).apply(null,arguments)};var _emscripten_bind_GCPnts_TangentialDeflection_GCPnts_TangentialDeflection_0=Module["_emscripten_bind_GCPnts_TangentialDeflection_GCPnts_TangentialDeflection_0"]=function(){return(_emscripten_bind_GCPnts_TangentialDeflection_GCPnts_TangentialDeflection_0=Module["_emscripten_bind_GCPnts_TangentialDeflection_GCPnts_TangentialDeflection_0"]=Module["asm"]["Wp"]).apply(null,arguments)};var _emscripten_bind_GCPnts_TangentialDeflection_GCPnts_TangentialDeflection_3=Module["_emscripten_bind_GCPnts_TangentialDeflection_GCPnts_TangentialDeflection_3"]=function(){return(_emscripten_bind_GCPnts_TangentialDeflection_GCPnts_TangentialDeflection_3=Module["_emscripten_bind_GCPnts_TangentialDeflection_GCPnts_TangentialDeflection_3"]=Module["asm"]["Xp"]).apply(null,arguments)};var _emscripten_bind_GCPnts_TangentialDeflection_GCPnts_TangentialDeflection_4=Module["_emscripten_bind_GCPnts_TangentialDeflection_GCPnts_TangentialDeflection_4"]=function(){return(_emscripten_bind_GCPnts_TangentialDeflection_GCPnts_TangentialDeflection_4=Module["_emscripten_bind_GCPnts_TangentialDeflection_GCPnts_TangentialDeflection_4"]=Module["asm"]["Yp"]).apply(null,arguments)};var _emscripten_bind_GCPnts_TangentialDeflection_GCPnts_TangentialDeflection_5=Module["_emscripten_bind_GCPnts_TangentialDeflection_GCPnts_TangentialDeflection_5"]=function(){return(_emscripten_bind_GCPnts_TangentialDeflection_GCPnts_TangentialDeflection_5=Module["_emscripten_bind_GCPnts_TangentialDeflection_GCPnts_TangentialDeflection_5"]=Module["asm"]["Zp"]).apply(null,arguments)};var _emscripten_bind_GCPnts_TangentialDeflection_GCPnts_TangentialDeflection_6=Module["_emscripten_bind_GCPnts_TangentialDeflection_GCPnts_TangentialDeflection_6"]=function(){return(_emscripten_bind_GCPnts_TangentialDeflection_GCPnts_TangentialDeflection_6=Module["_emscripten_bind_GCPnts_TangentialDeflection_GCPnts_TangentialDeflection_6"]=Module["asm"]["_p"]).apply(null,arguments)};var _emscripten_bind_GCPnts_TangentialDeflection_GCPnts_TangentialDeflection_8=Module["_emscripten_bind_GCPnts_TangentialDeflection_GCPnts_TangentialDeflection_8"]=function(){return(_emscripten_bind_GCPnts_TangentialDeflection_GCPnts_TangentialDeflection_8=Module["_emscripten_bind_GCPnts_TangentialDeflection_GCPnts_TangentialDeflection_8"]=Module["asm"]["$p"]).apply(null,arguments)};var _emscripten_bind_GCPnts_TangentialDeflection_Initialize_3=Module["_emscripten_bind_GCPnts_TangentialDeflection_Initialize_3"]=function(){return(_emscripten_bind_GCPnts_TangentialDeflection_Initialize_3=Module["_emscripten_bind_GCPnts_TangentialDeflection_Initialize_3"]=Module["asm"]["aq"]).apply(null,arguments)};var _emscripten_bind_GCPnts_TangentialDeflection_Initialize_4=Module["_emscripten_bind_GCPnts_TangentialDeflection_Initialize_4"]=function(){return(_emscripten_bind_GCPnts_TangentialDeflection_Initialize_4=Module["_emscripten_bind_GCPnts_TangentialDeflection_Initialize_4"]=Module["asm"]["bq"]).apply(null,arguments)};var _emscripten_bind_GCPnts_TangentialDeflection_Initialize_5=Module["_emscripten_bind_GCPnts_TangentialDeflection_Initialize_5"]=function(){return(_emscripten_bind_GCPnts_TangentialDeflection_Initialize_5=Module["_emscripten_bind_GCPnts_TangentialDeflection_Initialize_5"]=Module["asm"]["cq"]).apply(null,arguments)};var _emscripten_bind_GCPnts_TangentialDeflection_Initialize_6=Module["_emscripten_bind_GCPnts_TangentialDeflection_Initialize_6"]=function(){return(_emscripten_bind_GCPnts_TangentialDeflection_Initialize_6=Module["_emscripten_bind_GCPnts_TangentialDeflection_Initialize_6"]=Module["asm"]["dq"]).apply(null,arguments)};var _emscripten_bind_GCPnts_TangentialDeflection_Initialize_8=Module["_emscripten_bind_GCPnts_TangentialDeflection_Initialize_8"]=function(){return(_emscripten_bind_GCPnts_TangentialDeflection_Initialize_8=Module["_emscripten_bind_GCPnts_TangentialDeflection_Initialize_8"]=Module["asm"]["eq"]).apply(null,arguments)};var _emscripten_bind_GCPnts_TangentialDeflection_AddPoint_2=Module["_emscripten_bind_GCPnts_TangentialDeflection_AddPoint_2"]=function(){return(_emscripten_bind_GCPnts_TangentialDeflection_AddPoint_2=Module["_emscripten_bind_GCPnts_TangentialDeflection_AddPoint_2"]=Module["asm"]["fq"]).apply(null,arguments)};var _emscripten_bind_GCPnts_TangentialDeflection_AddPoint_3=Module["_emscripten_bind_GCPnts_TangentialDeflection_AddPoint_3"]=function(){return(_emscripten_bind_GCPnts_TangentialDeflection_AddPoint_3=Module["_emscripten_bind_GCPnts_TangentialDeflection_AddPoint_3"]=Module["asm"]["gq"]).apply(null,arguments)};var _emscripten_bind_GCPnts_TangentialDeflection_NbPoints_0=Module["_emscripten_bind_GCPnts_TangentialDeflection_NbPoints_0"]=function(){return(_emscripten_bind_GCPnts_TangentialDeflection_NbPoints_0=Module["_emscripten_bind_GCPnts_TangentialDeflection_NbPoints_0"]=Module["asm"]["hq"]).apply(null,arguments)};var _emscripten_bind_GCPnts_TangentialDeflection_Parameter_1=Module["_emscripten_bind_GCPnts_TangentialDeflection_Parameter_1"]=function(){return(_emscripten_bind_GCPnts_TangentialDeflection_Parameter_1=Module["_emscripten_bind_GCPnts_TangentialDeflection_Parameter_1"]=Module["asm"]["iq"]).apply(null,arguments)};var _emscripten_bind_GCPnts_TangentialDeflection_Value_1=Module["_emscripten_bind_GCPnts_TangentialDeflection_Value_1"]=function(){return(_emscripten_bind_GCPnts_TangentialDeflection_Value_1=Module["_emscripten_bind_GCPnts_TangentialDeflection_Value_1"]=Module["asm"]["jq"]).apply(null,arguments)};var _emscripten_bind_GCPnts_TangentialDeflection_ArcAngularStep_4=Module["_emscripten_bind_GCPnts_TangentialDeflection_ArcAngularStep_4"]=function(){return(_emscripten_bind_GCPnts_TangentialDeflection_ArcAngularStep_4=Module["_emscripten_bind_GCPnts_TangentialDeflection_ArcAngularStep_4"]=Module["asm"]["kq"]).apply(null,arguments)};var _emscripten_bind_GCPnts_TangentialDeflection___destroy___0=Module["_emscripten_bind_GCPnts_TangentialDeflection___destroy___0"]=function(){return(_emscripten_bind_GCPnts_TangentialDeflection___destroy___0=Module["_emscripten_bind_GCPnts_TangentialDeflection___destroy___0"]=Module["asm"]["lq"]).apply(null,arguments)};var _emscripten_bind_BRep_Tool_IsClosed_1=Module["_emscripten_bind_BRep_Tool_IsClosed_1"]=function(){return(_emscripten_bind_BRep_Tool_IsClosed_1=Module["_emscripten_bind_BRep_Tool_IsClosed_1"]=Module["asm"]["mq"]).apply(null,arguments)};var _emscripten_bind_BRep_Tool_IsClosed_2=Module["_emscripten_bind_BRep_Tool_IsClosed_2"]=function(){return(_emscripten_bind_BRep_Tool_IsClosed_2=Module["_emscripten_bind_BRep_Tool_IsClosed_2"]=Module["asm"]["nq"]).apply(null,arguments)};var _emscripten_bind_BRep_Tool_IsClosed_3=Module["_emscripten_bind_BRep_Tool_IsClosed_3"]=function(){return(_emscripten_bind_BRep_Tool_IsClosed_3=Module["_emscripten_bind_BRep_Tool_IsClosed_3"]=Module["asm"]["oq"]).apply(null,arguments)};var _emscripten_bind_BRep_Tool_Surface_1=Module["_emscripten_bind_BRep_Tool_Surface_1"]=function(){return(_emscripten_bind_BRep_Tool_Surface_1=Module["_emscripten_bind_BRep_Tool_Surface_1"]=Module["asm"]["pq"]).apply(null,arguments)};var _emscripten_bind_BRep_Tool_Triangulation_2=Module["_emscripten_bind_BRep_Tool_Triangulation_2"]=function(){return(_emscripten_bind_BRep_Tool_Triangulation_2=Module["_emscripten_bind_BRep_Tool_Triangulation_2"]=Module["asm"]["qq"]).apply(null,arguments)};var _emscripten_bind_BRep_Tool_Tolerance_1=Module["_emscripten_bind_BRep_Tool_Tolerance_1"]=function(){return(_emscripten_bind_BRep_Tool_Tolerance_1=Module["_emscripten_bind_BRep_Tool_Tolerance_1"]=Module["asm"]["rq"]).apply(null,arguments)};var _emscripten_bind_BRep_Tool_NaturalRestriction_1=Module["_emscripten_bind_BRep_Tool_NaturalRestriction_1"]=function(){return(_emscripten_bind_BRep_Tool_NaturalRestriction_1=Module["_emscripten_bind_BRep_Tool_NaturalRestriction_1"]=Module["asm"]["sq"]).apply(null,arguments)};var _emscripten_bind_BRep_Tool_IsGeometric_1=Module["_emscripten_bind_BRep_Tool_IsGeometric_1"]=function(){return(_emscripten_bind_BRep_Tool_IsGeometric_1=Module["_emscripten_bind_BRep_Tool_IsGeometric_1"]=Module["asm"]["tq"]).apply(null,arguments)};var _emscripten_bind_BRep_Tool_Curve_4=Module["_emscripten_bind_BRep_Tool_Curve_4"]=function(){return(_emscripten_bind_BRep_Tool_Curve_4=Module["_emscripten_bind_BRep_Tool_Curve_4"]=Module["asm"]["uq"]).apply(null,arguments)};var _emscripten_bind_BRep_Tool_Polygon3D_2=Module["_emscripten_bind_BRep_Tool_Polygon3D_2"]=function(){return(_emscripten_bind_BRep_Tool_Polygon3D_2=Module["_emscripten_bind_BRep_Tool_Polygon3D_2"]=Module["asm"]["vq"]).apply(null,arguments)};var _emscripten_bind_BRep_Tool_PolygonOnTriangulation_3=Module["_emscripten_bind_BRep_Tool_PolygonOnTriangulation_3"]=function(){return(_emscripten_bind_BRep_Tool_PolygonOnTriangulation_3=Module["_emscripten_bind_BRep_Tool_PolygonOnTriangulation_3"]=Module["asm"]["wq"]).apply(null,arguments)};var _emscripten_bind_BRep_Tool_SameParameter_1=Module["_emscripten_bind_BRep_Tool_SameParameter_1"]=function(){return(_emscripten_bind_BRep_Tool_SameParameter_1=Module["_emscripten_bind_BRep_Tool_SameParameter_1"]=Module["asm"]["xq"]).apply(null,arguments)};var _emscripten_bind_BRep_Tool_SameRange_1=Module["_emscripten_bind_BRep_Tool_SameRange_1"]=function(){return(_emscripten_bind_BRep_Tool_SameRange_1=Module["_emscripten_bind_BRep_Tool_SameRange_1"]=Module["asm"]["yq"]).apply(null,arguments)};var _emscripten_bind_BRep_Tool_Degenerated_1=Module["_emscripten_bind_BRep_Tool_Degenerated_1"]=function(){return(_emscripten_bind_BRep_Tool_Degenerated_1=Module["_emscripten_bind_BRep_Tool_Degenerated_1"]=Module["asm"]["zq"]).apply(null,arguments)};var _emscripten_bind_BRep_Tool_Range_3=Module["_emscripten_bind_BRep_Tool_Range_3"]=function(){return(_emscripten_bind_BRep_Tool_Range_3=Module["_emscripten_bind_BRep_Tool_Range_3"]=Module["asm"]["Aq"]).apply(null,arguments)};var _emscripten_bind_BRep_Tool_Range_4=Module["_emscripten_bind_BRep_Tool_Range_4"]=function(){return(_emscripten_bind_BRep_Tool_Range_4=Module["_emscripten_bind_BRep_Tool_Range_4"]=Module["asm"]["Bq"]).apply(null,arguments)};var _emscripten_bind_BRep_Tool_HasContinuity_1=Module["_emscripten_bind_BRep_Tool_HasContinuity_1"]=function(){return(_emscripten_bind_BRep_Tool_HasContinuity_1=Module["_emscripten_bind_BRep_Tool_HasContinuity_1"]=Module["asm"]["Cq"]).apply(null,arguments)};var _emscripten_bind_BRep_Tool_HasContinuity_3=Module["_emscripten_bind_BRep_Tool_HasContinuity_3"]=function(){return(_emscripten_bind_BRep_Tool_HasContinuity_3=Module["_emscripten_bind_BRep_Tool_HasContinuity_3"]=Module["asm"]["Dq"]).apply(null,arguments)};var _emscripten_bind_BRep_Tool_Parameter_2=Module["_emscripten_bind_BRep_Tool_Parameter_2"]=function(){return(_emscripten_bind_BRep_Tool_Parameter_2=Module["_emscripten_bind_BRep_Tool_Parameter_2"]=Module["asm"]["Eq"]).apply(null,arguments)};var _emscripten_bind_BRep_Tool_Parameter_3=Module["_emscripten_bind_BRep_Tool_Parameter_3"]=function(){return(_emscripten_bind_BRep_Tool_Parameter_3=Module["_emscripten_bind_BRep_Tool_Parameter_3"]=Module["asm"]["Fq"]).apply(null,arguments)};var _emscripten_bind_BRep_Tool_Pnt_1=Module["_emscripten_bind_BRep_Tool_Pnt_1"]=function(){return(_emscripten_bind_BRep_Tool_Pnt_1=Module["_emscripten_bind_BRep_Tool_Pnt_1"]=Module["asm"]["Gq"]).apply(null,arguments)};var _emscripten_bind_BRep_Tool_Parameters_2=Module["_emscripten_bind_BRep_Tool_Parameters_2"]=function(){return(_emscripten_bind_BRep_Tool_Parameters_2=Module["_emscripten_bind_BRep_Tool_Parameters_2"]=Module["asm"]["Hq"]).apply(null,arguments)};var _emscripten_bind_BRep_Tool_MaxTolerance_2=Module["_emscripten_bind_BRep_Tool_MaxTolerance_2"]=function(){return(_emscripten_bind_BRep_Tool_MaxTolerance_2=Module["_emscripten_bind_BRep_Tool_MaxTolerance_2"]=Module["asm"]["Iq"]).apply(null,arguments)};var _emscripten_bind_BRep_Tool___destroy___0=Module["_emscripten_bind_BRep_Tool___destroy___0"]=function(){return(_emscripten_bind_BRep_Tool___destroy___0=Module["_emscripten_bind_BRep_Tool___destroy___0"]=Module["asm"]["Jq"]).apply(null,arguments)};var _emscripten_bind_BRepMesh_IncrementalMesh_BRepMesh_IncrementalMesh_0=Module["_emscripten_bind_BRepMesh_IncrementalMesh_BRepMesh_IncrementalMesh_0"]=function(){return(_emscripten_bind_BRepMesh_IncrementalMesh_BRepMesh_IncrementalMesh_0=Module["_emscripten_bind_BRepMesh_IncrementalMesh_BRepMesh_IncrementalMesh_0"]=Module["asm"]["Kq"]).apply(null,arguments)};var _emscripten_bind_BRepMesh_IncrementalMesh_BRepMesh_IncrementalMesh_2=Module["_emscripten_bind_BRepMesh_IncrementalMesh_BRepMesh_IncrementalMesh_2"]=function(){return(_emscripten_bind_BRepMesh_IncrementalMesh_BRepMesh_IncrementalMesh_2=Module["_emscripten_bind_BRepMesh_IncrementalMesh_BRepMesh_IncrementalMesh_2"]=Module["asm"]["Lq"]).apply(null,arguments)};var _emscripten_bind_BRepMesh_IncrementalMesh_BRepMesh_IncrementalMesh_3=Module["_emscripten_bind_BRepMesh_IncrementalMesh_BRepMesh_IncrementalMesh_3"]=function(){return(_emscripten_bind_BRepMesh_IncrementalMesh_BRepMesh_IncrementalMesh_3=Module["_emscripten_bind_BRepMesh_IncrementalMesh_BRepMesh_IncrementalMesh_3"]=Module["asm"]["Mq"]).apply(null,arguments)};var _emscripten_bind_BRepMesh_IncrementalMesh_BRepMesh_IncrementalMesh_4=Module["_emscripten_bind_BRepMesh_IncrementalMesh_BRepMesh_IncrementalMesh_4"]=function(){return(_emscripten_bind_BRepMesh_IncrementalMesh_BRepMesh_IncrementalMesh_4=Module["_emscripten_bind_BRepMesh_IncrementalMesh_BRepMesh_IncrementalMesh_4"]=Module["asm"]["Nq"]).apply(null,arguments)};var _emscripten_bind_BRepMesh_IncrementalMesh___destroy___0=Module["_emscripten_bind_BRepMesh_IncrementalMesh___destroy___0"]=function(){return(_emscripten_bind_BRepMesh_IncrementalMesh___destroy___0=Module["_emscripten_bind_BRepMesh_IncrementalMesh___destroy___0"]=Module["asm"]["Oq"]).apply(null,arguments)};var _emscripten_bind_Geom_Hyperbola_Geom_Hyperbola_1=Module["_emscripten_bind_Geom_Hyperbola_Geom_Hyperbola_1"]=function(){return(_emscripten_bind_Geom_Hyperbola_Geom_Hyperbola_1=Module["_emscripten_bind_Geom_Hyperbola_Geom_Hyperbola_1"]=Module["asm"]["Pq"]).apply(null,arguments)};var _emscripten_bind_Geom_Hyperbola_Geom_Hyperbola_3=Module["_emscripten_bind_Geom_Hyperbola_Geom_Hyperbola_3"]=function(){return(_emscripten_bind_Geom_Hyperbola_Geom_Hyperbola_3=Module["_emscripten_bind_Geom_Hyperbola_Geom_Hyperbola_3"]=Module["asm"]["Qq"]).apply(null,arguments)};var _emscripten_bind_Geom_Hyperbola_MajorRadius_0=Module["_emscripten_bind_Geom_Hyperbola_MajorRadius_0"]=function(){return(_emscripten_bind_Geom_Hyperbola_MajorRadius_0=Module["_emscripten_bind_Geom_Hyperbola_MajorRadius_0"]=Module["asm"]["Rq"]).apply(null,arguments)};var _emscripten_bind_Geom_Hyperbola_MinorRadius_0=Module["_emscripten_bind_Geom_Hyperbola_MinorRadius_0"]=function(){return(_emscripten_bind_Geom_Hyperbola_MinorRadius_0=Module["_emscripten_bind_Geom_Hyperbola_MinorRadius_0"]=Module["asm"]["Sq"]).apply(null,arguments)};var _emscripten_bind_Geom_Hyperbola_Reverse_0=Module["_emscripten_bind_Geom_Hyperbola_Reverse_0"]=function(){return(_emscripten_bind_Geom_Hyperbola_Reverse_0=Module["_emscripten_bind_Geom_Hyperbola_Reverse_0"]=Module["asm"]["Tq"]).apply(null,arguments)};var _emscripten_bind_Geom_Hyperbola_ReversedParameter_1=Module["_emscripten_bind_Geom_Hyperbola_ReversedParameter_1"]=function(){return(_emscripten_bind_Geom_Hyperbola_ReversedParameter_1=Module["_emscripten_bind_Geom_Hyperbola_ReversedParameter_1"]=Module["asm"]["Uq"]).apply(null,arguments)};var _emscripten_bind_Geom_Hyperbola_TransformedParameter_2=Module["_emscripten_bind_Geom_Hyperbola_TransformedParameter_2"]=function(){return(_emscripten_bind_Geom_Hyperbola_TransformedParameter_2=Module["_emscripten_bind_Geom_Hyperbola_TransformedParameter_2"]=Module["asm"]["Vq"]).apply(null,arguments)};var _emscripten_bind_Geom_Hyperbola_ParametricTransformation_1=Module["_emscripten_bind_Geom_Hyperbola_ParametricTransformation_1"]=function(){return(_emscripten_bind_Geom_Hyperbola_ParametricTransformation_1=Module["_emscripten_bind_Geom_Hyperbola_ParametricTransformation_1"]=Module["asm"]["Wq"]).apply(null,arguments)};var _emscripten_bind_Geom_Hyperbola_Reversed_0=Module["_emscripten_bind_Geom_Hyperbola_Reversed_0"]=function(){return(_emscripten_bind_Geom_Hyperbola_Reversed_0=Module["_emscripten_bind_Geom_Hyperbola_Reversed_0"]=Module["asm"]["Xq"]).apply(null,arguments)};var _emscripten_bind_Geom_Hyperbola_FirstParameter_0=Module["_emscripten_bind_Geom_Hyperbola_FirstParameter_0"]=function(){return(_emscripten_bind_Geom_Hyperbola_FirstParameter_0=Module["_emscripten_bind_Geom_Hyperbola_FirstParameter_0"]=Module["asm"]["Yq"]).apply(null,arguments)};var _emscripten_bind_Geom_Hyperbola_LastParameter_0=Module["_emscripten_bind_Geom_Hyperbola_LastParameter_0"]=function(){return(_emscripten_bind_Geom_Hyperbola_LastParameter_0=Module["_emscripten_bind_Geom_Hyperbola_LastParameter_0"]=Module["asm"]["Zq"]).apply(null,arguments)};var _emscripten_bind_Geom_Hyperbola_IsClosed_0=Module["_emscripten_bind_Geom_Hyperbola_IsClosed_0"]=function(){return(_emscripten_bind_Geom_Hyperbola_IsClosed_0=Module["_emscripten_bind_Geom_Hyperbola_IsClosed_0"]=Module["asm"]["_q"]).apply(null,arguments)};var _emscripten_bind_Geom_Hyperbola_IsPeriodic_0=Module["_emscripten_bind_Geom_Hyperbola_IsPeriodic_0"]=function(){return(_emscripten_bind_Geom_Hyperbola_IsPeriodic_0=Module["_emscripten_bind_Geom_Hyperbola_IsPeriodic_0"]=Module["asm"]["$q"]).apply(null,arguments)};var _emscripten_bind_Geom_Hyperbola_Period_0=Module["_emscripten_bind_Geom_Hyperbola_Period_0"]=function(){return(_emscripten_bind_Geom_Hyperbola_Period_0=Module["_emscripten_bind_Geom_Hyperbola_Period_0"]=Module["asm"]["ar"]).apply(null,arguments)};var _emscripten_bind_Geom_Hyperbola_IsCN_1=Module["_emscripten_bind_Geom_Hyperbola_IsCN_1"]=function(){return(_emscripten_bind_Geom_Hyperbola_IsCN_1=Module["_emscripten_bind_Geom_Hyperbola_IsCN_1"]=Module["asm"]["br"]).apply(null,arguments)};var _emscripten_bind_Geom_Hyperbola_D0_2=Module["_emscripten_bind_Geom_Hyperbola_D0_2"]=function(){return(_emscripten_bind_Geom_Hyperbola_D0_2=Module["_emscripten_bind_Geom_Hyperbola_D0_2"]=Module["asm"]["cr"]).apply(null,arguments)};var _emscripten_bind_Geom_Hyperbola_D1_3=Module["_emscripten_bind_Geom_Hyperbola_D1_3"]=function(){return(_emscripten_bind_Geom_Hyperbola_D1_3=Module["_emscripten_bind_Geom_Hyperbola_D1_3"]=Module["asm"]["dr"]).apply(null,arguments)};var _emscripten_bind_Geom_Hyperbola_D2_4=Module["_emscripten_bind_Geom_Hyperbola_D2_4"]=function(){return(_emscripten_bind_Geom_Hyperbola_D2_4=Module["_emscripten_bind_Geom_Hyperbola_D2_4"]=Module["asm"]["er"]).apply(null,arguments)};var _emscripten_bind_Geom_Hyperbola_D3_5=Module["_emscripten_bind_Geom_Hyperbola_D3_5"]=function(){return(_emscripten_bind_Geom_Hyperbola_D3_5=Module["_emscripten_bind_Geom_Hyperbola_D3_5"]=Module["asm"]["fr"]).apply(null,arguments)};var _emscripten_bind_Geom_Hyperbola_DN_2=Module["_emscripten_bind_Geom_Hyperbola_DN_2"]=function(){return(_emscripten_bind_Geom_Hyperbola_DN_2=Module["_emscripten_bind_Geom_Hyperbola_DN_2"]=Module["asm"]["gr"]).apply(null,arguments)};var _emscripten_bind_Geom_Hyperbola_Value_1=Module["_emscripten_bind_Geom_Hyperbola_Value_1"]=function(){return(_emscripten_bind_Geom_Hyperbola_Value_1=Module["_emscripten_bind_Geom_Hyperbola_Value_1"]=Module["asm"]["hr"]).apply(null,arguments)};var _emscripten_bind_Geom_Hyperbola___destroy___0=Module["_emscripten_bind_Geom_Hyperbola___destroy___0"]=function(){return(_emscripten_bind_Geom_Hyperbola___destroy___0=Module["_emscripten_bind_Geom_Hyperbola___destroy___0"]=Module["asm"]["ir"]).apply(null,arguments)};var _emscripten_bind_BRepAlgoAPI_Cut_BRepAlgoAPI_Cut_2=Module["_emscripten_bind_BRepAlgoAPI_Cut_BRepAlgoAPI_Cut_2"]=function(){return(_emscripten_bind_BRepAlgoAPI_Cut_BRepAlgoAPI_Cut_2=Module["_emscripten_bind_BRepAlgoAPI_Cut_BRepAlgoAPI_Cut_2"]=Module["asm"]["jr"]).apply(null,arguments)};var _emscripten_bind_BRepAlgoAPI_Cut_Shape_0=Module["_emscripten_bind_BRepAlgoAPI_Cut_Shape_0"]=function(){return(_emscripten_bind_BRepAlgoAPI_Cut_Shape_0=Module["_emscripten_bind_BRepAlgoAPI_Cut_Shape_0"]=Module["asm"]["kr"]).apply(null,arguments)};var _emscripten_bind_BRepAlgoAPI_Cut___destroy___0=Module["_emscripten_bind_BRepAlgoAPI_Cut___destroy___0"]=function(){return(_emscripten_bind_BRepAlgoAPI_Cut___destroy___0=Module["_emscripten_bind_BRepAlgoAPI_Cut___destroy___0"]=Module["asm"]["lr"]).apply(null,arguments)};var _emscripten_bind_Geom_BSplineCurve_Geom_BSplineCurve_5=Module["_emscripten_bind_Geom_BSplineCurve_Geom_BSplineCurve_5"]=function(){return(_emscripten_bind_Geom_BSplineCurve_Geom_BSplineCurve_5=Module["_emscripten_bind_Geom_BSplineCurve_Geom_BSplineCurve_5"]=Module["asm"]["mr"]).apply(null,arguments)};var _emscripten_bind_Geom_BSplineCurve_Geom_BSplineCurve_6=Module["_emscripten_bind_Geom_BSplineCurve_Geom_BSplineCurve_6"]=function(){return(_emscripten_bind_Geom_BSplineCurve_Geom_BSplineCurve_6=Module["_emscripten_bind_Geom_BSplineCurve_Geom_BSplineCurve_6"]=Module["asm"]["nr"]).apply(null,arguments)};var _emscripten_bind_Geom_BSplineCurve_Geom_BSplineCurve_7=Module["_emscripten_bind_Geom_BSplineCurve_Geom_BSplineCurve_7"]=function(){return(_emscripten_bind_Geom_BSplineCurve_Geom_BSplineCurve_7=Module["_emscripten_bind_Geom_BSplineCurve_Geom_BSplineCurve_7"]=Module["asm"]["or"]).apply(null,arguments)};var _emscripten_bind_Geom_BSplineCurve_Reverse_0=Module["_emscripten_bind_Geom_BSplineCurve_Reverse_0"]=function(){return(_emscripten_bind_Geom_BSplineCurve_Reverse_0=Module["_emscripten_bind_Geom_BSplineCurve_Reverse_0"]=Module["asm"]["pr"]).apply(null,arguments)};var _emscripten_bind_Geom_BSplineCurve_ReversedParameter_1=Module["_emscripten_bind_Geom_BSplineCurve_ReversedParameter_1"]=function(){return(_emscripten_bind_Geom_BSplineCurve_ReversedParameter_1=Module["_emscripten_bind_Geom_BSplineCurve_ReversedParameter_1"]=Module["asm"]["qr"]).apply(null,arguments)};var _emscripten_bind_Geom_BSplineCurve_IsCN_1=Module["_emscripten_bind_Geom_BSplineCurve_IsCN_1"]=function(){return(_emscripten_bind_Geom_BSplineCurve_IsCN_1=Module["_emscripten_bind_Geom_BSplineCurve_IsCN_1"]=Module["asm"]["rr"]).apply(null,arguments)};var _emscripten_bind_Geom_BSplineCurve_FirstParameter_0=Module["_emscripten_bind_Geom_BSplineCurve_FirstParameter_0"]=function(){return(_emscripten_bind_Geom_BSplineCurve_FirstParameter_0=Module["_emscripten_bind_Geom_BSplineCurve_FirstParameter_0"]=Module["asm"]["sr"]).apply(null,arguments)};var _emscripten_bind_Geom_BSplineCurve_IsClosed_0=Module["_emscripten_bind_Geom_BSplineCurve_IsClosed_0"]=function(){return(_emscripten_bind_Geom_BSplineCurve_IsClosed_0=Module["_emscripten_bind_Geom_BSplineCurve_IsClosed_0"]=Module["asm"]["tr"]).apply(null,arguments)};var _emscripten_bind_Geom_BSplineCurve_IsPeriodic_0=Module["_emscripten_bind_Geom_BSplineCurve_IsPeriodic_0"]=function(){return(_emscripten_bind_Geom_BSplineCurve_IsPeriodic_0=Module["_emscripten_bind_Geom_BSplineCurve_IsPeriodic_0"]=Module["asm"]["ur"]).apply(null,arguments)};var _emscripten_bind_Geom_BSplineCurve_Period_0=Module["_emscripten_bind_Geom_BSplineCurve_Period_0"]=function(){return(_emscripten_bind_Geom_BSplineCurve_Period_0=Module["_emscripten_bind_Geom_BSplineCurve_Period_0"]=Module["asm"]["vr"]).apply(null,arguments)};var _emscripten_bind_Geom_BSplineCurve_LastParameter_0=Module["_emscripten_bind_Geom_BSplineCurve_LastParameter_0"]=function(){return(_emscripten_bind_Geom_BSplineCurve_LastParameter_0=Module["_emscripten_bind_Geom_BSplineCurve_LastParameter_0"]=Module["asm"]["wr"]).apply(null,arguments)};var _emscripten_bind_Geom_BSplineCurve_StartPoint_0=Module["_emscripten_bind_Geom_BSplineCurve_StartPoint_0"]=function(){return(_emscripten_bind_Geom_BSplineCurve_StartPoint_0=Module["_emscripten_bind_Geom_BSplineCurve_StartPoint_0"]=Module["asm"]["xr"]).apply(null,arguments)};var _emscripten_bind_Geom_BSplineCurve_D0_2=Module["_emscripten_bind_Geom_BSplineCurve_D0_2"]=function(){return(_emscripten_bind_Geom_BSplineCurve_D0_2=Module["_emscripten_bind_Geom_BSplineCurve_D0_2"]=Module["asm"]["yr"]).apply(null,arguments)};var _emscripten_bind_Geom_BSplineCurve_D1_3=Module["_emscripten_bind_Geom_BSplineCurve_D1_3"]=function(){return(_emscripten_bind_Geom_BSplineCurve_D1_3=Module["_emscripten_bind_Geom_BSplineCurve_D1_3"]=Module["asm"]["zr"]).apply(null,arguments)};var _emscripten_bind_Geom_BSplineCurve_D2_4=Module["_emscripten_bind_Geom_BSplineCurve_D2_4"]=function(){return(_emscripten_bind_Geom_BSplineCurve_D2_4=Module["_emscripten_bind_Geom_BSplineCurve_D2_4"]=Module["asm"]["Ar"]).apply(null,arguments)};var _emscripten_bind_Geom_BSplineCurve_D3_5=Module["_emscripten_bind_Geom_BSplineCurve_D3_5"]=function(){return(_emscripten_bind_Geom_BSplineCurve_D3_5=Module["_emscripten_bind_Geom_BSplineCurve_D3_5"]=Module["asm"]["Br"]).apply(null,arguments)};var _emscripten_bind_Geom_BSplineCurve_DN_2=Module["_emscripten_bind_Geom_BSplineCurve_DN_2"]=function(){return(_emscripten_bind_Geom_BSplineCurve_DN_2=Module["_emscripten_bind_Geom_BSplineCurve_DN_2"]=Module["asm"]["Cr"]).apply(null,arguments)};var _emscripten_bind_Geom_BSplineCurve_Transform_1=Module["_emscripten_bind_Geom_BSplineCurve_Transform_1"]=function(){return(_emscripten_bind_Geom_BSplineCurve_Transform_1=Module["_emscripten_bind_Geom_BSplineCurve_Transform_1"]=Module["asm"]["Dr"]).apply(null,arguments)};var _emscripten_bind_Geom_BSplineCurve_Reversed_0=Module["_emscripten_bind_Geom_BSplineCurve_Reversed_0"]=function(){return(_emscripten_bind_Geom_BSplineCurve_Reversed_0=Module["_emscripten_bind_Geom_BSplineCurve_Reversed_0"]=Module["asm"]["Er"]).apply(null,arguments)};var _emscripten_bind_Geom_BSplineCurve_Value_1=Module["_emscripten_bind_Geom_BSplineCurve_Value_1"]=function(){return(_emscripten_bind_Geom_BSplineCurve_Value_1=Module["_emscripten_bind_Geom_BSplineCurve_Value_1"]=Module["asm"]["Fr"]).apply(null,arguments)};var _emscripten_bind_Geom_BSplineCurve___destroy___0=Module["_emscripten_bind_Geom_BSplineCurve___destroy___0"]=function(){return(_emscripten_bind_Geom_BSplineCurve___destroy___0=Module["_emscripten_bind_Geom_BSplineCurve___destroy___0"]=Module["asm"]["Gr"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_TrimmedCurve_Handle_Geom_TrimmedCurve_0=Module["_emscripten_bind_Handle_Geom_TrimmedCurve_Handle_Geom_TrimmedCurve_0"]=function(){return(_emscripten_bind_Handle_Geom_TrimmedCurve_Handle_Geom_TrimmedCurve_0=Module["_emscripten_bind_Handle_Geom_TrimmedCurve_Handle_Geom_TrimmedCurve_0"]=Module["asm"]["Hr"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_TrimmedCurve_Handle_Geom_TrimmedCurve_1=Module["_emscripten_bind_Handle_Geom_TrimmedCurve_Handle_Geom_TrimmedCurve_1"]=function(){return(_emscripten_bind_Handle_Geom_TrimmedCurve_Handle_Geom_TrimmedCurve_1=Module["_emscripten_bind_Handle_Geom_TrimmedCurve_Handle_Geom_TrimmedCurve_1"]=Module["asm"]["Ir"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_TrimmedCurve_IsNull_0=Module["_emscripten_bind_Handle_Geom_TrimmedCurve_IsNull_0"]=function(){return(_emscripten_bind_Handle_Geom_TrimmedCurve_IsNull_0=Module["_emscripten_bind_Handle_Geom_TrimmedCurve_IsNull_0"]=Module["asm"]["Jr"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_TrimmedCurve_Nullify_0=Module["_emscripten_bind_Handle_Geom_TrimmedCurve_Nullify_0"]=function(){return(_emscripten_bind_Handle_Geom_TrimmedCurve_Nullify_0=Module["_emscripten_bind_Handle_Geom_TrimmedCurve_Nullify_0"]=Module["asm"]["Kr"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_TrimmedCurve_get_0=Module["_emscripten_bind_Handle_Geom_TrimmedCurve_get_0"]=function(){return(_emscripten_bind_Handle_Geom_TrimmedCurve_get_0=Module["_emscripten_bind_Handle_Geom_TrimmedCurve_get_0"]=Module["asm"]["Lr"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_TrimmedCurve___destroy___0=Module["_emscripten_bind_Handle_Geom_TrimmedCurve___destroy___0"]=function(){return(_emscripten_bind_Handle_Geom_TrimmedCurve___destroy___0=Module["_emscripten_bind_Handle_Geom_TrimmedCurve___destroy___0"]=Module["asm"]["Mr"]).apply(null,arguments)};var _emscripten_bind_GC_MakeCircle_GC_MakeCircle_1=Module["_emscripten_bind_GC_MakeCircle_GC_MakeCircle_1"]=function(){return(_emscripten_bind_GC_MakeCircle_GC_MakeCircle_1=Module["_emscripten_bind_GC_MakeCircle_GC_MakeCircle_1"]=Module["asm"]["Nr"]).apply(null,arguments)};var _emscripten_bind_GC_MakeCircle_GC_MakeCircle_2=Module["_emscripten_bind_GC_MakeCircle_GC_MakeCircle_2"]=function(){return(_emscripten_bind_GC_MakeCircle_GC_MakeCircle_2=Module["_emscripten_bind_GC_MakeCircle_GC_MakeCircle_2"]=Module["asm"]["Or"]).apply(null,arguments)};var _emscripten_bind_GC_MakeCircle_Value_0=Module["_emscripten_bind_GC_MakeCircle_Value_0"]=function(){return(_emscripten_bind_GC_MakeCircle_Value_0=Module["_emscripten_bind_GC_MakeCircle_Value_0"]=Module["asm"]["Pr"]).apply(null,arguments)};var _emscripten_bind_GC_MakeCircle___destroy___0=Module["_emscripten_bind_GC_MakeCircle___destroy___0"]=function(){return(_emscripten_bind_GC_MakeCircle___destroy___0=Module["_emscripten_bind_GC_MakeCircle___destroy___0"]=Module["asm"]["Qr"]).apply(null,arguments)};var _emscripten_bind_Geom_CylindricalSurface_Geom_CylindricalSurface_2=Module["_emscripten_bind_Geom_CylindricalSurface_Geom_CylindricalSurface_2"]=function(){return(_emscripten_bind_Geom_CylindricalSurface_Geom_CylindricalSurface_2=Module["_emscripten_bind_Geom_CylindricalSurface_Geom_CylindricalSurface_2"]=Module["asm"]["Rr"]).apply(null,arguments)};var _emscripten_bind_Geom_CylindricalSurface___destroy___0=Module["_emscripten_bind_Geom_CylindricalSurface___destroy___0"]=function(){return(_emscripten_bind_Geom_CylindricalSurface___destroy___0=Module["_emscripten_bind_Geom_CylindricalSurface___destroy___0"]=Module["asm"]["Sr"]).apply(null,arguments)};var _emscripten_bind_GC_MakeHyperbola_GC_MakeHyperbola_1=Module["_emscripten_bind_GC_MakeHyperbola_GC_MakeHyperbola_1"]=function(){return(_emscripten_bind_GC_MakeHyperbola_GC_MakeHyperbola_1=Module["_emscripten_bind_GC_MakeHyperbola_GC_MakeHyperbola_1"]=Module["asm"]["Tr"]).apply(null,arguments)};var _emscripten_bind_GC_MakeHyperbola_GC_MakeHyperbola_3=Module["_emscripten_bind_GC_MakeHyperbola_GC_MakeHyperbola_3"]=function(){return(_emscripten_bind_GC_MakeHyperbola_GC_MakeHyperbola_3=Module["_emscripten_bind_GC_MakeHyperbola_GC_MakeHyperbola_3"]=Module["asm"]["Ur"]).apply(null,arguments)};var _emscripten_bind_GC_MakeHyperbola_Value_0=Module["_emscripten_bind_GC_MakeHyperbola_Value_0"]=function(){return(_emscripten_bind_GC_MakeHyperbola_Value_0=Module["_emscripten_bind_GC_MakeHyperbola_Value_0"]=Module["asm"]["Vr"]).apply(null,arguments)};var _emscripten_bind_GC_MakeHyperbola___destroy___0=Module["_emscripten_bind_GC_MakeHyperbola___destroy___0"]=function(){return(_emscripten_bind_GC_MakeHyperbola___destroy___0=Module["_emscripten_bind_GC_MakeHyperbola___destroy___0"]=Module["asm"]["Wr"]).apply(null,arguments)};var _emscripten_bind_BRepPrim_Sphere___destroy___0=Module["_emscripten_bind_BRepPrim_Sphere___destroy___0"]=function(){return(_emscripten_bind_BRepPrim_Sphere___destroy___0=Module["_emscripten_bind_BRepPrim_Sphere___destroy___0"]=Module["asm"]["Xr"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shell_ShapeFix_Shell_0=Module["_emscripten_bind_ShapeFix_Shell_ShapeFix_Shell_0"]=function(){return(_emscripten_bind_ShapeFix_Shell_ShapeFix_Shell_0=Module["_emscripten_bind_ShapeFix_Shell_ShapeFix_Shell_0"]=Module["asm"]["Yr"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shell_ShapeFix_Shell_1=Module["_emscripten_bind_ShapeFix_Shell_ShapeFix_Shell_1"]=function(){return(_emscripten_bind_ShapeFix_Shell_ShapeFix_Shell_1=Module["_emscripten_bind_ShapeFix_Shell_ShapeFix_Shell_1"]=Module["asm"]["Zr"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shell_Init_1=Module["_emscripten_bind_ShapeFix_Shell_Init_1"]=function(){return(_emscripten_bind_ShapeFix_Shell_Init_1=Module["_emscripten_bind_ShapeFix_Shell_Init_1"]=Module["asm"]["_r"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shell_Perform_0=Module["_emscripten_bind_ShapeFix_Shell_Perform_0"]=function(){return(_emscripten_bind_ShapeFix_Shell_Perform_0=Module["_emscripten_bind_ShapeFix_Shell_Perform_0"]=Module["asm"]["$r"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shell_Perform_1=Module["_emscripten_bind_ShapeFix_Shell_Perform_1"]=function(){return(_emscripten_bind_ShapeFix_Shell_Perform_1=Module["_emscripten_bind_ShapeFix_Shell_Perform_1"]=Module["asm"]["as"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shell_FixFaceOrientation_1=Module["_emscripten_bind_ShapeFix_Shell_FixFaceOrientation_1"]=function(){return(_emscripten_bind_ShapeFix_Shell_FixFaceOrientation_1=Module["_emscripten_bind_ShapeFix_Shell_FixFaceOrientation_1"]=Module["asm"]["bs"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shell_FixFaceOrientation_2=Module["_emscripten_bind_ShapeFix_Shell_FixFaceOrientation_2"]=function(){return(_emscripten_bind_ShapeFix_Shell_FixFaceOrientation_2=Module["_emscripten_bind_ShapeFix_Shell_FixFaceOrientation_2"]=Module["asm"]["cs"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shell_FixFaceOrientation_3=Module["_emscripten_bind_ShapeFix_Shell_FixFaceOrientation_3"]=function(){return(_emscripten_bind_ShapeFix_Shell_FixFaceOrientation_3=Module["_emscripten_bind_ShapeFix_Shell_FixFaceOrientation_3"]=Module["asm"]["ds"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shell_Shell_0=Module["_emscripten_bind_ShapeFix_Shell_Shell_0"]=function(){return(_emscripten_bind_ShapeFix_Shell_Shell_0=Module["_emscripten_bind_ShapeFix_Shell_Shell_0"]=Module["asm"]["es"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shell_Shape_0=Module["_emscripten_bind_ShapeFix_Shell_Shape_0"]=function(){return(_emscripten_bind_ShapeFix_Shell_Shape_0=Module["_emscripten_bind_ShapeFix_Shell_Shape_0"]=Module["asm"]["fs"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shell_NbShells_0=Module["_emscripten_bind_ShapeFix_Shell_NbShells_0"]=function(){return(_emscripten_bind_ShapeFix_Shell_NbShells_0=Module["_emscripten_bind_ShapeFix_Shell_NbShells_0"]=Module["asm"]["gs"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shell_ErrorFaces_0=Module["_emscripten_bind_ShapeFix_Shell_ErrorFaces_0"]=function(){return(_emscripten_bind_ShapeFix_Shell_ErrorFaces_0=Module["_emscripten_bind_ShapeFix_Shell_ErrorFaces_0"]=Module["asm"]["hs"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shell_Status_1=Module["_emscripten_bind_ShapeFix_Shell_Status_1"]=function(){return(_emscripten_bind_ShapeFix_Shell_Status_1=Module["_emscripten_bind_ShapeFix_Shell_Status_1"]=Module["asm"]["is"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shell_SetPrecision_1=Module["_emscripten_bind_ShapeFix_Shell_SetPrecision_1"]=function(){return(_emscripten_bind_ShapeFix_Shell_SetPrecision_1=Module["_emscripten_bind_ShapeFix_Shell_SetPrecision_1"]=Module["asm"]["js"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shell_SetMinTolerance_1=Module["_emscripten_bind_ShapeFix_Shell_SetMinTolerance_1"]=function(){return(_emscripten_bind_ShapeFix_Shell_SetMinTolerance_1=Module["_emscripten_bind_ShapeFix_Shell_SetMinTolerance_1"]=Module["asm"]["ks"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shell_SetMaxTolerance_1=Module["_emscripten_bind_ShapeFix_Shell_SetMaxTolerance_1"]=function(){return(_emscripten_bind_ShapeFix_Shell_SetMaxTolerance_1=Module["_emscripten_bind_ShapeFix_Shell_SetMaxTolerance_1"]=Module["asm"]["ls"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shell_FixFaceMode_0=Module["_emscripten_bind_ShapeFix_Shell_FixFaceMode_0"]=function(){return(_emscripten_bind_ShapeFix_Shell_FixFaceMode_0=Module["_emscripten_bind_ShapeFix_Shell_FixFaceMode_0"]=Module["asm"]["ms"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shell_FixOrientationMode_0=Module["_emscripten_bind_ShapeFix_Shell_FixOrientationMode_0"]=function(){return(_emscripten_bind_ShapeFix_Shell_FixOrientationMode_0=Module["_emscripten_bind_ShapeFix_Shell_FixOrientationMode_0"]=Module["asm"]["ns"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shell_SetNonManifoldFlag_1=Module["_emscripten_bind_ShapeFix_Shell_SetNonManifoldFlag_1"]=function(){return(_emscripten_bind_ShapeFix_Shell_SetNonManifoldFlag_1=Module["_emscripten_bind_ShapeFix_Shell_SetNonManifoldFlag_1"]=Module["asm"]["os"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Shell___destroy___0=Module["_emscripten_bind_ShapeFix_Shell___destroy___0"]=function(){return(_emscripten_bind_ShapeFix_Shell___destroy___0=Module["_emscripten_bind_ShapeFix_Shell___destroy___0"]=Module["asm"]["ps"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakePipe_BRepOffsetAPI_MakePipe_2=Module["_emscripten_bind_BRepOffsetAPI_MakePipe_BRepOffsetAPI_MakePipe_2"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakePipe_BRepOffsetAPI_MakePipe_2=Module["_emscripten_bind_BRepOffsetAPI_MakePipe_BRepOffsetAPI_MakePipe_2"]=Module["asm"]["qs"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakePipe_Build_0=Module["_emscripten_bind_BRepOffsetAPI_MakePipe_Build_0"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakePipe_Build_0=Module["_emscripten_bind_BRepOffsetAPI_MakePipe_Build_0"]=Module["asm"]["rs"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakePipe_Generated_2=Module["_emscripten_bind_BRepOffsetAPI_MakePipe_Generated_2"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakePipe_Generated_2=Module["_emscripten_bind_BRepOffsetAPI_MakePipe_Generated_2"]=Module["asm"]["ss"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakePipe_FirstShape_0=Module["_emscripten_bind_BRepOffsetAPI_MakePipe_FirstShape_0"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakePipe_FirstShape_0=Module["_emscripten_bind_BRepOffsetAPI_MakePipe_FirstShape_0"]=Module["asm"]["ts"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakePipe_LastShape_0=Module["_emscripten_bind_BRepOffsetAPI_MakePipe_LastShape_0"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakePipe_LastShape_0=Module["_emscripten_bind_BRepOffsetAPI_MakePipe_LastShape_0"]=Module["asm"]["us"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakePipe_ErrorOnSurface_0=Module["_emscripten_bind_BRepOffsetAPI_MakePipe_ErrorOnSurface_0"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakePipe_ErrorOnSurface_0=Module["_emscripten_bind_BRepOffsetAPI_MakePipe_ErrorOnSurface_0"]=Module["asm"]["vs"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakePipe_Shape_0=Module["_emscripten_bind_BRepOffsetAPI_MakePipe_Shape_0"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakePipe_Shape_0=Module["_emscripten_bind_BRepOffsetAPI_MakePipe_Shape_0"]=Module["asm"]["ws"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakePipe___destroy___0=Module["_emscripten_bind_BRepOffsetAPI_MakePipe___destroy___0"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakePipe___destroy___0=Module["_emscripten_bind_BRepOffsetAPI_MakePipe___destroy___0"]=Module["asm"]["xs"]).apply(null,arguments)};var _emscripten_bind_Handle_Transfer_TransientProcess_Handle_Transfer_TransientProcess_0=Module["_emscripten_bind_Handle_Transfer_TransientProcess_Handle_Transfer_TransientProcess_0"]=function(){return(_emscripten_bind_Handle_Transfer_TransientProcess_Handle_Transfer_TransientProcess_0=Module["_emscripten_bind_Handle_Transfer_TransientProcess_Handle_Transfer_TransientProcess_0"]=Module["asm"]["ys"]).apply(null,arguments)};var _emscripten_bind_Handle_Transfer_TransientProcess_Handle_Transfer_TransientProcess_1=Module["_emscripten_bind_Handle_Transfer_TransientProcess_Handle_Transfer_TransientProcess_1"]=function(){return(_emscripten_bind_Handle_Transfer_TransientProcess_Handle_Transfer_TransientProcess_1=Module["_emscripten_bind_Handle_Transfer_TransientProcess_Handle_Transfer_TransientProcess_1"]=Module["asm"]["zs"]).apply(null,arguments)};var _emscripten_bind_Handle_Transfer_TransientProcess_IsNull_0=Module["_emscripten_bind_Handle_Transfer_TransientProcess_IsNull_0"]=function(){return(_emscripten_bind_Handle_Transfer_TransientProcess_IsNull_0=Module["_emscripten_bind_Handle_Transfer_TransientProcess_IsNull_0"]=Module["asm"]["As"]).apply(null,arguments)};var _emscripten_bind_Handle_Transfer_TransientProcess_Nullify_0=Module["_emscripten_bind_Handle_Transfer_TransientProcess_Nullify_0"]=function(){return(_emscripten_bind_Handle_Transfer_TransientProcess_Nullify_0=Module["_emscripten_bind_Handle_Transfer_TransientProcess_Nullify_0"]=Module["asm"]["Bs"]).apply(null,arguments)};var _emscripten_bind_Handle_Transfer_TransientProcess_get_0=Module["_emscripten_bind_Handle_Transfer_TransientProcess_get_0"]=function(){return(_emscripten_bind_Handle_Transfer_TransientProcess_get_0=Module["_emscripten_bind_Handle_Transfer_TransientProcess_get_0"]=Module["asm"]["Cs"]).apply(null,arguments)};var _emscripten_bind_Handle_Transfer_TransientProcess___destroy___0=Module["_emscripten_bind_Handle_Transfer_TransientProcess___destroy___0"]=function(){return(_emscripten_bind_Handle_Transfer_TransientProcess___destroy___0=Module["_emscripten_bind_Handle_Transfer_TransientProcess___destroy___0"]=Module["asm"]["Ds"]).apply(null,arguments)};var _emscripten_bind_XSControl_WorkSession_XSControl_WorkSession_0=Module["_emscripten_bind_XSControl_WorkSession_XSControl_WorkSession_0"]=function(){return(_emscripten_bind_XSControl_WorkSession_XSControl_WorkSession_0=Module["_emscripten_bind_XSControl_WorkSession_XSControl_WorkSession_0"]=Module["asm"]["Es"]).apply(null,arguments)};var _emscripten_bind_XSControl_WorkSession_ClearData_1=Module["_emscripten_bind_XSControl_WorkSession_ClearData_1"]=function(){return(_emscripten_bind_XSControl_WorkSession_ClearData_1=Module["_emscripten_bind_XSControl_WorkSession_ClearData_1"]=Module["asm"]["Fs"]).apply(null,arguments)};var _emscripten_bind_XSControl_WorkSession_SelectNorm_1=Module["_emscripten_bind_XSControl_WorkSession_SelectNorm_1"]=function(){return(_emscripten_bind_XSControl_WorkSession_SelectNorm_1=Module["_emscripten_bind_XSControl_WorkSession_SelectNorm_1"]=Module["asm"]["Gs"]).apply(null,arguments)};var _emscripten_bind_XSControl_WorkSession_ClearContext_0=Module["_emscripten_bind_XSControl_WorkSession_ClearContext_0"]=function(){return(_emscripten_bind_XSControl_WorkSession_ClearContext_0=Module["_emscripten_bind_XSControl_WorkSession_ClearContext_0"]=Module["asm"]["Hs"]).apply(null,arguments)};var _emscripten_bind_XSControl_WorkSession_InitTransferReader_1=Module["_emscripten_bind_XSControl_WorkSession_InitTransferReader_1"]=function(){return(_emscripten_bind_XSControl_WorkSession_InitTransferReader_1=Module["_emscripten_bind_XSControl_WorkSession_InitTransferReader_1"]=Module["asm"]["Is"]).apply(null,arguments)};var _emscripten_bind_XSControl_WorkSession_MapReader_0=Module["_emscripten_bind_XSControl_WorkSession_MapReader_0"]=function(){return(_emscripten_bind_XSControl_WorkSession_MapReader_0=Module["_emscripten_bind_XSControl_WorkSession_MapReader_0"]=Module["asm"]["Js"]).apply(null,arguments)};var _emscripten_bind_XSControl_WorkSession_SetMapReader_1=Module["_emscripten_bind_XSControl_WorkSession_SetMapReader_1"]=function(){return(_emscripten_bind_XSControl_WorkSession_SetMapReader_1=Module["_emscripten_bind_XSControl_WorkSession_SetMapReader_1"]=Module["asm"]["Ks"]).apply(null,arguments)};var _emscripten_bind_XSControl_WorkSession_TransferReadRoots_0=Module["_emscripten_bind_XSControl_WorkSession_TransferReadRoots_0"]=function(){return(_emscripten_bind_XSControl_WorkSession_TransferReadRoots_0=Module["_emscripten_bind_XSControl_WorkSession_TransferReadRoots_0"]=Module["asm"]["Ls"]).apply(null,arguments)};var _emscripten_bind_XSControl_WorkSession_TransferWriteShape_1=Module["_emscripten_bind_XSControl_WorkSession_TransferWriteShape_1"]=function(){return(_emscripten_bind_XSControl_WorkSession_TransferWriteShape_1=Module["_emscripten_bind_XSControl_WorkSession_TransferWriteShape_1"]=Module["asm"]["Ms"]).apply(null,arguments)};var _emscripten_bind_XSControl_WorkSession_TransferWriteShape_2=Module["_emscripten_bind_XSControl_WorkSession_TransferWriteShape_2"]=function(){return(_emscripten_bind_XSControl_WorkSession_TransferWriteShape_2=Module["_emscripten_bind_XSControl_WorkSession_TransferWriteShape_2"]=Module["asm"]["Ns"]).apply(null,arguments)};var _emscripten_bind_XSControl_WorkSession___destroy___0=Module["_emscripten_bind_XSControl_WorkSession___destroy___0"]=function(){return(_emscripten_bind_XSControl_WorkSession___destroy___0=Module["_emscripten_bind_XSControl_WorkSession___destroy___0"]=Module["asm"]["Os"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Ellipse_Handle_Geom_Ellipse_0=Module["_emscripten_bind_Handle_Geom_Ellipse_Handle_Geom_Ellipse_0"]=function(){return(_emscripten_bind_Handle_Geom_Ellipse_Handle_Geom_Ellipse_0=Module["_emscripten_bind_Handle_Geom_Ellipse_Handle_Geom_Ellipse_0"]=Module["asm"]["Ps"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Ellipse_Handle_Geom_Ellipse_1=Module["_emscripten_bind_Handle_Geom_Ellipse_Handle_Geom_Ellipse_1"]=function(){return(_emscripten_bind_Handle_Geom_Ellipse_Handle_Geom_Ellipse_1=Module["_emscripten_bind_Handle_Geom_Ellipse_Handle_Geom_Ellipse_1"]=Module["asm"]["Qs"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Ellipse_IsNull_0=Module["_emscripten_bind_Handle_Geom_Ellipse_IsNull_0"]=function(){return(_emscripten_bind_Handle_Geom_Ellipse_IsNull_0=Module["_emscripten_bind_Handle_Geom_Ellipse_IsNull_0"]=Module["asm"]["Rs"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Ellipse_Nullify_0=Module["_emscripten_bind_Handle_Geom_Ellipse_Nullify_0"]=function(){return(_emscripten_bind_Handle_Geom_Ellipse_Nullify_0=Module["_emscripten_bind_Handle_Geom_Ellipse_Nullify_0"]=Module["asm"]["Ss"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Ellipse_get_0=Module["_emscripten_bind_Handle_Geom_Ellipse_get_0"]=function(){return(_emscripten_bind_Handle_Geom_Ellipse_get_0=Module["_emscripten_bind_Handle_Geom_Ellipse_get_0"]=Module["asm"]["Ts"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Ellipse___destroy___0=Module["_emscripten_bind_Handle_Geom_Ellipse___destroy___0"]=function(){return(_emscripten_bind_Handle_Geom_Ellipse___destroy___0=Module["_emscripten_bind_Handle_Geom_Ellipse___destroy___0"]=Module["asm"]["Us"]).apply(null,arguments)};var _emscripten_bind_GProp_GProps_GProp_GProps_0=Module["_emscripten_bind_GProp_GProps_GProp_GProps_0"]=function(){return(_emscripten_bind_GProp_GProps_GProp_GProps_0=Module["_emscripten_bind_GProp_GProps_GProp_GProps_0"]=Module["asm"]["Vs"]).apply(null,arguments)};var _emscripten_bind_GProp_GProps_GProp_GProps_1=Module["_emscripten_bind_GProp_GProps_GProp_GProps_1"]=function(){return(_emscripten_bind_GProp_GProps_GProp_GProps_1=Module["_emscripten_bind_GProp_GProps_GProp_GProps_1"]=Module["asm"]["Ws"]).apply(null,arguments)};var _emscripten_bind_GProp_GProps_Mass_0=Module["_emscripten_bind_GProp_GProps_Mass_0"]=function(){return(_emscripten_bind_GProp_GProps_Mass_0=Module["_emscripten_bind_GProp_GProps_Mass_0"]=Module["asm"]["Xs"]).apply(null,arguments)};var _emscripten_bind_GProp_GProps_CentreOfMass_0=Module["_emscripten_bind_GProp_GProps_CentreOfMass_0"]=function(){return(_emscripten_bind_GProp_GProps_CentreOfMass_0=Module["_emscripten_bind_GProp_GProps_CentreOfMass_0"]=Module["asm"]["Ys"]).apply(null,arguments)};var _emscripten_bind_GProp_GProps_MomentOfInertia_1=Module["_emscripten_bind_GProp_GProps_MomentOfInertia_1"]=function(){return(_emscripten_bind_GProp_GProps_MomentOfInertia_1=Module["_emscripten_bind_GProp_GProps_MomentOfInertia_1"]=Module["asm"]["Zs"]).apply(null,arguments)};var _emscripten_bind_GProp_GProps_RadiusOfGyration_1=Module["_emscripten_bind_GProp_GProps_RadiusOfGyration_1"]=function(){return(_emscripten_bind_GProp_GProps_RadiusOfGyration_1=Module["_emscripten_bind_GProp_GProps_RadiusOfGyration_1"]=Module["asm"]["_s"]).apply(null,arguments)};var _emscripten_bind_GProp_GProps_StaticMoments_3=Module["_emscripten_bind_GProp_GProps_StaticMoments_3"]=function(){return(_emscripten_bind_GProp_GProps_StaticMoments_3=Module["_emscripten_bind_GProp_GProps_StaticMoments_3"]=Module["asm"]["$s"]).apply(null,arguments)};var _emscripten_bind_GProp_GProps___destroy___0=Module["_emscripten_bind_GProp_GProps___destroy___0"]=function(){return(_emscripten_bind_GProp_GProps___destroy___0=Module["_emscripten_bind_GProp_GProps___destroy___0"]=Module["asm"]["at"]).apply(null,arguments)};var _emscripten_bind_Poly_PolygonOnTriangulation_Poly_PolygonOnTriangulation_1=Module["_emscripten_bind_Poly_PolygonOnTriangulation_Poly_PolygonOnTriangulation_1"]=function(){return(_emscripten_bind_Poly_PolygonOnTriangulation_Poly_PolygonOnTriangulation_1=Module["_emscripten_bind_Poly_PolygonOnTriangulation_Poly_PolygonOnTriangulation_1"]=Module["asm"]["bt"]).apply(null,arguments)};var _emscripten_bind_Poly_PolygonOnTriangulation_Poly_PolygonOnTriangulation_2=Module["_emscripten_bind_Poly_PolygonOnTriangulation_Poly_PolygonOnTriangulation_2"]=function(){return(_emscripten_bind_Poly_PolygonOnTriangulation_Poly_PolygonOnTriangulation_2=Module["_emscripten_bind_Poly_PolygonOnTriangulation_Poly_PolygonOnTriangulation_2"]=Module["asm"]["ct"]).apply(null,arguments)};var _emscripten_bind_Poly_PolygonOnTriangulation_Deflection_1=Module["_emscripten_bind_Poly_PolygonOnTriangulation_Deflection_1"]=function(){return(_emscripten_bind_Poly_PolygonOnTriangulation_Deflection_1=Module["_emscripten_bind_Poly_PolygonOnTriangulation_Deflection_1"]=Module["asm"]["dt"]).apply(null,arguments)};var _emscripten_bind_Poly_PolygonOnTriangulation_NbNodes_0=Module["_emscripten_bind_Poly_PolygonOnTriangulation_NbNodes_0"]=function(){return(_emscripten_bind_Poly_PolygonOnTriangulation_NbNodes_0=Module["_emscripten_bind_Poly_PolygonOnTriangulation_NbNodes_0"]=Module["asm"]["et"]).apply(null,arguments)};var _emscripten_bind_Poly_PolygonOnTriangulation_Nodes_0=Module["_emscripten_bind_Poly_PolygonOnTriangulation_Nodes_0"]=function(){return(_emscripten_bind_Poly_PolygonOnTriangulation_Nodes_0=Module["_emscripten_bind_Poly_PolygonOnTriangulation_Nodes_0"]=Module["asm"]["ft"]).apply(null,arguments)};var _emscripten_bind_Poly_PolygonOnTriangulation_HasParameters_0=Module["_emscripten_bind_Poly_PolygonOnTriangulation_HasParameters_0"]=function(){return(_emscripten_bind_Poly_PolygonOnTriangulation_HasParameters_0=Module["_emscripten_bind_Poly_PolygonOnTriangulation_HasParameters_0"]=Module["asm"]["gt"]).apply(null,arguments)};var _emscripten_bind_Poly_PolygonOnTriangulation___destroy___0=Module["_emscripten_bind_Poly_PolygonOnTriangulation___destroy___0"]=function(){return(_emscripten_bind_Poly_PolygonOnTriangulation___destroy___0=Module["_emscripten_bind_Poly_PolygonOnTriangulation___destroy___0"]=Module["asm"]["ht"]).apply(null,arguments)};var _emscripten_bind_Poly_Connect_Poly_Connect_0=Module["_emscripten_bind_Poly_Connect_Poly_Connect_0"]=function(){return(_emscripten_bind_Poly_Connect_Poly_Connect_0=Module["_emscripten_bind_Poly_Connect_Poly_Connect_0"]=Module["asm"]["it"]).apply(null,arguments)};var _emscripten_bind_Poly_Connect_Poly_Connect_1=Module["_emscripten_bind_Poly_Connect_Poly_Connect_1"]=function(){return(_emscripten_bind_Poly_Connect_Poly_Connect_1=Module["_emscripten_bind_Poly_Connect_Poly_Connect_1"]=Module["asm"]["jt"]).apply(null,arguments)};var _emscripten_bind_Poly_Connect_Load_1=Module["_emscripten_bind_Poly_Connect_Load_1"]=function(){return(_emscripten_bind_Poly_Connect_Load_1=Module["_emscripten_bind_Poly_Connect_Load_1"]=Module["asm"]["kt"]).apply(null,arguments)};var _emscripten_bind_Poly_Connect_Triangulation_0=Module["_emscripten_bind_Poly_Connect_Triangulation_0"]=function(){return(_emscripten_bind_Poly_Connect_Triangulation_0=Module["_emscripten_bind_Poly_Connect_Triangulation_0"]=Module["asm"]["lt"]).apply(null,arguments)};var _emscripten_bind_Poly_Connect_Triangle_1=Module["_emscripten_bind_Poly_Connect_Triangle_1"]=function(){return(_emscripten_bind_Poly_Connect_Triangle_1=Module["_emscripten_bind_Poly_Connect_Triangle_1"]=Module["asm"]["mt"]).apply(null,arguments)};var _emscripten_bind_Poly_Connect_Triangles_4=Module["_emscripten_bind_Poly_Connect_Triangles_4"]=function(){return(_emscripten_bind_Poly_Connect_Triangles_4=Module["_emscripten_bind_Poly_Connect_Triangles_4"]=Module["asm"]["nt"]).apply(null,arguments)};var _emscripten_bind_Poly_Connect_Nodes_4=Module["_emscripten_bind_Poly_Connect_Nodes_4"]=function(){return(_emscripten_bind_Poly_Connect_Nodes_4=Module["_emscripten_bind_Poly_Connect_Nodes_4"]=Module["asm"]["ot"]).apply(null,arguments)};var _emscripten_bind_Poly_Connect_Initialize_1=Module["_emscripten_bind_Poly_Connect_Initialize_1"]=function(){return(_emscripten_bind_Poly_Connect_Initialize_1=Module["_emscripten_bind_Poly_Connect_Initialize_1"]=Module["asm"]["pt"]).apply(null,arguments)};var _emscripten_bind_Poly_Connect_More_0=Module["_emscripten_bind_Poly_Connect_More_0"]=function(){return(_emscripten_bind_Poly_Connect_More_0=Module["_emscripten_bind_Poly_Connect_More_0"]=Module["asm"]["qt"]).apply(null,arguments)};var _emscripten_bind_Poly_Connect_Next_0=Module["_emscripten_bind_Poly_Connect_Next_0"]=function(){return(_emscripten_bind_Poly_Connect_Next_0=Module["_emscripten_bind_Poly_Connect_Next_0"]=Module["asm"]["rt"]).apply(null,arguments)};var _emscripten_bind_Poly_Connect_Value_0=Module["_emscripten_bind_Poly_Connect_Value_0"]=function(){return(_emscripten_bind_Poly_Connect_Value_0=Module["_emscripten_bind_Poly_Connect_Value_0"]=Module["asm"]["st"]).apply(null,arguments)};var _emscripten_bind_Poly_Connect___destroy___0=Module["_emscripten_bind_Poly_Connect___destroy___0"]=function(){return(_emscripten_bind_Poly_Connect___destroy___0=Module["_emscripten_bind_Poly_Connect___destroy___0"]=Module["asm"]["tt"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Circle_Handle_Geom_Circle_0=Module["_emscripten_bind_Handle_Geom_Circle_Handle_Geom_Circle_0"]=function(){return(_emscripten_bind_Handle_Geom_Circle_Handle_Geom_Circle_0=Module["_emscripten_bind_Handle_Geom_Circle_Handle_Geom_Circle_0"]=Module["asm"]["ut"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Circle_Handle_Geom_Circle_1=Module["_emscripten_bind_Handle_Geom_Circle_Handle_Geom_Circle_1"]=function(){return(_emscripten_bind_Handle_Geom_Circle_Handle_Geom_Circle_1=Module["_emscripten_bind_Handle_Geom_Circle_Handle_Geom_Circle_1"]=Module["asm"]["vt"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Circle_IsNull_0=Module["_emscripten_bind_Handle_Geom_Circle_IsNull_0"]=function(){return(_emscripten_bind_Handle_Geom_Circle_IsNull_0=Module["_emscripten_bind_Handle_Geom_Circle_IsNull_0"]=Module["asm"]["wt"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Circle_Nullify_0=Module["_emscripten_bind_Handle_Geom_Circle_Nullify_0"]=function(){return(_emscripten_bind_Handle_Geom_Circle_Nullify_0=Module["_emscripten_bind_Handle_Geom_Circle_Nullify_0"]=Module["asm"]["xt"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Circle_get_0=Module["_emscripten_bind_Handle_Geom_Circle_get_0"]=function(){return(_emscripten_bind_Handle_Geom_Circle_get_0=Module["_emscripten_bind_Handle_Geom_Circle_get_0"]=Module["asm"]["yt"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Circle___destroy___0=Module["_emscripten_bind_Handle_Geom_Circle___destroy___0"]=function(){return(_emscripten_bind_Handle_Geom_Circle___destroy___0=Module["_emscripten_bind_Handle_Geom_Circle___destroy___0"]=Module["asm"]["zt"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Hyperbola_Handle_Geom_Hyperbola_0=Module["_emscripten_bind_Handle_Geom_Hyperbola_Handle_Geom_Hyperbola_0"]=function(){return(_emscripten_bind_Handle_Geom_Hyperbola_Handle_Geom_Hyperbola_0=Module["_emscripten_bind_Handle_Geom_Hyperbola_Handle_Geom_Hyperbola_0"]=Module["asm"]["At"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Hyperbola_Handle_Geom_Hyperbola_1=Module["_emscripten_bind_Handle_Geom_Hyperbola_Handle_Geom_Hyperbola_1"]=function(){return(_emscripten_bind_Handle_Geom_Hyperbola_Handle_Geom_Hyperbola_1=Module["_emscripten_bind_Handle_Geom_Hyperbola_Handle_Geom_Hyperbola_1"]=Module["asm"]["Bt"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Hyperbola_IsNull_0=Module["_emscripten_bind_Handle_Geom_Hyperbola_IsNull_0"]=function(){return(_emscripten_bind_Handle_Geom_Hyperbola_IsNull_0=Module["_emscripten_bind_Handle_Geom_Hyperbola_IsNull_0"]=Module["asm"]["Ct"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Hyperbola_Nullify_0=Module["_emscripten_bind_Handle_Geom_Hyperbola_Nullify_0"]=function(){return(_emscripten_bind_Handle_Geom_Hyperbola_Nullify_0=Module["_emscripten_bind_Handle_Geom_Hyperbola_Nullify_0"]=Module["asm"]["Dt"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Hyperbola_get_0=Module["_emscripten_bind_Handle_Geom_Hyperbola_get_0"]=function(){return(_emscripten_bind_Handle_Geom_Hyperbola_get_0=Module["_emscripten_bind_Handle_Geom_Hyperbola_get_0"]=Module["asm"]["Et"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Hyperbola___destroy___0=Module["_emscripten_bind_Handle_Geom_Hyperbola___destroy___0"]=function(){return(_emscripten_bind_Handle_Geom_Hyperbola___destroy___0=Module["_emscripten_bind_Handle_Geom_Hyperbola___destroy___0"]=Module["asm"]["Ft"]).apply(null,arguments)};var _emscripten_bind_GC_MakeEllipse_GC_MakeEllipse_1=Module["_emscripten_bind_GC_MakeEllipse_GC_MakeEllipse_1"]=function(){return(_emscripten_bind_GC_MakeEllipse_GC_MakeEllipse_1=Module["_emscripten_bind_GC_MakeEllipse_GC_MakeEllipse_1"]=Module["asm"]["Gt"]).apply(null,arguments)};var _emscripten_bind_GC_MakeEllipse_GC_MakeEllipse_3=Module["_emscripten_bind_GC_MakeEllipse_GC_MakeEllipse_3"]=function(){return(_emscripten_bind_GC_MakeEllipse_GC_MakeEllipse_3=Module["_emscripten_bind_GC_MakeEllipse_GC_MakeEllipse_3"]=Module["asm"]["Ht"]).apply(null,arguments)};var _emscripten_bind_GC_MakeEllipse_Value_0=Module["_emscripten_bind_GC_MakeEllipse_Value_0"]=function(){return(_emscripten_bind_GC_MakeEllipse_Value_0=Module["_emscripten_bind_GC_MakeEllipse_Value_0"]=Module["asm"]["It"]).apply(null,arguments)};var _emscripten_bind_GC_MakeEllipse___destroy___0=Module["_emscripten_bind_GC_MakeEllipse___destroy___0"]=function(){return(_emscripten_bind_GC_MakeEllipse___destroy___0=Module["_emscripten_bind_GC_MakeEllipse___destroy___0"]=Module["asm"]["Jt"]).apply(null,arguments)};var _emscripten_bind_GeomAPI_PointsToBSpline_GeomAPI_PointsToBSpline_1=Module["_emscripten_bind_GeomAPI_PointsToBSpline_GeomAPI_PointsToBSpline_1"]=function(){return(_emscripten_bind_GeomAPI_PointsToBSpline_GeomAPI_PointsToBSpline_1=Module["_emscripten_bind_GeomAPI_PointsToBSpline_GeomAPI_PointsToBSpline_1"]=Module["asm"]["Kt"]).apply(null,arguments)};var _emscripten_bind_GeomAPI_PointsToBSpline_GeomAPI_PointsToBSpline_2=Module["_emscripten_bind_GeomAPI_PointsToBSpline_GeomAPI_PointsToBSpline_2"]=function(){return(_emscripten_bind_GeomAPI_PointsToBSpline_GeomAPI_PointsToBSpline_2=Module["_emscripten_bind_GeomAPI_PointsToBSpline_GeomAPI_PointsToBSpline_2"]=Module["asm"]["Lt"]).apply(null,arguments)};var _emscripten_bind_GeomAPI_PointsToBSpline_GeomAPI_PointsToBSpline_3=Module["_emscripten_bind_GeomAPI_PointsToBSpline_GeomAPI_PointsToBSpline_3"]=function(){return(_emscripten_bind_GeomAPI_PointsToBSpline_GeomAPI_PointsToBSpline_3=Module["_emscripten_bind_GeomAPI_PointsToBSpline_GeomAPI_PointsToBSpline_3"]=Module["asm"]["Mt"]).apply(null,arguments)};var _emscripten_bind_GeomAPI_PointsToBSpline_GeomAPI_PointsToBSpline_4=Module["_emscripten_bind_GeomAPI_PointsToBSpline_GeomAPI_PointsToBSpline_4"]=function(){return(_emscripten_bind_GeomAPI_PointsToBSpline_GeomAPI_PointsToBSpline_4=Module["_emscripten_bind_GeomAPI_PointsToBSpline_GeomAPI_PointsToBSpline_4"]=Module["asm"]["Nt"]).apply(null,arguments)};var _emscripten_bind_GeomAPI_PointsToBSpline_GeomAPI_PointsToBSpline_5=Module["_emscripten_bind_GeomAPI_PointsToBSpline_GeomAPI_PointsToBSpline_5"]=function(){return(_emscripten_bind_GeomAPI_PointsToBSpline_GeomAPI_PointsToBSpline_5=Module["_emscripten_bind_GeomAPI_PointsToBSpline_GeomAPI_PointsToBSpline_5"]=Module["asm"]["Ot"]).apply(null,arguments)};var _emscripten_bind_GeomAPI_PointsToBSpline_Curve_0=Module["_emscripten_bind_GeomAPI_PointsToBSpline_Curve_0"]=function(){return(_emscripten_bind_GeomAPI_PointsToBSpline_Curve_0=Module["_emscripten_bind_GeomAPI_PointsToBSpline_Curve_0"]=Module["asm"]["Pt"]).apply(null,arguments)};var _emscripten_bind_GeomAPI_PointsToBSpline_IsDone_0=Module["_emscripten_bind_GeomAPI_PointsToBSpline_IsDone_0"]=function(){return(_emscripten_bind_GeomAPI_PointsToBSpline_IsDone_0=Module["_emscripten_bind_GeomAPI_PointsToBSpline_IsDone_0"]=Module["asm"]["Qt"]).apply(null,arguments)};var _emscripten_bind_GeomAPI_PointsToBSpline___destroy___0=Module["_emscripten_bind_GeomAPI_PointsToBSpline___destroy___0"]=function(){return(_emscripten_bind_GeomAPI_PointsToBSpline___destroy___0=Module["_emscripten_bind_GeomAPI_PointsToBSpline___destroy___0"]=Module["asm"]["Rt"]).apply(null,arguments)};var _emscripten_bind_BRep_Builder_BRep_Builder_0=Module["_emscripten_bind_BRep_Builder_BRep_Builder_0"]=function(){return(_emscripten_bind_BRep_Builder_BRep_Builder_0=Module["_emscripten_bind_BRep_Builder_BRep_Builder_0"]=Module["asm"]["St"]).apply(null,arguments)};var _emscripten_bind_BRep_Builder_MakeFace_1=Module["_emscripten_bind_BRep_Builder_MakeFace_1"]=function(){return(_emscripten_bind_BRep_Builder_MakeFace_1=Module["_emscripten_bind_BRep_Builder_MakeFace_1"]=Module["asm"]["Tt"]).apply(null,arguments)};var _emscripten_bind_BRep_Builder_MakeFace_2=Module["_emscripten_bind_BRep_Builder_MakeFace_2"]=function(){return(_emscripten_bind_BRep_Builder_MakeFace_2=Module["_emscripten_bind_BRep_Builder_MakeFace_2"]=Module["asm"]["Ut"]).apply(null,arguments)};var _emscripten_bind_BRep_Builder_UpdateFace_2=Module["_emscripten_bind_BRep_Builder_UpdateFace_2"]=function(){return(_emscripten_bind_BRep_Builder_UpdateFace_2=Module["_emscripten_bind_BRep_Builder_UpdateFace_2"]=Module["asm"]["Vt"]).apply(null,arguments)};var _emscripten_bind_BRep_Builder_NaturalRestriction_2=Module["_emscripten_bind_BRep_Builder_NaturalRestriction_2"]=function(){return(_emscripten_bind_BRep_Builder_NaturalRestriction_2=Module["_emscripten_bind_BRep_Builder_NaturalRestriction_2"]=Module["asm"]["Wt"]).apply(null,arguments)};var _emscripten_bind_BRep_Builder_MakeEdge_1=Module["_emscripten_bind_BRep_Builder_MakeEdge_1"]=function(){return(_emscripten_bind_BRep_Builder_MakeEdge_1=Module["_emscripten_bind_BRep_Builder_MakeEdge_1"]=Module["asm"]["Xt"]).apply(null,arguments)};var _emscripten_bind_BRep_Builder_SameParameter_2=Module["_emscripten_bind_BRep_Builder_SameParameter_2"]=function(){return(_emscripten_bind_BRep_Builder_SameParameter_2=Module["_emscripten_bind_BRep_Builder_SameParameter_2"]=Module["asm"]["Yt"]).apply(null,arguments)};var _emscripten_bind_BRep_Builder_SameRange_2=Module["_emscripten_bind_BRep_Builder_SameRange_2"]=function(){return(_emscripten_bind_BRep_Builder_SameRange_2=Module["_emscripten_bind_BRep_Builder_SameRange_2"]=Module["asm"]["Zt"]).apply(null,arguments)};var _emscripten_bind_BRep_Builder_Degenerated_2=Module["_emscripten_bind_BRep_Builder_Degenerated_2"]=function(){return(_emscripten_bind_BRep_Builder_Degenerated_2=Module["_emscripten_bind_BRep_Builder_Degenerated_2"]=Module["asm"]["_t"]).apply(null,arguments)};var _emscripten_bind_BRep_Builder_Range_3=Module["_emscripten_bind_BRep_Builder_Range_3"]=function(){return(_emscripten_bind_BRep_Builder_Range_3=Module["_emscripten_bind_BRep_Builder_Range_3"]=Module["asm"]["$t"]).apply(null,arguments)};var _emscripten_bind_BRep_Builder_Range_4=Module["_emscripten_bind_BRep_Builder_Range_4"]=function(){return(_emscripten_bind_BRep_Builder_Range_4=Module["_emscripten_bind_BRep_Builder_Range_4"]=Module["asm"]["au"]).apply(null,arguments)};var _emscripten_bind_BRep_Builder_Transfert_2=Module["_emscripten_bind_BRep_Builder_Transfert_2"]=function(){return(_emscripten_bind_BRep_Builder_Transfert_2=Module["_emscripten_bind_BRep_Builder_Transfert_2"]=Module["asm"]["bu"]).apply(null,arguments)};var _emscripten_bind_BRep_Builder_Transfert_4=Module["_emscripten_bind_BRep_Builder_Transfert_4"]=function(){return(_emscripten_bind_BRep_Builder_Transfert_4=Module["_emscripten_bind_BRep_Builder_Transfert_4"]=Module["asm"]["cu"]).apply(null,arguments)};var _emscripten_bind_BRep_Builder_MakeVertex_1=Module["_emscripten_bind_BRep_Builder_MakeVertex_1"]=function(){return(_emscripten_bind_BRep_Builder_MakeVertex_1=Module["_emscripten_bind_BRep_Builder_MakeVertex_1"]=Module["asm"]["du"]).apply(null,arguments)};var _emscripten_bind_BRep_Builder_MakeVertex_3=Module["_emscripten_bind_BRep_Builder_MakeVertex_3"]=function(){return(_emscripten_bind_BRep_Builder_MakeVertex_3=Module["_emscripten_bind_BRep_Builder_MakeVertex_3"]=Module["asm"]["eu"]).apply(null,arguments)};var _emscripten_bind_BRep_Builder_UpdateVertex_2=Module["_emscripten_bind_BRep_Builder_UpdateVertex_2"]=function(){return(_emscripten_bind_BRep_Builder_UpdateVertex_2=Module["_emscripten_bind_BRep_Builder_UpdateVertex_2"]=Module["asm"]["fu"]).apply(null,arguments)};var _emscripten_bind_BRep_Builder_UpdateVertex_3=Module["_emscripten_bind_BRep_Builder_UpdateVertex_3"]=function(){return(_emscripten_bind_BRep_Builder_UpdateVertex_3=Module["_emscripten_bind_BRep_Builder_UpdateVertex_3"]=Module["asm"]["gu"]).apply(null,arguments)};var _emscripten_bind_BRep_Builder_UpdateVertex_5=Module["_emscripten_bind_BRep_Builder_UpdateVertex_5"]=function(){return(_emscripten_bind_BRep_Builder_UpdateVertex_5=Module["_emscripten_bind_BRep_Builder_UpdateVertex_5"]=Module["asm"]["hu"]).apply(null,arguments)};var _emscripten_bind_BRep_Builder_MakeWire_1=Module["_emscripten_bind_BRep_Builder_MakeWire_1"]=function(){return(_emscripten_bind_BRep_Builder_MakeWire_1=Module["_emscripten_bind_BRep_Builder_MakeWire_1"]=Module["asm"]["iu"]).apply(null,arguments)};var _emscripten_bind_BRep_Builder_MakeCompound_1=Module["_emscripten_bind_BRep_Builder_MakeCompound_1"]=function(){return(_emscripten_bind_BRep_Builder_MakeCompound_1=Module["_emscripten_bind_BRep_Builder_MakeCompound_1"]=Module["asm"]["ju"]).apply(null,arguments)};var _emscripten_bind_BRep_Builder_Add_2=Module["_emscripten_bind_BRep_Builder_Add_2"]=function(){return(_emscripten_bind_BRep_Builder_Add_2=Module["_emscripten_bind_BRep_Builder_Add_2"]=Module["asm"]["ku"]).apply(null,arguments)};var _emscripten_bind_BRep_Builder_Remove_2=Module["_emscripten_bind_BRep_Builder_Remove_2"]=function(){return(_emscripten_bind_BRep_Builder_Remove_2=Module["_emscripten_bind_BRep_Builder_Remove_2"]=Module["asm"]["lu"]).apply(null,arguments)};var _emscripten_bind_BRep_Builder___destroy___0=Module["_emscripten_bind_BRep_Builder___destroy___0"]=function(){return(_emscripten_bind_BRep_Builder___destroy___0=Module["_emscripten_bind_BRep_Builder___destroy___0"]=Module["asm"]["mu"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Copy_BRepBuilderAPI_Copy_0=Module["_emscripten_bind_BRepBuilderAPI_Copy_BRepBuilderAPI_Copy_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_Copy_BRepBuilderAPI_Copy_0=Module["_emscripten_bind_BRepBuilderAPI_Copy_BRepBuilderAPI_Copy_0"]=Module["asm"]["nu"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Copy_BRepBuilderAPI_Copy_1=Module["_emscripten_bind_BRepBuilderAPI_Copy_BRepBuilderAPI_Copy_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_Copy_BRepBuilderAPI_Copy_1=Module["_emscripten_bind_BRepBuilderAPI_Copy_BRepBuilderAPI_Copy_1"]=Module["asm"]["ou"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Copy_BRepBuilderAPI_Copy_2=Module["_emscripten_bind_BRepBuilderAPI_Copy_BRepBuilderAPI_Copy_2"]=function(){return(_emscripten_bind_BRepBuilderAPI_Copy_BRepBuilderAPI_Copy_2=Module["_emscripten_bind_BRepBuilderAPI_Copy_BRepBuilderAPI_Copy_2"]=Module["asm"]["pu"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Copy_BRepBuilderAPI_Copy_3=Module["_emscripten_bind_BRepBuilderAPI_Copy_BRepBuilderAPI_Copy_3"]=function(){return(_emscripten_bind_BRepBuilderAPI_Copy_BRepBuilderAPI_Copy_3=Module["_emscripten_bind_BRepBuilderAPI_Copy_BRepBuilderAPI_Copy_3"]=Module["asm"]["qu"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Copy_Perform_1=Module["_emscripten_bind_BRepBuilderAPI_Copy_Perform_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_Copy_Perform_1=Module["_emscripten_bind_BRepBuilderAPI_Copy_Perform_1"]=Module["asm"]["ru"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Copy_Perform_2=Module["_emscripten_bind_BRepBuilderAPI_Copy_Perform_2"]=function(){return(_emscripten_bind_BRepBuilderAPI_Copy_Perform_2=Module["_emscripten_bind_BRepBuilderAPI_Copy_Perform_2"]=Module["asm"]["su"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Copy_Perform_3=Module["_emscripten_bind_BRepBuilderAPI_Copy_Perform_3"]=function(){return(_emscripten_bind_BRepBuilderAPI_Copy_Perform_3=Module["_emscripten_bind_BRepBuilderAPI_Copy_Perform_3"]=Module["asm"]["tu"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Copy___destroy___0=Module["_emscripten_bind_BRepBuilderAPI_Copy___destroy___0"]=function(){return(_emscripten_bind_BRepBuilderAPI_Copy___destroy___0=Module["_emscripten_bind_BRepBuilderAPI_Copy___destroy___0"]=Module["asm"]["uu"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeSphere_BRepPrimAPI_MakeSphere_1=Module["_emscripten_bind_BRepPrimAPI_MakeSphere_BRepPrimAPI_MakeSphere_1"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeSphere_BRepPrimAPI_MakeSphere_1=Module["_emscripten_bind_BRepPrimAPI_MakeSphere_BRepPrimAPI_MakeSphere_1"]=Module["asm"]["vu"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeSphere_BRepPrimAPI_MakeSphere_2=Module["_emscripten_bind_BRepPrimAPI_MakeSphere_BRepPrimAPI_MakeSphere_2"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeSphere_BRepPrimAPI_MakeSphere_2=Module["_emscripten_bind_BRepPrimAPI_MakeSphere_BRepPrimAPI_MakeSphere_2"]=Module["asm"]["wu"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeSphere_BRepPrimAPI_MakeSphere_3=Module["_emscripten_bind_BRepPrimAPI_MakeSphere_BRepPrimAPI_MakeSphere_3"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeSphere_BRepPrimAPI_MakeSphere_3=Module["_emscripten_bind_BRepPrimAPI_MakeSphere_BRepPrimAPI_MakeSphere_3"]=Module["asm"]["xu"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeSphere_BRepPrimAPI_MakeSphere_4=Module["_emscripten_bind_BRepPrimAPI_MakeSphere_BRepPrimAPI_MakeSphere_4"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeSphere_BRepPrimAPI_MakeSphere_4=Module["_emscripten_bind_BRepPrimAPI_MakeSphere_BRepPrimAPI_MakeSphere_4"]=Module["asm"]["yu"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeSphere_BRepPrimAPI_MakeSphere_5=Module["_emscripten_bind_BRepPrimAPI_MakeSphere_BRepPrimAPI_MakeSphere_5"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeSphere_BRepPrimAPI_MakeSphere_5=Module["_emscripten_bind_BRepPrimAPI_MakeSphere_BRepPrimAPI_MakeSphere_5"]=Module["asm"]["zu"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeSphere_Sphere_0=Module["_emscripten_bind_BRepPrimAPI_MakeSphere_Sphere_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeSphere_Sphere_0=Module["_emscripten_bind_BRepPrimAPI_MakeSphere_Sphere_0"]=Module["asm"]["Au"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeSphere_Shape_0=Module["_emscripten_bind_BRepPrimAPI_MakeSphere_Shape_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeSphere_Shape_0=Module["_emscripten_bind_BRepPrimAPI_MakeSphere_Shape_0"]=Module["asm"]["Bu"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeSphere_Build_0=Module["_emscripten_bind_BRepPrimAPI_MakeSphere_Build_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeSphere_Build_0=Module["_emscripten_bind_BRepPrimAPI_MakeSphere_Build_0"]=Module["asm"]["Cu"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeSphere_Face_0=Module["_emscripten_bind_BRepPrimAPI_MakeSphere_Face_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeSphere_Face_0=Module["_emscripten_bind_BRepPrimAPI_MakeSphere_Face_0"]=Module["asm"]["Du"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeSphere_Shell_0=Module["_emscripten_bind_BRepPrimAPI_MakeSphere_Shell_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeSphere_Shell_0=Module["_emscripten_bind_BRepPrimAPI_MakeSphere_Shell_0"]=Module["asm"]["Eu"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeSphere_Solid_0=Module["_emscripten_bind_BRepPrimAPI_MakeSphere_Solid_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeSphere_Solid_0=Module["_emscripten_bind_BRepPrimAPI_MakeSphere_Solid_0"]=Module["asm"]["Fu"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeSphere___destroy___0=Module["_emscripten_bind_BRepPrimAPI_MakeSphere___destroy___0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeSphere___destroy___0=Module["_emscripten_bind_BRepPrimAPI_MakeSphere___destroy___0"]=Module["asm"]["Gu"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom2d_Curve_Handle_Geom2d_Curve_0=Module["_emscripten_bind_Handle_Geom2d_Curve_Handle_Geom2d_Curve_0"]=function(){return(_emscripten_bind_Handle_Geom2d_Curve_Handle_Geom2d_Curve_0=Module["_emscripten_bind_Handle_Geom2d_Curve_Handle_Geom2d_Curve_0"]=Module["asm"]["Hu"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom2d_Curve_Handle_Geom2d_Curve_1=Module["_emscripten_bind_Handle_Geom2d_Curve_Handle_Geom2d_Curve_1"]=function(){return(_emscripten_bind_Handle_Geom2d_Curve_Handle_Geom2d_Curve_1=Module["_emscripten_bind_Handle_Geom2d_Curve_Handle_Geom2d_Curve_1"]=Module["asm"]["Iu"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom2d_Curve_IsNull_0=Module["_emscripten_bind_Handle_Geom2d_Curve_IsNull_0"]=function(){return(_emscripten_bind_Handle_Geom2d_Curve_IsNull_0=Module["_emscripten_bind_Handle_Geom2d_Curve_IsNull_0"]=Module["asm"]["Ju"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom2d_Curve_Nullify_0=Module["_emscripten_bind_Handle_Geom2d_Curve_Nullify_0"]=function(){return(_emscripten_bind_Handle_Geom2d_Curve_Nullify_0=Module["_emscripten_bind_Handle_Geom2d_Curve_Nullify_0"]=Module["asm"]["Ku"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom2d_Curve_get_0=Module["_emscripten_bind_Handle_Geom2d_Curve_get_0"]=function(){return(_emscripten_bind_Handle_Geom2d_Curve_get_0=Module["_emscripten_bind_Handle_Geom2d_Curve_get_0"]=Module["asm"]["Lu"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom2d_Curve___destroy___0=Module["_emscripten_bind_Handle_Geom2d_Curve___destroy___0"]=function(){return(_emscripten_bind_Handle_Geom2d_Curve___destroy___0=Module["_emscripten_bind_Handle_Geom2d_Curve___destroy___0"]=Module["asm"]["Mu"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_BezierCurve_Handle_Geom_BezierCurve_0=Module["_emscripten_bind_Handle_Geom_BezierCurve_Handle_Geom_BezierCurve_0"]=function(){return(_emscripten_bind_Handle_Geom_BezierCurve_Handle_Geom_BezierCurve_0=Module["_emscripten_bind_Handle_Geom_BezierCurve_Handle_Geom_BezierCurve_0"]=Module["asm"]["Nu"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_BezierCurve_Handle_Geom_BezierCurve_1=Module["_emscripten_bind_Handle_Geom_BezierCurve_Handle_Geom_BezierCurve_1"]=function(){return(_emscripten_bind_Handle_Geom_BezierCurve_Handle_Geom_BezierCurve_1=Module["_emscripten_bind_Handle_Geom_BezierCurve_Handle_Geom_BezierCurve_1"]=Module["asm"]["Ou"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_BezierCurve_IsNull_0=Module["_emscripten_bind_Handle_Geom_BezierCurve_IsNull_0"]=function(){return(_emscripten_bind_Handle_Geom_BezierCurve_IsNull_0=Module["_emscripten_bind_Handle_Geom_BezierCurve_IsNull_0"]=Module["asm"]["Pu"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_BezierCurve_Nullify_0=Module["_emscripten_bind_Handle_Geom_BezierCurve_Nullify_0"]=function(){return(_emscripten_bind_Handle_Geom_BezierCurve_Nullify_0=Module["_emscripten_bind_Handle_Geom_BezierCurve_Nullify_0"]=Module["asm"]["Qu"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_BezierCurve_get_0=Module["_emscripten_bind_Handle_Geom_BezierCurve_get_0"]=function(){return(_emscripten_bind_Handle_Geom_BezierCurve_get_0=Module["_emscripten_bind_Handle_Geom_BezierCurve_get_0"]=Module["asm"]["Ru"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_BezierCurve___destroy___0=Module["_emscripten_bind_Handle_Geom_BezierCurve___destroy___0"]=function(){return(_emscripten_bind_Handle_Geom_BezierCurve___destroy___0=Module["_emscripten_bind_Handle_Geom_BezierCurve___destroy___0"]=Module["asm"]["Su"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_TopoDS_Shell_0=Module["_emscripten_bind_TopoDS_Shell_TopoDS_Shell_0"]=function(){return(_emscripten_bind_TopoDS_Shell_TopoDS_Shell_0=Module["_emscripten_bind_TopoDS_Shell_TopoDS_Shell_0"]=Module["asm"]["Tu"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_TopoDS_Shell_1=Module["_emscripten_bind_TopoDS_Shell_TopoDS_Shell_1"]=function(){return(_emscripten_bind_TopoDS_Shell_TopoDS_Shell_1=Module["_emscripten_bind_TopoDS_Shell_TopoDS_Shell_1"]=Module["asm"]["Uu"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_IsNull_0=Module["_emscripten_bind_TopoDS_Shell_IsNull_0"]=function(){return(_emscripten_bind_TopoDS_Shell_IsNull_0=Module["_emscripten_bind_TopoDS_Shell_IsNull_0"]=Module["asm"]["Vu"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_Nullify_0=Module["_emscripten_bind_TopoDS_Shell_Nullify_0"]=function(){return(_emscripten_bind_TopoDS_Shell_Nullify_0=Module["_emscripten_bind_TopoDS_Shell_Nullify_0"]=Module["asm"]["Wu"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_Location_0=Module["_emscripten_bind_TopoDS_Shell_Location_0"]=function(){return(_emscripten_bind_TopoDS_Shell_Location_0=Module["_emscripten_bind_TopoDS_Shell_Location_0"]=Module["asm"]["Xu"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_Located_1=Module["_emscripten_bind_TopoDS_Shell_Located_1"]=function(){return(_emscripten_bind_TopoDS_Shell_Located_1=Module["_emscripten_bind_TopoDS_Shell_Located_1"]=Module["asm"]["Yu"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_Orientation_0=Module["_emscripten_bind_TopoDS_Shell_Orientation_0"]=function(){return(_emscripten_bind_TopoDS_Shell_Orientation_0=Module["_emscripten_bind_TopoDS_Shell_Orientation_0"]=Module["asm"]["Zu"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_Oriented_1=Module["_emscripten_bind_TopoDS_Shell_Oriented_1"]=function(){return(_emscripten_bind_TopoDS_Shell_Oriented_1=Module["_emscripten_bind_TopoDS_Shell_Oriented_1"]=Module["asm"]["_u"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_ShapeType_0=Module["_emscripten_bind_TopoDS_Shell_ShapeType_0"]=function(){return(_emscripten_bind_TopoDS_Shell_ShapeType_0=Module["_emscripten_bind_TopoDS_Shell_ShapeType_0"]=Module["asm"]["$u"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_Free_0=Module["_emscripten_bind_TopoDS_Shell_Free_0"]=function(){return(_emscripten_bind_TopoDS_Shell_Free_0=Module["_emscripten_bind_TopoDS_Shell_Free_0"]=Module["asm"]["av"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_Locked_0=Module["_emscripten_bind_TopoDS_Shell_Locked_0"]=function(){return(_emscripten_bind_TopoDS_Shell_Locked_0=Module["_emscripten_bind_TopoDS_Shell_Locked_0"]=Module["asm"]["bv"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_Modified_0=Module["_emscripten_bind_TopoDS_Shell_Modified_0"]=function(){return(_emscripten_bind_TopoDS_Shell_Modified_0=Module["_emscripten_bind_TopoDS_Shell_Modified_0"]=Module["asm"]["cv"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_Checked_0=Module["_emscripten_bind_TopoDS_Shell_Checked_0"]=function(){return(_emscripten_bind_TopoDS_Shell_Checked_0=Module["_emscripten_bind_TopoDS_Shell_Checked_0"]=Module["asm"]["dv"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_Orientable_0=Module["_emscripten_bind_TopoDS_Shell_Orientable_0"]=function(){return(_emscripten_bind_TopoDS_Shell_Orientable_0=Module["_emscripten_bind_TopoDS_Shell_Orientable_0"]=Module["asm"]["ev"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_Closed_0=Module["_emscripten_bind_TopoDS_Shell_Closed_0"]=function(){return(_emscripten_bind_TopoDS_Shell_Closed_0=Module["_emscripten_bind_TopoDS_Shell_Closed_0"]=Module["asm"]["fv"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_Infinite_0=Module["_emscripten_bind_TopoDS_Shell_Infinite_0"]=function(){return(_emscripten_bind_TopoDS_Shell_Infinite_0=Module["_emscripten_bind_TopoDS_Shell_Infinite_0"]=Module["asm"]["gv"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_Convex_0=Module["_emscripten_bind_TopoDS_Shell_Convex_0"]=function(){return(_emscripten_bind_TopoDS_Shell_Convex_0=Module["_emscripten_bind_TopoDS_Shell_Convex_0"]=Module["asm"]["hv"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_Move_1=Module["_emscripten_bind_TopoDS_Shell_Move_1"]=function(){return(_emscripten_bind_TopoDS_Shell_Move_1=Module["_emscripten_bind_TopoDS_Shell_Move_1"]=Module["asm"]["iv"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_Moved_1=Module["_emscripten_bind_TopoDS_Shell_Moved_1"]=function(){return(_emscripten_bind_TopoDS_Shell_Moved_1=Module["_emscripten_bind_TopoDS_Shell_Moved_1"]=Module["asm"]["jv"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_Reverse_0=Module["_emscripten_bind_TopoDS_Shell_Reverse_0"]=function(){return(_emscripten_bind_TopoDS_Shell_Reverse_0=Module["_emscripten_bind_TopoDS_Shell_Reverse_0"]=Module["asm"]["kv"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_Reversed_0=Module["_emscripten_bind_TopoDS_Shell_Reversed_0"]=function(){return(_emscripten_bind_TopoDS_Shell_Reversed_0=Module["_emscripten_bind_TopoDS_Shell_Reversed_0"]=Module["asm"]["lv"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_Complement_0=Module["_emscripten_bind_TopoDS_Shell_Complement_0"]=function(){return(_emscripten_bind_TopoDS_Shell_Complement_0=Module["_emscripten_bind_TopoDS_Shell_Complement_0"]=Module["asm"]["mv"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_Complemented_0=Module["_emscripten_bind_TopoDS_Shell_Complemented_0"]=function(){return(_emscripten_bind_TopoDS_Shell_Complemented_0=Module["_emscripten_bind_TopoDS_Shell_Complemented_0"]=Module["asm"]["nv"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_Compose_1=Module["_emscripten_bind_TopoDS_Shell_Compose_1"]=function(){return(_emscripten_bind_TopoDS_Shell_Compose_1=Module["_emscripten_bind_TopoDS_Shell_Compose_1"]=Module["asm"]["ov"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_Composed_1=Module["_emscripten_bind_TopoDS_Shell_Composed_1"]=function(){return(_emscripten_bind_TopoDS_Shell_Composed_1=Module["_emscripten_bind_TopoDS_Shell_Composed_1"]=Module["asm"]["pv"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_NbChildren_0=Module["_emscripten_bind_TopoDS_Shell_NbChildren_0"]=function(){return(_emscripten_bind_TopoDS_Shell_NbChildren_0=Module["_emscripten_bind_TopoDS_Shell_NbChildren_0"]=Module["asm"]["qv"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_IsPartner_1=Module["_emscripten_bind_TopoDS_Shell_IsPartner_1"]=function(){return(_emscripten_bind_TopoDS_Shell_IsPartner_1=Module["_emscripten_bind_TopoDS_Shell_IsPartner_1"]=Module["asm"]["rv"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_IsSame_1=Module["_emscripten_bind_TopoDS_Shell_IsSame_1"]=function(){return(_emscripten_bind_TopoDS_Shell_IsSame_1=Module["_emscripten_bind_TopoDS_Shell_IsSame_1"]=Module["asm"]["sv"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_IsEqual_1=Module["_emscripten_bind_TopoDS_Shell_IsEqual_1"]=function(){return(_emscripten_bind_TopoDS_Shell_IsEqual_1=Module["_emscripten_bind_TopoDS_Shell_IsEqual_1"]=Module["asm"]["tv"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_IsNotEqual_1=Module["_emscripten_bind_TopoDS_Shell_IsNotEqual_1"]=function(){return(_emscripten_bind_TopoDS_Shell_IsNotEqual_1=Module["_emscripten_bind_TopoDS_Shell_IsNotEqual_1"]=Module["asm"]["uv"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_HashCode_1=Module["_emscripten_bind_TopoDS_Shell_HashCode_1"]=function(){return(_emscripten_bind_TopoDS_Shell_HashCode_1=Module["_emscripten_bind_TopoDS_Shell_HashCode_1"]=Module["asm"]["vv"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_EmptyCopy_0=Module["_emscripten_bind_TopoDS_Shell_EmptyCopy_0"]=function(){return(_emscripten_bind_TopoDS_Shell_EmptyCopy_0=Module["_emscripten_bind_TopoDS_Shell_EmptyCopy_0"]=Module["asm"]["wv"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_EmptyCopied_0=Module["_emscripten_bind_TopoDS_Shell_EmptyCopied_0"]=function(){return(_emscripten_bind_TopoDS_Shell_EmptyCopied_0=Module["_emscripten_bind_TopoDS_Shell_EmptyCopied_0"]=Module["asm"]["xv"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell___destroy___0=Module["_emscripten_bind_TopoDS_Shell___destroy___0"]=function(){return(_emscripten_bind_TopoDS_Shell___destroy___0=Module["_emscripten_bind_TopoDS_Shell___destroy___0"]=Module["asm"]["yv"]).apply(null,arguments)};var _emscripten_bind_Handle_Poly_PolygonOnTriangulation_Handle_Poly_PolygonOnTriangulation_0=Module["_emscripten_bind_Handle_Poly_PolygonOnTriangulation_Handle_Poly_PolygonOnTriangulation_0"]=function(){return(_emscripten_bind_Handle_Poly_PolygonOnTriangulation_Handle_Poly_PolygonOnTriangulation_0=Module["_emscripten_bind_Handle_Poly_PolygonOnTriangulation_Handle_Poly_PolygonOnTriangulation_0"]=Module["asm"]["zv"]).apply(null,arguments)};var _emscripten_bind_Handle_Poly_PolygonOnTriangulation_Handle_Poly_PolygonOnTriangulation_1=Module["_emscripten_bind_Handle_Poly_PolygonOnTriangulation_Handle_Poly_PolygonOnTriangulation_1"]=function(){return(_emscripten_bind_Handle_Poly_PolygonOnTriangulation_Handle_Poly_PolygonOnTriangulation_1=Module["_emscripten_bind_Handle_Poly_PolygonOnTriangulation_Handle_Poly_PolygonOnTriangulation_1"]=Module["asm"]["Av"]).apply(null,arguments)};var _emscripten_bind_Handle_Poly_PolygonOnTriangulation_IsNull_0=Module["_emscripten_bind_Handle_Poly_PolygonOnTriangulation_IsNull_0"]=function(){return(_emscripten_bind_Handle_Poly_PolygonOnTriangulation_IsNull_0=Module["_emscripten_bind_Handle_Poly_PolygonOnTriangulation_IsNull_0"]=Module["asm"]["Bv"]).apply(null,arguments)};var _emscripten_bind_Handle_Poly_PolygonOnTriangulation_Nullify_0=Module["_emscripten_bind_Handle_Poly_PolygonOnTriangulation_Nullify_0"]=function(){return(_emscripten_bind_Handle_Poly_PolygonOnTriangulation_Nullify_0=Module["_emscripten_bind_Handle_Poly_PolygonOnTriangulation_Nullify_0"]=Module["asm"]["Cv"]).apply(null,arguments)};var _emscripten_bind_Handle_Poly_PolygonOnTriangulation_get_0=Module["_emscripten_bind_Handle_Poly_PolygonOnTriangulation_get_0"]=function(){return(_emscripten_bind_Handle_Poly_PolygonOnTriangulation_get_0=Module["_emscripten_bind_Handle_Poly_PolygonOnTriangulation_get_0"]=Module["asm"]["Dv"]).apply(null,arguments)};var _emscripten_bind_Handle_Poly_PolygonOnTriangulation___destroy___0=Module["_emscripten_bind_Handle_Poly_PolygonOnTriangulation___destroy___0"]=function(){return(_emscripten_bind_Handle_Poly_PolygonOnTriangulation___destroy___0=Module["_emscripten_bind_Handle_Poly_PolygonOnTriangulation___destroy___0"]=Module["asm"]["Ev"]).apply(null,arguments)};var _emscripten_bind_VoidPtr___destroy___0=Module["_emscripten_bind_VoidPtr___destroy___0"]=function(){return(_emscripten_bind_VoidPtr___destroy___0=Module["_emscripten_bind_VoidPtr___destroy___0"]=Module["asm"]["Fv"]).apply(null,arguments)};var _emscripten_bind_BRepFilletAPI_MakeFillet2d_BRepFilletAPI_MakeFillet2d_1=Module["_emscripten_bind_BRepFilletAPI_MakeFillet2d_BRepFilletAPI_MakeFillet2d_1"]=function(){return(_emscripten_bind_BRepFilletAPI_MakeFillet2d_BRepFilletAPI_MakeFillet2d_1=Module["_emscripten_bind_BRepFilletAPI_MakeFillet2d_BRepFilletAPI_MakeFillet2d_1"]=Module["asm"]["Gv"]).apply(null,arguments)};var _emscripten_bind_BRepFilletAPI_MakeFillet2d_AddFillet_2=Module["_emscripten_bind_BRepFilletAPI_MakeFillet2d_AddFillet_2"]=function(){return(_emscripten_bind_BRepFilletAPI_MakeFillet2d_AddFillet_2=Module["_emscripten_bind_BRepFilletAPI_MakeFillet2d_AddFillet_2"]=Module["asm"]["Hv"]).apply(null,arguments)};var _emscripten_bind_BRepFilletAPI_MakeFillet2d_Status_0=Module["_emscripten_bind_BRepFilletAPI_MakeFillet2d_Status_0"]=function(){return(_emscripten_bind_BRepFilletAPI_MakeFillet2d_Status_0=Module["_emscripten_bind_BRepFilletAPI_MakeFillet2d_Status_0"]=Module["asm"]["Iv"]).apply(null,arguments)};var _emscripten_bind_BRepFilletAPI_MakeFillet2d_Shape_0=Module["_emscripten_bind_BRepFilletAPI_MakeFillet2d_Shape_0"]=function(){return(_emscripten_bind_BRepFilletAPI_MakeFillet2d_Shape_0=Module["_emscripten_bind_BRepFilletAPI_MakeFillet2d_Shape_0"]=Module["asm"]["Jv"]).apply(null,arguments)};var _emscripten_bind_BRepFilletAPI_MakeFillet2d___destroy___0=Module["_emscripten_bind_BRepFilletAPI_MakeFillet2d___destroy___0"]=function(){return(_emscripten_bind_BRepFilletAPI_MakeFillet2d___destroy___0=Module["_emscripten_bind_BRepFilletAPI_MakeFillet2d___destroy___0"]=Module["asm"]["Kv"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeHalfSpace_BRepPrimAPI_MakeHalfSpace_2=Module["_emscripten_bind_BRepPrimAPI_MakeHalfSpace_BRepPrimAPI_MakeHalfSpace_2"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeHalfSpace_BRepPrimAPI_MakeHalfSpace_2=Module["_emscripten_bind_BRepPrimAPI_MakeHalfSpace_BRepPrimAPI_MakeHalfSpace_2"]=Module["asm"]["Lv"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeHalfSpace_Solid_0=Module["_emscripten_bind_BRepPrimAPI_MakeHalfSpace_Solid_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeHalfSpace_Solid_0=Module["_emscripten_bind_BRepPrimAPI_MakeHalfSpace_Solid_0"]=Module["asm"]["Mv"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeHalfSpace_Shape_0=Module["_emscripten_bind_BRepPrimAPI_MakeHalfSpace_Shape_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeHalfSpace_Shape_0=Module["_emscripten_bind_BRepPrimAPI_MakeHalfSpace_Shape_0"]=Module["asm"]["Nv"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeHalfSpace_IsDeleted_1=Module["_emscripten_bind_BRepPrimAPI_MakeHalfSpace_IsDeleted_1"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeHalfSpace_IsDeleted_1=Module["_emscripten_bind_BRepPrimAPI_MakeHalfSpace_IsDeleted_1"]=Module["asm"]["Ov"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeHalfSpace___destroy___0=Module["_emscripten_bind_BRepPrimAPI_MakeHalfSpace___destroy___0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeHalfSpace___destroy___0=Module["_emscripten_bind_BRepPrimAPI_MakeHalfSpace___destroy___0"]=Module["asm"]["Pv"]).apply(null,arguments)};var _emscripten_bind_Poly_Triangle_Poly_Triangle_0=Module["_emscripten_bind_Poly_Triangle_Poly_Triangle_0"]=function(){return(_emscripten_bind_Poly_Triangle_Poly_Triangle_0=Module["_emscripten_bind_Poly_Triangle_Poly_Triangle_0"]=Module["asm"]["Qv"]).apply(null,arguments)};var _emscripten_bind_Poly_Triangle_Poly_Triangle_3=Module["_emscripten_bind_Poly_Triangle_Poly_Triangle_3"]=function(){return(_emscripten_bind_Poly_Triangle_Poly_Triangle_3=Module["_emscripten_bind_Poly_Triangle_Poly_Triangle_3"]=Module["asm"]["Rv"]).apply(null,arguments)};var _emscripten_bind_Poly_Triangle_Set_2=Module["_emscripten_bind_Poly_Triangle_Set_2"]=function(){return(_emscripten_bind_Poly_Triangle_Set_2=Module["_emscripten_bind_Poly_Triangle_Set_2"]=Module["asm"]["Sv"]).apply(null,arguments)};var _emscripten_bind_Poly_Triangle_Set_3=Module["_emscripten_bind_Poly_Triangle_Set_3"]=function(){return(_emscripten_bind_Poly_Triangle_Set_3=Module["_emscripten_bind_Poly_Triangle_Set_3"]=Module["asm"]["Tv"]).apply(null,arguments)};var _emscripten_bind_Poly_Triangle_Value_1=Module["_emscripten_bind_Poly_Triangle_Value_1"]=function(){return(_emscripten_bind_Poly_Triangle_Value_1=Module["_emscripten_bind_Poly_Triangle_Value_1"]=Module["asm"]["Uv"]).apply(null,arguments)};var _emscripten_bind_Poly_Triangle_ChangeValue_1=Module["_emscripten_bind_Poly_Triangle_ChangeValue_1"]=function(){return(_emscripten_bind_Poly_Triangle_ChangeValue_1=Module["_emscripten_bind_Poly_Triangle_ChangeValue_1"]=Module["asm"]["Vv"]).apply(null,arguments)};var _emscripten_bind_Poly_Triangle___destroy___0=Module["_emscripten_bind_Poly_Triangle___destroy___0"]=function(){return(_emscripten_bind_Poly_Triangle___destroy___0=Module["_emscripten_bind_Poly_Triangle___destroy___0"]=Module["asm"]["Wv"]).apply(null,arguments)};var _emscripten_bind_gp_Dir_gp_Dir_0=Module["_emscripten_bind_gp_Dir_gp_Dir_0"]=function(){return(_emscripten_bind_gp_Dir_gp_Dir_0=Module["_emscripten_bind_gp_Dir_gp_Dir_0"]=Module["asm"]["Xv"]).apply(null,arguments)};var _emscripten_bind_gp_Dir_gp_Dir_1=Module["_emscripten_bind_gp_Dir_gp_Dir_1"]=function(){return(_emscripten_bind_gp_Dir_gp_Dir_1=Module["_emscripten_bind_gp_Dir_gp_Dir_1"]=Module["asm"]["Yv"]).apply(null,arguments)};var _emscripten_bind_gp_Dir_gp_Dir_3=Module["_emscripten_bind_gp_Dir_gp_Dir_3"]=function(){return(_emscripten_bind_gp_Dir_gp_Dir_3=Module["_emscripten_bind_gp_Dir_gp_Dir_3"]=Module["asm"]["Zv"]).apply(null,arguments)};var _emscripten_bind_gp_Dir_SetCoord_2=Module["_emscripten_bind_gp_Dir_SetCoord_2"]=function(){return(_emscripten_bind_gp_Dir_SetCoord_2=Module["_emscripten_bind_gp_Dir_SetCoord_2"]=Module["asm"]["_v"]).apply(null,arguments)};var _emscripten_bind_gp_Dir_SetCoord_3=Module["_emscripten_bind_gp_Dir_SetCoord_3"]=function(){return(_emscripten_bind_gp_Dir_SetCoord_3=Module["_emscripten_bind_gp_Dir_SetCoord_3"]=Module["asm"]["$v"]).apply(null,arguments)};var _emscripten_bind_gp_Dir_SetX_1=Module["_emscripten_bind_gp_Dir_SetX_1"]=function(){return(_emscripten_bind_gp_Dir_SetX_1=Module["_emscripten_bind_gp_Dir_SetX_1"]=Module["asm"]["aw"]).apply(null,arguments)};var _emscripten_bind_gp_Dir_SetY_1=Module["_emscripten_bind_gp_Dir_SetY_1"]=function(){return(_emscripten_bind_gp_Dir_SetY_1=Module["_emscripten_bind_gp_Dir_SetY_1"]=Module["asm"]["bw"]).apply(null,arguments)};var _emscripten_bind_gp_Dir_SetZ_1=Module["_emscripten_bind_gp_Dir_SetZ_1"]=function(){return(_emscripten_bind_gp_Dir_SetZ_1=Module["_emscripten_bind_gp_Dir_SetZ_1"]=Module["asm"]["cw"]).apply(null,arguments)};var _emscripten_bind_gp_Dir_Coord_1=Module["_emscripten_bind_gp_Dir_Coord_1"]=function(){return(_emscripten_bind_gp_Dir_Coord_1=Module["_emscripten_bind_gp_Dir_Coord_1"]=Module["asm"]["dw"]).apply(null,arguments)};var _emscripten_bind_gp_Dir_X_0=Module["_emscripten_bind_gp_Dir_X_0"]=function(){return(_emscripten_bind_gp_Dir_X_0=Module["_emscripten_bind_gp_Dir_X_0"]=Module["asm"]["ew"]).apply(null,arguments)};var _emscripten_bind_gp_Dir_Y_0=Module["_emscripten_bind_gp_Dir_Y_0"]=function(){return(_emscripten_bind_gp_Dir_Y_0=Module["_emscripten_bind_gp_Dir_Y_0"]=Module["asm"]["fw"]).apply(null,arguments)};var _emscripten_bind_gp_Dir_Z_0=Module["_emscripten_bind_gp_Dir_Z_0"]=function(){return(_emscripten_bind_gp_Dir_Z_0=Module["_emscripten_bind_gp_Dir_Z_0"]=Module["asm"]["gw"]).apply(null,arguments)};var _emscripten_bind_gp_Dir_IsEqual_2=Module["_emscripten_bind_gp_Dir_IsEqual_2"]=function(){return(_emscripten_bind_gp_Dir_IsEqual_2=Module["_emscripten_bind_gp_Dir_IsEqual_2"]=Module["asm"]["hw"]).apply(null,arguments)};var _emscripten_bind_gp_Dir_IsNormal_2=Module["_emscripten_bind_gp_Dir_IsNormal_2"]=function(){return(_emscripten_bind_gp_Dir_IsNormal_2=Module["_emscripten_bind_gp_Dir_IsNormal_2"]=Module["asm"]["iw"]).apply(null,arguments)};var _emscripten_bind_gp_Dir_IsOpposite_2=Module["_emscripten_bind_gp_Dir_IsOpposite_2"]=function(){return(_emscripten_bind_gp_Dir_IsOpposite_2=Module["_emscripten_bind_gp_Dir_IsOpposite_2"]=Module["asm"]["jw"]).apply(null,arguments)};var _emscripten_bind_gp_Dir_IsParallel_2=Module["_emscripten_bind_gp_Dir_IsParallel_2"]=function(){return(_emscripten_bind_gp_Dir_IsParallel_2=Module["_emscripten_bind_gp_Dir_IsParallel_2"]=Module["asm"]["kw"]).apply(null,arguments)};var _emscripten_bind_gp_Dir_Angle_1=Module["_emscripten_bind_gp_Dir_Angle_1"]=function(){return(_emscripten_bind_gp_Dir_Angle_1=Module["_emscripten_bind_gp_Dir_Angle_1"]=Module["asm"]["lw"]).apply(null,arguments)};var _emscripten_bind_gp_Dir_AngleWithRef_2=Module["_emscripten_bind_gp_Dir_AngleWithRef_2"]=function(){return(_emscripten_bind_gp_Dir_AngleWithRef_2=Module["_emscripten_bind_gp_Dir_AngleWithRef_2"]=Module["asm"]["mw"]).apply(null,arguments)};var _emscripten_bind_gp_Dir_Cross_1=Module["_emscripten_bind_gp_Dir_Cross_1"]=function(){return(_emscripten_bind_gp_Dir_Cross_1=Module["_emscripten_bind_gp_Dir_Cross_1"]=Module["asm"]["nw"]).apply(null,arguments)};var _emscripten_bind_gp_Dir_Crossed_1=Module["_emscripten_bind_gp_Dir_Crossed_1"]=function(){return(_emscripten_bind_gp_Dir_Crossed_1=Module["_emscripten_bind_gp_Dir_Crossed_1"]=Module["asm"]["ow"]).apply(null,arguments)};var _emscripten_bind_gp_Dir_CrossCross_2=Module["_emscripten_bind_gp_Dir_CrossCross_2"]=function(){return(_emscripten_bind_gp_Dir_CrossCross_2=Module["_emscripten_bind_gp_Dir_CrossCross_2"]=Module["asm"]["pw"]).apply(null,arguments)};var _emscripten_bind_gp_Dir_CrossCrossed_2=Module["_emscripten_bind_gp_Dir_CrossCrossed_2"]=function(){return(_emscripten_bind_gp_Dir_CrossCrossed_2=Module["_emscripten_bind_gp_Dir_CrossCrossed_2"]=Module["asm"]["qw"]).apply(null,arguments)};var _emscripten_bind_gp_Dir_Dot_1=Module["_emscripten_bind_gp_Dir_Dot_1"]=function(){return(_emscripten_bind_gp_Dir_Dot_1=Module["_emscripten_bind_gp_Dir_Dot_1"]=Module["asm"]["rw"]).apply(null,arguments)};var _emscripten_bind_gp_Dir_DotCross_2=Module["_emscripten_bind_gp_Dir_DotCross_2"]=function(){return(_emscripten_bind_gp_Dir_DotCross_2=Module["_emscripten_bind_gp_Dir_DotCross_2"]=Module["asm"]["sw"]).apply(null,arguments)};var _emscripten_bind_gp_Dir_Reversed_0=Module["_emscripten_bind_gp_Dir_Reversed_0"]=function(){return(_emscripten_bind_gp_Dir_Reversed_0=Module["_emscripten_bind_gp_Dir_Reversed_0"]=Module["asm"]["tw"]).apply(null,arguments)};var _emscripten_bind_gp_Dir_Mirror_1=Module["_emscripten_bind_gp_Dir_Mirror_1"]=function(){return(_emscripten_bind_gp_Dir_Mirror_1=Module["_emscripten_bind_gp_Dir_Mirror_1"]=Module["asm"]["uw"]).apply(null,arguments)};var _emscripten_bind_gp_Dir_Mirrored_1=Module["_emscripten_bind_gp_Dir_Mirrored_1"]=function(){return(_emscripten_bind_gp_Dir_Mirrored_1=Module["_emscripten_bind_gp_Dir_Mirrored_1"]=Module["asm"]["vw"]).apply(null,arguments)};var _emscripten_bind_gp_Dir_Rotate_2=Module["_emscripten_bind_gp_Dir_Rotate_2"]=function(){return(_emscripten_bind_gp_Dir_Rotate_2=Module["_emscripten_bind_gp_Dir_Rotate_2"]=Module["asm"]["ww"]).apply(null,arguments)};var _emscripten_bind_gp_Dir_Rotated_2=Module["_emscripten_bind_gp_Dir_Rotated_2"]=function(){return(_emscripten_bind_gp_Dir_Rotated_2=Module["_emscripten_bind_gp_Dir_Rotated_2"]=Module["asm"]["xw"]).apply(null,arguments)};var _emscripten_bind_gp_Dir_Transform_1=Module["_emscripten_bind_gp_Dir_Transform_1"]=function(){return(_emscripten_bind_gp_Dir_Transform_1=Module["_emscripten_bind_gp_Dir_Transform_1"]=Module["asm"]["yw"]).apply(null,arguments)};var _emscripten_bind_gp_Dir_Transformed_1=Module["_emscripten_bind_gp_Dir_Transformed_1"]=function(){return(_emscripten_bind_gp_Dir_Transformed_1=Module["_emscripten_bind_gp_Dir_Transformed_1"]=Module["asm"]["zw"]).apply(null,arguments)};var _emscripten_bind_gp_Dir___destroy___0=Module["_emscripten_bind_gp_Dir___destroy___0"]=function(){return(_emscripten_bind_gp_Dir___destroy___0=Module["_emscripten_bind_gp_Dir___destroy___0"]=Module["asm"]["Aw"]).apply(null,arguments)};var _emscripten_bind_GC_MakeSegment_GC_MakeSegment_2=Module["_emscripten_bind_GC_MakeSegment_GC_MakeSegment_2"]=function(){return(_emscripten_bind_GC_MakeSegment_GC_MakeSegment_2=Module["_emscripten_bind_GC_MakeSegment_GC_MakeSegment_2"]=Module["asm"]["Bw"]).apply(null,arguments)};var _emscripten_bind_GC_MakeSegment_GC_MakeSegment_3=Module["_emscripten_bind_GC_MakeSegment_GC_MakeSegment_3"]=function(){return(_emscripten_bind_GC_MakeSegment_GC_MakeSegment_3=Module["_emscripten_bind_GC_MakeSegment_GC_MakeSegment_3"]=Module["asm"]["Cw"]).apply(null,arguments)};var _emscripten_bind_GC_MakeSegment_Value_0=Module["_emscripten_bind_GC_MakeSegment_Value_0"]=function(){return(_emscripten_bind_GC_MakeSegment_Value_0=Module["_emscripten_bind_GC_MakeSegment_Value_0"]=Module["asm"]["Dw"]).apply(null,arguments)};var _emscripten_bind_GC_MakeSegment___destroy___0=Module["_emscripten_bind_GC_MakeSegment___destroy___0"]=function(){return(_emscripten_bind_GC_MakeSegment___destroy___0=Module["_emscripten_bind_GC_MakeSegment___destroy___0"]=Module["asm"]["Ew"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_Bnd_Box_0=Module["_emscripten_bind_Bnd_Box_Bnd_Box_0"]=function(){return(_emscripten_bind_Bnd_Box_Bnd_Box_0=Module["_emscripten_bind_Bnd_Box_Bnd_Box_0"]=Module["asm"]["Fw"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_Bnd_Box_2=Module["_emscripten_bind_Bnd_Box_Bnd_Box_2"]=function(){return(_emscripten_bind_Bnd_Box_Bnd_Box_2=Module["_emscripten_bind_Bnd_Box_Bnd_Box_2"]=Module["asm"]["Gw"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_SetWhole_0=Module["_emscripten_bind_Bnd_Box_SetWhole_0"]=function(){return(_emscripten_bind_Bnd_Box_SetWhole_0=Module["_emscripten_bind_Bnd_Box_SetWhole_0"]=Module["asm"]["Hw"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_SetVoid_0=Module["_emscripten_bind_Bnd_Box_SetVoid_0"]=function(){return(_emscripten_bind_Bnd_Box_SetVoid_0=Module["_emscripten_bind_Bnd_Box_SetVoid_0"]=Module["asm"]["Iw"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_Set_1=Module["_emscripten_bind_Bnd_Box_Set_1"]=function(){return(_emscripten_bind_Bnd_Box_Set_1=Module["_emscripten_bind_Bnd_Box_Set_1"]=Module["asm"]["Jw"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_Set_2=Module["_emscripten_bind_Bnd_Box_Set_2"]=function(){return(_emscripten_bind_Bnd_Box_Set_2=Module["_emscripten_bind_Bnd_Box_Set_2"]=Module["asm"]["Kw"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_Update_3=Module["_emscripten_bind_Bnd_Box_Update_3"]=function(){return(_emscripten_bind_Bnd_Box_Update_3=Module["_emscripten_bind_Bnd_Box_Update_3"]=Module["asm"]["Lw"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_Update_6=Module["_emscripten_bind_Bnd_Box_Update_6"]=function(){return(_emscripten_bind_Bnd_Box_Update_6=Module["_emscripten_bind_Bnd_Box_Update_6"]=Module["asm"]["Mw"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_GetGap_0=Module["_emscripten_bind_Bnd_Box_GetGap_0"]=function(){return(_emscripten_bind_Bnd_Box_GetGap_0=Module["_emscripten_bind_Bnd_Box_GetGap_0"]=Module["asm"]["Nw"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_SetGap_1=Module["_emscripten_bind_Bnd_Box_SetGap_1"]=function(){return(_emscripten_bind_Bnd_Box_SetGap_1=Module["_emscripten_bind_Bnd_Box_SetGap_1"]=Module["asm"]["Ow"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_Enlarge_1=Module["_emscripten_bind_Bnd_Box_Enlarge_1"]=function(){return(_emscripten_bind_Bnd_Box_Enlarge_1=Module["_emscripten_bind_Bnd_Box_Enlarge_1"]=Module["asm"]["Pw"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_GetXmin_0=Module["_emscripten_bind_Bnd_Box_GetXmin_0"]=function(){return(_emscripten_bind_Bnd_Box_GetXmin_0=Module["_emscripten_bind_Bnd_Box_GetXmin_0"]=Module["asm"]["Qw"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_GetXmax_0=Module["_emscripten_bind_Bnd_Box_GetXmax_0"]=function(){return(_emscripten_bind_Bnd_Box_GetXmax_0=Module["_emscripten_bind_Bnd_Box_GetXmax_0"]=Module["asm"]["Rw"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_GetYmin_0=Module["_emscripten_bind_Bnd_Box_GetYmin_0"]=function(){return(_emscripten_bind_Bnd_Box_GetYmin_0=Module["_emscripten_bind_Bnd_Box_GetYmin_0"]=Module["asm"]["Sw"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_GetYmax_0=Module["_emscripten_bind_Bnd_Box_GetYmax_0"]=function(){return(_emscripten_bind_Bnd_Box_GetYmax_0=Module["_emscripten_bind_Bnd_Box_GetYmax_0"]=Module["asm"]["Tw"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_GetZmin_0=Module["_emscripten_bind_Bnd_Box_GetZmin_0"]=function(){return(_emscripten_bind_Bnd_Box_GetZmin_0=Module["_emscripten_bind_Bnd_Box_GetZmin_0"]=Module["asm"]["Uw"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_GetZmax_0=Module["_emscripten_bind_Bnd_Box_GetZmax_0"]=function(){return(_emscripten_bind_Bnd_Box_GetZmax_0=Module["_emscripten_bind_Bnd_Box_GetZmax_0"]=Module["asm"]["Vw"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_CornerMin_0=Module["_emscripten_bind_Bnd_Box_CornerMin_0"]=function(){return(_emscripten_bind_Bnd_Box_CornerMin_0=Module["_emscripten_bind_Bnd_Box_CornerMin_0"]=Module["asm"]["Ww"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_CornerMax_0=Module["_emscripten_bind_Bnd_Box_CornerMax_0"]=function(){return(_emscripten_bind_Bnd_Box_CornerMax_0=Module["_emscripten_bind_Bnd_Box_CornerMax_0"]=Module["asm"]["Xw"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_OpenXmin_0=Module["_emscripten_bind_Bnd_Box_OpenXmin_0"]=function(){return(_emscripten_bind_Bnd_Box_OpenXmin_0=Module["_emscripten_bind_Bnd_Box_OpenXmin_0"]=Module["asm"]["Yw"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_OpenXmax_0=Module["_emscripten_bind_Bnd_Box_OpenXmax_0"]=function(){return(_emscripten_bind_Bnd_Box_OpenXmax_0=Module["_emscripten_bind_Bnd_Box_OpenXmax_0"]=Module["asm"]["Zw"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_OpenYmin_0=Module["_emscripten_bind_Bnd_Box_OpenYmin_0"]=function(){return(_emscripten_bind_Bnd_Box_OpenYmin_0=Module["_emscripten_bind_Bnd_Box_OpenYmin_0"]=Module["asm"]["_w"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_OpenYmax_0=Module["_emscripten_bind_Bnd_Box_OpenYmax_0"]=function(){return(_emscripten_bind_Bnd_Box_OpenYmax_0=Module["_emscripten_bind_Bnd_Box_OpenYmax_0"]=Module["asm"]["$w"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_OpenZmin_0=Module["_emscripten_bind_Bnd_Box_OpenZmin_0"]=function(){return(_emscripten_bind_Bnd_Box_OpenZmin_0=Module["_emscripten_bind_Bnd_Box_OpenZmin_0"]=Module["asm"]["ax"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_OpenZmax_0=Module["_emscripten_bind_Bnd_Box_OpenZmax_0"]=function(){return(_emscripten_bind_Bnd_Box_OpenZmax_0=Module["_emscripten_bind_Bnd_Box_OpenZmax_0"]=Module["asm"]["bx"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_IsOpen_0=Module["_emscripten_bind_Bnd_Box_IsOpen_0"]=function(){return(_emscripten_bind_Bnd_Box_IsOpen_0=Module["_emscripten_bind_Bnd_Box_IsOpen_0"]=Module["asm"]["cx"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_IsOpenXmin_0=Module["_emscripten_bind_Bnd_Box_IsOpenXmin_0"]=function(){return(_emscripten_bind_Bnd_Box_IsOpenXmin_0=Module["_emscripten_bind_Bnd_Box_IsOpenXmin_0"]=Module["asm"]["dx"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_IsOpenXmax_0=Module["_emscripten_bind_Bnd_Box_IsOpenXmax_0"]=function(){return(_emscripten_bind_Bnd_Box_IsOpenXmax_0=Module["_emscripten_bind_Bnd_Box_IsOpenXmax_0"]=Module["asm"]["ex"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_IsOpenYmin_0=Module["_emscripten_bind_Bnd_Box_IsOpenYmin_0"]=function(){return(_emscripten_bind_Bnd_Box_IsOpenYmin_0=Module["_emscripten_bind_Bnd_Box_IsOpenYmin_0"]=Module["asm"]["fx"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_IsOpenYmax_0=Module["_emscripten_bind_Bnd_Box_IsOpenYmax_0"]=function(){return(_emscripten_bind_Bnd_Box_IsOpenYmax_0=Module["_emscripten_bind_Bnd_Box_IsOpenYmax_0"]=Module["asm"]["gx"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_IsOpenZmin_0=Module["_emscripten_bind_Bnd_Box_IsOpenZmin_0"]=function(){return(_emscripten_bind_Bnd_Box_IsOpenZmin_0=Module["_emscripten_bind_Bnd_Box_IsOpenZmin_0"]=Module["asm"]["hx"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_IsOpenZmax_0=Module["_emscripten_bind_Bnd_Box_IsOpenZmax_0"]=function(){return(_emscripten_bind_Bnd_Box_IsOpenZmax_0=Module["_emscripten_bind_Bnd_Box_IsOpenZmax_0"]=Module["asm"]["ix"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_IsWhole_0=Module["_emscripten_bind_Bnd_Box_IsWhole_0"]=function(){return(_emscripten_bind_Bnd_Box_IsWhole_0=Module["_emscripten_bind_Bnd_Box_IsWhole_0"]=Module["asm"]["jx"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_IsVoid_0=Module["_emscripten_bind_Bnd_Box_IsVoid_0"]=function(){return(_emscripten_bind_Bnd_Box_IsVoid_0=Module["_emscripten_bind_Bnd_Box_IsVoid_0"]=Module["asm"]["kx"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_IsXThin_1=Module["_emscripten_bind_Bnd_Box_IsXThin_1"]=function(){return(_emscripten_bind_Bnd_Box_IsXThin_1=Module["_emscripten_bind_Bnd_Box_IsXThin_1"]=Module["asm"]["lx"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_IsYThin_1=Module["_emscripten_bind_Bnd_Box_IsYThin_1"]=function(){return(_emscripten_bind_Bnd_Box_IsYThin_1=Module["_emscripten_bind_Bnd_Box_IsYThin_1"]=Module["asm"]["mx"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_IsZThin_1=Module["_emscripten_bind_Bnd_Box_IsZThin_1"]=function(){return(_emscripten_bind_Bnd_Box_IsZThin_1=Module["_emscripten_bind_Bnd_Box_IsZThin_1"]=Module["asm"]["nx"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_IsThin_1=Module["_emscripten_bind_Bnd_Box_IsThin_1"]=function(){return(_emscripten_bind_Bnd_Box_IsThin_1=Module["_emscripten_bind_Bnd_Box_IsThin_1"]=Module["asm"]["ox"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_Transformed_1=Module["_emscripten_bind_Bnd_Box_Transformed_1"]=function(){return(_emscripten_bind_Bnd_Box_Transformed_1=Module["_emscripten_bind_Bnd_Box_Transformed_1"]=Module["asm"]["px"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_Add_1=Module["_emscripten_bind_Bnd_Box_Add_1"]=function(){return(_emscripten_bind_Bnd_Box_Add_1=Module["_emscripten_bind_Bnd_Box_Add_1"]=Module["asm"]["qx"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_Add_2=Module["_emscripten_bind_Bnd_Box_Add_2"]=function(){return(_emscripten_bind_Bnd_Box_Add_2=Module["_emscripten_bind_Bnd_Box_Add_2"]=Module["asm"]["rx"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_IsOut_1=Module["_emscripten_bind_Bnd_Box_IsOut_1"]=function(){return(_emscripten_bind_Bnd_Box_IsOut_1=Module["_emscripten_bind_Bnd_Box_IsOut_1"]=Module["asm"]["sx"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_IsOut_2=Module["_emscripten_bind_Bnd_Box_IsOut_2"]=function(){return(_emscripten_bind_Bnd_Box_IsOut_2=Module["_emscripten_bind_Bnd_Box_IsOut_2"]=Module["asm"]["tx"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_IsOut_3=Module["_emscripten_bind_Bnd_Box_IsOut_3"]=function(){return(_emscripten_bind_Bnd_Box_IsOut_3=Module["_emscripten_bind_Bnd_Box_IsOut_3"]=Module["asm"]["ux"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_Distance_1=Module["_emscripten_bind_Bnd_Box_Distance_1"]=function(){return(_emscripten_bind_Bnd_Box_Distance_1=Module["_emscripten_bind_Bnd_Box_Distance_1"]=Module["asm"]["vx"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_Dump_0=Module["_emscripten_bind_Bnd_Box_Dump_0"]=function(){return(_emscripten_bind_Bnd_Box_Dump_0=Module["_emscripten_bind_Bnd_Box_Dump_0"]=Module["asm"]["wx"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_SquareExtent_0=Module["_emscripten_bind_Bnd_Box_SquareExtent_0"]=function(){return(_emscripten_bind_Bnd_Box_SquareExtent_0=Module["_emscripten_bind_Bnd_Box_SquareExtent_0"]=Module["asm"]["xx"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_FinitePart_0=Module["_emscripten_bind_Bnd_Box_FinitePart_0"]=function(){return(_emscripten_bind_Bnd_Box_FinitePart_0=Module["_emscripten_bind_Bnd_Box_FinitePart_0"]=Module["asm"]["yx"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box_HasFinitePart_0=Module["_emscripten_bind_Bnd_Box_HasFinitePart_0"]=function(){return(_emscripten_bind_Bnd_Box_HasFinitePart_0=Module["_emscripten_bind_Bnd_Box_HasFinitePart_0"]=Module["asm"]["zx"]).apply(null,arguments)};var _emscripten_bind_Bnd_Box___destroy___0=Module["_emscripten_bind_Bnd_Box___destroy___0"]=function(){return(_emscripten_bind_Bnd_Box___destroy___0=Module["_emscripten_bind_Bnd_Box___destroy___0"]=Module["asm"]["Ax"]).apply(null,arguments)};var _emscripten_bind_StlAPI_Reader_StlAPI_Reader_0=Module["_emscripten_bind_StlAPI_Reader_StlAPI_Reader_0"]=function(){return(_emscripten_bind_StlAPI_Reader_StlAPI_Reader_0=Module["_emscripten_bind_StlAPI_Reader_StlAPI_Reader_0"]=Module["asm"]["Bx"]).apply(null,arguments)};var _emscripten_bind_StlAPI_Reader_Read_2=Module["_emscripten_bind_StlAPI_Reader_Read_2"]=function(){return(_emscripten_bind_StlAPI_Reader_Read_2=Module["_emscripten_bind_StlAPI_Reader_Read_2"]=Module["asm"]["Cx"]).apply(null,arguments)};var _emscripten_bind_StlAPI_Reader___destroy___0=Module["_emscripten_bind_StlAPI_Reader___destroy___0"]=function(){return(_emscripten_bind_StlAPI_Reader___destroy___0=Module["_emscripten_bind_StlAPI_Reader___destroy___0"]=Module["asm"]["Dx"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_TopoDS_Solid_0=Module["_emscripten_bind_TopoDS_Solid_TopoDS_Solid_0"]=function(){return(_emscripten_bind_TopoDS_Solid_TopoDS_Solid_0=Module["_emscripten_bind_TopoDS_Solid_TopoDS_Solid_0"]=Module["asm"]["Ex"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_TopoDS_Solid_1=Module["_emscripten_bind_TopoDS_Solid_TopoDS_Solid_1"]=function(){return(_emscripten_bind_TopoDS_Solid_TopoDS_Solid_1=Module["_emscripten_bind_TopoDS_Solid_TopoDS_Solid_1"]=Module["asm"]["Fx"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_IsNull_0=Module["_emscripten_bind_TopoDS_Solid_IsNull_0"]=function(){return(_emscripten_bind_TopoDS_Solid_IsNull_0=Module["_emscripten_bind_TopoDS_Solid_IsNull_0"]=Module["asm"]["Gx"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_Nullify_0=Module["_emscripten_bind_TopoDS_Solid_Nullify_0"]=function(){return(_emscripten_bind_TopoDS_Solid_Nullify_0=Module["_emscripten_bind_TopoDS_Solid_Nullify_0"]=Module["asm"]["Hx"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_Location_0=Module["_emscripten_bind_TopoDS_Solid_Location_0"]=function(){return(_emscripten_bind_TopoDS_Solid_Location_0=Module["_emscripten_bind_TopoDS_Solid_Location_0"]=Module["asm"]["Ix"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_Located_1=Module["_emscripten_bind_TopoDS_Solid_Located_1"]=function(){return(_emscripten_bind_TopoDS_Solid_Located_1=Module["_emscripten_bind_TopoDS_Solid_Located_1"]=Module["asm"]["Jx"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_Orientation_0=Module["_emscripten_bind_TopoDS_Solid_Orientation_0"]=function(){return(_emscripten_bind_TopoDS_Solid_Orientation_0=Module["_emscripten_bind_TopoDS_Solid_Orientation_0"]=Module["asm"]["Kx"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_Oriented_1=Module["_emscripten_bind_TopoDS_Solid_Oriented_1"]=function(){return(_emscripten_bind_TopoDS_Solid_Oriented_1=Module["_emscripten_bind_TopoDS_Solid_Oriented_1"]=Module["asm"]["Lx"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_ShapeType_0=Module["_emscripten_bind_TopoDS_Solid_ShapeType_0"]=function(){return(_emscripten_bind_TopoDS_Solid_ShapeType_0=Module["_emscripten_bind_TopoDS_Solid_ShapeType_0"]=Module["asm"]["Mx"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_Free_0=Module["_emscripten_bind_TopoDS_Solid_Free_0"]=function(){return(_emscripten_bind_TopoDS_Solid_Free_0=Module["_emscripten_bind_TopoDS_Solid_Free_0"]=Module["asm"]["Nx"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_Locked_0=Module["_emscripten_bind_TopoDS_Solid_Locked_0"]=function(){return(_emscripten_bind_TopoDS_Solid_Locked_0=Module["_emscripten_bind_TopoDS_Solid_Locked_0"]=Module["asm"]["Ox"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_Modified_0=Module["_emscripten_bind_TopoDS_Solid_Modified_0"]=function(){return(_emscripten_bind_TopoDS_Solid_Modified_0=Module["_emscripten_bind_TopoDS_Solid_Modified_0"]=Module["asm"]["Px"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_Checked_0=Module["_emscripten_bind_TopoDS_Solid_Checked_0"]=function(){return(_emscripten_bind_TopoDS_Solid_Checked_0=Module["_emscripten_bind_TopoDS_Solid_Checked_0"]=Module["asm"]["Qx"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_Orientable_0=Module["_emscripten_bind_TopoDS_Solid_Orientable_0"]=function(){return(_emscripten_bind_TopoDS_Solid_Orientable_0=Module["_emscripten_bind_TopoDS_Solid_Orientable_0"]=Module["asm"]["Rx"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_Closed_0=Module["_emscripten_bind_TopoDS_Solid_Closed_0"]=function(){return(_emscripten_bind_TopoDS_Solid_Closed_0=Module["_emscripten_bind_TopoDS_Solid_Closed_0"]=Module["asm"]["Sx"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_Infinite_0=Module["_emscripten_bind_TopoDS_Solid_Infinite_0"]=function(){return(_emscripten_bind_TopoDS_Solid_Infinite_0=Module["_emscripten_bind_TopoDS_Solid_Infinite_0"]=Module["asm"]["Tx"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_Convex_0=Module["_emscripten_bind_TopoDS_Solid_Convex_0"]=function(){return(_emscripten_bind_TopoDS_Solid_Convex_0=Module["_emscripten_bind_TopoDS_Solid_Convex_0"]=Module["asm"]["Ux"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_Move_1=Module["_emscripten_bind_TopoDS_Solid_Move_1"]=function(){return(_emscripten_bind_TopoDS_Solid_Move_1=Module["_emscripten_bind_TopoDS_Solid_Move_1"]=Module["asm"]["Vx"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_Moved_1=Module["_emscripten_bind_TopoDS_Solid_Moved_1"]=function(){return(_emscripten_bind_TopoDS_Solid_Moved_1=Module["_emscripten_bind_TopoDS_Solid_Moved_1"]=Module["asm"]["Wx"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_Reverse_0=Module["_emscripten_bind_TopoDS_Solid_Reverse_0"]=function(){return(_emscripten_bind_TopoDS_Solid_Reverse_0=Module["_emscripten_bind_TopoDS_Solid_Reverse_0"]=Module["asm"]["Xx"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_Reversed_0=Module["_emscripten_bind_TopoDS_Solid_Reversed_0"]=function(){return(_emscripten_bind_TopoDS_Solid_Reversed_0=Module["_emscripten_bind_TopoDS_Solid_Reversed_0"]=Module["asm"]["Yx"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_Complement_0=Module["_emscripten_bind_TopoDS_Solid_Complement_0"]=function(){return(_emscripten_bind_TopoDS_Solid_Complement_0=Module["_emscripten_bind_TopoDS_Solid_Complement_0"]=Module["asm"]["Zx"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_Complemented_0=Module["_emscripten_bind_TopoDS_Solid_Complemented_0"]=function(){return(_emscripten_bind_TopoDS_Solid_Complemented_0=Module["_emscripten_bind_TopoDS_Solid_Complemented_0"]=Module["asm"]["_x"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_Compose_1=Module["_emscripten_bind_TopoDS_Solid_Compose_1"]=function(){return(_emscripten_bind_TopoDS_Solid_Compose_1=Module["_emscripten_bind_TopoDS_Solid_Compose_1"]=Module["asm"]["$x"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_Composed_1=Module["_emscripten_bind_TopoDS_Solid_Composed_1"]=function(){return(_emscripten_bind_TopoDS_Solid_Composed_1=Module["_emscripten_bind_TopoDS_Solid_Composed_1"]=Module["asm"]["ay"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_NbChildren_0=Module["_emscripten_bind_TopoDS_Solid_NbChildren_0"]=function(){return(_emscripten_bind_TopoDS_Solid_NbChildren_0=Module["_emscripten_bind_TopoDS_Solid_NbChildren_0"]=Module["asm"]["by"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_IsPartner_1=Module["_emscripten_bind_TopoDS_Solid_IsPartner_1"]=function(){return(_emscripten_bind_TopoDS_Solid_IsPartner_1=Module["_emscripten_bind_TopoDS_Solid_IsPartner_1"]=Module["asm"]["cy"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_IsSame_1=Module["_emscripten_bind_TopoDS_Solid_IsSame_1"]=function(){return(_emscripten_bind_TopoDS_Solid_IsSame_1=Module["_emscripten_bind_TopoDS_Solid_IsSame_1"]=Module["asm"]["dy"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_IsEqual_1=Module["_emscripten_bind_TopoDS_Solid_IsEqual_1"]=function(){return(_emscripten_bind_TopoDS_Solid_IsEqual_1=Module["_emscripten_bind_TopoDS_Solid_IsEqual_1"]=Module["asm"]["ey"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_IsNotEqual_1=Module["_emscripten_bind_TopoDS_Solid_IsNotEqual_1"]=function(){return(_emscripten_bind_TopoDS_Solid_IsNotEqual_1=Module["_emscripten_bind_TopoDS_Solid_IsNotEqual_1"]=Module["asm"]["fy"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_HashCode_1=Module["_emscripten_bind_TopoDS_Solid_HashCode_1"]=function(){return(_emscripten_bind_TopoDS_Solid_HashCode_1=Module["_emscripten_bind_TopoDS_Solid_HashCode_1"]=Module["asm"]["gy"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_EmptyCopy_0=Module["_emscripten_bind_TopoDS_Solid_EmptyCopy_0"]=function(){return(_emscripten_bind_TopoDS_Solid_EmptyCopy_0=Module["_emscripten_bind_TopoDS_Solid_EmptyCopy_0"]=Module["asm"]["hy"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_EmptyCopied_0=Module["_emscripten_bind_TopoDS_Solid_EmptyCopied_0"]=function(){return(_emscripten_bind_TopoDS_Solid_EmptyCopied_0=Module["_emscripten_bind_TopoDS_Solid_EmptyCopied_0"]=Module["asm"]["iy"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid___destroy___0=Module["_emscripten_bind_TopoDS_Solid___destroy___0"]=function(){return(_emscripten_bind_TopoDS_Solid___destroy___0=Module["_emscripten_bind_TopoDS_Solid___destroy___0"]=Module["asm"]["jy"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_TopoDS_Edge_0=Module["_emscripten_bind_TopoDS_Edge_TopoDS_Edge_0"]=function(){return(_emscripten_bind_TopoDS_Edge_TopoDS_Edge_0=Module["_emscripten_bind_TopoDS_Edge_TopoDS_Edge_0"]=Module["asm"]["ky"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_TopoDS_Edge_1=Module["_emscripten_bind_TopoDS_Edge_TopoDS_Edge_1"]=function(){return(_emscripten_bind_TopoDS_Edge_TopoDS_Edge_1=Module["_emscripten_bind_TopoDS_Edge_TopoDS_Edge_1"]=Module["asm"]["ly"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_IsNull_0=Module["_emscripten_bind_TopoDS_Edge_IsNull_0"]=function(){return(_emscripten_bind_TopoDS_Edge_IsNull_0=Module["_emscripten_bind_TopoDS_Edge_IsNull_0"]=Module["asm"]["my"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_Nullify_0=Module["_emscripten_bind_TopoDS_Edge_Nullify_0"]=function(){return(_emscripten_bind_TopoDS_Edge_Nullify_0=Module["_emscripten_bind_TopoDS_Edge_Nullify_0"]=Module["asm"]["ny"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_Location_0=Module["_emscripten_bind_TopoDS_Edge_Location_0"]=function(){return(_emscripten_bind_TopoDS_Edge_Location_0=Module["_emscripten_bind_TopoDS_Edge_Location_0"]=Module["asm"]["oy"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_Located_1=Module["_emscripten_bind_TopoDS_Edge_Located_1"]=function(){return(_emscripten_bind_TopoDS_Edge_Located_1=Module["_emscripten_bind_TopoDS_Edge_Located_1"]=Module["asm"]["py"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_Orientation_0=Module["_emscripten_bind_TopoDS_Edge_Orientation_0"]=function(){return(_emscripten_bind_TopoDS_Edge_Orientation_0=Module["_emscripten_bind_TopoDS_Edge_Orientation_0"]=Module["asm"]["qy"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_Oriented_1=Module["_emscripten_bind_TopoDS_Edge_Oriented_1"]=function(){return(_emscripten_bind_TopoDS_Edge_Oriented_1=Module["_emscripten_bind_TopoDS_Edge_Oriented_1"]=Module["asm"]["ry"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_ShapeType_0=Module["_emscripten_bind_TopoDS_Edge_ShapeType_0"]=function(){return(_emscripten_bind_TopoDS_Edge_ShapeType_0=Module["_emscripten_bind_TopoDS_Edge_ShapeType_0"]=Module["asm"]["sy"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_Free_0=Module["_emscripten_bind_TopoDS_Edge_Free_0"]=function(){return(_emscripten_bind_TopoDS_Edge_Free_0=Module["_emscripten_bind_TopoDS_Edge_Free_0"]=Module["asm"]["ty"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_Locked_0=Module["_emscripten_bind_TopoDS_Edge_Locked_0"]=function(){return(_emscripten_bind_TopoDS_Edge_Locked_0=Module["_emscripten_bind_TopoDS_Edge_Locked_0"]=Module["asm"]["uy"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_Modified_0=Module["_emscripten_bind_TopoDS_Edge_Modified_0"]=function(){return(_emscripten_bind_TopoDS_Edge_Modified_0=Module["_emscripten_bind_TopoDS_Edge_Modified_0"]=Module["asm"]["vy"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_Checked_0=Module["_emscripten_bind_TopoDS_Edge_Checked_0"]=function(){return(_emscripten_bind_TopoDS_Edge_Checked_0=Module["_emscripten_bind_TopoDS_Edge_Checked_0"]=Module["asm"]["wy"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_Orientable_0=Module["_emscripten_bind_TopoDS_Edge_Orientable_0"]=function(){return(_emscripten_bind_TopoDS_Edge_Orientable_0=Module["_emscripten_bind_TopoDS_Edge_Orientable_0"]=Module["asm"]["xy"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_Closed_0=Module["_emscripten_bind_TopoDS_Edge_Closed_0"]=function(){return(_emscripten_bind_TopoDS_Edge_Closed_0=Module["_emscripten_bind_TopoDS_Edge_Closed_0"]=Module["asm"]["yy"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_Infinite_0=Module["_emscripten_bind_TopoDS_Edge_Infinite_0"]=function(){return(_emscripten_bind_TopoDS_Edge_Infinite_0=Module["_emscripten_bind_TopoDS_Edge_Infinite_0"]=Module["asm"]["zy"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_Convex_0=Module["_emscripten_bind_TopoDS_Edge_Convex_0"]=function(){return(_emscripten_bind_TopoDS_Edge_Convex_0=Module["_emscripten_bind_TopoDS_Edge_Convex_0"]=Module["asm"]["Ay"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_Move_1=Module["_emscripten_bind_TopoDS_Edge_Move_1"]=function(){return(_emscripten_bind_TopoDS_Edge_Move_1=Module["_emscripten_bind_TopoDS_Edge_Move_1"]=Module["asm"]["By"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_Moved_1=Module["_emscripten_bind_TopoDS_Edge_Moved_1"]=function(){return(_emscripten_bind_TopoDS_Edge_Moved_1=Module["_emscripten_bind_TopoDS_Edge_Moved_1"]=Module["asm"]["Cy"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_Reverse_0=Module["_emscripten_bind_TopoDS_Edge_Reverse_0"]=function(){return(_emscripten_bind_TopoDS_Edge_Reverse_0=Module["_emscripten_bind_TopoDS_Edge_Reverse_0"]=Module["asm"]["Dy"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_Reversed_0=Module["_emscripten_bind_TopoDS_Edge_Reversed_0"]=function(){return(_emscripten_bind_TopoDS_Edge_Reversed_0=Module["_emscripten_bind_TopoDS_Edge_Reversed_0"]=Module["asm"]["Ey"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_Complement_0=Module["_emscripten_bind_TopoDS_Edge_Complement_0"]=function(){return(_emscripten_bind_TopoDS_Edge_Complement_0=Module["_emscripten_bind_TopoDS_Edge_Complement_0"]=Module["asm"]["Fy"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_Complemented_0=Module["_emscripten_bind_TopoDS_Edge_Complemented_0"]=function(){return(_emscripten_bind_TopoDS_Edge_Complemented_0=Module["_emscripten_bind_TopoDS_Edge_Complemented_0"]=Module["asm"]["Gy"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_Compose_1=Module["_emscripten_bind_TopoDS_Edge_Compose_1"]=function(){return(_emscripten_bind_TopoDS_Edge_Compose_1=Module["_emscripten_bind_TopoDS_Edge_Compose_1"]=Module["asm"]["Hy"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_Composed_1=Module["_emscripten_bind_TopoDS_Edge_Composed_1"]=function(){return(_emscripten_bind_TopoDS_Edge_Composed_1=Module["_emscripten_bind_TopoDS_Edge_Composed_1"]=Module["asm"]["Iy"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_NbChildren_0=Module["_emscripten_bind_TopoDS_Edge_NbChildren_0"]=function(){return(_emscripten_bind_TopoDS_Edge_NbChildren_0=Module["_emscripten_bind_TopoDS_Edge_NbChildren_0"]=Module["asm"]["Jy"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_IsPartner_1=Module["_emscripten_bind_TopoDS_Edge_IsPartner_1"]=function(){return(_emscripten_bind_TopoDS_Edge_IsPartner_1=Module["_emscripten_bind_TopoDS_Edge_IsPartner_1"]=Module["asm"]["Ky"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_IsSame_1=Module["_emscripten_bind_TopoDS_Edge_IsSame_1"]=function(){return(_emscripten_bind_TopoDS_Edge_IsSame_1=Module["_emscripten_bind_TopoDS_Edge_IsSame_1"]=Module["asm"]["Ly"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_IsEqual_1=Module["_emscripten_bind_TopoDS_Edge_IsEqual_1"]=function(){return(_emscripten_bind_TopoDS_Edge_IsEqual_1=Module["_emscripten_bind_TopoDS_Edge_IsEqual_1"]=Module["asm"]["My"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_IsNotEqual_1=Module["_emscripten_bind_TopoDS_Edge_IsNotEqual_1"]=function(){return(_emscripten_bind_TopoDS_Edge_IsNotEqual_1=Module["_emscripten_bind_TopoDS_Edge_IsNotEqual_1"]=Module["asm"]["Ny"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_HashCode_1=Module["_emscripten_bind_TopoDS_Edge_HashCode_1"]=function(){return(_emscripten_bind_TopoDS_Edge_HashCode_1=Module["_emscripten_bind_TopoDS_Edge_HashCode_1"]=Module["asm"]["Oy"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_EmptyCopy_0=Module["_emscripten_bind_TopoDS_Edge_EmptyCopy_0"]=function(){return(_emscripten_bind_TopoDS_Edge_EmptyCopy_0=Module["_emscripten_bind_TopoDS_Edge_EmptyCopy_0"]=Module["asm"]["Py"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_EmptyCopied_0=Module["_emscripten_bind_TopoDS_Edge_EmptyCopied_0"]=function(){return(_emscripten_bind_TopoDS_Edge_EmptyCopied_0=Module["_emscripten_bind_TopoDS_Edge_EmptyCopied_0"]=Module["asm"]["Qy"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge___destroy___0=Module["_emscripten_bind_TopoDS_Edge___destroy___0"]=function(){return(_emscripten_bind_TopoDS_Edge___destroy___0=Module["_emscripten_bind_TopoDS_Edge___destroy___0"]=Module["asm"]["Ry"]).apply(null,arguments)};var _emscripten_bind_gp_Hypr_gp_Hypr_0=Module["_emscripten_bind_gp_Hypr_gp_Hypr_0"]=function(){return(_emscripten_bind_gp_Hypr_gp_Hypr_0=Module["_emscripten_bind_gp_Hypr_gp_Hypr_0"]=Module["asm"]["Sy"]).apply(null,arguments)};var _emscripten_bind_gp_Hypr_gp_Hypr_3=Module["_emscripten_bind_gp_Hypr_gp_Hypr_3"]=function(){return(_emscripten_bind_gp_Hypr_gp_Hypr_3=Module["_emscripten_bind_gp_Hypr_gp_Hypr_3"]=Module["asm"]["Ty"]).apply(null,arguments)};var _emscripten_bind_gp_Hypr_Eccentricity_0=Module["_emscripten_bind_gp_Hypr_Eccentricity_0"]=function(){return(_emscripten_bind_gp_Hypr_Eccentricity_0=Module["_emscripten_bind_gp_Hypr_Eccentricity_0"]=Module["asm"]["Uy"]).apply(null,arguments)};var _emscripten_bind_gp_Hypr_Focal_0=Module["_emscripten_bind_gp_Hypr_Focal_0"]=function(){return(_emscripten_bind_gp_Hypr_Focal_0=Module["_emscripten_bind_gp_Hypr_Focal_0"]=Module["asm"]["Vy"]).apply(null,arguments)};var _emscripten_bind_gp_Hypr_MajorRadius_0=Module["_emscripten_bind_gp_Hypr_MajorRadius_0"]=function(){return(_emscripten_bind_gp_Hypr_MajorRadius_0=Module["_emscripten_bind_gp_Hypr_MajorRadius_0"]=Module["asm"]["Wy"]).apply(null,arguments)};var _emscripten_bind_gp_Hypr_MinorRadius_0=Module["_emscripten_bind_gp_Hypr_MinorRadius_0"]=function(){return(_emscripten_bind_gp_Hypr_MinorRadius_0=Module["_emscripten_bind_gp_Hypr_MinorRadius_0"]=Module["asm"]["Xy"]).apply(null,arguments)};var _emscripten_bind_gp_Hypr___destroy___0=Module["_emscripten_bind_gp_Hypr___destroy___0"]=function(){return(_emscripten_bind_gp_Hypr___destroy___0=Module["_emscripten_bind_gp_Hypr___destroy___0"]=Module["asm"]["Yy"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeEdge_BRepBuilderAPI_MakeEdge_1=Module["_emscripten_bind_BRepBuilderAPI_MakeEdge_BRepBuilderAPI_MakeEdge_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeEdge_BRepBuilderAPI_MakeEdge_1=Module["_emscripten_bind_BRepBuilderAPI_MakeEdge_BRepBuilderAPI_MakeEdge_1"]=Module["asm"]["Zy"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeEdge_BRepBuilderAPI_MakeEdge_2=Module["_emscripten_bind_BRepBuilderAPI_MakeEdge_BRepBuilderAPI_MakeEdge_2"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeEdge_BRepBuilderAPI_MakeEdge_2=Module["_emscripten_bind_BRepBuilderAPI_MakeEdge_BRepBuilderAPI_MakeEdge_2"]=Module["asm"]["_y"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeEdge_Edge_0=Module["_emscripten_bind_BRepBuilderAPI_MakeEdge_Edge_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeEdge_Edge_0=Module["_emscripten_bind_BRepBuilderAPI_MakeEdge_Edge_0"]=Module["asm"]["$y"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeEdge___destroy___0=Module["_emscripten_bind_BRepBuilderAPI_MakeEdge___destroy___0"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeEdge___destroy___0=Module["_emscripten_bind_BRepBuilderAPI_MakeEdge___destroy___0"]=Module["asm"]["az"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_BRepBuilderAPI_Sewing_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_BRepBuilderAPI_Sewing_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_BRepBuilderAPI_Sewing_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_BRepBuilderAPI_Sewing_0"]=Module["asm"]["bz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_BRepBuilderAPI_Sewing_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_BRepBuilderAPI_Sewing_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_BRepBuilderAPI_Sewing_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_BRepBuilderAPI_Sewing_1"]=Module["asm"]["cz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_BRepBuilderAPI_Sewing_2=Module["_emscripten_bind_BRepBuilderAPI_Sewing_BRepBuilderAPI_Sewing_2"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_BRepBuilderAPI_Sewing_2=Module["_emscripten_bind_BRepBuilderAPI_Sewing_BRepBuilderAPI_Sewing_2"]=Module["asm"]["dz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_BRepBuilderAPI_Sewing_3=Module["_emscripten_bind_BRepBuilderAPI_Sewing_BRepBuilderAPI_Sewing_3"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_BRepBuilderAPI_Sewing_3=Module["_emscripten_bind_BRepBuilderAPI_Sewing_BRepBuilderAPI_Sewing_3"]=Module["asm"]["ez"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_BRepBuilderAPI_Sewing_4=Module["_emscripten_bind_BRepBuilderAPI_Sewing_BRepBuilderAPI_Sewing_4"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_BRepBuilderAPI_Sewing_4=Module["_emscripten_bind_BRepBuilderAPI_Sewing_BRepBuilderAPI_Sewing_4"]=Module["asm"]["fz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_BRepBuilderAPI_Sewing_5=Module["_emscripten_bind_BRepBuilderAPI_Sewing_BRepBuilderAPI_Sewing_5"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_BRepBuilderAPI_Sewing_5=Module["_emscripten_bind_BRepBuilderAPI_Sewing_BRepBuilderAPI_Sewing_5"]=Module["asm"]["gz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_Init_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_Init_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_Init_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_Init_0"]=Module["asm"]["hz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_Init_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_Init_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_Init_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_Init_1"]=Module["asm"]["iz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_Init_2=Module["_emscripten_bind_BRepBuilderAPI_Sewing_Init_2"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_Init_2=Module["_emscripten_bind_BRepBuilderAPI_Sewing_Init_2"]=Module["asm"]["jz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_Init_3=Module["_emscripten_bind_BRepBuilderAPI_Sewing_Init_3"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_Init_3=Module["_emscripten_bind_BRepBuilderAPI_Sewing_Init_3"]=Module["asm"]["kz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_Init_4=Module["_emscripten_bind_BRepBuilderAPI_Sewing_Init_4"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_Init_4=Module["_emscripten_bind_BRepBuilderAPI_Sewing_Init_4"]=Module["asm"]["lz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_Init_5=Module["_emscripten_bind_BRepBuilderAPI_Sewing_Init_5"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_Init_5=Module["_emscripten_bind_BRepBuilderAPI_Sewing_Init_5"]=Module["asm"]["mz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_Load_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_Load_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_Load_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_Load_1"]=Module["asm"]["nz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_Add_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_Add_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_Add_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_Add_1"]=Module["asm"]["oz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_Perform_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_Perform_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_Perform_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_Perform_0"]=Module["asm"]["pz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_Perform_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_Perform_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_Perform_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_Perform_1"]=Module["asm"]["qz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_SewedShape_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_SewedShape_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_SewedShape_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_SewedShape_0"]=Module["asm"]["rz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_NbFreeEdges_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_NbFreeEdges_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_NbFreeEdges_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_NbFreeEdges_0"]=Module["asm"]["sz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_FreeEdge_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_FreeEdge_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_FreeEdge_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_FreeEdge_1"]=Module["asm"]["tz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_NbMultipleEdges_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_NbMultipleEdges_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_NbMultipleEdges_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_NbMultipleEdges_0"]=Module["asm"]["uz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_MultipleEdge_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_MultipleEdge_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_MultipleEdge_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_MultipleEdge_1"]=Module["asm"]["vz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_NbContigousEdges_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_NbContigousEdges_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_NbContigousEdges_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_NbContigousEdges_0"]=Module["asm"]["wz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_ContigousEdge_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_ContigousEdge_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_ContigousEdge_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_ContigousEdge_1"]=Module["asm"]["xz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_IsSectionBound_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_IsSectionBound_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_IsSectionBound_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_IsSectionBound_1"]=Module["asm"]["yz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_SectionToBoundary_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_SectionToBoundary_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_SectionToBoundary_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_SectionToBoundary_1"]=Module["asm"]["zz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_NbDegeneratedShapes_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_NbDegeneratedShapes_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_NbDegeneratedShapes_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_NbDegeneratedShapes_0"]=Module["asm"]["Az"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_DegeneratedShape_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_DegeneratedShape_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_DegeneratedShape_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_DegeneratedShape_1"]=Module["asm"]["Bz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_IsDegenerated_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_IsDegenerated_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_IsDegenerated_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_IsDegenerated_1"]=Module["asm"]["Cz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_IsModified_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_IsModified_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_IsModified_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_IsModified_1"]=Module["asm"]["Dz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_Modified_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_Modified_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_Modified_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_Modified_1"]=Module["asm"]["Ez"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_IsModifiedSubShape_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_IsModifiedSubShape_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_IsModifiedSubShape_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_IsModifiedSubShape_1"]=Module["asm"]["Fz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_ModifiedSubShape_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_ModifiedSubShape_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_ModifiedSubShape_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_ModifiedSubShape_1"]=Module["asm"]["Gz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_Dump_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_Dump_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_Dump_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_Dump_0"]=Module["asm"]["Hz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_NbDeletedFaces_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_NbDeletedFaces_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_NbDeletedFaces_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_NbDeletedFaces_0"]=Module["asm"]["Iz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_DeletedFace_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_DeletedFace_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_DeletedFace_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_DeletedFace_1"]=Module["asm"]["Jz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_WhichFace_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_WhichFace_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_WhichFace_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_WhichFace_1"]=Module["asm"]["Kz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_WhichFace_2=Module["_emscripten_bind_BRepBuilderAPI_Sewing_WhichFace_2"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_WhichFace_2=Module["_emscripten_bind_BRepBuilderAPI_Sewing_WhichFace_2"]=Module["asm"]["Lz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_SameParameterMode_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_SameParameterMode_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_SameParameterMode_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_SameParameterMode_0"]=Module["asm"]["Mz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_SetSameParameterMode_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_SetSameParameterMode_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_SetSameParameterMode_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_SetSameParameterMode_1"]=Module["asm"]["Nz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_Tolerance_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_Tolerance_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_Tolerance_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_Tolerance_0"]=Module["asm"]["Oz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_SetTolerance_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_SetTolerance_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_SetTolerance_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_SetTolerance_1"]=Module["asm"]["Pz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_MinTolerance_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_MinTolerance_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_MinTolerance_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_MinTolerance_0"]=Module["asm"]["Qz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_SetMinTolerance_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_SetMinTolerance_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_SetMinTolerance_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_SetMinTolerance_1"]=Module["asm"]["Rz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_MaxTolerance_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_MaxTolerance_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_MaxTolerance_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_MaxTolerance_0"]=Module["asm"]["Sz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_SetMaxTolerance_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_SetMaxTolerance_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_SetMaxTolerance_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_SetMaxTolerance_1"]=Module["asm"]["Tz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_FaceMode_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_FaceMode_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_FaceMode_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_FaceMode_0"]=Module["asm"]["Uz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_SetFaceMode_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_SetFaceMode_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_SetFaceMode_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_SetFaceMode_1"]=Module["asm"]["Vz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_FloatingEdgesMode_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_FloatingEdgesMode_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_FloatingEdgesMode_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_FloatingEdgesMode_0"]=Module["asm"]["Wz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_SetFloatingEdgesMode_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_SetFloatingEdgesMode_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_SetFloatingEdgesMode_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_SetFloatingEdgesMode_1"]=Module["asm"]["Xz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_LocalTolerancesMode_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_LocalTolerancesMode_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_LocalTolerancesMode_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_LocalTolerancesMode_0"]=Module["asm"]["Yz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_SetLocalTolerancesMode_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_SetLocalTolerancesMode_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_SetLocalTolerancesMode_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_SetLocalTolerancesMode_1"]=Module["asm"]["Zz"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_SetNonManifoldMode_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_SetNonManifoldMode_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_SetNonManifoldMode_1=Module["_emscripten_bind_BRepBuilderAPI_Sewing_SetNonManifoldMode_1"]=Module["asm"]["_z"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing_NonManifoldMode_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_NonManifoldMode_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing_NonManifoldMode_0=Module["_emscripten_bind_BRepBuilderAPI_Sewing_NonManifoldMode_0"]=Module["asm"]["$z"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Sewing___destroy___0=Module["_emscripten_bind_BRepBuilderAPI_Sewing___destroy___0"]=function(){return(_emscripten_bind_BRepBuilderAPI_Sewing___destroy___0=Module["_emscripten_bind_BRepBuilderAPI_Sewing___destroy___0"]=Module["asm"]["aA"]).apply(null,arguments)};var _emscripten_bind_BRepFilletAPI_MakeChamfer_BRepFilletAPI_MakeChamfer_1=Module["_emscripten_bind_BRepFilletAPI_MakeChamfer_BRepFilletAPI_MakeChamfer_1"]=function(){return(_emscripten_bind_BRepFilletAPI_MakeChamfer_BRepFilletAPI_MakeChamfer_1=Module["_emscripten_bind_BRepFilletAPI_MakeChamfer_BRepFilletAPI_MakeChamfer_1"]=Module["asm"]["bA"]).apply(null,arguments)};var _emscripten_bind_BRepFilletAPI_MakeChamfer_Add_2=Module["_emscripten_bind_BRepFilletAPI_MakeChamfer_Add_2"]=function(){return(_emscripten_bind_BRepFilletAPI_MakeChamfer_Add_2=Module["_emscripten_bind_BRepFilletAPI_MakeChamfer_Add_2"]=Module["asm"]["cA"]).apply(null,arguments)};var _emscripten_bind_BRepFilletAPI_MakeChamfer_Add_4=Module["_emscripten_bind_BRepFilletAPI_MakeChamfer_Add_4"]=function(){return(_emscripten_bind_BRepFilletAPI_MakeChamfer_Add_4=Module["_emscripten_bind_BRepFilletAPI_MakeChamfer_Add_4"]=Module["asm"]["dA"]).apply(null,arguments)};var _emscripten_bind_BRepFilletAPI_MakeChamfer_Shape_0=Module["_emscripten_bind_BRepFilletAPI_MakeChamfer_Shape_0"]=function(){return(_emscripten_bind_BRepFilletAPI_MakeChamfer_Shape_0=Module["_emscripten_bind_BRepFilletAPI_MakeChamfer_Shape_0"]=Module["asm"]["eA"]).apply(null,arguments)};var _emscripten_bind_BRepFilletAPI_MakeChamfer___destroy___0=Module["_emscripten_bind_BRepFilletAPI_MakeChamfer___destroy___0"]=function(){return(_emscripten_bind_BRepFilletAPI_MakeChamfer___destroy___0=Module["_emscripten_bind_BRepFilletAPI_MakeChamfer___destroy___0"]=Module["asm"]["fA"]).apply(null,arguments)};var _emscripten_bind_TColgp_Array1OfDir_TColgp_Array1OfDir_0=Module["_emscripten_bind_TColgp_Array1OfDir_TColgp_Array1OfDir_0"]=function(){return(_emscripten_bind_TColgp_Array1OfDir_TColgp_Array1OfDir_0=Module["_emscripten_bind_TColgp_Array1OfDir_TColgp_Array1OfDir_0"]=Module["asm"]["gA"]).apply(null,arguments)};var _emscripten_bind_TColgp_Array1OfDir_TColgp_Array1OfDir_2=Module["_emscripten_bind_TColgp_Array1OfDir_TColgp_Array1OfDir_2"]=function(){return(_emscripten_bind_TColgp_Array1OfDir_TColgp_Array1OfDir_2=Module["_emscripten_bind_TColgp_Array1OfDir_TColgp_Array1OfDir_2"]=Module["asm"]["hA"]).apply(null,arguments)};var _emscripten_bind_TColgp_Array1OfDir_Length_0=Module["_emscripten_bind_TColgp_Array1OfDir_Length_0"]=function(){return(_emscripten_bind_TColgp_Array1OfDir_Length_0=Module["_emscripten_bind_TColgp_Array1OfDir_Length_0"]=Module["asm"]["iA"]).apply(null,arguments)};var _emscripten_bind_TColgp_Array1OfDir_Lower_0=Module["_emscripten_bind_TColgp_Array1OfDir_Lower_0"]=function(){return(_emscripten_bind_TColgp_Array1OfDir_Lower_0=Module["_emscripten_bind_TColgp_Array1OfDir_Lower_0"]=Module["asm"]["jA"]).apply(null,arguments)};var _emscripten_bind_TColgp_Array1OfDir_Upper_0=Module["_emscripten_bind_TColgp_Array1OfDir_Upper_0"]=function(){return(_emscripten_bind_TColgp_Array1OfDir_Upper_0=Module["_emscripten_bind_TColgp_Array1OfDir_Upper_0"]=Module["asm"]["kA"]).apply(null,arguments)};var _emscripten_bind_TColgp_Array1OfDir_Value_1=Module["_emscripten_bind_TColgp_Array1OfDir_Value_1"]=function(){return(_emscripten_bind_TColgp_Array1OfDir_Value_1=Module["_emscripten_bind_TColgp_Array1OfDir_Value_1"]=Module["asm"]["lA"]).apply(null,arguments)};var _emscripten_bind_TColgp_Array1OfDir___destroy___0=Module["_emscripten_bind_TColgp_Array1OfDir___destroy___0"]=function(){return(_emscripten_bind_TColgp_Array1OfDir___destroy___0=Module["_emscripten_bind_TColgp_Array1OfDir___destroy___0"]=Module["asm"]["mA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_TopoDS_CompSolid_0=Module["_emscripten_bind_TopoDS_CompSolid_TopoDS_CompSolid_0"]=function(){return(_emscripten_bind_TopoDS_CompSolid_TopoDS_CompSolid_0=Module["_emscripten_bind_TopoDS_CompSolid_TopoDS_CompSolid_0"]=Module["asm"]["nA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_TopoDS_CompSolid_1=Module["_emscripten_bind_TopoDS_CompSolid_TopoDS_CompSolid_1"]=function(){return(_emscripten_bind_TopoDS_CompSolid_TopoDS_CompSolid_1=Module["_emscripten_bind_TopoDS_CompSolid_TopoDS_CompSolid_1"]=Module["asm"]["oA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_IsNull_0=Module["_emscripten_bind_TopoDS_CompSolid_IsNull_0"]=function(){return(_emscripten_bind_TopoDS_CompSolid_IsNull_0=Module["_emscripten_bind_TopoDS_CompSolid_IsNull_0"]=Module["asm"]["pA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_Nullify_0=Module["_emscripten_bind_TopoDS_CompSolid_Nullify_0"]=function(){return(_emscripten_bind_TopoDS_CompSolid_Nullify_0=Module["_emscripten_bind_TopoDS_CompSolid_Nullify_0"]=Module["asm"]["qA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_Location_0=Module["_emscripten_bind_TopoDS_CompSolid_Location_0"]=function(){return(_emscripten_bind_TopoDS_CompSolid_Location_0=Module["_emscripten_bind_TopoDS_CompSolid_Location_0"]=Module["asm"]["rA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_Located_1=Module["_emscripten_bind_TopoDS_CompSolid_Located_1"]=function(){return(_emscripten_bind_TopoDS_CompSolid_Located_1=Module["_emscripten_bind_TopoDS_CompSolid_Located_1"]=Module["asm"]["sA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_Orientation_0=Module["_emscripten_bind_TopoDS_CompSolid_Orientation_0"]=function(){return(_emscripten_bind_TopoDS_CompSolid_Orientation_0=Module["_emscripten_bind_TopoDS_CompSolid_Orientation_0"]=Module["asm"]["tA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_Oriented_1=Module["_emscripten_bind_TopoDS_CompSolid_Oriented_1"]=function(){return(_emscripten_bind_TopoDS_CompSolid_Oriented_1=Module["_emscripten_bind_TopoDS_CompSolid_Oriented_1"]=Module["asm"]["uA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_ShapeType_0=Module["_emscripten_bind_TopoDS_CompSolid_ShapeType_0"]=function(){return(_emscripten_bind_TopoDS_CompSolid_ShapeType_0=Module["_emscripten_bind_TopoDS_CompSolid_ShapeType_0"]=Module["asm"]["vA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_Free_0=Module["_emscripten_bind_TopoDS_CompSolid_Free_0"]=function(){return(_emscripten_bind_TopoDS_CompSolid_Free_0=Module["_emscripten_bind_TopoDS_CompSolid_Free_0"]=Module["asm"]["wA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_Locked_0=Module["_emscripten_bind_TopoDS_CompSolid_Locked_0"]=function(){return(_emscripten_bind_TopoDS_CompSolid_Locked_0=Module["_emscripten_bind_TopoDS_CompSolid_Locked_0"]=Module["asm"]["xA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_Modified_0=Module["_emscripten_bind_TopoDS_CompSolid_Modified_0"]=function(){return(_emscripten_bind_TopoDS_CompSolid_Modified_0=Module["_emscripten_bind_TopoDS_CompSolid_Modified_0"]=Module["asm"]["yA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_Checked_0=Module["_emscripten_bind_TopoDS_CompSolid_Checked_0"]=function(){return(_emscripten_bind_TopoDS_CompSolid_Checked_0=Module["_emscripten_bind_TopoDS_CompSolid_Checked_0"]=Module["asm"]["zA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_Orientable_0=Module["_emscripten_bind_TopoDS_CompSolid_Orientable_0"]=function(){return(_emscripten_bind_TopoDS_CompSolid_Orientable_0=Module["_emscripten_bind_TopoDS_CompSolid_Orientable_0"]=Module["asm"]["AA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_Closed_0=Module["_emscripten_bind_TopoDS_CompSolid_Closed_0"]=function(){return(_emscripten_bind_TopoDS_CompSolid_Closed_0=Module["_emscripten_bind_TopoDS_CompSolid_Closed_0"]=Module["asm"]["BA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_Infinite_0=Module["_emscripten_bind_TopoDS_CompSolid_Infinite_0"]=function(){return(_emscripten_bind_TopoDS_CompSolid_Infinite_0=Module["_emscripten_bind_TopoDS_CompSolid_Infinite_0"]=Module["asm"]["CA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_Convex_0=Module["_emscripten_bind_TopoDS_CompSolid_Convex_0"]=function(){return(_emscripten_bind_TopoDS_CompSolid_Convex_0=Module["_emscripten_bind_TopoDS_CompSolid_Convex_0"]=Module["asm"]["DA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_Move_1=Module["_emscripten_bind_TopoDS_CompSolid_Move_1"]=function(){return(_emscripten_bind_TopoDS_CompSolid_Move_1=Module["_emscripten_bind_TopoDS_CompSolid_Move_1"]=Module["asm"]["EA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_Moved_1=Module["_emscripten_bind_TopoDS_CompSolid_Moved_1"]=function(){return(_emscripten_bind_TopoDS_CompSolid_Moved_1=Module["_emscripten_bind_TopoDS_CompSolid_Moved_1"]=Module["asm"]["FA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_Reverse_0=Module["_emscripten_bind_TopoDS_CompSolid_Reverse_0"]=function(){return(_emscripten_bind_TopoDS_CompSolid_Reverse_0=Module["_emscripten_bind_TopoDS_CompSolid_Reverse_0"]=Module["asm"]["GA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_Reversed_0=Module["_emscripten_bind_TopoDS_CompSolid_Reversed_0"]=function(){return(_emscripten_bind_TopoDS_CompSolid_Reversed_0=Module["_emscripten_bind_TopoDS_CompSolid_Reversed_0"]=Module["asm"]["HA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_Complement_0=Module["_emscripten_bind_TopoDS_CompSolid_Complement_0"]=function(){return(_emscripten_bind_TopoDS_CompSolid_Complement_0=Module["_emscripten_bind_TopoDS_CompSolid_Complement_0"]=Module["asm"]["IA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_Complemented_0=Module["_emscripten_bind_TopoDS_CompSolid_Complemented_0"]=function(){return(_emscripten_bind_TopoDS_CompSolid_Complemented_0=Module["_emscripten_bind_TopoDS_CompSolid_Complemented_0"]=Module["asm"]["JA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_Compose_1=Module["_emscripten_bind_TopoDS_CompSolid_Compose_1"]=function(){return(_emscripten_bind_TopoDS_CompSolid_Compose_1=Module["_emscripten_bind_TopoDS_CompSolid_Compose_1"]=Module["asm"]["KA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_Composed_1=Module["_emscripten_bind_TopoDS_CompSolid_Composed_1"]=function(){return(_emscripten_bind_TopoDS_CompSolid_Composed_1=Module["_emscripten_bind_TopoDS_CompSolid_Composed_1"]=Module["asm"]["LA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_NbChildren_0=Module["_emscripten_bind_TopoDS_CompSolid_NbChildren_0"]=function(){return(_emscripten_bind_TopoDS_CompSolid_NbChildren_0=Module["_emscripten_bind_TopoDS_CompSolid_NbChildren_0"]=Module["asm"]["MA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_IsPartner_1=Module["_emscripten_bind_TopoDS_CompSolid_IsPartner_1"]=function(){return(_emscripten_bind_TopoDS_CompSolid_IsPartner_1=Module["_emscripten_bind_TopoDS_CompSolid_IsPartner_1"]=Module["asm"]["NA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_IsSame_1=Module["_emscripten_bind_TopoDS_CompSolid_IsSame_1"]=function(){return(_emscripten_bind_TopoDS_CompSolid_IsSame_1=Module["_emscripten_bind_TopoDS_CompSolid_IsSame_1"]=Module["asm"]["OA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_IsEqual_1=Module["_emscripten_bind_TopoDS_CompSolid_IsEqual_1"]=function(){return(_emscripten_bind_TopoDS_CompSolid_IsEqual_1=Module["_emscripten_bind_TopoDS_CompSolid_IsEqual_1"]=Module["asm"]["PA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_IsNotEqual_1=Module["_emscripten_bind_TopoDS_CompSolid_IsNotEqual_1"]=function(){return(_emscripten_bind_TopoDS_CompSolid_IsNotEqual_1=Module["_emscripten_bind_TopoDS_CompSolid_IsNotEqual_1"]=Module["asm"]["QA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_HashCode_1=Module["_emscripten_bind_TopoDS_CompSolid_HashCode_1"]=function(){return(_emscripten_bind_TopoDS_CompSolid_HashCode_1=Module["_emscripten_bind_TopoDS_CompSolid_HashCode_1"]=Module["asm"]["RA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_EmptyCopy_0=Module["_emscripten_bind_TopoDS_CompSolid_EmptyCopy_0"]=function(){return(_emscripten_bind_TopoDS_CompSolid_EmptyCopy_0=Module["_emscripten_bind_TopoDS_CompSolid_EmptyCopy_0"]=Module["asm"]["SA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_EmptyCopied_0=Module["_emscripten_bind_TopoDS_CompSolid_EmptyCopied_0"]=function(){return(_emscripten_bind_TopoDS_CompSolid_EmptyCopied_0=Module["_emscripten_bind_TopoDS_CompSolid_EmptyCopied_0"]=Module["asm"]["TA"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid___destroy___0=Module["_emscripten_bind_TopoDS_CompSolid___destroy___0"]=function(){return(_emscripten_bind_TopoDS_CompSolid___destroy___0=Module["_emscripten_bind_TopoDS_CompSolid___destroy___0"]=Module["asm"]["UA"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeSolid_BRepBuilderAPI_MakeSolid_0=Module["_emscripten_bind_BRepBuilderAPI_MakeSolid_BRepBuilderAPI_MakeSolid_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeSolid_BRepBuilderAPI_MakeSolid_0=Module["_emscripten_bind_BRepBuilderAPI_MakeSolid_BRepBuilderAPI_MakeSolid_0"]=Module["asm"]["VA"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeSolid_BRepBuilderAPI_MakeSolid_1=Module["_emscripten_bind_BRepBuilderAPI_MakeSolid_BRepBuilderAPI_MakeSolid_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeSolid_BRepBuilderAPI_MakeSolid_1=Module["_emscripten_bind_BRepBuilderAPI_MakeSolid_BRepBuilderAPI_MakeSolid_1"]=Module["asm"]["WA"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeSolid_BRepBuilderAPI_MakeSolid_2=Module["_emscripten_bind_BRepBuilderAPI_MakeSolid_BRepBuilderAPI_MakeSolid_2"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeSolid_BRepBuilderAPI_MakeSolid_2=Module["_emscripten_bind_BRepBuilderAPI_MakeSolid_BRepBuilderAPI_MakeSolid_2"]=Module["asm"]["XA"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeSolid_BRepBuilderAPI_MakeSolid_3=Module["_emscripten_bind_BRepBuilderAPI_MakeSolid_BRepBuilderAPI_MakeSolid_3"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeSolid_BRepBuilderAPI_MakeSolid_3=Module["_emscripten_bind_BRepBuilderAPI_MakeSolid_BRepBuilderAPI_MakeSolid_3"]=Module["asm"]["YA"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeSolid_Add_1=Module["_emscripten_bind_BRepBuilderAPI_MakeSolid_Add_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeSolid_Add_1=Module["_emscripten_bind_BRepBuilderAPI_MakeSolid_Add_1"]=Module["asm"]["ZA"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeSolid_IsDone_0=Module["_emscripten_bind_BRepBuilderAPI_MakeSolid_IsDone_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeSolid_IsDone_0=Module["_emscripten_bind_BRepBuilderAPI_MakeSolid_IsDone_0"]=Module["asm"]["_A"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeSolid_Solid_0=Module["_emscripten_bind_BRepBuilderAPI_MakeSolid_Solid_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeSolid_Solid_0=Module["_emscripten_bind_BRepBuilderAPI_MakeSolid_Solid_0"]=Module["asm"]["$A"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeSolid_IsDeleted_1=Module["_emscripten_bind_BRepBuilderAPI_MakeSolid_IsDeleted_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeSolid_IsDeleted_1=Module["_emscripten_bind_BRepBuilderAPI_MakeSolid_IsDeleted_1"]=Module["asm"]["aB"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeSolid___destroy___0=Module["_emscripten_bind_BRepBuilderAPI_MakeSolid___destroy___0"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeSolid___destroy___0=Module["_emscripten_bind_BRepBuilderAPI_MakeSolid___destroy___0"]=Module["asm"]["bB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_TopoDS_Wire_0=Module["_emscripten_bind_TopoDS_Wire_TopoDS_Wire_0"]=function(){return(_emscripten_bind_TopoDS_Wire_TopoDS_Wire_0=Module["_emscripten_bind_TopoDS_Wire_TopoDS_Wire_0"]=Module["asm"]["cB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_TopoDS_Wire_1=Module["_emscripten_bind_TopoDS_Wire_TopoDS_Wire_1"]=function(){return(_emscripten_bind_TopoDS_Wire_TopoDS_Wire_1=Module["_emscripten_bind_TopoDS_Wire_TopoDS_Wire_1"]=Module["asm"]["dB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_IsNull_0=Module["_emscripten_bind_TopoDS_Wire_IsNull_0"]=function(){return(_emscripten_bind_TopoDS_Wire_IsNull_0=Module["_emscripten_bind_TopoDS_Wire_IsNull_0"]=Module["asm"]["eB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_Nullify_0=Module["_emscripten_bind_TopoDS_Wire_Nullify_0"]=function(){return(_emscripten_bind_TopoDS_Wire_Nullify_0=Module["_emscripten_bind_TopoDS_Wire_Nullify_0"]=Module["asm"]["fB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_Location_0=Module["_emscripten_bind_TopoDS_Wire_Location_0"]=function(){return(_emscripten_bind_TopoDS_Wire_Location_0=Module["_emscripten_bind_TopoDS_Wire_Location_0"]=Module["asm"]["gB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_Located_1=Module["_emscripten_bind_TopoDS_Wire_Located_1"]=function(){return(_emscripten_bind_TopoDS_Wire_Located_1=Module["_emscripten_bind_TopoDS_Wire_Located_1"]=Module["asm"]["hB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_Orientation_0=Module["_emscripten_bind_TopoDS_Wire_Orientation_0"]=function(){return(_emscripten_bind_TopoDS_Wire_Orientation_0=Module["_emscripten_bind_TopoDS_Wire_Orientation_0"]=Module["asm"]["iB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_Oriented_1=Module["_emscripten_bind_TopoDS_Wire_Oriented_1"]=function(){return(_emscripten_bind_TopoDS_Wire_Oriented_1=Module["_emscripten_bind_TopoDS_Wire_Oriented_1"]=Module["asm"]["jB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_ShapeType_0=Module["_emscripten_bind_TopoDS_Wire_ShapeType_0"]=function(){return(_emscripten_bind_TopoDS_Wire_ShapeType_0=Module["_emscripten_bind_TopoDS_Wire_ShapeType_0"]=Module["asm"]["kB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_Free_0=Module["_emscripten_bind_TopoDS_Wire_Free_0"]=function(){return(_emscripten_bind_TopoDS_Wire_Free_0=Module["_emscripten_bind_TopoDS_Wire_Free_0"]=Module["asm"]["lB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_Locked_0=Module["_emscripten_bind_TopoDS_Wire_Locked_0"]=function(){return(_emscripten_bind_TopoDS_Wire_Locked_0=Module["_emscripten_bind_TopoDS_Wire_Locked_0"]=Module["asm"]["mB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_Modified_0=Module["_emscripten_bind_TopoDS_Wire_Modified_0"]=function(){return(_emscripten_bind_TopoDS_Wire_Modified_0=Module["_emscripten_bind_TopoDS_Wire_Modified_0"]=Module["asm"]["nB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_Checked_0=Module["_emscripten_bind_TopoDS_Wire_Checked_0"]=function(){return(_emscripten_bind_TopoDS_Wire_Checked_0=Module["_emscripten_bind_TopoDS_Wire_Checked_0"]=Module["asm"]["oB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_Orientable_0=Module["_emscripten_bind_TopoDS_Wire_Orientable_0"]=function(){return(_emscripten_bind_TopoDS_Wire_Orientable_0=Module["_emscripten_bind_TopoDS_Wire_Orientable_0"]=Module["asm"]["pB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_Closed_0=Module["_emscripten_bind_TopoDS_Wire_Closed_0"]=function(){return(_emscripten_bind_TopoDS_Wire_Closed_0=Module["_emscripten_bind_TopoDS_Wire_Closed_0"]=Module["asm"]["qB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_Infinite_0=Module["_emscripten_bind_TopoDS_Wire_Infinite_0"]=function(){return(_emscripten_bind_TopoDS_Wire_Infinite_0=Module["_emscripten_bind_TopoDS_Wire_Infinite_0"]=Module["asm"]["rB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_Convex_0=Module["_emscripten_bind_TopoDS_Wire_Convex_0"]=function(){return(_emscripten_bind_TopoDS_Wire_Convex_0=Module["_emscripten_bind_TopoDS_Wire_Convex_0"]=Module["asm"]["sB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_Move_1=Module["_emscripten_bind_TopoDS_Wire_Move_1"]=function(){return(_emscripten_bind_TopoDS_Wire_Move_1=Module["_emscripten_bind_TopoDS_Wire_Move_1"]=Module["asm"]["tB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_Moved_1=Module["_emscripten_bind_TopoDS_Wire_Moved_1"]=function(){return(_emscripten_bind_TopoDS_Wire_Moved_1=Module["_emscripten_bind_TopoDS_Wire_Moved_1"]=Module["asm"]["uB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_Reverse_0=Module["_emscripten_bind_TopoDS_Wire_Reverse_0"]=function(){return(_emscripten_bind_TopoDS_Wire_Reverse_0=Module["_emscripten_bind_TopoDS_Wire_Reverse_0"]=Module["asm"]["vB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_Reversed_0=Module["_emscripten_bind_TopoDS_Wire_Reversed_0"]=function(){return(_emscripten_bind_TopoDS_Wire_Reversed_0=Module["_emscripten_bind_TopoDS_Wire_Reversed_0"]=Module["asm"]["wB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_Complement_0=Module["_emscripten_bind_TopoDS_Wire_Complement_0"]=function(){return(_emscripten_bind_TopoDS_Wire_Complement_0=Module["_emscripten_bind_TopoDS_Wire_Complement_0"]=Module["asm"]["xB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_Complemented_0=Module["_emscripten_bind_TopoDS_Wire_Complemented_0"]=function(){return(_emscripten_bind_TopoDS_Wire_Complemented_0=Module["_emscripten_bind_TopoDS_Wire_Complemented_0"]=Module["asm"]["yB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_Compose_1=Module["_emscripten_bind_TopoDS_Wire_Compose_1"]=function(){return(_emscripten_bind_TopoDS_Wire_Compose_1=Module["_emscripten_bind_TopoDS_Wire_Compose_1"]=Module["asm"]["zB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_Composed_1=Module["_emscripten_bind_TopoDS_Wire_Composed_1"]=function(){return(_emscripten_bind_TopoDS_Wire_Composed_1=Module["_emscripten_bind_TopoDS_Wire_Composed_1"]=Module["asm"]["AB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_NbChildren_0=Module["_emscripten_bind_TopoDS_Wire_NbChildren_0"]=function(){return(_emscripten_bind_TopoDS_Wire_NbChildren_0=Module["_emscripten_bind_TopoDS_Wire_NbChildren_0"]=Module["asm"]["BB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_IsPartner_1=Module["_emscripten_bind_TopoDS_Wire_IsPartner_1"]=function(){return(_emscripten_bind_TopoDS_Wire_IsPartner_1=Module["_emscripten_bind_TopoDS_Wire_IsPartner_1"]=Module["asm"]["CB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_IsSame_1=Module["_emscripten_bind_TopoDS_Wire_IsSame_1"]=function(){return(_emscripten_bind_TopoDS_Wire_IsSame_1=Module["_emscripten_bind_TopoDS_Wire_IsSame_1"]=Module["asm"]["DB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_IsEqual_1=Module["_emscripten_bind_TopoDS_Wire_IsEqual_1"]=function(){return(_emscripten_bind_TopoDS_Wire_IsEqual_1=Module["_emscripten_bind_TopoDS_Wire_IsEqual_1"]=Module["asm"]["EB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_IsNotEqual_1=Module["_emscripten_bind_TopoDS_Wire_IsNotEqual_1"]=function(){return(_emscripten_bind_TopoDS_Wire_IsNotEqual_1=Module["_emscripten_bind_TopoDS_Wire_IsNotEqual_1"]=Module["asm"]["FB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_HashCode_1=Module["_emscripten_bind_TopoDS_Wire_HashCode_1"]=function(){return(_emscripten_bind_TopoDS_Wire_HashCode_1=Module["_emscripten_bind_TopoDS_Wire_HashCode_1"]=Module["asm"]["GB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_EmptyCopy_0=Module["_emscripten_bind_TopoDS_Wire_EmptyCopy_0"]=function(){return(_emscripten_bind_TopoDS_Wire_EmptyCopy_0=Module["_emscripten_bind_TopoDS_Wire_EmptyCopy_0"]=Module["asm"]["HB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_EmptyCopied_0=Module["_emscripten_bind_TopoDS_Wire_EmptyCopied_0"]=function(){return(_emscripten_bind_TopoDS_Wire_EmptyCopied_0=Module["_emscripten_bind_TopoDS_Wire_EmptyCopied_0"]=Module["asm"]["IB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire___destroy___0=Module["_emscripten_bind_TopoDS_Wire___destroy___0"]=function(){return(_emscripten_bind_TopoDS_Wire___destroy___0=Module["_emscripten_bind_TopoDS_Wire___destroy___0"]=Module["asm"]["JB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_1=Module["_emscripten_bind_TopoDS_Vertex_1"]=function(){return(_emscripten_bind_TopoDS_Vertex_1=Module["_emscripten_bind_TopoDS_Vertex_1"]=Module["asm"]["KB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Edge_1=Module["_emscripten_bind_TopoDS_Edge_1"]=function(){return(_emscripten_bind_TopoDS_Edge_1=Module["_emscripten_bind_TopoDS_Edge_1"]=Module["asm"]["LB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Wire_1=Module["_emscripten_bind_TopoDS_Wire_1"]=function(){return(_emscripten_bind_TopoDS_Wire_1=Module["_emscripten_bind_TopoDS_Wire_1"]=Module["asm"]["MB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_1=Module["_emscripten_bind_TopoDS_Face_1"]=function(){return(_emscripten_bind_TopoDS_Face_1=Module["_emscripten_bind_TopoDS_Face_1"]=Module["asm"]["NB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Shell_1=Module["_emscripten_bind_TopoDS_Shell_1"]=function(){return(_emscripten_bind_TopoDS_Shell_1=Module["_emscripten_bind_TopoDS_Shell_1"]=Module["asm"]["OB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Solid_1=Module["_emscripten_bind_TopoDS_Solid_1"]=function(){return(_emscripten_bind_TopoDS_Solid_1=Module["_emscripten_bind_TopoDS_Solid_1"]=Module["asm"]["PB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_CompSolid_1=Module["_emscripten_bind_TopoDS_CompSolid_1"]=function(){return(_emscripten_bind_TopoDS_CompSolid_1=Module["_emscripten_bind_TopoDS_CompSolid_1"]=Module["asm"]["QB"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_1=Module["_emscripten_bind_TopoDS_Compound_1"]=function(){return(_emscripten_bind_TopoDS_Compound_1=Module["_emscripten_bind_TopoDS_Compound_1"]=Module["asm"]["RB"]).apply(null,arguments)};var _emscripten_bind_TopoDS___destroy___0=Module["_emscripten_bind_TopoDS___destroy___0"]=function(){return(_emscripten_bind_TopoDS___destroy___0=Module["_emscripten_bind_TopoDS___destroy___0"]=Module["asm"]["SB"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeCylinder_BRepPrimAPI_MakeCylinder_2=Module["_emscripten_bind_BRepPrimAPI_MakeCylinder_BRepPrimAPI_MakeCylinder_2"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeCylinder_BRepPrimAPI_MakeCylinder_2=Module["_emscripten_bind_BRepPrimAPI_MakeCylinder_BRepPrimAPI_MakeCylinder_2"]=Module["asm"]["TB"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeCylinder_BRepPrimAPI_MakeCylinder_3=Module["_emscripten_bind_BRepPrimAPI_MakeCylinder_BRepPrimAPI_MakeCylinder_3"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeCylinder_BRepPrimAPI_MakeCylinder_3=Module["_emscripten_bind_BRepPrimAPI_MakeCylinder_BRepPrimAPI_MakeCylinder_3"]=Module["asm"]["UB"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeCylinder_BRepPrimAPI_MakeCylinder_4=Module["_emscripten_bind_BRepPrimAPI_MakeCylinder_BRepPrimAPI_MakeCylinder_4"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeCylinder_BRepPrimAPI_MakeCylinder_4=Module["_emscripten_bind_BRepPrimAPI_MakeCylinder_BRepPrimAPI_MakeCylinder_4"]=Module["asm"]["VB"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeCylinder_Shape_0=Module["_emscripten_bind_BRepPrimAPI_MakeCylinder_Shape_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeCylinder_Shape_0=Module["_emscripten_bind_BRepPrimAPI_MakeCylinder_Shape_0"]=Module["asm"]["WB"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeCylinder_IsDeleted_1=Module["_emscripten_bind_BRepPrimAPI_MakeCylinder_IsDeleted_1"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeCylinder_IsDeleted_1=Module["_emscripten_bind_BRepPrimAPI_MakeCylinder_IsDeleted_1"]=Module["asm"]["XB"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeCylinder_Build_0=Module["_emscripten_bind_BRepPrimAPI_MakeCylinder_Build_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeCylinder_Build_0=Module["_emscripten_bind_BRepPrimAPI_MakeCylinder_Build_0"]=Module["asm"]["YB"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeCylinder_Face_0=Module["_emscripten_bind_BRepPrimAPI_MakeCylinder_Face_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeCylinder_Face_0=Module["_emscripten_bind_BRepPrimAPI_MakeCylinder_Face_0"]=Module["asm"]["ZB"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeCylinder_Shell_0=Module["_emscripten_bind_BRepPrimAPI_MakeCylinder_Shell_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeCylinder_Shell_0=Module["_emscripten_bind_BRepPrimAPI_MakeCylinder_Shell_0"]=Module["asm"]["_B"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeCylinder_Solid_0=Module["_emscripten_bind_BRepPrimAPI_MakeCylinder_Solid_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeCylinder_Solid_0=Module["_emscripten_bind_BRepPrimAPI_MakeCylinder_Solid_0"]=Module["asm"]["$B"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeCylinder___destroy___0=Module["_emscripten_bind_BRepPrimAPI_MakeCylinder___destroy___0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeCylinder___destroy___0=Module["_emscripten_bind_BRepPrimAPI_MakeCylinder___destroy___0"]=Module["asm"]["aC"]).apply(null,arguments)};var _emscripten_bind_Handle_Standard_Type_Handle_Standard_Type_0=Module["_emscripten_bind_Handle_Standard_Type_Handle_Standard_Type_0"]=function(){return(_emscripten_bind_Handle_Standard_Type_Handle_Standard_Type_0=Module["_emscripten_bind_Handle_Standard_Type_Handle_Standard_Type_0"]=Module["asm"]["bC"]).apply(null,arguments)};var _emscripten_bind_Handle_Standard_Type_Handle_Standard_Type_1=Module["_emscripten_bind_Handle_Standard_Type_Handle_Standard_Type_1"]=function(){return(_emscripten_bind_Handle_Standard_Type_Handle_Standard_Type_1=Module["_emscripten_bind_Handle_Standard_Type_Handle_Standard_Type_1"]=Module["asm"]["cC"]).apply(null,arguments)};var _emscripten_bind_Handle_Standard_Type_IsNull_0=Module["_emscripten_bind_Handle_Standard_Type_IsNull_0"]=function(){return(_emscripten_bind_Handle_Standard_Type_IsNull_0=Module["_emscripten_bind_Handle_Standard_Type_IsNull_0"]=Module["asm"]["dC"]).apply(null,arguments)};var _emscripten_bind_Handle_Standard_Type_Nullify_0=Module["_emscripten_bind_Handle_Standard_Type_Nullify_0"]=function(){return(_emscripten_bind_Handle_Standard_Type_Nullify_0=Module["_emscripten_bind_Handle_Standard_Type_Nullify_0"]=Module["asm"]["eC"]).apply(null,arguments)};var _emscripten_bind_Handle_Standard_Type_get_0=Module["_emscripten_bind_Handle_Standard_Type_get_0"]=function(){return(_emscripten_bind_Handle_Standard_Type_get_0=Module["_emscripten_bind_Handle_Standard_Type_get_0"]=Module["asm"]["fC"]).apply(null,arguments)};var _emscripten_bind_Handle_Standard_Type___destroy___0=Module["_emscripten_bind_Handle_Standard_Type___destroy___0"]=function(){return(_emscripten_bind_Handle_Standard_Type___destroy___0=Module["_emscripten_bind_Handle_Standard_Type___destroy___0"]=Module["asm"]["gC"]).apply(null,arguments)};var _emscripten_bind_STEPControl_Writer_STEPControl_Writer_0=Module["_emscripten_bind_STEPControl_Writer_STEPControl_Writer_0"]=function(){return(_emscripten_bind_STEPControl_Writer_STEPControl_Writer_0=Module["_emscripten_bind_STEPControl_Writer_STEPControl_Writer_0"]=Module["asm"]["hC"]).apply(null,arguments)};var _emscripten_bind_STEPControl_Writer_SetTolerance_1=Module["_emscripten_bind_STEPControl_Writer_SetTolerance_1"]=function(){return(_emscripten_bind_STEPControl_Writer_SetTolerance_1=Module["_emscripten_bind_STEPControl_Writer_SetTolerance_1"]=Module["asm"]["iC"]).apply(null,arguments)};var _emscripten_bind_STEPControl_Writer_UnsetTolerance_0=Module["_emscripten_bind_STEPControl_Writer_UnsetTolerance_0"]=function(){return(_emscripten_bind_STEPControl_Writer_UnsetTolerance_0=Module["_emscripten_bind_STEPControl_Writer_UnsetTolerance_0"]=Module["asm"]["jC"]).apply(null,arguments)};var _emscripten_bind_STEPControl_Writer_Transfer_2=Module["_emscripten_bind_STEPControl_Writer_Transfer_2"]=function(){return(_emscripten_bind_STEPControl_Writer_Transfer_2=Module["_emscripten_bind_STEPControl_Writer_Transfer_2"]=Module["asm"]["kC"]).apply(null,arguments)};var _emscripten_bind_STEPControl_Writer_Transfer_3=Module["_emscripten_bind_STEPControl_Writer_Transfer_3"]=function(){return(_emscripten_bind_STEPControl_Writer_Transfer_3=Module["_emscripten_bind_STEPControl_Writer_Transfer_3"]=Module["asm"]["lC"]).apply(null,arguments)};var _emscripten_bind_STEPControl_Writer_Write_1=Module["_emscripten_bind_STEPControl_Writer_Write_1"]=function(){return(_emscripten_bind_STEPControl_Writer_Write_1=Module["_emscripten_bind_STEPControl_Writer_Write_1"]=Module["asm"]["mC"]).apply(null,arguments)};var _emscripten_bind_STEPControl_Writer_PrintStatsTransfer_1=Module["_emscripten_bind_STEPControl_Writer_PrintStatsTransfer_1"]=function(){return(_emscripten_bind_STEPControl_Writer_PrintStatsTransfer_1=Module["_emscripten_bind_STEPControl_Writer_PrintStatsTransfer_1"]=Module["asm"]["nC"]).apply(null,arguments)};var _emscripten_bind_STEPControl_Writer_PrintStatsTransfer_2=Module["_emscripten_bind_STEPControl_Writer_PrintStatsTransfer_2"]=function(){return(_emscripten_bind_STEPControl_Writer_PrintStatsTransfer_2=Module["_emscripten_bind_STEPControl_Writer_PrintStatsTransfer_2"]=Module["asm"]["oC"]).apply(null,arguments)};var _emscripten_bind_STEPControl_Writer___destroy___0=Module["_emscripten_bind_STEPControl_Writer___destroy___0"]=function(){return(_emscripten_bind_STEPControl_Writer___destroy___0=Module["_emscripten_bind_STEPControl_Writer___destroy___0"]=Module["asm"]["pC"]).apply(null,arguments)};var _emscripten_bind_TColgp_Array1OfPnt_TColgp_Array1OfPnt_0=Module["_emscripten_bind_TColgp_Array1OfPnt_TColgp_Array1OfPnt_0"]=function(){return(_emscripten_bind_TColgp_Array1OfPnt_TColgp_Array1OfPnt_0=Module["_emscripten_bind_TColgp_Array1OfPnt_TColgp_Array1OfPnt_0"]=Module["asm"]["qC"]).apply(null,arguments)};var _emscripten_bind_TColgp_Array1OfPnt_TColgp_Array1OfPnt_2=Module["_emscripten_bind_TColgp_Array1OfPnt_TColgp_Array1OfPnt_2"]=function(){return(_emscripten_bind_TColgp_Array1OfPnt_TColgp_Array1OfPnt_2=Module["_emscripten_bind_TColgp_Array1OfPnt_TColgp_Array1OfPnt_2"]=Module["asm"]["rC"]).apply(null,arguments)};var _emscripten_bind_TColgp_Array1OfPnt_Length_0=Module["_emscripten_bind_TColgp_Array1OfPnt_Length_0"]=function(){return(_emscripten_bind_TColgp_Array1OfPnt_Length_0=Module["_emscripten_bind_TColgp_Array1OfPnt_Length_0"]=Module["asm"]["sC"]).apply(null,arguments)};var _emscripten_bind_TColgp_Array1OfPnt_Lower_0=Module["_emscripten_bind_TColgp_Array1OfPnt_Lower_0"]=function(){return(_emscripten_bind_TColgp_Array1OfPnt_Lower_0=Module["_emscripten_bind_TColgp_Array1OfPnt_Lower_0"]=Module["asm"]["tC"]).apply(null,arguments)};var _emscripten_bind_TColgp_Array1OfPnt_Upper_0=Module["_emscripten_bind_TColgp_Array1OfPnt_Upper_0"]=function(){return(_emscripten_bind_TColgp_Array1OfPnt_Upper_0=Module["_emscripten_bind_TColgp_Array1OfPnt_Upper_0"]=Module["asm"]["uC"]).apply(null,arguments)};var _emscripten_bind_TColgp_Array1OfPnt_Value_1=Module["_emscripten_bind_TColgp_Array1OfPnt_Value_1"]=function(){return(_emscripten_bind_TColgp_Array1OfPnt_Value_1=Module["_emscripten_bind_TColgp_Array1OfPnt_Value_1"]=Module["asm"]["vC"]).apply(null,arguments)};var _emscripten_bind_TColgp_Array1OfPnt_SetValue_2=Module["_emscripten_bind_TColgp_Array1OfPnt_SetValue_2"]=function(){return(_emscripten_bind_TColgp_Array1OfPnt_SetValue_2=Module["_emscripten_bind_TColgp_Array1OfPnt_SetValue_2"]=Module["asm"]["wC"]).apply(null,arguments)};var _emscripten_bind_TColgp_Array1OfPnt___destroy___0=Module["_emscripten_bind_TColgp_Array1OfPnt___destroy___0"]=function(){return(_emscripten_bind_TColgp_Array1OfPnt___destroy___0=Module["_emscripten_bind_TColgp_Array1OfPnt___destroy___0"]=Module["asm"]["xC"]).apply(null,arguments)};var _emscripten_bind_TColStd_Array1OfReal_TColStd_Array1OfReal_0=Module["_emscripten_bind_TColStd_Array1OfReal_TColStd_Array1OfReal_0"]=function(){return(_emscripten_bind_TColStd_Array1OfReal_TColStd_Array1OfReal_0=Module["_emscripten_bind_TColStd_Array1OfReal_TColStd_Array1OfReal_0"]=Module["asm"]["yC"]).apply(null,arguments)};var _emscripten_bind_TColStd_Array1OfReal_TColStd_Array1OfReal_2=Module["_emscripten_bind_TColStd_Array1OfReal_TColStd_Array1OfReal_2"]=function(){return(_emscripten_bind_TColStd_Array1OfReal_TColStd_Array1OfReal_2=Module["_emscripten_bind_TColStd_Array1OfReal_TColStd_Array1OfReal_2"]=Module["asm"]["zC"]).apply(null,arguments)};var _emscripten_bind_TColStd_Array1OfReal_Length_0=Module["_emscripten_bind_TColStd_Array1OfReal_Length_0"]=function(){return(_emscripten_bind_TColStd_Array1OfReal_Length_0=Module["_emscripten_bind_TColStd_Array1OfReal_Length_0"]=Module["asm"]["AC"]).apply(null,arguments)};var _emscripten_bind_TColStd_Array1OfReal_Lower_0=Module["_emscripten_bind_TColStd_Array1OfReal_Lower_0"]=function(){return(_emscripten_bind_TColStd_Array1OfReal_Lower_0=Module["_emscripten_bind_TColStd_Array1OfReal_Lower_0"]=Module["asm"]["BC"]).apply(null,arguments)};var _emscripten_bind_TColStd_Array1OfReal_Upper_0=Module["_emscripten_bind_TColStd_Array1OfReal_Upper_0"]=function(){return(_emscripten_bind_TColStd_Array1OfReal_Upper_0=Module["_emscripten_bind_TColStd_Array1OfReal_Upper_0"]=Module["asm"]["CC"]).apply(null,arguments)};var _emscripten_bind_TColStd_Array1OfReal_Value_1=Module["_emscripten_bind_TColStd_Array1OfReal_Value_1"]=function(){return(_emscripten_bind_TColStd_Array1OfReal_Value_1=Module["_emscripten_bind_TColStd_Array1OfReal_Value_1"]=Module["asm"]["DC"]).apply(null,arguments)};var _emscripten_bind_TColStd_Array1OfReal_SetValue_2=Module["_emscripten_bind_TColStd_Array1OfReal_SetValue_2"]=function(){return(_emscripten_bind_TColStd_Array1OfReal_SetValue_2=Module["_emscripten_bind_TColStd_Array1OfReal_SetValue_2"]=Module["asm"]["EC"]).apply(null,arguments)};var _emscripten_bind_TColStd_Array1OfReal___destroy___0=Module["_emscripten_bind_TColStd_Array1OfReal___destroy___0"]=function(){return(_emscripten_bind_TColStd_Array1OfReal___destroy___0=Module["_emscripten_bind_TColStd_Array1OfReal___destroy___0"]=Module["asm"]["FC"]).apply(null,arguments)};var _emscripten_bind_Geom_Plane_Location_0=Module["_emscripten_bind_Geom_Plane_Location_0"]=function(){return(_emscripten_bind_Geom_Plane_Location_0=Module["_emscripten_bind_Geom_Plane_Location_0"]=Module["asm"]["GC"]).apply(null,arguments)};var _emscripten_bind_Geom_Plane_get_type_name_0=Module["_emscripten_bind_Geom_Plane_get_type_name_0"]=function(){return(_emscripten_bind_Geom_Plane_get_type_name_0=Module["_emscripten_bind_Geom_Plane_get_type_name_0"]=Module["asm"]["HC"]).apply(null,arguments)};var _emscripten_bind_Geom_Plane_DynamicType_0=Module["_emscripten_bind_Geom_Plane_DynamicType_0"]=function(){return(_emscripten_bind_Geom_Plane_DynamicType_0=Module["_emscripten_bind_Geom_Plane_DynamicType_0"]=Module["asm"]["IC"]).apply(null,arguments)};var _emscripten_bind_Geom_Plane___destroy___0=Module["_emscripten_bind_Geom_Plane___destroy___0"]=function(){return(_emscripten_bind_Geom_Plane___destroy___0=Module["_emscripten_bind_Geom_Plane___destroy___0"]=Module["asm"]["JC"]).apply(null,arguments)};var _emscripten_bind_gp_Lin_gp_Lin_0=Module["_emscripten_bind_gp_Lin_gp_Lin_0"]=function(){return(_emscripten_bind_gp_Lin_gp_Lin_0=Module["_emscripten_bind_gp_Lin_gp_Lin_0"]=Module["asm"]["KC"]).apply(null,arguments)};var _emscripten_bind_gp_Lin_gp_Lin_1=Module["_emscripten_bind_gp_Lin_gp_Lin_1"]=function(){return(_emscripten_bind_gp_Lin_gp_Lin_1=Module["_emscripten_bind_gp_Lin_gp_Lin_1"]=Module["asm"]["LC"]).apply(null,arguments)};var _emscripten_bind_gp_Lin___destroy___0=Module["_emscripten_bind_gp_Lin___destroy___0"]=function(){return(_emscripten_bind_gp_Lin___destroy___0=Module["_emscripten_bind_gp_Lin___destroy___0"]=Module["asm"]["MC"]).apply(null,arguments)};var _emscripten_bind_Handle_Message_ProgressIndicator_Handle_Message_ProgressIndicator_0=Module["_emscripten_bind_Handle_Message_ProgressIndicator_Handle_Message_ProgressIndicator_0"]=function(){return(_emscripten_bind_Handle_Message_ProgressIndicator_Handle_Message_ProgressIndicator_0=Module["_emscripten_bind_Handle_Message_ProgressIndicator_Handle_Message_ProgressIndicator_0"]=Module["asm"]["NC"]).apply(null,arguments)};var _emscripten_bind_Handle_Message_ProgressIndicator_Handle_Message_ProgressIndicator_1=Module["_emscripten_bind_Handle_Message_ProgressIndicator_Handle_Message_ProgressIndicator_1"]=function(){return(_emscripten_bind_Handle_Message_ProgressIndicator_Handle_Message_ProgressIndicator_1=Module["_emscripten_bind_Handle_Message_ProgressIndicator_Handle_Message_ProgressIndicator_1"]=Module["asm"]["OC"]).apply(null,arguments)};var _emscripten_bind_Handle_Message_ProgressIndicator_IsNull_0=Module["_emscripten_bind_Handle_Message_ProgressIndicator_IsNull_0"]=function(){return(_emscripten_bind_Handle_Message_ProgressIndicator_IsNull_0=Module["_emscripten_bind_Handle_Message_ProgressIndicator_IsNull_0"]=Module["asm"]["PC"]).apply(null,arguments)};var _emscripten_bind_Handle_Message_ProgressIndicator_Nullify_0=Module["_emscripten_bind_Handle_Message_ProgressIndicator_Nullify_0"]=function(){return(_emscripten_bind_Handle_Message_ProgressIndicator_Nullify_0=Module["_emscripten_bind_Handle_Message_ProgressIndicator_Nullify_0"]=Module["asm"]["QC"]).apply(null,arguments)};var _emscripten_bind_Handle_Message_ProgressIndicator_get_0=Module["_emscripten_bind_Handle_Message_ProgressIndicator_get_0"]=function(){return(_emscripten_bind_Handle_Message_ProgressIndicator_get_0=Module["_emscripten_bind_Handle_Message_ProgressIndicator_get_0"]=Module["asm"]["RC"]).apply(null,arguments)};var _emscripten_bind_Handle_Message_ProgressIndicator___destroy___0=Module["_emscripten_bind_Handle_Message_ProgressIndicator___destroy___0"]=function(){return(_emscripten_bind_Handle_Message_ProgressIndicator___destroy___0=Module["_emscripten_bind_Handle_Message_ProgressIndicator___destroy___0"]=Module["asm"]["SC"]).apply(null,arguments)};var _emscripten_bind_GC_MakeArcOfParabola_GC_MakeArcOfParabola_4=Module["_emscripten_bind_GC_MakeArcOfParabola_GC_MakeArcOfParabola_4"]=function(){return(_emscripten_bind_GC_MakeArcOfParabola_GC_MakeArcOfParabola_4=Module["_emscripten_bind_GC_MakeArcOfParabola_GC_MakeArcOfParabola_4"]=Module["asm"]["TC"]).apply(null,arguments)};var _emscripten_bind_GC_MakeArcOfParabola_Value_0=Module["_emscripten_bind_GC_MakeArcOfParabola_Value_0"]=function(){return(_emscripten_bind_GC_MakeArcOfParabola_Value_0=Module["_emscripten_bind_GC_MakeArcOfParabola_Value_0"]=Module["asm"]["UC"]).apply(null,arguments)};var _emscripten_bind_GC_MakeArcOfParabola___destroy___0=Module["_emscripten_bind_GC_MakeArcOfParabola___destroy___0"]=function(){return(_emscripten_bind_GC_MakeArcOfParabola___destroy___0=Module["_emscripten_bind_GC_MakeArcOfParabola___destroy___0"]=Module["asm"]["VC"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakePolygon_BRepBuilderAPI_MakePolygon_0=Module["_emscripten_bind_BRepBuilderAPI_MakePolygon_BRepBuilderAPI_MakePolygon_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakePolygon_BRepBuilderAPI_MakePolygon_0=Module["_emscripten_bind_BRepBuilderAPI_MakePolygon_BRepBuilderAPI_MakePolygon_0"]=Module["asm"]["WC"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakePolygon_BRepBuilderAPI_MakePolygon_2=Module["_emscripten_bind_BRepBuilderAPI_MakePolygon_BRepBuilderAPI_MakePolygon_2"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakePolygon_BRepBuilderAPI_MakePolygon_2=Module["_emscripten_bind_BRepBuilderAPI_MakePolygon_BRepBuilderAPI_MakePolygon_2"]=Module["asm"]["XC"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakePolygon_BRepBuilderAPI_MakePolygon_4=Module["_emscripten_bind_BRepBuilderAPI_MakePolygon_BRepBuilderAPI_MakePolygon_4"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakePolygon_BRepBuilderAPI_MakePolygon_4=Module["_emscripten_bind_BRepBuilderAPI_MakePolygon_BRepBuilderAPI_MakePolygon_4"]=Module["asm"]["YC"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakePolygon_BRepBuilderAPI_MakePolygon_5=Module["_emscripten_bind_BRepBuilderAPI_MakePolygon_BRepBuilderAPI_MakePolygon_5"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakePolygon_BRepBuilderAPI_MakePolygon_5=Module["_emscripten_bind_BRepBuilderAPI_MakePolygon_BRepBuilderAPI_MakePolygon_5"]=Module["asm"]["ZC"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakePolygon_Add_1=Module["_emscripten_bind_BRepBuilderAPI_MakePolygon_Add_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakePolygon_Add_1=Module["_emscripten_bind_BRepBuilderAPI_MakePolygon_Add_1"]=Module["asm"]["_C"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakePolygon_Added_0=Module["_emscripten_bind_BRepBuilderAPI_MakePolygon_Added_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakePolygon_Added_0=Module["_emscripten_bind_BRepBuilderAPI_MakePolygon_Added_0"]=Module["asm"]["$C"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakePolygon_Close_0=Module["_emscripten_bind_BRepBuilderAPI_MakePolygon_Close_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakePolygon_Close_0=Module["_emscripten_bind_BRepBuilderAPI_MakePolygon_Close_0"]=Module["asm"]["aD"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakePolygon_FirstVertex_0=Module["_emscripten_bind_BRepBuilderAPI_MakePolygon_FirstVertex_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakePolygon_FirstVertex_0=Module["_emscripten_bind_BRepBuilderAPI_MakePolygon_FirstVertex_0"]=Module["asm"]["bD"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakePolygon_LastVertex_0=Module["_emscripten_bind_BRepBuilderAPI_MakePolygon_LastVertex_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakePolygon_LastVertex_0=Module["_emscripten_bind_BRepBuilderAPI_MakePolygon_LastVertex_0"]=Module["asm"]["cD"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakePolygon_IsDone_0=Module["_emscripten_bind_BRepBuilderAPI_MakePolygon_IsDone_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakePolygon_IsDone_0=Module["_emscripten_bind_BRepBuilderAPI_MakePolygon_IsDone_0"]=Module["asm"]["dD"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakePolygon_Edge_0=Module["_emscripten_bind_BRepBuilderAPI_MakePolygon_Edge_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakePolygon_Edge_0=Module["_emscripten_bind_BRepBuilderAPI_MakePolygon_Edge_0"]=Module["asm"]["eD"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakePolygon_Wire_0=Module["_emscripten_bind_BRepBuilderAPI_MakePolygon_Wire_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakePolygon_Wire_0=Module["_emscripten_bind_BRepBuilderAPI_MakePolygon_Wire_0"]=Module["asm"]["fD"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakePolygon_Shape_0=Module["_emscripten_bind_BRepBuilderAPI_MakePolygon_Shape_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakePolygon_Shape_0=Module["_emscripten_bind_BRepBuilderAPI_MakePolygon_Shape_0"]=Module["asm"]["gD"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakePolygon___destroy___0=Module["_emscripten_bind_BRepBuilderAPI_MakePolygon___destroy___0"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakePolygon___destroy___0=Module["_emscripten_bind_BRepBuilderAPI_MakePolygon___destroy___0"]=Module["asm"]["hD"]).apply(null,arguments)};var _emscripten_bind_gp_Circ_gp_Circ_0=Module["_emscripten_bind_gp_Circ_gp_Circ_0"]=function(){return(_emscripten_bind_gp_Circ_gp_Circ_0=Module["_emscripten_bind_gp_Circ_gp_Circ_0"]=Module["asm"]["iD"]).apply(null,arguments)};var _emscripten_bind_gp_Circ_gp_Circ_2=Module["_emscripten_bind_gp_Circ_gp_Circ_2"]=function(){return(_emscripten_bind_gp_Circ_gp_Circ_2=Module["_emscripten_bind_gp_Circ_gp_Circ_2"]=Module["asm"]["jD"]).apply(null,arguments)};var _emscripten_bind_gp_Circ_Radius_0=Module["_emscripten_bind_gp_Circ_Radius_0"]=function(){return(_emscripten_bind_gp_Circ_Radius_0=Module["_emscripten_bind_gp_Circ_Radius_0"]=Module["asm"]["kD"]).apply(null,arguments)};var _emscripten_bind_gp_Circ_Length_0=Module["_emscripten_bind_gp_Circ_Length_0"]=function(){return(_emscripten_bind_gp_Circ_Length_0=Module["_emscripten_bind_gp_Circ_Length_0"]=Module["asm"]["lD"]).apply(null,arguments)};var _emscripten_bind_gp_Circ_Area_0=Module["_emscripten_bind_gp_Circ_Area_0"]=function(){return(_emscripten_bind_gp_Circ_Area_0=Module["_emscripten_bind_gp_Circ_Area_0"]=Module["asm"]["mD"]).apply(null,arguments)};var _emscripten_bind_gp_Circ___destroy___0=Module["_emscripten_bind_gp_Circ___destroy___0"]=function(){return(_emscripten_bind_gp_Circ___destroy___0=Module["_emscripten_bind_gp_Circ___destroy___0"]=Module["asm"]["nD"]).apply(null,arguments)};var _emscripten_bind_Handle_ShapeFix_Shell_IsNull_0=Module["_emscripten_bind_Handle_ShapeFix_Shell_IsNull_0"]=function(){return(_emscripten_bind_Handle_ShapeFix_Shell_IsNull_0=Module["_emscripten_bind_Handle_ShapeFix_Shell_IsNull_0"]=Module["asm"]["oD"]).apply(null,arguments)};var _emscripten_bind_Handle_ShapeFix_Shell_get_0=Module["_emscripten_bind_Handle_ShapeFix_Shell_get_0"]=function(){return(_emscripten_bind_Handle_ShapeFix_Shell_get_0=Module["_emscripten_bind_Handle_ShapeFix_Shell_get_0"]=Module["asm"]["pD"]).apply(null,arguments)};var _emscripten_bind_Handle_ShapeFix_Shell___destroy___0=Module["_emscripten_bind_Handle_ShapeFix_Shell___destroy___0"]=function(){return(_emscripten_bind_Handle_ShapeFix_Shell___destroy___0=Module["_emscripten_bind_Handle_ShapeFix_Shell___destroy___0"]=Module["asm"]["qD"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeRevolution_BRepPrimAPI_MakeRevolution_1=Module["_emscripten_bind_BRepPrimAPI_MakeRevolution_BRepPrimAPI_MakeRevolution_1"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeRevolution_BRepPrimAPI_MakeRevolution_1=Module["_emscripten_bind_BRepPrimAPI_MakeRevolution_BRepPrimAPI_MakeRevolution_1"]=Module["asm"]["rD"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeRevolution_BRepPrimAPI_MakeRevolution_2=Module["_emscripten_bind_BRepPrimAPI_MakeRevolution_BRepPrimAPI_MakeRevolution_2"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeRevolution_BRepPrimAPI_MakeRevolution_2=Module["_emscripten_bind_BRepPrimAPI_MakeRevolution_BRepPrimAPI_MakeRevolution_2"]=Module["asm"]["sD"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeRevolution_BRepPrimAPI_MakeRevolution_3=Module["_emscripten_bind_BRepPrimAPI_MakeRevolution_BRepPrimAPI_MakeRevolution_3"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeRevolution_BRepPrimAPI_MakeRevolution_3=Module["_emscripten_bind_BRepPrimAPI_MakeRevolution_BRepPrimAPI_MakeRevolution_3"]=Module["asm"]["tD"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeRevolution_BRepPrimAPI_MakeRevolution_4=Module["_emscripten_bind_BRepPrimAPI_MakeRevolution_BRepPrimAPI_MakeRevolution_4"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeRevolution_BRepPrimAPI_MakeRevolution_4=Module["_emscripten_bind_BRepPrimAPI_MakeRevolution_BRepPrimAPI_MakeRevolution_4"]=Module["asm"]["uD"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeRevolution_BRepPrimAPI_MakeRevolution_5=Module["_emscripten_bind_BRepPrimAPI_MakeRevolution_BRepPrimAPI_MakeRevolution_5"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeRevolution_BRepPrimAPI_MakeRevolution_5=Module["_emscripten_bind_BRepPrimAPI_MakeRevolution_BRepPrimAPI_MakeRevolution_5"]=Module["asm"]["vD"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeRevolution_Shape_0=Module["_emscripten_bind_BRepPrimAPI_MakeRevolution_Shape_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeRevolution_Shape_0=Module["_emscripten_bind_BRepPrimAPI_MakeRevolution_Shape_0"]=Module["asm"]["wD"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeRevolution_Build_0=Module["_emscripten_bind_BRepPrimAPI_MakeRevolution_Build_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeRevolution_Build_0=Module["_emscripten_bind_BRepPrimAPI_MakeRevolution_Build_0"]=Module["asm"]["xD"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeRevolution_Face_0=Module["_emscripten_bind_BRepPrimAPI_MakeRevolution_Face_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeRevolution_Face_0=Module["_emscripten_bind_BRepPrimAPI_MakeRevolution_Face_0"]=Module["asm"]["yD"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeRevolution_Shell_0=Module["_emscripten_bind_BRepPrimAPI_MakeRevolution_Shell_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeRevolution_Shell_0=Module["_emscripten_bind_BRepPrimAPI_MakeRevolution_Shell_0"]=Module["asm"]["zD"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeRevolution_Solid_0=Module["_emscripten_bind_BRepPrimAPI_MakeRevolution_Solid_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeRevolution_Solid_0=Module["_emscripten_bind_BRepPrimAPI_MakeRevolution_Solid_0"]=Module["asm"]["AD"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeRevolution___destroy___0=Module["_emscripten_bind_BRepPrimAPI_MakeRevolution___destroy___0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeRevolution___destroy___0=Module["_emscripten_bind_BRepPrimAPI_MakeRevolution___destroy___0"]=Module["asm"]["BD"]).apply(null,arguments)};var _emscripten_bind_IGESControl_Reader_IGESControl_Reader_0=Module["_emscripten_bind_IGESControl_Reader_IGESControl_Reader_0"]=function(){return(_emscripten_bind_IGESControl_Reader_IGESControl_Reader_0=Module["_emscripten_bind_IGESControl_Reader_IGESControl_Reader_0"]=Module["asm"]["CD"]).apply(null,arguments)};var _emscripten_bind_IGESControl_Reader_SetNorm_1=Module["_emscripten_bind_IGESControl_Reader_SetNorm_1"]=function(){return(_emscripten_bind_IGESControl_Reader_SetNorm_1=Module["_emscripten_bind_IGESControl_Reader_SetNorm_1"]=Module["asm"]["DD"]).apply(null,arguments)};var _emscripten_bind_IGESControl_Reader_SetWS_1=Module["_emscripten_bind_IGESControl_Reader_SetWS_1"]=function(){return(_emscripten_bind_IGESControl_Reader_SetWS_1=Module["_emscripten_bind_IGESControl_Reader_SetWS_1"]=Module["asm"]["ED"]).apply(null,arguments)};var _emscripten_bind_IGESControl_Reader_SetWS_2=Module["_emscripten_bind_IGESControl_Reader_SetWS_2"]=function(){return(_emscripten_bind_IGESControl_Reader_SetWS_2=Module["_emscripten_bind_IGESControl_Reader_SetWS_2"]=Module["asm"]["FD"]).apply(null,arguments)};var _emscripten_bind_IGESControl_Reader_WS_0=Module["_emscripten_bind_IGESControl_Reader_WS_0"]=function(){return(_emscripten_bind_IGESControl_Reader_WS_0=Module["_emscripten_bind_IGESControl_Reader_WS_0"]=Module["asm"]["GD"]).apply(null,arguments)};var _emscripten_bind_IGESControl_Reader_ReadFile_1=Module["_emscripten_bind_IGESControl_Reader_ReadFile_1"]=function(){return(_emscripten_bind_IGESControl_Reader_ReadFile_1=Module["_emscripten_bind_IGESControl_Reader_ReadFile_1"]=Module["asm"]["HD"]).apply(null,arguments)};var _emscripten_bind_IGESControl_Reader_NbRootsForTransfer_0=Module["_emscripten_bind_IGESControl_Reader_NbRootsForTransfer_0"]=function(){return(_emscripten_bind_IGESControl_Reader_NbRootsForTransfer_0=Module["_emscripten_bind_IGESControl_Reader_NbRootsForTransfer_0"]=Module["asm"]["ID"]).apply(null,arguments)};var _emscripten_bind_IGESControl_Reader_TransferOneRoot_0=Module["_emscripten_bind_IGESControl_Reader_TransferOneRoot_0"]=function(){return(_emscripten_bind_IGESControl_Reader_TransferOneRoot_0=Module["_emscripten_bind_IGESControl_Reader_TransferOneRoot_0"]=Module["asm"]["JD"]).apply(null,arguments)};var _emscripten_bind_IGESControl_Reader_TransferOneRoot_1=Module["_emscripten_bind_IGESControl_Reader_TransferOneRoot_1"]=function(){return(_emscripten_bind_IGESControl_Reader_TransferOneRoot_1=Module["_emscripten_bind_IGESControl_Reader_TransferOneRoot_1"]=Module["asm"]["KD"]).apply(null,arguments)};var _emscripten_bind_IGESControl_Reader_TransferOne_1=Module["_emscripten_bind_IGESControl_Reader_TransferOne_1"]=function(){return(_emscripten_bind_IGESControl_Reader_TransferOne_1=Module["_emscripten_bind_IGESControl_Reader_TransferOne_1"]=Module["asm"]["LD"]).apply(null,arguments)};var _emscripten_bind_IGESControl_Reader_TransferRoots_0=Module["_emscripten_bind_IGESControl_Reader_TransferRoots_0"]=function(){return(_emscripten_bind_IGESControl_Reader_TransferRoots_0=Module["_emscripten_bind_IGESControl_Reader_TransferRoots_0"]=Module["asm"]["MD"]).apply(null,arguments)};var _emscripten_bind_IGESControl_Reader_ClearShapes_0=Module["_emscripten_bind_IGESControl_Reader_ClearShapes_0"]=function(){return(_emscripten_bind_IGESControl_Reader_ClearShapes_0=Module["_emscripten_bind_IGESControl_Reader_ClearShapes_0"]=Module["asm"]["ND"]).apply(null,arguments)};var _emscripten_bind_IGESControl_Reader_NbShapes_0=Module["_emscripten_bind_IGESControl_Reader_NbShapes_0"]=function(){return(_emscripten_bind_IGESControl_Reader_NbShapes_0=Module["_emscripten_bind_IGESControl_Reader_NbShapes_0"]=Module["asm"]["OD"]).apply(null,arguments)};var _emscripten_bind_IGESControl_Reader_Shape_0=Module["_emscripten_bind_IGESControl_Reader_Shape_0"]=function(){return(_emscripten_bind_IGESControl_Reader_Shape_0=Module["_emscripten_bind_IGESControl_Reader_Shape_0"]=Module["asm"]["PD"]).apply(null,arguments)};var _emscripten_bind_IGESControl_Reader_Shape_1=Module["_emscripten_bind_IGESControl_Reader_Shape_1"]=function(){return(_emscripten_bind_IGESControl_Reader_Shape_1=Module["_emscripten_bind_IGESControl_Reader_Shape_1"]=Module["asm"]["QD"]).apply(null,arguments)};var _emscripten_bind_IGESControl_Reader_OneShape_0=Module["_emscripten_bind_IGESControl_Reader_OneShape_0"]=function(){return(_emscripten_bind_IGESControl_Reader_OneShape_0=Module["_emscripten_bind_IGESControl_Reader_OneShape_0"]=Module["asm"]["RD"]).apply(null,arguments)};var _emscripten_bind_IGESControl_Reader_PrintStatsTransfer_1=Module["_emscripten_bind_IGESControl_Reader_PrintStatsTransfer_1"]=function(){return(_emscripten_bind_IGESControl_Reader_PrintStatsTransfer_1=Module["_emscripten_bind_IGESControl_Reader_PrintStatsTransfer_1"]=Module["asm"]["SD"]).apply(null,arguments)};var _emscripten_bind_IGESControl_Reader_PrintStatsTransfer_2=Module["_emscripten_bind_IGESControl_Reader_PrintStatsTransfer_2"]=function(){return(_emscripten_bind_IGESControl_Reader_PrintStatsTransfer_2=Module["_emscripten_bind_IGESControl_Reader_PrintStatsTransfer_2"]=Module["asm"]["TD"]).apply(null,arguments)};var _emscripten_bind_IGESControl_Reader___destroy___0=Module["_emscripten_bind_IGESControl_Reader___destroy___0"]=function(){return(_emscripten_bind_IGESControl_Reader___destroy___0=Module["_emscripten_bind_IGESControl_Reader___destroy___0"]=Module["asm"]["UD"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeBox_BRepPrimAPI_MakeBox_2=Module["_emscripten_bind_BRepPrimAPI_MakeBox_BRepPrimAPI_MakeBox_2"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeBox_BRepPrimAPI_MakeBox_2=Module["_emscripten_bind_BRepPrimAPI_MakeBox_BRepPrimAPI_MakeBox_2"]=Module["asm"]["VD"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeBox_BRepPrimAPI_MakeBox_3=Module["_emscripten_bind_BRepPrimAPI_MakeBox_BRepPrimAPI_MakeBox_3"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeBox_BRepPrimAPI_MakeBox_3=Module["_emscripten_bind_BRepPrimAPI_MakeBox_BRepPrimAPI_MakeBox_3"]=Module["asm"]["WD"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeBox_BRepPrimAPI_MakeBox_4=Module["_emscripten_bind_BRepPrimAPI_MakeBox_BRepPrimAPI_MakeBox_4"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeBox_BRepPrimAPI_MakeBox_4=Module["_emscripten_bind_BRepPrimAPI_MakeBox_BRepPrimAPI_MakeBox_4"]=Module["asm"]["XD"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeBox_Build_0=Module["_emscripten_bind_BRepPrimAPI_MakeBox_Build_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeBox_Build_0=Module["_emscripten_bind_BRepPrimAPI_MakeBox_Build_0"]=Module["asm"]["YD"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeBox_Shell_0=Module["_emscripten_bind_BRepPrimAPI_MakeBox_Shell_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeBox_Shell_0=Module["_emscripten_bind_BRepPrimAPI_MakeBox_Shell_0"]=Module["asm"]["ZD"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeBox_Solid_0=Module["_emscripten_bind_BRepPrimAPI_MakeBox_Solid_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeBox_Solid_0=Module["_emscripten_bind_BRepPrimAPI_MakeBox_Solid_0"]=Module["asm"]["_D"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeBox_BottomFace_0=Module["_emscripten_bind_BRepPrimAPI_MakeBox_BottomFace_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeBox_BottomFace_0=Module["_emscripten_bind_BRepPrimAPI_MakeBox_BottomFace_0"]=Module["asm"]["$D"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeBox_BackFace_0=Module["_emscripten_bind_BRepPrimAPI_MakeBox_BackFace_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeBox_BackFace_0=Module["_emscripten_bind_BRepPrimAPI_MakeBox_BackFace_0"]=Module["asm"]["aE"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeBox_FrontFace_0=Module["_emscripten_bind_BRepPrimAPI_MakeBox_FrontFace_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeBox_FrontFace_0=Module["_emscripten_bind_BRepPrimAPI_MakeBox_FrontFace_0"]=Module["asm"]["bE"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeBox_LeftFace_0=Module["_emscripten_bind_BRepPrimAPI_MakeBox_LeftFace_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeBox_LeftFace_0=Module["_emscripten_bind_BRepPrimAPI_MakeBox_LeftFace_0"]=Module["asm"]["cE"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeBox_RightFace_0=Module["_emscripten_bind_BRepPrimAPI_MakeBox_RightFace_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeBox_RightFace_0=Module["_emscripten_bind_BRepPrimAPI_MakeBox_RightFace_0"]=Module["asm"]["dE"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeBox_TopFace_0=Module["_emscripten_bind_BRepPrimAPI_MakeBox_TopFace_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeBox_TopFace_0=Module["_emscripten_bind_BRepPrimAPI_MakeBox_TopFace_0"]=Module["asm"]["eE"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeBox_Shape_0=Module["_emscripten_bind_BRepPrimAPI_MakeBox_Shape_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeBox_Shape_0=Module["_emscripten_bind_BRepPrimAPI_MakeBox_Shape_0"]=Module["asm"]["fE"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeBox_IsDeleted_1=Module["_emscripten_bind_BRepPrimAPI_MakeBox_IsDeleted_1"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeBox_IsDeleted_1=Module["_emscripten_bind_BRepPrimAPI_MakeBox_IsDeleted_1"]=Module["asm"]["gE"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeBox___destroy___0=Module["_emscripten_bind_BRepPrimAPI_MakeBox___destroy___0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeBox___destroy___0=Module["_emscripten_bind_BRepPrimAPI_MakeBox___destroy___0"]=Module["asm"]["hE"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Surface_Handle_Geom_Surface_0=Module["_emscripten_bind_Handle_Geom_Surface_Handle_Geom_Surface_0"]=function(){return(_emscripten_bind_Handle_Geom_Surface_Handle_Geom_Surface_0=Module["_emscripten_bind_Handle_Geom_Surface_Handle_Geom_Surface_0"]=Module["asm"]["iE"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Surface_Handle_Geom_Surface_1=Module["_emscripten_bind_Handle_Geom_Surface_Handle_Geom_Surface_1"]=function(){return(_emscripten_bind_Handle_Geom_Surface_Handle_Geom_Surface_1=Module["_emscripten_bind_Handle_Geom_Surface_Handle_Geom_Surface_1"]=Module["asm"]["jE"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Surface_IsNull_0=Module["_emscripten_bind_Handle_Geom_Surface_IsNull_0"]=function(){return(_emscripten_bind_Handle_Geom_Surface_IsNull_0=Module["_emscripten_bind_Handle_Geom_Surface_IsNull_0"]=Module["asm"]["kE"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Surface_Nullify_0=Module["_emscripten_bind_Handle_Geom_Surface_Nullify_0"]=function(){return(_emscripten_bind_Handle_Geom_Surface_Nullify_0=Module["_emscripten_bind_Handle_Geom_Surface_Nullify_0"]=Module["asm"]["lE"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Surface_get_0=Module["_emscripten_bind_Handle_Geom_Surface_get_0"]=function(){return(_emscripten_bind_Handle_Geom_Surface_get_0=Module["_emscripten_bind_Handle_Geom_Surface_get_0"]=Module["asm"]["mE"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Surface___destroy___0=Module["_emscripten_bind_Handle_Geom_Surface___destroy___0"]=function(){return(_emscripten_bind_Handle_Geom_Surface___destroy___0=Module["_emscripten_bind_Handle_Geom_Surface___destroy___0"]=Module["asm"]["nE"]).apply(null,arguments)};var _emscripten_bind_gp_Vec_gp_Vec_3=Module["_emscripten_bind_gp_Vec_gp_Vec_3"]=function(){return(_emscripten_bind_gp_Vec_gp_Vec_3=Module["_emscripten_bind_gp_Vec_gp_Vec_3"]=Module["asm"]["oE"]).apply(null,arguments)};var _emscripten_bind_gp_Vec_X_0=Module["_emscripten_bind_gp_Vec_X_0"]=function(){return(_emscripten_bind_gp_Vec_X_0=Module["_emscripten_bind_gp_Vec_X_0"]=Module["asm"]["pE"]).apply(null,arguments)};var _emscripten_bind_gp_Vec_Y_0=Module["_emscripten_bind_gp_Vec_Y_0"]=function(){return(_emscripten_bind_gp_Vec_Y_0=Module["_emscripten_bind_gp_Vec_Y_0"]=Module["asm"]["qE"]).apply(null,arguments)};var _emscripten_bind_gp_Vec_Z_0=Module["_emscripten_bind_gp_Vec_Z_0"]=function(){return(_emscripten_bind_gp_Vec_Z_0=Module["_emscripten_bind_gp_Vec_Z_0"]=Module["asm"]["rE"]).apply(null,arguments)};var _emscripten_bind_gp_Vec___destroy___0=Module["_emscripten_bind_gp_Vec___destroy___0"]=function(){return(_emscripten_bind_gp_Vec___destroy___0=Module["_emscripten_bind_gp_Vec___destroy___0"]=Module["asm"]["sE"]).apply(null,arguments)};var _emscripten_bind_TopExp_Explorer_TopExp_Explorer_0=Module["_emscripten_bind_TopExp_Explorer_TopExp_Explorer_0"]=function(){return(_emscripten_bind_TopExp_Explorer_TopExp_Explorer_0=Module["_emscripten_bind_TopExp_Explorer_TopExp_Explorer_0"]=Module["asm"]["tE"]).apply(null,arguments)};var _emscripten_bind_TopExp_Explorer_TopExp_Explorer_2=Module["_emscripten_bind_TopExp_Explorer_TopExp_Explorer_2"]=function(){return(_emscripten_bind_TopExp_Explorer_TopExp_Explorer_2=Module["_emscripten_bind_TopExp_Explorer_TopExp_Explorer_2"]=Module["asm"]["uE"]).apply(null,arguments)};var _emscripten_bind_TopExp_Explorer_TopExp_Explorer_3=Module["_emscripten_bind_TopExp_Explorer_TopExp_Explorer_3"]=function(){return(_emscripten_bind_TopExp_Explorer_TopExp_Explorer_3=Module["_emscripten_bind_TopExp_Explorer_TopExp_Explorer_3"]=Module["asm"]["vE"]).apply(null,arguments)};var _emscripten_bind_TopExp_Explorer_Init_2=Module["_emscripten_bind_TopExp_Explorer_Init_2"]=function(){return(_emscripten_bind_TopExp_Explorer_Init_2=Module["_emscripten_bind_TopExp_Explorer_Init_2"]=Module["asm"]["wE"]).apply(null,arguments)};var _emscripten_bind_TopExp_Explorer_Init_3=Module["_emscripten_bind_TopExp_Explorer_Init_3"]=function(){return(_emscripten_bind_TopExp_Explorer_Init_3=Module["_emscripten_bind_TopExp_Explorer_Init_3"]=Module["asm"]["xE"]).apply(null,arguments)};var _emscripten_bind_TopExp_Explorer_More_0=Module["_emscripten_bind_TopExp_Explorer_More_0"]=function(){return(_emscripten_bind_TopExp_Explorer_More_0=Module["_emscripten_bind_TopExp_Explorer_More_0"]=Module["asm"]["yE"]).apply(null,arguments)};var _emscripten_bind_TopExp_Explorer_Next_0=Module["_emscripten_bind_TopExp_Explorer_Next_0"]=function(){return(_emscripten_bind_TopExp_Explorer_Next_0=Module["_emscripten_bind_TopExp_Explorer_Next_0"]=Module["asm"]["zE"]).apply(null,arguments)};var _emscripten_bind_TopExp_Explorer_Current_0=Module["_emscripten_bind_TopExp_Explorer_Current_0"]=function(){return(_emscripten_bind_TopExp_Explorer_Current_0=Module["_emscripten_bind_TopExp_Explorer_Current_0"]=Module["asm"]["AE"]).apply(null,arguments)};var _emscripten_bind_TopExp_Explorer_ReInit_0=Module["_emscripten_bind_TopExp_Explorer_ReInit_0"]=function(){return(_emscripten_bind_TopExp_Explorer_ReInit_0=Module["_emscripten_bind_TopExp_Explorer_ReInit_0"]=Module["asm"]["BE"]).apply(null,arguments)};var _emscripten_bind_TopExp_Explorer_Depth_0=Module["_emscripten_bind_TopExp_Explorer_Depth_0"]=function(){return(_emscripten_bind_TopExp_Explorer_Depth_0=Module["_emscripten_bind_TopExp_Explorer_Depth_0"]=Module["asm"]["CE"]).apply(null,arguments)};var _emscripten_bind_TopExp_Explorer_Clear_0=Module["_emscripten_bind_TopExp_Explorer_Clear_0"]=function(){return(_emscripten_bind_TopExp_Explorer_Clear_0=Module["_emscripten_bind_TopExp_Explorer_Clear_0"]=Module["asm"]["DE"]).apply(null,arguments)};var _emscripten_bind_TopExp_Explorer_Destroy_0=Module["_emscripten_bind_TopExp_Explorer_Destroy_0"]=function(){return(_emscripten_bind_TopExp_Explorer_Destroy_0=Module["_emscripten_bind_TopExp_Explorer_Destroy_0"]=Module["asm"]["EE"]).apply(null,arguments)};var _emscripten_bind_TopExp_Explorer___destroy___0=Module["_emscripten_bind_TopExp_Explorer___destroy___0"]=function(){return(_emscripten_bind_TopExp_Explorer___destroy___0=Module["_emscripten_bind_TopExp_Explorer___destroy___0"]=Module["asm"]["FE"]).apply(null,arguments)};var _emscripten_bind_Poly_Array1OfTriangle_Poly_Array1OfTriangle_0=Module["_emscripten_bind_Poly_Array1OfTriangle_Poly_Array1OfTriangle_0"]=function(){return(_emscripten_bind_Poly_Array1OfTriangle_Poly_Array1OfTriangle_0=Module["_emscripten_bind_Poly_Array1OfTriangle_Poly_Array1OfTriangle_0"]=Module["asm"]["GE"]).apply(null,arguments)};var _emscripten_bind_Poly_Array1OfTriangle_Poly_Array1OfTriangle_2=Module["_emscripten_bind_Poly_Array1OfTriangle_Poly_Array1OfTriangle_2"]=function(){return(_emscripten_bind_Poly_Array1OfTriangle_Poly_Array1OfTriangle_2=Module["_emscripten_bind_Poly_Array1OfTriangle_Poly_Array1OfTriangle_2"]=Module["asm"]["HE"]).apply(null,arguments)};var _emscripten_bind_Poly_Array1OfTriangle_Length_0=Module["_emscripten_bind_Poly_Array1OfTriangle_Length_0"]=function(){return(_emscripten_bind_Poly_Array1OfTriangle_Length_0=Module["_emscripten_bind_Poly_Array1OfTriangle_Length_0"]=Module["asm"]["IE"]).apply(null,arguments)};var _emscripten_bind_Poly_Array1OfTriangle_Lower_0=Module["_emscripten_bind_Poly_Array1OfTriangle_Lower_0"]=function(){return(_emscripten_bind_Poly_Array1OfTriangle_Lower_0=Module["_emscripten_bind_Poly_Array1OfTriangle_Lower_0"]=Module["asm"]["JE"]).apply(null,arguments)};var _emscripten_bind_Poly_Array1OfTriangle_Upper_0=Module["_emscripten_bind_Poly_Array1OfTriangle_Upper_0"]=function(){return(_emscripten_bind_Poly_Array1OfTriangle_Upper_0=Module["_emscripten_bind_Poly_Array1OfTriangle_Upper_0"]=Module["asm"]["KE"]).apply(null,arguments)};var _emscripten_bind_Poly_Array1OfTriangle_Value_1=Module["_emscripten_bind_Poly_Array1OfTriangle_Value_1"]=function(){return(_emscripten_bind_Poly_Array1OfTriangle_Value_1=Module["_emscripten_bind_Poly_Array1OfTriangle_Value_1"]=Module["asm"]["LE"]).apply(null,arguments)};var _emscripten_bind_Poly_Array1OfTriangle_SetValue_2=Module["_emscripten_bind_Poly_Array1OfTriangle_SetValue_2"]=function(){return(_emscripten_bind_Poly_Array1OfTriangle_SetValue_2=Module["_emscripten_bind_Poly_Array1OfTriangle_SetValue_2"]=Module["asm"]["ME"]).apply(null,arguments)};var _emscripten_bind_Poly_Array1OfTriangle___destroy___0=Module["_emscripten_bind_Poly_Array1OfTriangle___destroy___0"]=function(){return(_emscripten_bind_Poly_Array1OfTriangle___destroy___0=Module["_emscripten_bind_Poly_Array1OfTriangle___destroy___0"]=Module["asm"]["NE"]).apply(null,arguments)};var _emscripten_bind_Geom2d_Ellipse_Geom2d_Ellipse_3=Module["_emscripten_bind_Geom2d_Ellipse_Geom2d_Ellipse_3"]=function(){return(_emscripten_bind_Geom2d_Ellipse_Geom2d_Ellipse_3=Module["_emscripten_bind_Geom2d_Ellipse_Geom2d_Ellipse_3"]=Module["asm"]["OE"]).apply(null,arguments)};var _emscripten_bind_Geom2d_Ellipse_Geom2d_Ellipse_4=Module["_emscripten_bind_Geom2d_Ellipse_Geom2d_Ellipse_4"]=function(){return(_emscripten_bind_Geom2d_Ellipse_Geom2d_Ellipse_4=Module["_emscripten_bind_Geom2d_Ellipse_Geom2d_Ellipse_4"]=Module["asm"]["PE"]).apply(null,arguments)};var _emscripten_bind_Geom2d_Ellipse_Period_0=Module["_emscripten_bind_Geom2d_Ellipse_Period_0"]=function(){return(_emscripten_bind_Geom2d_Ellipse_Period_0=Module["_emscripten_bind_Geom2d_Ellipse_Period_0"]=Module["asm"]["QE"]).apply(null,arguments)};var _emscripten_bind_Geom2d_Ellipse_Value_1=Module["_emscripten_bind_Geom2d_Ellipse_Value_1"]=function(){return(_emscripten_bind_Geom2d_Ellipse_Value_1=Module["_emscripten_bind_Geom2d_Ellipse_Value_1"]=Module["asm"]["RE"]).apply(null,arguments)};var _emscripten_bind_Geom2d_Ellipse___destroy___0=Module["_emscripten_bind_Geom2d_Ellipse___destroy___0"]=function(){return(_emscripten_bind_Geom2d_Ellipse___destroy___0=Module["_emscripten_bind_Geom2d_Ellipse___destroy___0"]=Module["asm"]["SE"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakePipeShell_BRepOffsetAPI_MakePipeShell_1=Module["_emscripten_bind_BRepOffsetAPI_MakePipeShell_BRepOffsetAPI_MakePipeShell_1"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakePipeShell_BRepOffsetAPI_MakePipeShell_1=Module["_emscripten_bind_BRepOffsetAPI_MakePipeShell_BRepOffsetAPI_MakePipeShell_1"]=Module["asm"]["TE"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakePipeShell_SetMode_2=Module["_emscripten_bind_BRepOffsetAPI_MakePipeShell_SetMode_2"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakePipeShell_SetMode_2=Module["_emscripten_bind_BRepOffsetAPI_MakePipeShell_SetMode_2"]=Module["asm"]["UE"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakePipeShell_SetMode_3=Module["_emscripten_bind_BRepOffsetAPI_MakePipeShell_SetMode_3"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakePipeShell_SetMode_3=Module["_emscripten_bind_BRepOffsetAPI_MakePipeShell_SetMode_3"]=Module["asm"]["VE"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakePipeShell_Add_1=Module["_emscripten_bind_BRepOffsetAPI_MakePipeShell_Add_1"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakePipeShell_Add_1=Module["_emscripten_bind_BRepOffsetAPI_MakePipeShell_Add_1"]=Module["asm"]["WE"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakePipeShell_Add_2=Module["_emscripten_bind_BRepOffsetAPI_MakePipeShell_Add_2"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakePipeShell_Add_2=Module["_emscripten_bind_BRepOffsetAPI_MakePipeShell_Add_2"]=Module["asm"]["XE"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakePipeShell_Add_3=Module["_emscripten_bind_BRepOffsetAPI_MakePipeShell_Add_3"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakePipeShell_Add_3=Module["_emscripten_bind_BRepOffsetAPI_MakePipeShell_Add_3"]=Module["asm"]["YE"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakePipeShell_Build_0=Module["_emscripten_bind_BRepOffsetAPI_MakePipeShell_Build_0"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakePipeShell_Build_0=Module["_emscripten_bind_BRepOffsetAPI_MakePipeShell_Build_0"]=Module["asm"]["ZE"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakePipeShell_MakeSolid_0=Module["_emscripten_bind_BRepOffsetAPI_MakePipeShell_MakeSolid_0"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakePipeShell_MakeSolid_0=Module["_emscripten_bind_BRepOffsetAPI_MakePipeShell_MakeSolid_0"]=Module["asm"]["_E"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakePipeShell_Generated_1=Module["_emscripten_bind_BRepOffsetAPI_MakePipeShell_Generated_1"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakePipeShell_Generated_1=Module["_emscripten_bind_BRepOffsetAPI_MakePipeShell_Generated_1"]=Module["asm"]["$E"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakePipeShell_FirstShape_0=Module["_emscripten_bind_BRepOffsetAPI_MakePipeShell_FirstShape_0"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakePipeShell_FirstShape_0=Module["_emscripten_bind_BRepOffsetAPI_MakePipeShell_FirstShape_0"]=Module["asm"]["aF"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakePipeShell_LastShape_0=Module["_emscripten_bind_BRepOffsetAPI_MakePipeShell_LastShape_0"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakePipeShell_LastShape_0=Module["_emscripten_bind_BRepOffsetAPI_MakePipeShell_LastShape_0"]=Module["asm"]["bF"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakePipeShell_Shape_0=Module["_emscripten_bind_BRepOffsetAPI_MakePipeShell_Shape_0"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakePipeShell_Shape_0=Module["_emscripten_bind_BRepOffsetAPI_MakePipeShell_Shape_0"]=Module["asm"]["cF"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakePipeShell_ErrorOnSurface_0=Module["_emscripten_bind_BRepOffsetAPI_MakePipeShell_ErrorOnSurface_0"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakePipeShell_ErrorOnSurface_0=Module["_emscripten_bind_BRepOffsetAPI_MakePipeShell_ErrorOnSurface_0"]=Module["asm"]["dF"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakePipeShell_GetStatus_0=Module["_emscripten_bind_BRepOffsetAPI_MakePipeShell_GetStatus_0"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakePipeShell_GetStatus_0=Module["_emscripten_bind_BRepOffsetAPI_MakePipeShell_GetStatus_0"]=Module["asm"]["eF"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakePipeShell_IsReady_0=Module["_emscripten_bind_BRepOffsetAPI_MakePipeShell_IsReady_0"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakePipeShell_IsReady_0=Module["_emscripten_bind_BRepOffsetAPI_MakePipeShell_IsReady_0"]=Module["asm"]["fF"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakePipeShell___destroy___0=Module["_emscripten_bind_BRepOffsetAPI_MakePipeShell___destroy___0"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakePipeShell___destroy___0=Module["_emscripten_bind_BRepOffsetAPI_MakePipeShell___destroy___0"]=Module["asm"]["gF"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeFace_BRepBuilderAPI_MakeFace_1=Module["_emscripten_bind_BRepBuilderAPI_MakeFace_BRepBuilderAPI_MakeFace_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeFace_BRepBuilderAPI_MakeFace_1=Module["_emscripten_bind_BRepBuilderAPI_MakeFace_BRepBuilderAPI_MakeFace_1"]=Module["asm"]["hF"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeFace_BRepBuilderAPI_MakeFace_2=Module["_emscripten_bind_BRepBuilderAPI_MakeFace_BRepBuilderAPI_MakeFace_2"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeFace_BRepBuilderAPI_MakeFace_2=Module["_emscripten_bind_BRepBuilderAPI_MakeFace_BRepBuilderAPI_MakeFace_2"]=Module["asm"]["iF"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeFace_Face_0=Module["_emscripten_bind_BRepBuilderAPI_MakeFace_Face_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeFace_Face_0=Module["_emscripten_bind_BRepBuilderAPI_MakeFace_Face_0"]=Module["asm"]["jF"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeFace_Add_1=Module["_emscripten_bind_BRepBuilderAPI_MakeFace_Add_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeFace_Add_1=Module["_emscripten_bind_BRepBuilderAPI_MakeFace_Add_1"]=Module["asm"]["kF"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeFace_Error_0=Module["_emscripten_bind_BRepBuilderAPI_MakeFace_Error_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeFace_Error_0=Module["_emscripten_bind_BRepBuilderAPI_MakeFace_Error_0"]=Module["asm"]["lF"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeFace___destroy___0=Module["_emscripten_bind_BRepBuilderAPI_MakeFace___destroy___0"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeFace___destroy___0=Module["_emscripten_bind_BRepBuilderAPI_MakeFace___destroy___0"]=Module["asm"]["mF"]).apply(null,arguments)};var _emscripten_bind_BRepAlgoAPI_Fuse_BRepAlgoAPI_Fuse_2=Module["_emscripten_bind_BRepAlgoAPI_Fuse_BRepAlgoAPI_Fuse_2"]=function(){return(_emscripten_bind_BRepAlgoAPI_Fuse_BRepAlgoAPI_Fuse_2=Module["_emscripten_bind_BRepAlgoAPI_Fuse_BRepAlgoAPI_Fuse_2"]=Module["asm"]["nF"]).apply(null,arguments)};var _emscripten_bind_BRepAlgoAPI_Fuse_Shape_0=Module["_emscripten_bind_BRepAlgoAPI_Fuse_Shape_0"]=function(){return(_emscripten_bind_BRepAlgoAPI_Fuse_Shape_0=Module["_emscripten_bind_BRepAlgoAPI_Fuse_Shape_0"]=Module["asm"]["oF"]).apply(null,arguments)};var _emscripten_bind_BRepAlgoAPI_Fuse___destroy___0=Module["_emscripten_bind_BRepAlgoAPI_Fuse___destroy___0"]=function(){return(_emscripten_bind_BRepAlgoAPI_Fuse___destroy___0=Module["_emscripten_bind_BRepAlgoAPI_Fuse___destroy___0"]=Module["asm"]["pF"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom2d_TrimmedCurve_Handle_Geom2d_TrimmedCurve_0=Module["_emscripten_bind_Handle_Geom2d_TrimmedCurve_Handle_Geom2d_TrimmedCurve_0"]=function(){return(_emscripten_bind_Handle_Geom2d_TrimmedCurve_Handle_Geom2d_TrimmedCurve_0=Module["_emscripten_bind_Handle_Geom2d_TrimmedCurve_Handle_Geom2d_TrimmedCurve_0"]=Module["asm"]["qF"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom2d_TrimmedCurve_Handle_Geom2d_TrimmedCurve_1=Module["_emscripten_bind_Handle_Geom2d_TrimmedCurve_Handle_Geom2d_TrimmedCurve_1"]=function(){return(_emscripten_bind_Handle_Geom2d_TrimmedCurve_Handle_Geom2d_TrimmedCurve_1=Module["_emscripten_bind_Handle_Geom2d_TrimmedCurve_Handle_Geom2d_TrimmedCurve_1"]=Module["asm"]["rF"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom2d_TrimmedCurve_IsNull_0=Module["_emscripten_bind_Handle_Geom2d_TrimmedCurve_IsNull_0"]=function(){return(_emscripten_bind_Handle_Geom2d_TrimmedCurve_IsNull_0=Module["_emscripten_bind_Handle_Geom2d_TrimmedCurve_IsNull_0"]=Module["asm"]["sF"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom2d_TrimmedCurve_Nullify_0=Module["_emscripten_bind_Handle_Geom2d_TrimmedCurve_Nullify_0"]=function(){return(_emscripten_bind_Handle_Geom2d_TrimmedCurve_Nullify_0=Module["_emscripten_bind_Handle_Geom2d_TrimmedCurve_Nullify_0"]=Module["asm"]["tF"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom2d_TrimmedCurve_get_0=Module["_emscripten_bind_Handle_Geom2d_TrimmedCurve_get_0"]=function(){return(_emscripten_bind_Handle_Geom2d_TrimmedCurve_get_0=Module["_emscripten_bind_Handle_Geom2d_TrimmedCurve_get_0"]=Module["asm"]["uF"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom2d_TrimmedCurve___destroy___0=Module["_emscripten_bind_Handle_Geom2d_TrimmedCurve___destroy___0"]=function(){return(_emscripten_bind_Handle_Geom2d_TrimmedCurve___destroy___0=Module["_emscripten_bind_Handle_Geom2d_TrimmedCurve___destroy___0"]=Module["asm"]["vF"]).apply(null,arguments)};var _emscripten_bind_gp_Parab_gp_Parab_0=Module["_emscripten_bind_gp_Parab_gp_Parab_0"]=function(){return(_emscripten_bind_gp_Parab_gp_Parab_0=Module["_emscripten_bind_gp_Parab_gp_Parab_0"]=Module["asm"]["wF"]).apply(null,arguments)};var _emscripten_bind_gp_Parab_gp_Parab_2=Module["_emscripten_bind_gp_Parab_gp_Parab_2"]=function(){return(_emscripten_bind_gp_Parab_gp_Parab_2=Module["_emscripten_bind_gp_Parab_gp_Parab_2"]=Module["asm"]["xF"]).apply(null,arguments)};var _emscripten_bind_gp_Parab_Focal_0=Module["_emscripten_bind_gp_Parab_Focal_0"]=function(){return(_emscripten_bind_gp_Parab_Focal_0=Module["_emscripten_bind_gp_Parab_Focal_0"]=Module["asm"]["yF"]).apply(null,arguments)};var _emscripten_bind_gp_Parab___destroy___0=Module["_emscripten_bind_gp_Parab___destroy___0"]=function(){return(_emscripten_bind_gp_Parab___destroy___0=Module["_emscripten_bind_gp_Parab___destroy___0"]=Module["asm"]["zF"]).apply(null,arguments)};var _emscripten_bind_gp_XYZ_gp_XYZ_3=Module["_emscripten_bind_gp_XYZ_gp_XYZ_3"]=function(){return(_emscripten_bind_gp_XYZ_gp_XYZ_3=Module["_emscripten_bind_gp_XYZ_gp_XYZ_3"]=Module["asm"]["AF"]).apply(null,arguments)};var _emscripten_bind_gp_XYZ_SetCoord_3=Module["_emscripten_bind_gp_XYZ_SetCoord_3"]=function(){return(_emscripten_bind_gp_XYZ_SetCoord_3=Module["_emscripten_bind_gp_XYZ_SetCoord_3"]=Module["asm"]["BF"]).apply(null,arguments)};var _emscripten_bind_gp_XYZ_SetX_1=Module["_emscripten_bind_gp_XYZ_SetX_1"]=function(){return(_emscripten_bind_gp_XYZ_SetX_1=Module["_emscripten_bind_gp_XYZ_SetX_1"]=Module["asm"]["CF"]).apply(null,arguments)};var _emscripten_bind_gp_XYZ_SetY_1=Module["_emscripten_bind_gp_XYZ_SetY_1"]=function(){return(_emscripten_bind_gp_XYZ_SetY_1=Module["_emscripten_bind_gp_XYZ_SetY_1"]=Module["asm"]["DF"]).apply(null,arguments)};var _emscripten_bind_gp_XYZ_SetZ_1=Module["_emscripten_bind_gp_XYZ_SetZ_1"]=function(){return(_emscripten_bind_gp_XYZ_SetZ_1=Module["_emscripten_bind_gp_XYZ_SetZ_1"]=Module["asm"]["EF"]).apply(null,arguments)};var _emscripten_bind_gp_XYZ_Coord_1=Module["_emscripten_bind_gp_XYZ_Coord_1"]=function(){return(_emscripten_bind_gp_XYZ_Coord_1=Module["_emscripten_bind_gp_XYZ_Coord_1"]=Module["asm"]["FF"]).apply(null,arguments)};var _emscripten_bind_gp_XYZ_X_0=Module["_emscripten_bind_gp_XYZ_X_0"]=function(){return(_emscripten_bind_gp_XYZ_X_0=Module["_emscripten_bind_gp_XYZ_X_0"]=Module["asm"]["GF"]).apply(null,arguments)};var _emscripten_bind_gp_XYZ_Y_0=Module["_emscripten_bind_gp_XYZ_Y_0"]=function(){return(_emscripten_bind_gp_XYZ_Y_0=Module["_emscripten_bind_gp_XYZ_Y_0"]=Module["asm"]["HF"]).apply(null,arguments)};var _emscripten_bind_gp_XYZ_Z_0=Module["_emscripten_bind_gp_XYZ_Z_0"]=function(){return(_emscripten_bind_gp_XYZ_Z_0=Module["_emscripten_bind_gp_XYZ_Z_0"]=Module["asm"]["IF"]).apply(null,arguments)};var _emscripten_bind_gp_XYZ_IsEqual_2=Module["_emscripten_bind_gp_XYZ_IsEqual_2"]=function(){return(_emscripten_bind_gp_XYZ_IsEqual_2=Module["_emscripten_bind_gp_XYZ_IsEqual_2"]=Module["asm"]["JF"]).apply(null,arguments)};var _emscripten_bind_gp_XYZ___destroy___0=Module["_emscripten_bind_gp_XYZ___destroy___0"]=function(){return(_emscripten_bind_gp_XYZ___destroy___0=Module["_emscripten_bind_gp_XYZ___destroy___0"]=Module["asm"]["KF"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_BRepAdaptor_Surface_0=Module["_emscripten_bind_BRepAdaptor_Surface_BRepAdaptor_Surface_0"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_BRepAdaptor_Surface_0=Module["_emscripten_bind_BRepAdaptor_Surface_BRepAdaptor_Surface_0"]=Module["asm"]["LF"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_BRepAdaptor_Surface_1=Module["_emscripten_bind_BRepAdaptor_Surface_BRepAdaptor_Surface_1"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_BRepAdaptor_Surface_1=Module["_emscripten_bind_BRepAdaptor_Surface_BRepAdaptor_Surface_1"]=Module["asm"]["MF"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_BRepAdaptor_Surface_2=Module["_emscripten_bind_BRepAdaptor_Surface_BRepAdaptor_Surface_2"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_BRepAdaptor_Surface_2=Module["_emscripten_bind_BRepAdaptor_Surface_BRepAdaptor_Surface_2"]=Module["asm"]["NF"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_Initialize_1=Module["_emscripten_bind_BRepAdaptor_Surface_Initialize_1"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_Initialize_1=Module["_emscripten_bind_BRepAdaptor_Surface_Initialize_1"]=Module["asm"]["OF"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_Initialize_2=Module["_emscripten_bind_BRepAdaptor_Surface_Initialize_2"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_Initialize_2=Module["_emscripten_bind_BRepAdaptor_Surface_Initialize_2"]=Module["asm"]["PF"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_Trsf_0=Module["_emscripten_bind_BRepAdaptor_Surface_Trsf_0"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_Trsf_0=Module["_emscripten_bind_BRepAdaptor_Surface_Trsf_0"]=Module["asm"]["QF"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_Face_0=Module["_emscripten_bind_BRepAdaptor_Surface_Face_0"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_Face_0=Module["_emscripten_bind_BRepAdaptor_Surface_Face_0"]=Module["asm"]["RF"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_Tolerance_0=Module["_emscripten_bind_BRepAdaptor_Surface_Tolerance_0"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_Tolerance_0=Module["_emscripten_bind_BRepAdaptor_Surface_Tolerance_0"]=Module["asm"]["SF"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_FirstUParameter_0=Module["_emscripten_bind_BRepAdaptor_Surface_FirstUParameter_0"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_FirstUParameter_0=Module["_emscripten_bind_BRepAdaptor_Surface_FirstUParameter_0"]=Module["asm"]["TF"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_LastUParameter_0=Module["_emscripten_bind_BRepAdaptor_Surface_LastUParameter_0"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_LastUParameter_0=Module["_emscripten_bind_BRepAdaptor_Surface_LastUParameter_0"]=Module["asm"]["UF"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_FirstVParameter_0=Module["_emscripten_bind_BRepAdaptor_Surface_FirstVParameter_0"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_FirstVParameter_0=Module["_emscripten_bind_BRepAdaptor_Surface_FirstVParameter_0"]=Module["asm"]["VF"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_LastVParameter_0=Module["_emscripten_bind_BRepAdaptor_Surface_LastVParameter_0"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_LastVParameter_0=Module["_emscripten_bind_BRepAdaptor_Surface_LastVParameter_0"]=Module["asm"]["WF"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_IsUClosed_0=Module["_emscripten_bind_BRepAdaptor_Surface_IsUClosed_0"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_IsUClosed_0=Module["_emscripten_bind_BRepAdaptor_Surface_IsUClosed_0"]=Module["asm"]["XF"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_IsVClosed_0=Module["_emscripten_bind_BRepAdaptor_Surface_IsVClosed_0"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_IsVClosed_0=Module["_emscripten_bind_BRepAdaptor_Surface_IsVClosed_0"]=Module["asm"]["YF"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_IsUPeriodic_0=Module["_emscripten_bind_BRepAdaptor_Surface_IsUPeriodic_0"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_IsUPeriodic_0=Module["_emscripten_bind_BRepAdaptor_Surface_IsUPeriodic_0"]=Module["asm"]["ZF"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_UPeriod_0=Module["_emscripten_bind_BRepAdaptor_Surface_UPeriod_0"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_UPeriod_0=Module["_emscripten_bind_BRepAdaptor_Surface_UPeriod_0"]=Module["asm"]["_F"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_IsVPeriodic_0=Module["_emscripten_bind_BRepAdaptor_Surface_IsVPeriodic_0"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_IsVPeriodic_0=Module["_emscripten_bind_BRepAdaptor_Surface_IsVPeriodic_0"]=Module["asm"]["$F"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_VPeriod_0=Module["_emscripten_bind_BRepAdaptor_Surface_VPeriod_0"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_VPeriod_0=Module["_emscripten_bind_BRepAdaptor_Surface_VPeriod_0"]=Module["asm"]["aG"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_Value_2=Module["_emscripten_bind_BRepAdaptor_Surface_Value_2"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_Value_2=Module["_emscripten_bind_BRepAdaptor_Surface_Value_2"]=Module["asm"]["bG"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_D0_3=Module["_emscripten_bind_BRepAdaptor_Surface_D0_3"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_D0_3=Module["_emscripten_bind_BRepAdaptor_Surface_D0_3"]=Module["asm"]["cG"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_D1_5=Module["_emscripten_bind_BRepAdaptor_Surface_D1_5"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_D1_5=Module["_emscripten_bind_BRepAdaptor_Surface_D1_5"]=Module["asm"]["dG"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_D2_8=Module["_emscripten_bind_BRepAdaptor_Surface_D2_8"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_D2_8=Module["_emscripten_bind_BRepAdaptor_Surface_D2_8"]=Module["asm"]["eG"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_D3_12=Module["_emscripten_bind_BRepAdaptor_Surface_D3_12"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_D3_12=Module["_emscripten_bind_BRepAdaptor_Surface_D3_12"]=Module["asm"]["fG"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_DN_4=Module["_emscripten_bind_BRepAdaptor_Surface_DN_4"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_DN_4=Module["_emscripten_bind_BRepAdaptor_Surface_DN_4"]=Module["asm"]["gG"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_UResolution_1=Module["_emscripten_bind_BRepAdaptor_Surface_UResolution_1"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_UResolution_1=Module["_emscripten_bind_BRepAdaptor_Surface_UResolution_1"]=Module["asm"]["hG"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_VResolution_1=Module["_emscripten_bind_BRepAdaptor_Surface_VResolution_1"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_VResolution_1=Module["_emscripten_bind_BRepAdaptor_Surface_VResolution_1"]=Module["asm"]["iG"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_GetType_0=Module["_emscripten_bind_BRepAdaptor_Surface_GetType_0"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_GetType_0=Module["_emscripten_bind_BRepAdaptor_Surface_GetType_0"]=Module["asm"]["jG"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_Plane_0=Module["_emscripten_bind_BRepAdaptor_Surface_Plane_0"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_Plane_0=Module["_emscripten_bind_BRepAdaptor_Surface_Plane_0"]=Module["asm"]["kG"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_UDegree_0=Module["_emscripten_bind_BRepAdaptor_Surface_UDegree_0"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_UDegree_0=Module["_emscripten_bind_BRepAdaptor_Surface_UDegree_0"]=Module["asm"]["lG"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_NbUPoles_0=Module["_emscripten_bind_BRepAdaptor_Surface_NbUPoles_0"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_NbUPoles_0=Module["_emscripten_bind_BRepAdaptor_Surface_NbUPoles_0"]=Module["asm"]["mG"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_VDegree_0=Module["_emscripten_bind_BRepAdaptor_Surface_VDegree_0"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_VDegree_0=Module["_emscripten_bind_BRepAdaptor_Surface_VDegree_0"]=Module["asm"]["nG"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_NbVPoles_0=Module["_emscripten_bind_BRepAdaptor_Surface_NbVPoles_0"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_NbVPoles_0=Module["_emscripten_bind_BRepAdaptor_Surface_NbVPoles_0"]=Module["asm"]["oG"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_NbUKnots_0=Module["_emscripten_bind_BRepAdaptor_Surface_NbUKnots_0"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_NbUKnots_0=Module["_emscripten_bind_BRepAdaptor_Surface_NbUKnots_0"]=Module["asm"]["pG"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_NbVKnots_0=Module["_emscripten_bind_BRepAdaptor_Surface_NbVKnots_0"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_NbVKnots_0=Module["_emscripten_bind_BRepAdaptor_Surface_NbVKnots_0"]=Module["asm"]["qG"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_IsURational_0=Module["_emscripten_bind_BRepAdaptor_Surface_IsURational_0"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_IsURational_0=Module["_emscripten_bind_BRepAdaptor_Surface_IsURational_0"]=Module["asm"]["rG"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_IsVRational_0=Module["_emscripten_bind_BRepAdaptor_Surface_IsVRational_0"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_IsVRational_0=Module["_emscripten_bind_BRepAdaptor_Surface_IsVRational_0"]=Module["asm"]["sG"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_AxeOfRevolution_0=Module["_emscripten_bind_BRepAdaptor_Surface_AxeOfRevolution_0"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_AxeOfRevolution_0=Module["_emscripten_bind_BRepAdaptor_Surface_AxeOfRevolution_0"]=Module["asm"]["tG"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_Direction_0=Module["_emscripten_bind_BRepAdaptor_Surface_Direction_0"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_Direction_0=Module["_emscripten_bind_BRepAdaptor_Surface_Direction_0"]=Module["asm"]["uG"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface_OffsetValue_0=Module["_emscripten_bind_BRepAdaptor_Surface_OffsetValue_0"]=function(){return(_emscripten_bind_BRepAdaptor_Surface_OffsetValue_0=Module["_emscripten_bind_BRepAdaptor_Surface_OffsetValue_0"]=Module["asm"]["vG"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Surface___destroy___0=Module["_emscripten_bind_BRepAdaptor_Surface___destroy___0"]=function(){return(_emscripten_bind_BRepAdaptor_Surface___destroy___0=Module["_emscripten_bind_BRepAdaptor_Surface___destroy___0"]=Module["asm"]["wG"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeWedge_BRepPrimAPI_MakeWedge_4=Module["_emscripten_bind_BRepPrimAPI_MakeWedge_BRepPrimAPI_MakeWedge_4"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeWedge_BRepPrimAPI_MakeWedge_4=Module["_emscripten_bind_BRepPrimAPI_MakeWedge_BRepPrimAPI_MakeWedge_4"]=Module["asm"]["xG"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeWedge_BRepPrimAPI_MakeWedge_5=Module["_emscripten_bind_BRepPrimAPI_MakeWedge_BRepPrimAPI_MakeWedge_5"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeWedge_BRepPrimAPI_MakeWedge_5=Module["_emscripten_bind_BRepPrimAPI_MakeWedge_BRepPrimAPI_MakeWedge_5"]=Module["asm"]["yG"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeWedge_BRepPrimAPI_MakeWedge_7=Module["_emscripten_bind_BRepPrimAPI_MakeWedge_BRepPrimAPI_MakeWedge_7"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeWedge_BRepPrimAPI_MakeWedge_7=Module["_emscripten_bind_BRepPrimAPI_MakeWedge_BRepPrimAPI_MakeWedge_7"]=Module["asm"]["zG"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeWedge_BRepPrimAPI_MakeWedge_8=Module["_emscripten_bind_BRepPrimAPI_MakeWedge_BRepPrimAPI_MakeWedge_8"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeWedge_BRepPrimAPI_MakeWedge_8=Module["_emscripten_bind_BRepPrimAPI_MakeWedge_BRepPrimAPI_MakeWedge_8"]=Module["asm"]["AG"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeWedge_Build_0=Module["_emscripten_bind_BRepPrimAPI_MakeWedge_Build_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeWedge_Build_0=Module["_emscripten_bind_BRepPrimAPI_MakeWedge_Build_0"]=Module["asm"]["BG"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeWedge_Shell_0=Module["_emscripten_bind_BRepPrimAPI_MakeWedge_Shell_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeWedge_Shell_0=Module["_emscripten_bind_BRepPrimAPI_MakeWedge_Shell_0"]=Module["asm"]["CG"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeWedge_Solid_0=Module["_emscripten_bind_BRepPrimAPI_MakeWedge_Solid_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeWedge_Solid_0=Module["_emscripten_bind_BRepPrimAPI_MakeWedge_Solid_0"]=Module["asm"]["DG"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeWedge_Shape_0=Module["_emscripten_bind_BRepPrimAPI_MakeWedge_Shape_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeWedge_Shape_0=Module["_emscripten_bind_BRepPrimAPI_MakeWedge_Shape_0"]=Module["asm"]["EG"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeWedge___destroy___0=Module["_emscripten_bind_BRepPrimAPI_MakeWedge___destroy___0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeWedge___destroy___0=Module["_emscripten_bind_BRepPrimAPI_MakeWedge___destroy___0"]=Module["asm"]["FG"]).apply(null,arguments)};var _emscripten_bind_Geom_BezierCurve_Geom_BezierCurve_1=Module["_emscripten_bind_Geom_BezierCurve_Geom_BezierCurve_1"]=function(){return(_emscripten_bind_Geom_BezierCurve_Geom_BezierCurve_1=Module["_emscripten_bind_Geom_BezierCurve_Geom_BezierCurve_1"]=Module["asm"]["GG"]).apply(null,arguments)};var _emscripten_bind_Geom_BezierCurve_Geom_BezierCurve_2=Module["_emscripten_bind_Geom_BezierCurve_Geom_BezierCurve_2"]=function(){return(_emscripten_bind_Geom_BezierCurve_Geom_BezierCurve_2=Module["_emscripten_bind_Geom_BezierCurve_Geom_BezierCurve_2"]=Module["asm"]["HG"]).apply(null,arguments)};var _emscripten_bind_Geom_BezierCurve_Reverse_0=Module["_emscripten_bind_Geom_BezierCurve_Reverse_0"]=function(){return(_emscripten_bind_Geom_BezierCurve_Reverse_0=Module["_emscripten_bind_Geom_BezierCurve_Reverse_0"]=Module["asm"]["IG"]).apply(null,arguments)};var _emscripten_bind_Geom_BezierCurve_ReversedParameter_1=Module["_emscripten_bind_Geom_BezierCurve_ReversedParameter_1"]=function(){return(_emscripten_bind_Geom_BezierCurve_ReversedParameter_1=Module["_emscripten_bind_Geom_BezierCurve_ReversedParameter_1"]=Module["asm"]["JG"]).apply(null,arguments)};var _emscripten_bind_Geom_BezierCurve_IsCN_1=Module["_emscripten_bind_Geom_BezierCurve_IsCN_1"]=function(){return(_emscripten_bind_Geom_BezierCurve_IsCN_1=Module["_emscripten_bind_Geom_BezierCurve_IsCN_1"]=Module["asm"]["KG"]).apply(null,arguments)};var _emscripten_bind_Geom_BezierCurve_FirstParameter_0=Module["_emscripten_bind_Geom_BezierCurve_FirstParameter_0"]=function(){return(_emscripten_bind_Geom_BezierCurve_FirstParameter_0=Module["_emscripten_bind_Geom_BezierCurve_FirstParameter_0"]=Module["asm"]["LG"]).apply(null,arguments)};var _emscripten_bind_Geom_BezierCurve_IsClosed_0=Module["_emscripten_bind_Geom_BezierCurve_IsClosed_0"]=function(){return(_emscripten_bind_Geom_BezierCurve_IsClosed_0=Module["_emscripten_bind_Geom_BezierCurve_IsClosed_0"]=Module["asm"]["MG"]).apply(null,arguments)};var _emscripten_bind_Geom_BezierCurve_IsPeriodic_0=Module["_emscripten_bind_Geom_BezierCurve_IsPeriodic_0"]=function(){return(_emscripten_bind_Geom_BezierCurve_IsPeriodic_0=Module["_emscripten_bind_Geom_BezierCurve_IsPeriodic_0"]=Module["asm"]["NG"]).apply(null,arguments)};var _emscripten_bind_Geom_BezierCurve_Period_0=Module["_emscripten_bind_Geom_BezierCurve_Period_0"]=function(){return(_emscripten_bind_Geom_BezierCurve_Period_0=Module["_emscripten_bind_Geom_BezierCurve_Period_0"]=Module["asm"]["OG"]).apply(null,arguments)};var _emscripten_bind_Geom_BezierCurve_LastParameter_0=Module["_emscripten_bind_Geom_BezierCurve_LastParameter_0"]=function(){return(_emscripten_bind_Geom_BezierCurve_LastParameter_0=Module["_emscripten_bind_Geom_BezierCurve_LastParameter_0"]=Module["asm"]["PG"]).apply(null,arguments)};var _emscripten_bind_Geom_BezierCurve_StartPoint_0=Module["_emscripten_bind_Geom_BezierCurve_StartPoint_0"]=function(){return(_emscripten_bind_Geom_BezierCurve_StartPoint_0=Module["_emscripten_bind_Geom_BezierCurve_StartPoint_0"]=Module["asm"]["QG"]).apply(null,arguments)};var _emscripten_bind_Geom_BezierCurve_D0_2=Module["_emscripten_bind_Geom_BezierCurve_D0_2"]=function(){return(_emscripten_bind_Geom_BezierCurve_D0_2=Module["_emscripten_bind_Geom_BezierCurve_D0_2"]=Module["asm"]["RG"]).apply(null,arguments)};var _emscripten_bind_Geom_BezierCurve_D1_3=Module["_emscripten_bind_Geom_BezierCurve_D1_3"]=function(){return(_emscripten_bind_Geom_BezierCurve_D1_3=Module["_emscripten_bind_Geom_BezierCurve_D1_3"]=Module["asm"]["SG"]).apply(null,arguments)};var _emscripten_bind_Geom_BezierCurve_D2_4=Module["_emscripten_bind_Geom_BezierCurve_D2_4"]=function(){return(_emscripten_bind_Geom_BezierCurve_D2_4=Module["_emscripten_bind_Geom_BezierCurve_D2_4"]=Module["asm"]["TG"]).apply(null,arguments)};var _emscripten_bind_Geom_BezierCurve_D3_5=Module["_emscripten_bind_Geom_BezierCurve_D3_5"]=function(){return(_emscripten_bind_Geom_BezierCurve_D3_5=Module["_emscripten_bind_Geom_BezierCurve_D3_5"]=Module["asm"]["UG"]).apply(null,arguments)};var _emscripten_bind_Geom_BezierCurve_DN_2=Module["_emscripten_bind_Geom_BezierCurve_DN_2"]=function(){return(_emscripten_bind_Geom_BezierCurve_DN_2=Module["_emscripten_bind_Geom_BezierCurve_DN_2"]=Module["asm"]["VG"]).apply(null,arguments)};var _emscripten_bind_Geom_BezierCurve_Transform_1=Module["_emscripten_bind_Geom_BezierCurve_Transform_1"]=function(){return(_emscripten_bind_Geom_BezierCurve_Transform_1=Module["_emscripten_bind_Geom_BezierCurve_Transform_1"]=Module["asm"]["WG"]).apply(null,arguments)};var _emscripten_bind_Geom_BezierCurve_Reversed_0=Module["_emscripten_bind_Geom_BezierCurve_Reversed_0"]=function(){return(_emscripten_bind_Geom_BezierCurve_Reversed_0=Module["_emscripten_bind_Geom_BezierCurve_Reversed_0"]=Module["asm"]["XG"]).apply(null,arguments)};var _emscripten_bind_Geom_BezierCurve_Value_1=Module["_emscripten_bind_Geom_BezierCurve_Value_1"]=function(){return(_emscripten_bind_Geom_BezierCurve_Value_1=Module["_emscripten_bind_Geom_BezierCurve_Value_1"]=Module["asm"]["YG"]).apply(null,arguments)};var _emscripten_bind_Geom_BezierCurve___destroy___0=Module["_emscripten_bind_Geom_BezierCurve___destroy___0"]=function(){return(_emscripten_bind_Geom_BezierCurve___destroy___0=Module["_emscripten_bind_Geom_BezierCurve___destroy___0"]=Module["asm"]["ZG"]).apply(null,arguments)};var _emscripten_bind_GCE2d_MakeSegment_GCE2d_MakeSegment_2=Module["_emscripten_bind_GCE2d_MakeSegment_GCE2d_MakeSegment_2"]=function(){return(_emscripten_bind_GCE2d_MakeSegment_GCE2d_MakeSegment_2=Module["_emscripten_bind_GCE2d_MakeSegment_GCE2d_MakeSegment_2"]=Module["asm"]["_G"]).apply(null,arguments)};var _emscripten_bind_GCE2d_MakeSegment_Value_0=Module["_emscripten_bind_GCE2d_MakeSegment_Value_0"]=function(){return(_emscripten_bind_GCE2d_MakeSegment_Value_0=Module["_emscripten_bind_GCE2d_MakeSegment_Value_0"]=Module["asm"]["$G"]).apply(null,arguments)};var _emscripten_bind_GCE2d_MakeSegment___destroy___0=Module["_emscripten_bind_GCE2d_MakeSegment___destroy___0"]=function(){return(_emscripten_bind_GCE2d_MakeSegment___destroy___0=Module["_emscripten_bind_GCE2d_MakeSegment___destroy___0"]=Module["asm"]["aH"]).apply(null,arguments)};var _emscripten_bind_Geom_Ellipse_Geom_Ellipse_1=Module["_emscripten_bind_Geom_Ellipse_Geom_Ellipse_1"]=function(){return(_emscripten_bind_Geom_Ellipse_Geom_Ellipse_1=Module["_emscripten_bind_Geom_Ellipse_Geom_Ellipse_1"]=Module["asm"]["bH"]).apply(null,arguments)};var _emscripten_bind_Geom_Ellipse_Geom_Ellipse_3=Module["_emscripten_bind_Geom_Ellipse_Geom_Ellipse_3"]=function(){return(_emscripten_bind_Geom_Ellipse_Geom_Ellipse_3=Module["_emscripten_bind_Geom_Ellipse_Geom_Ellipse_3"]=Module["asm"]["cH"]).apply(null,arguments)};var _emscripten_bind_Geom_Ellipse_MajorRadius_0=Module["_emscripten_bind_Geom_Ellipse_MajorRadius_0"]=function(){return(_emscripten_bind_Geom_Ellipse_MajorRadius_0=Module["_emscripten_bind_Geom_Ellipse_MajorRadius_0"]=Module["asm"]["dH"]).apply(null,arguments)};var _emscripten_bind_Geom_Ellipse_MinorRadius_0=Module["_emscripten_bind_Geom_Ellipse_MinorRadius_0"]=function(){return(_emscripten_bind_Geom_Ellipse_MinorRadius_0=Module["_emscripten_bind_Geom_Ellipse_MinorRadius_0"]=Module["asm"]["eH"]).apply(null,arguments)};var _emscripten_bind_Geom_Ellipse_Reverse_0=Module["_emscripten_bind_Geom_Ellipse_Reverse_0"]=function(){return(_emscripten_bind_Geom_Ellipse_Reverse_0=Module["_emscripten_bind_Geom_Ellipse_Reverse_0"]=Module["asm"]["fH"]).apply(null,arguments)};var _emscripten_bind_Geom_Ellipse_ReversedParameter_1=Module["_emscripten_bind_Geom_Ellipse_ReversedParameter_1"]=function(){return(_emscripten_bind_Geom_Ellipse_ReversedParameter_1=Module["_emscripten_bind_Geom_Ellipse_ReversedParameter_1"]=Module["asm"]["gH"]).apply(null,arguments)};var _emscripten_bind_Geom_Ellipse_TransformedParameter_2=Module["_emscripten_bind_Geom_Ellipse_TransformedParameter_2"]=function(){return(_emscripten_bind_Geom_Ellipse_TransformedParameter_2=Module["_emscripten_bind_Geom_Ellipse_TransformedParameter_2"]=Module["asm"]["hH"]).apply(null,arguments)};var _emscripten_bind_Geom_Ellipse_ParametricTransformation_1=Module["_emscripten_bind_Geom_Ellipse_ParametricTransformation_1"]=function(){return(_emscripten_bind_Geom_Ellipse_ParametricTransformation_1=Module["_emscripten_bind_Geom_Ellipse_ParametricTransformation_1"]=Module["asm"]["iH"]).apply(null,arguments)};var _emscripten_bind_Geom_Ellipse_Reversed_0=Module["_emscripten_bind_Geom_Ellipse_Reversed_0"]=function(){return(_emscripten_bind_Geom_Ellipse_Reversed_0=Module["_emscripten_bind_Geom_Ellipse_Reversed_0"]=Module["asm"]["jH"]).apply(null,arguments)};var _emscripten_bind_Geom_Ellipse_FirstParameter_0=Module["_emscripten_bind_Geom_Ellipse_FirstParameter_0"]=function(){return(_emscripten_bind_Geom_Ellipse_FirstParameter_0=Module["_emscripten_bind_Geom_Ellipse_FirstParameter_0"]=Module["asm"]["kH"]).apply(null,arguments)};var _emscripten_bind_Geom_Ellipse_LastParameter_0=Module["_emscripten_bind_Geom_Ellipse_LastParameter_0"]=function(){return(_emscripten_bind_Geom_Ellipse_LastParameter_0=Module["_emscripten_bind_Geom_Ellipse_LastParameter_0"]=Module["asm"]["lH"]).apply(null,arguments)};var _emscripten_bind_Geom_Ellipse_IsClosed_0=Module["_emscripten_bind_Geom_Ellipse_IsClosed_0"]=function(){return(_emscripten_bind_Geom_Ellipse_IsClosed_0=Module["_emscripten_bind_Geom_Ellipse_IsClosed_0"]=Module["asm"]["mH"]).apply(null,arguments)};var _emscripten_bind_Geom_Ellipse_IsPeriodic_0=Module["_emscripten_bind_Geom_Ellipse_IsPeriodic_0"]=function(){return(_emscripten_bind_Geom_Ellipse_IsPeriodic_0=Module["_emscripten_bind_Geom_Ellipse_IsPeriodic_0"]=Module["asm"]["nH"]).apply(null,arguments)};var _emscripten_bind_Geom_Ellipse_Period_0=Module["_emscripten_bind_Geom_Ellipse_Period_0"]=function(){return(_emscripten_bind_Geom_Ellipse_Period_0=Module["_emscripten_bind_Geom_Ellipse_Period_0"]=Module["asm"]["oH"]).apply(null,arguments)};var _emscripten_bind_Geom_Ellipse_IsCN_1=Module["_emscripten_bind_Geom_Ellipse_IsCN_1"]=function(){return(_emscripten_bind_Geom_Ellipse_IsCN_1=Module["_emscripten_bind_Geom_Ellipse_IsCN_1"]=Module["asm"]["pH"]).apply(null,arguments)};var _emscripten_bind_Geom_Ellipse_D0_2=Module["_emscripten_bind_Geom_Ellipse_D0_2"]=function(){return(_emscripten_bind_Geom_Ellipse_D0_2=Module["_emscripten_bind_Geom_Ellipse_D0_2"]=Module["asm"]["qH"]).apply(null,arguments)};var _emscripten_bind_Geom_Ellipse_D1_3=Module["_emscripten_bind_Geom_Ellipse_D1_3"]=function(){return(_emscripten_bind_Geom_Ellipse_D1_3=Module["_emscripten_bind_Geom_Ellipse_D1_3"]=Module["asm"]["rH"]).apply(null,arguments)};var _emscripten_bind_Geom_Ellipse_D2_4=Module["_emscripten_bind_Geom_Ellipse_D2_4"]=function(){return(_emscripten_bind_Geom_Ellipse_D2_4=Module["_emscripten_bind_Geom_Ellipse_D2_4"]=Module["asm"]["sH"]).apply(null,arguments)};var _emscripten_bind_Geom_Ellipse_D3_5=Module["_emscripten_bind_Geom_Ellipse_D3_5"]=function(){return(_emscripten_bind_Geom_Ellipse_D3_5=Module["_emscripten_bind_Geom_Ellipse_D3_5"]=Module["asm"]["tH"]).apply(null,arguments)};var _emscripten_bind_Geom_Ellipse_DN_2=Module["_emscripten_bind_Geom_Ellipse_DN_2"]=function(){return(_emscripten_bind_Geom_Ellipse_DN_2=Module["_emscripten_bind_Geom_Ellipse_DN_2"]=Module["asm"]["uH"]).apply(null,arguments)};var _emscripten_bind_Geom_Ellipse_Value_1=Module["_emscripten_bind_Geom_Ellipse_Value_1"]=function(){return(_emscripten_bind_Geom_Ellipse_Value_1=Module["_emscripten_bind_Geom_Ellipse_Value_1"]=Module["asm"]["vH"]).apply(null,arguments)};var _emscripten_bind_Geom_Ellipse___destroy___0=Module["_emscripten_bind_Geom_Ellipse___destroy___0"]=function(){return(_emscripten_bind_Geom_Ellipse___destroy___0=Module["_emscripten_bind_Geom_Ellipse___destroy___0"]=Module["asm"]["wH"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_TopoDS_Compound_0=Module["_emscripten_bind_TopoDS_Compound_TopoDS_Compound_0"]=function(){return(_emscripten_bind_TopoDS_Compound_TopoDS_Compound_0=Module["_emscripten_bind_TopoDS_Compound_TopoDS_Compound_0"]=Module["asm"]["xH"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_TopoDS_Compound_1=Module["_emscripten_bind_TopoDS_Compound_TopoDS_Compound_1"]=function(){return(_emscripten_bind_TopoDS_Compound_TopoDS_Compound_1=Module["_emscripten_bind_TopoDS_Compound_TopoDS_Compound_1"]=Module["asm"]["yH"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_IsNull_0=Module["_emscripten_bind_TopoDS_Compound_IsNull_0"]=function(){return(_emscripten_bind_TopoDS_Compound_IsNull_0=Module["_emscripten_bind_TopoDS_Compound_IsNull_0"]=Module["asm"]["zH"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_Nullify_0=Module["_emscripten_bind_TopoDS_Compound_Nullify_0"]=function(){return(_emscripten_bind_TopoDS_Compound_Nullify_0=Module["_emscripten_bind_TopoDS_Compound_Nullify_0"]=Module["asm"]["AH"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_Location_0=Module["_emscripten_bind_TopoDS_Compound_Location_0"]=function(){return(_emscripten_bind_TopoDS_Compound_Location_0=Module["_emscripten_bind_TopoDS_Compound_Location_0"]=Module["asm"]["BH"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_Located_1=Module["_emscripten_bind_TopoDS_Compound_Located_1"]=function(){return(_emscripten_bind_TopoDS_Compound_Located_1=Module["_emscripten_bind_TopoDS_Compound_Located_1"]=Module["asm"]["CH"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_Orientation_0=Module["_emscripten_bind_TopoDS_Compound_Orientation_0"]=function(){return(_emscripten_bind_TopoDS_Compound_Orientation_0=Module["_emscripten_bind_TopoDS_Compound_Orientation_0"]=Module["asm"]["DH"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_Oriented_1=Module["_emscripten_bind_TopoDS_Compound_Oriented_1"]=function(){return(_emscripten_bind_TopoDS_Compound_Oriented_1=Module["_emscripten_bind_TopoDS_Compound_Oriented_1"]=Module["asm"]["EH"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_ShapeType_0=Module["_emscripten_bind_TopoDS_Compound_ShapeType_0"]=function(){return(_emscripten_bind_TopoDS_Compound_ShapeType_0=Module["_emscripten_bind_TopoDS_Compound_ShapeType_0"]=Module["asm"]["FH"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_Free_0=Module["_emscripten_bind_TopoDS_Compound_Free_0"]=function(){return(_emscripten_bind_TopoDS_Compound_Free_0=Module["_emscripten_bind_TopoDS_Compound_Free_0"]=Module["asm"]["GH"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_Locked_0=Module["_emscripten_bind_TopoDS_Compound_Locked_0"]=function(){return(_emscripten_bind_TopoDS_Compound_Locked_0=Module["_emscripten_bind_TopoDS_Compound_Locked_0"]=Module["asm"]["HH"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_Modified_0=Module["_emscripten_bind_TopoDS_Compound_Modified_0"]=function(){return(_emscripten_bind_TopoDS_Compound_Modified_0=Module["_emscripten_bind_TopoDS_Compound_Modified_0"]=Module["asm"]["IH"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_Checked_0=Module["_emscripten_bind_TopoDS_Compound_Checked_0"]=function(){return(_emscripten_bind_TopoDS_Compound_Checked_0=Module["_emscripten_bind_TopoDS_Compound_Checked_0"]=Module["asm"]["JH"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_Orientable_0=Module["_emscripten_bind_TopoDS_Compound_Orientable_0"]=function(){return(_emscripten_bind_TopoDS_Compound_Orientable_0=Module["_emscripten_bind_TopoDS_Compound_Orientable_0"]=Module["asm"]["KH"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_Closed_0=Module["_emscripten_bind_TopoDS_Compound_Closed_0"]=function(){return(_emscripten_bind_TopoDS_Compound_Closed_0=Module["_emscripten_bind_TopoDS_Compound_Closed_0"]=Module["asm"]["LH"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_Infinite_0=Module["_emscripten_bind_TopoDS_Compound_Infinite_0"]=function(){return(_emscripten_bind_TopoDS_Compound_Infinite_0=Module["_emscripten_bind_TopoDS_Compound_Infinite_0"]=Module["asm"]["MH"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_Convex_0=Module["_emscripten_bind_TopoDS_Compound_Convex_0"]=function(){return(_emscripten_bind_TopoDS_Compound_Convex_0=Module["_emscripten_bind_TopoDS_Compound_Convex_0"]=Module["asm"]["NH"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_Move_1=Module["_emscripten_bind_TopoDS_Compound_Move_1"]=function(){return(_emscripten_bind_TopoDS_Compound_Move_1=Module["_emscripten_bind_TopoDS_Compound_Move_1"]=Module["asm"]["OH"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_Moved_1=Module["_emscripten_bind_TopoDS_Compound_Moved_1"]=function(){return(_emscripten_bind_TopoDS_Compound_Moved_1=Module["_emscripten_bind_TopoDS_Compound_Moved_1"]=Module["asm"]["PH"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_Reverse_0=Module["_emscripten_bind_TopoDS_Compound_Reverse_0"]=function(){return(_emscripten_bind_TopoDS_Compound_Reverse_0=Module["_emscripten_bind_TopoDS_Compound_Reverse_0"]=Module["asm"]["QH"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_Reversed_0=Module["_emscripten_bind_TopoDS_Compound_Reversed_0"]=function(){return(_emscripten_bind_TopoDS_Compound_Reversed_0=Module["_emscripten_bind_TopoDS_Compound_Reversed_0"]=Module["asm"]["RH"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_Complement_0=Module["_emscripten_bind_TopoDS_Compound_Complement_0"]=function(){return(_emscripten_bind_TopoDS_Compound_Complement_0=Module["_emscripten_bind_TopoDS_Compound_Complement_0"]=Module["asm"]["SH"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_Complemented_0=Module["_emscripten_bind_TopoDS_Compound_Complemented_0"]=function(){return(_emscripten_bind_TopoDS_Compound_Complemented_0=Module["_emscripten_bind_TopoDS_Compound_Complemented_0"]=Module["asm"]["TH"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_Compose_1=Module["_emscripten_bind_TopoDS_Compound_Compose_1"]=function(){return(_emscripten_bind_TopoDS_Compound_Compose_1=Module["_emscripten_bind_TopoDS_Compound_Compose_1"]=Module["asm"]["UH"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_Composed_1=Module["_emscripten_bind_TopoDS_Compound_Composed_1"]=function(){return(_emscripten_bind_TopoDS_Compound_Composed_1=Module["_emscripten_bind_TopoDS_Compound_Composed_1"]=Module["asm"]["VH"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_NbChildren_0=Module["_emscripten_bind_TopoDS_Compound_NbChildren_0"]=function(){return(_emscripten_bind_TopoDS_Compound_NbChildren_0=Module["_emscripten_bind_TopoDS_Compound_NbChildren_0"]=Module["asm"]["WH"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_IsPartner_1=Module["_emscripten_bind_TopoDS_Compound_IsPartner_1"]=function(){return(_emscripten_bind_TopoDS_Compound_IsPartner_1=Module["_emscripten_bind_TopoDS_Compound_IsPartner_1"]=Module["asm"]["XH"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_IsSame_1=Module["_emscripten_bind_TopoDS_Compound_IsSame_1"]=function(){return(_emscripten_bind_TopoDS_Compound_IsSame_1=Module["_emscripten_bind_TopoDS_Compound_IsSame_1"]=Module["asm"]["YH"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_IsEqual_1=Module["_emscripten_bind_TopoDS_Compound_IsEqual_1"]=function(){return(_emscripten_bind_TopoDS_Compound_IsEqual_1=Module["_emscripten_bind_TopoDS_Compound_IsEqual_1"]=Module["asm"]["ZH"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_IsNotEqual_1=Module["_emscripten_bind_TopoDS_Compound_IsNotEqual_1"]=function(){return(_emscripten_bind_TopoDS_Compound_IsNotEqual_1=Module["_emscripten_bind_TopoDS_Compound_IsNotEqual_1"]=Module["asm"]["_H"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_HashCode_1=Module["_emscripten_bind_TopoDS_Compound_HashCode_1"]=function(){return(_emscripten_bind_TopoDS_Compound_HashCode_1=Module["_emscripten_bind_TopoDS_Compound_HashCode_1"]=Module["asm"]["$H"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_EmptyCopy_0=Module["_emscripten_bind_TopoDS_Compound_EmptyCopy_0"]=function(){return(_emscripten_bind_TopoDS_Compound_EmptyCopy_0=Module["_emscripten_bind_TopoDS_Compound_EmptyCopy_0"]=Module["asm"]["aI"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound_EmptyCopied_0=Module["_emscripten_bind_TopoDS_Compound_EmptyCopied_0"]=function(){return(_emscripten_bind_TopoDS_Compound_EmptyCopied_0=Module["_emscripten_bind_TopoDS_Compound_EmptyCopied_0"]=Module["asm"]["bI"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Compound___destroy___0=Module["_emscripten_bind_TopoDS_Compound___destroy___0"]=function(){return(_emscripten_bind_TopoDS_Compound___destroy___0=Module["_emscripten_bind_TopoDS_Compound___destroy___0"]=Module["asm"]["cI"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_ThruSections_BRepOffsetAPI_ThruSections_0=Module["_emscripten_bind_BRepOffsetAPI_ThruSections_BRepOffsetAPI_ThruSections_0"]=function(){return(_emscripten_bind_BRepOffsetAPI_ThruSections_BRepOffsetAPI_ThruSections_0=Module["_emscripten_bind_BRepOffsetAPI_ThruSections_BRepOffsetAPI_ThruSections_0"]=Module["asm"]["dI"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_ThruSections_BRepOffsetAPI_ThruSections_1=Module["_emscripten_bind_BRepOffsetAPI_ThruSections_BRepOffsetAPI_ThruSections_1"]=function(){return(_emscripten_bind_BRepOffsetAPI_ThruSections_BRepOffsetAPI_ThruSections_1=Module["_emscripten_bind_BRepOffsetAPI_ThruSections_BRepOffsetAPI_ThruSections_1"]=Module["asm"]["eI"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_ThruSections_BRepOffsetAPI_ThruSections_2=Module["_emscripten_bind_BRepOffsetAPI_ThruSections_BRepOffsetAPI_ThruSections_2"]=function(){return(_emscripten_bind_BRepOffsetAPI_ThruSections_BRepOffsetAPI_ThruSections_2=Module["_emscripten_bind_BRepOffsetAPI_ThruSections_BRepOffsetAPI_ThruSections_2"]=Module["asm"]["fI"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_ThruSections_BRepOffsetAPI_ThruSections_3=Module["_emscripten_bind_BRepOffsetAPI_ThruSections_BRepOffsetAPI_ThruSections_3"]=function(){return(_emscripten_bind_BRepOffsetAPI_ThruSections_BRepOffsetAPI_ThruSections_3=Module["_emscripten_bind_BRepOffsetAPI_ThruSections_BRepOffsetAPI_ThruSections_3"]=Module["asm"]["gI"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_ThruSections_AddWire_1=Module["_emscripten_bind_BRepOffsetAPI_ThruSections_AddWire_1"]=function(){return(_emscripten_bind_BRepOffsetAPI_ThruSections_AddWire_1=Module["_emscripten_bind_BRepOffsetAPI_ThruSections_AddWire_1"]=Module["asm"]["hI"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_ThruSections_CheckCompatibility_0=Module["_emscripten_bind_BRepOffsetAPI_ThruSections_CheckCompatibility_0"]=function(){return(_emscripten_bind_BRepOffsetAPI_ThruSections_CheckCompatibility_0=Module["_emscripten_bind_BRepOffsetAPI_ThruSections_CheckCompatibility_0"]=Module["asm"]["iI"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_ThruSections_CheckCompatibility_1=Module["_emscripten_bind_BRepOffsetAPI_ThruSections_CheckCompatibility_1"]=function(){return(_emscripten_bind_BRepOffsetAPI_ThruSections_CheckCompatibility_1=Module["_emscripten_bind_BRepOffsetAPI_ThruSections_CheckCompatibility_1"]=Module["asm"]["jI"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_ThruSections_Shape_0=Module["_emscripten_bind_BRepOffsetAPI_ThruSections_Shape_0"]=function(){return(_emscripten_bind_BRepOffsetAPI_ThruSections_Shape_0=Module["_emscripten_bind_BRepOffsetAPI_ThruSections_Shape_0"]=Module["asm"]["kI"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_ThruSections___destroy___0=Module["_emscripten_bind_BRepOffsetAPI_ThruSections___destroy___0"]=function(){return(_emscripten_bind_BRepOffsetAPI_ThruSections___destroy___0=Module["_emscripten_bind_BRepOffsetAPI_ThruSections___destroy___0"]=Module["asm"]["lI"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeCone_BRepPrimAPI_MakeCone_3=Module["_emscripten_bind_BRepPrimAPI_MakeCone_BRepPrimAPI_MakeCone_3"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeCone_BRepPrimAPI_MakeCone_3=Module["_emscripten_bind_BRepPrimAPI_MakeCone_BRepPrimAPI_MakeCone_3"]=Module["asm"]["mI"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeCone_BRepPrimAPI_MakeCone_4=Module["_emscripten_bind_BRepPrimAPI_MakeCone_BRepPrimAPI_MakeCone_4"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeCone_BRepPrimAPI_MakeCone_4=Module["_emscripten_bind_BRepPrimAPI_MakeCone_BRepPrimAPI_MakeCone_4"]=Module["asm"]["nI"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeCone_BRepPrimAPI_MakeCone_5=Module["_emscripten_bind_BRepPrimAPI_MakeCone_BRepPrimAPI_MakeCone_5"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeCone_BRepPrimAPI_MakeCone_5=Module["_emscripten_bind_BRepPrimAPI_MakeCone_BRepPrimAPI_MakeCone_5"]=Module["asm"]["oI"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeCone_Shape_0=Module["_emscripten_bind_BRepPrimAPI_MakeCone_Shape_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeCone_Shape_0=Module["_emscripten_bind_BRepPrimAPI_MakeCone_Shape_0"]=Module["asm"]["pI"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeCone_IsDeleted_1=Module["_emscripten_bind_BRepPrimAPI_MakeCone_IsDeleted_1"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeCone_IsDeleted_1=Module["_emscripten_bind_BRepPrimAPI_MakeCone_IsDeleted_1"]=Module["asm"]["qI"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeCone_Build_0=Module["_emscripten_bind_BRepPrimAPI_MakeCone_Build_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeCone_Build_0=Module["_emscripten_bind_BRepPrimAPI_MakeCone_Build_0"]=Module["asm"]["rI"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeCone_Face_0=Module["_emscripten_bind_BRepPrimAPI_MakeCone_Face_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeCone_Face_0=Module["_emscripten_bind_BRepPrimAPI_MakeCone_Face_0"]=Module["asm"]["sI"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeCone_Shell_0=Module["_emscripten_bind_BRepPrimAPI_MakeCone_Shell_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeCone_Shell_0=Module["_emscripten_bind_BRepPrimAPI_MakeCone_Shell_0"]=Module["asm"]["tI"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeCone_Solid_0=Module["_emscripten_bind_BRepPrimAPI_MakeCone_Solid_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeCone_Solid_0=Module["_emscripten_bind_BRepPrimAPI_MakeCone_Solid_0"]=Module["asm"]["uI"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeCone___destroy___0=Module["_emscripten_bind_BRepPrimAPI_MakeCone___destroy___0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeCone___destroy___0=Module["_emscripten_bind_BRepPrimAPI_MakeCone___destroy___0"]=Module["asm"]["vI"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_BSplineCurve_Handle_Geom_BSplineCurve_0=Module["_emscripten_bind_Handle_Geom_BSplineCurve_Handle_Geom_BSplineCurve_0"]=function(){return(_emscripten_bind_Handle_Geom_BSplineCurve_Handle_Geom_BSplineCurve_0=Module["_emscripten_bind_Handle_Geom_BSplineCurve_Handle_Geom_BSplineCurve_0"]=Module["asm"]["wI"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_BSplineCurve_Handle_Geom_BSplineCurve_1=Module["_emscripten_bind_Handle_Geom_BSplineCurve_Handle_Geom_BSplineCurve_1"]=function(){return(_emscripten_bind_Handle_Geom_BSplineCurve_Handle_Geom_BSplineCurve_1=Module["_emscripten_bind_Handle_Geom_BSplineCurve_Handle_Geom_BSplineCurve_1"]=Module["asm"]["xI"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_BSplineCurve_IsNull_0=Module["_emscripten_bind_Handle_Geom_BSplineCurve_IsNull_0"]=function(){return(_emscripten_bind_Handle_Geom_BSplineCurve_IsNull_0=Module["_emscripten_bind_Handle_Geom_BSplineCurve_IsNull_0"]=Module["asm"]["yI"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_BSplineCurve_Nullify_0=Module["_emscripten_bind_Handle_Geom_BSplineCurve_Nullify_0"]=function(){return(_emscripten_bind_Handle_Geom_BSplineCurve_Nullify_0=Module["_emscripten_bind_Handle_Geom_BSplineCurve_Nullify_0"]=Module["asm"]["zI"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_BSplineCurve_get_0=Module["_emscripten_bind_Handle_Geom_BSplineCurve_get_0"]=function(){return(_emscripten_bind_Handle_Geom_BSplineCurve_get_0=Module["_emscripten_bind_Handle_Geom_BSplineCurve_get_0"]=Module["asm"]["AI"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_BSplineCurve___destroy___0=Module["_emscripten_bind_Handle_Geom_BSplineCurve___destroy___0"]=function(){return(_emscripten_bind_Handle_Geom_BSplineCurve___destroy___0=Module["_emscripten_bind_Handle_Geom_BSplineCurve___destroy___0"]=Module["asm"]["BI"]).apply(null,arguments)};var _emscripten_bind_TColStd_Array1OfInteger_TColStd_Array1OfInteger_0=Module["_emscripten_bind_TColStd_Array1OfInteger_TColStd_Array1OfInteger_0"]=function(){return(_emscripten_bind_TColStd_Array1OfInteger_TColStd_Array1OfInteger_0=Module["_emscripten_bind_TColStd_Array1OfInteger_TColStd_Array1OfInteger_0"]=Module["asm"]["CI"]).apply(null,arguments)};var _emscripten_bind_TColStd_Array1OfInteger_TColStd_Array1OfInteger_2=Module["_emscripten_bind_TColStd_Array1OfInteger_TColStd_Array1OfInteger_2"]=function(){return(_emscripten_bind_TColStd_Array1OfInteger_TColStd_Array1OfInteger_2=Module["_emscripten_bind_TColStd_Array1OfInteger_TColStd_Array1OfInteger_2"]=Module["asm"]["DI"]).apply(null,arguments)};var _emscripten_bind_TColStd_Array1OfInteger_Length_0=Module["_emscripten_bind_TColStd_Array1OfInteger_Length_0"]=function(){return(_emscripten_bind_TColStd_Array1OfInteger_Length_0=Module["_emscripten_bind_TColStd_Array1OfInteger_Length_0"]=Module["asm"]["EI"]).apply(null,arguments)};var _emscripten_bind_TColStd_Array1OfInteger_Lower_0=Module["_emscripten_bind_TColStd_Array1OfInteger_Lower_0"]=function(){return(_emscripten_bind_TColStd_Array1OfInteger_Lower_0=Module["_emscripten_bind_TColStd_Array1OfInteger_Lower_0"]=Module["asm"]["FI"]).apply(null,arguments)};var _emscripten_bind_TColStd_Array1OfInteger_Upper_0=Module["_emscripten_bind_TColStd_Array1OfInteger_Upper_0"]=function(){return(_emscripten_bind_TColStd_Array1OfInteger_Upper_0=Module["_emscripten_bind_TColStd_Array1OfInteger_Upper_0"]=Module["asm"]["GI"]).apply(null,arguments)};var _emscripten_bind_TColStd_Array1OfInteger_Value_1=Module["_emscripten_bind_TColStd_Array1OfInteger_Value_1"]=function(){return(_emscripten_bind_TColStd_Array1OfInteger_Value_1=Module["_emscripten_bind_TColStd_Array1OfInteger_Value_1"]=Module["asm"]["HI"]).apply(null,arguments)};var _emscripten_bind_TColStd_Array1OfInteger_SetValue_2=Module["_emscripten_bind_TColStd_Array1OfInteger_SetValue_2"]=function(){return(_emscripten_bind_TColStd_Array1OfInteger_SetValue_2=Module["_emscripten_bind_TColStd_Array1OfInteger_SetValue_2"]=Module["asm"]["II"]).apply(null,arguments)};var _emscripten_bind_TColStd_Array1OfInteger___destroy___0=Module["_emscripten_bind_TColStd_Array1OfInteger___destroy___0"]=function(){return(_emscripten_bind_TColStd_Array1OfInteger___destroy___0=Module["_emscripten_bind_TColStd_Array1OfInteger___destroy___0"]=Module["asm"]["JI"]).apply(null,arguments)};var _emscripten_bind_gp_Trsf_gp_Trsf_0=Module["_emscripten_bind_gp_Trsf_gp_Trsf_0"]=function(){return(_emscripten_bind_gp_Trsf_gp_Trsf_0=Module["_emscripten_bind_gp_Trsf_gp_Trsf_0"]=Module["asm"]["KI"]).apply(null,arguments)};var _emscripten_bind_gp_Trsf_SetMirror_1=Module["_emscripten_bind_gp_Trsf_SetMirror_1"]=function(){return(_emscripten_bind_gp_Trsf_SetMirror_1=Module["_emscripten_bind_gp_Trsf_SetMirror_1"]=Module["asm"]["LI"]).apply(null,arguments)};var _emscripten_bind_gp_Trsf_SetTranslation_1=Module["_emscripten_bind_gp_Trsf_SetTranslation_1"]=function(){return(_emscripten_bind_gp_Trsf_SetTranslation_1=Module["_emscripten_bind_gp_Trsf_SetTranslation_1"]=Module["asm"]["MI"]).apply(null,arguments)};var _emscripten_bind_gp_Trsf_SetTranslationPart_1=Module["_emscripten_bind_gp_Trsf_SetTranslationPart_1"]=function(){return(_emscripten_bind_gp_Trsf_SetTranslationPart_1=Module["_emscripten_bind_gp_Trsf_SetTranslationPart_1"]=Module["asm"]["NI"]).apply(null,arguments)};var _emscripten_bind_gp_Trsf_SetRotation_2=Module["_emscripten_bind_gp_Trsf_SetRotation_2"]=function(){return(_emscripten_bind_gp_Trsf_SetRotation_2=Module["_emscripten_bind_gp_Trsf_SetRotation_2"]=Module["asm"]["OI"]).apply(null,arguments)};var _emscripten_bind_gp_Trsf_SetScaleFactor_1=Module["_emscripten_bind_gp_Trsf_SetScaleFactor_1"]=function(){return(_emscripten_bind_gp_Trsf_SetScaleFactor_1=Module["_emscripten_bind_gp_Trsf_SetScaleFactor_1"]=Module["asm"]["PI"]).apply(null,arguments)};var _emscripten_bind_gp_Trsf_Multiply_1=Module["_emscripten_bind_gp_Trsf_Multiply_1"]=function(){return(_emscripten_bind_gp_Trsf_Multiply_1=Module["_emscripten_bind_gp_Trsf_Multiply_1"]=Module["asm"]["QI"]).apply(null,arguments)};var _emscripten_bind_gp_Trsf_PreMultiply_1=Module["_emscripten_bind_gp_Trsf_PreMultiply_1"]=function(){return(_emscripten_bind_gp_Trsf_PreMultiply_1=Module["_emscripten_bind_gp_Trsf_PreMultiply_1"]=Module["asm"]["RI"]).apply(null,arguments)};var _emscripten_bind_gp_Trsf_Value_2=Module["_emscripten_bind_gp_Trsf_Value_2"]=function(){return(_emscripten_bind_gp_Trsf_Value_2=Module["_emscripten_bind_gp_Trsf_Value_2"]=Module["asm"]["SI"]).apply(null,arguments)};var _emscripten_bind_gp_Trsf_Inverted_0=Module["_emscripten_bind_gp_Trsf_Inverted_0"]=function(){return(_emscripten_bind_gp_Trsf_Inverted_0=Module["_emscripten_bind_gp_Trsf_Inverted_0"]=Module["asm"]["TI"]).apply(null,arguments)};var _emscripten_bind_gp_Trsf_TranslationPart_0=Module["_emscripten_bind_gp_Trsf_TranslationPart_0"]=function(){return(_emscripten_bind_gp_Trsf_TranslationPart_0=Module["_emscripten_bind_gp_Trsf_TranslationPart_0"]=Module["asm"]["UI"]).apply(null,arguments)};var _emscripten_bind_gp_Trsf_ScaleFactor_0=Module["_emscripten_bind_gp_Trsf_ScaleFactor_0"]=function(){return(_emscripten_bind_gp_Trsf_ScaleFactor_0=Module["_emscripten_bind_gp_Trsf_ScaleFactor_0"]=Module["asm"]["VI"]).apply(null,arguments)};var _emscripten_bind_gp_Trsf_Multiplied_1=Module["_emscripten_bind_gp_Trsf_Multiplied_1"]=function(){return(_emscripten_bind_gp_Trsf_Multiplied_1=Module["_emscripten_bind_gp_Trsf_Multiplied_1"]=Module["asm"]["WI"]).apply(null,arguments)};var _emscripten_bind_gp_Trsf___destroy___0=Module["_emscripten_bind_gp_Trsf___destroy___0"]=function(){return(_emscripten_bind_gp_Trsf___destroy___0=Module["_emscripten_bind_gp_Trsf___destroy___0"]=Module["asm"]["XI"]).apply(null,arguments)};var _emscripten_bind_BRepLib_BuildCurve3d_1=Module["_emscripten_bind_BRepLib_BuildCurve3d_1"]=function(){return(_emscripten_bind_BRepLib_BuildCurve3d_1=Module["_emscripten_bind_BRepLib_BuildCurve3d_1"]=Module["asm"]["YI"]).apply(null,arguments)};var _emscripten_bind_BRepLib_BuildCurve3d_2=Module["_emscripten_bind_BRepLib_BuildCurve3d_2"]=function(){return(_emscripten_bind_BRepLib_BuildCurve3d_2=Module["_emscripten_bind_BRepLib_BuildCurve3d_2"]=Module["asm"]["ZI"]).apply(null,arguments)};var _emscripten_bind_BRepLib_BuildCurve3d_3=Module["_emscripten_bind_BRepLib_BuildCurve3d_3"]=function(){return(_emscripten_bind_BRepLib_BuildCurve3d_3=Module["_emscripten_bind_BRepLib_BuildCurve3d_3"]=Module["asm"]["_I"]).apply(null,arguments)};var _emscripten_bind_BRepLib_BuildCurve3d_4=Module["_emscripten_bind_BRepLib_BuildCurve3d_4"]=function(){return(_emscripten_bind_BRepLib_BuildCurve3d_4=Module["_emscripten_bind_BRepLib_BuildCurve3d_4"]=Module["asm"]["$I"]).apply(null,arguments)};var _emscripten_bind_BRepLib_BuildCurve3d_5=Module["_emscripten_bind_BRepLib_BuildCurve3d_5"]=function(){return(_emscripten_bind_BRepLib_BuildCurve3d_5=Module["_emscripten_bind_BRepLib_BuildCurve3d_5"]=Module["asm"]["aJ"]).apply(null,arguments)};var _emscripten_bind_BRepLib_BuildCurves3d_1=Module["_emscripten_bind_BRepLib_BuildCurves3d_1"]=function(){return(_emscripten_bind_BRepLib_BuildCurves3d_1=Module["_emscripten_bind_BRepLib_BuildCurves3d_1"]=Module["asm"]["bJ"]).apply(null,arguments)};var _emscripten_bind_BRepLib___destroy___0=Module["_emscripten_bind_BRepLib___destroy___0"]=function(){return(_emscripten_bind_BRepLib___destroy___0=Module["_emscripten_bind_BRepLib___destroy___0"]=Module["asm"]["cJ"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Curve_Handle_Geom_Curve_0=Module["_emscripten_bind_Handle_Geom_Curve_Handle_Geom_Curve_0"]=function(){return(_emscripten_bind_Handle_Geom_Curve_Handle_Geom_Curve_0=Module["_emscripten_bind_Handle_Geom_Curve_Handle_Geom_Curve_0"]=Module["asm"]["dJ"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Curve_Handle_Geom_Curve_1=Module["_emscripten_bind_Handle_Geom_Curve_Handle_Geom_Curve_1"]=function(){return(_emscripten_bind_Handle_Geom_Curve_Handle_Geom_Curve_1=Module["_emscripten_bind_Handle_Geom_Curve_Handle_Geom_Curve_1"]=Module["asm"]["eJ"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Curve_IsNull_0=Module["_emscripten_bind_Handle_Geom_Curve_IsNull_0"]=function(){return(_emscripten_bind_Handle_Geom_Curve_IsNull_0=Module["_emscripten_bind_Handle_Geom_Curve_IsNull_0"]=Module["asm"]["fJ"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Curve_Nullify_0=Module["_emscripten_bind_Handle_Geom_Curve_Nullify_0"]=function(){return(_emscripten_bind_Handle_Geom_Curve_Nullify_0=Module["_emscripten_bind_Handle_Geom_Curve_Nullify_0"]=Module["asm"]["gJ"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Curve_get_0=Module["_emscripten_bind_Handle_Geom_Curve_get_0"]=function(){return(_emscripten_bind_Handle_Geom_Curve_get_0=Module["_emscripten_bind_Handle_Geom_Curve_get_0"]=Module["asm"]["hJ"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Curve___destroy___0=Module["_emscripten_bind_Handle_Geom_Curve___destroy___0"]=function(){return(_emscripten_bind_Handle_Geom_Curve___destroy___0=Module["_emscripten_bind_Handle_Geom_Curve___destroy___0"]=Module["asm"]["iJ"]).apply(null,arguments)};var _emscripten_bind_Handle_Poly_Triangulation_Handle_Poly_Triangulation_0=Module["_emscripten_bind_Handle_Poly_Triangulation_Handle_Poly_Triangulation_0"]=function(){return(_emscripten_bind_Handle_Poly_Triangulation_Handle_Poly_Triangulation_0=Module["_emscripten_bind_Handle_Poly_Triangulation_Handle_Poly_Triangulation_0"]=Module["asm"]["jJ"]).apply(null,arguments)};var _emscripten_bind_Handle_Poly_Triangulation_Handle_Poly_Triangulation_1=Module["_emscripten_bind_Handle_Poly_Triangulation_Handle_Poly_Triangulation_1"]=function(){return(_emscripten_bind_Handle_Poly_Triangulation_Handle_Poly_Triangulation_1=Module["_emscripten_bind_Handle_Poly_Triangulation_Handle_Poly_Triangulation_1"]=Module["asm"]["kJ"]).apply(null,arguments)};var _emscripten_bind_Handle_Poly_Triangulation_IsNull_0=Module["_emscripten_bind_Handle_Poly_Triangulation_IsNull_0"]=function(){return(_emscripten_bind_Handle_Poly_Triangulation_IsNull_0=Module["_emscripten_bind_Handle_Poly_Triangulation_IsNull_0"]=Module["asm"]["lJ"]).apply(null,arguments)};var _emscripten_bind_Handle_Poly_Triangulation_Nullify_0=Module["_emscripten_bind_Handle_Poly_Triangulation_Nullify_0"]=function(){return(_emscripten_bind_Handle_Poly_Triangulation_Nullify_0=Module["_emscripten_bind_Handle_Poly_Triangulation_Nullify_0"]=Module["asm"]["mJ"]).apply(null,arguments)};var _emscripten_bind_Handle_Poly_Triangulation_get_0=Module["_emscripten_bind_Handle_Poly_Triangulation_get_0"]=function(){return(_emscripten_bind_Handle_Poly_Triangulation_get_0=Module["_emscripten_bind_Handle_Poly_Triangulation_get_0"]=Module["asm"]["nJ"]).apply(null,arguments)};var _emscripten_bind_Handle_Poly_Triangulation___destroy___0=Module["_emscripten_bind_Handle_Poly_Triangulation___destroy___0"]=function(){return(_emscripten_bind_Handle_Poly_Triangulation___destroy___0=Module["_emscripten_bind_Handle_Poly_Triangulation___destroy___0"]=Module["asm"]["oJ"]).apply(null,arguments)};var _emscripten_bind_GC_MakeArcOfCircle_GC_MakeArcOfCircle_3=Module["_emscripten_bind_GC_MakeArcOfCircle_GC_MakeArcOfCircle_3"]=function(){return(_emscripten_bind_GC_MakeArcOfCircle_GC_MakeArcOfCircle_3=Module["_emscripten_bind_GC_MakeArcOfCircle_GC_MakeArcOfCircle_3"]=Module["asm"]["pJ"]).apply(null,arguments)};var _emscripten_bind_GC_MakeArcOfCircle_GC_MakeArcOfCircle_4=Module["_emscripten_bind_GC_MakeArcOfCircle_GC_MakeArcOfCircle_4"]=function(){return(_emscripten_bind_GC_MakeArcOfCircle_GC_MakeArcOfCircle_4=Module["_emscripten_bind_GC_MakeArcOfCircle_GC_MakeArcOfCircle_4"]=Module["asm"]["qJ"]).apply(null,arguments)};var _emscripten_bind_GC_MakeArcOfCircle_Value_0=Module["_emscripten_bind_GC_MakeArcOfCircle_Value_0"]=function(){return(_emscripten_bind_GC_MakeArcOfCircle_Value_0=Module["_emscripten_bind_GC_MakeArcOfCircle_Value_0"]=Module["asm"]["rJ"]).apply(null,arguments)};var _emscripten_bind_GC_MakeArcOfCircle___destroy___0=Module["_emscripten_bind_GC_MakeArcOfCircle___destroy___0"]=function(){return(_emscripten_bind_GC_MakeArcOfCircle___destroy___0=Module["_emscripten_bind_GC_MakeArcOfCircle___destroy___0"]=Module["asm"]["sJ"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Plane_Handle_Geom_Plane_0=Module["_emscripten_bind_Handle_Geom_Plane_Handle_Geom_Plane_0"]=function(){return(_emscripten_bind_Handle_Geom_Plane_Handle_Geom_Plane_0=Module["_emscripten_bind_Handle_Geom_Plane_Handle_Geom_Plane_0"]=Module["asm"]["tJ"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Plane_Handle_Geom_Plane_1=Module["_emscripten_bind_Handle_Geom_Plane_Handle_Geom_Plane_1"]=function(){return(_emscripten_bind_Handle_Geom_Plane_Handle_Geom_Plane_1=Module["_emscripten_bind_Handle_Geom_Plane_Handle_Geom_Plane_1"]=Module["asm"]["uJ"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Plane_IsNull_0=Module["_emscripten_bind_Handle_Geom_Plane_IsNull_0"]=function(){return(_emscripten_bind_Handle_Geom_Plane_IsNull_0=Module["_emscripten_bind_Handle_Geom_Plane_IsNull_0"]=Module["asm"]["vJ"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Plane_Nullify_0=Module["_emscripten_bind_Handle_Geom_Plane_Nullify_0"]=function(){return(_emscripten_bind_Handle_Geom_Plane_Nullify_0=Module["_emscripten_bind_Handle_Geom_Plane_Nullify_0"]=Module["asm"]["wJ"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Plane_get_0=Module["_emscripten_bind_Handle_Geom_Plane_get_0"]=function(){return(_emscripten_bind_Handle_Geom_Plane_get_0=Module["_emscripten_bind_Handle_Geom_Plane_get_0"]=Module["asm"]["xJ"]).apply(null,arguments)};var _emscripten_bind_Handle_Geom_Plane___destroy___0=Module["_emscripten_bind_Handle_Geom_Plane___destroy___0"]=function(){return(_emscripten_bind_Handle_Geom_Plane___destroy___0=Module["_emscripten_bind_Handle_Geom_Plane___destroy___0"]=Module["asm"]["yJ"]).apply(null,arguments)};var _emscripten_bind_Standard_Type_Name_0=Module["_emscripten_bind_Standard_Type_Name_0"]=function(){return(_emscripten_bind_Standard_Type_Name_0=Module["_emscripten_bind_Standard_Type_Name_0"]=Module["asm"]["zJ"]).apply(null,arguments)};var _emscripten_bind_Standard_Type_get_type_name_0=Module["_emscripten_bind_Standard_Type_get_type_name_0"]=function(){return(_emscripten_bind_Standard_Type_get_type_name_0=Module["_emscripten_bind_Standard_Type_get_type_name_0"]=Module["asm"]["AJ"]).apply(null,arguments)};var _emscripten_bind_Standard_Type_DynamicType_0=Module["_emscripten_bind_Standard_Type_DynamicType_0"]=function(){return(_emscripten_bind_Standard_Type_DynamicType_0=Module["_emscripten_bind_Standard_Type_DynamicType_0"]=Module["asm"]["BJ"]).apply(null,arguments)};var _emscripten_bind_Standard_Type___destroy___0=Module["_emscripten_bind_Standard_Type___destroy___0"]=function(){return(_emscripten_bind_Standard_Type___destroy___0=Module["_emscripten_bind_Standard_Type___destroy___0"]=Module["asm"]["CJ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_TopoDS_Face_0=Module["_emscripten_bind_TopoDS_Face_TopoDS_Face_0"]=function(){return(_emscripten_bind_TopoDS_Face_TopoDS_Face_0=Module["_emscripten_bind_TopoDS_Face_TopoDS_Face_0"]=Module["asm"]["DJ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_TopoDS_Face_1=Module["_emscripten_bind_TopoDS_Face_TopoDS_Face_1"]=function(){return(_emscripten_bind_TopoDS_Face_TopoDS_Face_1=Module["_emscripten_bind_TopoDS_Face_TopoDS_Face_1"]=Module["asm"]["EJ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_IsNull_0=Module["_emscripten_bind_TopoDS_Face_IsNull_0"]=function(){return(_emscripten_bind_TopoDS_Face_IsNull_0=Module["_emscripten_bind_TopoDS_Face_IsNull_0"]=Module["asm"]["FJ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_Nullify_0=Module["_emscripten_bind_TopoDS_Face_Nullify_0"]=function(){return(_emscripten_bind_TopoDS_Face_Nullify_0=Module["_emscripten_bind_TopoDS_Face_Nullify_0"]=Module["asm"]["GJ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_Location_0=Module["_emscripten_bind_TopoDS_Face_Location_0"]=function(){return(_emscripten_bind_TopoDS_Face_Location_0=Module["_emscripten_bind_TopoDS_Face_Location_0"]=Module["asm"]["HJ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_Located_1=Module["_emscripten_bind_TopoDS_Face_Located_1"]=function(){return(_emscripten_bind_TopoDS_Face_Located_1=Module["_emscripten_bind_TopoDS_Face_Located_1"]=Module["asm"]["IJ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_Orientation_0=Module["_emscripten_bind_TopoDS_Face_Orientation_0"]=function(){return(_emscripten_bind_TopoDS_Face_Orientation_0=Module["_emscripten_bind_TopoDS_Face_Orientation_0"]=Module["asm"]["JJ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_Oriented_1=Module["_emscripten_bind_TopoDS_Face_Oriented_1"]=function(){return(_emscripten_bind_TopoDS_Face_Oriented_1=Module["_emscripten_bind_TopoDS_Face_Oriented_1"]=Module["asm"]["KJ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_ShapeType_0=Module["_emscripten_bind_TopoDS_Face_ShapeType_0"]=function(){return(_emscripten_bind_TopoDS_Face_ShapeType_0=Module["_emscripten_bind_TopoDS_Face_ShapeType_0"]=Module["asm"]["LJ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_Free_0=Module["_emscripten_bind_TopoDS_Face_Free_0"]=function(){return(_emscripten_bind_TopoDS_Face_Free_0=Module["_emscripten_bind_TopoDS_Face_Free_0"]=Module["asm"]["MJ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_Locked_0=Module["_emscripten_bind_TopoDS_Face_Locked_0"]=function(){return(_emscripten_bind_TopoDS_Face_Locked_0=Module["_emscripten_bind_TopoDS_Face_Locked_0"]=Module["asm"]["NJ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_Modified_0=Module["_emscripten_bind_TopoDS_Face_Modified_0"]=function(){return(_emscripten_bind_TopoDS_Face_Modified_0=Module["_emscripten_bind_TopoDS_Face_Modified_0"]=Module["asm"]["OJ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_Checked_0=Module["_emscripten_bind_TopoDS_Face_Checked_0"]=function(){return(_emscripten_bind_TopoDS_Face_Checked_0=Module["_emscripten_bind_TopoDS_Face_Checked_0"]=Module["asm"]["PJ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_Orientable_0=Module["_emscripten_bind_TopoDS_Face_Orientable_0"]=function(){return(_emscripten_bind_TopoDS_Face_Orientable_0=Module["_emscripten_bind_TopoDS_Face_Orientable_0"]=Module["asm"]["QJ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_Closed_0=Module["_emscripten_bind_TopoDS_Face_Closed_0"]=function(){return(_emscripten_bind_TopoDS_Face_Closed_0=Module["_emscripten_bind_TopoDS_Face_Closed_0"]=Module["asm"]["RJ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_Infinite_0=Module["_emscripten_bind_TopoDS_Face_Infinite_0"]=function(){return(_emscripten_bind_TopoDS_Face_Infinite_0=Module["_emscripten_bind_TopoDS_Face_Infinite_0"]=Module["asm"]["SJ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_Convex_0=Module["_emscripten_bind_TopoDS_Face_Convex_0"]=function(){return(_emscripten_bind_TopoDS_Face_Convex_0=Module["_emscripten_bind_TopoDS_Face_Convex_0"]=Module["asm"]["TJ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_Move_1=Module["_emscripten_bind_TopoDS_Face_Move_1"]=function(){return(_emscripten_bind_TopoDS_Face_Move_1=Module["_emscripten_bind_TopoDS_Face_Move_1"]=Module["asm"]["UJ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_Moved_1=Module["_emscripten_bind_TopoDS_Face_Moved_1"]=function(){return(_emscripten_bind_TopoDS_Face_Moved_1=Module["_emscripten_bind_TopoDS_Face_Moved_1"]=Module["asm"]["VJ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_Reverse_0=Module["_emscripten_bind_TopoDS_Face_Reverse_0"]=function(){return(_emscripten_bind_TopoDS_Face_Reverse_0=Module["_emscripten_bind_TopoDS_Face_Reverse_0"]=Module["asm"]["WJ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_Reversed_0=Module["_emscripten_bind_TopoDS_Face_Reversed_0"]=function(){return(_emscripten_bind_TopoDS_Face_Reversed_0=Module["_emscripten_bind_TopoDS_Face_Reversed_0"]=Module["asm"]["XJ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_Complement_0=Module["_emscripten_bind_TopoDS_Face_Complement_0"]=function(){return(_emscripten_bind_TopoDS_Face_Complement_0=Module["_emscripten_bind_TopoDS_Face_Complement_0"]=Module["asm"]["YJ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_Complemented_0=Module["_emscripten_bind_TopoDS_Face_Complemented_0"]=function(){return(_emscripten_bind_TopoDS_Face_Complemented_0=Module["_emscripten_bind_TopoDS_Face_Complemented_0"]=Module["asm"]["ZJ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_Compose_1=Module["_emscripten_bind_TopoDS_Face_Compose_1"]=function(){return(_emscripten_bind_TopoDS_Face_Compose_1=Module["_emscripten_bind_TopoDS_Face_Compose_1"]=Module["asm"]["_J"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_Composed_1=Module["_emscripten_bind_TopoDS_Face_Composed_1"]=function(){return(_emscripten_bind_TopoDS_Face_Composed_1=Module["_emscripten_bind_TopoDS_Face_Composed_1"]=Module["asm"]["$J"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_NbChildren_0=Module["_emscripten_bind_TopoDS_Face_NbChildren_0"]=function(){return(_emscripten_bind_TopoDS_Face_NbChildren_0=Module["_emscripten_bind_TopoDS_Face_NbChildren_0"]=Module["asm"]["aK"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_IsPartner_1=Module["_emscripten_bind_TopoDS_Face_IsPartner_1"]=function(){return(_emscripten_bind_TopoDS_Face_IsPartner_1=Module["_emscripten_bind_TopoDS_Face_IsPartner_1"]=Module["asm"]["bK"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_IsSame_1=Module["_emscripten_bind_TopoDS_Face_IsSame_1"]=function(){return(_emscripten_bind_TopoDS_Face_IsSame_1=Module["_emscripten_bind_TopoDS_Face_IsSame_1"]=Module["asm"]["cK"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_IsEqual_1=Module["_emscripten_bind_TopoDS_Face_IsEqual_1"]=function(){return(_emscripten_bind_TopoDS_Face_IsEqual_1=Module["_emscripten_bind_TopoDS_Face_IsEqual_1"]=Module["asm"]["dK"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_IsNotEqual_1=Module["_emscripten_bind_TopoDS_Face_IsNotEqual_1"]=function(){return(_emscripten_bind_TopoDS_Face_IsNotEqual_1=Module["_emscripten_bind_TopoDS_Face_IsNotEqual_1"]=Module["asm"]["eK"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_HashCode_1=Module["_emscripten_bind_TopoDS_Face_HashCode_1"]=function(){return(_emscripten_bind_TopoDS_Face_HashCode_1=Module["_emscripten_bind_TopoDS_Face_HashCode_1"]=Module["asm"]["fK"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_EmptyCopy_0=Module["_emscripten_bind_TopoDS_Face_EmptyCopy_0"]=function(){return(_emscripten_bind_TopoDS_Face_EmptyCopy_0=Module["_emscripten_bind_TopoDS_Face_EmptyCopy_0"]=Module["asm"]["gK"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face_EmptyCopied_0=Module["_emscripten_bind_TopoDS_Face_EmptyCopied_0"]=function(){return(_emscripten_bind_TopoDS_Face_EmptyCopied_0=Module["_emscripten_bind_TopoDS_Face_EmptyCopied_0"]=Module["asm"]["hK"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Face___destroy___0=Module["_emscripten_bind_TopoDS_Face___destroy___0"]=function(){return(_emscripten_bind_TopoDS_Face___destroy___0=Module["_emscripten_bind_TopoDS_Face___destroy___0"]=Module["asm"]["iK"]).apply(null,arguments)};var _emscripten_bind_gp_Pln_gp_Pln_0=Module["_emscripten_bind_gp_Pln_gp_Pln_0"]=function(){return(_emscripten_bind_gp_Pln_gp_Pln_0=Module["_emscripten_bind_gp_Pln_gp_Pln_0"]=Module["asm"]["jK"]).apply(null,arguments)};var _emscripten_bind_gp_Pln_gp_Pln_2=Module["_emscripten_bind_gp_Pln_gp_Pln_2"]=function(){return(_emscripten_bind_gp_Pln_gp_Pln_2=Module["_emscripten_bind_gp_Pln_gp_Pln_2"]=Module["asm"]["kK"]).apply(null,arguments)};var _emscripten_bind_gp_Pln_Coefficients_4=Module["_emscripten_bind_gp_Pln_Coefficients_4"]=function(){return(_emscripten_bind_gp_Pln_Coefficients_4=Module["_emscripten_bind_gp_Pln_Coefficients_4"]=Module["asm"]["lK"]).apply(null,arguments)};var _emscripten_bind_gp_Pln_SetAxis_1=Module["_emscripten_bind_gp_Pln_SetAxis_1"]=function(){return(_emscripten_bind_gp_Pln_SetAxis_1=Module["_emscripten_bind_gp_Pln_SetAxis_1"]=Module["asm"]["mK"]).apply(null,arguments)};var _emscripten_bind_gp_Pln_SetLocation_1=Module["_emscripten_bind_gp_Pln_SetLocation_1"]=function(){return(_emscripten_bind_gp_Pln_SetLocation_1=Module["_emscripten_bind_gp_Pln_SetLocation_1"]=Module["asm"]["nK"]).apply(null,arguments)};var _emscripten_bind_gp_Pln_UReverse_0=Module["_emscripten_bind_gp_Pln_UReverse_0"]=function(){return(_emscripten_bind_gp_Pln_UReverse_0=Module["_emscripten_bind_gp_Pln_UReverse_0"]=Module["asm"]["oK"]).apply(null,arguments)};var _emscripten_bind_gp_Pln_VReverse_0=Module["_emscripten_bind_gp_Pln_VReverse_0"]=function(){return(_emscripten_bind_gp_Pln_VReverse_0=Module["_emscripten_bind_gp_Pln_VReverse_0"]=Module["asm"]["pK"]).apply(null,arguments)};var _emscripten_bind_gp_Pln_Direct_0=Module["_emscripten_bind_gp_Pln_Direct_0"]=function(){return(_emscripten_bind_gp_Pln_Direct_0=Module["_emscripten_bind_gp_Pln_Direct_0"]=Module["asm"]["qK"]).apply(null,arguments)};var _emscripten_bind_gp_Pln_Axis_0=Module["_emscripten_bind_gp_Pln_Axis_0"]=function(){return(_emscripten_bind_gp_Pln_Axis_0=Module["_emscripten_bind_gp_Pln_Axis_0"]=Module["asm"]["rK"]).apply(null,arguments)};var _emscripten_bind_gp_Pln_Location_0=Module["_emscripten_bind_gp_Pln_Location_0"]=function(){return(_emscripten_bind_gp_Pln_Location_0=Module["_emscripten_bind_gp_Pln_Location_0"]=Module["asm"]["sK"]).apply(null,arguments)};var _emscripten_bind_gp_Pln_Distance_1=Module["_emscripten_bind_gp_Pln_Distance_1"]=function(){return(_emscripten_bind_gp_Pln_Distance_1=Module["_emscripten_bind_gp_Pln_Distance_1"]=Module["asm"]["tK"]).apply(null,arguments)};var _emscripten_bind_gp_Pln_SquareDistance_1=Module["_emscripten_bind_gp_Pln_SquareDistance_1"]=function(){return(_emscripten_bind_gp_Pln_SquareDistance_1=Module["_emscripten_bind_gp_Pln_SquareDistance_1"]=Module["asm"]["uK"]).apply(null,arguments)};var _emscripten_bind_gp_Pln_XAxis_0=Module["_emscripten_bind_gp_Pln_XAxis_0"]=function(){return(_emscripten_bind_gp_Pln_XAxis_0=Module["_emscripten_bind_gp_Pln_XAxis_0"]=Module["asm"]["vK"]).apply(null,arguments)};var _emscripten_bind_gp_Pln_YAxis_0=Module["_emscripten_bind_gp_Pln_YAxis_0"]=function(){return(_emscripten_bind_gp_Pln_YAxis_0=Module["_emscripten_bind_gp_Pln_YAxis_0"]=Module["asm"]["wK"]).apply(null,arguments)};var _emscripten_bind_gp_Pln_Contains_2=Module["_emscripten_bind_gp_Pln_Contains_2"]=function(){return(_emscripten_bind_gp_Pln_Contains_2=Module["_emscripten_bind_gp_Pln_Contains_2"]=Module["asm"]["xK"]).apply(null,arguments)};var _emscripten_bind_gp_Pln_Contains_3=Module["_emscripten_bind_gp_Pln_Contains_3"]=function(){return(_emscripten_bind_gp_Pln_Contains_3=Module["_emscripten_bind_gp_Pln_Contains_3"]=Module["asm"]["yK"]).apply(null,arguments)};var _emscripten_bind_gp_Pln_Mirror_1=Module["_emscripten_bind_gp_Pln_Mirror_1"]=function(){return(_emscripten_bind_gp_Pln_Mirror_1=Module["_emscripten_bind_gp_Pln_Mirror_1"]=Module["asm"]["zK"]).apply(null,arguments)};var _emscripten_bind_gp_Pln_Mirrored_1=Module["_emscripten_bind_gp_Pln_Mirrored_1"]=function(){return(_emscripten_bind_gp_Pln_Mirrored_1=Module["_emscripten_bind_gp_Pln_Mirrored_1"]=Module["asm"]["AK"]).apply(null,arguments)};var _emscripten_bind_gp_Pln_Rotate_2=Module["_emscripten_bind_gp_Pln_Rotate_2"]=function(){return(_emscripten_bind_gp_Pln_Rotate_2=Module["_emscripten_bind_gp_Pln_Rotate_2"]=Module["asm"]["BK"]).apply(null,arguments)};var _emscripten_bind_gp_Pln_Rotated_2=Module["_emscripten_bind_gp_Pln_Rotated_2"]=function(){return(_emscripten_bind_gp_Pln_Rotated_2=Module["_emscripten_bind_gp_Pln_Rotated_2"]=Module["asm"]["CK"]).apply(null,arguments)};var _emscripten_bind_gp_Pln_Scale_2=Module["_emscripten_bind_gp_Pln_Scale_2"]=function(){return(_emscripten_bind_gp_Pln_Scale_2=Module["_emscripten_bind_gp_Pln_Scale_2"]=Module["asm"]["DK"]).apply(null,arguments)};var _emscripten_bind_gp_Pln_Scaled_2=Module["_emscripten_bind_gp_Pln_Scaled_2"]=function(){return(_emscripten_bind_gp_Pln_Scaled_2=Module["_emscripten_bind_gp_Pln_Scaled_2"]=Module["asm"]["EK"]).apply(null,arguments)};var _emscripten_bind_gp_Pln_Transform_1=Module["_emscripten_bind_gp_Pln_Transform_1"]=function(){return(_emscripten_bind_gp_Pln_Transform_1=Module["_emscripten_bind_gp_Pln_Transform_1"]=Module["asm"]["FK"]).apply(null,arguments)};var _emscripten_bind_gp_Pln_Transformed_1=Module["_emscripten_bind_gp_Pln_Transformed_1"]=function(){return(_emscripten_bind_gp_Pln_Transformed_1=Module["_emscripten_bind_gp_Pln_Transformed_1"]=Module["asm"]["GK"]).apply(null,arguments)};var _emscripten_bind_gp_Pln_Translate_1=Module["_emscripten_bind_gp_Pln_Translate_1"]=function(){return(_emscripten_bind_gp_Pln_Translate_1=Module["_emscripten_bind_gp_Pln_Translate_1"]=Module["asm"]["HK"]).apply(null,arguments)};var _emscripten_bind_gp_Pln_Translate_2=Module["_emscripten_bind_gp_Pln_Translate_2"]=function(){return(_emscripten_bind_gp_Pln_Translate_2=Module["_emscripten_bind_gp_Pln_Translate_2"]=Module["asm"]["IK"]).apply(null,arguments)};var _emscripten_bind_gp_Pln_Translated_1=Module["_emscripten_bind_gp_Pln_Translated_1"]=function(){return(_emscripten_bind_gp_Pln_Translated_1=Module["_emscripten_bind_gp_Pln_Translated_1"]=Module["asm"]["JK"]).apply(null,arguments)};var _emscripten_bind_gp_Pln_Translated_2=Module["_emscripten_bind_gp_Pln_Translated_2"]=function(){return(_emscripten_bind_gp_Pln_Translated_2=Module["_emscripten_bind_gp_Pln_Translated_2"]=Module["asm"]["KK"]).apply(null,arguments)};var _emscripten_bind_gp_Pln___destroy___0=Module["_emscripten_bind_gp_Pln___destroy___0"]=function(){return(_emscripten_bind_gp_Pln___destroy___0=Module["_emscripten_bind_gp_Pln___destroy___0"]=Module["asm"]["LK"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakeThickSolid_BRepOffsetAPI_MakeThickSolid_0=Module["_emscripten_bind_BRepOffsetAPI_MakeThickSolid_BRepOffsetAPI_MakeThickSolid_0"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakeThickSolid_BRepOffsetAPI_MakeThickSolid_0=Module["_emscripten_bind_BRepOffsetAPI_MakeThickSolid_BRepOffsetAPI_MakeThickSolid_0"]=Module["asm"]["MK"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakeThickSolid_MakeThickSolidByJoin_4=Module["_emscripten_bind_BRepOffsetAPI_MakeThickSolid_MakeThickSolidByJoin_4"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakeThickSolid_MakeThickSolidByJoin_4=Module["_emscripten_bind_BRepOffsetAPI_MakeThickSolid_MakeThickSolidByJoin_4"]=Module["asm"]["NK"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformBySimple_2=Module["_emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformBySimple_2"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformBySimple_2=Module["_emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformBySimple_2"]=Module["asm"]["OK"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformByJoin_3=Module["_emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformByJoin_3"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformByJoin_3=Module["_emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformByJoin_3"]=Module["asm"]["PK"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformByJoin_4=Module["_emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformByJoin_4"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformByJoin_4=Module["_emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformByJoin_4"]=Module["asm"]["QK"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformByJoin_5=Module["_emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformByJoin_5"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformByJoin_5=Module["_emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformByJoin_5"]=Module["asm"]["RK"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformByJoin_6=Module["_emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformByJoin_6"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformByJoin_6=Module["_emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformByJoin_6"]=Module["asm"]["SK"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformByJoin_7=Module["_emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformByJoin_7"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformByJoin_7=Module["_emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformByJoin_7"]=Module["asm"]["TK"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformByJoin_8=Module["_emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformByJoin_8"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformByJoin_8=Module["_emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformByJoin_8"]=Module["asm"]["UK"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakeThickSolid_Shape_0=Module["_emscripten_bind_BRepOffsetAPI_MakeThickSolid_Shape_0"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakeThickSolid_Shape_0=Module["_emscripten_bind_BRepOffsetAPI_MakeThickSolid_Shape_0"]=Module["asm"]["VK"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakeThickSolid___destroy___0=Module["_emscripten_bind_BRepOffsetAPI_MakeThickSolid___destroy___0"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakeThickSolid___destroy___0=Module["_emscripten_bind_BRepOffsetAPI_MakeThickSolid___destroy___0"]=Module["asm"]["WK"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Face_ShapeFix_Face_0=Module["_emscripten_bind_ShapeFix_Face_ShapeFix_Face_0"]=function(){return(_emscripten_bind_ShapeFix_Face_ShapeFix_Face_0=Module["_emscripten_bind_ShapeFix_Face_ShapeFix_Face_0"]=Module["asm"]["XK"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Face_ShapeFix_Face_1=Module["_emscripten_bind_ShapeFix_Face_ShapeFix_Face_1"]=function(){return(_emscripten_bind_ShapeFix_Face_ShapeFix_Face_1=Module["_emscripten_bind_ShapeFix_Face_ShapeFix_Face_1"]=Module["asm"]["YK"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Face_ClearModes_0=Module["_emscripten_bind_ShapeFix_Face_ClearModes_0"]=function(){return(_emscripten_bind_ShapeFix_Face_ClearModes_0=Module["_emscripten_bind_ShapeFix_Face_ClearModes_0"]=Module["asm"]["ZK"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Face_Init_1=Module["_emscripten_bind_ShapeFix_Face_Init_1"]=function(){return(_emscripten_bind_ShapeFix_Face_Init_1=Module["_emscripten_bind_ShapeFix_Face_Init_1"]=Module["asm"]["_K"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Face_SetPrecision_1=Module["_emscripten_bind_ShapeFix_Face_SetPrecision_1"]=function(){return(_emscripten_bind_ShapeFix_Face_SetPrecision_1=Module["_emscripten_bind_ShapeFix_Face_SetPrecision_1"]=Module["asm"]["$K"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Face_SetMinTolerance_1=Module["_emscripten_bind_ShapeFix_Face_SetMinTolerance_1"]=function(){return(_emscripten_bind_ShapeFix_Face_SetMinTolerance_1=Module["_emscripten_bind_ShapeFix_Face_SetMinTolerance_1"]=Module["asm"]["aL"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Face_SetMaxTolerance_1=Module["_emscripten_bind_ShapeFix_Face_SetMaxTolerance_1"]=function(){return(_emscripten_bind_ShapeFix_Face_SetMaxTolerance_1=Module["_emscripten_bind_ShapeFix_Face_SetMaxTolerance_1"]=Module["asm"]["bL"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Face_FixWireMode_0=Module["_emscripten_bind_ShapeFix_Face_FixWireMode_0"]=function(){return(_emscripten_bind_ShapeFix_Face_FixWireMode_0=Module["_emscripten_bind_ShapeFix_Face_FixWireMode_0"]=Module["asm"]["cL"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Face_FixOrientationMode_0=Module["_emscripten_bind_ShapeFix_Face_FixOrientationMode_0"]=function(){return(_emscripten_bind_ShapeFix_Face_FixOrientationMode_0=Module["_emscripten_bind_ShapeFix_Face_FixOrientationMode_0"]=Module["asm"]["dL"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Face_FixAddNaturalBoundMode_0=Module["_emscripten_bind_ShapeFix_Face_FixAddNaturalBoundMode_0"]=function(){return(_emscripten_bind_ShapeFix_Face_FixAddNaturalBoundMode_0=Module["_emscripten_bind_ShapeFix_Face_FixAddNaturalBoundMode_0"]=Module["asm"]["eL"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Face_FixMissingSeamMode_0=Module["_emscripten_bind_ShapeFix_Face_FixMissingSeamMode_0"]=function(){return(_emscripten_bind_ShapeFix_Face_FixMissingSeamMode_0=Module["_emscripten_bind_ShapeFix_Face_FixMissingSeamMode_0"]=Module["asm"]["fL"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Face_FixSmallAreaWireMode_0=Module["_emscripten_bind_ShapeFix_Face_FixSmallAreaWireMode_0"]=function(){return(_emscripten_bind_ShapeFix_Face_FixSmallAreaWireMode_0=Module["_emscripten_bind_ShapeFix_Face_FixSmallAreaWireMode_0"]=Module["asm"]["gL"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Face_RemoveSmallAreaFaceMode_0=Module["_emscripten_bind_ShapeFix_Face_RemoveSmallAreaFaceMode_0"]=function(){return(_emscripten_bind_ShapeFix_Face_RemoveSmallAreaFaceMode_0=Module["_emscripten_bind_ShapeFix_Face_RemoveSmallAreaFaceMode_0"]=Module["asm"]["hL"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Face_FixIntersectingWiresMode_0=Module["_emscripten_bind_ShapeFix_Face_FixIntersectingWiresMode_0"]=function(){return(_emscripten_bind_ShapeFix_Face_FixIntersectingWiresMode_0=Module["_emscripten_bind_ShapeFix_Face_FixIntersectingWiresMode_0"]=Module["asm"]["iL"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Face_FixLoopWiresMode_0=Module["_emscripten_bind_ShapeFix_Face_FixLoopWiresMode_0"]=function(){return(_emscripten_bind_ShapeFix_Face_FixLoopWiresMode_0=Module["_emscripten_bind_ShapeFix_Face_FixLoopWiresMode_0"]=Module["asm"]["jL"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Face_FixSplitFaceMode_0=Module["_emscripten_bind_ShapeFix_Face_FixSplitFaceMode_0"]=function(){return(_emscripten_bind_ShapeFix_Face_FixSplitFaceMode_0=Module["_emscripten_bind_ShapeFix_Face_FixSplitFaceMode_0"]=Module["asm"]["kL"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Face_AutoCorrectPrecisionMode_0=Module["_emscripten_bind_ShapeFix_Face_AutoCorrectPrecisionMode_0"]=function(){return(_emscripten_bind_ShapeFix_Face_AutoCorrectPrecisionMode_0=Module["_emscripten_bind_ShapeFix_Face_AutoCorrectPrecisionMode_0"]=Module["asm"]["lL"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Face_FixPeriodicDegeneratedMode_0=Module["_emscripten_bind_ShapeFix_Face_FixPeriodicDegeneratedMode_0"]=function(){return(_emscripten_bind_ShapeFix_Face_FixPeriodicDegeneratedMode_0=Module["_emscripten_bind_ShapeFix_Face_FixPeriodicDegeneratedMode_0"]=Module["asm"]["mL"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Face_Face_0=Module["_emscripten_bind_ShapeFix_Face_Face_0"]=function(){return(_emscripten_bind_ShapeFix_Face_Face_0=Module["_emscripten_bind_ShapeFix_Face_Face_0"]=Module["asm"]["nL"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Face_Result_0=Module["_emscripten_bind_ShapeFix_Face_Result_0"]=function(){return(_emscripten_bind_ShapeFix_Face_Result_0=Module["_emscripten_bind_ShapeFix_Face_Result_0"]=Module["asm"]["oL"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Face_Add_1=Module["_emscripten_bind_ShapeFix_Face_Add_1"]=function(){return(_emscripten_bind_ShapeFix_Face_Add_1=Module["_emscripten_bind_ShapeFix_Face_Add_1"]=Module["asm"]["pL"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Face_Perform_0=Module["_emscripten_bind_ShapeFix_Face_Perform_0"]=function(){return(_emscripten_bind_ShapeFix_Face_Perform_0=Module["_emscripten_bind_ShapeFix_Face_Perform_0"]=Module["asm"]["qL"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Face_FixOrientation_0=Module["_emscripten_bind_ShapeFix_Face_FixOrientation_0"]=function(){return(_emscripten_bind_ShapeFix_Face_FixOrientation_0=Module["_emscripten_bind_ShapeFix_Face_FixOrientation_0"]=Module["asm"]["rL"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Face_FixAddNaturalBound_0=Module["_emscripten_bind_ShapeFix_Face_FixAddNaturalBound_0"]=function(){return(_emscripten_bind_ShapeFix_Face_FixAddNaturalBound_0=Module["_emscripten_bind_ShapeFix_Face_FixAddNaturalBound_0"]=Module["asm"]["sL"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Face_FixMissingSeam_0=Module["_emscripten_bind_ShapeFix_Face_FixMissingSeam_0"]=function(){return(_emscripten_bind_ShapeFix_Face_FixMissingSeam_0=Module["_emscripten_bind_ShapeFix_Face_FixMissingSeam_0"]=Module["asm"]["tL"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Face_FixSmallAreaWire_1=Module["_emscripten_bind_ShapeFix_Face_FixSmallAreaWire_1"]=function(){return(_emscripten_bind_ShapeFix_Face_FixSmallAreaWire_1=Module["_emscripten_bind_ShapeFix_Face_FixSmallAreaWire_1"]=Module["asm"]["uL"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Face_FixIntersectingWires_0=Module["_emscripten_bind_ShapeFix_Face_FixIntersectingWires_0"]=function(){return(_emscripten_bind_ShapeFix_Face_FixIntersectingWires_0=Module["_emscripten_bind_ShapeFix_Face_FixIntersectingWires_0"]=Module["asm"]["vL"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Face_FixWiresTwoCoincEdges_0=Module["_emscripten_bind_ShapeFix_Face_FixWiresTwoCoincEdges_0"]=function(){return(_emscripten_bind_ShapeFix_Face_FixWiresTwoCoincEdges_0=Module["_emscripten_bind_ShapeFix_Face_FixWiresTwoCoincEdges_0"]=Module["asm"]["wL"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Face_FixPeriodicDegenerated_0=Module["_emscripten_bind_ShapeFix_Face_FixPeriodicDegenerated_0"]=function(){return(_emscripten_bind_ShapeFix_Face_FixPeriodicDegenerated_0=Module["_emscripten_bind_ShapeFix_Face_FixPeriodicDegenerated_0"]=Module["asm"]["xL"]).apply(null,arguments)};var _emscripten_bind_ShapeFix_Face___destroy___0=Module["_emscripten_bind_ShapeFix_Face___destroy___0"]=function(){return(_emscripten_bind_ShapeFix_Face___destroy___0=Module["_emscripten_bind_ShapeFix_Face___destroy___0"]=Module["asm"]["yL"]).apply(null,arguments)};var _emscripten_bind_Geom_Parabola_Geom_Parabola_1=Module["_emscripten_bind_Geom_Parabola_Geom_Parabola_1"]=function(){return(_emscripten_bind_Geom_Parabola_Geom_Parabola_1=Module["_emscripten_bind_Geom_Parabola_Geom_Parabola_1"]=Module["asm"]["zL"]).apply(null,arguments)};var _emscripten_bind_Geom_Parabola_Geom_Parabola_2=Module["_emscripten_bind_Geom_Parabola_Geom_Parabola_2"]=function(){return(_emscripten_bind_Geom_Parabola_Geom_Parabola_2=Module["_emscripten_bind_Geom_Parabola_Geom_Parabola_2"]=Module["asm"]["AL"]).apply(null,arguments)};var _emscripten_bind_Geom_Parabola_Focal_0=Module["_emscripten_bind_Geom_Parabola_Focal_0"]=function(){return(_emscripten_bind_Geom_Parabola_Focal_0=Module["_emscripten_bind_Geom_Parabola_Focal_0"]=Module["asm"]["BL"]).apply(null,arguments)};var _emscripten_bind_Geom_Parabola_Reverse_0=Module["_emscripten_bind_Geom_Parabola_Reverse_0"]=function(){return(_emscripten_bind_Geom_Parabola_Reverse_0=Module["_emscripten_bind_Geom_Parabola_Reverse_0"]=Module["asm"]["CL"]).apply(null,arguments)};var _emscripten_bind_Geom_Parabola_ReversedParameter_1=Module["_emscripten_bind_Geom_Parabola_ReversedParameter_1"]=function(){return(_emscripten_bind_Geom_Parabola_ReversedParameter_1=Module["_emscripten_bind_Geom_Parabola_ReversedParameter_1"]=Module["asm"]["DL"]).apply(null,arguments)};var _emscripten_bind_Geom_Parabola_TransformedParameter_2=Module["_emscripten_bind_Geom_Parabola_TransformedParameter_2"]=function(){return(_emscripten_bind_Geom_Parabola_TransformedParameter_2=Module["_emscripten_bind_Geom_Parabola_TransformedParameter_2"]=Module["asm"]["EL"]).apply(null,arguments)};var _emscripten_bind_Geom_Parabola_ParametricTransformation_1=Module["_emscripten_bind_Geom_Parabola_ParametricTransformation_1"]=function(){return(_emscripten_bind_Geom_Parabola_ParametricTransformation_1=Module["_emscripten_bind_Geom_Parabola_ParametricTransformation_1"]=Module["asm"]["FL"]).apply(null,arguments)};var _emscripten_bind_Geom_Parabola_Reversed_0=Module["_emscripten_bind_Geom_Parabola_Reversed_0"]=function(){return(_emscripten_bind_Geom_Parabola_Reversed_0=Module["_emscripten_bind_Geom_Parabola_Reversed_0"]=Module["asm"]["GL"]).apply(null,arguments)};var _emscripten_bind_Geom_Parabola_FirstParameter_0=Module["_emscripten_bind_Geom_Parabola_FirstParameter_0"]=function(){return(_emscripten_bind_Geom_Parabola_FirstParameter_0=Module["_emscripten_bind_Geom_Parabola_FirstParameter_0"]=Module["asm"]["HL"]).apply(null,arguments)};var _emscripten_bind_Geom_Parabola_LastParameter_0=Module["_emscripten_bind_Geom_Parabola_LastParameter_0"]=function(){return(_emscripten_bind_Geom_Parabola_LastParameter_0=Module["_emscripten_bind_Geom_Parabola_LastParameter_0"]=Module["asm"]["IL"]).apply(null,arguments)};var _emscripten_bind_Geom_Parabola_IsClosed_0=Module["_emscripten_bind_Geom_Parabola_IsClosed_0"]=function(){return(_emscripten_bind_Geom_Parabola_IsClosed_0=Module["_emscripten_bind_Geom_Parabola_IsClosed_0"]=Module["asm"]["JL"]).apply(null,arguments)};var _emscripten_bind_Geom_Parabola_IsPeriodic_0=Module["_emscripten_bind_Geom_Parabola_IsPeriodic_0"]=function(){return(_emscripten_bind_Geom_Parabola_IsPeriodic_0=Module["_emscripten_bind_Geom_Parabola_IsPeriodic_0"]=Module["asm"]["KL"]).apply(null,arguments)};var _emscripten_bind_Geom_Parabola_Period_0=Module["_emscripten_bind_Geom_Parabola_Period_0"]=function(){return(_emscripten_bind_Geom_Parabola_Period_0=Module["_emscripten_bind_Geom_Parabola_Period_0"]=Module["asm"]["LL"]).apply(null,arguments)};var _emscripten_bind_Geom_Parabola_IsCN_1=Module["_emscripten_bind_Geom_Parabola_IsCN_1"]=function(){return(_emscripten_bind_Geom_Parabola_IsCN_1=Module["_emscripten_bind_Geom_Parabola_IsCN_1"]=Module["asm"]["ML"]).apply(null,arguments)};var _emscripten_bind_Geom_Parabola_D0_2=Module["_emscripten_bind_Geom_Parabola_D0_2"]=function(){return(_emscripten_bind_Geom_Parabola_D0_2=Module["_emscripten_bind_Geom_Parabola_D0_2"]=Module["asm"]["NL"]).apply(null,arguments)};var _emscripten_bind_Geom_Parabola_D1_3=Module["_emscripten_bind_Geom_Parabola_D1_3"]=function(){return(_emscripten_bind_Geom_Parabola_D1_3=Module["_emscripten_bind_Geom_Parabola_D1_3"]=Module["asm"]["OL"]).apply(null,arguments)};var _emscripten_bind_Geom_Parabola_D2_4=Module["_emscripten_bind_Geom_Parabola_D2_4"]=function(){return(_emscripten_bind_Geom_Parabola_D2_4=Module["_emscripten_bind_Geom_Parabola_D2_4"]=Module["asm"]["PL"]).apply(null,arguments)};var _emscripten_bind_Geom_Parabola_D3_5=Module["_emscripten_bind_Geom_Parabola_D3_5"]=function(){return(_emscripten_bind_Geom_Parabola_D3_5=Module["_emscripten_bind_Geom_Parabola_D3_5"]=Module["asm"]["QL"]).apply(null,arguments)};var _emscripten_bind_Geom_Parabola_DN_2=Module["_emscripten_bind_Geom_Parabola_DN_2"]=function(){return(_emscripten_bind_Geom_Parabola_DN_2=Module["_emscripten_bind_Geom_Parabola_DN_2"]=Module["asm"]["RL"]).apply(null,arguments)};var _emscripten_bind_Geom_Parabola_Value_1=Module["_emscripten_bind_Geom_Parabola_Value_1"]=function(){return(_emscripten_bind_Geom_Parabola_Value_1=Module["_emscripten_bind_Geom_Parabola_Value_1"]=Module["asm"]["SL"]).apply(null,arguments)};var _emscripten_bind_Geom_Parabola___destroy___0=Module["_emscripten_bind_Geom_Parabola___destroy___0"]=function(){return(_emscripten_bind_Geom_Parabola___destroy___0=Module["_emscripten_bind_Geom_Parabola___destroy___0"]=Module["asm"]["TL"]).apply(null,arguments)};var _emscripten_bind_gp_Elips_gp_Elips_0=Module["_emscripten_bind_gp_Elips_gp_Elips_0"]=function(){return(_emscripten_bind_gp_Elips_gp_Elips_0=Module["_emscripten_bind_gp_Elips_gp_Elips_0"]=Module["asm"]["UL"]).apply(null,arguments)};var _emscripten_bind_gp_Elips_gp_Elips_3=Module["_emscripten_bind_gp_Elips_gp_Elips_3"]=function(){return(_emscripten_bind_gp_Elips_gp_Elips_3=Module["_emscripten_bind_gp_Elips_gp_Elips_3"]=Module["asm"]["VL"]).apply(null,arguments)};var _emscripten_bind_gp_Elips_Eccentricity_0=Module["_emscripten_bind_gp_Elips_Eccentricity_0"]=function(){return(_emscripten_bind_gp_Elips_Eccentricity_0=Module["_emscripten_bind_gp_Elips_Eccentricity_0"]=Module["asm"]["WL"]).apply(null,arguments)};var _emscripten_bind_gp_Elips_Focal_0=Module["_emscripten_bind_gp_Elips_Focal_0"]=function(){return(_emscripten_bind_gp_Elips_Focal_0=Module["_emscripten_bind_gp_Elips_Focal_0"]=Module["asm"]["XL"]).apply(null,arguments)};var _emscripten_bind_gp_Elips_Area_0=Module["_emscripten_bind_gp_Elips_Area_0"]=function(){return(_emscripten_bind_gp_Elips_Area_0=Module["_emscripten_bind_gp_Elips_Area_0"]=Module["asm"]["YL"]).apply(null,arguments)};var _emscripten_bind_gp_Elips_MajorRadius_0=Module["_emscripten_bind_gp_Elips_MajorRadius_0"]=function(){return(_emscripten_bind_gp_Elips_MajorRadius_0=Module["_emscripten_bind_gp_Elips_MajorRadius_0"]=Module["asm"]["ZL"]).apply(null,arguments)};var _emscripten_bind_gp_Elips_MinorRadius_0=Module["_emscripten_bind_gp_Elips_MinorRadius_0"]=function(){return(_emscripten_bind_gp_Elips_MinorRadius_0=Module["_emscripten_bind_gp_Elips_MinorRadius_0"]=Module["asm"]["_L"]).apply(null,arguments)};var _emscripten_bind_gp_Elips___destroy___0=Module["_emscripten_bind_gp_Elips___destroy___0"]=function(){return(_emscripten_bind_gp_Elips___destroy___0=Module["_emscripten_bind_gp_Elips___destroy___0"]=Module["asm"]["$L"]).apply(null,arguments)};var _emscripten_bind_Geom2d_TrimmedCurve_Geom2d_TrimmedCurve_3=Module["_emscripten_bind_Geom2d_TrimmedCurve_Geom2d_TrimmedCurve_3"]=function(){return(_emscripten_bind_Geom2d_TrimmedCurve_Geom2d_TrimmedCurve_3=Module["_emscripten_bind_Geom2d_TrimmedCurve_Geom2d_TrimmedCurve_3"]=Module["asm"]["aM"]).apply(null,arguments)};var _emscripten_bind_Geom2d_TrimmedCurve_Geom2d_TrimmedCurve_4=Module["_emscripten_bind_Geom2d_TrimmedCurve_Geom2d_TrimmedCurve_4"]=function(){return(_emscripten_bind_Geom2d_TrimmedCurve_Geom2d_TrimmedCurve_4=Module["_emscripten_bind_Geom2d_TrimmedCurve_Geom2d_TrimmedCurve_4"]=Module["asm"]["bM"]).apply(null,arguments)};var _emscripten_bind_Geom2d_TrimmedCurve_Geom2d_TrimmedCurve_5=Module["_emscripten_bind_Geom2d_TrimmedCurve_Geom2d_TrimmedCurve_5"]=function(){return(_emscripten_bind_Geom2d_TrimmedCurve_Geom2d_TrimmedCurve_5=Module["_emscripten_bind_Geom2d_TrimmedCurve_Geom2d_TrimmedCurve_5"]=Module["asm"]["cM"]).apply(null,arguments)};var _emscripten_bind_Geom2d_TrimmedCurve_Period_0=Module["_emscripten_bind_Geom2d_TrimmedCurve_Period_0"]=function(){return(_emscripten_bind_Geom2d_TrimmedCurve_Period_0=Module["_emscripten_bind_Geom2d_TrimmedCurve_Period_0"]=Module["asm"]["dM"]).apply(null,arguments)};var _emscripten_bind_Geom2d_TrimmedCurve_Value_1=Module["_emscripten_bind_Geom2d_TrimmedCurve_Value_1"]=function(){return(_emscripten_bind_Geom2d_TrimmedCurve_Value_1=Module["_emscripten_bind_Geom2d_TrimmedCurve_Value_1"]=Module["asm"]["eM"]).apply(null,arguments)};var _emscripten_bind_Geom2d_TrimmedCurve___destroy___0=Module["_emscripten_bind_Geom2d_TrimmedCurve___destroy___0"]=function(){return(_emscripten_bind_Geom2d_TrimmedCurve___destroy___0=Module["_emscripten_bind_Geom2d_TrimmedCurve___destroy___0"]=Module["asm"]["fM"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeRevol_BRepPrimAPI_MakeRevol_3=Module["_emscripten_bind_BRepPrimAPI_MakeRevol_BRepPrimAPI_MakeRevol_3"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeRevol_BRepPrimAPI_MakeRevol_3=Module["_emscripten_bind_BRepPrimAPI_MakeRevol_BRepPrimAPI_MakeRevol_3"]=Module["asm"]["gM"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeRevol_BRepPrimAPI_MakeRevol_4=Module["_emscripten_bind_BRepPrimAPI_MakeRevol_BRepPrimAPI_MakeRevol_4"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeRevol_BRepPrimAPI_MakeRevol_4=Module["_emscripten_bind_BRepPrimAPI_MakeRevol_BRepPrimAPI_MakeRevol_4"]=Module["asm"]["hM"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeRevol_Build_0=Module["_emscripten_bind_BRepPrimAPI_MakeRevol_Build_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeRevol_Build_0=Module["_emscripten_bind_BRepPrimAPI_MakeRevol_Build_0"]=Module["asm"]["iM"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeRevol_Generated_1=Module["_emscripten_bind_BRepPrimAPI_MakeRevol_Generated_1"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeRevol_Generated_1=Module["_emscripten_bind_BRepPrimAPI_MakeRevol_Generated_1"]=Module["asm"]["jM"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeRevol_IsDeleted_1=Module["_emscripten_bind_BRepPrimAPI_MakeRevol_IsDeleted_1"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeRevol_IsDeleted_1=Module["_emscripten_bind_BRepPrimAPI_MakeRevol_IsDeleted_1"]=Module["asm"]["kM"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeRevol_FirstShape_1=Module["_emscripten_bind_BRepPrimAPI_MakeRevol_FirstShape_1"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeRevol_FirstShape_1=Module["_emscripten_bind_BRepPrimAPI_MakeRevol_FirstShape_1"]=Module["asm"]["lM"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeRevol_LastShape_1=Module["_emscripten_bind_BRepPrimAPI_MakeRevol_LastShape_1"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeRevol_LastShape_1=Module["_emscripten_bind_BRepPrimAPI_MakeRevol_LastShape_1"]=Module["asm"]["mM"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeRevol_HasDegenerated_0=Module["_emscripten_bind_BRepPrimAPI_MakeRevol_HasDegenerated_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeRevol_HasDegenerated_0=Module["_emscripten_bind_BRepPrimAPI_MakeRevol_HasDegenerated_0"]=Module["asm"]["nM"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeRevol_Degenerated_0=Module["_emscripten_bind_BRepPrimAPI_MakeRevol_Degenerated_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeRevol_Degenerated_0=Module["_emscripten_bind_BRepPrimAPI_MakeRevol_Degenerated_0"]=Module["asm"]["oM"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeRevol_Shape_0=Module["_emscripten_bind_BRepPrimAPI_MakeRevol_Shape_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeRevol_Shape_0=Module["_emscripten_bind_BRepPrimAPI_MakeRevol_Shape_0"]=Module["asm"]["pM"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeRevol___destroy___0=Module["_emscripten_bind_BRepPrimAPI_MakeRevol___destroy___0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeRevol___destroy___0=Module["_emscripten_bind_BRepPrimAPI_MakeRevol___destroy___0"]=Module["asm"]["qM"]).apply(null,arguments)};var _emscripten_bind_gp_Ax3_gp_Ax3_0=Module["_emscripten_bind_gp_Ax3_gp_Ax3_0"]=function(){return(_emscripten_bind_gp_Ax3_gp_Ax3_0=Module["_emscripten_bind_gp_Ax3_gp_Ax3_0"]=Module["asm"]["rM"]).apply(null,arguments)};var _emscripten_bind_gp_Ax3___destroy___0=Module["_emscripten_bind_gp_Ax3___destroy___0"]=function(){return(_emscripten_bind_gp_Ax3___destroy___0=Module["_emscripten_bind_gp_Ax3___destroy___0"]=Module["asm"]["sM"]).apply(null,arguments)};var _emscripten_bind_gp_Ax2_gp_Ax2_0=Module["_emscripten_bind_gp_Ax2_gp_Ax2_0"]=function(){return(_emscripten_bind_gp_Ax2_gp_Ax2_0=Module["_emscripten_bind_gp_Ax2_gp_Ax2_0"]=Module["asm"]["tM"]).apply(null,arguments)};var _emscripten_bind_gp_Ax2_gp_Ax2_2=Module["_emscripten_bind_gp_Ax2_gp_Ax2_2"]=function(){return(_emscripten_bind_gp_Ax2_gp_Ax2_2=Module["_emscripten_bind_gp_Ax2_gp_Ax2_2"]=Module["asm"]["uM"]).apply(null,arguments)};var _emscripten_bind_gp_Ax2___destroy___0=Module["_emscripten_bind_gp_Ax2___destroy___0"]=function(){return(_emscripten_bind_gp_Ax2___destroy___0=Module["_emscripten_bind_gp_Ax2___destroy___0"]=Module["asm"]["vM"]).apply(null,arguments)};var _emscripten_bind_gp_Ax1_gp_Ax1_0=Module["_emscripten_bind_gp_Ax1_gp_Ax1_0"]=function(){return(_emscripten_bind_gp_Ax1_gp_Ax1_0=Module["_emscripten_bind_gp_Ax1_gp_Ax1_0"]=Module["asm"]["wM"]).apply(null,arguments)};var _emscripten_bind_gp_Ax1_gp_Ax1_2=Module["_emscripten_bind_gp_Ax1_gp_Ax1_2"]=function(){return(_emscripten_bind_gp_Ax1_gp_Ax1_2=Module["_emscripten_bind_gp_Ax1_gp_Ax1_2"]=Module["asm"]["xM"]).apply(null,arguments)};var _emscripten_bind_gp_Ax1___destroy___0=Module["_emscripten_bind_gp_Ax1___destroy___0"]=function(){return(_emscripten_bind_gp_Ax1___destroy___0=Module["_emscripten_bind_gp_Ax1___destroy___0"]=Module["asm"]["yM"]).apply(null,arguments)};var _emscripten_bind_gp_Ax2d_gp_Ax2d_0=Module["_emscripten_bind_gp_Ax2d_gp_Ax2d_0"]=function(){return(_emscripten_bind_gp_Ax2d_gp_Ax2d_0=Module["_emscripten_bind_gp_Ax2d_gp_Ax2d_0"]=Module["asm"]["zM"]).apply(null,arguments)};var _emscripten_bind_gp_Ax2d_gp_Ax2d_2=Module["_emscripten_bind_gp_Ax2d_gp_Ax2d_2"]=function(){return(_emscripten_bind_gp_Ax2d_gp_Ax2d_2=Module["_emscripten_bind_gp_Ax2d_gp_Ax2d_2"]=Module["asm"]["AM"]).apply(null,arguments)};var _emscripten_bind_gp_Ax2d___destroy___0=Module["_emscripten_bind_gp_Ax2d___destroy___0"]=function(){return(_emscripten_bind_gp_Ax2d___destroy___0=Module["_emscripten_bind_gp_Ax2d___destroy___0"]=Module["asm"]["BM"]).apply(null,arguments)};var _emscripten_bind_Transfer_TransientProcess_Transfer_TransientProcess_0=Module["_emscripten_bind_Transfer_TransientProcess_Transfer_TransientProcess_0"]=function(){return(_emscripten_bind_Transfer_TransientProcess_Transfer_TransientProcess_0=Module["_emscripten_bind_Transfer_TransientProcess_Transfer_TransientProcess_0"]=Module["asm"]["CM"]).apply(null,arguments)};var _emscripten_bind_Transfer_TransientProcess_Transfer_TransientProcess_1=Module["_emscripten_bind_Transfer_TransientProcess_Transfer_TransientProcess_1"]=function(){return(_emscripten_bind_Transfer_TransientProcess_Transfer_TransientProcess_1=Module["_emscripten_bind_Transfer_TransientProcess_Transfer_TransientProcess_1"]=Module["asm"]["DM"]).apply(null,arguments)};var _emscripten_bind_Transfer_TransientProcess_HasGraph_0=Module["_emscripten_bind_Transfer_TransientProcess_HasGraph_0"]=function(){return(_emscripten_bind_Transfer_TransientProcess_HasGraph_0=Module["_emscripten_bind_Transfer_TransientProcess_HasGraph_0"]=Module["asm"]["EM"]).apply(null,arguments)};var _emscripten_bind_Transfer_TransientProcess_GetProgress_0=Module["_emscripten_bind_Transfer_TransientProcess_GetProgress_0"]=function(){return(_emscripten_bind_Transfer_TransientProcess_GetProgress_0=Module["_emscripten_bind_Transfer_TransientProcess_GetProgress_0"]=Module["asm"]["FM"]).apply(null,arguments)};var _emscripten_bind_Transfer_TransientProcess_SetProgress_1=Module["_emscripten_bind_Transfer_TransientProcess_SetProgress_1"]=function(){return(_emscripten_bind_Transfer_TransientProcess_SetProgress_1=Module["_emscripten_bind_Transfer_TransientProcess_SetProgress_1"]=Module["asm"]["GM"]).apply(null,arguments)};var _emscripten_bind_Transfer_TransientProcess___destroy___0=Module["_emscripten_bind_Transfer_TransientProcess___destroy___0"]=function(){return(_emscripten_bind_Transfer_TransientProcess___destroy___0=Module["_emscripten_bind_Transfer_TransientProcess___destroy___0"]=Module["asm"]["HM"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakeOffset_BRepOffsetAPI_MakeOffset_0=Module["_emscripten_bind_BRepOffsetAPI_MakeOffset_BRepOffsetAPI_MakeOffset_0"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakeOffset_BRepOffsetAPI_MakeOffset_0=Module["_emscripten_bind_BRepOffsetAPI_MakeOffset_BRepOffsetAPI_MakeOffset_0"]=Module["asm"]["IM"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakeOffset_BRepOffsetAPI_MakeOffset_1=Module["_emscripten_bind_BRepOffsetAPI_MakeOffset_BRepOffsetAPI_MakeOffset_1"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakeOffset_BRepOffsetAPI_MakeOffset_1=Module["_emscripten_bind_BRepOffsetAPI_MakeOffset_BRepOffsetAPI_MakeOffset_1"]=Module["asm"]["JM"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakeOffset_BRepOffsetAPI_MakeOffset_2=Module["_emscripten_bind_BRepOffsetAPI_MakeOffset_BRepOffsetAPI_MakeOffset_2"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakeOffset_BRepOffsetAPI_MakeOffset_2=Module["_emscripten_bind_BRepOffsetAPI_MakeOffset_BRepOffsetAPI_MakeOffset_2"]=Module["asm"]["KM"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakeOffset_BRepOffsetAPI_MakeOffset_3=Module["_emscripten_bind_BRepOffsetAPI_MakeOffset_BRepOffsetAPI_MakeOffset_3"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakeOffset_BRepOffsetAPI_MakeOffset_3=Module["_emscripten_bind_BRepOffsetAPI_MakeOffset_BRepOffsetAPI_MakeOffset_3"]=Module["asm"]["LM"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakeOffset_AddWire_1=Module["_emscripten_bind_BRepOffsetAPI_MakeOffset_AddWire_1"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakeOffset_AddWire_1=Module["_emscripten_bind_BRepOffsetAPI_MakeOffset_AddWire_1"]=Module["asm"]["MM"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakeOffset_Perform_1=Module["_emscripten_bind_BRepOffsetAPI_MakeOffset_Perform_1"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakeOffset_Perform_1=Module["_emscripten_bind_BRepOffsetAPI_MakeOffset_Perform_1"]=Module["asm"]["NM"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakeOffset_Perform_2=Module["_emscripten_bind_BRepOffsetAPI_MakeOffset_Perform_2"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakeOffset_Perform_2=Module["_emscripten_bind_BRepOffsetAPI_MakeOffset_Perform_2"]=Module["asm"]["OM"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakeOffset_Shape_0=Module["_emscripten_bind_BRepOffsetAPI_MakeOffset_Shape_0"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakeOffset_Shape_0=Module["_emscripten_bind_BRepOffsetAPI_MakeOffset_Shape_0"]=Module["asm"]["PM"]).apply(null,arguments)};var _emscripten_bind_BRepOffsetAPI_MakeOffset___destroy___0=Module["_emscripten_bind_BRepOffsetAPI_MakeOffset___destroy___0"]=function(){return(_emscripten_bind_BRepOffsetAPI_MakeOffset___destroy___0=Module["_emscripten_bind_BRepOffsetAPI_MakeOffset___destroy___0"]=Module["asm"]["QM"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakePrism_BRepPrimAPI_MakePrism_2=Module["_emscripten_bind_BRepPrimAPI_MakePrism_BRepPrimAPI_MakePrism_2"]=function(){return(_emscripten_bind_BRepPrimAPI_MakePrism_BRepPrimAPI_MakePrism_2=Module["_emscripten_bind_BRepPrimAPI_MakePrism_BRepPrimAPI_MakePrism_2"]=Module["asm"]["RM"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakePrism_BRepPrimAPI_MakePrism_3=Module["_emscripten_bind_BRepPrimAPI_MakePrism_BRepPrimAPI_MakePrism_3"]=function(){return(_emscripten_bind_BRepPrimAPI_MakePrism_BRepPrimAPI_MakePrism_3=Module["_emscripten_bind_BRepPrimAPI_MakePrism_BRepPrimAPI_MakePrism_3"]=Module["asm"]["SM"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakePrism_BRepPrimAPI_MakePrism_4=Module["_emscripten_bind_BRepPrimAPI_MakePrism_BRepPrimAPI_MakePrism_4"]=function(){return(_emscripten_bind_BRepPrimAPI_MakePrism_BRepPrimAPI_MakePrism_4=Module["_emscripten_bind_BRepPrimAPI_MakePrism_BRepPrimAPI_MakePrism_4"]=Module["asm"]["TM"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakePrism_Build_0=Module["_emscripten_bind_BRepPrimAPI_MakePrism_Build_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakePrism_Build_0=Module["_emscripten_bind_BRepPrimAPI_MakePrism_Build_0"]=Module["asm"]["UM"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakePrism_Generated_1=Module["_emscripten_bind_BRepPrimAPI_MakePrism_Generated_1"]=function(){return(_emscripten_bind_BRepPrimAPI_MakePrism_Generated_1=Module["_emscripten_bind_BRepPrimAPI_MakePrism_Generated_1"]=Module["asm"]["VM"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakePrism_IsDeleted_1=Module["_emscripten_bind_BRepPrimAPI_MakePrism_IsDeleted_1"]=function(){return(_emscripten_bind_BRepPrimAPI_MakePrism_IsDeleted_1=Module["_emscripten_bind_BRepPrimAPI_MakePrism_IsDeleted_1"]=Module["asm"]["WM"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakePrism_FirstShape_1=Module["_emscripten_bind_BRepPrimAPI_MakePrism_FirstShape_1"]=function(){return(_emscripten_bind_BRepPrimAPI_MakePrism_FirstShape_1=Module["_emscripten_bind_BRepPrimAPI_MakePrism_FirstShape_1"]=Module["asm"]["XM"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakePrism_LastShape_1=Module["_emscripten_bind_BRepPrimAPI_MakePrism_LastShape_1"]=function(){return(_emscripten_bind_BRepPrimAPI_MakePrism_LastShape_1=Module["_emscripten_bind_BRepPrimAPI_MakePrism_LastShape_1"]=Module["asm"]["YM"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakePrism_Shape_0=Module["_emscripten_bind_BRepPrimAPI_MakePrism_Shape_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakePrism_Shape_0=Module["_emscripten_bind_BRepPrimAPI_MakePrism_Shape_0"]=Module["asm"]["ZM"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakePrism___destroy___0=Module["_emscripten_bind_BRepPrimAPI_MakePrism___destroy___0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakePrism___destroy___0=Module["_emscripten_bind_BRepPrimAPI_MakePrism___destroy___0"]=Module["asm"]["_M"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Transform_BRepBuilderAPI_Transform_2=Module["_emscripten_bind_BRepBuilderAPI_Transform_BRepBuilderAPI_Transform_2"]=function(){return(_emscripten_bind_BRepBuilderAPI_Transform_BRepBuilderAPI_Transform_2=Module["_emscripten_bind_BRepBuilderAPI_Transform_BRepBuilderAPI_Transform_2"]=Module["asm"]["$M"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Transform_BRepBuilderAPI_Transform_3=Module["_emscripten_bind_BRepBuilderAPI_Transform_BRepBuilderAPI_Transform_3"]=function(){return(_emscripten_bind_BRepBuilderAPI_Transform_BRepBuilderAPI_Transform_3=Module["_emscripten_bind_BRepBuilderAPI_Transform_BRepBuilderAPI_Transform_3"]=Module["asm"]["aN"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Transform_Shape_0=Module["_emscripten_bind_BRepBuilderAPI_Transform_Shape_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_Transform_Shape_0=Module["_emscripten_bind_BRepBuilderAPI_Transform_Shape_0"]=Module["asm"]["bN"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_Transform___destroy___0=Module["_emscripten_bind_BRepBuilderAPI_Transform___destroy___0"]=function(){return(_emscripten_bind_BRepBuilderAPI_Transform___destroy___0=Module["_emscripten_bind_BRepBuilderAPI_Transform___destroy___0"]=Module["asm"]["cN"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeVertex_BRepBuilderAPI_MakeVertex_1=Module["_emscripten_bind_BRepBuilderAPI_MakeVertex_BRepBuilderAPI_MakeVertex_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeVertex_BRepBuilderAPI_MakeVertex_1=Module["_emscripten_bind_BRepBuilderAPI_MakeVertex_BRepBuilderAPI_MakeVertex_1"]=Module["asm"]["dN"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeVertex_Vertex_0=Module["_emscripten_bind_BRepBuilderAPI_MakeVertex_Vertex_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeVertex_Vertex_0=Module["_emscripten_bind_BRepBuilderAPI_MakeVertex_Vertex_0"]=Module["asm"]["eN"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeVertex_Shape_0=Module["_emscripten_bind_BRepBuilderAPI_MakeVertex_Shape_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeVertex_Shape_0=Module["_emscripten_bind_BRepBuilderAPI_MakeVertex_Shape_0"]=Module["asm"]["fN"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeVertex___destroy___0=Module["_emscripten_bind_BRepBuilderAPI_MakeVertex___destroy___0"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeVertex___destroy___0=Module["_emscripten_bind_BRepBuilderAPI_MakeVertex___destroy___0"]=Module["asm"]["gN"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Curve_BRepAdaptor_Curve_0=Module["_emscripten_bind_BRepAdaptor_Curve_BRepAdaptor_Curve_0"]=function(){return(_emscripten_bind_BRepAdaptor_Curve_BRepAdaptor_Curve_0=Module["_emscripten_bind_BRepAdaptor_Curve_BRepAdaptor_Curve_0"]=Module["asm"]["hN"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Curve_BRepAdaptor_Curve_1=Module["_emscripten_bind_BRepAdaptor_Curve_BRepAdaptor_Curve_1"]=function(){return(_emscripten_bind_BRepAdaptor_Curve_BRepAdaptor_Curve_1=Module["_emscripten_bind_BRepAdaptor_Curve_BRepAdaptor_Curve_1"]=Module["asm"]["iN"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Curve_BRepAdaptor_Curve_2=Module["_emscripten_bind_BRepAdaptor_Curve_BRepAdaptor_Curve_2"]=function(){return(_emscripten_bind_BRepAdaptor_Curve_BRepAdaptor_Curve_2=Module["_emscripten_bind_BRepAdaptor_Curve_BRepAdaptor_Curve_2"]=Module["asm"]["jN"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Curve_Reset_0=Module["_emscripten_bind_BRepAdaptor_Curve_Reset_0"]=function(){return(_emscripten_bind_BRepAdaptor_Curve_Reset_0=Module["_emscripten_bind_BRepAdaptor_Curve_Reset_0"]=Module["asm"]["kN"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Curve_Initialize_1=Module["_emscripten_bind_BRepAdaptor_Curve_Initialize_1"]=function(){return(_emscripten_bind_BRepAdaptor_Curve_Initialize_1=Module["_emscripten_bind_BRepAdaptor_Curve_Initialize_1"]=Module["asm"]["lN"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Curve_Initialize_2=Module["_emscripten_bind_BRepAdaptor_Curve_Initialize_2"]=function(){return(_emscripten_bind_BRepAdaptor_Curve_Initialize_2=Module["_emscripten_bind_BRepAdaptor_Curve_Initialize_2"]=Module["asm"]["mN"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Curve_Trsf_0=Module["_emscripten_bind_BRepAdaptor_Curve_Trsf_0"]=function(){return(_emscripten_bind_BRepAdaptor_Curve_Trsf_0=Module["_emscripten_bind_BRepAdaptor_Curve_Trsf_0"]=Module["asm"]["nN"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Curve_Is3DCurve_0=Module["_emscripten_bind_BRepAdaptor_Curve_Is3DCurve_0"]=function(){return(_emscripten_bind_BRepAdaptor_Curve_Is3DCurve_0=Module["_emscripten_bind_BRepAdaptor_Curve_Is3DCurve_0"]=Module["asm"]["oN"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Curve_IsCurveOnSurface_0=Module["_emscripten_bind_BRepAdaptor_Curve_IsCurveOnSurface_0"]=function(){return(_emscripten_bind_BRepAdaptor_Curve_IsCurveOnSurface_0=Module["_emscripten_bind_BRepAdaptor_Curve_IsCurveOnSurface_0"]=Module["asm"]["pN"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Curve_Edge_0=Module["_emscripten_bind_BRepAdaptor_Curve_Edge_0"]=function(){return(_emscripten_bind_BRepAdaptor_Curve_Edge_0=Module["_emscripten_bind_BRepAdaptor_Curve_Edge_0"]=Module["asm"]["qN"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Curve_Tolerance_0=Module["_emscripten_bind_BRepAdaptor_Curve_Tolerance_0"]=function(){return(_emscripten_bind_BRepAdaptor_Curve_Tolerance_0=Module["_emscripten_bind_BRepAdaptor_Curve_Tolerance_0"]=Module["asm"]["rN"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Curve_FirstParameter_0=Module["_emscripten_bind_BRepAdaptor_Curve_FirstParameter_0"]=function(){return(_emscripten_bind_BRepAdaptor_Curve_FirstParameter_0=Module["_emscripten_bind_BRepAdaptor_Curve_FirstParameter_0"]=Module["asm"]["sN"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Curve_LastParameter_0=Module["_emscripten_bind_BRepAdaptor_Curve_LastParameter_0"]=function(){return(_emscripten_bind_BRepAdaptor_Curve_LastParameter_0=Module["_emscripten_bind_BRepAdaptor_Curve_LastParameter_0"]=Module["asm"]["tN"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Curve_IsClosed_0=Module["_emscripten_bind_BRepAdaptor_Curve_IsClosed_0"]=function(){return(_emscripten_bind_BRepAdaptor_Curve_IsClosed_0=Module["_emscripten_bind_BRepAdaptor_Curve_IsClosed_0"]=Module["asm"]["uN"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Curve_IsPeriodic_0=Module["_emscripten_bind_BRepAdaptor_Curve_IsPeriodic_0"]=function(){return(_emscripten_bind_BRepAdaptor_Curve_IsPeriodic_0=Module["_emscripten_bind_BRepAdaptor_Curve_IsPeriodic_0"]=Module["asm"]["vN"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Curve_Period_0=Module["_emscripten_bind_BRepAdaptor_Curve_Period_0"]=function(){return(_emscripten_bind_BRepAdaptor_Curve_Period_0=Module["_emscripten_bind_BRepAdaptor_Curve_Period_0"]=Module["asm"]["wN"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Curve_Value_1=Module["_emscripten_bind_BRepAdaptor_Curve_Value_1"]=function(){return(_emscripten_bind_BRepAdaptor_Curve_Value_1=Module["_emscripten_bind_BRepAdaptor_Curve_Value_1"]=Module["asm"]["xN"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Curve_D0_2=Module["_emscripten_bind_BRepAdaptor_Curve_D0_2"]=function(){return(_emscripten_bind_BRepAdaptor_Curve_D0_2=Module["_emscripten_bind_BRepAdaptor_Curve_D0_2"]=Module["asm"]["yN"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Curve_D1_3=Module["_emscripten_bind_BRepAdaptor_Curve_D1_3"]=function(){return(_emscripten_bind_BRepAdaptor_Curve_D1_3=Module["_emscripten_bind_BRepAdaptor_Curve_D1_3"]=Module["asm"]["zN"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Curve_D2_4=Module["_emscripten_bind_BRepAdaptor_Curve_D2_4"]=function(){return(_emscripten_bind_BRepAdaptor_Curve_D2_4=Module["_emscripten_bind_BRepAdaptor_Curve_D2_4"]=Module["asm"]["AN"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Curve_D3_5=Module["_emscripten_bind_BRepAdaptor_Curve_D3_5"]=function(){return(_emscripten_bind_BRepAdaptor_Curve_D3_5=Module["_emscripten_bind_BRepAdaptor_Curve_D3_5"]=Module["asm"]["BN"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Curve_DN_2=Module["_emscripten_bind_BRepAdaptor_Curve_DN_2"]=function(){return(_emscripten_bind_BRepAdaptor_Curve_DN_2=Module["_emscripten_bind_BRepAdaptor_Curve_DN_2"]=Module["asm"]["CN"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Curve_Resolution_1=Module["_emscripten_bind_BRepAdaptor_Curve_Resolution_1"]=function(){return(_emscripten_bind_BRepAdaptor_Curve_Resolution_1=Module["_emscripten_bind_BRepAdaptor_Curve_Resolution_1"]=Module["asm"]["DN"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Curve_Line_0=Module["_emscripten_bind_BRepAdaptor_Curve_Line_0"]=function(){return(_emscripten_bind_BRepAdaptor_Curve_Line_0=Module["_emscripten_bind_BRepAdaptor_Curve_Line_0"]=Module["asm"]["EN"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Curve_Circle_0=Module["_emscripten_bind_BRepAdaptor_Curve_Circle_0"]=function(){return(_emscripten_bind_BRepAdaptor_Curve_Circle_0=Module["_emscripten_bind_BRepAdaptor_Curve_Circle_0"]=Module["asm"]["FN"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Curve_Degree_0=Module["_emscripten_bind_BRepAdaptor_Curve_Degree_0"]=function(){return(_emscripten_bind_BRepAdaptor_Curve_Degree_0=Module["_emscripten_bind_BRepAdaptor_Curve_Degree_0"]=Module["asm"]["GN"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Curve_IsRational_0=Module["_emscripten_bind_BRepAdaptor_Curve_IsRational_0"]=function(){return(_emscripten_bind_BRepAdaptor_Curve_IsRational_0=Module["_emscripten_bind_BRepAdaptor_Curve_IsRational_0"]=Module["asm"]["HN"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Curve_NbPoles_0=Module["_emscripten_bind_BRepAdaptor_Curve_NbPoles_0"]=function(){return(_emscripten_bind_BRepAdaptor_Curve_NbPoles_0=Module["_emscripten_bind_BRepAdaptor_Curve_NbPoles_0"]=Module["asm"]["IN"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Curve_NbKnots_0=Module["_emscripten_bind_BRepAdaptor_Curve_NbKnots_0"]=function(){return(_emscripten_bind_BRepAdaptor_Curve_NbKnots_0=Module["_emscripten_bind_BRepAdaptor_Curve_NbKnots_0"]=Module["asm"]["JN"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Curve_Bezier_0=Module["_emscripten_bind_BRepAdaptor_Curve_Bezier_0"]=function(){return(_emscripten_bind_BRepAdaptor_Curve_Bezier_0=Module["_emscripten_bind_BRepAdaptor_Curve_Bezier_0"]=Module["asm"]["KN"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Curve_BSpline_0=Module["_emscripten_bind_BRepAdaptor_Curve_BSpline_0"]=function(){return(_emscripten_bind_BRepAdaptor_Curve_BSpline_0=Module["_emscripten_bind_BRepAdaptor_Curve_BSpline_0"]=Module["asm"]["LN"]).apply(null,arguments)};var _emscripten_bind_BRepAdaptor_Curve___destroy___0=Module["_emscripten_bind_BRepAdaptor_Curve___destroy___0"]=function(){return(_emscripten_bind_BRepAdaptor_Curve___destroy___0=Module["_emscripten_bind_BRepAdaptor_Curve___destroy___0"]=Module["asm"]["MN"]).apply(null,arguments)};var _emscripten_bind_gp_Pnt2d_gp_Pnt2d_0=Module["_emscripten_bind_gp_Pnt2d_gp_Pnt2d_0"]=function(){return(_emscripten_bind_gp_Pnt2d_gp_Pnt2d_0=Module["_emscripten_bind_gp_Pnt2d_gp_Pnt2d_0"]=Module["asm"]["NN"]).apply(null,arguments)};var _emscripten_bind_gp_Pnt2d_gp_Pnt2d_2=Module["_emscripten_bind_gp_Pnt2d_gp_Pnt2d_2"]=function(){return(_emscripten_bind_gp_Pnt2d_gp_Pnt2d_2=Module["_emscripten_bind_gp_Pnt2d_gp_Pnt2d_2"]=Module["asm"]["ON"]).apply(null,arguments)};var _emscripten_bind_gp_Pnt2d_X_0=Module["_emscripten_bind_gp_Pnt2d_X_0"]=function(){return(_emscripten_bind_gp_Pnt2d_X_0=Module["_emscripten_bind_gp_Pnt2d_X_0"]=Module["asm"]["PN"]).apply(null,arguments)};var _emscripten_bind_gp_Pnt2d_Y_0=Module["_emscripten_bind_gp_Pnt2d_Y_0"]=function(){return(_emscripten_bind_gp_Pnt2d_Y_0=Module["_emscripten_bind_gp_Pnt2d_Y_0"]=Module["asm"]["QN"]).apply(null,arguments)};var _emscripten_bind_gp_Pnt2d___destroy___0=Module["_emscripten_bind_gp_Pnt2d___destroy___0"]=function(){return(_emscripten_bind_gp_Pnt2d___destroy___0=Module["_emscripten_bind_gp_Pnt2d___destroy___0"]=Module["asm"]["RN"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeWire_BRepBuilderAPI_MakeWire_0=Module["_emscripten_bind_BRepBuilderAPI_MakeWire_BRepBuilderAPI_MakeWire_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeWire_BRepBuilderAPI_MakeWire_0=Module["_emscripten_bind_BRepBuilderAPI_MakeWire_BRepBuilderAPI_MakeWire_0"]=Module["asm"]["SN"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeWire_BRepBuilderAPI_MakeWire_1=Module["_emscripten_bind_BRepBuilderAPI_MakeWire_BRepBuilderAPI_MakeWire_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeWire_BRepBuilderAPI_MakeWire_1=Module["_emscripten_bind_BRepBuilderAPI_MakeWire_BRepBuilderAPI_MakeWire_1"]=Module["asm"]["TN"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeWire_BRepBuilderAPI_MakeWire_2=Module["_emscripten_bind_BRepBuilderAPI_MakeWire_BRepBuilderAPI_MakeWire_2"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeWire_BRepBuilderAPI_MakeWire_2=Module["_emscripten_bind_BRepBuilderAPI_MakeWire_BRepBuilderAPI_MakeWire_2"]=Module["asm"]["UN"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeWire_BRepBuilderAPI_MakeWire_3=Module["_emscripten_bind_BRepBuilderAPI_MakeWire_BRepBuilderAPI_MakeWire_3"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeWire_BRepBuilderAPI_MakeWire_3=Module["_emscripten_bind_BRepBuilderAPI_MakeWire_BRepBuilderAPI_MakeWire_3"]=Module["asm"]["VN"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeWire_Add_1=Module["_emscripten_bind_BRepBuilderAPI_MakeWire_Add_1"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeWire_Add_1=Module["_emscripten_bind_BRepBuilderAPI_MakeWire_Add_1"]=Module["asm"]["WN"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeWire_Wire_0=Module["_emscripten_bind_BRepBuilderAPI_MakeWire_Wire_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeWire_Wire_0=Module["_emscripten_bind_BRepBuilderAPI_MakeWire_Wire_0"]=Module["asm"]["XN"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeWire_Shape_0=Module["_emscripten_bind_BRepBuilderAPI_MakeWire_Shape_0"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeWire_Shape_0=Module["_emscripten_bind_BRepBuilderAPI_MakeWire_Shape_0"]=Module["asm"]["YN"]).apply(null,arguments)};var _emscripten_bind_BRepBuilderAPI_MakeWire___destroy___0=Module["_emscripten_bind_BRepBuilderAPI_MakeWire___destroy___0"]=function(){return(_emscripten_bind_BRepBuilderAPI_MakeWire___destroy___0=Module["_emscripten_bind_BRepBuilderAPI_MakeWire___destroy___0"]=Module["asm"]["ZN"]).apply(null,arguments)};var _emscripten_bind_StdPrs_ToolTriangulatedShape_StdPrs_ToolTriangulatedShape_0=Module["_emscripten_bind_StdPrs_ToolTriangulatedShape_StdPrs_ToolTriangulatedShape_0"]=function(){return(_emscripten_bind_StdPrs_ToolTriangulatedShape_StdPrs_ToolTriangulatedShape_0=Module["_emscripten_bind_StdPrs_ToolTriangulatedShape_StdPrs_ToolTriangulatedShape_0"]=Module["asm"]["_N"]).apply(null,arguments)};var _emscripten_bind_StdPrs_ToolTriangulatedShape_IsTriangulated_1=Module["_emscripten_bind_StdPrs_ToolTriangulatedShape_IsTriangulated_1"]=function(){return(_emscripten_bind_StdPrs_ToolTriangulatedShape_IsTriangulated_1=Module["_emscripten_bind_StdPrs_ToolTriangulatedShape_IsTriangulated_1"]=Module["asm"]["$N"]).apply(null,arguments)};var _emscripten_bind_StdPrs_ToolTriangulatedShape_IsClosed_1=Module["_emscripten_bind_StdPrs_ToolTriangulatedShape_IsClosed_1"]=function(){return(_emscripten_bind_StdPrs_ToolTriangulatedShape_IsClosed_1=Module["_emscripten_bind_StdPrs_ToolTriangulatedShape_IsClosed_1"]=Module["asm"]["aO"]).apply(null,arguments)};var _emscripten_bind_StdPrs_ToolTriangulatedShape_ComputeNormals_2=Module["_emscripten_bind_StdPrs_ToolTriangulatedShape_ComputeNormals_2"]=function(){return(_emscripten_bind_StdPrs_ToolTriangulatedShape_ComputeNormals_2=Module["_emscripten_bind_StdPrs_ToolTriangulatedShape_ComputeNormals_2"]=Module["asm"]["bO"]).apply(null,arguments)};var _emscripten_bind_StdPrs_ToolTriangulatedShape_ComputeNormals_3=Module["_emscripten_bind_StdPrs_ToolTriangulatedShape_ComputeNormals_3"]=function(){return(_emscripten_bind_StdPrs_ToolTriangulatedShape_ComputeNormals_3=Module["_emscripten_bind_StdPrs_ToolTriangulatedShape_ComputeNormals_3"]=Module["asm"]["cO"]).apply(null,arguments)};var _emscripten_bind_StdPrs_ToolTriangulatedShape_Normal_3=Module["_emscripten_bind_StdPrs_ToolTriangulatedShape_Normal_3"]=function(){return(_emscripten_bind_StdPrs_ToolTriangulatedShape_Normal_3=Module["_emscripten_bind_StdPrs_ToolTriangulatedShape_Normal_3"]=Module["asm"]["dO"]).apply(null,arguments)};var _emscripten_bind_StdPrs_ToolTriangulatedShape___destroy___0=Module["_emscripten_bind_StdPrs_ToolTriangulatedShape___destroy___0"]=function(){return(_emscripten_bind_StdPrs_ToolTriangulatedShape___destroy___0=Module["_emscripten_bind_StdPrs_ToolTriangulatedShape___destroy___0"]=Module["asm"]["eO"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeTorus_BRepPrimAPI_MakeTorus_3=Module["_emscripten_bind_BRepPrimAPI_MakeTorus_BRepPrimAPI_MakeTorus_3"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeTorus_BRepPrimAPI_MakeTorus_3=Module["_emscripten_bind_BRepPrimAPI_MakeTorus_BRepPrimAPI_MakeTorus_3"]=Module["asm"]["fO"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeTorus_BRepPrimAPI_MakeTorus_4=Module["_emscripten_bind_BRepPrimAPI_MakeTorus_BRepPrimAPI_MakeTorus_4"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeTorus_BRepPrimAPI_MakeTorus_4=Module["_emscripten_bind_BRepPrimAPI_MakeTorus_BRepPrimAPI_MakeTorus_4"]=Module["asm"]["gO"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeTorus_BRepPrimAPI_MakeTorus_5=Module["_emscripten_bind_BRepPrimAPI_MakeTorus_BRepPrimAPI_MakeTorus_5"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeTorus_BRepPrimAPI_MakeTorus_5=Module["_emscripten_bind_BRepPrimAPI_MakeTorus_BRepPrimAPI_MakeTorus_5"]=Module["asm"]["hO"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeTorus_BRepPrimAPI_MakeTorus_6=Module["_emscripten_bind_BRepPrimAPI_MakeTorus_BRepPrimAPI_MakeTorus_6"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeTorus_BRepPrimAPI_MakeTorus_6=Module["_emscripten_bind_BRepPrimAPI_MakeTorus_BRepPrimAPI_MakeTorus_6"]=Module["asm"]["iO"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeTorus_Shape_0=Module["_emscripten_bind_BRepPrimAPI_MakeTorus_Shape_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeTorus_Shape_0=Module["_emscripten_bind_BRepPrimAPI_MakeTorus_Shape_0"]=Module["asm"]["jO"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeTorus_Build_0=Module["_emscripten_bind_BRepPrimAPI_MakeTorus_Build_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeTorus_Build_0=Module["_emscripten_bind_BRepPrimAPI_MakeTorus_Build_0"]=Module["asm"]["kO"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeTorus_Face_0=Module["_emscripten_bind_BRepPrimAPI_MakeTorus_Face_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeTorus_Face_0=Module["_emscripten_bind_BRepPrimAPI_MakeTorus_Face_0"]=Module["asm"]["lO"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeTorus_Shell_0=Module["_emscripten_bind_BRepPrimAPI_MakeTorus_Shell_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeTorus_Shell_0=Module["_emscripten_bind_BRepPrimAPI_MakeTorus_Shell_0"]=Module["asm"]["mO"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeTorus_Solid_0=Module["_emscripten_bind_BRepPrimAPI_MakeTorus_Solid_0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeTorus_Solid_0=Module["_emscripten_bind_BRepPrimAPI_MakeTorus_Solid_0"]=Module["asm"]["nO"]).apply(null,arguments)};var _emscripten_bind_BRepPrimAPI_MakeTorus___destroy___0=Module["_emscripten_bind_BRepPrimAPI_MakeTorus___destroy___0"]=function(){return(_emscripten_bind_BRepPrimAPI_MakeTorus___destroy___0=Module["_emscripten_bind_BRepPrimAPI_MakeTorus___destroy___0"]=Module["asm"]["oO"]).apply(null,arguments)};var _emscripten_bind_BRepFilletAPI_MakeFillet_BRepFilletAPI_MakeFillet_1=Module["_emscripten_bind_BRepFilletAPI_MakeFillet_BRepFilletAPI_MakeFillet_1"]=function(){return(_emscripten_bind_BRepFilletAPI_MakeFillet_BRepFilletAPI_MakeFillet_1=Module["_emscripten_bind_BRepFilletAPI_MakeFillet_BRepFilletAPI_MakeFillet_1"]=Module["asm"]["pO"]).apply(null,arguments)};var _emscripten_bind_BRepFilletAPI_MakeFillet_Add_2=Module["_emscripten_bind_BRepFilletAPI_MakeFillet_Add_2"]=function(){return(_emscripten_bind_BRepFilletAPI_MakeFillet_Add_2=Module["_emscripten_bind_BRepFilletAPI_MakeFillet_Add_2"]=Module["asm"]["qO"]).apply(null,arguments)};var _emscripten_bind_BRepFilletAPI_MakeFillet_Shape_0=Module["_emscripten_bind_BRepFilletAPI_MakeFillet_Shape_0"]=function(){return(_emscripten_bind_BRepFilletAPI_MakeFillet_Shape_0=Module["_emscripten_bind_BRepFilletAPI_MakeFillet_Shape_0"]=Module["asm"]["rO"]).apply(null,arguments)};var _emscripten_bind_BRepFilletAPI_MakeFillet___destroy___0=Module["_emscripten_bind_BRepFilletAPI_MakeFillet___destroy___0"]=function(){return(_emscripten_bind_BRepFilletAPI_MakeFillet___destroy___0=Module["_emscripten_bind_BRepFilletAPI_MakeFillet___destroy___0"]=Module["asm"]["sO"]).apply(null,arguments)};var _emscripten_bind_STEPControl_Reader_STEPControl_Reader_0=Module["_emscripten_bind_STEPControl_Reader_STEPControl_Reader_0"]=function(){return(_emscripten_bind_STEPControl_Reader_STEPControl_Reader_0=Module["_emscripten_bind_STEPControl_Reader_STEPControl_Reader_0"]=Module["asm"]["tO"]).apply(null,arguments)};var _emscripten_bind_STEPControl_Reader_SetNorm_1=Module["_emscripten_bind_STEPControl_Reader_SetNorm_1"]=function(){return(_emscripten_bind_STEPControl_Reader_SetNorm_1=Module["_emscripten_bind_STEPControl_Reader_SetNorm_1"]=Module["asm"]["uO"]).apply(null,arguments)};var _emscripten_bind_STEPControl_Reader_SetWS_1=Module["_emscripten_bind_STEPControl_Reader_SetWS_1"]=function(){return(_emscripten_bind_STEPControl_Reader_SetWS_1=Module["_emscripten_bind_STEPControl_Reader_SetWS_1"]=Module["asm"]["vO"]).apply(null,arguments)};var _emscripten_bind_STEPControl_Reader_SetWS_2=Module["_emscripten_bind_STEPControl_Reader_SetWS_2"]=function(){return(_emscripten_bind_STEPControl_Reader_SetWS_2=Module["_emscripten_bind_STEPControl_Reader_SetWS_2"]=Module["asm"]["wO"]).apply(null,arguments)};var _emscripten_bind_STEPControl_Reader_WS_0=Module["_emscripten_bind_STEPControl_Reader_WS_0"]=function(){return(_emscripten_bind_STEPControl_Reader_WS_0=Module["_emscripten_bind_STEPControl_Reader_WS_0"]=Module["asm"]["xO"]).apply(null,arguments)};var _emscripten_bind_STEPControl_Reader_ReadFile_1=Module["_emscripten_bind_STEPControl_Reader_ReadFile_1"]=function(){return(_emscripten_bind_STEPControl_Reader_ReadFile_1=Module["_emscripten_bind_STEPControl_Reader_ReadFile_1"]=Module["asm"]["yO"]).apply(null,arguments)};var _emscripten_bind_STEPControl_Reader_NbRootsForTransfer_0=Module["_emscripten_bind_STEPControl_Reader_NbRootsForTransfer_0"]=function(){return(_emscripten_bind_STEPControl_Reader_NbRootsForTransfer_0=Module["_emscripten_bind_STEPControl_Reader_NbRootsForTransfer_0"]=Module["asm"]["zO"]).apply(null,arguments)};var _emscripten_bind_STEPControl_Reader_TransferOneRoot_0=Module["_emscripten_bind_STEPControl_Reader_TransferOneRoot_0"]=function(){return(_emscripten_bind_STEPControl_Reader_TransferOneRoot_0=Module["_emscripten_bind_STEPControl_Reader_TransferOneRoot_0"]=Module["asm"]["AO"]).apply(null,arguments)};var _emscripten_bind_STEPControl_Reader_TransferOneRoot_1=Module["_emscripten_bind_STEPControl_Reader_TransferOneRoot_1"]=function(){return(_emscripten_bind_STEPControl_Reader_TransferOneRoot_1=Module["_emscripten_bind_STEPControl_Reader_TransferOneRoot_1"]=Module["asm"]["BO"]).apply(null,arguments)};var _emscripten_bind_STEPControl_Reader_TransferOne_1=Module["_emscripten_bind_STEPControl_Reader_TransferOne_1"]=function(){return(_emscripten_bind_STEPControl_Reader_TransferOne_1=Module["_emscripten_bind_STEPControl_Reader_TransferOne_1"]=Module["asm"]["CO"]).apply(null,arguments)};var _emscripten_bind_STEPControl_Reader_TransferRoots_0=Module["_emscripten_bind_STEPControl_Reader_TransferRoots_0"]=function(){return(_emscripten_bind_STEPControl_Reader_TransferRoots_0=Module["_emscripten_bind_STEPControl_Reader_TransferRoots_0"]=Module["asm"]["DO"]).apply(null,arguments)};var _emscripten_bind_STEPControl_Reader_ClearShapes_0=Module["_emscripten_bind_STEPControl_Reader_ClearShapes_0"]=function(){return(_emscripten_bind_STEPControl_Reader_ClearShapes_0=Module["_emscripten_bind_STEPControl_Reader_ClearShapes_0"]=Module["asm"]["EO"]).apply(null,arguments)};var _emscripten_bind_STEPControl_Reader_NbShapes_0=Module["_emscripten_bind_STEPControl_Reader_NbShapes_0"]=function(){return(_emscripten_bind_STEPControl_Reader_NbShapes_0=Module["_emscripten_bind_STEPControl_Reader_NbShapes_0"]=Module["asm"]["FO"]).apply(null,arguments)};var _emscripten_bind_STEPControl_Reader_Shape_0=Module["_emscripten_bind_STEPControl_Reader_Shape_0"]=function(){return(_emscripten_bind_STEPControl_Reader_Shape_0=Module["_emscripten_bind_STEPControl_Reader_Shape_0"]=Module["asm"]["GO"]).apply(null,arguments)};var _emscripten_bind_STEPControl_Reader_Shape_1=Module["_emscripten_bind_STEPControl_Reader_Shape_1"]=function(){return(_emscripten_bind_STEPControl_Reader_Shape_1=Module["_emscripten_bind_STEPControl_Reader_Shape_1"]=Module["asm"]["HO"]).apply(null,arguments)};var _emscripten_bind_STEPControl_Reader_OneShape_0=Module["_emscripten_bind_STEPControl_Reader_OneShape_0"]=function(){return(_emscripten_bind_STEPControl_Reader_OneShape_0=Module["_emscripten_bind_STEPControl_Reader_OneShape_0"]=Module["asm"]["IO"]).apply(null,arguments)};var _emscripten_bind_STEPControl_Reader_PrintStatsTransfer_1=Module["_emscripten_bind_STEPControl_Reader_PrintStatsTransfer_1"]=function(){return(_emscripten_bind_STEPControl_Reader_PrintStatsTransfer_1=Module["_emscripten_bind_STEPControl_Reader_PrintStatsTransfer_1"]=Module["asm"]["JO"]).apply(null,arguments)};var _emscripten_bind_STEPControl_Reader_PrintStatsTransfer_2=Module["_emscripten_bind_STEPControl_Reader_PrintStatsTransfer_2"]=function(){return(_emscripten_bind_STEPControl_Reader_PrintStatsTransfer_2=Module["_emscripten_bind_STEPControl_Reader_PrintStatsTransfer_2"]=Module["asm"]["KO"]).apply(null,arguments)};var _emscripten_bind_STEPControl_Reader___destroy___0=Module["_emscripten_bind_STEPControl_Reader___destroy___0"]=function(){return(_emscripten_bind_STEPControl_Reader___destroy___0=Module["_emscripten_bind_STEPControl_Reader___destroy___0"]=Module["asm"]["LO"]).apply(null,arguments)};var _emscripten_bind_Handle_Poly_Polygon3D_Handle_Poly_Polygon3D_0=Module["_emscripten_bind_Handle_Poly_Polygon3D_Handle_Poly_Polygon3D_0"]=function(){return(_emscripten_bind_Handle_Poly_Polygon3D_Handle_Poly_Polygon3D_0=Module["_emscripten_bind_Handle_Poly_Polygon3D_Handle_Poly_Polygon3D_0"]=Module["asm"]["MO"]).apply(null,arguments)};var _emscripten_bind_Handle_Poly_Polygon3D_Handle_Poly_Polygon3D_1=Module["_emscripten_bind_Handle_Poly_Polygon3D_Handle_Poly_Polygon3D_1"]=function(){return(_emscripten_bind_Handle_Poly_Polygon3D_Handle_Poly_Polygon3D_1=Module["_emscripten_bind_Handle_Poly_Polygon3D_Handle_Poly_Polygon3D_1"]=Module["asm"]["NO"]).apply(null,arguments)};var _emscripten_bind_Handle_Poly_Polygon3D_IsNull_0=Module["_emscripten_bind_Handle_Poly_Polygon3D_IsNull_0"]=function(){return(_emscripten_bind_Handle_Poly_Polygon3D_IsNull_0=Module["_emscripten_bind_Handle_Poly_Polygon3D_IsNull_0"]=Module["asm"]["OO"]).apply(null,arguments)};var _emscripten_bind_Handle_Poly_Polygon3D_Nullify_0=Module["_emscripten_bind_Handle_Poly_Polygon3D_Nullify_0"]=function(){return(_emscripten_bind_Handle_Poly_Polygon3D_Nullify_0=Module["_emscripten_bind_Handle_Poly_Polygon3D_Nullify_0"]=Module["asm"]["PO"]).apply(null,arguments)};var _emscripten_bind_Handle_Poly_Polygon3D_get_0=Module["_emscripten_bind_Handle_Poly_Polygon3D_get_0"]=function(){return(_emscripten_bind_Handle_Poly_Polygon3D_get_0=Module["_emscripten_bind_Handle_Poly_Polygon3D_get_0"]=Module["asm"]["QO"]).apply(null,arguments)};var _emscripten_bind_Handle_Poly_Polygon3D___destroy___0=Module["_emscripten_bind_Handle_Poly_Polygon3D___destroy___0"]=function(){return(_emscripten_bind_Handle_Poly_Polygon3D___destroy___0=Module["_emscripten_bind_Handle_Poly_Polygon3D___destroy___0"]=Module["asm"]["RO"]).apply(null,arguments)};var _emscripten_bind_Geom_Circle_Geom_Circle_1=Module["_emscripten_bind_Geom_Circle_Geom_Circle_1"]=function(){return(_emscripten_bind_Geom_Circle_Geom_Circle_1=Module["_emscripten_bind_Geom_Circle_Geom_Circle_1"]=Module["asm"]["SO"]).apply(null,arguments)};var _emscripten_bind_Geom_Circle_Geom_Circle_2=Module["_emscripten_bind_Geom_Circle_Geom_Circle_2"]=function(){return(_emscripten_bind_Geom_Circle_Geom_Circle_2=Module["_emscripten_bind_Geom_Circle_Geom_Circle_2"]=Module["asm"]["TO"]).apply(null,arguments)};var _emscripten_bind_Geom_Circle_Radius_0=Module["_emscripten_bind_Geom_Circle_Radius_0"]=function(){return(_emscripten_bind_Geom_Circle_Radius_0=Module["_emscripten_bind_Geom_Circle_Radius_0"]=Module["asm"]["UO"]).apply(null,arguments)};var _emscripten_bind_Geom_Circle_Reverse_0=Module["_emscripten_bind_Geom_Circle_Reverse_0"]=function(){return(_emscripten_bind_Geom_Circle_Reverse_0=Module["_emscripten_bind_Geom_Circle_Reverse_0"]=Module["asm"]["VO"]).apply(null,arguments)};var _emscripten_bind_Geom_Circle_ReversedParameter_1=Module["_emscripten_bind_Geom_Circle_ReversedParameter_1"]=function(){return(_emscripten_bind_Geom_Circle_ReversedParameter_1=Module["_emscripten_bind_Geom_Circle_ReversedParameter_1"]=Module["asm"]["WO"]).apply(null,arguments)};var _emscripten_bind_Geom_Circle_TransformedParameter_2=Module["_emscripten_bind_Geom_Circle_TransformedParameter_2"]=function(){return(_emscripten_bind_Geom_Circle_TransformedParameter_2=Module["_emscripten_bind_Geom_Circle_TransformedParameter_2"]=Module["asm"]["XO"]).apply(null,arguments)};var _emscripten_bind_Geom_Circle_ParametricTransformation_1=Module["_emscripten_bind_Geom_Circle_ParametricTransformation_1"]=function(){return(_emscripten_bind_Geom_Circle_ParametricTransformation_1=Module["_emscripten_bind_Geom_Circle_ParametricTransformation_1"]=Module["asm"]["YO"]).apply(null,arguments)};var _emscripten_bind_Geom_Circle_Reversed_0=Module["_emscripten_bind_Geom_Circle_Reversed_0"]=function(){return(_emscripten_bind_Geom_Circle_Reversed_0=Module["_emscripten_bind_Geom_Circle_Reversed_0"]=Module["asm"]["ZO"]).apply(null,arguments)};var _emscripten_bind_Geom_Circle_FirstParameter_0=Module["_emscripten_bind_Geom_Circle_FirstParameter_0"]=function(){return(_emscripten_bind_Geom_Circle_FirstParameter_0=Module["_emscripten_bind_Geom_Circle_FirstParameter_0"]=Module["asm"]["_O"]).apply(null,arguments)};var _emscripten_bind_Geom_Circle_LastParameter_0=Module["_emscripten_bind_Geom_Circle_LastParameter_0"]=function(){return(_emscripten_bind_Geom_Circle_LastParameter_0=Module["_emscripten_bind_Geom_Circle_LastParameter_0"]=Module["asm"]["$O"]).apply(null,arguments)};var _emscripten_bind_Geom_Circle_IsClosed_0=Module["_emscripten_bind_Geom_Circle_IsClosed_0"]=function(){return(_emscripten_bind_Geom_Circle_IsClosed_0=Module["_emscripten_bind_Geom_Circle_IsClosed_0"]=Module["asm"]["aP"]).apply(null,arguments)};var _emscripten_bind_Geom_Circle_IsPeriodic_0=Module["_emscripten_bind_Geom_Circle_IsPeriodic_0"]=function(){return(_emscripten_bind_Geom_Circle_IsPeriodic_0=Module["_emscripten_bind_Geom_Circle_IsPeriodic_0"]=Module["asm"]["bP"]).apply(null,arguments)};var _emscripten_bind_Geom_Circle_Period_0=Module["_emscripten_bind_Geom_Circle_Period_0"]=function(){return(_emscripten_bind_Geom_Circle_Period_0=Module["_emscripten_bind_Geom_Circle_Period_0"]=Module["asm"]["cP"]).apply(null,arguments)};var _emscripten_bind_Geom_Circle_IsCN_1=Module["_emscripten_bind_Geom_Circle_IsCN_1"]=function(){return(_emscripten_bind_Geom_Circle_IsCN_1=Module["_emscripten_bind_Geom_Circle_IsCN_1"]=Module["asm"]["dP"]).apply(null,arguments)};var _emscripten_bind_Geom_Circle_D0_2=Module["_emscripten_bind_Geom_Circle_D0_2"]=function(){return(_emscripten_bind_Geom_Circle_D0_2=Module["_emscripten_bind_Geom_Circle_D0_2"]=Module["asm"]["eP"]).apply(null,arguments)};var _emscripten_bind_Geom_Circle_D1_3=Module["_emscripten_bind_Geom_Circle_D1_3"]=function(){return(_emscripten_bind_Geom_Circle_D1_3=Module["_emscripten_bind_Geom_Circle_D1_3"]=Module["asm"]["fP"]).apply(null,arguments)};var _emscripten_bind_Geom_Circle_D2_4=Module["_emscripten_bind_Geom_Circle_D2_4"]=function(){return(_emscripten_bind_Geom_Circle_D2_4=Module["_emscripten_bind_Geom_Circle_D2_4"]=Module["asm"]["gP"]).apply(null,arguments)};var _emscripten_bind_Geom_Circle_D3_5=Module["_emscripten_bind_Geom_Circle_D3_5"]=function(){return(_emscripten_bind_Geom_Circle_D3_5=Module["_emscripten_bind_Geom_Circle_D3_5"]=Module["asm"]["hP"]).apply(null,arguments)};var _emscripten_bind_Geom_Circle_DN_2=Module["_emscripten_bind_Geom_Circle_DN_2"]=function(){return(_emscripten_bind_Geom_Circle_DN_2=Module["_emscripten_bind_Geom_Circle_DN_2"]=Module["asm"]["iP"]).apply(null,arguments)};var _emscripten_bind_Geom_Circle_Value_1=Module["_emscripten_bind_Geom_Circle_Value_1"]=function(){return(_emscripten_bind_Geom_Circle_Value_1=Module["_emscripten_bind_Geom_Circle_Value_1"]=Module["asm"]["jP"]).apply(null,arguments)};var _emscripten_bind_Geom_Circle___destroy___0=Module["_emscripten_bind_Geom_Circle___destroy___0"]=function(){return(_emscripten_bind_Geom_Circle___destroy___0=Module["_emscripten_bind_Geom_Circle___destroy___0"]=Module["asm"]["kP"]).apply(null,arguments)};var _emscripten_bind_BRepBndLib_BRepBndLib_0=Module["_emscripten_bind_BRepBndLib_BRepBndLib_0"]=function(){return(_emscripten_bind_BRepBndLib_BRepBndLib_0=Module["_emscripten_bind_BRepBndLib_BRepBndLib_0"]=Module["asm"]["lP"]).apply(null,arguments)};var _emscripten_bind_BRepBndLib_Add_2=Module["_emscripten_bind_BRepBndLib_Add_2"]=function(){return(_emscripten_bind_BRepBndLib_Add_2=Module["_emscripten_bind_BRepBndLib_Add_2"]=Module["asm"]["mP"]).apply(null,arguments)};var _emscripten_bind_BRepBndLib_Add_3=Module["_emscripten_bind_BRepBndLib_Add_3"]=function(){return(_emscripten_bind_BRepBndLib_Add_3=Module["_emscripten_bind_BRepBndLib_Add_3"]=Module["asm"]["nP"]).apply(null,arguments)};var _emscripten_bind_BRepBndLib_AddClose_2=Module["_emscripten_bind_BRepBndLib_AddClose_2"]=function(){return(_emscripten_bind_BRepBndLib_AddClose_2=Module["_emscripten_bind_BRepBndLib_AddClose_2"]=Module["asm"]["oP"]).apply(null,arguments)};var _emscripten_bind_BRepBndLib_AddOptimal_2=Module["_emscripten_bind_BRepBndLib_AddOptimal_2"]=function(){return(_emscripten_bind_BRepBndLib_AddOptimal_2=Module["_emscripten_bind_BRepBndLib_AddOptimal_2"]=Module["asm"]["pP"]).apply(null,arguments)};var _emscripten_bind_BRepBndLib_AddOptimal_3=Module["_emscripten_bind_BRepBndLib_AddOptimal_3"]=function(){return(_emscripten_bind_BRepBndLib_AddOptimal_3=Module["_emscripten_bind_BRepBndLib_AddOptimal_3"]=Module["asm"]["qP"]).apply(null,arguments)};var _emscripten_bind_BRepBndLib_AddOptimal_4=Module["_emscripten_bind_BRepBndLib_AddOptimal_4"]=function(){return(_emscripten_bind_BRepBndLib_AddOptimal_4=Module["_emscripten_bind_BRepBndLib_AddOptimal_4"]=Module["asm"]["rP"]).apply(null,arguments)};var _emscripten_bind_BRepBndLib_AddOBB_2=Module["_emscripten_bind_BRepBndLib_AddOBB_2"]=function(){return(_emscripten_bind_BRepBndLib_AddOBB_2=Module["_emscripten_bind_BRepBndLib_AddOBB_2"]=Module["asm"]["sP"]).apply(null,arguments)};var _emscripten_bind_BRepBndLib_AddOBB_3=Module["_emscripten_bind_BRepBndLib_AddOBB_3"]=function(){return(_emscripten_bind_BRepBndLib_AddOBB_3=Module["_emscripten_bind_BRepBndLib_AddOBB_3"]=Module["asm"]["tP"]).apply(null,arguments)};var _emscripten_bind_BRepBndLib_AddOBB_4=Module["_emscripten_bind_BRepBndLib_AddOBB_4"]=function(){return(_emscripten_bind_BRepBndLib_AddOBB_4=Module["_emscripten_bind_BRepBndLib_AddOBB_4"]=Module["asm"]["uP"]).apply(null,arguments)};var _emscripten_bind_BRepBndLib_AddOBB_5=Module["_emscripten_bind_BRepBndLib_AddOBB_5"]=function(){return(_emscripten_bind_BRepBndLib_AddOBB_5=Module["_emscripten_bind_BRepBndLib_AddOBB_5"]=Module["asm"]["vP"]).apply(null,arguments)};var _emscripten_bind_BRepBndLib___destroy___0=Module["_emscripten_bind_BRepBndLib___destroy___0"]=function(){return(_emscripten_bind_BRepBndLib___destroy___0=Module["_emscripten_bind_BRepBndLib___destroy___0"]=Module["asm"]["wP"]).apply(null,arguments)};var _emscripten_bind_Message_ProgressIndicator_GetPosition_0=Module["_emscripten_bind_Message_ProgressIndicator_GetPosition_0"]=function(){return(_emscripten_bind_Message_ProgressIndicator_GetPosition_0=Module["_emscripten_bind_Message_ProgressIndicator_GetPosition_0"]=Module["asm"]["xP"]).apply(null,arguments)};var _emscripten_bind_Message_ProgressIndicator_GetValue_0=Module["_emscripten_bind_Message_ProgressIndicator_GetValue_0"]=function(){return(_emscripten_bind_Message_ProgressIndicator_GetValue_0=Module["_emscripten_bind_Message_ProgressIndicator_GetValue_0"]=Module["asm"]["yP"]).apply(null,arguments)};var _emscripten_bind_Message_ProgressIndicator_NewScope_1=Module["_emscripten_bind_Message_ProgressIndicator_NewScope_1"]=function(){return(_emscripten_bind_Message_ProgressIndicator_NewScope_1=Module["_emscripten_bind_Message_ProgressIndicator_NewScope_1"]=Module["asm"]["zP"]).apply(null,arguments)};var _emscripten_bind_Message_ProgressIndicator_NewScope_2=Module["_emscripten_bind_Message_ProgressIndicator_NewScope_2"]=function(){return(_emscripten_bind_Message_ProgressIndicator_NewScope_2=Module["_emscripten_bind_Message_ProgressIndicator_NewScope_2"]=Module["asm"]["AP"]).apply(null,arguments)};var _emscripten_bind_Message_ProgressIndicator_EndScope_0=Module["_emscripten_bind_Message_ProgressIndicator_EndScope_0"]=function(){return(_emscripten_bind_Message_ProgressIndicator_EndScope_0=Module["_emscripten_bind_Message_ProgressIndicator_EndScope_0"]=Module["asm"]["BP"]).apply(null,arguments)};var _emscripten_bind_Message_ProgressIndicator_Reset_0=Module["_emscripten_bind_Message_ProgressIndicator_Reset_0"]=function(){return(_emscripten_bind_Message_ProgressIndicator_Reset_0=Module["_emscripten_bind_Message_ProgressIndicator_Reset_0"]=Module["asm"]["CP"]).apply(null,arguments)};var _emscripten_bind_Message_ProgressIndicator___destroy___0=Module["_emscripten_bind_Message_ProgressIndicator___destroy___0"]=function(){return(_emscripten_bind_Message_ProgressIndicator___destroy___0=Module["_emscripten_bind_Message_ProgressIndicator___destroy___0"]=Module["asm"]["DP"]).apply(null,arguments)};var _emscripten_bind_Poly_Polygon3D_Poly_Polygon3D_1=Module["_emscripten_bind_Poly_Polygon3D_Poly_Polygon3D_1"]=function(){return(_emscripten_bind_Poly_Polygon3D_Poly_Polygon3D_1=Module["_emscripten_bind_Poly_Polygon3D_Poly_Polygon3D_1"]=Module["asm"]["EP"]).apply(null,arguments)};var _emscripten_bind_Poly_Polygon3D_Poly_Polygon3D_2=Module["_emscripten_bind_Poly_Polygon3D_Poly_Polygon3D_2"]=function(){return(_emscripten_bind_Poly_Polygon3D_Poly_Polygon3D_2=Module["_emscripten_bind_Poly_Polygon3D_Poly_Polygon3D_2"]=Module["asm"]["FP"]).apply(null,arguments)};var _emscripten_bind_Poly_Polygon3D_Copy_0=Module["_emscripten_bind_Poly_Polygon3D_Copy_0"]=function(){return(_emscripten_bind_Poly_Polygon3D_Copy_0=Module["_emscripten_bind_Poly_Polygon3D_Copy_0"]=Module["asm"]["GP"]).apply(null,arguments)};var _emscripten_bind_Poly_Polygon3D_Deflection_0=Module["_emscripten_bind_Poly_Polygon3D_Deflection_0"]=function(){return(_emscripten_bind_Poly_Polygon3D_Deflection_0=Module["_emscripten_bind_Poly_Polygon3D_Deflection_0"]=Module["asm"]["HP"]).apply(null,arguments)};var _emscripten_bind_Poly_Polygon3D_NbNodes_0=Module["_emscripten_bind_Poly_Polygon3D_NbNodes_0"]=function(){return(_emscripten_bind_Poly_Polygon3D_NbNodes_0=Module["_emscripten_bind_Poly_Polygon3D_NbNodes_0"]=Module["asm"]["IP"]).apply(null,arguments)};var _emscripten_bind_Poly_Polygon3D_Nodes_0=Module["_emscripten_bind_Poly_Polygon3D_Nodes_0"]=function(){return(_emscripten_bind_Poly_Polygon3D_Nodes_0=Module["_emscripten_bind_Poly_Polygon3D_Nodes_0"]=Module["asm"]["JP"]).apply(null,arguments)};var _emscripten_bind_Poly_Polygon3D_HasParameters_0=Module["_emscripten_bind_Poly_Polygon3D_HasParameters_0"]=function(){return(_emscripten_bind_Poly_Polygon3D_HasParameters_0=Module["_emscripten_bind_Poly_Polygon3D_HasParameters_0"]=Module["asm"]["KP"]).apply(null,arguments)};var _emscripten_bind_Poly_Polygon3D_Parameters_0=Module["_emscripten_bind_Poly_Polygon3D_Parameters_0"]=function(){return(_emscripten_bind_Poly_Polygon3D_Parameters_0=Module["_emscripten_bind_Poly_Polygon3D_Parameters_0"]=Module["asm"]["LP"]).apply(null,arguments)};var _emscripten_bind_Poly_Polygon3D_ChangeParameters_0=Module["_emscripten_bind_Poly_Polygon3D_ChangeParameters_0"]=function(){return(_emscripten_bind_Poly_Polygon3D_ChangeParameters_0=Module["_emscripten_bind_Poly_Polygon3D_ChangeParameters_0"]=Module["asm"]["MP"]).apply(null,arguments)};var _emscripten_bind_Poly_Polygon3D___destroy___0=Module["_emscripten_bind_Poly_Polygon3D___destroy___0"]=function(){return(_emscripten_bind_Poly_Polygon3D___destroy___0=Module["_emscripten_bind_Poly_Polygon3D___destroy___0"]=Module["asm"]["NP"]).apply(null,arguments)};var _emscripten_bind_gp_Dir2d_gp_Dir2d_0=Module["_emscripten_bind_gp_Dir2d_gp_Dir2d_0"]=function(){return(_emscripten_bind_gp_Dir2d_gp_Dir2d_0=Module["_emscripten_bind_gp_Dir2d_gp_Dir2d_0"]=Module["asm"]["OP"]).apply(null,arguments)};var _emscripten_bind_gp_Dir2d_gp_Dir2d_2=Module["_emscripten_bind_gp_Dir2d_gp_Dir2d_2"]=function(){return(_emscripten_bind_gp_Dir2d_gp_Dir2d_2=Module["_emscripten_bind_gp_Dir2d_gp_Dir2d_2"]=Module["asm"]["PP"]).apply(null,arguments)};var _emscripten_bind_gp_Dir2d___destroy___0=Module["_emscripten_bind_gp_Dir2d___destroy___0"]=function(){return(_emscripten_bind_gp_Dir2d___destroy___0=Module["_emscripten_bind_gp_Dir2d___destroy___0"]=Module["asm"]["QP"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_TopoDS_Vertex_0=Module["_emscripten_bind_TopoDS_Vertex_TopoDS_Vertex_0"]=function(){return(_emscripten_bind_TopoDS_Vertex_TopoDS_Vertex_0=Module["_emscripten_bind_TopoDS_Vertex_TopoDS_Vertex_0"]=Module["asm"]["RP"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_TopoDS_Vertex_1=Module["_emscripten_bind_TopoDS_Vertex_TopoDS_Vertex_1"]=function(){return(_emscripten_bind_TopoDS_Vertex_TopoDS_Vertex_1=Module["_emscripten_bind_TopoDS_Vertex_TopoDS_Vertex_1"]=Module["asm"]["SP"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_IsNull_0=Module["_emscripten_bind_TopoDS_Vertex_IsNull_0"]=function(){return(_emscripten_bind_TopoDS_Vertex_IsNull_0=Module["_emscripten_bind_TopoDS_Vertex_IsNull_0"]=Module["asm"]["TP"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_Nullify_0=Module["_emscripten_bind_TopoDS_Vertex_Nullify_0"]=function(){return(_emscripten_bind_TopoDS_Vertex_Nullify_0=Module["_emscripten_bind_TopoDS_Vertex_Nullify_0"]=Module["asm"]["UP"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_Location_0=Module["_emscripten_bind_TopoDS_Vertex_Location_0"]=function(){return(_emscripten_bind_TopoDS_Vertex_Location_0=Module["_emscripten_bind_TopoDS_Vertex_Location_0"]=Module["asm"]["VP"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_Located_1=Module["_emscripten_bind_TopoDS_Vertex_Located_1"]=function(){return(_emscripten_bind_TopoDS_Vertex_Located_1=Module["_emscripten_bind_TopoDS_Vertex_Located_1"]=Module["asm"]["WP"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_Orientation_0=Module["_emscripten_bind_TopoDS_Vertex_Orientation_0"]=function(){return(_emscripten_bind_TopoDS_Vertex_Orientation_0=Module["_emscripten_bind_TopoDS_Vertex_Orientation_0"]=Module["asm"]["XP"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_Oriented_1=Module["_emscripten_bind_TopoDS_Vertex_Oriented_1"]=function(){return(_emscripten_bind_TopoDS_Vertex_Oriented_1=Module["_emscripten_bind_TopoDS_Vertex_Oriented_1"]=Module["asm"]["YP"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_ShapeType_0=Module["_emscripten_bind_TopoDS_Vertex_ShapeType_0"]=function(){return(_emscripten_bind_TopoDS_Vertex_ShapeType_0=Module["_emscripten_bind_TopoDS_Vertex_ShapeType_0"]=Module["asm"]["ZP"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_Free_0=Module["_emscripten_bind_TopoDS_Vertex_Free_0"]=function(){return(_emscripten_bind_TopoDS_Vertex_Free_0=Module["_emscripten_bind_TopoDS_Vertex_Free_0"]=Module["asm"]["_P"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_Locked_0=Module["_emscripten_bind_TopoDS_Vertex_Locked_0"]=function(){return(_emscripten_bind_TopoDS_Vertex_Locked_0=Module["_emscripten_bind_TopoDS_Vertex_Locked_0"]=Module["asm"]["$P"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_Modified_0=Module["_emscripten_bind_TopoDS_Vertex_Modified_0"]=function(){return(_emscripten_bind_TopoDS_Vertex_Modified_0=Module["_emscripten_bind_TopoDS_Vertex_Modified_0"]=Module["asm"]["aQ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_Checked_0=Module["_emscripten_bind_TopoDS_Vertex_Checked_0"]=function(){return(_emscripten_bind_TopoDS_Vertex_Checked_0=Module["_emscripten_bind_TopoDS_Vertex_Checked_0"]=Module["asm"]["bQ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_Orientable_0=Module["_emscripten_bind_TopoDS_Vertex_Orientable_0"]=function(){return(_emscripten_bind_TopoDS_Vertex_Orientable_0=Module["_emscripten_bind_TopoDS_Vertex_Orientable_0"]=Module["asm"]["cQ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_Closed_0=Module["_emscripten_bind_TopoDS_Vertex_Closed_0"]=function(){return(_emscripten_bind_TopoDS_Vertex_Closed_0=Module["_emscripten_bind_TopoDS_Vertex_Closed_0"]=Module["asm"]["dQ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_Infinite_0=Module["_emscripten_bind_TopoDS_Vertex_Infinite_0"]=function(){return(_emscripten_bind_TopoDS_Vertex_Infinite_0=Module["_emscripten_bind_TopoDS_Vertex_Infinite_0"]=Module["asm"]["eQ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_Convex_0=Module["_emscripten_bind_TopoDS_Vertex_Convex_0"]=function(){return(_emscripten_bind_TopoDS_Vertex_Convex_0=Module["_emscripten_bind_TopoDS_Vertex_Convex_0"]=Module["asm"]["fQ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_Move_1=Module["_emscripten_bind_TopoDS_Vertex_Move_1"]=function(){return(_emscripten_bind_TopoDS_Vertex_Move_1=Module["_emscripten_bind_TopoDS_Vertex_Move_1"]=Module["asm"]["gQ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_Moved_1=Module["_emscripten_bind_TopoDS_Vertex_Moved_1"]=function(){return(_emscripten_bind_TopoDS_Vertex_Moved_1=Module["_emscripten_bind_TopoDS_Vertex_Moved_1"]=Module["asm"]["hQ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_Reverse_0=Module["_emscripten_bind_TopoDS_Vertex_Reverse_0"]=function(){return(_emscripten_bind_TopoDS_Vertex_Reverse_0=Module["_emscripten_bind_TopoDS_Vertex_Reverse_0"]=Module["asm"]["iQ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_Reversed_0=Module["_emscripten_bind_TopoDS_Vertex_Reversed_0"]=function(){return(_emscripten_bind_TopoDS_Vertex_Reversed_0=Module["_emscripten_bind_TopoDS_Vertex_Reversed_0"]=Module["asm"]["jQ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_Complement_0=Module["_emscripten_bind_TopoDS_Vertex_Complement_0"]=function(){return(_emscripten_bind_TopoDS_Vertex_Complement_0=Module["_emscripten_bind_TopoDS_Vertex_Complement_0"]=Module["asm"]["kQ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_Complemented_0=Module["_emscripten_bind_TopoDS_Vertex_Complemented_0"]=function(){return(_emscripten_bind_TopoDS_Vertex_Complemented_0=Module["_emscripten_bind_TopoDS_Vertex_Complemented_0"]=Module["asm"]["lQ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_Compose_1=Module["_emscripten_bind_TopoDS_Vertex_Compose_1"]=function(){return(_emscripten_bind_TopoDS_Vertex_Compose_1=Module["_emscripten_bind_TopoDS_Vertex_Compose_1"]=Module["asm"]["mQ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_Composed_1=Module["_emscripten_bind_TopoDS_Vertex_Composed_1"]=function(){return(_emscripten_bind_TopoDS_Vertex_Composed_1=Module["_emscripten_bind_TopoDS_Vertex_Composed_1"]=Module["asm"]["nQ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_NbChildren_0=Module["_emscripten_bind_TopoDS_Vertex_NbChildren_0"]=function(){return(_emscripten_bind_TopoDS_Vertex_NbChildren_0=Module["_emscripten_bind_TopoDS_Vertex_NbChildren_0"]=Module["asm"]["oQ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_IsPartner_1=Module["_emscripten_bind_TopoDS_Vertex_IsPartner_1"]=function(){return(_emscripten_bind_TopoDS_Vertex_IsPartner_1=Module["_emscripten_bind_TopoDS_Vertex_IsPartner_1"]=Module["asm"]["pQ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_IsSame_1=Module["_emscripten_bind_TopoDS_Vertex_IsSame_1"]=function(){return(_emscripten_bind_TopoDS_Vertex_IsSame_1=Module["_emscripten_bind_TopoDS_Vertex_IsSame_1"]=Module["asm"]["qQ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_IsEqual_1=Module["_emscripten_bind_TopoDS_Vertex_IsEqual_1"]=function(){return(_emscripten_bind_TopoDS_Vertex_IsEqual_1=Module["_emscripten_bind_TopoDS_Vertex_IsEqual_1"]=Module["asm"]["rQ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_IsNotEqual_1=Module["_emscripten_bind_TopoDS_Vertex_IsNotEqual_1"]=function(){return(_emscripten_bind_TopoDS_Vertex_IsNotEqual_1=Module["_emscripten_bind_TopoDS_Vertex_IsNotEqual_1"]=Module["asm"]["sQ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_HashCode_1=Module["_emscripten_bind_TopoDS_Vertex_HashCode_1"]=function(){return(_emscripten_bind_TopoDS_Vertex_HashCode_1=Module["_emscripten_bind_TopoDS_Vertex_HashCode_1"]=Module["asm"]["tQ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_EmptyCopy_0=Module["_emscripten_bind_TopoDS_Vertex_EmptyCopy_0"]=function(){return(_emscripten_bind_TopoDS_Vertex_EmptyCopy_0=Module["_emscripten_bind_TopoDS_Vertex_EmptyCopy_0"]=Module["asm"]["uQ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex_EmptyCopied_0=Module["_emscripten_bind_TopoDS_Vertex_EmptyCopied_0"]=function(){return(_emscripten_bind_TopoDS_Vertex_EmptyCopied_0=Module["_emscripten_bind_TopoDS_Vertex_EmptyCopied_0"]=Module["asm"]["vQ"]).apply(null,arguments)};var _emscripten_bind_TopoDS_Vertex___destroy___0=Module["_emscripten_bind_TopoDS_Vertex___destroy___0"]=function(){return(_emscripten_bind_TopoDS_Vertex___destroy___0=Module["_emscripten_bind_TopoDS_Vertex___destroy___0"]=Module["asm"]["wQ"]).apply(null,arguments)};var _emscripten_bind_Handle_XSControl_WorkSession_Handle_XSControl_WorkSession_0=Module["_emscripten_bind_Handle_XSControl_WorkSession_Handle_XSControl_WorkSession_0"]=function(){return(_emscripten_bind_Handle_XSControl_WorkSession_Handle_XSControl_WorkSession_0=Module["_emscripten_bind_Handle_XSControl_WorkSession_Handle_XSControl_WorkSession_0"]=Module["asm"]["xQ"]).apply(null,arguments)};var _emscripten_bind_Handle_XSControl_WorkSession_Handle_XSControl_WorkSession_1=Module["_emscripten_bind_Handle_XSControl_WorkSession_Handle_XSControl_WorkSession_1"]=function(){return(_emscripten_bind_Handle_XSControl_WorkSession_Handle_XSControl_WorkSession_1=Module["_emscripten_bind_Handle_XSControl_WorkSession_Handle_XSControl_WorkSession_1"]=Module["asm"]["yQ"]).apply(null,arguments)};var _emscripten_bind_Handle_XSControl_WorkSession_IsNull_0=Module["_emscripten_bind_Handle_XSControl_WorkSession_IsNull_0"]=function(){return(_emscripten_bind_Handle_XSControl_WorkSession_IsNull_0=Module["_emscripten_bind_Handle_XSControl_WorkSession_IsNull_0"]=Module["asm"]["zQ"]).apply(null,arguments)};var _emscripten_bind_Handle_XSControl_WorkSession_Nullify_0=Module["_emscripten_bind_Handle_XSControl_WorkSession_Nullify_0"]=function(){return(_emscripten_bind_Handle_XSControl_WorkSession_Nullify_0=Module["_emscripten_bind_Handle_XSControl_WorkSession_Nullify_0"]=Module["asm"]["AQ"]).apply(null,arguments)};var _emscripten_bind_Handle_XSControl_WorkSession_get_0=Module["_emscripten_bind_Handle_XSControl_WorkSession_get_0"]=function(){return(_emscripten_bind_Handle_XSControl_WorkSession_get_0=Module["_emscripten_bind_Handle_XSControl_WorkSession_get_0"]=Module["asm"]["BQ"]).apply(null,arguments)};var _emscripten_bind_Handle_XSControl_WorkSession___destroy___0=Module["_emscripten_bind_Handle_XSControl_WorkSession___destroy___0"]=function(){return(_emscripten_bind_Handle_XSControl_WorkSession___destroy___0=Module["_emscripten_bind_Handle_XSControl_WorkSession___destroy___0"]=Module["asm"]["CQ"]).apply(null,arguments)};var _emscripten_enum_BRepBuilderAPI_PipeError_BRepBuilderAPI_PipeDone=Module["_emscripten_enum_BRepBuilderAPI_PipeError_BRepBuilderAPI_PipeDone"]=function(){return(_emscripten_enum_BRepBuilderAPI_PipeError_BRepBuilderAPI_PipeDone=Module["_emscripten_enum_BRepBuilderAPI_PipeError_BRepBuilderAPI_PipeDone"]=Module["asm"]["DQ"]).apply(null,arguments)};var _emscripten_enum_BRepBuilderAPI_PipeError_BRepBuilderAPI_PipeNotDone=Module["_emscripten_enum_BRepBuilderAPI_PipeError_BRepBuilderAPI_PipeNotDone"]=function(){return(_emscripten_enum_BRepBuilderAPI_PipeError_BRepBuilderAPI_PipeNotDone=Module["_emscripten_enum_BRepBuilderAPI_PipeError_BRepBuilderAPI_PipeNotDone"]=Module["asm"]["EQ"]).apply(null,arguments)};var _emscripten_enum_BRepBuilderAPI_PipeError_BRepBuilderAPI_PlaneNotIntersectGuide=Module["_emscripten_enum_BRepBuilderAPI_PipeError_BRepBuilderAPI_PlaneNotIntersectGuide"]=function(){return(_emscripten_enum_BRepBuilderAPI_PipeError_BRepBuilderAPI_PlaneNotIntersectGuide=Module["_emscripten_enum_BRepBuilderAPI_PipeError_BRepBuilderAPI_PlaneNotIntersectGuide"]=Module["asm"]["FQ"]).apply(null,arguments)};var _emscripten_enum_BRepBuilderAPI_PipeError_BRepBuilderAPI_ImpossibleContact=Module["_emscripten_enum_BRepBuilderAPI_PipeError_BRepBuilderAPI_ImpossibleContact"]=function(){return(_emscripten_enum_BRepBuilderAPI_PipeError_BRepBuilderAPI_ImpossibleContact=Module["_emscripten_enum_BRepBuilderAPI_PipeError_BRepBuilderAPI_ImpossibleContact"]=Module["asm"]["GQ"]).apply(null,arguments)};var _emscripten_enum_TopAbs_Orientation_TopAbs_FORWARD=Module["_emscripten_enum_TopAbs_Orientation_TopAbs_FORWARD"]=function(){return(_emscripten_enum_TopAbs_Orientation_TopAbs_FORWARD=Module["_emscripten_enum_TopAbs_Orientation_TopAbs_FORWARD"]=Module["asm"]["HQ"]).apply(null,arguments)};var _emscripten_enum_TopAbs_Orientation_TopAbs_REVERSED=Module["_emscripten_enum_TopAbs_Orientation_TopAbs_REVERSED"]=function(){return(_emscripten_enum_TopAbs_Orientation_TopAbs_REVERSED=Module["_emscripten_enum_TopAbs_Orientation_TopAbs_REVERSED"]=Module["asm"]["IQ"]).apply(null,arguments)};var _emscripten_enum_TopAbs_Orientation_TopAbs_INTERNAL=Module["_emscripten_enum_TopAbs_Orientation_TopAbs_INTERNAL"]=function(){return(_emscripten_enum_TopAbs_Orientation_TopAbs_INTERNAL=Module["_emscripten_enum_TopAbs_Orientation_TopAbs_INTERNAL"]=Module["asm"]["JQ"]).apply(null,arguments)};var _emscripten_enum_TopAbs_Orientation_TopAbs_EXTERNAL=Module["_emscripten_enum_TopAbs_Orientation_TopAbs_EXTERNAL"]=function(){return(_emscripten_enum_TopAbs_Orientation_TopAbs_EXTERNAL=Module["_emscripten_enum_TopAbs_Orientation_TopAbs_EXTERNAL"]=Module["asm"]["KQ"]).apply(null,arguments)};var _emscripten_enum_TopAbs_ShapeEnum_TopAbs_COMPOUND=Module["_emscripten_enum_TopAbs_ShapeEnum_TopAbs_COMPOUND"]=function(){return(_emscripten_enum_TopAbs_ShapeEnum_TopAbs_COMPOUND=Module["_emscripten_enum_TopAbs_ShapeEnum_TopAbs_COMPOUND"]=Module["asm"]["LQ"]).apply(null,arguments)};var _emscripten_enum_TopAbs_ShapeEnum_TopAbs_COMPSOLID=Module["_emscripten_enum_TopAbs_ShapeEnum_TopAbs_COMPSOLID"]=function(){return(_emscripten_enum_TopAbs_ShapeEnum_TopAbs_COMPSOLID=Module["_emscripten_enum_TopAbs_ShapeEnum_TopAbs_COMPSOLID"]=Module["asm"]["MQ"]).apply(null,arguments)};var _emscripten_enum_TopAbs_ShapeEnum_TopAbs_SOLID=Module["_emscripten_enum_TopAbs_ShapeEnum_TopAbs_SOLID"]=function(){return(_emscripten_enum_TopAbs_ShapeEnum_TopAbs_SOLID=Module["_emscripten_enum_TopAbs_ShapeEnum_TopAbs_SOLID"]=Module["asm"]["NQ"]).apply(null,arguments)};var _emscripten_enum_TopAbs_ShapeEnum_TopAbs_SHELL=Module["_emscripten_enum_TopAbs_ShapeEnum_TopAbs_SHELL"]=function(){return(_emscripten_enum_TopAbs_ShapeEnum_TopAbs_SHELL=Module["_emscripten_enum_TopAbs_ShapeEnum_TopAbs_SHELL"]=Module["asm"]["OQ"]).apply(null,arguments)};var _emscripten_enum_TopAbs_ShapeEnum_TopAbs_FACE=Module["_emscripten_enum_TopAbs_ShapeEnum_TopAbs_FACE"]=function(){return(_emscripten_enum_TopAbs_ShapeEnum_TopAbs_FACE=Module["_emscripten_enum_TopAbs_ShapeEnum_TopAbs_FACE"]=Module["asm"]["PQ"]).apply(null,arguments)};var _emscripten_enum_TopAbs_ShapeEnum_TopAbs_WIRE=Module["_emscripten_enum_TopAbs_ShapeEnum_TopAbs_WIRE"]=function(){return(_emscripten_enum_TopAbs_ShapeEnum_TopAbs_WIRE=Module["_emscripten_enum_TopAbs_ShapeEnum_TopAbs_WIRE"]=Module["asm"]["QQ"]).apply(null,arguments)};var _emscripten_enum_TopAbs_ShapeEnum_TopAbs_EDGE=Module["_emscripten_enum_TopAbs_ShapeEnum_TopAbs_EDGE"]=function(){return(_emscripten_enum_TopAbs_ShapeEnum_TopAbs_EDGE=Module["_emscripten_enum_TopAbs_ShapeEnum_TopAbs_EDGE"]=Module["asm"]["RQ"]).apply(null,arguments)};var _emscripten_enum_TopAbs_ShapeEnum_TopAbs_VERTEX=Module["_emscripten_enum_TopAbs_ShapeEnum_TopAbs_VERTEX"]=function(){return(_emscripten_enum_TopAbs_ShapeEnum_TopAbs_VERTEX=Module["_emscripten_enum_TopAbs_ShapeEnum_TopAbs_VERTEX"]=Module["asm"]["SQ"]).apply(null,arguments)};var _emscripten_enum_TopAbs_ShapeEnum_TopAbs_SHAPE=Module["_emscripten_enum_TopAbs_ShapeEnum_TopAbs_SHAPE"]=function(){return(_emscripten_enum_TopAbs_ShapeEnum_TopAbs_SHAPE=Module["_emscripten_enum_TopAbs_ShapeEnum_TopAbs_SHAPE"]=Module["asm"]["TQ"]).apply(null,arguments)};var _emscripten_enum_GeomAbs_Shape_GeomAbs_C0=Module["_emscripten_enum_GeomAbs_Shape_GeomAbs_C0"]=function(){return(_emscripten_enum_GeomAbs_Shape_GeomAbs_C0=Module["_emscripten_enum_GeomAbs_Shape_GeomAbs_C0"]=Module["asm"]["UQ"]).apply(null,arguments)};var _emscripten_enum_GeomAbs_Shape_GeomAbs_G1=Module["_emscripten_enum_GeomAbs_Shape_GeomAbs_G1"]=function(){return(_emscripten_enum_GeomAbs_Shape_GeomAbs_G1=Module["_emscripten_enum_GeomAbs_Shape_GeomAbs_G1"]=Module["asm"]["VQ"]).apply(null,arguments)};var _emscripten_enum_GeomAbs_Shape_GeomAbs_C1=Module["_emscripten_enum_GeomAbs_Shape_GeomAbs_C1"]=function(){return(_emscripten_enum_GeomAbs_Shape_GeomAbs_C1=Module["_emscripten_enum_GeomAbs_Shape_GeomAbs_C1"]=Module["asm"]["WQ"]).apply(null,arguments)};var _emscripten_enum_GeomAbs_Shape_GeomAbs_G2=Module["_emscripten_enum_GeomAbs_Shape_GeomAbs_G2"]=function(){return(_emscripten_enum_GeomAbs_Shape_GeomAbs_G2=Module["_emscripten_enum_GeomAbs_Shape_GeomAbs_G2"]=Module["asm"]["XQ"]).apply(null,arguments)};var _emscripten_enum_GeomAbs_Shape_GeomAbs_C2=Module["_emscripten_enum_GeomAbs_Shape_GeomAbs_C2"]=function(){return(_emscripten_enum_GeomAbs_Shape_GeomAbs_C2=Module["_emscripten_enum_GeomAbs_Shape_GeomAbs_C2"]=Module["asm"]["YQ"]).apply(null,arguments)};var _emscripten_enum_GeomAbs_Shape_GeomAbs_C3=Module["_emscripten_enum_GeomAbs_Shape_GeomAbs_C3"]=function(){return(_emscripten_enum_GeomAbs_Shape_GeomAbs_C3=Module["_emscripten_enum_GeomAbs_Shape_GeomAbs_C3"]=Module["asm"]["ZQ"]).apply(null,arguments)};var _emscripten_enum_GeomAbs_Shape_GeomAbs_CN=Module["_emscripten_enum_GeomAbs_Shape_GeomAbs_CN"]=function(){return(_emscripten_enum_GeomAbs_Shape_GeomAbs_CN=Module["_emscripten_enum_GeomAbs_Shape_GeomAbs_CN"]=Module["asm"]["_Q"]).apply(null,arguments)};var _emscripten_enum_BRepOffset_Mode_BRepOffset_Skin=Module["_emscripten_enum_BRepOffset_Mode_BRepOffset_Skin"]=function(){return(_emscripten_enum_BRepOffset_Mode_BRepOffset_Skin=Module["_emscripten_enum_BRepOffset_Mode_BRepOffset_Skin"]=Module["asm"]["$Q"]).apply(null,arguments)};var _emscripten_enum_BRepOffset_Mode_BRepOffset_Pipe=Module["_emscripten_enum_BRepOffset_Mode_BRepOffset_Pipe"]=function(){return(_emscripten_enum_BRepOffset_Mode_BRepOffset_Pipe=Module["_emscripten_enum_BRepOffset_Mode_BRepOffset_Pipe"]=Module["asm"]["aR"]).apply(null,arguments)};var _emscripten_enum_BRepOffset_Mode_BRepOffset_RectoVerso=Module["_emscripten_enum_BRepOffset_Mode_BRepOffset_RectoVerso"]=function(){return(_emscripten_enum_BRepOffset_Mode_BRepOffset_RectoVerso=Module["_emscripten_enum_BRepOffset_Mode_BRepOffset_RectoVerso"]=Module["asm"]["bR"]).apply(null,arguments)};var _emscripten_enum_ChFi2d_ConstructionError_ChFi2d_NotPlanar=Module["_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_NotPlanar"]=function(){return(_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_NotPlanar=Module["_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_NotPlanar"]=Module["asm"]["cR"]).apply(null,arguments)};var _emscripten_enum_ChFi2d_ConstructionError_ChFi2d_NoFace=Module["_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_NoFace"]=function(){return(_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_NoFace=Module["_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_NoFace"]=Module["asm"]["dR"]).apply(null,arguments)};var _emscripten_enum_ChFi2d_ConstructionError_ChFi2d_InitialisationError=Module["_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_InitialisationError"]=function(){return(_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_InitialisationError=Module["_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_InitialisationError"]=Module["asm"]["eR"]).apply(null,arguments)};var _emscripten_enum_ChFi2d_ConstructionError_ChFi2d_ParametersError=Module["_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_ParametersError"]=function(){return(_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_ParametersError=Module["_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_ParametersError"]=Module["asm"]["fR"]).apply(null,arguments)};var _emscripten_enum_ChFi2d_ConstructionError_ChFi2d_Ready=Module["_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_Ready"]=function(){return(_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_Ready=Module["_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_Ready"]=Module["asm"]["gR"]).apply(null,arguments)};var _emscripten_enum_ChFi2d_ConstructionError_ChFi2d_IsDone=Module["_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_IsDone"]=function(){return(_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_IsDone=Module["_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_IsDone"]=Module["asm"]["hR"]).apply(null,arguments)};var _emscripten_enum_ChFi2d_ConstructionError_ChFi2d_ComputationError=Module["_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_ComputationError"]=function(){return(_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_ComputationError=Module["_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_ComputationError"]=Module["asm"]["iR"]).apply(null,arguments)};var _emscripten_enum_ChFi2d_ConstructionError_ChFi2d_ConnexionError=Module["_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_ConnexionError"]=function(){return(_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_ConnexionError=Module["_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_ConnexionError"]=Module["asm"]["jR"]).apply(null,arguments)};var _emscripten_enum_ChFi2d_ConstructionError_ChFi2d_TangencyError=Module["_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_TangencyError"]=function(){return(_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_TangencyError=Module["_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_TangencyError"]=Module["asm"]["kR"]).apply(null,arguments)};var _emscripten_enum_ChFi2d_ConstructionError_ChFi2d_FirstEdgeDegenerated=Module["_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_FirstEdgeDegenerated"]=function(){return(_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_FirstEdgeDegenerated=Module["_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_FirstEdgeDegenerated"]=Module["asm"]["lR"]).apply(null,arguments)};var _emscripten_enum_ChFi2d_ConstructionError_ChFi2d_LastEdgeDegenerated=Module["_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_LastEdgeDegenerated"]=function(){return(_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_LastEdgeDegenerated=Module["_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_LastEdgeDegenerated"]=Module["asm"]["mR"]).apply(null,arguments)};var _emscripten_enum_ChFi2d_ConstructionError_ChFi2d_BothEdgesDegenerated=Module["_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_BothEdgesDegenerated"]=function(){return(_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_BothEdgesDegenerated=Module["_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_BothEdgesDegenerated"]=Module["asm"]["nR"]).apply(null,arguments)};var _emscripten_enum_ChFi2d_ConstructionError_ChFi2d_NotAuthorized=Module["_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_NotAuthorized"]=function(){return(_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_NotAuthorized=Module["_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_NotAuthorized"]=Module["asm"]["oR"]).apply(null,arguments)};var _emscripten_enum_GeomAbs_JoinType_GeomAbs_Arc=Module["_emscripten_enum_GeomAbs_JoinType_GeomAbs_Arc"]=function(){return(_emscripten_enum_GeomAbs_JoinType_GeomAbs_Arc=Module["_emscripten_enum_GeomAbs_JoinType_GeomAbs_Arc"]=Module["asm"]["pR"]).apply(null,arguments)};var _emscripten_enum_GeomAbs_JoinType_GeomAbs_Tangent=Module["_emscripten_enum_GeomAbs_JoinType_GeomAbs_Tangent"]=function(){return(_emscripten_enum_GeomAbs_JoinType_GeomAbs_Tangent=Module["_emscripten_enum_GeomAbs_JoinType_GeomAbs_Tangent"]=Module["asm"]["qR"]).apply(null,arguments)};var _emscripten_enum_GeomAbs_JoinType_GeomAbs_Intersection=Module["_emscripten_enum_GeomAbs_JoinType_GeomAbs_Intersection"]=function(){return(_emscripten_enum_GeomAbs_JoinType_GeomAbs_Intersection=Module["_emscripten_enum_GeomAbs_JoinType_GeomAbs_Intersection"]=Module["asm"]["rR"]).apply(null,arguments)};var _emscripten_enum_IFSelect_ReturnStatus_IFSelect_RetVoid=Module["_emscripten_enum_IFSelect_ReturnStatus_IFSelect_RetVoid"]=function(){return(_emscripten_enum_IFSelect_ReturnStatus_IFSelect_RetVoid=Module["_emscripten_enum_IFSelect_ReturnStatus_IFSelect_RetVoid"]=Module["asm"]["sR"]).apply(null,arguments)};var _emscripten_enum_IFSelect_ReturnStatus_IFSelect_RetDone=Module["_emscripten_enum_IFSelect_ReturnStatus_IFSelect_RetDone"]=function(){return(_emscripten_enum_IFSelect_ReturnStatus_IFSelect_RetDone=Module["_emscripten_enum_IFSelect_ReturnStatus_IFSelect_RetDone"]=Module["asm"]["tR"]).apply(null,arguments)};var _emscripten_enum_IFSelect_ReturnStatus_IFSelect_RetError=Module["_emscripten_enum_IFSelect_ReturnStatus_IFSelect_RetError"]=function(){return(_emscripten_enum_IFSelect_ReturnStatus_IFSelect_RetError=Module["_emscripten_enum_IFSelect_ReturnStatus_IFSelect_RetError"]=Module["asm"]["uR"]).apply(null,arguments)};var _emscripten_enum_IFSelect_ReturnStatus_IFSelect_RetFail=Module["_emscripten_enum_IFSelect_ReturnStatus_IFSelect_RetFail"]=function(){return(_emscripten_enum_IFSelect_ReturnStatus_IFSelect_RetFail=Module["_emscripten_enum_IFSelect_ReturnStatus_IFSelect_RetFail"]=Module["asm"]["vR"]).apply(null,arguments)};var _emscripten_enum_IFSelect_ReturnStatus_IFSelect_RetStop=Module["_emscripten_enum_IFSelect_ReturnStatus_IFSelect_RetStop"]=function(){return(_emscripten_enum_IFSelect_ReturnStatus_IFSelect_RetStop=Module["_emscripten_enum_IFSelect_ReturnStatus_IFSelect_RetStop"]=Module["asm"]["wR"]).apply(null,arguments)};var _emscripten_enum_ShapeExtend_Status_ShapeExtend_OK=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_OK"]=function(){return(_emscripten_enum_ShapeExtend_Status_ShapeExtend_OK=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_OK"]=Module["asm"]["xR"]).apply(null,arguments)};var _emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE1=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE1"]=function(){return(_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE1=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE1"]=Module["asm"]["yR"]).apply(null,arguments)};var _emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE2=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE2"]=function(){return(_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE2=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE2"]=Module["asm"]["zR"]).apply(null,arguments)};var _emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE3=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE3"]=function(){return(_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE3=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE3"]=Module["asm"]["AR"]).apply(null,arguments)};var _emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE4=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE4"]=function(){return(_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE4=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE4"]=Module["asm"]["BR"]).apply(null,arguments)};var _emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE5=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE5"]=function(){return(_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE5=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE5"]=Module["asm"]["CR"]).apply(null,arguments)};var _emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE6=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE6"]=function(){return(_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE6=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE6"]=Module["asm"]["DR"]).apply(null,arguments)};var _emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE7=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE7"]=function(){return(_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE7=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE7"]=Module["asm"]["ER"]).apply(null,arguments)};var _emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE8=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE8"]=function(){return(_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE8=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE8"]=Module["asm"]["FR"]).apply(null,arguments)};var _emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE"]=function(){return(_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE"]=Module["asm"]["GR"]).apply(null,arguments)};var _emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL1=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL1"]=function(){return(_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL1=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL1"]=Module["asm"]["HR"]).apply(null,arguments)};var _emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL2=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL2"]=function(){return(_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL2=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL2"]=Module["asm"]["IR"]).apply(null,arguments)};var _emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL3=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL3"]=function(){return(_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL3=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL3"]=Module["asm"]["JR"]).apply(null,arguments)};var _emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL4=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL4"]=function(){return(_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL4=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL4"]=Module["asm"]["KR"]).apply(null,arguments)};var _emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL5=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL5"]=function(){return(_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL5=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL5"]=Module["asm"]["LR"]).apply(null,arguments)};var _emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL6=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL6"]=function(){return(_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL6=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL6"]=Module["asm"]["MR"]).apply(null,arguments)};var _emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL7=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL7"]=function(){return(_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL7=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL7"]=Module["asm"]["NR"]).apply(null,arguments)};var _emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL8=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL8"]=function(){return(_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL8=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL8"]=Module["asm"]["OR"]).apply(null,arguments)};var _emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL"]=function(){return(_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL=Module["_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL"]=Module["asm"]["PR"]).apply(null,arguments)};var _emscripten_enum_GeomAbs_SurfaceType_GeomAbs_Plane=Module["_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_Plane"]=function(){return(_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_Plane=Module["_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_Plane"]=Module["asm"]["QR"]).apply(null,arguments)};var _emscripten_enum_GeomAbs_SurfaceType_GeomAbs_Cylinder=Module["_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_Cylinder"]=function(){return(_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_Cylinder=Module["_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_Cylinder"]=Module["asm"]["RR"]).apply(null,arguments)};var _emscripten_enum_GeomAbs_SurfaceType_GeomAbs_Cone=Module["_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_Cone"]=function(){return(_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_Cone=Module["_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_Cone"]=Module["asm"]["SR"]).apply(null,arguments)};var _emscripten_enum_GeomAbs_SurfaceType_GeomAbs_Sphere=Module["_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_Sphere"]=function(){return(_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_Sphere=Module["_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_Sphere"]=Module["asm"]["TR"]).apply(null,arguments)};var _emscripten_enum_GeomAbs_SurfaceType_GeomAbs_Torus=Module["_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_Torus"]=function(){return(_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_Torus=Module["_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_Torus"]=Module["asm"]["UR"]).apply(null,arguments)};var _emscripten_enum_GeomAbs_SurfaceType_GeomAbs_BezierSurface=Module["_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_BezierSurface"]=function(){return(_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_BezierSurface=Module["_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_BezierSurface"]=Module["asm"]["VR"]).apply(null,arguments)};var _emscripten_enum_GeomAbs_SurfaceType_GeomAbs_BSplineSurface=Module["_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_BSplineSurface"]=function(){return(_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_BSplineSurface=Module["_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_BSplineSurface"]=Module["asm"]["WR"]).apply(null,arguments)};var _emscripten_enum_GeomAbs_SurfaceType_GeomAbs_SurfaceOfRevolution=Module["_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_SurfaceOfRevolution"]=function(){return(_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_SurfaceOfRevolution=Module["_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_SurfaceOfRevolution"]=Module["asm"]["XR"]).apply(null,arguments)};var _emscripten_enum_GeomAbs_SurfaceType_GeomAbs_SurfaceOfExtrusion=Module["_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_SurfaceOfExtrusion"]=function(){return(_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_SurfaceOfExtrusion=Module["_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_SurfaceOfExtrusion"]=Module["asm"]["YR"]).apply(null,arguments)};var _emscripten_enum_GeomAbs_SurfaceType_GeomAbs_OffsetSurface=Module["_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_OffsetSurface"]=function(){return(_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_OffsetSurface=Module["_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_OffsetSurface"]=Module["asm"]["ZR"]).apply(null,arguments)};var _emscripten_enum_GeomAbs_SurfaceType_GeomAbs_OtherSurface=Module["_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_OtherSurface"]=function(){return(_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_OtherSurface=Module["_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_OtherSurface"]=Module["asm"]["_R"]).apply(null,arguments)};var _emscripten_enum_BRepBuilderAPI_FaceError_BRepBuilderAPI_FaceDone=Module["_emscripten_enum_BRepBuilderAPI_FaceError_BRepBuilderAPI_FaceDone"]=function(){return(_emscripten_enum_BRepBuilderAPI_FaceError_BRepBuilderAPI_FaceDone=Module["_emscripten_enum_BRepBuilderAPI_FaceError_BRepBuilderAPI_FaceDone"]=Module["asm"]["$R"]).apply(null,arguments)};var _emscripten_enum_BRepBuilderAPI_FaceError_BRepBuilderAPI_NoFace=Module["_emscripten_enum_BRepBuilderAPI_FaceError_BRepBuilderAPI_NoFace"]=function(){return(_emscripten_enum_BRepBuilderAPI_FaceError_BRepBuilderAPI_NoFace=Module["_emscripten_enum_BRepBuilderAPI_FaceError_BRepBuilderAPI_NoFace"]=Module["asm"]["aS"]).apply(null,arguments)};var _emscripten_enum_BRepBuilderAPI_FaceError_BRepBuilderAPI_NotPlanar=Module["_emscripten_enum_BRepBuilderAPI_FaceError_BRepBuilderAPI_NotPlanar"]=function(){return(_emscripten_enum_BRepBuilderAPI_FaceError_BRepBuilderAPI_NotPlanar=Module["_emscripten_enum_BRepBuilderAPI_FaceError_BRepBuilderAPI_NotPlanar"]=Module["asm"]["bS"]).apply(null,arguments)};var _emscripten_enum_BRepBuilderAPI_FaceError_BRepBuilderAPI_CurveProjectionFailed=Module["_emscripten_enum_BRepBuilderAPI_FaceError_BRepBuilderAPI_CurveProjectionFailed"]=function(){return(_emscripten_enum_BRepBuilderAPI_FaceError_BRepBuilderAPI_CurveProjectionFailed=Module["_emscripten_enum_BRepBuilderAPI_FaceError_BRepBuilderAPI_CurveProjectionFailed"]=Module["asm"]["cS"]).apply(null,arguments)};var _emscripten_enum_BRepBuilderAPI_FaceError_BRepBuilderAPI_ParametersOutOfRange=Module["_emscripten_enum_BRepBuilderAPI_FaceError_BRepBuilderAPI_ParametersOutOfRange"]=function(){return(_emscripten_enum_BRepBuilderAPI_FaceError_BRepBuilderAPI_ParametersOutOfRange=Module["_emscripten_enum_BRepBuilderAPI_FaceError_BRepBuilderAPI_ParametersOutOfRange"]=Module["asm"]["dS"]).apply(null,arguments)};var _emscripten_enum_STEPControl_StepModelType_STEPControl_AsIs=Module["_emscripten_enum_STEPControl_StepModelType_STEPControl_AsIs"]=function(){return(_emscripten_enum_STEPControl_StepModelType_STEPControl_AsIs=Module["_emscripten_enum_STEPControl_StepModelType_STEPControl_AsIs"]=Module["asm"]["eS"]).apply(null,arguments)};var _emscripten_enum_STEPControl_StepModelType_STEPControl_ManifoldSolidBrep=Module["_emscripten_enum_STEPControl_StepModelType_STEPControl_ManifoldSolidBrep"]=function(){return(_emscripten_enum_STEPControl_StepModelType_STEPControl_ManifoldSolidBrep=Module["_emscripten_enum_STEPControl_StepModelType_STEPControl_ManifoldSolidBrep"]=Module["asm"]["fS"]).apply(null,arguments)};var _emscripten_enum_STEPControl_StepModelType_STEPControl_BrepWithVoids=Module["_emscripten_enum_STEPControl_StepModelType_STEPControl_BrepWithVoids"]=function(){return(_emscripten_enum_STEPControl_StepModelType_STEPControl_BrepWithVoids=Module["_emscripten_enum_STEPControl_StepModelType_STEPControl_BrepWithVoids"]=Module["asm"]["gS"]).apply(null,arguments)};var _emscripten_enum_STEPControl_StepModelType_STEPControl_FacetedBrep=Module["_emscripten_enum_STEPControl_StepModelType_STEPControl_FacetedBrep"]=function(){return(_emscripten_enum_STEPControl_StepModelType_STEPControl_FacetedBrep=Module["_emscripten_enum_STEPControl_StepModelType_STEPControl_FacetedBrep"]=Module["asm"]["hS"]).apply(null,arguments)};var _emscripten_enum_STEPControl_StepModelType_STEPControl_FacetedBrepAndBrepWithVoids=Module["_emscripten_enum_STEPControl_StepModelType_STEPControl_FacetedBrepAndBrepWithVoids"]=function(){return(_emscripten_enum_STEPControl_StepModelType_STEPControl_FacetedBrepAndBrepWithVoids=Module["_emscripten_enum_STEPControl_StepModelType_STEPControl_FacetedBrepAndBrepWithVoids"]=Module["asm"]["iS"]).apply(null,arguments)};var _emscripten_enum_STEPControl_StepModelType_STEPControl_ShellBasedSurfaceModel=Module["_emscripten_enum_STEPControl_StepModelType_STEPControl_ShellBasedSurfaceModel"]=function(){return(_emscripten_enum_STEPControl_StepModelType_STEPControl_ShellBasedSurfaceModel=Module["_emscripten_enum_STEPControl_StepModelType_STEPControl_ShellBasedSurfaceModel"]=Module["asm"]["jS"]).apply(null,arguments)};var _emscripten_enum_STEPControl_StepModelType_STEPControl_GeometricCurveSet=Module["_emscripten_enum_STEPControl_StepModelType_STEPControl_GeometricCurveSet"]=function(){return(_emscripten_enum_STEPControl_StepModelType_STEPControl_GeometricCurveSet=Module["_emscripten_enum_STEPControl_StepModelType_STEPControl_GeometricCurveSet"]=Module["asm"]["kS"]).apply(null,arguments)};var _emscripten_enum_STEPControl_StepModelType_STEPControl_Hybrid=Module["_emscripten_enum_STEPControl_StepModelType_STEPControl_Hybrid"]=function(){return(_emscripten_enum_STEPControl_StepModelType_STEPControl_Hybrid=Module["_emscripten_enum_STEPControl_StepModelType_STEPControl_Hybrid"]=Module["asm"]["lS"]).apply(null,arguments)};var _emscripten_enum_BRepFill_TypeOfContact_BRepFill_NoContact=Module["_emscripten_enum_BRepFill_TypeOfContact_BRepFill_NoContact"]=function(){return(_emscripten_enum_BRepFill_TypeOfContact_BRepFill_NoContact=Module["_emscripten_enum_BRepFill_TypeOfContact_BRepFill_NoContact"]=Module["asm"]["mS"]).apply(null,arguments)};var _emscripten_enum_BRepFill_TypeOfContact_BRepFill_Contact=Module["_emscripten_enum_BRepFill_TypeOfContact_BRepFill_Contact"]=function(){return(_emscripten_enum_BRepFill_TypeOfContact_BRepFill_Contact=Module["_emscripten_enum_BRepFill_TypeOfContact_BRepFill_Contact"]=Module["asm"]["nS"]).apply(null,arguments)};var _emscripten_enum_BRepFill_TypeOfContact_BRepFill_ContactOnBorder=Module["_emscripten_enum_BRepFill_TypeOfContact_BRepFill_ContactOnBorder"]=function(){return(_emscripten_enum_BRepFill_TypeOfContact_BRepFill_ContactOnBorder=Module["_emscripten_enum_BRepFill_TypeOfContact_BRepFill_ContactOnBorder"]=Module["asm"]["oS"]).apply(null,arguments)};var _free=Module["_free"]=function(){return(_free=Module["_free"]=Module["asm"]["pS"]).apply(null,arguments)};var _malloc=Module["_malloc"]=function(){return(_malloc=Module["_malloc"]=Module["asm"]["qS"]).apply(null,arguments)};var _memset=Module["_memset"]=function(){return(_memset=Module["_memset"]=Module["asm"]["rS"]).apply(null,arguments)};var ___errno_location=Module["___errno_location"]=function(){return(___errno_location=Module["___errno_location"]=Module["asm"]["sS"]).apply(null,arguments)};var _htons=Module["_htons"]=function(){return(_htons=Module["_htons"]=Module["asm"]["tS"]).apply(null,arguments)};var __get_tzname=Module["__get_tzname"]=function(){return(__get_tzname=Module["__get_tzname"]=Module["asm"]["uS"]).apply(null,arguments)};var __get_daylight=Module["__get_daylight"]=function(){return(__get_daylight=Module["__get_daylight"]=Module["asm"]["vS"]).apply(null,arguments)};var __get_timezone=Module["__get_timezone"]=function(){return(__get_timezone=Module["__get_timezone"]=Module["asm"]["wS"]).apply(null,arguments)};var _setThrew=Module["_setThrew"]=function(){return(_setThrew=Module["_setThrew"]=Module["asm"]["xS"]).apply(null,arguments)};var stackSave=Module["stackSave"]=function(){return(stackSave=Module["stackSave"]=Module["asm"]["yS"]).apply(null,arguments)};var stackRestore=Module["stackRestore"]=function(){return(stackRestore=Module["stackRestore"]=Module["asm"]["zS"]).apply(null,arguments)};var __ZSt18uncaught_exceptionv=Module["__ZSt18uncaught_exceptionv"]=function(){return(__ZSt18uncaught_exceptionv=Module["__ZSt18uncaught_exceptionv"]=Module["asm"]["AS"]).apply(null,arguments)};var _memalign=Module["_memalign"]=function(){return(_memalign=Module["_memalign"]=Module["asm"]["BS"]).apply(null,arguments)};var dynCall_v=Module["dynCall_v"]=function(){return(dynCall_v=Module["dynCall_v"]=Module["asm"]["CS"]).apply(null,arguments)};var dynCall_vi=Module["dynCall_vi"]=function(){return(dynCall_vi=Module["dynCall_vi"]=Module["asm"]["DS"]).apply(null,arguments)};var dynCall_vii=Module["dynCall_vii"]=function(){return(dynCall_vii=Module["dynCall_vii"]=Module["asm"]["ES"]).apply(null,arguments)};var dynCall_viii=Module["dynCall_viii"]=function(){return(dynCall_viii=Module["dynCall_viii"]=Module["asm"]["FS"]).apply(null,arguments)};var dynCall_viiii=Module["dynCall_viiii"]=function(){return(dynCall_viiii=Module["dynCall_viiii"]=Module["asm"]["GS"]).apply(null,arguments)};var dynCall_viiiii=Module["dynCall_viiiii"]=function(){return(dynCall_viiiii=Module["dynCall_viiiii"]=Module["asm"]["HS"]).apply(null,arguments)};var dynCall_viiiiii=Module["dynCall_viiiiii"]=function(){return(dynCall_viiiiii=Module["dynCall_viiiiii"]=Module["asm"]["IS"]).apply(null,arguments)};var dynCall_viiiiiii=Module["dynCall_viiiiiii"]=function(){return(dynCall_viiiiiii=Module["dynCall_viiiiiii"]=Module["asm"]["JS"]).apply(null,arguments)};var dynCall_viiiiiiii=Module["dynCall_viiiiiiii"]=function(){return(dynCall_viiiiiiii=Module["dynCall_viiiiiiii"]=Module["asm"]["KS"]).apply(null,arguments)};var dynCall_viiiiiiiii=Module["dynCall_viiiiiiiii"]=function(){return(dynCall_viiiiiiiii=Module["dynCall_viiiiiiiii"]=Module["asm"]["LS"]).apply(null,arguments)};var dynCall_viiiiiiiiii=Module["dynCall_viiiiiiiiii"]=function(){return(dynCall_viiiiiiiiii=Module["dynCall_viiiiiiiiii"]=Module["asm"]["MS"]).apply(null,arguments)};var dynCall_viiiiiiiiiii=Module["dynCall_viiiiiiiiiii"]=function(){return(dynCall_viiiiiiiiiii=Module["dynCall_viiiiiiiiiii"]=Module["asm"]["NS"]).apply(null,arguments)};var dynCall_viiiiiiiiiiii=Module["dynCall_viiiiiiiiiiii"]=function(){return(dynCall_viiiiiiiiiiii=Module["dynCall_viiiiiiiiiiii"]=Module["asm"]["OS"]).apply(null,arguments)};var dynCall_viiiiiiiiiiiii=Module["dynCall_viiiiiiiiiiiii"]=function(){return(dynCall_viiiiiiiiiiiii=Module["dynCall_viiiiiiiiiiiii"]=Module["asm"]["PS"]).apply(null,arguments)};var dynCall_viiiiiiiiiiiiii=Module["dynCall_viiiiiiiiiiiiii"]=function(){return(dynCall_viiiiiiiiiiiiii=Module["dynCall_viiiiiiiiiiiiii"]=Module["asm"]["QS"]).apply(null,arguments)};var dynCall_viiiiiiiiiiiiiii=Module["dynCall_viiiiiiiiiiiiiii"]=function(){return(dynCall_viiiiiiiiiiiiiii=Module["dynCall_viiiiiiiiiiiiiii"]=Module["asm"]["RS"]).apply(null,arguments)};var dynCall_viiiiiiiiiiiiiiiii=Module["dynCall_viiiiiiiiiiiiiiiii"]=function(){return(dynCall_viiiiiiiiiiiiiiiii=Module["dynCall_viiiiiiiiiiiiiiiii"]=Module["asm"]["SS"]).apply(null,arguments)};var dynCall_viiiiiiiiiiiiiiiiii=Module["dynCall_viiiiiiiiiiiiiiiiii"]=function(){return(dynCall_viiiiiiiiiiiiiiiiii=Module["dynCall_viiiiiiiiiiiiiiiiii"]=Module["asm"]["TS"]).apply(null,arguments)};var dynCall_viiiiiiiiiiiiiiiiiii=Module["dynCall_viiiiiiiiiiiiiiiiiii"]=function(){return(dynCall_viiiiiiiiiiiiiiiiiii=Module["dynCall_viiiiiiiiiiiiiiiiiii"]=Module["asm"]["US"]).apply(null,arguments)};var dynCall_viiiiiiiiiiiiiiiiiiiii=Module["dynCall_viiiiiiiiiiiiiiiiiiiii"]=function(){return(dynCall_viiiiiiiiiiiiiiiiiiiii=Module["dynCall_viiiiiiiiiiiiiiiiiiiii"]=Module["asm"]["VS"]).apply(null,arguments)};var dynCall_viiiiiiiiiiiiiiiiiiiiii=Module["dynCall_viiiiiiiiiiiiiiiiiiiiii"]=function(){return(dynCall_viiiiiiiiiiiiiiiiiiiiii=Module["dynCall_viiiiiiiiiiiiiiiiiiiiii"]=Module["asm"]["WS"]).apply(null,arguments)};var dynCall_viiiiiiiiiiiiiiiiiiiiiii=Module["dynCall_viiiiiiiiiiiiiiiiiiiiiii"]=function(){return(dynCall_viiiiiiiiiiiiiiiiiiiiiii=Module["dynCall_viiiiiiiiiiiiiiiiiiiiiii"]=Module["asm"]["XS"]).apply(null,arguments)};var dynCall_viiiiiiiiiiiiiiiiiiiiiiiii=Module["dynCall_viiiiiiiiiiiiiiiiiiiiiiiii"]=function(){return(dynCall_viiiiiiiiiiiiiiiiiiiiiiiii=Module["dynCall_viiiiiiiiiiiiiiiiiiiiiiiii"]=Module["asm"]["YS"]).apply(null,arguments)};var dynCall_viiiiiiiiiiiiiiiiiiiiiiiiiii=Module["dynCall_viiiiiiiiiiiiiiiiiiiiiiiiiii"]=function(){return(dynCall_viiiiiiiiiiiiiiiiiiiiiiiiiii=Module["dynCall_viiiiiiiiiiiiiiiiiiiiiiiiiii"]=Module["asm"]["ZS"]).apply(null,arguments)};var dynCall_viiiiiiiiiiiiiiiiiiiddiiiiiiiiii=Module["dynCall_viiiiiiiiiiiiiiiiiiiddiiiiiiiiii"]=function(){return(dynCall_viiiiiiiiiiiiiiiiiiiddiiiiiiiiii=Module["dynCall_viiiiiiiiiiiiiiiiiiiddiiiiiiiiii"]=Module["asm"]["_S"]).apply(null,arguments)};var dynCall_viiiiiiiiiiiiiiiiiiidddiiiiiiiiii=Module["dynCall_viiiiiiiiiiiiiiiiiiidddiiiiiiiiii"]=function(){return(dynCall_viiiiiiiiiiiiiiiiiiidddiiiiiiiiii=Module["dynCall_viiiiiiiiiiiiiiiiiiidddiiiiiiiiii"]=Module["asm"]["$S"]).apply(null,arguments)};var dynCall_viiiiiiiiiiiiiiiiidddiiiiiiiiiiii=Module["dynCall_viiiiiiiiiiiiiiiiidddiiiiiiiiiiii"]=function(){return(dynCall_viiiiiiiiiiiiiiiiidddiiiiiiiiiiii=Module["dynCall_viiiiiiiiiiiiiiiiidddiiiiiiiiiiii"]=Module["asm"]["aT"]).apply(null,arguments)};var dynCall_viiiiiiiiiiiiiiddiiiiiiiii=Module["dynCall_viiiiiiiiiiiiiiddiiiiiiiii"]=function(){return(dynCall_viiiiiiiiiiiiiiddiiiiiiiii=Module["dynCall_viiiiiiiiiiiiiiddiiiiiiiii"]=Module["asm"]["bT"]).apply(null,arguments)};var dynCall_viiiiiiiiiiiiiidddiiiiiiiii=Module["dynCall_viiiiiiiiiiiiiidddiiiiiiiii"]=function(){return(dynCall_viiiiiiiiiiiiiidddiiiiiiiii=Module["dynCall_viiiiiiiiiiiiiidddiiiiiiiii"]=Module["asm"]["cT"]).apply(null,arguments)};var dynCall_viiiiiiiiiiiiiidddd=Module["dynCall_viiiiiiiiiiiiiidddd"]=function(){return(dynCall_viiiiiiiiiiiiiidddd=Module["dynCall_viiiiiiiiiiiiiidddd"]=Module["asm"]["dT"]).apply(null,arguments)};var dynCall_viiiiiiiiiiiiidi=Module["dynCall_viiiiiiiiiiiiidi"]=function(){return(dynCall_viiiiiiiiiiiiidi=Module["dynCall_viiiiiiiiiiiiidi"]=Module["asm"]["eT"]).apply(null,arguments)};var dynCall_viiiiiiiiiiiidi=Module["dynCall_viiiiiiiiiiiidi"]=function(){return(dynCall_viiiiiiiiiiiidi=Module["dynCall_viiiiiiiiiiiidi"]=Module["asm"]["fT"]).apply(null,arguments)};var dynCall_viiiiiiiiiiiidii=Module["dynCall_viiiiiiiiiiiidii"]=function(){return(dynCall_viiiiiiiiiiiidii=Module["dynCall_viiiiiiiiiiiidii"]=Module["asm"]["gT"]).apply(null,arguments)};var dynCall_viiiiiiiiiiidi=Module["dynCall_viiiiiiiiiiidi"]=function(){return(dynCall_viiiiiiiiiiidi=Module["dynCall_viiiiiiiiiiidi"]=Module["asm"]["hT"]).apply(null,arguments)};var dynCall_viiiiiiiiiiidd=Module["dynCall_viiiiiiiiiiidd"]=function(){return(dynCall_viiiiiiiiiiidd=Module["dynCall_viiiiiiiiiiidd"]=Module["asm"]["iT"]).apply(null,arguments)};var dynCall_viiiiiiiiiid=Module["dynCall_viiiiiiiiiid"]=function(){return(dynCall_viiiiiiiiiid=Module["dynCall_viiiiiiiiiid"]=Module["asm"]["jT"]).apply(null,arguments)};var dynCall_viiiiiiiiiiddi=Module["dynCall_viiiiiiiiiiddi"]=function(){return(dynCall_viiiiiiiiiiddi=Module["dynCall_viiiiiiiiiiddi"]=Module["asm"]["kT"]).apply(null,arguments)};var dynCall_viiiiiiiiiidddiii=Module["dynCall_viiiiiiiiiidddiii"]=function(){return(dynCall_viiiiiiiiiidddiii=Module["dynCall_viiiiiiiiiidddiii"]=Module["asm"]["lT"]).apply(null,arguments)};var dynCall_viiiiiiiiiidddiiiiii=Module["dynCall_viiiiiiiiiidddiiiiii"]=function(){return(dynCall_viiiiiiiiiidddiiiiii=Module["dynCall_viiiiiiiiiidddiiiiii"]=Module["asm"]["mT"]).apply(null,arguments)};var dynCall_viiiiiiiiid=Module["dynCall_viiiiiiiiid"]=function(){return(dynCall_viiiiiiiiid=Module["dynCall_viiiiiiiiid"]=Module["asm"]["nT"]).apply(null,arguments)};var dynCall_viiiiiiiiidd=Module["dynCall_viiiiiiiiidd"]=function(){return(dynCall_viiiiiiiiidd=Module["dynCall_viiiiiiiiidd"]=Module["asm"]["oT"]).apply(null,arguments)};var dynCall_viiiiiiiiiddi=Module["dynCall_viiiiiiiiiddi"]=function(){return(dynCall_viiiiiiiiiddi=Module["dynCall_viiiiiiiiiddi"]=Module["asm"]["pT"]).apply(null,arguments)};var dynCall_viiiiiiiiiddii=Module["dynCall_viiiiiiiiiddii"]=function(){return(dynCall_viiiiiiiiiddii=Module["dynCall_viiiiiiiiiddii"]=Module["asm"]["qT"]).apply(null,arguments)};var dynCall_viiiiiiiid=Module["dynCall_viiiiiiiid"]=function(){return(dynCall_viiiiiiiid=Module["dynCall_viiiiiiiid"]=Module["asm"]["rT"]).apply(null,arguments)};var dynCall_viiiiiiiidii=Module["dynCall_viiiiiiiidii"]=function(){return(dynCall_viiiiiiiidii=Module["dynCall_viiiiiiiidii"]=Module["asm"]["sT"]).apply(null,arguments)};var dynCall_viiiiiiiiddi=Module["dynCall_viiiiiiiiddi"]=function(){return(dynCall_viiiiiiiiddi=Module["dynCall_viiiiiiiiddi"]=Module["asm"]["tT"]).apply(null,arguments)};var dynCall_viiiiiiid=Module["dynCall_viiiiiiid"]=function(){return(dynCall_viiiiiiid=Module["dynCall_viiiiiiid"]=Module["asm"]["uT"]).apply(null,arguments)};var dynCall_viiiiiiidiiiidiii=Module["dynCall_viiiiiiidiiiidiii"]=function(){return(dynCall_viiiiiiidiiiidiii=Module["dynCall_viiiiiiidiiiidiii"]=Module["asm"]["vT"]).apply(null,arguments)};var dynCall_viiiiiiiddii=Module["dynCall_viiiiiiiddii"]=function(){return(dynCall_viiiiiiiddii=Module["dynCall_viiiiiiiddii"]=Module["asm"]["wT"]).apply(null,arguments)};var dynCall_viiiiiiiddiiii=Module["dynCall_viiiiiiiddiiii"]=function(){return(dynCall_viiiiiiiddiiii=Module["dynCall_viiiiiiiddiiii"]=Module["asm"]["xT"]).apply(null,arguments)};var dynCall_viiiiiiiddd=Module["dynCall_viiiiiiiddd"]=function(){return(dynCall_viiiiiiiddd=Module["dynCall_viiiiiiiddd"]=Module["asm"]["yT"]).apply(null,arguments)};var dynCall_viiiiiid=Module["dynCall_viiiiiid"]=function(){return(dynCall_viiiiiid=Module["dynCall_viiiiiid"]=Module["asm"]["zT"]).apply(null,arguments)};var dynCall_viiiiiidi=Module["dynCall_viiiiiidi"]=function(){return(dynCall_viiiiiidi=Module["dynCall_viiiiiidi"]=Module["asm"]["AT"]).apply(null,arguments)};var dynCall_viiiiiidii=Module["dynCall_viiiiiidii"]=function(){return(dynCall_viiiiiidii=Module["dynCall_viiiiiidii"]=Module["asm"]["BT"]).apply(null,arguments)};var dynCall_viiiiiidiii=Module["dynCall_viiiiiidiii"]=function(){return(dynCall_viiiiiidiii=Module["dynCall_viiiiiidiii"]=Module["asm"]["CT"]).apply(null,arguments)};var dynCall_viiiiiidiidid=Module["dynCall_viiiiiidiidid"]=function(){return(dynCall_viiiiiidiidid=Module["dynCall_viiiiiidiidid"]=Module["asm"]["DT"]).apply(null,arguments)};var dynCall_viiiiiididi=Module["dynCall_viiiiiididi"]=function(){return(dynCall_viiiiiididi=Module["dynCall_viiiiiididi"]=Module["asm"]["ET"]).apply(null,arguments)};var dynCall_viiiiiidd=Module["dynCall_viiiiiidd"]=function(){return(dynCall_viiiiiidd=Module["dynCall_viiiiiidd"]=Module["asm"]["FT"]).apply(null,arguments)};var dynCall_viiiiiiddi=Module["dynCall_viiiiiiddi"]=function(){return(dynCall_viiiiiiddi=Module["dynCall_viiiiiiddi"]=Module["asm"]["GT"]).apply(null,arguments)};var dynCall_viiiiiiddiii=Module["dynCall_viiiiiiddiii"]=function(){return(dynCall_viiiiiiddiii=Module["dynCall_viiiiiiddiii"]=Module["asm"]["HT"]).apply(null,arguments)};var dynCall_viiiiiiddiiii=Module["dynCall_viiiiiiddiiii"]=function(){return(dynCall_viiiiiiddiiii=Module["dynCall_viiiiiiddiiii"]=Module["asm"]["IT"]).apply(null,arguments)};var dynCall_viiiiiidddi=Module["dynCall_viiiiiidddi"]=function(){return(dynCall_viiiiiidddi=Module["dynCall_viiiiiidddi"]=Module["asm"]["JT"]).apply(null,arguments)};var dynCall_viiiiiiddddidd=Module["dynCall_viiiiiiddddidd"]=function(){return(dynCall_viiiiiiddddidd=Module["dynCall_viiiiiiddddidd"]=Module["asm"]["KT"]).apply(null,arguments)};var dynCall_viiiiiiddddiddi=Module["dynCall_viiiiiiddddiddi"]=function(){return(dynCall_viiiiiiddddiddi=Module["dynCall_viiiiiiddddiddi"]=Module["asm"]["LT"]).apply(null,arguments)};var dynCall_viiiiid=Module["dynCall_viiiiid"]=function(){return(dynCall_viiiiid=Module["dynCall_viiiiid"]=Module["asm"]["MT"]).apply(null,arguments)};var dynCall_viiiiidi=Module["dynCall_viiiiidi"]=function(){return(dynCall_viiiiidi=Module["dynCall_viiiiidi"]=Module["asm"]["NT"]).apply(null,arguments)};var dynCall_viiiiidii=Module["dynCall_viiiiidii"]=function(){return(dynCall_viiiiidii=Module["dynCall_viiiiidii"]=Module["asm"]["OT"]).apply(null,arguments)};var dynCall_viiiiidiii=Module["dynCall_viiiiidiii"]=function(){return(dynCall_viiiiidiii=Module["dynCall_viiiiidiii"]=Module["asm"]["PT"]).apply(null,arguments)};var dynCall_viiiiidd=Module["dynCall_viiiiidd"]=function(){return(dynCall_viiiiidd=Module["dynCall_viiiiidd"]=Module["asm"]["QT"]).apply(null,arguments)};var dynCall_viiiiiddi=Module["dynCall_viiiiiddi"]=function(){return(dynCall_viiiiiddi=Module["dynCall_viiiiiddi"]=Module["asm"]["RT"]).apply(null,arguments)};var dynCall_viiiiiddii=Module["dynCall_viiiiiddii"]=function(){return(dynCall_viiiiiddii=Module["dynCall_viiiiiddii"]=Module["asm"]["ST"]).apply(null,arguments)};var dynCall_viiiiiddiii=Module["dynCall_viiiiiddiii"]=function(){return(dynCall_viiiiiddiii=Module["dynCall_viiiiiddiii"]=Module["asm"]["TT"]).apply(null,arguments)};var dynCall_viiiiiddiiii=Module["dynCall_viiiiiddiiii"]=function(){return(dynCall_viiiiiddiiii=Module["dynCall_viiiiiddiiii"]=Module["asm"]["UT"]).apply(null,arguments)};var dynCall_viiiiiddiiiiii=Module["dynCall_viiiiiddiiiiii"]=function(){return(dynCall_viiiiiddiiiiii=Module["dynCall_viiiiiddiiiiii"]=Module["asm"]["VT"]).apply(null,arguments)};var dynCall_viiiiiddidd=Module["dynCall_viiiiiddidd"]=function(){return(dynCall_viiiiiddidd=Module["dynCall_viiiiiddidd"]=Module["asm"]["WT"]).apply(null,arguments)};var dynCall_viiiiiddd=Module["dynCall_viiiiiddd"]=function(){return(dynCall_viiiiiddd=Module["dynCall_viiiiiddd"]=Module["asm"]["XT"]).apply(null,arguments)};var dynCall_viiiiidddii=Module["dynCall_viiiiidddii"]=function(){return(dynCall_viiiiidddii=Module["dynCall_viiiiidddii"]=Module["asm"]["YT"]).apply(null,arguments)};var dynCall_viiiiidddiii=Module["dynCall_viiiiidddiii"]=function(){return(dynCall_viiiiidddiii=Module["dynCall_viiiiidddiii"]=Module["asm"]["ZT"]).apply(null,arguments)};var dynCall_viiiiidddd=Module["dynCall_viiiiidddd"]=function(){return(dynCall_viiiiidddd=Module["dynCall_viiiiidddd"]=Module["asm"]["_T"]).apply(null,arguments)};var dynCall_viiiiiddddi=Module["dynCall_viiiiiddddi"]=function(){return(dynCall_viiiiiddddi=Module["dynCall_viiiiiddddi"]=Module["asm"]["$T"]).apply(null,arguments)};var dynCall_viiiiiddddiddi=Module["dynCall_viiiiiddddiddi"]=function(){return(dynCall_viiiiiddddiddi=Module["dynCall_viiiiiddddiddi"]=Module["asm"]["aU"]).apply(null,arguments)};var dynCall_viiiiidddddddd=Module["dynCall_viiiiidddddddd"]=function(){return(dynCall_viiiiidddddddd=Module["dynCall_viiiiidddddddd"]=Module["asm"]["bU"]).apply(null,arguments)};var dynCall_viiiid=Module["dynCall_viiiid"]=function(){return(dynCall_viiiid=Module["dynCall_viiiid"]=Module["asm"]["cU"]).apply(null,arguments)};var dynCall_viiiidi=Module["dynCall_viiiidi"]=function(){return(dynCall_viiiidi=Module["dynCall_viiiidi"]=Module["asm"]["dU"]).apply(null,arguments)};var dynCall_viiiidii=Module["dynCall_viiiidii"]=function(){return(dynCall_viiiidii=Module["dynCall_viiiidii"]=Module["asm"]["eU"]).apply(null,arguments)};var dynCall_viiiidiii=Module["dynCall_viiiidiii"]=function(){return(dynCall_viiiidiii=Module["dynCall_viiiidiii"]=Module["asm"]["fU"]).apply(null,arguments)};var dynCall_viiiidiiii=Module["dynCall_viiiidiiii"]=function(){return(dynCall_viiiidiiii=Module["dynCall_viiiidiiii"]=Module["asm"]["gU"]).apply(null,arguments)};var dynCall_viiiidiiiiiidiiiiiiiiiii=Module["dynCall_viiiidiiiiiidiiiiiiiiiii"]=function(){return(dynCall_viiiidiiiiiidiiiiiiiiiii=Module["dynCall_viiiidiiiiiidiiiiiiiiiii"]=Module["asm"]["hU"]).apply(null,arguments)};var dynCall_viiiidiiidi=Module["dynCall_viiiidiiidi"]=function(){return(dynCall_viiiidiiidi=Module["dynCall_viiiidiiidi"]=Module["asm"]["iU"]).apply(null,arguments)};var dynCall_viiiidiidi=Module["dynCall_viiiidiidi"]=function(){return(dynCall_viiiidiidi=Module["dynCall_viiiidiidi"]=Module["asm"]["jU"]).apply(null,arguments)};var dynCall_viiiidd=Module["dynCall_viiiidd"]=function(){return(dynCall_viiiidd=Module["dynCall_viiiidd"]=Module["asm"]["kU"]).apply(null,arguments)};var dynCall_viiiiddi=Module["dynCall_viiiiddi"]=function(){return(dynCall_viiiiddi=Module["dynCall_viiiiddi"]=Module["asm"]["lU"]).apply(null,arguments)};var dynCall_viiiidddii=Module["dynCall_viiiidddii"]=function(){return(dynCall_viiiidddii=Module["dynCall_viiiidddii"]=Module["asm"]["mU"]).apply(null,arguments)};var dynCall_viiiidddiiiii=Module["dynCall_viiiidddiiiii"]=function(){return(dynCall_viiiidddiiiii=Module["dynCall_viiiidddiiiii"]=Module["asm"]["nU"]).apply(null,arguments)};var dynCall_viiiidddd=Module["dynCall_viiiidddd"]=function(){return(dynCall_viiiidddd=Module["dynCall_viiiidddd"]=Module["asm"]["oU"]).apply(null,arguments)};var dynCall_viiiiddddd=Module["dynCall_viiiiddddd"]=function(){return(dynCall_viiiiddddd=Module["dynCall_viiiiddddd"]=Module["asm"]["pU"]).apply(null,arguments)};var dynCall_viiiidddddd=Module["dynCall_viiiidddddd"]=function(){return(dynCall_viiiidddddd=Module["dynCall_viiiidddddd"]=Module["asm"]["qU"]).apply(null,arguments)};var dynCall_viiid=Module["dynCall_viiid"]=function(){return(dynCall_viiid=Module["dynCall_viiid"]=Module["asm"]["rU"]).apply(null,arguments)};var dynCall_viiidi=Module["dynCall_viiidi"]=function(){return(dynCall_viiidi=Module["dynCall_viiidi"]=Module["asm"]["sU"]).apply(null,arguments)};var dynCall_viiidii=Module["dynCall_viiidii"]=function(){return(dynCall_viiidii=Module["dynCall_viiidii"]=Module["asm"]["tU"]).apply(null,arguments)};var dynCall_viiidiii=Module["dynCall_viiidiii"]=function(){return(dynCall_viiidiii=Module["dynCall_viiidiii"]=Module["asm"]["uU"]).apply(null,arguments)};var dynCall_viiidiiii=Module["dynCall_viiidiiii"]=function(){return(dynCall_viiidiiii=Module["dynCall_viiidiiii"]=Module["asm"]["vU"]).apply(null,arguments)};var dynCall_viiidiiiii=Module["dynCall_viiidiiiii"]=function(){return(dynCall_viiidiiiii=Module["dynCall_viiidiiiii"]=Module["asm"]["wU"]).apply(null,arguments)};var dynCall_viiidiiiiiiiiii=Module["dynCall_viiidiiiiiiiiii"]=function(){return(dynCall_viiidiiiiiiiiii=Module["dynCall_viiidiiiiiiiiii"]=Module["asm"]["xU"]).apply(null,arguments)};var dynCall_viiidiiiiddiiiiii=Module["dynCall_viiidiiiiddiiiiii"]=function(){return(dynCall_viiidiiiiddiiiiii=Module["dynCall_viiidiiiiddiiiiii"]=Module["asm"]["yU"]).apply(null,arguments)};var dynCall_viiidiid=Module["dynCall_viiidiid"]=function(){return(dynCall_viiidiid=Module["dynCall_viiidiid"]=Module["asm"]["zU"]).apply(null,arguments)};var dynCall_viiidid=Module["dynCall_viiidid"]=function(){return(dynCall_viiidid=Module["dynCall_viiidid"]=Module["asm"]["AU"]).apply(null,arguments)};var dynCall_viiididi=Module["dynCall_viiididi"]=function(){return(dynCall_viiididi=Module["dynCall_viiididi"]=Module["asm"]["BU"]).apply(null,arguments)};var dynCall_viiidd=Module["dynCall_viiidd"]=function(){return(dynCall_viiidd=Module["dynCall_viiidd"]=Module["asm"]["CU"]).apply(null,arguments)};var dynCall_viiiddi=Module["dynCall_viiiddi"]=function(){return(dynCall_viiiddi=Module["dynCall_viiiddi"]=Module["asm"]["DU"]).apply(null,arguments)};var dynCall_viiiddii=Module["dynCall_viiiddii"]=function(){return(dynCall_viiiddii=Module["dynCall_viiiddii"]=Module["asm"]["EU"]).apply(null,arguments)};var dynCall_viiiddiiii=Module["dynCall_viiiddiiii"]=function(){return(dynCall_viiiddiiii=Module["dynCall_viiiddiiii"]=Module["asm"]["FU"]).apply(null,arguments)};var dynCall_viiiddiiiii=Module["dynCall_viiiddiiiii"]=function(){return(dynCall_viiiddiiiii=Module["dynCall_viiiddiiiii"]=Module["asm"]["GU"]).apply(null,arguments)};var dynCall_viiiddiiiiiiiiiiiiii=Module["dynCall_viiiddiiiiiiiiiiiiii"]=function(){return(dynCall_viiiddiiiiiiiiiiiiii=Module["dynCall_viiiddiiiiiiiiiiiiii"]=Module["asm"]["HU"]).apply(null,arguments)};var dynCall_viiiddid=Module["dynCall_viiiddid"]=function(){return(dynCall_viiiddid=Module["dynCall_viiiddid"]=Module["asm"]["IU"]).apply(null,arguments)};var dynCall_viiiddidiii=Module["dynCall_viiiddidiii"]=function(){return(dynCall_viiiddidiii=Module["dynCall_viiiddidiii"]=Module["asm"]["JU"]).apply(null,arguments)};var dynCall_viiiddidiiiii=Module["dynCall_viiiddidiiiii"]=function(){return(dynCall_viiiddidiiiii=Module["dynCall_viiiddidiiiii"]=Module["asm"]["KU"]).apply(null,arguments)};var dynCall_viiiddd=Module["dynCall_viiiddd"]=function(){return(dynCall_viiiddd=Module["dynCall_viiiddd"]=Module["asm"]["LU"]).apply(null,arguments)};var dynCall_viiidddi=Module["dynCall_viiidddi"]=function(){return(dynCall_viiidddi=Module["dynCall_viiidddi"]=Module["asm"]["MU"]).apply(null,arguments)};var dynCall_viiidddiii=Module["dynCall_viiidddiii"]=function(){return(dynCall_viiidddiii=Module["dynCall_viiidddiii"]=Module["asm"]["NU"]).apply(null,arguments)};var dynCall_viiidddd=Module["dynCall_viiidddd"]=function(){return(dynCall_viiidddd=Module["dynCall_viiidddd"]=Module["asm"]["OU"]).apply(null,arguments)};var dynCall_viiiddddi=Module["dynCall_viiiddddi"]=function(){return(dynCall_viiiddddi=Module["dynCall_viiiddddi"]=Module["asm"]["PU"]).apply(null,arguments)};var dynCall_viiiddddii=Module["dynCall_viiiddddii"]=function(){return(dynCall_viiiddddii=Module["dynCall_viiiddddii"]=Module["asm"]["QU"]).apply(null,arguments)};var dynCall_viiiddddiddi=Module["dynCall_viiiddddiddi"]=function(){return(dynCall_viiiddddiddi=Module["dynCall_viiiddddiddi"]=Module["asm"]["RU"]).apply(null,arguments)};var dynCall_viiiddddd=Module["dynCall_viiiddddd"]=function(){return(dynCall_viiiddddd=Module["dynCall_viiiddddd"]=Module["asm"]["SU"]).apply(null,arguments)};var dynCall_viid=Module["dynCall_viid"]=function(){return(dynCall_viid=Module["dynCall_viid"]=Module["asm"]["TU"]).apply(null,arguments)};var dynCall_viidi=Module["dynCall_viidi"]=function(){return(dynCall_viidi=Module["dynCall_viidi"]=Module["asm"]["UU"]).apply(null,arguments)};var dynCall_viidii=Module["dynCall_viidii"]=function(){return(dynCall_viidii=Module["dynCall_viidii"]=Module["asm"]["VU"]).apply(null,arguments)};var dynCall_viidiii=Module["dynCall_viidiii"]=function(){return(dynCall_viidiii=Module["dynCall_viidiii"]=Module["asm"]["WU"]).apply(null,arguments)};var dynCall_viidiiiii=Module["dynCall_viidiiiii"]=function(){return(dynCall_viidiiiii=Module["dynCall_viidiiiii"]=Module["asm"]["XU"]).apply(null,arguments)};var dynCall_viidiiiiii=Module["dynCall_viidiiiiii"]=function(){return(dynCall_viidiiiiii=Module["dynCall_viidiiiiii"]=Module["asm"]["YU"]).apply(null,arguments)};var dynCall_viidiiid=Module["dynCall_viidiiid"]=function(){return(dynCall_viidiiid=Module["dynCall_viidiiid"]=Module["asm"]["ZU"]).apply(null,arguments)};var dynCall_viidiiidddii=Module["dynCall_viidiiidddii"]=function(){return(dynCall_viidiiidddii=Module["dynCall_viidiiidddii"]=Module["asm"]["_U"]).apply(null,arguments)};var dynCall_viidiid=Module["dynCall_viidiid"]=function(){return(dynCall_viidiid=Module["dynCall_viidiid"]=Module["asm"]["$U"]).apply(null,arguments)};var dynCall_viidid=Module["dynCall_viidid"]=function(){return(dynCall_viidid=Module["dynCall_viidid"]=Module["asm"]["aV"]).apply(null,arguments)};var dynCall_viididi=Module["dynCall_viididi"]=function(){return(dynCall_viididi=Module["dynCall_viididi"]=Module["asm"]["bV"]).apply(null,arguments)};var dynCall_viididd=Module["dynCall_viididd"]=function(){return(dynCall_viididd=Module["dynCall_viididd"]=Module["asm"]["cV"]).apply(null,arguments)};var dynCall_viididdi=Module["dynCall_viididdi"]=function(){return(dynCall_viididdi=Module["dynCall_viididdi"]=Module["asm"]["dV"]).apply(null,arguments)};var dynCall_viidd=Module["dynCall_viidd"]=function(){return(dynCall_viidd=Module["dynCall_viidd"]=Module["asm"]["eV"]).apply(null,arguments)};var dynCall_viiddi=Module["dynCall_viiddi"]=function(){return(dynCall_viiddi=Module["dynCall_viiddi"]=Module["asm"]["fV"]).apply(null,arguments)};var dynCall_viiddii=Module["dynCall_viiddii"]=function(){return(dynCall_viiddii=Module["dynCall_viiddii"]=Module["asm"]["gV"]).apply(null,arguments)};var dynCall_viiddiii=Module["dynCall_viiddiii"]=function(){return(dynCall_viiddiii=Module["dynCall_viiddiii"]=Module["asm"]["hV"]).apply(null,arguments)};var dynCall_viiddiiii=Module["dynCall_viiddiiii"]=function(){return(dynCall_viiddiiii=Module["dynCall_viiddiiii"]=Module["asm"]["iV"]).apply(null,arguments)};var dynCall_viiddiiiiii=Module["dynCall_viiddiiiiii"]=function(){return(dynCall_viiddiiiiii=Module["dynCall_viiddiiiiii"]=Module["asm"]["jV"]).apply(null,arguments)};var dynCall_viiddiiiiiiii=Module["dynCall_viiddiiiiiiii"]=function(){return(dynCall_viiddiiiiiiii=Module["dynCall_viiddiiiiiiii"]=Module["asm"]["kV"]).apply(null,arguments)};var dynCall_viiddiidiiiiii=Module["dynCall_viiddiidiiiiii"]=function(){return(dynCall_viiddiidiiiiii=Module["dynCall_viiddiidiiiiii"]=Module["asm"]["lV"]).apply(null,arguments)};var dynCall_viiddid=Module["dynCall_viiddid"]=function(){return(dynCall_viiddid=Module["dynCall_viiddid"]=Module["asm"]["mV"]).apply(null,arguments)};var dynCall_viiddidi=Module["dynCall_viiddidi"]=function(){return(dynCall_viiddidi=Module["dynCall_viiddidi"]=Module["asm"]["nV"]).apply(null,arguments)};var dynCall_viiddidd=Module["dynCall_viiddidd"]=function(){return(dynCall_viiddidd=Module["dynCall_viiddidd"]=Module["asm"]["oV"]).apply(null,arguments)};var dynCall_viiddd=Module["dynCall_viiddd"]=function(){return(dynCall_viiddd=Module["dynCall_viiddd"]=Module["asm"]["pV"]).apply(null,arguments)};var dynCall_viidddi=Module["dynCall_viidddi"]=function(){return(dynCall_viidddi=Module["dynCall_viidddi"]=Module["asm"]["qV"]).apply(null,arguments)};var dynCall_viidddii=Module["dynCall_viidddii"]=function(){return(dynCall_viidddii=Module["dynCall_viidddii"]=Module["asm"]["rV"]).apply(null,arguments)};var dynCall_viidddiii=Module["dynCall_viidddiii"]=function(){return(dynCall_viidddiii=Module["dynCall_viidddiii"]=Module["asm"]["sV"]).apply(null,arguments)};var dynCall_viidddd=Module["dynCall_viidddd"]=function(){return(dynCall_viidddd=Module["dynCall_viidddd"]=Module["asm"]["tV"]).apply(null,arguments)};var dynCall_viiddddi=Module["dynCall_viiddddi"]=function(){return(dynCall_viiddddi=Module["dynCall_viiddddi"]=Module["asm"]["uV"]).apply(null,arguments)};var dynCall_viiddddiii=Module["dynCall_viiddddiii"]=function(){return(dynCall_viiddddiii=Module["dynCall_viiddddiii"]=Module["asm"]["vV"]).apply(null,arguments)};var dynCall_viiddddidd=Module["dynCall_viiddddidd"]=function(){return(dynCall_viiddddidd=Module["dynCall_viiddddidd"]=Module["asm"]["wV"]).apply(null,arguments)};var dynCall_viiddddiddd=Module["dynCall_viiddddiddd"]=function(){return(dynCall_viiddddiddd=Module["dynCall_viiddddiddd"]=Module["asm"]["xV"]).apply(null,arguments)};var dynCall_viiddddd=Module["dynCall_viiddddd"]=function(){return(dynCall_viiddddd=Module["dynCall_viiddddd"]=Module["asm"]["yV"]).apply(null,arguments)};var dynCall_viidddddi=Module["dynCall_viidddddi"]=function(){return(dynCall_viidddddi=Module["dynCall_viidddddi"]=Module["asm"]["zV"]).apply(null,arguments)};var dynCall_viidddddiii=Module["dynCall_viidddddiii"]=function(){return(dynCall_viidddddiii=Module["dynCall_viidddddiii"]=Module["asm"]["AV"]).apply(null,arguments)};var dynCall_viidddddd=Module["dynCall_viidddddd"]=function(){return(dynCall_viidddddd=Module["dynCall_viidddddd"]=Module["asm"]["BV"]).apply(null,arguments)};var dynCall_viidddddddiiii=Module["dynCall_viidddddddiiii"]=function(){return(dynCall_viidddddddiiii=Module["dynCall_viidddddddiiii"]=Module["asm"]["CV"]).apply(null,arguments)};var dynCall_viidddddddd=Module["dynCall_viidddddddd"]=function(){return(dynCall_viidddddddd=Module["dynCall_viidddddddd"]=Module["asm"]["DV"]).apply(null,arguments)};var dynCall_vid=Module["dynCall_vid"]=function(){return(dynCall_vid=Module["dynCall_vid"]=Module["asm"]["EV"]).apply(null,arguments)};var dynCall_vidi=Module["dynCall_vidi"]=function(){return(dynCall_vidi=Module["dynCall_vidi"]=Module["asm"]["FV"]).apply(null,arguments)};var dynCall_vidii=Module["dynCall_vidii"]=function(){return(dynCall_vidii=Module["dynCall_vidii"]=Module["asm"]["GV"]).apply(null,arguments)};var dynCall_vidiii=Module["dynCall_vidiii"]=function(){return(dynCall_vidiii=Module["dynCall_vidiii"]=Module["asm"]["HV"]).apply(null,arguments)};var dynCall_vidiiii=Module["dynCall_vidiiii"]=function(){return(dynCall_vidiiii=Module["dynCall_vidiiii"]=Module["asm"]["IV"]).apply(null,arguments)};var dynCall_vidiiiiii=Module["dynCall_vidiiiiii"]=function(){return(dynCall_vidiiiiii=Module["dynCall_vidiiiiii"]=Module["asm"]["JV"]).apply(null,arguments)};var dynCall_vidiiiiiiiiiii=Module["dynCall_vidiiiiiiiiiii"]=function(){return(dynCall_vidiiiiiiiiiii=Module["dynCall_vidiiiiiiiiiii"]=Module["asm"]["KV"]).apply(null,arguments)};var dynCall_vidiiiiidd=Module["dynCall_vidiiiiidd"]=function(){return(dynCall_vidiiiiidd=Module["dynCall_vidiiiiidd"]=Module["asm"]["LV"]).apply(null,arguments)};var dynCall_vidiiidi=Module["dynCall_vidiiidi"]=function(){return(dynCall_vidiiidi=Module["dynCall_vidiiidi"]=Module["asm"]["MV"]).apply(null,arguments)};var dynCall_vidiiiddii=Module["dynCall_vidiiiddii"]=function(){return(dynCall_vidiiiddii=Module["dynCall_vidiiiddii"]=Module["asm"]["NV"]).apply(null,arguments)};var dynCall_vidiidii=Module["dynCall_vidiidii"]=function(){return(dynCall_vidiidii=Module["dynCall_vidiidii"]=Module["asm"]["OV"]).apply(null,arguments)};var dynCall_vidiiddddii=Module["dynCall_vidiiddddii"]=function(){return(dynCall_vidiiddddii=Module["dynCall_vidiiddddii"]=Module["asm"]["PV"]).apply(null,arguments)};var dynCall_vidid=Module["dynCall_vidid"]=function(){return(dynCall_vidid=Module["dynCall_vidid"]=Module["asm"]["QV"]).apply(null,arguments)};var dynCall_vididi=Module["dynCall_vididi"]=function(){return(dynCall_vididi=Module["dynCall_vididi"]=Module["asm"]["RV"]).apply(null,arguments)};var dynCall_vididd=Module["dynCall_vididd"]=function(){return(dynCall_vididd=Module["dynCall_vididd"]=Module["asm"]["SV"]).apply(null,arguments)};var dynCall_vididdi=Module["dynCall_vididdi"]=function(){return(dynCall_vididdi=Module["dynCall_vididdi"]=Module["asm"]["TV"]).apply(null,arguments)};var dynCall_vidd=Module["dynCall_vidd"]=function(){return(dynCall_vidd=Module["dynCall_vidd"]=Module["asm"]["UV"]).apply(null,arguments)};var dynCall_viddi=Module["dynCall_viddi"]=function(){return(dynCall_viddi=Module["dynCall_viddi"]=Module["asm"]["VV"]).apply(null,arguments)};var dynCall_viddii=Module["dynCall_viddii"]=function(){return(dynCall_viddii=Module["dynCall_viddii"]=Module["asm"]["WV"]).apply(null,arguments)};var dynCall_viddiii=Module["dynCall_viddiii"]=function(){return(dynCall_viddiii=Module["dynCall_viddiii"]=Module["asm"]["XV"]).apply(null,arguments)};var dynCall_viddiiiiii=Module["dynCall_viddiiiiii"]=function(){return(dynCall_viddiiiiii=Module["dynCall_viddiiiiii"]=Module["asm"]["YV"]).apply(null,arguments)};var dynCall_viddiiiiiiiiii=Module["dynCall_viddiiiiiiiiii"]=function(){return(dynCall_viddiiiiiiiiii=Module["dynCall_viddiiiiiiiiii"]=Module["asm"]["ZV"]).apply(null,arguments)};var dynCall_viddiidiiidii=Module["dynCall_viddiidiiidii"]=function(){return(dynCall_viddiidiiidii=Module["dynCall_viddiidiiidii"]=Module["asm"]["_V"]).apply(null,arguments)};var dynCall_viddiididiiiiiiiiiiiiiiiiiii=Module["dynCall_viddiididiiiiiiiiiiiiiiiiiii"]=function(){return(dynCall_viddiididiiiiiiiiiiiiiiiiiii=Module["dynCall_viddiididiiiiiiiiiiiiiiiiiii"]=Module["asm"]["$V"]).apply(null,arguments)};var dynCall_viddiiddi=Module["dynCall_viddiiddi"]=function(){return(dynCall_viddiiddi=Module["dynCall_viddiiddi"]=Module["asm"]["aW"]).apply(null,arguments)};var dynCall_viddiiddiii=Module["dynCall_viddiiddiii"]=function(){return(dynCall_viddiiddiii=Module["dynCall_viddiiddiii"]=Module["asm"]["bW"]).apply(null,arguments)};var dynCall_viddid=Module["dynCall_viddid"]=function(){return(dynCall_viddid=Module["dynCall_viddid"]=Module["asm"]["cW"]).apply(null,arguments)};var dynCall_viddidd=Module["dynCall_viddidd"]=function(){return(dynCall_viddidd=Module["dynCall_viddidd"]=Module["asm"]["dW"]).apply(null,arguments)};var dynCall_viddidddiiii=Module["dynCall_viddidddiiii"]=function(){return(dynCall_viddidddiiii=Module["dynCall_viddidddiiii"]=Module["asm"]["eW"]).apply(null,arguments)};var dynCall_viddd=Module["dynCall_viddd"]=function(){return(dynCall_viddd=Module["dynCall_viddd"]=Module["asm"]["fW"]).apply(null,arguments)};var dynCall_vidddi=Module["dynCall_vidddi"]=function(){return(dynCall_vidddi=Module["dynCall_vidddi"]=Module["asm"]["gW"]).apply(null,arguments)};var dynCall_vidddii=Module["dynCall_vidddii"]=function(){return(dynCall_vidddii=Module["dynCall_vidddii"]=Module["asm"]["hW"]).apply(null,arguments)};var dynCall_vidddiii=Module["dynCall_vidddiii"]=function(){return(dynCall_vidddiii=Module["dynCall_vidddiii"]=Module["asm"]["iW"]).apply(null,arguments)};var dynCall_vidddiiidi=Module["dynCall_vidddiiidi"]=function(){return(dynCall_vidddiiidi=Module["dynCall_vidddiiidi"]=Module["asm"]["jW"]).apply(null,arguments)};var dynCall_vidddidddddd=Module["dynCall_vidddidddddd"]=function(){return(dynCall_vidddidddddd=Module["dynCall_vidddidddddd"]=Module["asm"]["kW"]).apply(null,arguments)};var dynCall_vidddd=Module["dynCall_vidddd"]=function(){return(dynCall_vidddd=Module["dynCall_vidddd"]=Module["asm"]["lW"]).apply(null,arguments)};var dynCall_viddddi=Module["dynCall_viddddi"]=function(){return(dynCall_viddddi=Module["dynCall_viddddi"]=Module["asm"]["mW"]).apply(null,arguments)};var dynCall_viddddii=Module["dynCall_viddddii"]=function(){return(dynCall_viddddii=Module["dynCall_viddddii"]=Module["asm"]["nW"]).apply(null,arguments)};var dynCall_viddddiii=Module["dynCall_viddddiii"]=function(){return(dynCall_viddddiii=Module["dynCall_viddddiii"]=Module["asm"]["oW"]).apply(null,arguments)};var dynCall_viddddiiii=Module["dynCall_viddddiiii"]=function(){return(dynCall_viddddiiii=Module["dynCall_viddddiiii"]=Module["asm"]["pW"]).apply(null,arguments)};var dynCall_viddddiiiii=Module["dynCall_viddddiiiii"]=function(){return(dynCall_viddddiiiii=Module["dynCall_viddddiiiii"]=Module["asm"]["qW"]).apply(null,arguments)};var dynCall_viddddiid=Module["dynCall_viddddiid"]=function(){return(dynCall_viddddiid=Module["dynCall_viddddiid"]=Module["asm"]["rW"]).apply(null,arguments)};var dynCall_viddddd=Module["dynCall_viddddd"]=function(){return(dynCall_viddddd=Module["dynCall_viddddd"]=Module["asm"]["sW"]).apply(null,arguments)};var dynCall_vidddddi=Module["dynCall_vidddddi"]=function(){return(dynCall_vidddddi=Module["dynCall_vidddddi"]=Module["asm"]["tW"]).apply(null,arguments)};var dynCall_vidddddiii=Module["dynCall_vidddddiii"]=function(){return(dynCall_vidddddiii=Module["dynCall_vidddddiii"]=Module["asm"]["uW"]).apply(null,arguments)};var dynCall_vidddddd=Module["dynCall_vidddddd"]=function(){return(dynCall_vidddddd=Module["dynCall_vidddddd"]=Module["asm"]["vW"]).apply(null,arguments)};var dynCall_viddddddiii=Module["dynCall_viddddddiii"]=function(){return(dynCall_viddddddiii=Module["dynCall_viddddddiii"]=Module["asm"]["wW"]).apply(null,arguments)};var dynCall_viddddddd=Module["dynCall_viddddddd"]=function(){return(dynCall_viddddddd=Module["dynCall_viddddddd"]=Module["asm"]["xW"]).apply(null,arguments)};var dynCall_vidddddddii=Module["dynCall_vidddddddii"]=function(){return(dynCall_vidddddddii=Module["dynCall_vidddddddii"]=Module["asm"]["yW"]).apply(null,arguments)};var dynCall_vidddddddddddd=Module["dynCall_vidddddddddddd"]=function(){return(dynCall_vidddddddddddd=Module["dynCall_vidddddddddddd"]=Module["asm"]["zW"]).apply(null,arguments)};var dynCall_vdi=Module["dynCall_vdi"]=function(){return(dynCall_vdi=Module["dynCall_vdi"]=Module["asm"]["AW"]).apply(null,arguments)};var dynCall_vdiii=Module["dynCall_vdiii"]=function(){return(dynCall_vdiii=Module["dynCall_vdiii"]=Module["asm"]["BW"]).apply(null,arguments)};var dynCall_vdiiii=Module["dynCall_vdiiii"]=function(){return(dynCall_vdiiii=Module["dynCall_vdiiii"]=Module["asm"]["CW"]).apply(null,arguments)};var dynCall_vdiiiii=Module["dynCall_vdiiiii"]=function(){return(dynCall_vdiiiii=Module["dynCall_vdiiiii"]=Module["asm"]["DW"]).apply(null,arguments)};var dynCall_vdiiiiiiii=Module["dynCall_vdiiiiiiii"]=function(){return(dynCall_vdiiiiiiii=Module["dynCall_vdiiiiiiii"]=Module["asm"]["EW"]).apply(null,arguments)};var dynCall_vdiiiiiiiii=Module["dynCall_vdiiiiiiiii"]=function(){return(dynCall_vdiiiiiiiii=Module["dynCall_vdiiiiiiiii"]=Module["asm"]["FW"]).apply(null,arguments)};var dynCall_vdiiiiiiiiii=Module["dynCall_vdiiiiiiiiii"]=function(){return(dynCall_vdiiiiiiiiii=Module["dynCall_vdiiiiiiiiii"]=Module["asm"]["GW"]).apply(null,arguments)};var dynCall_vdiiiiiiiiiii=Module["dynCall_vdiiiiiiiiiii"]=function(){return(dynCall_vdiiiiiiiiiii=Module["dynCall_vdiiiiiiiiiii"]=Module["asm"]["HW"]).apply(null,arguments)};var dynCall_vdidii=Module["dynCall_vdidii"]=function(){return(dynCall_vdidii=Module["dynCall_vdidii"]=Module["asm"]["IW"]).apply(null,arguments)};var dynCall_vdiddii=Module["dynCall_vdiddii"]=function(){return(dynCall_vdiddii=Module["dynCall_vdiddii"]=Module["asm"]["JW"]).apply(null,arguments)};var dynCall_vdiddiiii=Module["dynCall_vdiddiiii"]=function(){return(dynCall_vdiddiiii=Module["dynCall_vdiddiiii"]=Module["asm"]["KW"]).apply(null,arguments)};var dynCall_vdiddiiiiii=Module["dynCall_vdiddiiiiii"]=function(){return(dynCall_vdiddiiiiii=Module["dynCall_vdiddiiiiii"]=Module["asm"]["LW"]).apply(null,arguments)};var dynCall_vdiddddi=Module["dynCall_vdiddddi"]=function(){return(dynCall_vdiddddi=Module["dynCall_vdiddddi"]=Module["asm"]["MW"]).apply(null,arguments)};var dynCall_vddi=Module["dynCall_vddi"]=function(){return(dynCall_vddi=Module["dynCall_vddi"]=Module["asm"]["NW"]).apply(null,arguments)};var dynCall_vddii=Module["dynCall_vddii"]=function(){return(dynCall_vddii=Module["dynCall_vddii"]=Module["asm"]["OW"]).apply(null,arguments)};var dynCall_vddiii=Module["dynCall_vddiii"]=function(){return(dynCall_vddiii=Module["dynCall_vddiii"]=Module["asm"]["PW"]).apply(null,arguments)};var dynCall_vddiiii=Module["dynCall_vddiiii"]=function(){return(dynCall_vddiiii=Module["dynCall_vddiiii"]=Module["asm"]["QW"]).apply(null,arguments)};var dynCall_vddiiiiiii=Module["dynCall_vddiiiiiii"]=function(){return(dynCall_vddiiiiiii=Module["dynCall_vddiiiiiii"]=Module["asm"]["RW"]).apply(null,arguments)};var dynCall_vddiiiiiiiiiiiiiii=Module["dynCall_vddiiiiiiiiiiiiiii"]=function(){return(dynCall_vddiiiiiiiiiiiiiii=Module["dynCall_vddiiiiiiiiiiiiiii"]=Module["asm"]["SW"]).apply(null,arguments)};var dynCall_vddiiiiiiiiiiiiiiiii=Module["dynCall_vddiiiiiiiiiiiiiiiii"]=function(){return(dynCall_vddiiiiiiiiiiiiiiiii=Module["dynCall_vddiiiiiiiiiiiiiiiii"]=Module["asm"]["TW"]).apply(null,arguments)};var dynCall_vddiiiiiiiiiiiiiiiiiiii=Module["dynCall_vddiiiiiiiiiiiiiiiiiiii"]=function(){return(dynCall_vddiiiiiiiiiiiiiiiiiiii=Module["dynCall_vddiiiiiiiiiiiiiiiiiiii"]=Module["asm"]["UW"]).apply(null,arguments)};var dynCall_vddiiiiiiiiiiiiiiiiiiiiiiii=Module["dynCall_vddiiiiiiiiiiiiiiiiiiiiiiii"]=function(){return(dynCall_vddiiiiiiiiiiiiiiiiiiiiiiii=Module["dynCall_vddiiiiiiiiiiiiiiiiiiiiiiii"]=Module["asm"]["VW"]).apply(null,arguments)};var dynCall_vddidiii=Module["dynCall_vddidiii"]=function(){return(dynCall_vddidiii=Module["dynCall_vddidiii"]=Module["asm"]["WW"]).apply(null,arguments)};var dynCall_vddiddi=Module["dynCall_vddiddi"]=function(){return(dynCall_vddiddi=Module["dynCall_vddiddi"]=Module["asm"]["XW"]).apply(null,arguments)};var dynCall_vddiddiii=Module["dynCall_vddiddiii"]=function(){return(dynCall_vddiddiii=Module["dynCall_vddiddiii"]=Module["asm"]["YW"]).apply(null,arguments)};var dynCall_vddd=Module["dynCall_vddd"]=function(){return(dynCall_vddd=Module["dynCall_vddd"]=Module["asm"]["ZW"]).apply(null,arguments)};var dynCall_vdddii=Module["dynCall_vdddii"]=function(){return(dynCall_vdddii=Module["dynCall_vdddii"]=Module["asm"]["_W"]).apply(null,arguments)};var dynCall_vdddiii=Module["dynCall_vdddiii"]=function(){return(dynCall_vdddiii=Module["dynCall_vdddiii"]=Module["asm"]["$W"]).apply(null,arguments)};var dynCall_vdddiiii=Module["dynCall_vdddiiii"]=function(){return(dynCall_vdddiiii=Module["dynCall_vdddiiii"]=Module["asm"]["aX"]).apply(null,arguments)};var dynCall_vdddiiiiiiiii=Module["dynCall_vdddiiiiiiiii"]=function(){return(dynCall_vdddiiiiiiiii=Module["dynCall_vdddiiiiiiiii"]=Module["asm"]["bX"]).apply(null,arguments)};var dynCall_vddddiiiiiiiiiiii=Module["dynCall_vddddiiiiiiiiiiii"]=function(){return(dynCall_vddddiiiiiiiiiiii=Module["dynCall_vddddiiiiiiiiiiii"]=Module["asm"]["cX"]).apply(null,arguments)};var dynCall_i=Module["dynCall_i"]=function(){return(dynCall_i=Module["dynCall_i"]=Module["asm"]["dX"]).apply(null,arguments)};var dynCall_ii=Module["dynCall_ii"]=function(){return(dynCall_ii=Module["dynCall_ii"]=Module["asm"]["eX"]).apply(null,arguments)};var dynCall_iii=Module["dynCall_iii"]=function(){return(dynCall_iii=Module["dynCall_iii"]=Module["asm"]["fX"]).apply(null,arguments)};var dynCall_iiii=Module["dynCall_iiii"]=function(){return(dynCall_iiii=Module["dynCall_iiii"]=Module["asm"]["gX"]).apply(null,arguments)};var dynCall_iiiii=Module["dynCall_iiiii"]=function(){return(dynCall_iiiii=Module["dynCall_iiiii"]=Module["asm"]["hX"]).apply(null,arguments)};var dynCall_iiiiii=Module["dynCall_iiiiii"]=function(){return(dynCall_iiiiii=Module["dynCall_iiiiii"]=Module["asm"]["iX"]).apply(null,arguments)};var dynCall_iiiiiii=Module["dynCall_iiiiiii"]=function(){return(dynCall_iiiiiii=Module["dynCall_iiiiiii"]=Module["asm"]["jX"]).apply(null,arguments)};var dynCall_iiiiiiii=Module["dynCall_iiiiiiii"]=function(){return(dynCall_iiiiiiii=Module["dynCall_iiiiiiii"]=Module["asm"]["kX"]).apply(null,arguments)};var dynCall_iiiiiiiii=Module["dynCall_iiiiiiiii"]=function(){return(dynCall_iiiiiiiii=Module["dynCall_iiiiiiiii"]=Module["asm"]["lX"]).apply(null,arguments)};var dynCall_iiiiiiiiii=Module["dynCall_iiiiiiiiii"]=function(){return(dynCall_iiiiiiiiii=Module["dynCall_iiiiiiiiii"]=Module["asm"]["mX"]).apply(null,arguments)};var dynCall_iiiiiiiiiii=Module["dynCall_iiiiiiiiiii"]=function(){return(dynCall_iiiiiiiiiii=Module["dynCall_iiiiiiiiiii"]=Module["asm"]["nX"]).apply(null,arguments)};var dynCall_iiiiiiiiiiii=Module["dynCall_iiiiiiiiiiii"]=function(){return(dynCall_iiiiiiiiiiii=Module["dynCall_iiiiiiiiiiii"]=Module["asm"]["oX"]).apply(null,arguments)};var dynCall_iiiiiiiiiiiii=Module["dynCall_iiiiiiiiiiiii"]=function(){return(dynCall_iiiiiiiiiiiii=Module["dynCall_iiiiiiiiiiiii"]=Module["asm"]["pX"]).apply(null,arguments)};var dynCall_iiiiiiiiiiiiii=Module["dynCall_iiiiiiiiiiiiii"]=function(){return(dynCall_iiiiiiiiiiiiii=Module["dynCall_iiiiiiiiiiiiii"]=Module["asm"]["qX"]).apply(null,arguments)};var dynCall_iiiiiiiiiiiiiii=Module["dynCall_iiiiiiiiiiiiiii"]=function(){return(dynCall_iiiiiiiiiiiiiii=Module["dynCall_iiiiiiiiiiiiiii"]=Module["asm"]["rX"]).apply(null,arguments)};var dynCall_iiiiiiiiiiiiiiii=Module["dynCall_iiiiiiiiiiiiiiii"]=function(){return(dynCall_iiiiiiiiiiiiiiii=Module["dynCall_iiiiiiiiiiiiiiii"]=Module["asm"]["sX"]).apply(null,arguments)};var dynCall_iiiiiiiiiiiiiiiii=Module["dynCall_iiiiiiiiiiiiiiiii"]=function(){return(dynCall_iiiiiiiiiiiiiiiii=Module["dynCall_iiiiiiiiiiiiiiiii"]=Module["asm"]["tX"]).apply(null,arguments)};var dynCall_iiiiiiiiiiiiiiiiii=Module["dynCall_iiiiiiiiiiiiiiiiii"]=function(){return(dynCall_iiiiiiiiiiiiiiiiii=Module["dynCall_iiiiiiiiiiiiiiiiii"]=Module["asm"]["uX"]).apply(null,arguments)};var dynCall_iiiiiiiiiiiiiiiiiiii=Module["dynCall_iiiiiiiiiiiiiiiiiiii"]=function(){return(dynCall_iiiiiiiiiiiiiiiiiiii=Module["dynCall_iiiiiiiiiiiiiiiiiiii"]=Module["asm"]["vX"]).apply(null,arguments)};var dynCall_iiiiiiiiiiiiiiiiiiiiiiiii=Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"]=function(){return(dynCall_iiiiiiiiiiiiiiiiiiiiiiiii=Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"]=Module["asm"]["wX"]).apply(null,arguments)};var dynCall_iiiiiiiiiiiiiiiiiiiiiiiiiii=Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiiiii"]=function(){return(dynCall_iiiiiiiiiiiiiiiiiiiiiiiiiii=Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiiiii"]=Module["asm"]["xX"]).apply(null,arguments)};var dynCall_iiiiiiiiiiiiiiiiiiddddiiiiiiiiii=Module["dynCall_iiiiiiiiiiiiiiiiiiddddiiiiiiiiii"]=function(){return(dynCall_iiiiiiiiiiiiiiiiiiddddiiiiiiiiii=Module["dynCall_iiiiiiiiiiiiiiiiiiddddiiiiiiiiii"]=Module["asm"]["yX"]).apply(null,arguments)};var dynCall_iiiiiiiiiiiiiiiiiiddddiiiiiiiiiii=Module["dynCall_iiiiiiiiiiiiiiiiiiddddiiiiiiiiiii"]=function(){return(dynCall_iiiiiiiiiiiiiiiiiiddddiiiiiiiiiii=Module["dynCall_iiiiiiiiiiiiiiiiiiddddiiiiiiiiiii"]=Module["asm"]["zX"]).apply(null,arguments)};var dynCall_iiiiiiiiiiiiiiiiidddiiiiiiiii=Module["dynCall_iiiiiiiiiiiiiiiiidddiiiiiiiii"]=function(){return(dynCall_iiiiiiiiiiiiiiiiidddiiiiiiiii=Module["dynCall_iiiiiiiiiiiiiiiiidddiiiiiiiii"]=Module["asm"]["AX"]).apply(null,arguments)};var dynCall_iiiiiiiiiiiiiiiddddiiiiiiiii=Module["dynCall_iiiiiiiiiiiiiiiddddiiiiiiiii"]=function(){return(dynCall_iiiiiiiiiiiiiiiddddiiiiiiiii=Module["dynCall_iiiiiiiiiiiiiiiddddiiiiiiiii"]=Module["asm"]["BX"]).apply(null,arguments)};var dynCall_iiiiiiiiiiiiiiiddddiiiiiiiiii=Module["dynCall_iiiiiiiiiiiiiiiddddiiiiiiiiii"]=function(){return(dynCall_iiiiiiiiiiiiiiiddddiiiiiiiiii=Module["dynCall_iiiiiiiiiiiiiiiddddiiiiiiiiii"]=Module["asm"]["CX"]).apply(null,arguments)};var dynCall_iiiiiiiiiiiiiid=Module["dynCall_iiiiiiiiiiiiiid"]=function(){return(dynCall_iiiiiiiiiiiiiid=Module["dynCall_iiiiiiiiiiiiiid"]=Module["asm"]["DX"]).apply(null,arguments)};var dynCall_iiiiiiiiiiiiiiddi=Module["dynCall_iiiiiiiiiiiiiiddi"]=function(){return(dynCall_iiiiiiiiiiiiiiddi=Module["dynCall_iiiiiiiiiiiiiiddi"]=Module["asm"]["EX"]).apply(null,arguments)};var dynCall_iiiiiiiiiiiiid=Module["dynCall_iiiiiiiiiiiiid"]=function(){return(dynCall_iiiiiiiiiiiiid=Module["dynCall_iiiiiiiiiiiiid"]=Module["asm"]["FX"]).apply(null,arguments)};var dynCall_iiiiiiiiiiiid=Module["dynCall_iiiiiiiiiiiid"]=function(){return(dynCall_iiiiiiiiiiiid=Module["dynCall_iiiiiiiiiiiid"]=Module["asm"]["GX"]).apply(null,arguments)};var dynCall_iiiiiiiiiiiiddiiiiii=Module["dynCall_iiiiiiiiiiiiddiiiiii"]=function(){return(dynCall_iiiiiiiiiiiiddiiiiii=Module["dynCall_iiiiiiiiiiiiddiiiiii"]=Module["asm"]["HX"]).apply(null,arguments)};var dynCall_iiiiiiiiiiiiddddiiiiiiiii=Module["dynCall_iiiiiiiiiiiiddddiiiiiiiii"]=function(){return(dynCall_iiiiiiiiiiiiddddiiiiiiiii=Module["dynCall_iiiiiiiiiiiiddddiiiiiiiii"]=Module["asm"]["IX"]).apply(null,arguments)};var dynCall_iiiiiiiiiiiiddddiiiiiiiiiiiiii=Module["dynCall_iiiiiiiiiiiiddddiiiiiiiiiiiiii"]=function(){return(dynCall_iiiiiiiiiiiiddddiiiiiiiiiiiiii=Module["dynCall_iiiiiiiiiiiiddddiiiiiiiiiiiiii"]=Module["asm"]["JX"]).apply(null,arguments)};var dynCall_iiiiiiiiiiidi=Module["dynCall_iiiiiiiiiiidi"]=function(){return(dynCall_iiiiiiiiiiidi=Module["dynCall_iiiiiiiiiiidi"]=Module["asm"]["KX"]).apply(null,arguments)};var dynCall_iiiiiiiiiiiddddiiiiiiiiii=Module["dynCall_iiiiiiiiiiiddddiiiiiiiiii"]=function(){return(dynCall_iiiiiiiiiiiddddiiiiiiiiii=Module["dynCall_iiiiiiiiiiiddddiiiiiiiiii"]=Module["asm"]["LX"]).apply(null,arguments)};var dynCall_iiiiiiiiiiiddddiiiiiiiiiii=Module["dynCall_iiiiiiiiiiiddddiiiiiiiiiii"]=function(){return(dynCall_iiiiiiiiiiiddddiiiiiiiiiii=Module["dynCall_iiiiiiiiiiiddddiiiiiiiiiii"]=Module["asm"]["MX"]).apply(null,arguments)};var dynCall_iiiiiiiiiid=Module["dynCall_iiiiiiiiiid"]=function(){return(dynCall_iiiiiiiiiid=Module["dynCall_iiiiiiiiiid"]=Module["asm"]["NX"]).apply(null,arguments)};var dynCall_iiiiiiiiiidiiiiiiiiii=Module["dynCall_iiiiiiiiiidiiiiiiiiii"]=function(){return(dynCall_iiiiiiiiiidiiiiiiiiii=Module["dynCall_iiiiiiiiiidiiiiiiiiii"]=Module["asm"]["OX"]).apply(null,arguments)};var dynCall_iiiiiiiiiiddidd=Module["dynCall_iiiiiiiiiiddidd"]=function(){return(dynCall_iiiiiiiiiiddidd=Module["dynCall_iiiiiiiiiiddidd"]=Module["asm"]["PX"]).apply(null,arguments)};var dynCall_iiiiiiiiiidddiiiiiiiiii=Module["dynCall_iiiiiiiiiidddiiiiiiiiii"]=function(){return(dynCall_iiiiiiiiiidddiiiiiiiiii=Module["dynCall_iiiiiiiiiidddiiiiiiiiii"]=Module["asm"]["QX"]).apply(null,arguments)};var dynCall_iiiiiiiiid=Module["dynCall_iiiiiiiiid"]=function(){return(dynCall_iiiiiiiiid=Module["dynCall_iiiiiiiiid"]=Module["asm"]["RX"]).apply(null,arguments)};var dynCall_iiiiiiiiidi=Module["dynCall_iiiiiiiiidi"]=function(){return(dynCall_iiiiiiiiidi=Module["dynCall_iiiiiiiiidi"]=Module["asm"]["SX"]).apply(null,arguments)};var dynCall_iiiiiiiiidiii=Module["dynCall_iiiiiiiiidiii"]=function(){return(dynCall_iiiiiiiiidiii=Module["dynCall_iiiiiiiiidiii"]=Module["asm"]["TX"]).apply(null,arguments)};var dynCall_iiiiiiiiidiiii=Module["dynCall_iiiiiiiiidiiii"]=function(){return(dynCall_iiiiiiiiidiiii=Module["dynCall_iiiiiiiiidiiii"]=Module["asm"]["UX"]).apply(null,arguments)};var dynCall_iiiiiiiiiddiiii=Module["dynCall_iiiiiiiiiddiiii"]=function(){return(dynCall_iiiiiiiiiddiiii=Module["dynCall_iiiiiiiiiddiiii"]=Module["asm"]["VX"]).apply(null,arguments)};var dynCall_iiiiiiiiidddd=Module["dynCall_iiiiiiiiidddd"]=function(){return(dynCall_iiiiiiiiidddd=Module["dynCall_iiiiiiiiidddd"]=Module["asm"]["WX"]).apply(null,arguments)};var dynCall_iiiiiiiiiddddii=Module["dynCall_iiiiiiiiiddddii"]=function(){return(dynCall_iiiiiiiiiddddii=Module["dynCall_iiiiiiiiiddddii"]=Module["asm"]["XX"]).apply(null,arguments)};var dynCall_iiiiiiiid=Module["dynCall_iiiiiiiid"]=function(){return(dynCall_iiiiiiiid=Module["dynCall_iiiiiiiid"]=Module["asm"]["YX"]).apply(null,arguments)};var dynCall_iiiiiiiidiii=Module["dynCall_iiiiiiiidiii"]=function(){return(dynCall_iiiiiiiidiii=Module["dynCall_iiiiiiiidiii"]=Module["asm"]["ZX"]).apply(null,arguments)};var dynCall_iiiiiiiididd=Module["dynCall_iiiiiiiididd"]=function(){return(dynCall_iiiiiiiididd=Module["dynCall_iiiiiiiididd"]=Module["asm"]["_X"]).apply(null,arguments)};var dynCall_iiiiiiiidd=Module["dynCall_iiiiiiiidd"]=function(){return(dynCall_iiiiiiiidd=Module["dynCall_iiiiiiiidd"]=Module["asm"]["$X"]).apply(null,arguments)};var dynCall_iiiiiiiiddi=Module["dynCall_iiiiiiiiddi"]=function(){return(dynCall_iiiiiiiiddi=Module["dynCall_iiiiiiiiddi"]=Module["asm"]["aY"]).apply(null,arguments)};var dynCall_iiiiiiiiddii=Module["dynCall_iiiiiiiiddii"]=function(){return(dynCall_iiiiiiiiddii=Module["dynCall_iiiiiiiiddii"]=Module["asm"]["bY"]).apply(null,arguments)};var dynCall_iiiiiiiiddiiii=Module["dynCall_iiiiiiiiddiiii"]=function(){return(dynCall_iiiiiiiiddiiii=Module["dynCall_iiiiiiiiddiiii"]=Module["asm"]["cY"]).apply(null,arguments)};var dynCall_iiiiiiiiddiiiii=Module["dynCall_iiiiiiiiddiiiii"]=function(){return(dynCall_iiiiiiiiddiiiii=Module["dynCall_iiiiiiiiddiiiii"]=Module["asm"]["dY"]).apply(null,arguments)};var dynCall_iiiiiiiiddidi=Module["dynCall_iiiiiiiiddidi"]=function(){return(dynCall_iiiiiiiiddidi=Module["dynCall_iiiiiiiiddidi"]=Module["asm"]["eY"]).apply(null,arguments)};var dynCall_iiiiiiiidddddiiidddd=Module["dynCall_iiiiiiiidddddiiidddd"]=function(){return(dynCall_iiiiiiiidddddiiidddd=Module["dynCall_iiiiiiiidddddiiidddd"]=Module["asm"]["fY"]).apply(null,arguments)};var dynCall_iiiiiiiidddddddddiiddii=Module["dynCall_iiiiiiiidddddddddiiddii"]=function(){return(dynCall_iiiiiiiidddddddddiiddii=Module["dynCall_iiiiiiiidddddddddiiddii"]=Module["asm"]["gY"]).apply(null,arguments)};var dynCall_iiiiiiid=Module["dynCall_iiiiiiid"]=function(){return(dynCall_iiiiiiid=Module["dynCall_iiiiiiid"]=Module["asm"]["hY"]).apply(null,arguments)};var dynCall_iiiiiiididi=Module["dynCall_iiiiiiididi"]=function(){return(dynCall_iiiiiiididi=Module["dynCall_iiiiiiididi"]=Module["asm"]["iY"]).apply(null,arguments)};var dynCall_iiiiiiiddi=Module["dynCall_iiiiiiiddi"]=function(){return(dynCall_iiiiiiiddi=Module["dynCall_iiiiiiiddi"]=Module["asm"]["jY"]).apply(null,arguments)};var dynCall_iiiiiiiddidii=Module["dynCall_iiiiiiiddidii"]=function(){return(dynCall_iiiiiiiddidii=Module["dynCall_iiiiiiiddidii"]=Module["asm"]["kY"]).apply(null,arguments)};var dynCall_iiiiiiiddiddiiiiii=Module["dynCall_iiiiiiiddiddiiiiii"]=function(){return(dynCall_iiiiiiiddiddiiiiii=Module["dynCall_iiiiiiiddiddiiiiii"]=Module["asm"]["lY"]).apply(null,arguments)};var dynCall_iiiiiid=Module["dynCall_iiiiiid"]=function(){return(dynCall_iiiiiid=Module["dynCall_iiiiiid"]=Module["asm"]["mY"]).apply(null,arguments)};var dynCall_iiiiiidi=Module["dynCall_iiiiiidi"]=function(){return(dynCall_iiiiiidi=Module["dynCall_iiiiiidi"]=Module["asm"]["nY"]).apply(null,arguments)};var dynCall_iiiiiidiii=Module["dynCall_iiiiiidiii"]=function(){return(dynCall_iiiiiidiii=Module["dynCall_iiiiiidiii"]=Module["asm"]["oY"]).apply(null,arguments)};var dynCall_iiiiiidiiiii=Module["dynCall_iiiiiidiiiii"]=function(){return(dynCall_iiiiiidiiiii=Module["dynCall_iiiiiidiiiii"]=Module["asm"]["pY"]).apply(null,arguments)};var dynCall_iiiiiidiiidd=Module["dynCall_iiiiiidiiidd"]=function(){return(dynCall_iiiiiidiiidd=Module["dynCall_iiiiiidiiidd"]=Module["asm"]["qY"]).apply(null,arguments)};var dynCall_iiiiiidd=Module["dynCall_iiiiiidd"]=function(){return(dynCall_iiiiiidd=Module["dynCall_iiiiiidd"]=Module["asm"]["rY"]).apply(null,arguments)};var dynCall_iiiiiiddi=Module["dynCall_iiiiiiddi"]=function(){return(dynCall_iiiiiiddi=Module["dynCall_iiiiiiddi"]=Module["asm"]["sY"]).apply(null,arguments)};var dynCall_iiiiiiddiiiii=Module["dynCall_iiiiiiddiiiii"]=function(){return(dynCall_iiiiiiddiiiii=Module["dynCall_iiiiiiddiiiii"]=Module["asm"]["tY"]).apply(null,arguments)};var dynCall_iiiiiiddiiddidii=Module["dynCall_iiiiiiddiiddidii"]=function(){return(dynCall_iiiiiiddiiddidii=Module["dynCall_iiiiiiddiiddidii"]=Module["asm"]["uY"]).apply(null,arguments)};var dynCall_iiiiiiddiddiii=Module["dynCall_iiiiiiddiddiii"]=function(){return(dynCall_iiiiiiddiddiii=Module["dynCall_iiiiiiddiddiii"]=Module["asm"]["vY"]).apply(null,arguments)};var dynCall_iiiiiiddiddiiiii=Module["dynCall_iiiiiiddiddiiiii"]=function(){return(dynCall_iiiiiiddiddiiiii=Module["dynCall_iiiiiiddiddiiiii"]=Module["asm"]["wY"]).apply(null,arguments)};var dynCall_iiiiiidddii=Module["dynCall_iiiiiidddii"]=function(){return(dynCall_iiiiiidddii=Module["dynCall_iiiiiidddii"]=Module["asm"]["xY"]).apply(null,arguments)};var dynCall_iiiiid=Module["dynCall_iiiiid"]=function(){return(dynCall_iiiiid=Module["dynCall_iiiiid"]=Module["asm"]["yY"]).apply(null,arguments)};var dynCall_iiiiidi=Module["dynCall_iiiiidi"]=function(){return(dynCall_iiiiidi=Module["dynCall_iiiiidi"]=Module["asm"]["zY"]).apply(null,arguments)};var dynCall_iiiiidii=Module["dynCall_iiiiidii"]=function(){return(dynCall_iiiiidii=Module["dynCall_iiiiidii"]=Module["asm"]["AY"]).apply(null,arguments)};var dynCall_iiiiidiii=Module["dynCall_iiiiidiii"]=function(){return(dynCall_iiiiidiii=Module["dynCall_iiiiidiii"]=Module["asm"]["BY"]).apply(null,arguments)};var dynCall_iiiiidiiiiii=Module["dynCall_iiiiidiiiiii"]=function(){return(dynCall_iiiiidiiiiii=Module["dynCall_iiiiidiiiiii"]=Module["asm"]["CY"]).apply(null,arguments)};var dynCall_iiiiidiiidi=Module["dynCall_iiiiidiiidi"]=function(){return(dynCall_iiiiidiiidi=Module["dynCall_iiiiidiiidi"]=Module["asm"]["DY"]).apply(null,arguments)};var dynCall_iiiiidiidd=Module["dynCall_iiiiidiidd"]=function(){return(dynCall_iiiiidiidd=Module["dynCall_iiiiidiidd"]=Module["asm"]["EY"]).apply(null,arguments)};var dynCall_iiiiididi=Module["dynCall_iiiiididi"]=function(){return(dynCall_iiiiididi=Module["dynCall_iiiiididi"]=Module["asm"]["FY"]).apply(null,arguments)};var dynCall_iiiiidd=Module["dynCall_iiiiidd"]=function(){return(dynCall_iiiiidd=Module["dynCall_iiiiidd"]=Module["asm"]["GY"]).apply(null,arguments)};var dynCall_iiiiiddi=Module["dynCall_iiiiiddi"]=function(){return(dynCall_iiiiiddi=Module["dynCall_iiiiiddi"]=Module["asm"]["HY"]).apply(null,arguments)};var dynCall_iiiiiddii=Module["dynCall_iiiiiddii"]=function(){return(dynCall_iiiiiddii=Module["dynCall_iiiiiddii"]=Module["asm"]["IY"]).apply(null,arguments)};var dynCall_iiiiiddiii=Module["dynCall_iiiiiddiii"]=function(){return(dynCall_iiiiiddiii=Module["dynCall_iiiiiddiii"]=Module["asm"]["JY"]).apply(null,arguments)};var dynCall_iiiiiddiiiiiii=Module["dynCall_iiiiiddiiiiiii"]=function(){return(dynCall_iiiiiddiiiiiii=Module["dynCall_iiiiiddiiiiiii"]=Module["asm"]["KY"]).apply(null,arguments)};var dynCall_iiiiiddiididii=Module["dynCall_iiiiiddiididii"]=function(){return(dynCall_iiiiiddiididii=Module["dynCall_iiiiiddiididii"]=Module["asm"]["LY"]).apply(null,arguments)};var dynCall_iiiiiddiiddidiii=Module["dynCall_iiiiiddiiddidiii"]=function(){return(dynCall_iiiiiddiiddidiii=Module["dynCall_iiiiiddiiddidiii"]=Module["asm"]["MY"]).apply(null,arguments)};var dynCall_iiiiiddidi=Module["dynCall_iiiiiddidi"]=function(){return(dynCall_iiiiiddidi=Module["dynCall_iiiiiddidi"]=Module["asm"]["NY"]).apply(null,arguments)};var dynCall_iiiiiddd=Module["dynCall_iiiiiddd"]=function(){return(dynCall_iiiiiddd=Module["dynCall_iiiiiddd"]=Module["asm"]["OY"]).apply(null,arguments)};var dynCall_iiiiidddd=Module["dynCall_iiiiidddd"]=function(){return(dynCall_iiiiidddd=Module["dynCall_iiiiidddd"]=Module["asm"]["PY"]).apply(null,arguments)};var dynCall_iiiiiddddi=Module["dynCall_iiiiiddddi"]=function(){return(dynCall_iiiiiddddi=Module["dynCall_iiiiiddddi"]=Module["asm"]["QY"]).apply(null,arguments)};var dynCall_iiiid=Module["dynCall_iiiid"]=function(){return(dynCall_iiiid=Module["dynCall_iiiid"]=Module["asm"]["RY"]).apply(null,arguments)};var dynCall_iiiidi=Module["dynCall_iiiidi"]=function(){return(dynCall_iiiidi=Module["dynCall_iiiidi"]=Module["asm"]["SY"]).apply(null,arguments)};var dynCall_iiiidii=Module["dynCall_iiiidii"]=function(){return(dynCall_iiiidii=Module["dynCall_iiiidii"]=Module["asm"]["TY"]).apply(null,arguments)};var dynCall_iiiidiii=Module["dynCall_iiiidiii"]=function(){return(dynCall_iiiidiii=Module["dynCall_iiiidiii"]=Module["asm"]["UY"]).apply(null,arguments)};var dynCall_iiiidiiii=Module["dynCall_iiiidiiii"]=function(){return(dynCall_iiiidiiii=Module["dynCall_iiiidiiii"]=Module["asm"]["VY"]).apply(null,arguments)};var dynCall_iiiidiiiii=Module["dynCall_iiiidiiiii"]=function(){return(dynCall_iiiidiiiii=Module["dynCall_iiiidiiiii"]=Module["asm"]["WY"]).apply(null,arguments)};var dynCall_iiiidiiiiiid=Module["dynCall_iiiidiiiiiid"]=function(){return(dynCall_iiiidiiiiiid=Module["dynCall_iiiidiiiiiid"]=Module["asm"]["XY"]).apply(null,arguments)};var dynCall_iiiidiiid=Module["dynCall_iiiidiiid"]=function(){return(dynCall_iiiidiiid=Module["dynCall_iiiidiiid"]=Module["asm"]["YY"]).apply(null,arguments)};var dynCall_iiiidiiiddddddd=Module["dynCall_iiiidiiiddddddd"]=function(){return(dynCall_iiiidiiiddddddd=Module["dynCall_iiiidiiiddddddd"]=Module["asm"]["ZY"]).apply(null,arguments)};var dynCall_iiiidid=Module["dynCall_iiiidid"]=function(){return(dynCall_iiiidid=Module["dynCall_iiiidid"]=Module["asm"]["_Y"]).apply(null,arguments)};var dynCall_iiiididi=Module["dynCall_iiiididi"]=function(){return(dynCall_iiiididi=Module["dynCall_iiiididi"]=Module["asm"]["$Y"]).apply(null,arguments)};var dynCall_iiiidd=Module["dynCall_iiiidd"]=function(){return(dynCall_iiiidd=Module["dynCall_iiiidd"]=Module["asm"]["aZ"]).apply(null,arguments)};var dynCall_iiiiddi=Module["dynCall_iiiiddi"]=function(){return(dynCall_iiiiddi=Module["dynCall_iiiiddi"]=Module["asm"]["bZ"]).apply(null,arguments)};var dynCall_iiiiddii=Module["dynCall_iiiiddii"]=function(){return(dynCall_iiiiddii=Module["dynCall_iiiiddii"]=Module["asm"]["cZ"]).apply(null,arguments)};var dynCall_iiiiddiii=Module["dynCall_iiiiddiii"]=function(){return(dynCall_iiiiddiii=Module["dynCall_iiiiddiii"]=Module["asm"]["dZ"]).apply(null,arguments)};var dynCall_iiiiddiiii=Module["dynCall_iiiiddiiii"]=function(){return(dynCall_iiiiddiiii=Module["dynCall_iiiiddiiii"]=Module["asm"]["eZ"]).apply(null,arguments)};var dynCall_iiiiddiid=Module["dynCall_iiiiddiid"]=function(){return(dynCall_iiiiddiid=Module["dynCall_iiiiddiid"]=Module["asm"]["fZ"]).apply(null,arguments)};var dynCall_iiiiddiddiiii=Module["dynCall_iiiiddiddiiii"]=function(){return(dynCall_iiiiddiddiiii=Module["dynCall_iiiiddiddiiii"]=Module["asm"]["gZ"]).apply(null,arguments)};var dynCall_iiiiddd=Module["dynCall_iiiiddd"]=function(){return(dynCall_iiiiddd=Module["dynCall_iiiiddd"]=Module["asm"]["hZ"]).apply(null,arguments)};var dynCall_iiiidddi=Module["dynCall_iiiidddi"]=function(){return(dynCall_iiiidddi=Module["dynCall_iiiidddi"]=Module["asm"]["iZ"]).apply(null,arguments)};var dynCall_iiiidddiiii=Module["dynCall_iiiidddiiii"]=function(){return(dynCall_iiiidddiiii=Module["dynCall_iiiidddiiii"]=Module["asm"]["jZ"]).apply(null,arguments)};var dynCall_iiiidddiiiii=Module["dynCall_iiiidddiiiii"]=function(){return(dynCall_iiiidddiiiii=Module["dynCall_iiiidddiiiii"]=Module["asm"]["kZ"]).apply(null,arguments)};var dynCall_iiiidddid=Module["dynCall_iiiidddid"]=function(){return(dynCall_iiiidddid=Module["dynCall_iiiidddid"]=Module["asm"]["lZ"]).apply(null,arguments)};var dynCall_iiiidddd=Module["dynCall_iiiidddd"]=function(){return(dynCall_iiiidddd=Module["dynCall_iiiidddd"]=Module["asm"]["mZ"]).apply(null,arguments)};var dynCall_iiiiddddi=Module["dynCall_iiiiddddi"]=function(){return(dynCall_iiiiddddi=Module["dynCall_iiiiddddi"]=Module["asm"]["nZ"]).apply(null,arguments)};var dynCall_iiiiddddidd=Module["dynCall_iiiiddddidd"]=function(){return(dynCall_iiiiddddidd=Module["dynCall_iiiiddddidd"]=Module["asm"]["oZ"]).apply(null,arguments)};var dynCall_iiiidddddd=Module["dynCall_iiiidddddd"]=function(){return(dynCall_iiiidddddd=Module["dynCall_iiiidddddd"]=Module["asm"]["pZ"]).apply(null,arguments)};var dynCall_iiiiddddddi=Module["dynCall_iiiiddddddi"]=function(){return(dynCall_iiiiddddddi=Module["dynCall_iiiiddddddi"]=Module["asm"]["qZ"]).apply(null,arguments)};var dynCall_iiiiddddddii=Module["dynCall_iiiiddddddii"]=function(){return(dynCall_iiiiddddddii=Module["dynCall_iiiiddddddii"]=Module["asm"]["rZ"]).apply(null,arguments)};var dynCall_iiiidddddddddd=Module["dynCall_iiiidddddddddd"]=function(){return(dynCall_iiiidddddddddd=Module["dynCall_iiiidddddddddd"]=Module["asm"]["sZ"]).apply(null,arguments)};var dynCall_iiid=Module["dynCall_iiid"]=function(){return(dynCall_iiid=Module["dynCall_iiid"]=Module["asm"]["tZ"]).apply(null,arguments)};var dynCall_iiidi=Module["dynCall_iiidi"]=function(){return(dynCall_iiidi=Module["dynCall_iiidi"]=Module["asm"]["uZ"]).apply(null,arguments)};var dynCall_iiidii=Module["dynCall_iiidii"]=function(){return(dynCall_iiidii=Module["dynCall_iiidii"]=Module["asm"]["vZ"]).apply(null,arguments)};var dynCall_iiidiii=Module["dynCall_iiidiii"]=function(){return(dynCall_iiidiii=Module["dynCall_iiidiii"]=Module["asm"]["wZ"]).apply(null,arguments)};var dynCall_iiidiiiii=Module["dynCall_iiidiiiii"]=function(){return(dynCall_iiidiiiii=Module["dynCall_iiidiiiii"]=Module["asm"]["xZ"]).apply(null,arguments)};var dynCall_iiidiiiiii=Module["dynCall_iiidiiiiii"]=function(){return(dynCall_iiidiiiiii=Module["dynCall_iiidiiiiii"]=Module["asm"]["yZ"]).apply(null,arguments)};var dynCall_iiidiiiid=Module["dynCall_iiidiiiid"]=function(){return(dynCall_iiidiiiid=Module["dynCall_iiidiiiid"]=Module["asm"]["zZ"]).apply(null,arguments)};var dynCall_iiidiid=Module["dynCall_iiidiid"]=function(){return(dynCall_iiidiid=Module["dynCall_iiidiid"]=Module["asm"]["AZ"]).apply(null,arguments)};var dynCall_iiidiidiid=Module["dynCall_iiidiidiid"]=function(){return(dynCall_iiidiidiid=Module["dynCall_iiidiidiid"]=Module["asm"]["BZ"]).apply(null,arguments)};var dynCall_iiidid=Module["dynCall_iiidid"]=function(){return(dynCall_iiidid=Module["dynCall_iiidid"]=Module["asm"]["CZ"]).apply(null,arguments)};var dynCall_iiididi=Module["dynCall_iiididi"]=function(){return(dynCall_iiididi=Module["dynCall_iiididi"]=Module["asm"]["DZ"]).apply(null,arguments)};var dynCall_iiididdii=Module["dynCall_iiididdii"]=function(){return(dynCall_iiididdii=Module["dynCall_iiididdii"]=Module["asm"]["EZ"]).apply(null,arguments)};var dynCall_iiidd=Module["dynCall_iiidd"]=function(){return(dynCall_iiidd=Module["dynCall_iiidd"]=Module["asm"]["FZ"]).apply(null,arguments)};var dynCall_iiiddi=Module["dynCall_iiiddi"]=function(){return(dynCall_iiiddi=Module["dynCall_iiiddi"]=Module["asm"]["GZ"]).apply(null,arguments)};var dynCall_iiiddii=Module["dynCall_iiiddii"]=function(){return(dynCall_iiiddii=Module["dynCall_iiiddii"]=Module["asm"]["HZ"]).apply(null,arguments)};var dynCall_iiiddiii=Module["dynCall_iiiddiii"]=function(){return(dynCall_iiiddiii=Module["dynCall_iiiddiii"]=Module["asm"]["IZ"]).apply(null,arguments)};var dynCall_iiiddiiii=Module["dynCall_iiiddiiii"]=function(){return(dynCall_iiiddiiii=Module["dynCall_iiiddiiii"]=Module["asm"]["JZ"]).apply(null,arguments)};var dynCall_iiiddiidd=Module["dynCall_iiiddiidd"]=function(){return(dynCall_iiiddiidd=Module["dynCall_iiiddiidd"]=Module["asm"]["KZ"]).apply(null,arguments)};var dynCall_iiiddid=Module["dynCall_iiiddid"]=function(){return(dynCall_iiiddid=Module["dynCall_iiiddid"]=Module["asm"]["LZ"]).apply(null,arguments)};var dynCall_iiiddidi=Module["dynCall_iiiddidi"]=function(){return(dynCall_iiiddidi=Module["dynCall_iiiddidi"]=Module["asm"]["MZ"]).apply(null,arguments)};var dynCall_iiiddidd=Module["dynCall_iiiddidd"]=function(){return(dynCall_iiiddidd=Module["dynCall_iiiddidd"]=Module["asm"]["NZ"]).apply(null,arguments)};var dynCall_iiiddidddd=Module["dynCall_iiiddidddd"]=function(){return(dynCall_iiiddidddd=Module["dynCall_iiiddidddd"]=Module["asm"]["OZ"]).apply(null,arguments)};var dynCall_iiiddd=Module["dynCall_iiiddd"]=function(){return(dynCall_iiiddd=Module["dynCall_iiiddd"]=Module["asm"]["PZ"]).apply(null,arguments)};var dynCall_iiidddi=Module["dynCall_iiidddi"]=function(){return(dynCall_iiidddi=Module["dynCall_iiidddi"]=Module["asm"]["QZ"]).apply(null,arguments)};var dynCall_iiidddiiiii=Module["dynCall_iiidddiiiii"]=function(){return(dynCall_iiidddiiiii=Module["dynCall_iiidddiiiii"]=Module["asm"]["RZ"]).apply(null,arguments)};var dynCall_iiidddiid=Module["dynCall_iiidddiid"]=function(){return(dynCall_iiidddiid=Module["dynCall_iiidddiid"]=Module["asm"]["SZ"]).apply(null,arguments)};var dynCall_iiidddid=Module["dynCall_iiidddid"]=function(){return(dynCall_iiidddid=Module["dynCall_iiidddid"]=Module["asm"]["TZ"]).apply(null,arguments)};var dynCall_iiidddd=Module["dynCall_iiidddd"]=function(){return(dynCall_iiidddd=Module["dynCall_iiidddd"]=Module["asm"]["UZ"]).apply(null,arguments)};var dynCall_iiiddddi=Module["dynCall_iiiddddi"]=function(){return(dynCall_iiiddddi=Module["dynCall_iiiddddi"]=Module["asm"]["VZ"]).apply(null,arguments)};var dynCall_iiiddddii=Module["dynCall_iiiddddii"]=function(){return(dynCall_iiiddddii=Module["dynCall_iiiddddii"]=Module["asm"]["WZ"]).apply(null,arguments)};var dynCall_iiiddddiii=Module["dynCall_iiiddddiii"]=function(){return(dynCall_iiiddddiii=Module["dynCall_iiiddddiii"]=Module["asm"]["XZ"]).apply(null,arguments)};var dynCall_iiiddddid=Module["dynCall_iiiddddid"]=function(){return(dynCall_iiiddddid=Module["dynCall_iiiddddid"]=Module["asm"]["YZ"]).apply(null,arguments)};var dynCall_iiiddddd=Module["dynCall_iiiddddd"]=function(){return(dynCall_iiiddddd=Module["dynCall_iiiddddd"]=Module["asm"]["ZZ"]).apply(null,arguments)};var dynCall_iiidddddiii=Module["dynCall_iiidddddiii"]=function(){return(dynCall_iiidddddiii=Module["dynCall_iiidddddiii"]=Module["asm"]["_Z"]).apply(null,arguments)};var dynCall_iiidddddd=Module["dynCall_iiidddddd"]=function(){return(dynCall_iiidddddd=Module["dynCall_iiidddddd"]=Module["asm"]["$Z"]).apply(null,arguments)};var dynCall_iiidddddddddd=Module["dynCall_iiidddddddddd"]=function(){return(dynCall_iiidddddddddd=Module["dynCall_iiidddddddddd"]=Module["asm"]["a_"]).apply(null,arguments)};var dynCall_iiji=Module["dynCall_iiji"]=function(){return(dynCall_iiji=Module["dynCall_iiji"]=Module["asm"]["b_"]).apply(null,arguments)};var dynCall_iid=Module["dynCall_iid"]=function(){return(dynCall_iid=Module["dynCall_iid"]=Module["asm"]["c_"]).apply(null,arguments)};var dynCall_iidi=Module["dynCall_iidi"]=function(){return(dynCall_iidi=Module["dynCall_iidi"]=Module["asm"]["d_"]).apply(null,arguments)};var dynCall_iidii=Module["dynCall_iidii"]=function(){return(dynCall_iidii=Module["dynCall_iidii"]=Module["asm"]["e_"]).apply(null,arguments)};var dynCall_iidiii=Module["dynCall_iidiii"]=function(){return(dynCall_iidiii=Module["dynCall_iidiii"]=Module["asm"]["f_"]).apply(null,arguments)};var dynCall_iidiiii=Module["dynCall_iidiiii"]=function(){return(dynCall_iidiiii=Module["dynCall_iidiiii"]=Module["asm"]["g_"]).apply(null,arguments)};var dynCall_iidiiiiii=Module["dynCall_iidiiiiii"]=function(){return(dynCall_iidiiiiii=Module["dynCall_iidiiiiii"]=Module["asm"]["h_"]).apply(null,arguments)};var dynCall_iidiiiiiiiii=Module["dynCall_iidiiiiiiiii"]=function(){return(dynCall_iidiiiiiiiii=Module["dynCall_iidiiiiiiiii"]=Module["asm"]["i_"]).apply(null,arguments)};var dynCall_iidiiiidiiiiii=Module["dynCall_iidiiiidiiiiii"]=function(){return(dynCall_iidiiiidiiiiii=Module["dynCall_iidiiiidiiiiii"]=Module["asm"]["j_"]).apply(null,arguments)};var dynCall_iidiiid=Module["dynCall_iidiiid"]=function(){return(dynCall_iidiiid=Module["dynCall_iidiiid"]=Module["asm"]["k_"]).apply(null,arguments)};var dynCall_iidiiidd=Module["dynCall_iidiiidd"]=function(){return(dynCall_iidiiidd=Module["dynCall_iidiiidd"]=Module["asm"]["l_"]).apply(null,arguments)};var dynCall_iidiiddii=Module["dynCall_iidiiddii"]=function(){return(dynCall_iidiiddii=Module["dynCall_iidiiddii"]=Module["asm"]["m_"]).apply(null,arguments)};var dynCall_iidid=Module["dynCall_iidid"]=function(){return(dynCall_iidid=Module["dynCall_iidid"]=Module["asm"]["n_"]).apply(null,arguments)};var dynCall_iididi=Module["dynCall_iididi"]=function(){return(dynCall_iididi=Module["dynCall_iididi"]=Module["asm"]["o_"]).apply(null,arguments)};var dynCall_iididiii=Module["dynCall_iididiii"]=function(){return(dynCall_iididiii=Module["dynCall_iididiii"]=Module["asm"]["p_"]).apply(null,arguments)};var dynCall_iididd=Module["dynCall_iididd"]=function(){return(dynCall_iididd=Module["dynCall_iididd"]=Module["asm"]["q_"]).apply(null,arguments)};var dynCall_iididdii=Module["dynCall_iididdii"]=function(){return(dynCall_iididdii=Module["dynCall_iididdii"]=Module["asm"]["r_"]).apply(null,arguments)};var dynCall_iidd=Module["dynCall_iidd"]=function(){return(dynCall_iidd=Module["dynCall_iidd"]=Module["asm"]["s_"]).apply(null,arguments)};var dynCall_iiddi=Module["dynCall_iiddi"]=function(){return(dynCall_iiddi=Module["dynCall_iiddi"]=Module["asm"]["t_"]).apply(null,arguments)};var dynCall_iiddii=Module["dynCall_iiddii"]=function(){return(dynCall_iiddii=Module["dynCall_iiddii"]=Module["asm"]["u_"]).apply(null,arguments)};var dynCall_iiddiiiii=Module["dynCall_iiddiiiii"]=function(){return(dynCall_iiddiiiii=Module["dynCall_iiddiiiii"]=Module["asm"]["v_"]).apply(null,arguments)};var dynCall_iiddiiiiii=Module["dynCall_iiddiiiiii"]=function(){return(dynCall_iiddiiiiii=Module["dynCall_iiddiiiiii"]=Module["asm"]["w_"]).apply(null,arguments)};var dynCall_iiddiiiiiiiiii=Module["dynCall_iiddiiiiiiiiii"]=function(){return(dynCall_iiddiiiiiiiiii=Module["dynCall_iiddiiiiiiiiii"]=Module["asm"]["x_"]).apply(null,arguments)};var dynCall_iiddiiid=Module["dynCall_iiddiiid"]=function(){return(dynCall_iiddiiid=Module["dynCall_iiddiiid"]=Module["asm"]["y_"]).apply(null,arguments)};var dynCall_iiddiid=Module["dynCall_iiddiid"]=function(){return(dynCall_iiddiid=Module["dynCall_iiddiid"]=Module["asm"]["z_"]).apply(null,arguments)};var dynCall_iiddid=Module["dynCall_iiddid"]=function(){return(dynCall_iiddid=Module["dynCall_iiddid"]=Module["asm"]["A_"]).apply(null,arguments)};var dynCall_iiddiddidii=Module["dynCall_iiddiddidii"]=function(){return(dynCall_iiddiddidii=Module["dynCall_iiddiddidii"]=Module["asm"]["B_"]).apply(null,arguments)};var dynCall_iiddd=Module["dynCall_iiddd"]=function(){return(dynCall_iiddd=Module["dynCall_iiddd"]=Module["asm"]["C_"]).apply(null,arguments)};var dynCall_iidddi=Module["dynCall_iidddi"]=function(){return(dynCall_iidddi=Module["dynCall_iidddi"]=Module["asm"]["D_"]).apply(null,arguments)};var dynCall_iidddiii=Module["dynCall_iidddiii"]=function(){return(dynCall_iidddiii=Module["dynCall_iidddiii"]=Module["asm"]["E_"]).apply(null,arguments)};var dynCall_iidddiiiiii=Module["dynCall_iidddiiiiii"]=function(){return(dynCall_iidddiiiiii=Module["dynCall_iidddiiiiii"]=Module["asm"]["F_"]).apply(null,arguments)};var dynCall_iidddiiiiiiiii=Module["dynCall_iidddiiiiiiiii"]=function(){return(dynCall_iidddiiiiiiiii=Module["dynCall_iidddiiiiiiiii"]=Module["asm"]["G_"]).apply(null,arguments)};var dynCall_iidddiiiiiiiiii=Module["dynCall_iidddiiiiiiiiii"]=function(){return(dynCall_iidddiiiiiiiiii=Module["dynCall_iidddiiiiiiiiii"]=Module["asm"]["H_"]).apply(null,arguments)};var dynCall_iidddidd=Module["dynCall_iidddidd"]=function(){return(dynCall_iidddidd=Module["dynCall_iidddidd"]=Module["asm"]["I_"]).apply(null,arguments)};var dynCall_iidddd=Module["dynCall_iidddd"]=function(){return(dynCall_iidddd=Module["dynCall_iidddd"]=Module["asm"]["J_"]).apply(null,arguments)};var dynCall_iiddddi=Module["dynCall_iiddddi"]=function(){return(dynCall_iiddddi=Module["dynCall_iiddddi"]=Module["asm"]["K_"]).apply(null,arguments)};var dynCall_iiddddii=Module["dynCall_iiddddii"]=function(){return(dynCall_iiddddii=Module["dynCall_iiddddii"]=Module["asm"]["L_"]).apply(null,arguments)};var dynCall_iiddddd=Module["dynCall_iiddddd"]=function(){return(dynCall_iiddddd=Module["dynCall_iiddddd"]=Module["asm"]["M_"]).apply(null,arguments)};var dynCall_iiddddddiiii=Module["dynCall_iiddddddiiii"]=function(){return(dynCall_iiddddddiiii=Module["dynCall_iiddddddiiii"]=Module["asm"]["N_"]).apply(null,arguments)};var dynCall_iiddddddd=Module["dynCall_iiddddddd"]=function(){return(dynCall_iiddddddd=Module["dynCall_iiddddddd"]=Module["asm"]["O_"]).apply(null,arguments)};var dynCall_iiddddddddiii=Module["dynCall_iiddddddddiii"]=function(){return(dynCall_iiddddddddiii=Module["dynCall_iiddddddddiii"]=Module["asm"]["P_"]).apply(null,arguments)};var dynCall_idi=Module["dynCall_idi"]=function(){return(dynCall_idi=Module["dynCall_idi"]=Module["asm"]["Q_"]).apply(null,arguments)};var dynCall_idii=Module["dynCall_idii"]=function(){return(dynCall_idii=Module["dynCall_idii"]=Module["asm"]["R_"]).apply(null,arguments)};var dynCall_idiiiii=Module["dynCall_idiiiii"]=function(){return(dynCall_idiiiii=Module["dynCall_idiiiii"]=Module["asm"]["S_"]).apply(null,arguments)};var dynCall_idiiiiii=Module["dynCall_idiiiiii"]=function(){return(dynCall_idiiiiii=Module["dynCall_idiiiiii"]=Module["asm"]["T_"]).apply(null,arguments)};var dynCall_idiiididii=Module["dynCall_idiiididii"]=function(){return(dynCall_idiiididii=Module["dynCall_idiiididii"]=Module["asm"]["U_"]).apply(null,arguments)};var dynCall_idiid=Module["dynCall_idiid"]=function(){return(dynCall_idiid=Module["dynCall_idiid"]=Module["asm"]["V_"]).apply(null,arguments)};var dynCall_idiiddii=Module["dynCall_idiiddii"]=function(){return(dynCall_idiiddii=Module["dynCall_idiiddii"]=Module["asm"]["W_"]).apply(null,arguments)};var dynCall_idid=Module["dynCall_idid"]=function(){return(dynCall_idid=Module["dynCall_idid"]=Module["asm"]["X_"]).apply(null,arguments)};var dynCall_iddii=Module["dynCall_iddii"]=function(){return(dynCall_iddii=Module["dynCall_iddii"]=Module["asm"]["Y_"]).apply(null,arguments)};var dynCall_iddiii=Module["dynCall_iddiii"]=function(){return(dynCall_iddiii=Module["dynCall_iddiii"]=Module["asm"]["Z_"]).apply(null,arguments)};var dynCall_iddiiiiii=Module["dynCall_iddiiiiii"]=function(){return(dynCall_iddiiiiii=Module["dynCall_iddiiiiii"]=Module["asm"]["__"]).apply(null,arguments)};var dynCall_iddiiiiiii=Module["dynCall_iddiiiiiii"]=function(){return(dynCall_iddiiiiiii=Module["dynCall_iddiiiiiii"]=Module["asm"]["$_"]).apply(null,arguments)};var dynCall_iddid=Module["dynCall_iddid"]=function(){return(dynCall_iddid=Module["dynCall_iddid"]=Module["asm"]["a$"]).apply(null,arguments)};var dynCall_iddiddiiiii=Module["dynCall_iddiddiiiii"]=function(){return(dynCall_iddiddiiiii=Module["dynCall_iddiddiiiii"]=Module["asm"]["b$"]).apply(null,arguments)};var dynCall_idddii=Module["dynCall_idddii"]=function(){return(dynCall_idddii=Module["dynCall_idddii"]=Module["asm"]["c$"]).apply(null,arguments)};var dynCall_iddddiid=Module["dynCall_iddddiid"]=function(){return(dynCall_iddddiid=Module["dynCall_iddddiid"]=Module["asm"]["d$"]).apply(null,arguments)};var dynCall_d=Module["dynCall_d"]=function(){return(dynCall_d=Module["dynCall_d"]=Module["asm"]["e$"]).apply(null,arguments)};var dynCall_di=Module["dynCall_di"]=function(){return(dynCall_di=Module["dynCall_di"]=Module["asm"]["f$"]).apply(null,arguments)};var dynCall_dii=Module["dynCall_dii"]=function(){return(dynCall_dii=Module["dynCall_dii"]=Module["asm"]["g$"]).apply(null,arguments)};var dynCall_diii=Module["dynCall_diii"]=function(){return(dynCall_diii=Module["dynCall_diii"]=Module["asm"]["h$"]).apply(null,arguments)};var dynCall_diiii=Module["dynCall_diiii"]=function(){return(dynCall_diiii=Module["dynCall_diiii"]=Module["asm"]["i$"]).apply(null,arguments)};var dynCall_diiiii=Module["dynCall_diiiii"]=function(){return(dynCall_diiiii=Module["dynCall_diiiii"]=Module["asm"]["j$"]).apply(null,arguments)};var dynCall_diiiiii=Module["dynCall_diiiiii"]=function(){return(dynCall_diiiiii=Module["dynCall_diiiiii"]=Module["asm"]["k$"]).apply(null,arguments)};var dynCall_diiiiiii=Module["dynCall_diiiiiii"]=function(){return(dynCall_diiiiiii=Module["dynCall_diiiiiii"]=Module["asm"]["l$"]).apply(null,arguments)};var dynCall_diiiiiidiiii=Module["dynCall_diiiiiidiiii"]=function(){return(dynCall_diiiiiidiiii=Module["dynCall_diiiiiidiiii"]=Module["asm"]["m$"]).apply(null,arguments)};var dynCall_diiiidii=Module["dynCall_diiiidii"]=function(){return(dynCall_diiiidii=Module["dynCall_diiiidii"]=Module["asm"]["n$"]).apply(null,arguments)};var dynCall_diiiidd=Module["dynCall_diiiidd"]=function(){return(dynCall_diiiidd=Module["dynCall_diiiidd"]=Module["asm"]["o$"]).apply(null,arguments)};var dynCall_diiid=Module["dynCall_diiid"]=function(){return(dynCall_diiid=Module["dynCall_diiid"]=Module["asm"]["p$"]).apply(null,arguments)};var dynCall_diiidii=Module["dynCall_diiidii"]=function(){return(dynCall_diiidii=Module["dynCall_diiidii"]=Module["asm"]["q$"]).apply(null,arguments)};var dynCall_diiidiii=Module["dynCall_diiidiii"]=function(){return(dynCall_diiidiii=Module["dynCall_diiidiii"]=Module["asm"]["r$"]).apply(null,arguments)};var dynCall_diiidiiii=Module["dynCall_diiidiiii"]=function(){return(dynCall_diiidiiii=Module["dynCall_diiidiiii"]=Module["asm"]["s$"]).apply(null,arguments)};var dynCall_diiidiiddi=Module["dynCall_diiidiiddi"]=function(){return(dynCall_diiidiiddi=Module["dynCall_diiidiiddi"]=Module["asm"]["t$"]).apply(null,arguments)};var dynCall_diiiddi=Module["dynCall_diiiddi"]=function(){return(dynCall_diiiddi=Module["dynCall_diiiddi"]=Module["asm"]["u$"]).apply(null,arguments)};var dynCall_diid=Module["dynCall_diid"]=function(){return(dynCall_diid=Module["dynCall_diid"]=Module["asm"]["v$"]).apply(null,arguments)};var dynCall_diidi=Module["dynCall_diidi"]=function(){return(dynCall_diidi=Module["dynCall_diidi"]=Module["asm"]["w$"]).apply(null,arguments)};var dynCall_diidii=Module["dynCall_diidii"]=function(){return(dynCall_diidii=Module["dynCall_diidii"]=Module["asm"]["x$"]).apply(null,arguments)};var dynCall_diidiiii=Module["dynCall_diidiiii"]=function(){return(dynCall_diidiiii=Module["dynCall_diidiiii"]=Module["asm"]["y$"]).apply(null,arguments)};var dynCall_diidd=Module["dynCall_diidd"]=function(){return(dynCall_diidd=Module["dynCall_diidd"]=Module["asm"]["z$"]).apply(null,arguments)};var dynCall_diiddi=Module["dynCall_diiddi"]=function(){return(dynCall_diiddi=Module["dynCall_diiddi"]=Module["asm"]["A$"]).apply(null,arguments)};var dynCall_diiddd=Module["dynCall_diiddd"]=function(){return(dynCall_diiddd=Module["dynCall_diiddd"]=Module["asm"]["B$"]).apply(null,arguments)};var dynCall_did=Module["dynCall_did"]=function(){return(dynCall_did=Module["dynCall_did"]=Module["asm"]["C$"]).apply(null,arguments)};var dynCall_didi=Module["dynCall_didi"]=function(){return(dynCall_didi=Module["dynCall_didi"]=Module["asm"]["D$"]).apply(null,arguments)};var dynCall_didii=Module["dynCall_didii"]=function(){return(dynCall_didii=Module["dynCall_didii"]=Module["asm"]["E$"]).apply(null,arguments)};var dynCall_didiiiiidi=Module["dynCall_didiiiiidi"]=function(){return(dynCall_didiiiiidi=Module["dynCall_didiiiiidi"]=Module["asm"]["F$"]).apply(null,arguments)};var dynCall_didiidii=Module["dynCall_didiidii"]=function(){return(dynCall_didiidii=Module["dynCall_didiidii"]=Module["asm"]["G$"]).apply(null,arguments)};var dynCall_didiidiiddi=Module["dynCall_didiidiiddi"]=function(){return(dynCall_didiidiiddi=Module["dynCall_didiidiiddi"]=Module["asm"]["H$"]).apply(null,arguments)};var dynCall_dididd=Module["dynCall_dididd"]=function(){return(dynCall_dididd=Module["dynCall_dididd"]=Module["asm"]["I$"]).apply(null,arguments)};var dynCall_didd=Module["dynCall_didd"]=function(){return(dynCall_didd=Module["dynCall_didd"]=Module["asm"]["J$"]).apply(null,arguments)};var dynCall_diddi=Module["dynCall_diddi"]=function(){return(dynCall_diddi=Module["dynCall_diddi"]=Module["asm"]["K$"]).apply(null,arguments)};var dynCall_diddidii=Module["dynCall_diddidii"]=function(){return(dynCall_diddidii=Module["dynCall_diddidii"]=Module["asm"]["L$"]).apply(null,arguments)};var dynCall_diddd=Module["dynCall_diddd"]=function(){return(dynCall_diddd=Module["dynCall_diddd"]=Module["asm"]["M$"]).apply(null,arguments)};var dynCall_didddidi=Module["dynCall_didddidi"]=function(){return(dynCall_didddidi=Module["dynCall_didddidi"]=Module["asm"]["N$"]).apply(null,arguments)};var dynCall_didddddidi=Module["dynCall_didddddidi"]=function(){return(dynCall_didddddidi=Module["dynCall_didddddidi"]=Module["asm"]["O$"]).apply(null,arguments)};var dynCall_dd=Module["dynCall_dd"]=function(){return(dynCall_dd=Module["dynCall_dd"]=Module["asm"]["P$"]).apply(null,arguments)};var dynCall_ddii=Module["dynCall_ddii"]=function(){return(dynCall_ddii=Module["dynCall_ddii"]=Module["asm"]["Q$"]).apply(null,arguments)};var dynCall_ddd=Module["dynCall_ddd"]=function(){return(dynCall_ddd=Module["dynCall_ddd"]=Module["asm"]["R$"]).apply(null,arguments)};var dynCall_dddd=Module["dynCall_dddd"]=function(){return(dynCall_dddd=Module["dynCall_dddd"]=Module["asm"]["S$"]).apply(null,arguments)};var dynCall_ddddd=Module["dynCall_ddddd"]=function(){return(dynCall_ddddd=Module["dynCall_ddddd"]=Module["asm"]["T$"]).apply(null,arguments)};function invoke_iiiiiii(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{return dynCall_iiiiiii(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iii(index,a1,a2){var sp=stackSave();try{return dynCall_iii(index,a1,a2)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_ii(index,a1){var sp=stackSave();try{return dynCall_ii(index,a1)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vi(index,a1){var sp=stackSave();try{dynCall_vi(index,a1)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vii(index,a1,a2){var sp=stackSave();try{dynCall_vii(index,a1,a2)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_i(index){var sp=stackSave();try{return dynCall_i(index)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiii(index,a1,a2,a3){var sp=stackSave();try{return dynCall_iiii(index,a1,a2,a3)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viii(index,a1,a2,a3){var sp=stackSave();try{dynCall_viii(index,a1,a2,a3)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiii(index,a1,a2,a3,a4){var sp=stackSave();try{return dynCall_iiiii(index,a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_v(index){var sp=stackSave();try{dynCall_v(index)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiii(index,a1,a2,a3,a4,a5){var sp=stackSave();try{return dynCall_iiiiii(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiii(index,a1,a2,a3,a4,a5){var sp=stackSave();try{dynCall_viiiii(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiii(index,a1,a2,a3,a4){var sp=stackSave();try{dynCall_viiii(index,a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iid(index,a1,a2){var sp=stackSave();try{return dynCall_iid(index,a1,a2)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_did(index,a1,a2){var sp=stackSave();try{return dynCall_did(index,a1,a2)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22){var sp=stackSave();try{dynCall_viiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_di(index,a1){var sp=stackSave();try{return dynCall_di(index,a1)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viddi(index,a1,a2,a3,a4){var sp=stackSave();try{dynCall_viddi(index,a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vid(index,a1,a2){var sp=stackSave();try{dynCall_vid(index,a1,a2)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_idiiddii(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_idiiddii(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{dynCall_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{dynCall_viiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{dynCall_viiiiii(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiid(index,a1,a2,a3,a4,a5){var sp=stackSave();try{dynCall_viiiid(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){var sp=stackSave();try{dynCall_viiiiiiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_dii(index,a1,a2){var sp=stackSave();try{return dynCall_dii(index,a1,a2)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiiiiiiidddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18){var sp=stackSave();try{dynCall_viiiiiiiiiiiiiidddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_diii(index,a1,a2,a3){var sp=stackSave();try{return dynCall_diii(index,a1,a2,a3)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{dynCall_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vidiii(index,a1,a2,a3,a4,a5){var sp=stackSave();try{dynCall_vidiii(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vidddddddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{dynCall_vidddddddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viidi(index,a1,a2,a3,a4){var sp=stackSave();try{dynCall_viidi(index,a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viidddi(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{dynCall_viidddi(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiddddidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){var sp=stackSave();try{dynCall_viiiiiiddddidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viddddiid(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{dynCall_viddddiid(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){var sp=stackSave();try{dynCall_viiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiidd(index,a1,a2,a3,a4,a5){var sp=stackSave();try{dynCall_viiidd(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiddi(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{dynCall_viiiddi(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiidi(index,a1,a2,a3,a4,a5){var sp=stackSave();try{dynCall_viiidi(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiid(index,a1,a2,a3){var sp=stackSave();try{return dynCall_iiid(index,a1,a2,a3)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viidii(index,a1,a2,a3,a4,a5){var sp=stackSave();try{dynCall_viidii(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vidddi(index,a1,a2,a3,a4,a5){var sp=stackSave();try{dynCall_vidddi(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viddiiddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{dynCall_viddiiddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){var sp=stackSave();try{dynCall_viiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_diiii(index,a1,a2,a3,a4){var sp=stackSave();try{return dynCall_diiii(index,a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiidii(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{dynCall_viiiiidii(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiidiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16){var sp=stackSave();try{dynCall_viiiiiiidiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){var sp=stackSave();try{dynCall_viiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vidddii(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{dynCall_vidddii(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{dynCall_viiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viddiididiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25,a26,a27){var sp=stackSave();try{dynCall_viddiididiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25,a26,a27)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiddi(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{dynCall_viiiiddi(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiidddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{dynCall_viiiidddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viidiiidddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){var sp=stackSave();try{dynCall_viidiiidddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viidiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{dynCall_viidiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiidiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14){var sp=stackSave();try{dynCall_viiidiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{dynCall_viiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiidiii(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{dynCall_viiidiii(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viidd(index,a1,a2,a3,a4){var sp=stackSave();try{dynCall_viidd(index,a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23){var sp=stackSave();try{dynCall_viiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viid(index,a1,a2,a3){var sp=stackSave();try{dynCall_viid(index,a1,a2,a3)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_ddd(index,a1,a2){var sp=stackSave();try{return dynCall_ddd(index,a1,a2)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_idiid(index,a1,a2,a3,a4){var sp=stackSave();try{return dynCall_idiid(index,a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{return dynCall_iiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){var sp=stackSave();try{return dynCall_iiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiid(index,a1,a2,a3,a4){var sp=stackSave();try{return dynCall_iiiid(index,a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiddi(index,a1,a2,a3,a4){var sp=stackSave();try{return dynCall_iiddi(index,a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iidi(index,a1,a2,a3){var sp=stackSave();try{return dynCall_iidi(index,a1,a2,a3)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiidd(index,a1,a2,a3,a4){var sp=stackSave();try{return dynCall_iiidd(index,a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiidi(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{dynCall_viiiiidi(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vidddddddddddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){var sp=stackSave();try{dynCall_vidddddddddddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{return dynCall_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viddd(index,a1,a2,a3,a4){var sp=stackSave();try{dynCall_viddd(index,a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiddii(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{return dynCall_iiiddii(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_diddi(index,a1,a2,a3,a4){var sp=stackSave();try{return dynCall_diddi(index,a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiidi(index,a1,a2,a3,a4){var sp=stackSave();try{return dynCall_iiidi(index,a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiddi(index,a1,a2,a3,a4,a5){var sp=stackSave();try{return dynCall_iiiddi(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiid(index,a1,a2,a3,a4){var sp=stackSave();try{dynCall_viiid(index,a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiddddd(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{dynCall_viiddddd(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiidi(index,a1,a2,a3,a4,a5){var sp=stackSave();try{return dynCall_iiiidi(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiddddd(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_iiiddddd(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vddi(index,a1,a2,a3){var sp=stackSave();try{dynCall_vddi(index,a1,a2,a3)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiddi(index,a1,a2,a3,a4,a5){var sp=stackSave();try{dynCall_viiddi(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiid(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{dynCall_viiiiid(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiddddii(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{return dynCall_iiiddddii(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiidddd(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{dynCall_viiidddd(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viddiii(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{dynCall_viddiii(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_dddd(index,a1,a2,a3){var sp=stackSave();try{return dynCall_dddd(index,a1,a2,a3)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iidddd(index,a1,a2,a3,a4,a5){var sp=stackSave();try{return dynCall_iidddd(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiidddid(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{return dynCall_iiiidddid(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viidid(index,a1,a2,a3,a4,a5){var sp=stackSave();try{dynCall_viidid(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{return dynCall_iiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiidiii(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_iiiidiii(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiid(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{dynCall_viiiiiid(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiidii(index,a1,a2,a3,a4,a5){var sp=stackSave();try{return dynCall_iiidii(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiidd(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{dynCall_viiiidd(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiidii(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{dynCall_viiiidii(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viidddddd(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{dynCall_viidddddd(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){var sp=stackSave();try{return dynCall_iiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vdiddddi(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{dynCall_vdiddddi(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiddiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{dynCall_viiiddiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vidi(index,a1,a2,a3){var sp=stackSave();try{dynCall_vidi(index,a1,a2,a3)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiidiii(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{return dynCall_iiidiii(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_didi(index,a1,a2,a3){var sp=stackSave();try{return dynCall_didi(index,a1,a2,a3)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiidi(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{dynCall_viiiidi(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiddid(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{return dynCall_iiiddid(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{return dynCall_iiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iidiiii(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{return dynCall_iidiiii(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vidiiii(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{dynCall_vidiiii(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiddd(index,a1,a2,a3,a4){var sp=stackSave();try{return dynCall_iiddd(index,a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){var sp=stackSave();try{dynCall_viiiiiiiiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{return dynCall_iiiiiiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vidiiiiidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{dynCall_vidiiiiidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_dd(index,a1){var sp=stackSave();try{return dynCall_dd(index,a1)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiidi(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{return dynCall_iiiiidi(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vdiiiii(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{dynCall_vdiiiii(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iddiii(index,a1,a2,a3,a4,a5){var sp=stackSave();try{return dynCall_iddiii(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vdiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{dynCall_vdiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){var sp=stackSave();try{return dynCall_iiiiiiiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiidii(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{dynCall_viiidii(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiid(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{return dynCall_iiiiiid(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vddiii(index,a1,a2,a3,a4,a5){var sp=stackSave();try{dynCall_vddiii(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vddii(index,a1,a2,a3,a4){var sp=stackSave();try{dynCall_vddii(index,a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iidii(index,a1,a2,a3,a4){var sp=stackSave();try{return dynCall_iidii(index,a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iidiii(index,a1,a2,a3,a4,a5){var sp=stackSave();try{return dynCall_iidiii(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiddii(index,a1,a2,a3,a4,a5){var sp=stackSave();try{return dynCall_iiddii(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiddd(index,a1,a2,a3,a4,a5){var sp=stackSave();try{dynCall_viiddd(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vidddd(index,a1,a2,a3,a4,a5){var sp=stackSave();try{dynCall_vidddd(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiidii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{dynCall_viiiiiidii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_diiiiiii(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_diiiiiii(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vidii(index,a1,a2,a3,a4){var sp=stackSave();try{dynCall_vidii(index,a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vidd(index,a1,a2,a3){var sp=stackSave();try{dynCall_vidd(index,a1,a2,a3)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiddii(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_iiiiddii(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vidddddd(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{dynCall_vidddddd(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiidddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){var sp=stackSave();try{return dynCall_iiiiiiiiidddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viididi(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{dynCall_viididi(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiid(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_iiiiiiid(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iddii(index,a1,a2,a3,a4){var sp=stackSave();try{return dynCall_iddii(index,a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiididi(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_iiiididi(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiidiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{return dynCall_iiiiidiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iidddi(index,a1,a2,a3,a4,a5){var sp=stackSave();try{return dynCall_iidddi(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiidd(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{dynCall_viiiiidd(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiidddid(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_iiidddid(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiddidddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{return dynCall_iiiddidddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiddd(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{return dynCall_iiiiddd(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vidiiidi(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{dynCall_vidiiidi(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiidddddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{return dynCall_iiiidddddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iidid(index,a1,a2,a3,a4){var sp=stackSave();try{return dynCall_iidid(index,a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vdiii(index,a1,a2,a3,a4){var sp=stackSave();try{dynCall_vdiii(index,a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vdidii(index,a1,a2,a3,a4,a5){var sp=stackSave();try{dynCall_vdidii(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vidiidii(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{dynCall_vidiidii(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viddiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{dynCall_viddiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vdiddiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{dynCall_vdiddiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiidd(index,a1,a2,a3,a4,a5){var sp=stackSave();try{return dynCall_iiiidd(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{dynCall_viiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viidiii(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{dynCall_viidiii(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{dynCall_viiiiiddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{dynCall_viiiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19){var sp=stackSave();try{dynCall_viiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21){var sp=stackSave();try{dynCall_viiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15){var sp=stackSave();try{dynCall_viiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18){var sp=stackSave();try{dynCall_viiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiddii(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{dynCall_viiddii(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiidiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{dynCall_viiiidiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiid(index,a1,a2,a3,a4,a5){var sp=stackSave();try{return dynCall_iiiiid(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiididi(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{dynCall_viiididi(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiidiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{return dynCall_iiidiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiidd(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{return dynCall_iiiiidd(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viddid(index,a1,a2,a3,a4,a5){var sp=stackSave();try{dynCall_viddid(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viddidd(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{dynCall_viddidd(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viidddiii(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{dynCall_viidddiii(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiidddddiiidddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19){var sp=stackSave();try{return dynCall_iiiiiiiidddddiiidddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viddddiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{dynCall_viddddiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiddidd(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{dynCall_viiddidd(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vidddddi(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{dynCall_vidddddi(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiddddidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{return dynCall_iiiiddddidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiidddddd(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{return dynCall_iiidddddd(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiidddddddddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){var sp=stackSave();try{return dynCall_iiiidddddddddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iidiiid(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{return dynCall_iidiiid(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iidiiidd(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_iidiiidd(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiddidd(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_iiiddidd(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiidd(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_iiiiiidd(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiidid(index,a1,a2,a3,a4,a5){var sp=stackSave();try{return dynCall_iiidid(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiidddd(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{return dynCall_iiiiidddd(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiidddi(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{return dynCall_iiidddi(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiiddddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14){var sp=stackSave();try{return dynCall_iiiiiiiiiddddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiddiddidii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{return dynCall_iiddiddidii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vdddii(index,a1,a2,a3,a4,a5){var sp=stackSave();try{dynCall_vdddii(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_d(index){var sp=stackSave();try{return dynCall_d(index)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_diiid(index,a1,a2,a3,a4){var sp=stackSave();try{return dynCall_diiid(index,a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_diidii(index,a1,a2,a3,a4,a5){var sp=stackSave();try{return dynCall_diidii(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_diidiiii(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_diidiiii(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_diiidii(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{return dynCall_diiidii(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_diiidiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{return dynCall_diiidiiii(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_diiiidii(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_diiiidii(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iddiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{return dynCall_iddiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viddii(index,a1,a2,a3,a4,a5){var sp=stackSave();try{dynCall_viddii(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiddiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{return dynCall_iiddiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiddidi(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{dynCall_viiddidi(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_diiiidd(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{return dynCall_diiiidd(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiidddd(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_iiiidddd(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_didd(index,a1,a2,a3){var sp=stackSave();try{return dynCall_didd(index,a1,a2,a3)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{dynCall_viiiddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{return dynCall_iiiiddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viidddd(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{dynCall_viidddd(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{dynCall_viiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiddi(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_iiiiiddi(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vdi(index,a1,a2){var sp=stackSave();try{dynCall_vdi(index,a1,a2)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{return dynCall_iiiiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){var sp=stackSave();try{dynCall_viiiiiiddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vddiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{dynCall_vddiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vdiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{dynCall_vdiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vdiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){var sp=stackSave();try{dynCall_vdiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vdiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){var sp=stackSave();try{dynCall_vdiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vdiddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{dynCall_vdiddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiddid(index,a1,a2,a3,a4,a5){var sp=stackSave();try{return dynCall_iiddid(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiidddi(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_iiiidddi(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{return dynCall_iiiiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_diiiii(index,a1,a2,a3,a4,a5){var sp=stackSave();try{return dynCall_diiiii(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){var sp=stackSave();try{dynCall_viiiiiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiiiddidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14){var sp=stackSave();try{return dynCall_iiiiiiiiiiddidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_diiiiii(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{return dynCall_diiiiii(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiddddddddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){var sp=stackSave();try{return dynCall_iiddddddddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiddi(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{return dynCall_iiiiddi(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiddddi(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{return dynCall_iiddddi(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14){var sp=stackSave();try{dynCall_viiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiddd(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{dynCall_viiiddd(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{dynCall_viiiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiidii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){var sp=stackSave();try{dynCall_viiiiiiiidii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25,a26,a27){var sp=stackSave();try{dynCall_viiiiiiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25,a26,a27)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiddddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{dynCall_viiiddddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25){var sp=stackSave();try{dynCall_viiiiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vddd(index,a1,a2,a3){var sp=stackSave();try{dynCall_vddd(index,a1,a2,a3)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_ddii(index,a1,a2,a3){var sp=stackSave();try{return dynCall_ddii(index,a1,a2,a3)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viddddddd(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{dynCall_viddddddd(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iidd(index,a1,a2,a3){var sp=stackSave();try{return dynCall_iidd(index,a1,a2,a3)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_diiidiii(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_diiidiii(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiidiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{dynCall_viiiidiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiidddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{dynCall_viiidddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14){var sp=stackSave();try{dynCall_viiiiiiiiiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){var sp=stackSave();try{return dynCall_iiiiiiiiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiidiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{dynCall_viiidiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viidddddi(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{dynCall_viidddddi(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){var sp=stackSave();try{dynCall_viiiiiddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_idiiididii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{return dynCall_idiiididii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vddiiii(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{dynCall_vddiiii(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){var sp=stackSave();try{return dynCall_iiiiiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiddddi(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{dynCall_viiddddi(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iddddiid(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_iddddiid(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiddddi(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_iiiddddi(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viddddii(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{dynCall_viddddii(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_idddii(index,a1,a2,a3,a4,a5){var sp=stackSave();try{return dynCall_idddii(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_diidd(index,a1,a2,a3,a4){var sp=stackSave();try{return dynCall_diidd(index,a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viddddi(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{dynCall_viddddi(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iddiddiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{return dynCall_iddiddiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_idid(index,a1,a2,a3){var sp=stackSave();try{return dynCall_idid(index,a1,a2,a3)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vididi(index,a1,a2,a3,a4,a5){var sp=stackSave();try{dynCall_vididi(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_diddd(index,a1,a2,a3,a4){var sp=stackSave();try{return dynCall_diddd(index,a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiddddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{dynCall_viiiiddddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_didii(index,a1,a2,a3,a4){var sp=stackSave();try{return dynCall_didii(index,a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiddiiid(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_iiddiiid(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiidiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{return dynCall_iiiidiiii(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viididdi(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{dynCall_viididdi(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viidiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{dynCall_viidiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiidid(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{return dynCall_iiiidid(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiidid(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{dynCall_viiidid(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiidiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){var sp=stackSave();try{return dynCall_iiiidiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiddiii(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{dynCall_viiddiii(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiddiid(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{return dynCall_iiiiddiid(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiddiii(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_iiiddiii(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iididdii(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_iididdii(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_idi(index,a1,a2){var sp=stackSave();try{return dynCall_idi(index,a1,a2)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_idii(index,a1,a2,a3){var sp=stackSave();try{return dynCall_idii(index,a1,a2,a3)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iididi(index,a1,a2,a3,a4,a5){var sp=stackSave();try{return dynCall_iididi(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiddddddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){var sp=stackSave();try{return dynCall_iiiiddddddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vidiiiddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{dynCall_vidiiiddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiddiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){var sp=stackSave();try{return dynCall_iiddiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiidddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){var sp=stackSave();try{dynCall_viiiiidddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viidiid(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{dynCall_viidiid(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viidiiid(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{dynCall_viidiiid(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_diid(index,a1,a2,a3){var sp=stackSave();try{return dynCall_diid(index,a1,a2,a3)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiddddi(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{return dynCall_iiiiddddi(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiddd(index,a1,a2,a3,a4,a5){var sp=stackSave();try{return dynCall_iiiddd(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{return dynCall_iiiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiidddd(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{return dynCall_iiidddd(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiidiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{return dynCall_iiidiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiidddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{return dynCall_iiiiiidddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_diiiiiidiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){var sp=stackSave();try{return dynCall_diiiiiidiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiididi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{dynCall_viiiiiididi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiddid(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{dynCall_viiiddid(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiidiiiiddiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16){var sp=stackSave();try{dynCall_viiidiiiiddiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{dynCall_viiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{dynCall_viiddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iididiii(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_iididiii(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viddiidiiidii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){var sp=stackSave();try{dynCall_viddiidiiidii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iidiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{return dynCall_iidiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{dynCall_viiiiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiddddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{return dynCall_iiiiiddddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiidddi(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{dynCall_viiidddi(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiidiid(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{dynCall_viiidiid(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiidddiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){var sp=stackSave();try{return dynCall_iiiidddiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{return dynCall_iiiiiiiidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiidiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){var sp=stackSave();try{return dynCall_iiiiiidiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiidd(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{dynCall_viiiiiidd(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){var sp=stackSave();try{return dynCall_iiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiddddiddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{dynCall_viiddddiddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vddidiii(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{dynCall_vddidiii(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vddiddiii(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{dynCall_vddiddiii(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iidiiiidiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){var sp=stackSave();try{return dynCall_iidiiiidiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiidddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{dynCall_viiiiidddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiiddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){var sp=stackSave();try{dynCall_viiiiiiiiiddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17){var sp=stackSave();try{return dynCall_iiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiidiiiddddddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14){var sp=stackSave();try{return dynCall_iiiidiiiddddddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiiidiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20){var sp=stackSave();try{return dynCall_iiiiiiiiiidiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiiidddiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22){var sp=stackSave();try{return dynCall_iiiiiiiiiidddiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){var sp=stackSave();try{return dynCall_iiiiiiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19){var sp=stackSave();try{return dynCall_iiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiiiiiiiiiiiiddiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25,a26,a27,a28,a29,a30,a31){var sp=stackSave();try{dynCall_viiiiiiiiiiiiiiiiiiiddiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25,a26,a27,a28,a29,a30,a31)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiiiiiiiiiiiidddiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25,a26,a27,a28,a29,a30,a31,a32){var sp=stackSave();try{dynCall_viiiiiiiiiiiiiiiiiiidddiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25,a26,a27,a28,a29,a30,a31,a32)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiiiiiiiddiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25){var sp=stackSave();try{dynCall_viiiiiiiiiiiiiiddiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiiiiiiidddiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25,a26){var sp=stackSave();try{dynCall_viiiiiiiiiiiiiidddiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25,a26)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiiiiiiiiiidddiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25,a26,a27,a28,a29,a30,a31,a32){var sp=stackSave();try{dynCall_viiiiiiiiiiiiiiiiidddiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25,a26,a27,a28,a29,a30,a31,a32)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiididi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{return dynCall_iiiiiiididi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_ddddd(index,a1,a2,a3,a4){var sp=stackSave();try{return dynCall_ddddd(index,a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiddiididii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){var sp=stackSave();try{return dynCall_iiiiiddiididii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiddidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){var sp=stackSave();try{return dynCall_iiiiiiiiddidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiddiiddidii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15){var sp=stackSave();try{return dynCall_iiiiiiddiiddidii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiddidii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){var sp=stackSave();try{return dynCall_iiiiiiiddidii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiddiiddidiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15){var sp=stackSave();try{return dynCall_iiiiiddiiddidiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vddiddi(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{dynCall_vddiddi(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiidiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{dynCall_viiiidiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_didiiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{return dynCall_didiiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){var sp=stackSave();try{dynCall_viiiiiiiiidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iidddiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){var sp=stackSave();try{return dynCall_iidddiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iidddiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{return dynCall_iidddiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viddddddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{dynCall_viddddddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiidddddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{return dynCall_iiidddddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiddiddiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15){var sp=stackSave();try{return dynCall_iiiiiiddiddiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiddddiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){var sp=stackSave();try{dynCall_viiiiiddddiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiddiddiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17){var sp=stackSave();try{return dynCall_iiiiiiiddiddiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiddddiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14){var sp=stackSave();try{dynCall_viiiiiiddddiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiidddiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{return dynCall_iiidddiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viidddddddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){var sp=stackSave();try{dynCall_viidddddddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiddiddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){var sp=stackSave();try{return dynCall_iiiiddiddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiddddiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){var sp=stackSave();try{dynCall_viiiddddiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiddddd(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{dynCall_viiiddddd(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiddiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){var sp=stackSave();try{dynCall_viiiiiddiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){var sp=stackSave();try{return dynCall_iiiiiiiiddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiidiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){var sp=stackSave();try{return dynCall_iiiiiiiiidiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15){var sp=stackSave();try{return dynCall_iiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiidiiiiiidiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23){var sp=stackSave();try{dynCall_viiiidiiiiiidiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiddd(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_iiiiiddd(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiidii(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{return dynCall_iiiidii(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiidiiid(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{return dynCall_iiiidiiid(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{return dynCall_iiiiiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiiiiiddddiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24){var sp=stackSave();try{return dynCall_iiiiiiiiiiiiddddiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vidddddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{dynCall_vidddddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viddddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{dynCall_viddddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiididdii(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{return dynCall_iiididdii(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiiiiiddddiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25,a26,a27,a28,a29){var sp=stackSave();try{return dynCall_iiiiiiiiiiiiddddiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25,a26,a27,a28,a29)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiddii(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{dynCall_viiiddii(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiiiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16){var sp=stackSave();try{return dynCall_iiiiiiiiiiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{dynCall_viiiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiiiiiddiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19){var sp=stackSave();try{return dynCall_iiiiiiiiiiiiddiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiiiiiiiiiidddiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25,a26,a27,a28){var sp=stackSave();try{return dynCall_iiiiiiiiiiiiiiiiidddiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25,a26,a27,a28)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiiiiiiiiddddiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25,a26,a27,a28){var sp=stackSave();try{return dynCall_iiiiiiiiiiiiiiiddddiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25,a26,a27,a28)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viddddiii(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{dynCall_viddddiii(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiiiiiiiiiiiddddiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25,a26,a27,a28,a29,a30,a31,a32){var sp=stackSave();try{return dynCall_iiiiiiiiiiiiiiiiiiddddiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25,a26,a27,a28,a29,a30,a31,a32)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vidddiii(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{dynCall_vidddiii(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiiiiiiiiddddiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25,a26,a27){var sp=stackSave();try{return dynCall_iiiiiiiiiiiiiiiddddiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25,a26,a27)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiiiiiiiiiiiddddiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25,a26,a27,a28,a29,a30,a31){var sp=stackSave();try{return dynCall_iiiiiiiiiiiiiiiiiiddddiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25,a26,a27,a28,a29,a30,a31)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiiddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14){var sp=stackSave();try{return dynCall_iiiiiiiiiddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{dynCall_viiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiddddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{return dynCall_iiiddddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vididd(index,a1,a2,a3,a4,a5){var sp=stackSave();try{dynCall_vididd(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vidid(index,a1,a2,a3,a4){var sp=stackSave();try{dynCall_vidid(index,a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_didiidii(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_didiidii(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{return dynCall_iiiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iididd(index,a1,a2,a3,a4,a5){var sp=stackSave();try{return dynCall_iididd(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_diiidiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{return dynCall_diiidiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_diddidii(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_diddidii(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_dididd(index,a1,a2,a3,a4,a5){var sp=stackSave();try{return dynCall_dididd(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiddid(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{dynCall_viiddid(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiidii(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_iiiiidii(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{return dynCall_iiiddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14){var sp=stackSave();try{return dynCall_iiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiddidiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){var sp=stackSave();try{dynCall_viiiddidiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_didiidiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{return dynCall_didiidiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{return dynCall_iiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiidiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{return dynCall_iiidiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiididi(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{return dynCall_iiiiididi(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iidiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){var sp=stackSave();try{return dynCall_iidiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiddidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{return dynCall_iiiiiddidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiidddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{return dynCall_iiiidddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_diiiddi(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{return dynCall_diiiddi(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiddii(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{return dynCall_iiiiiddii(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viidddddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{dynCall_viidddddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiddiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){var sp=stackSave();try{return dynCall_iiiiiddiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiddidiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{dynCall_viiiddidiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiddiidiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){var sp=stackSave();try{dynCall_viiddiidiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vidddiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{dynCall_vidddiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iidiiddii(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{return dynCall_iidiiddii(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vdddiii(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{dynCall_vdddiii(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiddddii(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_iiddddii(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vdddiiii(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{dynCall_vdddiiii(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiddiii(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{return dynCall_iiiiddiii(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vidiiddddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{dynCall_vidiiddddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiddddi(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{dynCall_viiiddddi(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiddddidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{dynCall_viiddddidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiddiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14){var sp=stackSave();try{return dynCall_iiiiiiiiddiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_diidi(index,a1,a2,a3,a4){var sp=stackSave();try{return dynCall_diidi(index,a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){var sp=stackSave();try{return dynCall_iiiiiiiiddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiidddiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){var sp=stackSave();try{dynCall_viiiidddiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vdiiii(index,a1,a2,a3,a4,a5){var sp=stackSave();try{dynCall_vdiiii(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viidddii(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{dynCall_viidddii(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiidddiid(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{return dynCall_iiidddiid(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiddddd(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{return dynCall_iiddddd(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiidddddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{dynCall_viiiidddddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iddiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{return dynCall_iddiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){var sp=stackSave();try{dynCall_viiiiiiddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiddiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{dynCall_viiddiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiddiidd(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{return dynCall_iiiddiidd(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vdddiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){var sp=stackSave();try{dynCall_vdddiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiiiiddddiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24){var sp=stackSave();try{return dynCall_iiiiiiiiiiiddddiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiddddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{dynCall_viiddddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17){var sp=stackSave();try{dynCall_viiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25,a26){var sp=stackSave();try{return dynCall_iiiiiiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25,a26)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24){var sp=stackSave();try{return dynCall_iiiiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16){var sp=stackSave();try{return dynCall_iiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vidiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){var sp=stackSave();try{dynCall_vidiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiididi(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{return dynCall_iiididi(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiddd(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{dynCall_viiiiiddd(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_didddidi(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_didddidi(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_diiddi(index,a1,a2,a3,a4,a5){var sp=stackSave();try{return dynCall_diiddi(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_didddddidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{return dynCall_didddddidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiddddid(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{return dynCall_iiiddddid(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiidi(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_iiiiiidi(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiidddddddddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){var sp=stackSave();try{return dynCall_iiidddddddddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vddddiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16){var sp=stackSave();try{dynCall_vddddiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vddiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17){var sp=stackSave();try{dynCall_vddiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vddiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19){var sp=stackSave();try{dynCall_vddiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vddiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22){var sp=stackSave();try{dynCall_vddiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vddiiiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25,a26){var sp=stackSave();try{dynCall_vddiiiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25,a26)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiiiiidii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15){var sp=stackSave();try{dynCall_viiiiiiiiiiiidii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiiiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15){var sp=stackSave();try{dynCall_viiiiiiiiiiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14){var sp=stackSave();try{return dynCall_iiiiiiiiiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiddiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19){var sp=stackSave();try{dynCall_viiiddiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiddiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{return dynCall_iiddiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiddiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){var sp=stackSave();try{dynCall_viiddiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiddiid(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{return dynCall_iiddiid(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viddiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){var sp=stackSave();try{dynCall_viddiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiddddddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){var sp=stackSave();try{return dynCall_iiddddddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vdiddii(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{dynCall_vdiddii(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{dynCall_viiiiiddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viidddddddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{dynCall_viidddddddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiidddd(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{dynCall_viiiidddd(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiidddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{dynCall_viiiiidddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viididd(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{dynCall_viididd(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vidddidddddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){var sp=stackSave();try{dynCall_vidddidddddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{dynCall_viiiiiiiddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiddddddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{return dynCall_iiiiddddddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiidiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{return dynCall_iiiidiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iddid(index,a1,a2,a3,a4){var sp=stackSave();try{return dynCall_iddid(index,a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiidiidid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){var sp=stackSave();try{dynCall_viiiiiidiidid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vididdi(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{dynCall_vididdi(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiidddddddddiiddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22){var sp=stackSave();try{return dynCall_iiiiiiiidddddddddiiddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_idiiiii(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{return dynCall_idiiiii(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){var sp=stackSave();try{dynCall_viiiiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiidiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{dynCall_viiidiiii(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiddddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{dynCall_viiiiiddddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{return dynCall_iiiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiidiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){var sp=stackSave();try{return dynCall_iiiiidiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiidddddddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){var sp=stackSave();try{dynCall_viiiiidddddddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiidiiidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){var sp=stackSave();try{return dynCall_iiiiiidiiidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiidddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{dynCall_viiiiiidddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iidddidd(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_iidddidd(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiidiid(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{return dynCall_iiidiid(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){var sp=stackSave();try{return dynCall_iiiiiiiiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiiiidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){var sp=stackSave();try{dynCall_viiiiiiiiiiidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){var sp=stackSave();try{dynCall_viiiiiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiddiddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){var sp=stackSave();try{return dynCall_iiiiiiddiddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_diiddd(index,a1,a2,a3,a4,a5){var sp=stackSave();try{return dynCall_diiddd(index,a1,a2,a3,a4,a5)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viddidddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){var sp=stackSave();try{dynCall_viddidddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiddidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){var sp=stackSave();try{dynCall_viiiiiddidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiidiidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{return dynCall_iiiiidiidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_idiiiiii(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_idiiiiii(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiidiidiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{return dynCall_iiidiidiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_vidiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{dynCall_vidiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiddddddd(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{return dynCall_iiddddddd(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiiiiiddddiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25){var sp=stackSave();try{return dynCall_iiiiiiiiiiiddddiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iidddiii(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_iidddiii(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viddddd(index,a1,a2,a3,a4,a5,a6){var sp=stackSave();try{dynCall_viddddd(index,a1,a2,a3,a4,a5,a6)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){var sp=stackSave();try{dynCall_viiiiiiiddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){var sp=stackSave();try{dynCall_viiiiiiiddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiiidddiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19){var sp=stackSave();try{dynCall_viiiiiiiiiidddiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viiiiiiiiiidddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16){var sp=stackSave();try{dynCall_viiiiiiiiiidddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){var sp=stackSave();try{return dynCall_iiiiiddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_viddiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8){var sp=stackSave();try{dynCall_viddiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iidddiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14){var sp=stackSave();try{return dynCall_iidddiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiiididd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){var sp=stackSave();try{return dynCall_iiiiiiiididd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiddidi(index,a1,a2,a3,a4,a5,a6,a7){var sp=stackSave();try{return dynCall_iiiddidi(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiiiiiddiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){var sp=stackSave();try{return dynCall_iiiiiiddiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}function invoke_iiji(index,a1,a2,a3,a4){var sp=stackSave();try{return dynCall_iiji(index,a1,a2,a3,a4)}catch(e){stackRestore(sp);if(e!==e+0&&e!=="longjmp")throw e;_setThrew(1,0)}}Module["UTF8ToString"]=UTF8ToString;Module["FS"]=FS;var calledRun;function ExitStatus(status){this.name="ExitStatus";this.message="Program terminated with exit("+status+")";this.status=status}dependenciesFulfilled=function runCaller(){if(!calledRun)run();if(!calledRun)dependenciesFulfilled=runCaller};function run(args){args=args||arguments_;if(runDependencies>0){return}preRun();if(runDependencies>0)return;function doRun(){if(calledRun)return;calledRun=true;Module["calledRun"]=true;if(ABORT)return;initRuntime();preMain();readyPromiseResolve(Module);if(Module["onRuntimeInitialized"])Module["onRuntimeInitialized"]();postRun()}if(Module["setStatus"]){Module["setStatus"]("Running...");setTimeout(function(){setTimeout(function(){Module["setStatus"]("")},1);doRun()},1)}else{doRun()}}Module["run"]=run;function exit(status,implicit){if(implicit&&noExitRuntime&&status===0){return}if(noExitRuntime){}else{ABORT=true;EXITSTATUS=status;exitRuntime();if(Module["onExit"])Module["onExit"](status)}quit_(status,new ExitStatus(status))}if(Module["preInit"]){if(typeof Module["preInit"]=="function")Module["preInit"]=[Module["preInit"]];while(Module["preInit"].length>0){Module["preInit"].pop()()}}noExitRuntime=true;run();function WrapperObject(){}WrapperObject.prototype=Object.create(WrapperObject.prototype);WrapperObject.prototype.constructor=WrapperObject;WrapperObject.prototype.__class__=WrapperObject;WrapperObject.__cache__={};Module["WrapperObject"]=WrapperObject;function getCache(__class__){return(__class__||WrapperObject).__cache__}Module["getCache"]=getCache;function wrapPointer(ptr,__class__){var cache=getCache(__class__);var ret=cache[ptr];if(ret)return ret;ret=Object.create((__class__||WrapperObject).prototype);ret.ptr=ptr;return cache[ptr]=ret}Module["wrapPointer"]=wrapPointer;function castObject(obj,__class__){return wrapPointer(obj.ptr,__class__)}Module["castObject"]=castObject;Module["NULL"]=wrapPointer(0);function destroy(obj){if(!obj["__destroy__"])throw"Error: Cannot destroy object. (Did you create it yourself?)";obj["__destroy__"]();delete getCache(obj.__class__)[obj.ptr]}Module["destroy"]=destroy;function compare(obj1,obj2){return obj1.ptr===obj2.ptr}Module["compare"]=compare;function getPointer(obj){return obj.ptr}Module["getPointer"]=getPointer;function getClass(obj){return obj.__class__}Module["getClass"]=getClass;var ensureCache={buffer:0,size:0,pos:0,temps:[],needed:0,prepare:function(){if(ensureCache.needed){for(var i=0;i<ensureCache.temps.length;i++){Module["_free"](ensureCache.temps[i])}ensureCache.temps.length=0;Module["_free"](ensureCache.buffer);ensureCache.buffer=0;ensureCache.size+=ensureCache.needed;ensureCache.needed=0}if(!ensureCache.buffer){ensureCache.size+=128;ensureCache.buffer=Module["_malloc"](ensureCache.size);assert(ensureCache.buffer)}ensureCache.pos=0},alloc:function(array,view){assert(ensureCache.buffer);var bytes=view.BYTES_PER_ELEMENT;var len=array.length*bytes;len=len+7&-8;var ret;if(ensureCache.pos+len>=ensureCache.size){assert(len>0);ensureCache.needed+=len;ret=Module["_malloc"](len);ensureCache.temps.push(ret)}else{ret=ensureCache.buffer+ensureCache.pos;ensureCache.pos+=len}return ret},copy:function(array,view,offset){offset>>>=0;var bytes=view.BYTES_PER_ELEMENT;switch(bytes){case 2:offset>>>=1;break;case 4:offset>>>=2;break;case 8:offset>>>=3;break}for(var i=0;i<array.length;i++){view[offset+i]=array[i]}}};function ensureString(value){if(typeof value==="string"){var intArray=intArrayFromString(value);var offset=ensureCache.alloc(intArray,HEAP8);ensureCache.copy(intArray,HEAP8,offset);return offset}return value}function Standard_Transient(){throw"cannot construct a Standard_Transient, no constructor in IDL"}Standard_Transient.prototype=Object.create(WrapperObject.prototype);Standard_Transient.prototype.constructor=Standard_Transient;Standard_Transient.prototype.__class__=Standard_Transient;Standard_Transient.__cache__={};Module["Standard_Transient"]=Standard_Transient;Standard_Transient.prototype["get_type_name"]=Standard_Transient.prototype.get_type_name=function(){var self=this.ptr;return UTF8ToString(_emscripten_bind_Standard_Transient_get_type_name_0(self))};Standard_Transient.prototype["DynamicType"]=Standard_Transient.prototype.DynamicType=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Standard_Transient_DynamicType_0(self),Handle_Standard_Type)};Standard_Transient.prototype["__destroy__"]=Standard_Transient.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Standard_Transient___destroy___0(self)};function Geom_Geometry(){throw"cannot construct a Geom_Geometry, no constructor in IDL"}Geom_Geometry.prototype=Object.create(Standard_Transient.prototype);Geom_Geometry.prototype.constructor=Geom_Geometry;Geom_Geometry.prototype.__class__=Geom_Geometry;Geom_Geometry.__cache__={};Module["Geom_Geometry"]=Geom_Geometry;Geom_Geometry.prototype["get_type_name"]=Geom_Geometry.prototype.get_type_name=function(){var self=this.ptr;return UTF8ToString(_emscripten_bind_Geom_Geometry_get_type_name_0(self))};Geom_Geometry.prototype["DynamicType"]=Geom_Geometry.prototype.DynamicType=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Geom_Geometry_DynamicType_0(self),Handle_Standard_Type)};Geom_Geometry.prototype["__destroy__"]=Geom_Geometry.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Geom_Geometry___destroy___0(self)};function BRepBuilderAPI_MakeShape(){throw"cannot construct a BRepBuilderAPI_MakeShape, no constructor in IDL"}BRepBuilderAPI_MakeShape.prototype=Object.create(WrapperObject.prototype);BRepBuilderAPI_MakeShape.prototype.constructor=BRepBuilderAPI_MakeShape;BRepBuilderAPI_MakeShape.prototype.__class__=BRepBuilderAPI_MakeShape;BRepBuilderAPI_MakeShape.__cache__={};Module["BRepBuilderAPI_MakeShape"]=BRepBuilderAPI_MakeShape;BRepBuilderAPI_MakeShape.prototype["Build"]=BRepBuilderAPI_MakeShape.prototype.Build=function(){var self=this.ptr;_emscripten_bind_BRepBuilderAPI_MakeShape_Build_0(self)};BRepBuilderAPI_MakeShape.prototype["Shape"]=BRepBuilderAPI_MakeShape.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepBuilderAPI_MakeShape_Shape_0(self),TopoDS_Shape)};BRepBuilderAPI_MakeShape.prototype["IsDeleted"]=BRepBuilderAPI_MakeShape.prototype.IsDeleted=function(S){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;return!!_emscripten_bind_BRepBuilderAPI_MakeShape_IsDeleted_1(self,S)};BRepBuilderAPI_MakeShape.prototype["__destroy__"]=BRepBuilderAPI_MakeShape.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepBuilderAPI_MakeShape___destroy___0(self)};function Geom_Surface(){throw"cannot construct a Geom_Surface, no constructor in IDL"}Geom_Surface.prototype=Object.create(Geom_Geometry.prototype);Geom_Surface.prototype.constructor=Geom_Surface;Geom_Surface.prototype.__class__=Geom_Surface;Geom_Surface.__cache__={};Module["Geom_Surface"]=Geom_Surface;Geom_Surface.prototype["get_type_name"]=Geom_Surface.prototype.get_type_name=function(){var self=this.ptr;return UTF8ToString(_emscripten_bind_Geom_Surface_get_type_name_0(self))};Geom_Surface.prototype["DynamicType"]=Geom_Surface.prototype.DynamicType=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Geom_Surface_DynamicType_0(self),Handle_Standard_Type)};Geom_Surface.prototype["__destroy__"]=Geom_Surface.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Geom_Surface___destroy___0(self)};function Geom_Curve(){throw"cannot construct a Geom_Curve, no constructor in IDL"}Geom_Curve.prototype=Object.create(WrapperObject.prototype);Geom_Curve.prototype.constructor=Geom_Curve;Geom_Curve.prototype.__class__=Geom_Curve;Geom_Curve.__cache__={};Module["Geom_Curve"]=Geom_Curve;Geom_Curve.prototype["Reverse"]=Geom_Curve.prototype.Reverse=function(){var self=this.ptr;_emscripten_bind_Geom_Curve_Reverse_0(self)};Geom_Curve.prototype["ReversedParameter"]=Geom_Curve.prototype.ReversedParameter=function(U){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;return _emscripten_bind_Geom_Curve_ReversedParameter_1(self,U)};Geom_Curve.prototype["TransformedParameter"]=Geom_Curve.prototype.TransformedParameter=function(U,T){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(T&&typeof T==="object")T=T.ptr;return _emscripten_bind_Geom_Curve_TransformedParameter_2(self,U,T)};Geom_Curve.prototype["ParametricTransformation"]=Geom_Curve.prototype.ParametricTransformation=function(T){var self=this.ptr;if(T&&typeof T==="object")T=T.ptr;return _emscripten_bind_Geom_Curve_ParametricTransformation_1(self,T)};Geom_Curve.prototype["Reversed"]=Geom_Curve.prototype.Reversed=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Geom_Curve_Reversed_0(self),Handle_Geom_Curve)};Geom_Curve.prototype["FirstParameter"]=Geom_Curve.prototype.FirstParameter=function(){var self=this.ptr;return _emscripten_bind_Geom_Curve_FirstParameter_0(self)};Geom_Curve.prototype["LastParameter"]=Geom_Curve.prototype.LastParameter=function(){var self=this.ptr;return _emscripten_bind_Geom_Curve_LastParameter_0(self)};Geom_Curve.prototype["IsClosed"]=Geom_Curve.prototype.IsClosed=function(){var self=this.ptr;return!!_emscripten_bind_Geom_Curve_IsClosed_0(self)};Geom_Curve.prototype["IsPeriodic"]=Geom_Curve.prototype.IsPeriodic=function(){var self=this.ptr;return!!_emscripten_bind_Geom_Curve_IsPeriodic_0(self)};Geom_Curve.prototype["Period"]=Geom_Curve.prototype.Period=function(){var self=this.ptr;return _emscripten_bind_Geom_Curve_Period_0(self)};Geom_Curve.prototype["IsCN"]=Geom_Curve.prototype.IsCN=function(N){var self=this.ptr;if(N&&typeof N==="object")N=N.ptr;return!!_emscripten_bind_Geom_Curve_IsCN_1(self,N)};Geom_Curve.prototype["D0"]=Geom_Curve.prototype.D0=function(U,P){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;_emscripten_bind_Geom_Curve_D0_2(self,U,P)};Geom_Curve.prototype["D1"]=Geom_Curve.prototype.D1=function(U,P,V1){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;_emscripten_bind_Geom_Curve_D1_3(self,U,P,V1)};Geom_Curve.prototype["D2"]=Geom_Curve.prototype.D2=function(U,P,V1,V2){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;if(V2&&typeof V2==="object")V2=V2.ptr;_emscripten_bind_Geom_Curve_D2_4(self,U,P,V1,V2)};Geom_Curve.prototype["D3"]=Geom_Curve.prototype.D3=function(U,P,V1,V2,V3){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;if(V2&&typeof V2==="object")V2=V2.ptr;if(V3&&typeof V3==="object")V3=V3.ptr;_emscripten_bind_Geom_Curve_D3_5(self,U,P,V1,V2,V3)};Geom_Curve.prototype["DN"]=Geom_Curve.prototype.DN=function(U,N){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(N&&typeof N==="object")N=N.ptr;_emscripten_bind_Geom_Curve_DN_2(self,U,N)};Geom_Curve.prototype["Value"]=Geom_Curve.prototype.Value=function(U){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;return wrapPointer(_emscripten_bind_Geom_Curve_Value_1(self,U),gp_Pnt)};Geom_Curve.prototype["__destroy__"]=Geom_Curve.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Geom_Curve___destroy___0(self)};function Geom2d_Curve(){throw"cannot construct a Geom2d_Curve, no constructor in IDL"}Geom2d_Curve.prototype=Object.create(WrapperObject.prototype);Geom2d_Curve.prototype.constructor=Geom2d_Curve;Geom2d_Curve.prototype.__class__=Geom2d_Curve;Geom2d_Curve.__cache__={};Module["Geom2d_Curve"]=Geom2d_Curve;Geom2d_Curve.prototype["Period"]=Geom2d_Curve.prototype.Period=function(){var self=this.ptr;return _emscripten_bind_Geom2d_Curve_Period_0(self)};Geom2d_Curve.prototype["Value"]=Geom2d_Curve.prototype.Value=function(U){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;return wrapPointer(_emscripten_bind_Geom2d_Curve_Value_1(self,U),gp_Pnt2d)};Geom2d_Curve.prototype["__destroy__"]=Geom2d_Curve.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Geom2d_Curve___destroy___0(self)};function Transfer_ProcessForTransient(){this.ptr=_emscripten_bind_Transfer_ProcessForTransient_Transfer_ProcessForTransient_0();getCache(Transfer_ProcessForTransient)[this.ptr]=this}Transfer_ProcessForTransient.prototype=Object.create(WrapperObject.prototype);Transfer_ProcessForTransient.prototype.constructor=Transfer_ProcessForTransient;Transfer_ProcessForTransient.prototype.__class__=Transfer_ProcessForTransient;Transfer_ProcessForTransient.__cache__={};Module["Transfer_ProcessForTransient"]=Transfer_ProcessForTransient;Transfer_ProcessForTransient.prototype["GetProgress"]=Transfer_ProcessForTransient.prototype.GetProgress=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Transfer_ProcessForTransient_GetProgress_0(self),Handle_Message_ProgressIndicator)};Transfer_ProcessForTransient.prototype["SetProgress"]=Transfer_ProcessForTransient.prototype.SetProgress=function(theProgess){var self=this.ptr;if(theProgess&&typeof theProgess==="object")theProgess=theProgess.ptr;_emscripten_bind_Transfer_ProcessForTransient_SetProgress_1(self,theProgess)};Transfer_ProcessForTransient.prototype["__destroy__"]=Transfer_ProcessForTransient.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Transfer_ProcessForTransient___destroy___0(self)};function Geom2d_Conic(){throw"cannot construct a Geom2d_Conic, no constructor in IDL"}Geom2d_Conic.prototype=Object.create(Geom2d_Curve.prototype);Geom2d_Conic.prototype.constructor=Geom2d_Conic;Geom2d_Conic.prototype.__class__=Geom2d_Conic;Geom2d_Conic.__cache__={};Module["Geom2d_Conic"]=Geom2d_Conic;Geom2d_Conic.prototype["Period"]=Geom2d_Conic.prototype.Period=function(){var self=this.ptr;return _emscripten_bind_Geom2d_Conic_Period_0(self)};Geom2d_Conic.prototype["Value"]=Geom2d_Conic.prototype.Value=function(U){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;return wrapPointer(_emscripten_bind_Geom2d_Conic_Value_1(self,U),gp_Pnt2d)};Geom2d_Conic.prototype["__destroy__"]=Geom2d_Conic.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Geom2d_Conic___destroy___0(self)};function TopoDS_Builder(){throw"cannot construct a TopoDS_Builder, no constructor in IDL"}TopoDS_Builder.prototype=Object.create(WrapperObject.prototype);TopoDS_Builder.prototype.constructor=TopoDS_Builder;TopoDS_Builder.prototype.__class__=TopoDS_Builder;TopoDS_Builder.__cache__={};Module["TopoDS_Builder"]=TopoDS_Builder;TopoDS_Builder.prototype["MakeWire"]=TopoDS_Builder.prototype.MakeWire=function(W){var self=this.ptr;if(W&&typeof W==="object")W=W.ptr;_emscripten_bind_TopoDS_Builder_MakeWire_1(self,W)};TopoDS_Builder.prototype["MakeCompound"]=TopoDS_Builder.prototype.MakeCompound=function(C){var self=this.ptr;if(C&&typeof C==="object")C=C.ptr;_emscripten_bind_TopoDS_Builder_MakeCompound_1(self,C)};TopoDS_Builder.prototype["Add"]=TopoDS_Builder.prototype.Add=function(S,C){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;if(C&&typeof C==="object")C=C.ptr;_emscripten_bind_TopoDS_Builder_Add_2(self,S,C)};TopoDS_Builder.prototype["Remove"]=TopoDS_Builder.prototype.Remove=function(S,C){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;if(C&&typeof C==="object")C=C.ptr;_emscripten_bind_TopoDS_Builder_Remove_2(self,S,C)};TopoDS_Builder.prototype["__destroy__"]=TopoDS_Builder.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_TopoDS_Builder___destroy___0(self)};function TopoDS_Shape(T2){if(T2&&typeof T2==="object")T2=T2.ptr;if(T2===undefined){this.ptr=_emscripten_bind_TopoDS_Shape_TopoDS_Shape_0();getCache(TopoDS_Shape)[this.ptr]=this;return}this.ptr=_emscripten_bind_TopoDS_Shape_TopoDS_Shape_1(T2);getCache(TopoDS_Shape)[this.ptr]=this}TopoDS_Shape.prototype=Object.create(WrapperObject.prototype);TopoDS_Shape.prototype.constructor=TopoDS_Shape;TopoDS_Shape.prototype.__class__=TopoDS_Shape;TopoDS_Shape.__cache__={};Module["TopoDS_Shape"]=TopoDS_Shape;TopoDS_Shape.prototype["IsNull"]=TopoDS_Shape.prototype.IsNull=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Shape_IsNull_0(self)};TopoDS_Shape.prototype["Nullify"]=TopoDS_Shape.prototype.Nullify=function(){var self=this.ptr;_emscripten_bind_TopoDS_Shape_Nullify_0(self)};TopoDS_Shape.prototype["Location"]=TopoDS_Shape.prototype.Location=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_Shape_Location_0(self),TopLoc_Location)};TopoDS_Shape.prototype["Located"]=TopoDS_Shape.prototype.Located=function(theLoc){var self=this.ptr;if(theLoc&&typeof theLoc==="object")theLoc=theLoc.ptr;return wrapPointer(_emscripten_bind_TopoDS_Shape_Located_1(self,theLoc),TopoDS_Shape)};TopoDS_Shape.prototype["Orientation"]=TopoDS_Shape.prototype.Orientation=function(){var self=this.ptr;return _emscripten_bind_TopoDS_Shape_Orientation_0(self)};TopoDS_Shape.prototype["Oriented"]=TopoDS_Shape.prototype.Oriented=function(theOrient){var self=this.ptr;if(theOrient&&typeof theOrient==="object")theOrient=theOrient.ptr;return wrapPointer(_emscripten_bind_TopoDS_Shape_Oriented_1(self,theOrient),TopoDS_Shape)};TopoDS_Shape.prototype["ShapeType"]=TopoDS_Shape.prototype.ShapeType=function(){var self=this.ptr;return _emscripten_bind_TopoDS_Shape_ShapeType_0(self)};TopoDS_Shape.prototype["Free"]=TopoDS_Shape.prototype.Free=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Shape_Free_0(self)};TopoDS_Shape.prototype["Locked"]=TopoDS_Shape.prototype.Locked=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Shape_Locked_0(self)};TopoDS_Shape.prototype["Modified"]=TopoDS_Shape.prototype.Modified=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Shape_Modified_0(self)};TopoDS_Shape.prototype["Checked"]=TopoDS_Shape.prototype.Checked=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Shape_Checked_0(self)};TopoDS_Shape.prototype["Orientable"]=TopoDS_Shape.prototype.Orientable=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Shape_Orientable_0(self)};TopoDS_Shape.prototype["Closed"]=TopoDS_Shape.prototype.Closed=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Shape_Closed_0(self)};TopoDS_Shape.prototype["Infinite"]=TopoDS_Shape.prototype.Infinite=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Shape_Infinite_0(self)};TopoDS_Shape.prototype["Convex"]=TopoDS_Shape.prototype.Convex=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Shape_Convex_0(self)};TopoDS_Shape.prototype["Move"]=TopoDS_Shape.prototype.Move=function(thePosition){var self=this.ptr;if(thePosition&&typeof thePosition==="object")thePosition=thePosition.ptr;_emscripten_bind_TopoDS_Shape_Move_1(self,thePosition)};TopoDS_Shape.prototype["Moved"]=TopoDS_Shape.prototype.Moved=function(thePosition){var self=this.ptr;if(thePosition&&typeof thePosition==="object")thePosition=thePosition.ptr;return wrapPointer(_emscripten_bind_TopoDS_Shape_Moved_1(self,thePosition),TopoDS_Shape)};TopoDS_Shape.prototype["Reverse"]=TopoDS_Shape.prototype.Reverse=function(){var self=this.ptr;_emscripten_bind_TopoDS_Shape_Reverse_0(self)};TopoDS_Shape.prototype["Reversed"]=TopoDS_Shape.prototype.Reversed=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_Shape_Reversed_0(self),TopoDS_Shape)};TopoDS_Shape.prototype["Complement"]=TopoDS_Shape.prototype.Complement=function(){var self=this.ptr;_emscripten_bind_TopoDS_Shape_Complement_0(self)};TopoDS_Shape.prototype["Complemented"]=TopoDS_Shape.prototype.Complemented=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_Shape_Complemented_0(self),TopoDS_Shape)};TopoDS_Shape.prototype["Compose"]=TopoDS_Shape.prototype.Compose=function(theOrient){var self=this.ptr;if(theOrient&&typeof theOrient==="object")theOrient=theOrient.ptr;_emscripten_bind_TopoDS_Shape_Compose_1(self,theOrient)};TopoDS_Shape.prototype["Composed"]=TopoDS_Shape.prototype.Composed=function(theOrient){var self=this.ptr;if(theOrient&&typeof theOrient==="object")theOrient=theOrient.ptr;return wrapPointer(_emscripten_bind_TopoDS_Shape_Composed_1(self,theOrient),TopoDS_Shape)};TopoDS_Shape.prototype["NbChildren"]=TopoDS_Shape.prototype.NbChildren=function(){var self=this.ptr;return _emscripten_bind_TopoDS_Shape_NbChildren_0(self)};TopoDS_Shape.prototype["IsPartner"]=TopoDS_Shape.prototype.IsPartner=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_Shape_IsPartner_1(self,theOther)};TopoDS_Shape.prototype["IsSame"]=TopoDS_Shape.prototype.IsSame=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_Shape_IsSame_1(self,theOther)};TopoDS_Shape.prototype["IsEqual"]=TopoDS_Shape.prototype.IsEqual=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_Shape_IsEqual_1(self,theOther)};TopoDS_Shape.prototype["IsNotEqual"]=TopoDS_Shape.prototype.IsNotEqual=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_Shape_IsNotEqual_1(self,theOther)};TopoDS_Shape.prototype["HashCode"]=TopoDS_Shape.prototype.HashCode=function(theUpperBound){var self=this.ptr;if(theUpperBound&&typeof theUpperBound==="object")theUpperBound=theUpperBound.ptr;return _emscripten_bind_TopoDS_Shape_HashCode_1(self,theUpperBound)};TopoDS_Shape.prototype["EmptyCopy"]=TopoDS_Shape.prototype.EmptyCopy=function(){var self=this.ptr;_emscripten_bind_TopoDS_Shape_EmptyCopy_0(self)};TopoDS_Shape.prototype["EmptyCopied"]=TopoDS_Shape.prototype.EmptyCopied=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_Shape_EmptyCopied_0(self),TopoDS_Shape)};TopoDS_Shape.prototype["__destroy__"]=TopoDS_Shape.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_TopoDS_Shape___destroy___0(self)};function BRepOffsetAPI_MakeOffsetShape(){this.ptr=_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_BRepOffsetAPI_MakeOffsetShape_0();getCache(BRepOffsetAPI_MakeOffsetShape)[this.ptr]=this}BRepOffsetAPI_MakeOffsetShape.prototype=Object.create(BRepBuilderAPI_MakeShape.prototype);BRepOffsetAPI_MakeOffsetShape.prototype.constructor=BRepOffsetAPI_MakeOffsetShape;BRepOffsetAPI_MakeOffsetShape.prototype.__class__=BRepOffsetAPI_MakeOffsetShape;BRepOffsetAPI_MakeOffsetShape.__cache__={};Module["BRepOffsetAPI_MakeOffsetShape"]=BRepOffsetAPI_MakeOffsetShape;BRepOffsetAPI_MakeOffsetShape.prototype["PerformBySimple"]=BRepOffsetAPI_MakeOffsetShape.prototype.PerformBySimple=function(theS,theOffsetValue){var self=this.ptr;if(theS&&typeof theS==="object")theS=theS.ptr;if(theOffsetValue&&typeof theOffsetValue==="object")theOffsetValue=theOffsetValue.ptr;_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformBySimple_2(self,theS,theOffsetValue)};BRepOffsetAPI_MakeOffsetShape.prototype["PerformByJoin"]=BRepOffsetAPI_MakeOffsetShape.prototype.PerformByJoin=function(S,Offset,Tol,Mode,Intersection,SelfInter,Join,RemoveIntEdges){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;if(Offset&&typeof Offset==="object")Offset=Offset.ptr;if(Tol&&typeof Tol==="object")Tol=Tol.ptr;if(Mode&&typeof Mode==="object")Mode=Mode.ptr;if(Intersection&&typeof Intersection==="object")Intersection=Intersection.ptr;if(SelfInter&&typeof SelfInter==="object")SelfInter=SelfInter.ptr;if(Join&&typeof Join==="object")Join=Join.ptr;if(RemoveIntEdges&&typeof RemoveIntEdges==="object")RemoveIntEdges=RemoveIntEdges.ptr;if(Mode===undefined){_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformByJoin_3(self,S,Offset,Tol);return}if(Intersection===undefined){_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformByJoin_4(self,S,Offset,Tol,Mode);return}if(SelfInter===undefined){_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformByJoin_5(self,S,Offset,Tol,Mode,Intersection);return}if(Join===undefined){_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformByJoin_6(self,S,Offset,Tol,Mode,Intersection,SelfInter);return}if(RemoveIntEdges===undefined){_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformByJoin_7(self,S,Offset,Tol,Mode,Intersection,SelfInter,Join);return}_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_PerformByJoin_8(self,S,Offset,Tol,Mode,Intersection,SelfInter,Join,RemoveIntEdges)};BRepOffsetAPI_MakeOffsetShape.prototype["Shape"]=BRepOffsetAPI_MakeOffsetShape.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepOffsetAPI_MakeOffsetShape_Shape_0(self),TopoDS_Shape)};BRepOffsetAPI_MakeOffsetShape.prototype["__destroy__"]=BRepOffsetAPI_MakeOffsetShape.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepOffsetAPI_MakeOffsetShape___destroy___0(self)};function BRepFilletAPI_LocalOperation(){throw"cannot construct a BRepFilletAPI_LocalOperation, no constructor in IDL"}BRepFilletAPI_LocalOperation.prototype=Object.create(BRepBuilderAPI_MakeShape.prototype);BRepFilletAPI_LocalOperation.prototype.constructor=BRepFilletAPI_LocalOperation;BRepFilletAPI_LocalOperation.prototype.__class__=BRepFilletAPI_LocalOperation;BRepFilletAPI_LocalOperation.__cache__={};Module["BRepFilletAPI_LocalOperation"]=BRepFilletAPI_LocalOperation;BRepFilletAPI_LocalOperation.prototype["Shape"]=BRepFilletAPI_LocalOperation.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepFilletAPI_LocalOperation_Shape_0(self),TopoDS_Shape)};BRepFilletAPI_LocalOperation.prototype["__destroy__"]=BRepFilletAPI_LocalOperation.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepFilletAPI_LocalOperation___destroy___0(self)};function Geom_ElementarySurface(){throw"cannot construct a Geom_ElementarySurface, no constructor in IDL"}Geom_ElementarySurface.prototype=Object.create(Geom_Surface.prototype);Geom_ElementarySurface.prototype.constructor=Geom_ElementarySurface;Geom_ElementarySurface.prototype.__class__=Geom_ElementarySurface;Geom_ElementarySurface.__cache__={};Module["Geom_ElementarySurface"]=Geom_ElementarySurface;Geom_ElementarySurface.prototype["Location"]=Geom_ElementarySurface.prototype.Location=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Geom_ElementarySurface_Location_0(self),gp_Pnt)};Geom_ElementarySurface.prototype["get_type_name"]=Geom_ElementarySurface.prototype.get_type_name=function(){var self=this.ptr;return UTF8ToString(_emscripten_bind_Geom_ElementarySurface_get_type_name_0(self))};Geom_ElementarySurface.prototype["DynamicType"]=Geom_ElementarySurface.prototype.DynamicType=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Geom_ElementarySurface_DynamicType_0(self),Handle_Standard_Type)};Geom_ElementarySurface.prototype["__destroy__"]=Geom_ElementarySurface.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Geom_ElementarySurface___destroy___0(self)};function Geom2d_BoundedCurve(){throw"cannot construct a Geom2d_BoundedCurve, no constructor in IDL"}Geom2d_BoundedCurve.prototype=Object.create(Geom2d_Curve.prototype);Geom2d_BoundedCurve.prototype.constructor=Geom2d_BoundedCurve;Geom2d_BoundedCurve.prototype.__class__=Geom2d_BoundedCurve;Geom2d_BoundedCurve.__cache__={};Module["Geom2d_BoundedCurve"]=Geom2d_BoundedCurve;Geom2d_BoundedCurve.prototype["Period"]=Geom2d_BoundedCurve.prototype.Period=function(){var self=this.ptr;return _emscripten_bind_Geom2d_BoundedCurve_Period_0(self)};Geom2d_BoundedCurve.prototype["Value"]=Geom2d_BoundedCurve.prototype.Value=function(U){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;return wrapPointer(_emscripten_bind_Geom2d_BoundedCurve_Value_1(self,U),gp_Pnt2d)};Geom2d_BoundedCurve.prototype["__destroy__"]=Geom2d_BoundedCurve.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Geom2d_BoundedCurve___destroy___0(self)};function XSControl_Reader(WS,scratch){if(WS&&typeof WS==="object")WS=WS.ptr;if(scratch&&typeof scratch==="object")scratch=scratch.ptr;if(WS===undefined){this.ptr=_emscripten_bind_XSControl_Reader_XSControl_Reader_0();getCache(XSControl_Reader)[this.ptr]=this;return}if(scratch===undefined){this.ptr=_emscripten_bind_XSControl_Reader_XSControl_Reader_1(WS);getCache(XSControl_Reader)[this.ptr]=this;return}this.ptr=_emscripten_bind_XSControl_Reader_XSControl_Reader_2(WS,scratch);getCache(XSControl_Reader)[this.ptr]=this}XSControl_Reader.prototype=Object.create(WrapperObject.prototype);XSControl_Reader.prototype.constructor=XSControl_Reader;XSControl_Reader.prototype.__class__=XSControl_Reader;XSControl_Reader.__cache__={};Module["XSControl_Reader"]=XSControl_Reader;XSControl_Reader.prototype["SetNorm"]=XSControl_Reader.prototype.SetNorm=function(norm){var self=this.ptr;ensureCache.prepare();if(norm&&typeof norm==="object")norm=norm.ptr;else norm=ensureString(norm);return!!_emscripten_bind_XSControl_Reader_SetNorm_1(self,norm)};XSControl_Reader.prototype["SetWS"]=XSControl_Reader.prototype.SetWS=function(WS,scratch){var self=this.ptr;if(WS&&typeof WS==="object")WS=WS.ptr;if(scratch&&typeof scratch==="object")scratch=scratch.ptr;if(scratch===undefined){_emscripten_bind_XSControl_Reader_SetWS_1(self,WS);return}_emscripten_bind_XSControl_Reader_SetWS_2(self,WS,scratch)};XSControl_Reader.prototype["WS"]=XSControl_Reader.prototype.WS=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_XSControl_Reader_WS_0(self),Handle_XSControl_WorkSession)};XSControl_Reader.prototype["ReadFile"]=XSControl_Reader.prototype.ReadFile=function(filename){var self=this.ptr;ensureCache.prepare();if(filename&&typeof filename==="object")filename=filename.ptr;else filename=ensureString(filename);return _emscripten_bind_XSControl_Reader_ReadFile_1(self,filename)};XSControl_Reader.prototype["NbRootsForTransfer"]=XSControl_Reader.prototype.NbRootsForTransfer=function(){var self=this.ptr;return _emscripten_bind_XSControl_Reader_NbRootsForTransfer_0(self)};XSControl_Reader.prototype["TransferOneRoot"]=XSControl_Reader.prototype.TransferOneRoot=function(num){var self=this.ptr;if(num&&typeof num==="object")num=num.ptr;if(num===undefined){return!!_emscripten_bind_XSControl_Reader_TransferOneRoot_0(self)}return!!_emscripten_bind_XSControl_Reader_TransferOneRoot_1(self,num)};XSControl_Reader.prototype["TransferOne"]=XSControl_Reader.prototype.TransferOne=function(num){var self=this.ptr;if(num&&typeof num==="object")num=num.ptr;return!!_emscripten_bind_XSControl_Reader_TransferOne_1(self,num)};XSControl_Reader.prototype["TransferRoots"]=XSControl_Reader.prototype.TransferRoots=function(){var self=this.ptr;return _emscripten_bind_XSControl_Reader_TransferRoots_0(self)};XSControl_Reader.prototype["ClearShapes"]=XSControl_Reader.prototype.ClearShapes=function(){var self=this.ptr;_emscripten_bind_XSControl_Reader_ClearShapes_0(self)};XSControl_Reader.prototype["NbShapes"]=XSControl_Reader.prototype.NbShapes=function(){var self=this.ptr;return _emscripten_bind_XSControl_Reader_NbShapes_0(self)};XSControl_Reader.prototype["Shape"]=XSControl_Reader.prototype.Shape=function(num){var self=this.ptr;if(num&&typeof num==="object")num=num.ptr;if(num===undefined){return wrapPointer(_emscripten_bind_XSControl_Reader_Shape_0(self),TopoDS_Shape)}return wrapPointer(_emscripten_bind_XSControl_Reader_Shape_1(self,num),TopoDS_Shape)};XSControl_Reader.prototype["OneShape"]=XSControl_Reader.prototype.OneShape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_XSControl_Reader_OneShape_0(self),TopoDS_Shape)};XSControl_Reader.prototype["PrintStatsTransfer"]=XSControl_Reader.prototype.PrintStatsTransfer=function(what,mode){var self=this.ptr;if(what&&typeof what==="object")what=what.ptr;if(mode&&typeof mode==="object")mode=mode.ptr;if(mode===undefined){_emscripten_bind_XSControl_Reader_PrintStatsTransfer_1(self,what);return}_emscripten_bind_XSControl_Reader_PrintStatsTransfer_2(self,what,mode)};XSControl_Reader.prototype["__destroy__"]=XSControl_Reader.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_XSControl_Reader___destroy___0(self)};function BRepAlgoAPI_BooleanOperation(){throw"cannot construct a BRepAlgoAPI_BooleanOperation, no constructor in IDL"}BRepAlgoAPI_BooleanOperation.prototype=Object.create(BRepBuilderAPI_MakeShape.prototype);BRepAlgoAPI_BooleanOperation.prototype.constructor=BRepAlgoAPI_BooleanOperation;BRepAlgoAPI_BooleanOperation.prototype.__class__=BRepAlgoAPI_BooleanOperation;BRepAlgoAPI_BooleanOperation.__cache__={};Module["BRepAlgoAPI_BooleanOperation"]=BRepAlgoAPI_BooleanOperation;BRepAlgoAPI_BooleanOperation.prototype["Shape"]=BRepAlgoAPI_BooleanOperation.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepAlgoAPI_BooleanOperation_Shape_0(self),TopoDS_Shape)};BRepAlgoAPI_BooleanOperation.prototype["__destroy__"]=BRepAlgoAPI_BooleanOperation.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepAlgoAPI_BooleanOperation___destroy___0(self)};function BRepPrimAPI_MakeOneAxis(){throw"cannot construct a BRepPrimAPI_MakeOneAxis, no constructor in IDL"}BRepPrimAPI_MakeOneAxis.prototype=Object.create(BRepBuilderAPI_MakeShape.prototype);BRepPrimAPI_MakeOneAxis.prototype.constructor=BRepPrimAPI_MakeOneAxis;BRepPrimAPI_MakeOneAxis.prototype.__class__=BRepPrimAPI_MakeOneAxis;BRepPrimAPI_MakeOneAxis.__cache__={};Module["BRepPrimAPI_MakeOneAxis"]=BRepPrimAPI_MakeOneAxis;BRepPrimAPI_MakeOneAxis.prototype["Build"]=BRepPrimAPI_MakeOneAxis.prototype.Build=function(){var self=this.ptr;_emscripten_bind_BRepPrimAPI_MakeOneAxis_Build_0(self)};BRepPrimAPI_MakeOneAxis.prototype["Face"]=BRepPrimAPI_MakeOneAxis.prototype.Face=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeOneAxis_Face_0(self),TopoDS_Face)};BRepPrimAPI_MakeOneAxis.prototype["Shell"]=BRepPrimAPI_MakeOneAxis.prototype.Shell=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeOneAxis_Shell_0(self),TopoDS_Shell)};BRepPrimAPI_MakeOneAxis.prototype["Solid"]=BRepPrimAPI_MakeOneAxis.prototype.Solid=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeOneAxis_Solid_0(self),TopoDS_Solid)};BRepPrimAPI_MakeOneAxis.prototype["Shape"]=BRepPrimAPI_MakeOneAxis.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeOneAxis_Shape_0(self),TopoDS_Shape)};BRepPrimAPI_MakeOneAxis.prototype["IsDeleted"]=BRepPrimAPI_MakeOneAxis.prototype.IsDeleted=function(S){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;return!!_emscripten_bind_BRepPrimAPI_MakeOneAxis_IsDeleted_1(self,S)};BRepPrimAPI_MakeOneAxis.prototype["__destroy__"]=BRepPrimAPI_MakeOneAxis.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepPrimAPI_MakeOneAxis___destroy___0(self)};function BRepBuilderAPI_ModifyShape(){throw"cannot construct a BRepBuilderAPI_ModifyShape, no constructor in IDL"}BRepBuilderAPI_ModifyShape.prototype=Object.create(BRepBuilderAPI_MakeShape.prototype);BRepBuilderAPI_ModifyShape.prototype.constructor=BRepBuilderAPI_ModifyShape;BRepBuilderAPI_ModifyShape.prototype.__class__=BRepBuilderAPI_ModifyShape;BRepBuilderAPI_ModifyShape.__cache__={};Module["BRepBuilderAPI_ModifyShape"]=BRepBuilderAPI_ModifyShape;BRepBuilderAPI_ModifyShape.prototype["Shape"]=BRepBuilderAPI_ModifyShape.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepBuilderAPI_ModifyShape_Shape_0(self),TopoDS_Shape)};BRepBuilderAPI_ModifyShape.prototype["__destroy__"]=BRepBuilderAPI_ModifyShape.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepBuilderAPI_ModifyShape___destroy___0(self)};function Geom_Conic(){throw"cannot construct a Geom_Conic, no constructor in IDL"}Geom_Conic.prototype=Object.create(Geom_Curve.prototype);Geom_Conic.prototype.constructor=Geom_Conic;Geom_Conic.prototype.__class__=Geom_Conic;Geom_Conic.__cache__={};Module["Geom_Conic"]=Geom_Conic;Geom_Conic.prototype["Reverse"]=Geom_Conic.prototype.Reverse=function(){var self=this.ptr;_emscripten_bind_Geom_Conic_Reverse_0(self)};Geom_Conic.prototype["ReversedParameter"]=Geom_Conic.prototype.ReversedParameter=function(U){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;return _emscripten_bind_Geom_Conic_ReversedParameter_1(self,U)};Geom_Conic.prototype["TransformedParameter"]=Geom_Conic.prototype.TransformedParameter=function(U,T){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(T&&typeof T==="object")T=T.ptr;return _emscripten_bind_Geom_Conic_TransformedParameter_2(self,U,T)};Geom_Conic.prototype["ParametricTransformation"]=Geom_Conic.prototype.ParametricTransformation=function(T){var self=this.ptr;if(T&&typeof T==="object")T=T.ptr;return _emscripten_bind_Geom_Conic_ParametricTransformation_1(self,T)};Geom_Conic.prototype["Reversed"]=Geom_Conic.prototype.Reversed=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Geom_Conic_Reversed_0(self),Handle_Geom_Curve)};Geom_Conic.prototype["FirstParameter"]=Geom_Conic.prototype.FirstParameter=function(){var self=this.ptr;return _emscripten_bind_Geom_Conic_FirstParameter_0(self)};Geom_Conic.prototype["LastParameter"]=Geom_Conic.prototype.LastParameter=function(){var self=this.ptr;return _emscripten_bind_Geom_Conic_LastParameter_0(self)};Geom_Conic.prototype["IsClosed"]=Geom_Conic.prototype.IsClosed=function(){var self=this.ptr;return!!_emscripten_bind_Geom_Conic_IsClosed_0(self)};Geom_Conic.prototype["IsPeriodic"]=Geom_Conic.prototype.IsPeriodic=function(){var self=this.ptr;return!!_emscripten_bind_Geom_Conic_IsPeriodic_0(self)};Geom_Conic.prototype["Period"]=Geom_Conic.prototype.Period=function(){var self=this.ptr;return _emscripten_bind_Geom_Conic_Period_0(self)};Geom_Conic.prototype["IsCN"]=Geom_Conic.prototype.IsCN=function(N){var self=this.ptr;if(N&&typeof N==="object")N=N.ptr;return!!_emscripten_bind_Geom_Conic_IsCN_1(self,N)};Geom_Conic.prototype["D0"]=Geom_Conic.prototype.D0=function(U,P){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;_emscripten_bind_Geom_Conic_D0_2(self,U,P)};Geom_Conic.prototype["D1"]=Geom_Conic.prototype.D1=function(U,P,V1){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;_emscripten_bind_Geom_Conic_D1_3(self,U,P,V1)};Geom_Conic.prototype["D2"]=Geom_Conic.prototype.D2=function(U,P,V1,V2){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;if(V2&&typeof V2==="object")V2=V2.ptr;_emscripten_bind_Geom_Conic_D2_4(self,U,P,V1,V2)};Geom_Conic.prototype["D3"]=Geom_Conic.prototype.D3=function(U,P,V1,V2,V3){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;if(V2&&typeof V2==="object")V2=V2.ptr;if(V3&&typeof V3==="object")V3=V3.ptr;_emscripten_bind_Geom_Conic_D3_5(self,U,P,V1,V2,V3)};Geom_Conic.prototype["DN"]=Geom_Conic.prototype.DN=function(U,N){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(N&&typeof N==="object")N=N.ptr;_emscripten_bind_Geom_Conic_DN_2(self,U,N)};Geom_Conic.prototype["Value"]=Geom_Conic.prototype.Value=function(U){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;return wrapPointer(_emscripten_bind_Geom_Conic_Value_1(self,U),gp_Pnt)};Geom_Conic.prototype["__destroy__"]=Geom_Conic.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Geom_Conic___destroy___0(self)};function Adaptor3d_Curve(){throw"cannot construct a Adaptor3d_Curve, no constructor in IDL"}Adaptor3d_Curve.prototype=Object.create(WrapperObject.prototype);Adaptor3d_Curve.prototype.constructor=Adaptor3d_Curve;Adaptor3d_Curve.prototype.__class__=Adaptor3d_Curve;Adaptor3d_Curve.__cache__={};Module["Adaptor3d_Curve"]=Adaptor3d_Curve;Adaptor3d_Curve.prototype["FirstParameter"]=Adaptor3d_Curve.prototype.FirstParameter=function(){var self=this.ptr;return _emscripten_bind_Adaptor3d_Curve_FirstParameter_0(self)};Adaptor3d_Curve.prototype["LastParameter"]=Adaptor3d_Curve.prototype.LastParameter=function(){var self=this.ptr;return _emscripten_bind_Adaptor3d_Curve_LastParameter_0(self)};Adaptor3d_Curve.prototype["IsClosed"]=Adaptor3d_Curve.prototype.IsClosed=function(){var self=this.ptr;return!!_emscripten_bind_Adaptor3d_Curve_IsClosed_0(self)};Adaptor3d_Curve.prototype["IsPeriodic"]=Adaptor3d_Curve.prototype.IsPeriodic=function(){var self=this.ptr;return!!_emscripten_bind_Adaptor3d_Curve_IsPeriodic_0(self)};Adaptor3d_Curve.prototype["Period"]=Adaptor3d_Curve.prototype.Period=function(){var self=this.ptr;return _emscripten_bind_Adaptor3d_Curve_Period_0(self)};Adaptor3d_Curve.prototype["Value"]=Adaptor3d_Curve.prototype.Value=function(U){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;return wrapPointer(_emscripten_bind_Adaptor3d_Curve_Value_1(self,U),gp_Pnt)};Adaptor3d_Curve.prototype["D0"]=Adaptor3d_Curve.prototype.D0=function(U,P){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;_emscripten_bind_Adaptor3d_Curve_D0_2(self,U,P)};Adaptor3d_Curve.prototype["D1"]=Adaptor3d_Curve.prototype.D1=function(U,P,V1){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;_emscripten_bind_Adaptor3d_Curve_D1_3(self,U,P,V1)};Adaptor3d_Curve.prototype["D2"]=Adaptor3d_Curve.prototype.D2=function(U,P,V1,V2){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;if(V2&&typeof V2==="object")V2=V2.ptr;_emscripten_bind_Adaptor3d_Curve_D2_4(self,U,P,V1,V2)};Adaptor3d_Curve.prototype["D3"]=Adaptor3d_Curve.prototype.D3=function(U,P,V1,V2,V3){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;if(V2&&typeof V2==="object")V2=V2.ptr;if(V3&&typeof V3==="object")V3=V3.ptr;_emscripten_bind_Adaptor3d_Curve_D3_5(self,U,P,V1,V2,V3)};Adaptor3d_Curve.prototype["DN"]=Adaptor3d_Curve.prototype.DN=function(U,N){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(N&&typeof N==="object")N=N.ptr;_emscripten_bind_Adaptor3d_Curve_DN_2(self,U,N)};Adaptor3d_Curve.prototype["Resolution"]=Adaptor3d_Curve.prototype.Resolution=function(R3d){var self=this.ptr;if(R3d&&typeof R3d==="object")R3d=R3d.ptr;return _emscripten_bind_Adaptor3d_Curve_Resolution_1(self,R3d)};Adaptor3d_Curve.prototype["Line"]=Adaptor3d_Curve.prototype.Line=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Adaptor3d_Curve_Line_0(self),gp_Lin)};Adaptor3d_Curve.prototype["Circle"]=Adaptor3d_Curve.prototype.Circle=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Adaptor3d_Curve_Circle_0(self),gp_Circ)};Adaptor3d_Curve.prototype["Degree"]=Adaptor3d_Curve.prototype.Degree=function(){var self=this.ptr;return _emscripten_bind_Adaptor3d_Curve_Degree_0(self)};Adaptor3d_Curve.prototype["IsRational"]=Adaptor3d_Curve.prototype.IsRational=function(){var self=this.ptr;return!!_emscripten_bind_Adaptor3d_Curve_IsRational_0(self)};Adaptor3d_Curve.prototype["NbPoles"]=Adaptor3d_Curve.prototype.NbPoles=function(){var self=this.ptr;return _emscripten_bind_Adaptor3d_Curve_NbPoles_0(self)};Adaptor3d_Curve.prototype["NbKnots"]=Adaptor3d_Curve.prototype.NbKnots=function(){var self=this.ptr;return _emscripten_bind_Adaptor3d_Curve_NbKnots_0(self)};Adaptor3d_Curve.prototype["Bezier"]=Adaptor3d_Curve.prototype.Bezier=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Adaptor3d_Curve_Bezier_0(self),Handle_Geom_BezierCurve)};Adaptor3d_Curve.prototype["BSpline"]=Adaptor3d_Curve.prototype.BSpline=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Adaptor3d_Curve_BSpline_0(self),Handle_Geom_BSplineCurve)};Adaptor3d_Curve.prototype["__destroy__"]=Adaptor3d_Curve.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Adaptor3d_Curve___destroy___0(self)};function Geom_BoundedCurve(){throw"cannot construct a Geom_BoundedCurve, no constructor in IDL"}Geom_BoundedCurve.prototype=Object.create(Geom_Curve.prototype);Geom_BoundedCurve.prototype.constructor=Geom_BoundedCurve;Geom_BoundedCurve.prototype.__class__=Geom_BoundedCurve;Geom_BoundedCurve.__cache__={};Module["Geom_BoundedCurve"]=Geom_BoundedCurve;Geom_BoundedCurve.prototype["Reverse"]=Geom_BoundedCurve.prototype.Reverse=function(){var self=this.ptr;_emscripten_bind_Geom_BoundedCurve_Reverse_0(self)};Geom_BoundedCurve.prototype["ReversedParameter"]=Geom_BoundedCurve.prototype.ReversedParameter=function(U){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;return _emscripten_bind_Geom_BoundedCurve_ReversedParameter_1(self,U)};Geom_BoundedCurve.prototype["TransformedParameter"]=Geom_BoundedCurve.prototype.TransformedParameter=function(U,T){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(T&&typeof T==="object")T=T.ptr;return _emscripten_bind_Geom_BoundedCurve_TransformedParameter_2(self,U,T)};Geom_BoundedCurve.prototype["ParametricTransformation"]=Geom_BoundedCurve.prototype.ParametricTransformation=function(T){var self=this.ptr;if(T&&typeof T==="object")T=T.ptr;return _emscripten_bind_Geom_BoundedCurve_ParametricTransformation_1(self,T)};Geom_BoundedCurve.prototype["Reversed"]=Geom_BoundedCurve.prototype.Reversed=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Geom_BoundedCurve_Reversed_0(self),Handle_Geom_Curve)};Geom_BoundedCurve.prototype["FirstParameter"]=Geom_BoundedCurve.prototype.FirstParameter=function(){var self=this.ptr;return _emscripten_bind_Geom_BoundedCurve_FirstParameter_0(self)};Geom_BoundedCurve.prototype["LastParameter"]=Geom_BoundedCurve.prototype.LastParameter=function(){var self=this.ptr;return _emscripten_bind_Geom_BoundedCurve_LastParameter_0(self)};Geom_BoundedCurve.prototype["IsClosed"]=Geom_BoundedCurve.prototype.IsClosed=function(){var self=this.ptr;return!!_emscripten_bind_Geom_BoundedCurve_IsClosed_0(self)};Geom_BoundedCurve.prototype["IsPeriodic"]=Geom_BoundedCurve.prototype.IsPeriodic=function(){var self=this.ptr;return!!_emscripten_bind_Geom_BoundedCurve_IsPeriodic_0(self)};Geom_BoundedCurve.prototype["Period"]=Geom_BoundedCurve.prototype.Period=function(){var self=this.ptr;return _emscripten_bind_Geom_BoundedCurve_Period_0(self)};Geom_BoundedCurve.prototype["IsCN"]=Geom_BoundedCurve.prototype.IsCN=function(N){var self=this.ptr;if(N&&typeof N==="object")N=N.ptr;return!!_emscripten_bind_Geom_BoundedCurve_IsCN_1(self,N)};Geom_BoundedCurve.prototype["D0"]=Geom_BoundedCurve.prototype.D0=function(U,P){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;_emscripten_bind_Geom_BoundedCurve_D0_2(self,U,P)};Geom_BoundedCurve.prototype["D1"]=Geom_BoundedCurve.prototype.D1=function(U,P,V1){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;_emscripten_bind_Geom_BoundedCurve_D1_3(self,U,P,V1)};Geom_BoundedCurve.prototype["D2"]=Geom_BoundedCurve.prototype.D2=function(U,P,V1,V2){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;if(V2&&typeof V2==="object")V2=V2.ptr;_emscripten_bind_Geom_BoundedCurve_D2_4(self,U,P,V1,V2)};Geom_BoundedCurve.prototype["D3"]=Geom_BoundedCurve.prototype.D3=function(U,P,V1,V2,V3){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;if(V2&&typeof V2==="object")V2=V2.ptr;if(V3&&typeof V3==="object")V3=V3.ptr;_emscripten_bind_Geom_BoundedCurve_D3_5(self,U,P,V1,V2,V3)};Geom_BoundedCurve.prototype["DN"]=Geom_BoundedCurve.prototype.DN=function(U,N){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(N&&typeof N==="object")N=N.ptr;_emscripten_bind_Geom_BoundedCurve_DN_2(self,U,N)};Geom_BoundedCurve.prototype["Value"]=Geom_BoundedCurve.prototype.Value=function(U){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;return wrapPointer(_emscripten_bind_Geom_BoundedCurve_Value_1(self,U),gp_Pnt)};Geom_BoundedCurve.prototype["__destroy__"]=Geom_BoundedCurve.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Geom_BoundedCurve___destroy___0(self)};function BRepPrimAPI_MakeSweep(){throw"cannot construct a BRepPrimAPI_MakeSweep, no constructor in IDL"}BRepPrimAPI_MakeSweep.prototype=Object.create(BRepBuilderAPI_MakeShape.prototype);BRepPrimAPI_MakeSweep.prototype.constructor=BRepPrimAPI_MakeSweep;BRepPrimAPI_MakeSweep.prototype.__class__=BRepPrimAPI_MakeSweep;BRepPrimAPI_MakeSweep.__cache__={};Module["BRepPrimAPI_MakeSweep"]=BRepPrimAPI_MakeSweep;BRepPrimAPI_MakeSweep.prototype["FirstShape"]=BRepPrimAPI_MakeSweep.prototype.FirstShape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeSweep_FirstShape_0(self),TopoDS_Shape)};BRepPrimAPI_MakeSweep.prototype["LastShape"]=BRepPrimAPI_MakeSweep.prototype.LastShape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeSweep_LastShape_0(self),TopoDS_Shape)};BRepPrimAPI_MakeSweep.prototype["Shape"]=BRepPrimAPI_MakeSweep.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeSweep_Shape_0(self),TopoDS_Shape)};BRepPrimAPI_MakeSweep.prototype["IsDeleted"]=BRepPrimAPI_MakeSweep.prototype.IsDeleted=function(S){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;return!!_emscripten_bind_BRepPrimAPI_MakeSweep_IsDeleted_1(self,S)};BRepPrimAPI_MakeSweep.prototype["__destroy__"]=BRepPrimAPI_MakeSweep.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepPrimAPI_MakeSweep___destroy___0(self)};function gp(){throw"cannot construct a gp, no constructor in IDL"}gp.prototype=Object.create(WrapperObject.prototype);gp.prototype.constructor=gp;gp.prototype.__class__=gp;gp.__cache__={};Module["gp"]=gp;gp.prototype["OX"]=gp.prototype.OX=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_gp_OX_0(self),gp_Ax1)};gp.prototype["DZ"]=gp.prototype.DZ=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_gp_DZ_0(self),gp_Dir)};gp.prototype["__destroy__"]=gp.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_gp___destroy___0(self)};function Poly_Triangulation(nbNodes,nbTriangles,UVNodes){if(nbNodes&&typeof nbNodes==="object")nbNodes=nbNodes.ptr;if(nbTriangles&&typeof nbTriangles==="object")nbTriangles=nbTriangles.ptr;if(UVNodes&&typeof UVNodes==="object")UVNodes=UVNodes.ptr;if(nbTriangles===undefined){this.ptr=_emscripten_bind_Poly_Triangulation_Poly_Triangulation_1(nbNodes);getCache(Poly_Triangulation)[this.ptr]=this;return}if(UVNodes===undefined){this.ptr=_emscripten_bind_Poly_Triangulation_Poly_Triangulation_2(nbNodes,nbTriangles);getCache(Poly_Triangulation)[this.ptr]=this;return}this.ptr=_emscripten_bind_Poly_Triangulation_Poly_Triangulation_3(nbNodes,nbTriangles,UVNodes);getCache(Poly_Triangulation)[this.ptr]=this}Poly_Triangulation.prototype=Object.create(WrapperObject.prototype);Poly_Triangulation.prototype.constructor=Poly_Triangulation;Poly_Triangulation.prototype.__class__=Poly_Triangulation;Poly_Triangulation.__cache__={};Module["Poly_Triangulation"]=Poly_Triangulation;Poly_Triangulation.prototype["Copy"]=Poly_Triangulation.prototype.Copy=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Poly_Triangulation_Copy_0(self),Handle_Poly_Triangulation)};Poly_Triangulation.prototype["Deflection"]=Poly_Triangulation.prototype.Deflection=function(theDeflection){var self=this.ptr;if(theDeflection&&typeof theDeflection==="object")theDeflection=theDeflection.ptr;_emscripten_bind_Poly_Triangulation_Deflection_1(self,theDeflection)};Poly_Triangulation.prototype["RemoveUVNodes"]=Poly_Triangulation.prototype.RemoveUVNodes=function(){var self=this.ptr;_emscripten_bind_Poly_Triangulation_RemoveUVNodes_0(self)};Poly_Triangulation.prototype["NbNodes"]=Poly_Triangulation.prototype.NbNodes=function(){var self=this.ptr;return _emscripten_bind_Poly_Triangulation_NbNodes_0(self)};Poly_Triangulation.prototype["NbTriangles"]=Poly_Triangulation.prototype.NbTriangles=function(){var self=this.ptr;return _emscripten_bind_Poly_Triangulation_NbTriangles_0(self)};Poly_Triangulation.prototype["HasUVNodes"]=Poly_Triangulation.prototype.HasUVNodes=function(){var self=this.ptr;return!!_emscripten_bind_Poly_Triangulation_HasUVNodes_0(self)};Poly_Triangulation.prototype["Nodes"]=Poly_Triangulation.prototype.Nodes=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Poly_Triangulation_Nodes_0(self),TColgp_Array1OfPnt)};Poly_Triangulation.prototype["ChangeNodes"]=Poly_Triangulation.prototype.ChangeNodes=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Poly_Triangulation_ChangeNodes_0(self),TColgp_Array1OfPnt)};Poly_Triangulation.prototype["Triangles"]=Poly_Triangulation.prototype.Triangles=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Poly_Triangulation_Triangles_0(self),Poly_Array1OfTriangle)};Poly_Triangulation.prototype["ChangeTriangles"]=Poly_Triangulation.prototype.ChangeTriangles=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Poly_Triangulation_ChangeTriangles_0(self),Poly_Array1OfTriangle)};Poly_Triangulation.prototype["HasNormals"]=Poly_Triangulation.prototype.HasNormals=function(){var self=this.ptr;return!!_emscripten_bind_Poly_Triangulation_HasNormals_0(self)};Poly_Triangulation.prototype["Normal"]=Poly_Triangulation.prototype.Normal=function(theIndex){var self=this.ptr;if(theIndex&&typeof theIndex==="object")theIndex=theIndex.ptr;return wrapPointer(_emscripten_bind_Poly_Triangulation_Normal_1(self,theIndex),gp_Dir)};Poly_Triangulation.prototype["SetNormal"]=Poly_Triangulation.prototype.SetNormal=function(theIndex,theNormal){var self=this.ptr;if(theIndex&&typeof theIndex==="object")theIndex=theIndex.ptr;if(theNormal&&typeof theNormal==="object")theNormal=theNormal.ptr;_emscripten_bind_Poly_Triangulation_SetNormal_2(self,theIndex,theNormal)};Poly_Triangulation.prototype["__destroy__"]=Poly_Triangulation.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Poly_Triangulation___destroy___0(self)};function ShapeFix_Shape(shape){if(shape&&typeof shape==="object")shape=shape.ptr;if(shape===undefined){this.ptr=_emscripten_bind_ShapeFix_Shape_ShapeFix_Shape_0();getCache(ShapeFix_Shape)[this.ptr]=this;return}this.ptr=_emscripten_bind_ShapeFix_Shape_ShapeFix_Shape_1(shape);getCache(ShapeFix_Shape)[this.ptr]=this}ShapeFix_Shape.prototype=Object.create(WrapperObject.prototype);ShapeFix_Shape.prototype.constructor=ShapeFix_Shape;ShapeFix_Shape.prototype.__class__=ShapeFix_Shape;ShapeFix_Shape.__cache__={};Module["ShapeFix_Shape"]=ShapeFix_Shape;ShapeFix_Shape.prototype["Init"]=ShapeFix_Shape.prototype.Init=function(shape){var self=this.ptr;if(shape&&typeof shape==="object")shape=shape.ptr;_emscripten_bind_ShapeFix_Shape_Init_1(self,shape)};ShapeFix_Shape.prototype["Perform"]=ShapeFix_Shape.prototype.Perform=function(theProgress){var self=this.ptr;if(theProgress&&typeof theProgress==="object")theProgress=theProgress.ptr;if(theProgress===undefined){return!!_emscripten_bind_ShapeFix_Shape_Perform_0(self)}return!!_emscripten_bind_ShapeFix_Shape_Perform_1(self,theProgress)};ShapeFix_Shape.prototype["Shape"]=ShapeFix_Shape.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_ShapeFix_Shape_Shape_0(self),TopoDS_Shape)};ShapeFix_Shape.prototype["FixShellTool"]=ShapeFix_Shape.prototype.FixShellTool=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_ShapeFix_Shape_FixShellTool_0(self),Handle_ShapeFix_Shell)};ShapeFix_Shape.prototype["Status"]=ShapeFix_Shape.prototype.Status=function(status){var self=this.ptr;if(status&&typeof status==="object")status=status.ptr;return!!_emscripten_bind_ShapeFix_Shape_Status_1(self,status)};ShapeFix_Shape.prototype["SetPrecision"]=ShapeFix_Shape.prototype.SetPrecision=function(preci){var self=this.ptr;if(preci&&typeof preci==="object")preci=preci.ptr;_emscripten_bind_ShapeFix_Shape_SetPrecision_1(self,preci)};ShapeFix_Shape.prototype["SetMinTolerance"]=ShapeFix_Shape.prototype.SetMinTolerance=function(mintol){var self=this.ptr;if(mintol&&typeof mintol==="object")mintol=mintol.ptr;_emscripten_bind_ShapeFix_Shape_SetMinTolerance_1(self,mintol)};ShapeFix_Shape.prototype["SetMaxTolerance"]=ShapeFix_Shape.prototype.SetMaxTolerance=function(maxtol){var self=this.ptr;if(maxtol&&typeof maxtol==="object")maxtol=maxtol.ptr;_emscripten_bind_ShapeFix_Shape_SetMaxTolerance_1(self,maxtol)};ShapeFix_Shape.prototype["FixSolidMode"]=ShapeFix_Shape.prototype.FixSolidMode=function(){var self=this.ptr;return _emscripten_bind_ShapeFix_Shape_FixSolidMode_0(self)};ShapeFix_Shape.prototype["FixFreeShellMode"]=ShapeFix_Shape.prototype.FixFreeShellMode=function(){var self=this.ptr;return _emscripten_bind_ShapeFix_Shape_FixFreeShellMode_0(self)};ShapeFix_Shape.prototype["FixFreeFaceMode"]=ShapeFix_Shape.prototype.FixFreeFaceMode=function(){var self=this.ptr;return _emscripten_bind_ShapeFix_Shape_FixFreeFaceMode_0(self)};ShapeFix_Shape.prototype["FixFreeWireMode"]=ShapeFix_Shape.prototype.FixFreeWireMode=function(){var self=this.ptr;return _emscripten_bind_ShapeFix_Shape_FixFreeWireMode_0(self)};ShapeFix_Shape.prototype["FixSameParameterMode"]=ShapeFix_Shape.prototype.FixSameParameterMode=function(){var self=this.ptr;return _emscripten_bind_ShapeFix_Shape_FixSameParameterMode_0(self)};ShapeFix_Shape.prototype["FixVertexPositionMode"]=ShapeFix_Shape.prototype.FixVertexPositionMode=function(){var self=this.ptr;return _emscripten_bind_ShapeFix_Shape_FixVertexPositionMode_0(self)};ShapeFix_Shape.prototype["FixVertexTolMode"]=ShapeFix_Shape.prototype.FixVertexTolMode=function(){var self=this.ptr;return _emscripten_bind_ShapeFix_Shape_FixVertexTolMode_0(self)};ShapeFix_Shape.prototype["__destroy__"]=ShapeFix_Shape.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_ShapeFix_Shape___destroy___0(self)};function gp_Pnt(Xp,Yp,Zp){if(Xp&&typeof Xp==="object")Xp=Xp.ptr;if(Yp&&typeof Yp==="object")Yp=Yp.ptr;if(Zp&&typeof Zp==="object")Zp=Zp.ptr;if(Xp===undefined){this.ptr=_emscripten_bind_gp_Pnt_gp_Pnt_0();getCache(gp_Pnt)[this.ptr]=this;return}if(Yp===undefined){this.ptr=_emscripten_bind_gp_Pnt_gp_Pnt_1(Xp);getCache(gp_Pnt)[this.ptr]=this;return}if(Zp===undefined){this.ptr=_emscripten_bind_gp_Pnt_gp_Pnt_2(Xp,Yp);getCache(gp_Pnt)[this.ptr]=this;return}this.ptr=_emscripten_bind_gp_Pnt_gp_Pnt_3(Xp,Yp,Zp);getCache(gp_Pnt)[this.ptr]=this}gp_Pnt.prototype=Object.create(WrapperObject.prototype);gp_Pnt.prototype.constructor=gp_Pnt;gp_Pnt.prototype.__class__=gp_Pnt;gp_Pnt.__cache__={};Module["gp_Pnt"]=gp_Pnt;gp_Pnt.prototype["SetCoord"]=gp_Pnt.prototype.SetCoord=function(Xp,Yp,Zp){var self=this.ptr;if(Xp&&typeof Xp==="object")Xp=Xp.ptr;if(Yp&&typeof Yp==="object")Yp=Yp.ptr;if(Zp&&typeof Zp==="object")Zp=Zp.ptr;if(Zp===undefined){_emscripten_bind_gp_Pnt_SetCoord_2(self,Xp,Yp);return}_emscripten_bind_gp_Pnt_SetCoord_3(self,Xp,Yp,Zp)};gp_Pnt.prototype["SetX"]=gp_Pnt.prototype.SetX=function(X){var self=this.ptr;if(X&&typeof X==="object")X=X.ptr;_emscripten_bind_gp_Pnt_SetX_1(self,X)};gp_Pnt.prototype["SetY"]=gp_Pnt.prototype.SetY=function(Y){var self=this.ptr;if(Y&&typeof Y==="object")Y=Y.ptr;_emscripten_bind_gp_Pnt_SetY_1(self,Y)};gp_Pnt.prototype["SetZ"]=gp_Pnt.prototype.SetZ=function(Z){var self=this.ptr;if(Z&&typeof Z==="object")Z=Z.ptr;_emscripten_bind_gp_Pnt_SetZ_1(self,Z)};gp_Pnt.prototype["Coord"]=gp_Pnt.prototype.Coord=function(Index){var self=this.ptr;if(Index&&typeof Index==="object")Index=Index.ptr;return _emscripten_bind_gp_Pnt_Coord_1(self,Index)};gp_Pnt.prototype["X"]=gp_Pnt.prototype.X=function(){var self=this.ptr;return _emscripten_bind_gp_Pnt_X_0(self)};gp_Pnt.prototype["Y"]=gp_Pnt.prototype.Y=function(){var self=this.ptr;return _emscripten_bind_gp_Pnt_Y_0(self)};gp_Pnt.prototype["Z"]=gp_Pnt.prototype.Z=function(){var self=this.ptr;return _emscripten_bind_gp_Pnt_Z_0(self)};gp_Pnt.prototype["BaryCenter"]=gp_Pnt.prototype.BaryCenter=function(Alpha,P,Beta){var self=this.ptr;if(Alpha&&typeof Alpha==="object")Alpha=Alpha.ptr;if(P&&typeof P==="object")P=P.ptr;if(Beta&&typeof Beta==="object")Beta=Beta.ptr;_emscripten_bind_gp_Pnt_BaryCenter_3(self,Alpha,P,Beta)};gp_Pnt.prototype["IsEqual"]=gp_Pnt.prototype.IsEqual=function(Other,LinearTolerance){var self=this.ptr;if(Other&&typeof Other==="object")Other=Other.ptr;if(LinearTolerance&&typeof LinearTolerance==="object")LinearTolerance=LinearTolerance.ptr;return!!_emscripten_bind_gp_Pnt_IsEqual_2(self,Other,LinearTolerance)};gp_Pnt.prototype["Distance"]=gp_Pnt.prototype.Distance=function(Other){var self=this.ptr;if(Other&&typeof Other==="object")Other=Other.ptr;return _emscripten_bind_gp_Pnt_Distance_1(self,Other)};gp_Pnt.prototype["SquareDistance"]=gp_Pnt.prototype.SquareDistance=function(Other){var self=this.ptr;if(Other&&typeof Other==="object")Other=Other.ptr;return _emscripten_bind_gp_Pnt_SquareDistance_1(self,Other)};gp_Pnt.prototype["Mirror"]=gp_Pnt.prototype.Mirror=function(P){var self=this.ptr;if(P&&typeof P==="object")P=P.ptr;_emscripten_bind_gp_Pnt_Mirror_1(self,P)};gp_Pnt.prototype["Rotate"]=gp_Pnt.prototype.Rotate=function(A1,Ang){var self=this.ptr;if(A1&&typeof A1==="object")A1=A1.ptr;if(Ang&&typeof Ang==="object")Ang=Ang.ptr;_emscripten_bind_gp_Pnt_Rotate_2(self,A1,Ang)};gp_Pnt.prototype["Rotated"]=gp_Pnt.prototype.Rotated=function(A1,Ang){var self=this.ptr;if(A1&&typeof A1==="object")A1=A1.ptr;if(Ang&&typeof Ang==="object")Ang=Ang.ptr;return wrapPointer(_emscripten_bind_gp_Pnt_Rotated_2(self,A1,Ang),gp_Pnt)};gp_Pnt.prototype["Scale"]=gp_Pnt.prototype.Scale=function(P,S){var self=this.ptr;if(P&&typeof P==="object")P=P.ptr;if(S&&typeof S==="object")S=S.ptr;_emscripten_bind_gp_Pnt_Scale_2(self,P,S)};gp_Pnt.prototype["Scaled"]=gp_Pnt.prototype.Scaled=function(P,S){var self=this.ptr;if(P&&typeof P==="object")P=P.ptr;if(S&&typeof S==="object")S=S.ptr;return wrapPointer(_emscripten_bind_gp_Pnt_Scaled_2(self,P,S),gp_Pnt)};gp_Pnt.prototype["Transform"]=gp_Pnt.prototype.Transform=function(T){var self=this.ptr;if(T&&typeof T==="object")T=T.ptr;_emscripten_bind_gp_Pnt_Transform_1(self,T)};gp_Pnt.prototype["Transformed"]=gp_Pnt.prototype.Transformed=function(T){var self=this.ptr;if(T&&typeof T==="object")T=T.ptr;return wrapPointer(_emscripten_bind_gp_Pnt_Transformed_1(self,T),gp_Pnt)};gp_Pnt.prototype["Translated"]=gp_Pnt.prototype.Translated=function(P1,P2){var self=this.ptr;if(P1&&typeof P1==="object")P1=P1.ptr;if(P2&&typeof P2==="object")P2=P2.ptr;if(P2===undefined){return wrapPointer(_emscripten_bind_gp_Pnt_Translated_1(self,P1),gp_Pnt)}return wrapPointer(_emscripten_bind_gp_Pnt_Translated_2(self,P1,P2),gp_Pnt)};gp_Pnt.prototype["__destroy__"]=gp_Pnt.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_gp_Pnt___destroy___0(self)};function TopLoc_Location(T){if(T&&typeof T==="object")T=T.ptr;if(T===undefined){this.ptr=_emscripten_bind_TopLoc_Location_TopLoc_Location_0();getCache(TopLoc_Location)[this.ptr]=this;return}this.ptr=_emscripten_bind_TopLoc_Location_TopLoc_Location_1(T);getCache(TopLoc_Location)[this.ptr]=this}TopLoc_Location.prototype=Object.create(WrapperObject.prototype);TopLoc_Location.prototype.constructor=TopLoc_Location;TopLoc_Location.prototype.__class__=TopLoc_Location;TopLoc_Location.__cache__={};Module["TopLoc_Location"]=TopLoc_Location;TopLoc_Location.prototype["Identity"]=TopLoc_Location.prototype.Identity=function(){var self=this.ptr;_emscripten_bind_TopLoc_Location_Identity_0(self)};TopLoc_Location.prototype["FirstPower"]=TopLoc_Location.prototype.FirstPower=function(){var self=this.ptr;return _emscripten_bind_TopLoc_Location_FirstPower_0(self)};TopLoc_Location.prototype["NextLocation"]=TopLoc_Location.prototype.NextLocation=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopLoc_Location_NextLocation_0(self),TopLoc_Location)};TopLoc_Location.prototype["Transformation"]=TopLoc_Location.prototype.Transformation=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopLoc_Location_Transformation_0(self),gp_Trsf)};TopLoc_Location.prototype["__destroy__"]=TopLoc_Location.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_TopLoc_Location___destroy___0(self)};function Bnd_OBB(theCenter,theXDirection,theYDirection,theZDirection,theHXSize,theHYSize,theHZSize){if(theCenter&&typeof theCenter==="object")theCenter=theCenter.ptr;if(theXDirection&&typeof theXDirection==="object")theXDirection=theXDirection.ptr;if(theYDirection&&typeof theYDirection==="object")theYDirection=theYDirection.ptr;if(theZDirection&&typeof theZDirection==="object")theZDirection=theZDirection.ptr;if(theHXSize&&typeof theHXSize==="object")theHXSize=theHXSize.ptr;if(theHYSize&&typeof theHYSize==="object")theHYSize=theHYSize.ptr;if(theHZSize&&typeof theHZSize==="object")theHZSize=theHZSize.ptr;if(theCenter===undefined){this.ptr=_emscripten_bind_Bnd_OBB_Bnd_OBB_0();getCache(Bnd_OBB)[this.ptr]=this;return}if(theXDirection===undefined){this.ptr=_emscripten_bind_Bnd_OBB_Bnd_OBB_1(theCenter);getCache(Bnd_OBB)[this.ptr]=this;return}if(theYDirection===undefined){this.ptr=_emscripten_bind_Bnd_OBB_Bnd_OBB_2(theCenter,theXDirection);getCache(Bnd_OBB)[this.ptr]=this;return}if(theZDirection===undefined){this.ptr=_emscripten_bind_Bnd_OBB_Bnd_OBB_3(theCenter,theXDirection,theYDirection);getCache(Bnd_OBB)[this.ptr]=this;return}if(theHXSize===undefined){this.ptr=_emscripten_bind_Bnd_OBB_Bnd_OBB_4(theCenter,theXDirection,theYDirection,theZDirection);getCache(Bnd_OBB)[this.ptr]=this;return}if(theHYSize===undefined){this.ptr=_emscripten_bind_Bnd_OBB_Bnd_OBB_5(theCenter,theXDirection,theYDirection,theZDirection,theHXSize);getCache(Bnd_OBB)[this.ptr]=this;return}if(theHZSize===undefined){this.ptr=_emscripten_bind_Bnd_OBB_Bnd_OBB_6(theCenter,theXDirection,theYDirection,theZDirection,theHXSize,theHYSize);getCache(Bnd_OBB)[this.ptr]=this;return}this.ptr=_emscripten_bind_Bnd_OBB_Bnd_OBB_7(theCenter,theXDirection,theYDirection,theZDirection,theHXSize,theHYSize,theHZSize);getCache(Bnd_OBB)[this.ptr]=this}Bnd_OBB.prototype=Object.create(WrapperObject.prototype);Bnd_OBB.prototype.constructor=Bnd_OBB;Bnd_OBB.prototype.__class__=Bnd_OBB;Bnd_OBB.__cache__={};Module["Bnd_OBB"]=Bnd_OBB;Bnd_OBB.prototype["ReBuild"]=Bnd_OBB.prototype.ReBuild=function(theListOfPoints,theListOfTolerances,theIsOptimal){var self=this.ptr;if(theListOfPoints&&typeof theListOfPoints==="object")theListOfPoints=theListOfPoints.ptr;if(theListOfTolerances&&typeof theListOfTolerances==="object")theListOfTolerances=theListOfTolerances.ptr;if(theIsOptimal&&typeof theIsOptimal==="object")theIsOptimal=theIsOptimal.ptr;if(theIsOptimal===undefined){_emscripten_bind_Bnd_OBB_ReBuild_2(self,theListOfPoints,theListOfTolerances);return}_emscripten_bind_Bnd_OBB_ReBuild_3(self,theListOfPoints,theListOfTolerances,theIsOptimal)};Bnd_OBB.prototype["SetCenter"]=Bnd_OBB.prototype.SetCenter=function(theCenter){var self=this.ptr;if(theCenter&&typeof theCenter==="object")theCenter=theCenter.ptr;_emscripten_bind_Bnd_OBB_SetCenter_1(self,theCenter)};Bnd_OBB.prototype["SetXComponent"]=Bnd_OBB.prototype.SetXComponent=function(theXDirection,theHXSize){var self=this.ptr;if(theXDirection&&typeof theXDirection==="object")theXDirection=theXDirection.ptr;if(theHXSize&&typeof theHXSize==="object")theHXSize=theHXSize.ptr;_emscripten_bind_Bnd_OBB_SetXComponent_2(self,theXDirection,theHXSize)};Bnd_OBB.prototype["SetYComponent"]=Bnd_OBB.prototype.SetYComponent=function(theYDirection,theHYSize){var self=this.ptr;if(theYDirection&&typeof theYDirection==="object")theYDirection=theYDirection.ptr;if(theHYSize&&typeof theHYSize==="object")theHYSize=theHYSize.ptr;_emscripten_bind_Bnd_OBB_SetYComponent_2(self,theYDirection,theHYSize)};Bnd_OBB.prototype["SetZComponent"]=Bnd_OBB.prototype.SetZComponent=function(theZDirection,theHZSize){var self=this.ptr;if(theZDirection&&typeof theZDirection==="object")theZDirection=theZDirection.ptr;if(theHZSize&&typeof theHZSize==="object")theHZSize=theHZSize.ptr;_emscripten_bind_Bnd_OBB_SetZComponent_2(self,theZDirection,theHZSize)};Bnd_OBB.prototype["XHSize"]=Bnd_OBB.prototype.XHSize=function(){var self=this.ptr;return _emscripten_bind_Bnd_OBB_XHSize_0(self)};Bnd_OBB.prototype["YHSize"]=Bnd_OBB.prototype.YHSize=function(){var self=this.ptr;return _emscripten_bind_Bnd_OBB_YHSize_0(self)};Bnd_OBB.prototype["ZHSize"]=Bnd_OBB.prototype.ZHSize=function(){var self=this.ptr;return _emscripten_bind_Bnd_OBB_ZHSize_0(self)};Bnd_OBB.prototype["IsVoid"]=Bnd_OBB.prototype.IsVoid=function(){var self=this.ptr;return!!_emscripten_bind_Bnd_OBB_IsVoid_0(self)};Bnd_OBB.prototype["SetVoid"]=Bnd_OBB.prototype.SetVoid=function(){var self=this.ptr;_emscripten_bind_Bnd_OBB_SetVoid_0(self)};Bnd_OBB.prototype["SetAABox"]=Bnd_OBB.prototype.SetAABox=function(theFlag){var self=this.ptr;if(theFlag&&typeof theFlag==="object")theFlag=theFlag.ptr;_emscripten_bind_Bnd_OBB_SetAABox_1(self,theFlag)};Bnd_OBB.prototype["IsAABox"]=Bnd_OBB.prototype.IsAABox=function(){var self=this.ptr;return!!_emscripten_bind_Bnd_OBB_IsAABox_0(self)};Bnd_OBB.prototype["Enlarge"]=Bnd_OBB.prototype.Enlarge=function(theGapAdd){var self=this.ptr;if(theGapAdd&&typeof theGapAdd==="object")theGapAdd=theGapAdd.ptr;_emscripten_bind_Bnd_OBB_Enlarge_1(self,theGapAdd)};Bnd_OBB.prototype["GetVertex"]=Bnd_OBB.prototype.GetVertex=function(theP){var self=this.ptr;if(theP&&typeof theP==="object")theP=theP.ptr;return!!_emscripten_bind_Bnd_OBB_GetVertex_1(self,theP)};Bnd_OBB.prototype["SquareExtent"]=Bnd_OBB.prototype.SquareExtent=function(){var self=this.ptr;return _emscripten_bind_Bnd_OBB_SquareExtent_0(self)};Bnd_OBB.prototype["IsOut"]=Bnd_OBB.prototype.IsOut=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_Bnd_OBB_IsOut_1(self,theOther)};Bnd_OBB.prototype["IsCompletelyInside"]=Bnd_OBB.prototype.IsCompletelyInside=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_Bnd_OBB_IsCompletelyInside_1(self,theOther)};Bnd_OBB.prototype["Add"]=Bnd_OBB.prototype.Add=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;_emscripten_bind_Bnd_OBB_Add_1(self,theOther)};Bnd_OBB.prototype["__destroy__"]=Bnd_OBB.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Bnd_OBB___destroy___0(self)};function TopTools_ListOfShape(){this.ptr=_emscripten_bind_TopTools_ListOfShape_TopTools_ListOfShape_0();getCache(TopTools_ListOfShape)[this.ptr]=this}TopTools_ListOfShape.prototype=Object.create(WrapperObject.prototype);TopTools_ListOfShape.prototype.constructor=TopTools_ListOfShape;TopTools_ListOfShape.prototype.__class__=TopTools_ListOfShape;TopTools_ListOfShape.__cache__={};Module["TopTools_ListOfShape"]=TopTools_ListOfShape;TopTools_ListOfShape.prototype["Append"]=TopTools_ListOfShape.prototype.Append=function(theItem){var self=this.ptr;if(theItem&&typeof theItem==="object")theItem=theItem.ptr;return wrapPointer(_emscripten_bind_TopTools_ListOfShape_Append_1(self,theItem),TopoDS_Shape)};TopTools_ListOfShape.prototype["First"]=TopTools_ListOfShape.prototype.First=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopTools_ListOfShape_First_0(self),TopoDS_Shape)};TopTools_ListOfShape.prototype["Last"]=TopTools_ListOfShape.prototype.Last=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopTools_ListOfShape_Last_0(self),TopoDS_Shape)};TopTools_ListOfShape.prototype["__destroy__"]=TopTools_ListOfShape.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_TopTools_ListOfShape___destroy___0(self)};function BRepAlgoAPI_Common(S1,S2){if(S1&&typeof S1==="object")S1=S1.ptr;if(S2&&typeof S2==="object")S2=S2.ptr;this.ptr=_emscripten_bind_BRepAlgoAPI_Common_BRepAlgoAPI_Common_2(S1,S2);getCache(BRepAlgoAPI_Common)[this.ptr]=this}BRepAlgoAPI_Common.prototype=Object.create(BRepAlgoAPI_BooleanOperation.prototype);BRepAlgoAPI_Common.prototype.constructor=BRepAlgoAPI_Common;BRepAlgoAPI_Common.prototype.__class__=BRepAlgoAPI_Common;BRepAlgoAPI_Common.__cache__={};Module["BRepAlgoAPI_Common"]=BRepAlgoAPI_Common;BRepAlgoAPI_Common.prototype["Shape"]=BRepAlgoAPI_Common.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepAlgoAPI_Common_Shape_0(self),TopoDS_Shape)};BRepAlgoAPI_Common.prototype["__destroy__"]=BRepAlgoAPI_Common.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepAlgoAPI_Common___destroy___0(self)};function Geom_TrimmedCurve(C,U1,U2,Sense,theAdjustPeriodic){if(C&&typeof C==="object")C=C.ptr;if(U1&&typeof U1==="object")U1=U1.ptr;if(U2&&typeof U2==="object")U2=U2.ptr;if(Sense&&typeof Sense==="object")Sense=Sense.ptr;if(theAdjustPeriodic&&typeof theAdjustPeriodic==="object")theAdjustPeriodic=theAdjustPeriodic.ptr;if(Sense===undefined){this.ptr=_emscripten_bind_Geom_TrimmedCurve_Geom_TrimmedCurve_3(C,U1,U2);getCache(Geom_TrimmedCurve)[this.ptr]=this;return}if(theAdjustPeriodic===undefined){this.ptr=_emscripten_bind_Geom_TrimmedCurve_Geom_TrimmedCurve_4(C,U1,U2,Sense);getCache(Geom_TrimmedCurve)[this.ptr]=this;return}this.ptr=_emscripten_bind_Geom_TrimmedCurve_Geom_TrimmedCurve_5(C,U1,U2,Sense,theAdjustPeriodic);getCache(Geom_TrimmedCurve)[this.ptr]=this}Geom_TrimmedCurve.prototype=Object.create(Geom_BoundedCurve.prototype);Geom_TrimmedCurve.prototype.constructor=Geom_TrimmedCurve;Geom_TrimmedCurve.prototype.__class__=Geom_TrimmedCurve;Geom_TrimmedCurve.__cache__={};Module["Geom_TrimmedCurve"]=Geom_TrimmedCurve;Geom_TrimmedCurve.prototype["Reverse"]=Geom_TrimmedCurve.prototype.Reverse=function(){var self=this.ptr;_emscripten_bind_Geom_TrimmedCurve_Reverse_0(self)};Geom_TrimmedCurve.prototype["ReversedParameter"]=Geom_TrimmedCurve.prototype.ReversedParameter=function(U){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;return _emscripten_bind_Geom_TrimmedCurve_ReversedParameter_1(self,U)};Geom_TrimmedCurve.prototype["SetTrim"]=Geom_TrimmedCurve.prototype.SetTrim=function(U1,U2,Sense,theAdjust){var self=this.ptr;if(U1&&typeof U1==="object")U1=U1.ptr;if(U2&&typeof U2==="object")U2=U2.ptr;if(Sense&&typeof Sense==="object")Sense=Sense.ptr;if(theAdjust&&typeof theAdjust==="object")theAdjust=theAdjust.ptr;if(Sense===undefined){_emscripten_bind_Geom_TrimmedCurve_SetTrim_2(self,U1,U2);return}if(theAdjust===undefined){_emscripten_bind_Geom_TrimmedCurve_SetTrim_3(self,U1,U2,Sense);return}_emscripten_bind_Geom_TrimmedCurve_SetTrim_4(self,U1,U2,Sense,theAdjust)};Geom_TrimmedCurve.prototype["BasisCurve"]=Geom_TrimmedCurve.prototype.BasisCurve=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Geom_TrimmedCurve_BasisCurve_0(self),Handle_Geom_Curve)};Geom_TrimmedCurve.prototype["IsCN"]=Geom_TrimmedCurve.prototype.IsCN=function(N){var self=this.ptr;if(N&&typeof N==="object")N=N.ptr;return!!_emscripten_bind_Geom_TrimmedCurve_IsCN_1(self,N)};Geom_TrimmedCurve.prototype["FirstParameter"]=Geom_TrimmedCurve.prototype.FirstParameter=function(){var self=this.ptr;return _emscripten_bind_Geom_TrimmedCurve_FirstParameter_0(self)};Geom_TrimmedCurve.prototype["IsClosed"]=Geom_TrimmedCurve.prototype.IsClosed=function(){var self=this.ptr;return!!_emscripten_bind_Geom_TrimmedCurve_IsClosed_0(self)};Geom_TrimmedCurve.prototype["IsPeriodic"]=Geom_TrimmedCurve.prototype.IsPeriodic=function(){var self=this.ptr;return!!_emscripten_bind_Geom_TrimmedCurve_IsPeriodic_0(self)};Geom_TrimmedCurve.prototype["Period"]=Geom_TrimmedCurve.prototype.Period=function(){var self=this.ptr;return _emscripten_bind_Geom_TrimmedCurve_Period_0(self)};Geom_TrimmedCurve.prototype["LastParameter"]=Geom_TrimmedCurve.prototype.LastParameter=function(){var self=this.ptr;return _emscripten_bind_Geom_TrimmedCurve_LastParameter_0(self)};Geom_TrimmedCurve.prototype["StartPoint"]=Geom_TrimmedCurve.prototype.StartPoint=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Geom_TrimmedCurve_StartPoint_0(self),gp_Pnt)};Geom_TrimmedCurve.prototype["D0"]=Geom_TrimmedCurve.prototype.D0=function(U,P){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;_emscripten_bind_Geom_TrimmedCurve_D0_2(self,U,P)};Geom_TrimmedCurve.prototype["D1"]=Geom_TrimmedCurve.prototype.D1=function(U,P,V1){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;_emscripten_bind_Geom_TrimmedCurve_D1_3(self,U,P,V1)};Geom_TrimmedCurve.prototype["D2"]=Geom_TrimmedCurve.prototype.D2=function(U,P,V1,V2){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;if(V2&&typeof V2==="object")V2=V2.ptr;_emscripten_bind_Geom_TrimmedCurve_D2_4(self,U,P,V1,V2)};Geom_TrimmedCurve.prototype["D3"]=Geom_TrimmedCurve.prototype.D3=function(U,P,V1,V2,V3){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;if(V2&&typeof V2==="object")V2=V2.ptr;if(V3&&typeof V3==="object")V3=V3.ptr;_emscripten_bind_Geom_TrimmedCurve_D3_5(self,U,P,V1,V2,V3)};Geom_TrimmedCurve.prototype["DN"]=Geom_TrimmedCurve.prototype.DN=function(U,N){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(N&&typeof N==="object")N=N.ptr;_emscripten_bind_Geom_TrimmedCurve_DN_2(self,U,N)};Geom_TrimmedCurve.prototype["Transform"]=Geom_TrimmedCurve.prototype.Transform=function(T){var self=this.ptr;if(T&&typeof T==="object")T=T.ptr;_emscripten_bind_Geom_TrimmedCurve_Transform_1(self,T)};Geom_TrimmedCurve.prototype["TransformedParameter"]=Geom_TrimmedCurve.prototype.TransformedParameter=function(U,T){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(T&&typeof T==="object")T=T.ptr;return _emscripten_bind_Geom_TrimmedCurve_TransformedParameter_2(self,U,T)};Geom_TrimmedCurve.prototype["ParametricTransformation"]=Geom_TrimmedCurve.prototype.ParametricTransformation=function(T){var self=this.ptr;if(T&&typeof T==="object")T=T.ptr;return _emscripten_bind_Geom_TrimmedCurve_ParametricTransformation_1(self,T)};Geom_TrimmedCurve.prototype["Reversed"]=Geom_TrimmedCurve.prototype.Reversed=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Geom_TrimmedCurve_Reversed_0(self),Handle_Geom_Curve)};Geom_TrimmedCurve.prototype["Value"]=Geom_TrimmedCurve.prototype.Value=function(U){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;return wrapPointer(_emscripten_bind_Geom_TrimmedCurve_Value_1(self,U),gp_Pnt)};Geom_TrimmedCurve.prototype["__destroy__"]=Geom_TrimmedCurve.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Geom_TrimmedCurve___destroy___0(self)};function BRepGProp(){throw"cannot construct a BRepGProp, no constructor in IDL"}BRepGProp.prototype=Object.create(WrapperObject.prototype);BRepGProp.prototype.constructor=BRepGProp;BRepGProp.prototype.__class__=BRepGProp;BRepGProp.__cache__={};Module["BRepGProp"]=BRepGProp;BRepGProp.prototype["LinearProperties"]=BRepGProp.prototype.LinearProperties=function(S,LProps,SkipShared,UseTriangulation){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;if(LProps&&typeof LProps==="object")LProps=LProps.ptr;if(SkipShared&&typeof SkipShared==="object")SkipShared=SkipShared.ptr;if(UseTriangulation&&typeof UseTriangulation==="object")UseTriangulation=UseTriangulation.ptr;if(SkipShared===undefined){_emscripten_bind_BRepGProp_LinearProperties_2(self,S,LProps);return}if(UseTriangulation===undefined){_emscripten_bind_BRepGProp_LinearProperties_3(self,S,LProps,SkipShared);return}_emscripten_bind_BRepGProp_LinearProperties_4(self,S,LProps,SkipShared,UseTriangulation)};BRepGProp.prototype["SurfaceProperties"]=BRepGProp.prototype.SurfaceProperties=function(S,SProps,SkipShared,UseTriangulation){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;if(SProps&&typeof SProps==="object")SProps=SProps.ptr;if(SkipShared&&typeof SkipShared==="object")SkipShared=SkipShared.ptr;if(UseTriangulation&&typeof UseTriangulation==="object")UseTriangulation=UseTriangulation.ptr;if(SkipShared===undefined){_emscripten_bind_BRepGProp_SurfaceProperties_2(self,S,SProps);return}if(UseTriangulation===undefined){_emscripten_bind_BRepGProp_SurfaceProperties_3(self,S,SProps,SkipShared);return}_emscripten_bind_BRepGProp_SurfaceProperties_4(self,S,SProps,SkipShared,UseTriangulation)};BRepGProp.prototype["SurfaceProperties2"]=BRepGProp.prototype.SurfaceProperties2=function(S,SProps,Eps,SkipShared){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;if(SProps&&typeof SProps==="object")SProps=SProps.ptr;if(Eps&&typeof Eps==="object")Eps=Eps.ptr;if(SkipShared&&typeof SkipShared==="object")SkipShared=SkipShared.ptr;if(SkipShared===undefined){return _emscripten_bind_BRepGProp_SurfaceProperties2_3(self,S,SProps,Eps)}return _emscripten_bind_BRepGProp_SurfaceProperties2_4(self,S,SProps,Eps,SkipShared)};BRepGProp.prototype["VolumeProperties"]=BRepGProp.prototype.VolumeProperties=function(S,VProps,OnlyClosed,SkipShared,UseTriangulation){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;if(VProps&&typeof VProps==="object")VProps=VProps.ptr;if(OnlyClosed&&typeof OnlyClosed==="object")OnlyClosed=OnlyClosed.ptr;if(SkipShared&&typeof SkipShared==="object")SkipShared=SkipShared.ptr;if(UseTriangulation&&typeof UseTriangulation==="object")UseTriangulation=UseTriangulation.ptr;if(OnlyClosed===undefined){_emscripten_bind_BRepGProp_VolumeProperties_2(self,S,VProps);return}if(SkipShared===undefined){_emscripten_bind_BRepGProp_VolumeProperties_3(self,S,VProps,OnlyClosed);return}if(UseTriangulation===undefined){_emscripten_bind_BRepGProp_VolumeProperties_4(self,S,VProps,OnlyClosed,SkipShared);return}_emscripten_bind_BRepGProp_VolumeProperties_5(self,S,VProps,OnlyClosed,SkipShared,UseTriangulation)};BRepGProp.prototype["VolumeProperties2"]=BRepGProp.prototype.VolumeProperties2=function(S,VProps,Eps,OnlyClosed,SkipShared){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;if(VProps&&typeof VProps==="object")VProps=VProps.ptr;if(Eps&&typeof Eps==="object")Eps=Eps.ptr;if(OnlyClosed&&typeof OnlyClosed==="object")OnlyClosed=OnlyClosed.ptr;if(SkipShared&&typeof SkipShared==="object")SkipShared=SkipShared.ptr;if(OnlyClosed===undefined){return _emscripten_bind_BRepGProp_VolumeProperties2_3(self,S,VProps,Eps)}if(SkipShared===undefined){return _emscripten_bind_BRepGProp_VolumeProperties2_4(self,S,VProps,Eps,OnlyClosed)}return _emscripten_bind_BRepGProp_VolumeProperties2_5(self,S,VProps,Eps,OnlyClosed,SkipShared)};BRepGProp.prototype["VolumePropertiesGK"]=BRepGProp.prototype.VolumePropertiesGK=function(S,VProps,Eps,OnlyClosed,IsUseSpan,CGFlag,IFlag,SkipShared){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;if(VProps&&typeof VProps==="object")VProps=VProps.ptr;if(Eps&&typeof Eps==="object")Eps=Eps.ptr;if(OnlyClosed&&typeof OnlyClosed==="object")OnlyClosed=OnlyClosed.ptr;if(IsUseSpan&&typeof IsUseSpan==="object")IsUseSpan=IsUseSpan.ptr;if(CGFlag&&typeof CGFlag==="object")CGFlag=CGFlag.ptr;if(IFlag&&typeof IFlag==="object")IFlag=IFlag.ptr;if(SkipShared&&typeof SkipShared==="object")SkipShared=SkipShared.ptr;if(Eps===undefined){return _emscripten_bind_BRepGProp_VolumePropertiesGK_2(self,S,VProps)}if(OnlyClosed===undefined){return _emscripten_bind_BRepGProp_VolumePropertiesGK_3(self,S,VProps,Eps)}if(IsUseSpan===undefined){return _emscripten_bind_BRepGProp_VolumePropertiesGK_4(self,S,VProps,Eps,OnlyClosed)}if(CGFlag===undefined){return _emscripten_bind_BRepGProp_VolumePropertiesGK_5(self,S,VProps,Eps,OnlyClosed,IsUseSpan)}if(IFlag===undefined){return _emscripten_bind_BRepGProp_VolumePropertiesGK_6(self,S,VProps,Eps,OnlyClosed,IsUseSpan,CGFlag)}if(SkipShared===undefined){return _emscripten_bind_BRepGProp_VolumePropertiesGK_7(self,S,VProps,Eps,OnlyClosed,IsUseSpan,CGFlag,IFlag)}return _emscripten_bind_BRepGProp_VolumePropertiesGK_8(self,S,VProps,Eps,OnlyClosed,IsUseSpan,CGFlag,IFlag,SkipShared)};BRepGProp.prototype["VolumePropertiesGK2"]=BRepGProp.prototype.VolumePropertiesGK2=function(S,VProps,thePln,Eps,OnlyClosed,IsUseSpan,CGFlag,IFlag,SkipShared){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;if(VProps&&typeof VProps==="object")VProps=VProps.ptr;if(thePln&&typeof thePln==="object")thePln=thePln.ptr;if(Eps&&typeof Eps==="object")Eps=Eps.ptr;if(OnlyClosed&&typeof OnlyClosed==="object")OnlyClosed=OnlyClosed.ptr;if(IsUseSpan&&typeof IsUseSpan==="object")IsUseSpan=IsUseSpan.ptr;if(CGFlag&&typeof CGFlag==="object")CGFlag=CGFlag.ptr;if(IFlag&&typeof IFlag==="object")IFlag=IFlag.ptr;if(SkipShared&&typeof SkipShared==="object")SkipShared=SkipShared.ptr;if(Eps===undefined){return _emscripten_bind_BRepGProp_VolumePropertiesGK2_3(self,S,VProps,thePln)}if(OnlyClosed===undefined){return _emscripten_bind_BRepGProp_VolumePropertiesGK2_4(self,S,VProps,thePln,Eps)}if(IsUseSpan===undefined){return _emscripten_bind_BRepGProp_VolumePropertiesGK2_5(self,S,VProps,thePln,Eps,OnlyClosed)}if(CGFlag===undefined){return _emscripten_bind_BRepGProp_VolumePropertiesGK2_6(self,S,VProps,thePln,Eps,OnlyClosed,IsUseSpan)}if(IFlag===undefined){return _emscripten_bind_BRepGProp_VolumePropertiesGK2_7(self,S,VProps,thePln,Eps,OnlyClosed,IsUseSpan,CGFlag)}if(SkipShared===undefined){return _emscripten_bind_BRepGProp_VolumePropertiesGK2_8(self,S,VProps,thePln,Eps,OnlyClosed,IsUseSpan,CGFlag,IFlag)}return _emscripten_bind_BRepGProp_VolumePropertiesGK2_9(self,S,VProps,thePln,Eps,OnlyClosed,IsUseSpan,CGFlag,IFlag,SkipShared)};BRepGProp.prototype["__destroy__"]=BRepGProp.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepGProp___destroy___0(self)};function GCPnts_TangentialDeflection(C,FirstParameter,LastParameter,AngularDeflection,CurvatureDeflection,MinimumOfPoints,UTol,theMinLen){if(C&&typeof C==="object")C=C.ptr;if(FirstParameter&&typeof FirstParameter==="object")FirstParameter=FirstParameter.ptr;if(LastParameter&&typeof LastParameter==="object")LastParameter=LastParameter.ptr;if(AngularDeflection&&typeof AngularDeflection==="object")AngularDeflection=AngularDeflection.ptr;if(CurvatureDeflection&&typeof CurvatureDeflection==="object")CurvatureDeflection=CurvatureDeflection.ptr;if(MinimumOfPoints&&typeof MinimumOfPoints==="object")MinimumOfPoints=MinimumOfPoints.ptr;if(UTol&&typeof UTol==="object")UTol=UTol.ptr;if(theMinLen&&typeof theMinLen==="object")theMinLen=theMinLen.ptr;if(C===undefined){this.ptr=_emscripten_bind_GCPnts_TangentialDeflection_GCPnts_TangentialDeflection_0();getCache(GCPnts_TangentialDeflection)[this.ptr]=this;return}if(FirstParameter===undefined){this.ptr=_emscripten_bind_GCPnts_TangentialDeflection_GCPnts_TangentialDeflection_1(C);getCache(GCPnts_TangentialDeflection)[this.ptr]=this;return}if(LastParameter===undefined){this.ptr=_emscripten_bind_GCPnts_TangentialDeflection_GCPnts_TangentialDeflection_2(C,FirstParameter);getCache(GCPnts_TangentialDeflection)[this.ptr]=this;return}if(AngularDeflection===undefined){this.ptr=_emscripten_bind_GCPnts_TangentialDeflection_GCPnts_TangentialDeflection_3(C,FirstParameter,LastParameter);getCache(GCPnts_TangentialDeflection)[this.ptr]=this;return}if(CurvatureDeflection===undefined){this.ptr=_emscripten_bind_GCPnts_TangentialDeflection_GCPnts_TangentialDeflection_4(C,FirstParameter,LastParameter,AngularDeflection);getCache(GCPnts_TangentialDeflection)[this.ptr]=this;return}if(MinimumOfPoints===undefined){this.ptr=_emscripten_bind_GCPnts_TangentialDeflection_GCPnts_TangentialDeflection_5(C,FirstParameter,LastParameter,AngularDeflection,CurvatureDeflection);getCache(GCPnts_TangentialDeflection)[this.ptr]=this;return}if(UTol===undefined){this.ptr=_emscripten_bind_GCPnts_TangentialDeflection_GCPnts_TangentialDeflection_6(C,FirstParameter,LastParameter,AngularDeflection,CurvatureDeflection,MinimumOfPoints);getCache(GCPnts_TangentialDeflection)[this.ptr]=this;return}if(theMinLen===undefined){this.ptr=_emscripten_bind_GCPnts_TangentialDeflection_GCPnts_TangentialDeflection_7(C,FirstParameter,LastParameter,AngularDeflection,CurvatureDeflection,MinimumOfPoints,UTol);getCache(GCPnts_TangentialDeflection)[this.ptr]=this;return}this.ptr=_emscripten_bind_GCPnts_TangentialDeflection_GCPnts_TangentialDeflection_8(C,FirstParameter,LastParameter,AngularDeflection,CurvatureDeflection,MinimumOfPoints,UTol,theMinLen);getCache(GCPnts_TangentialDeflection)[this.ptr]=this}GCPnts_TangentialDeflection.prototype=Object.create(WrapperObject.prototype);GCPnts_TangentialDeflection.prototype.constructor=GCPnts_TangentialDeflection;GCPnts_TangentialDeflection.prototype.__class__=GCPnts_TangentialDeflection;GCPnts_TangentialDeflection.__cache__={};Module["GCPnts_TangentialDeflection"]=GCPnts_TangentialDeflection;GCPnts_TangentialDeflection.prototype["Initialize"]=GCPnts_TangentialDeflection.prototype.Initialize=function(C,FirstParameter,LastParameter,AngularDeflection,CurvatureDeflection,MinimumOfPoints,UTol,theMinLen){var self=this.ptr;if(C&&typeof C==="object")C=C.ptr;if(FirstParameter&&typeof FirstParameter==="object")FirstParameter=FirstParameter.ptr;if(LastParameter&&typeof LastParameter==="object")LastParameter=LastParameter.ptr;if(AngularDeflection&&typeof AngularDeflection==="object")AngularDeflection=AngularDeflection.ptr;if(CurvatureDeflection&&typeof CurvatureDeflection==="object")CurvatureDeflection=CurvatureDeflection.ptr;if(MinimumOfPoints&&typeof MinimumOfPoints==="object")MinimumOfPoints=MinimumOfPoints.ptr;if(UTol&&typeof UTol==="object")UTol=UTol.ptr;if(theMinLen&&typeof theMinLen==="object")theMinLen=theMinLen.ptr;if(AngularDeflection===undefined){_emscripten_bind_GCPnts_TangentialDeflection_Initialize_3(self,C,FirstParameter,LastParameter);return}if(CurvatureDeflection===undefined){_emscripten_bind_GCPnts_TangentialDeflection_Initialize_4(self,C,FirstParameter,LastParameter,AngularDeflection);return}if(MinimumOfPoints===undefined){_emscripten_bind_GCPnts_TangentialDeflection_Initialize_5(self,C,FirstParameter,LastParameter,AngularDeflection,CurvatureDeflection);return}if(UTol===undefined){_emscripten_bind_GCPnts_TangentialDeflection_Initialize_6(self,C,FirstParameter,LastParameter,AngularDeflection,CurvatureDeflection,MinimumOfPoints);return}if(theMinLen===undefined){_emscripten_bind_GCPnts_TangentialDeflection_Initialize_7(self,C,FirstParameter,LastParameter,AngularDeflection,CurvatureDeflection,MinimumOfPoints,UTol);return}_emscripten_bind_GCPnts_TangentialDeflection_Initialize_8(self,C,FirstParameter,LastParameter,AngularDeflection,CurvatureDeflection,MinimumOfPoints,UTol,theMinLen)};GCPnts_TangentialDeflection.prototype["AddPoint"]=GCPnts_TangentialDeflection.prototype.AddPoint=function(thePnt,theParam,theIsReplace){var self=this.ptr;if(thePnt&&typeof thePnt==="object")thePnt=thePnt.ptr;if(theParam&&typeof theParam==="object")theParam=theParam.ptr;if(theIsReplace&&typeof theIsReplace==="object")theIsReplace=theIsReplace.ptr;if(theIsReplace===undefined){return _emscripten_bind_GCPnts_TangentialDeflection_AddPoint_2(self,thePnt,theParam)}return _emscripten_bind_GCPnts_TangentialDeflection_AddPoint_3(self,thePnt,theParam,theIsReplace)};GCPnts_TangentialDeflection.prototype["NbPoints"]=GCPnts_TangentialDeflection.prototype.NbPoints=function(){var self=this.ptr;return _emscripten_bind_GCPnts_TangentialDeflection_NbPoints_0(self)};GCPnts_TangentialDeflection.prototype["Parameter"]=GCPnts_TangentialDeflection.prototype.Parameter=function(I){var self=this.ptr;if(I&&typeof I==="object")I=I.ptr;return _emscripten_bind_GCPnts_TangentialDeflection_Parameter_1(self,I)};GCPnts_TangentialDeflection.prototype["Value"]=GCPnts_TangentialDeflection.prototype.Value=function(I){var self=this.ptr;if(I&&typeof I==="object")I=I.ptr;return wrapPointer(_emscripten_bind_GCPnts_TangentialDeflection_Value_1(self,I),gp_Pnt)};GCPnts_TangentialDeflection.prototype["ArcAngularStep"]=GCPnts_TangentialDeflection.prototype.ArcAngularStep=function(theRadius,theLinearDeflection,theAngularDeflection,theMinLength){var self=this.ptr;if(theRadius&&typeof theRadius==="object")theRadius=theRadius.ptr;if(theLinearDeflection&&typeof theLinearDeflection==="object")theLinearDeflection=theLinearDeflection.ptr;if(theAngularDeflection&&typeof theAngularDeflection==="object")theAngularDeflection=theAngularDeflection.ptr;if(theMinLength&&typeof theMinLength==="object")theMinLength=theMinLength.ptr;return _emscripten_bind_GCPnts_TangentialDeflection_ArcAngularStep_4(self,theRadius,theLinearDeflection,theAngularDeflection,theMinLength)};GCPnts_TangentialDeflection.prototype["__destroy__"]=GCPnts_TangentialDeflection.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_GCPnts_TangentialDeflection___destroy___0(self)};function BRep_Tool(){throw"cannot construct a BRep_Tool, no constructor in IDL"}BRep_Tool.prototype=Object.create(WrapperObject.prototype);BRep_Tool.prototype.constructor=BRep_Tool;BRep_Tool.prototype.__class__=BRep_Tool;BRep_Tool.__cache__={};Module["BRep_Tool"]=BRep_Tool;BRep_Tool.prototype["IsClosed"]=BRep_Tool.prototype.IsClosed=function(E,T,L){var self=this.ptr;if(E&&typeof E==="object")E=E.ptr;if(T&&typeof T==="object")T=T.ptr;if(L&&typeof L==="object")L=L.ptr;if(T===undefined){return!!_emscripten_bind_BRep_Tool_IsClosed_1(self,E)}if(L===undefined){return!!_emscripten_bind_BRep_Tool_IsClosed_2(self,E,T)}return!!_emscripten_bind_BRep_Tool_IsClosed_3(self,E,T,L)};BRep_Tool.prototype["Surface"]=BRep_Tool.prototype.Surface=function(F){var self=this.ptr;if(F&&typeof F==="object")F=F.ptr;return wrapPointer(_emscripten_bind_BRep_Tool_Surface_1(self,F),Handle_Geom_Surface)};BRep_Tool.prototype["Triangulation"]=BRep_Tool.prototype.Triangulation=function(F,L){var self=this.ptr;if(F&&typeof F==="object")F=F.ptr;if(L&&typeof L==="object")L=L.ptr;return wrapPointer(_emscripten_bind_BRep_Tool_Triangulation_2(self,F,L),Handle_Poly_Triangulation)};BRep_Tool.prototype["Tolerance"]=BRep_Tool.prototype.Tolerance=function(F){var self=this.ptr;if(F&&typeof F==="object")F=F.ptr;return _emscripten_bind_BRep_Tool_Tolerance_1(self,F)};BRep_Tool.prototype["NaturalRestriction"]=BRep_Tool.prototype.NaturalRestriction=function(F){var self=this.ptr;if(F&&typeof F==="object")F=F.ptr;return!!_emscripten_bind_BRep_Tool_NaturalRestriction_1(self,F)};BRep_Tool.prototype["IsGeometric"]=BRep_Tool.prototype.IsGeometric=function(E){var self=this.ptr;if(E&&typeof E==="object")E=E.ptr;return!!_emscripten_bind_BRep_Tool_IsGeometric_1(self,E)};BRep_Tool.prototype["Curve"]=BRep_Tool.prototype.Curve=function(E,L,First,Last){var self=this.ptr;if(E&&typeof E==="object")E=E.ptr;if(L&&typeof L==="object")L=L.ptr;if(First&&typeof First==="object")First=First.ptr;if(Last&&typeof Last==="object")Last=Last.ptr;return wrapPointer(_emscripten_bind_BRep_Tool_Curve_4(self,E,L,First,Last),Handle_Geom_Curve)};BRep_Tool.prototype["Polygon3D"]=BRep_Tool.prototype.Polygon3D=function(E,L){var self=this.ptr;if(E&&typeof E==="object")E=E.ptr;if(L&&typeof L==="object")L=L.ptr;return wrapPointer(_emscripten_bind_BRep_Tool_Polygon3D_2(self,E,L),Handle_Poly_Polygon3D)};BRep_Tool.prototype["PolygonOnTriangulation"]=BRep_Tool.prototype.PolygonOnTriangulation=function(E,T,L){var self=this.ptr;if(E&&typeof E==="object")E=E.ptr;if(T&&typeof T==="object")T=T.ptr;if(L&&typeof L==="object")L=L.ptr;return wrapPointer(_emscripten_bind_BRep_Tool_PolygonOnTriangulation_3(self,E,T,L),Handle_Poly_PolygonOnTriangulation)};BRep_Tool.prototype["SameParameter"]=BRep_Tool.prototype.SameParameter=function(E){var self=this.ptr;if(E&&typeof E==="object")E=E.ptr;return!!_emscripten_bind_BRep_Tool_SameParameter_1(self,E)};BRep_Tool.prototype["SameRange"]=BRep_Tool.prototype.SameRange=function(E){var self=this.ptr;if(E&&typeof E==="object")E=E.ptr;return!!_emscripten_bind_BRep_Tool_SameRange_1(self,E)};BRep_Tool.prototype["Degenerated"]=BRep_Tool.prototype.Degenerated=function(E){var self=this.ptr;if(E&&typeof E==="object")E=E.ptr;return!!_emscripten_bind_BRep_Tool_Degenerated_1(self,E)};BRep_Tool.prototype["Range"]=BRep_Tool.prototype.Range=function(E,F,First,Last){var self=this.ptr;if(E&&typeof E==="object")E=E.ptr;if(F&&typeof F==="object")F=F.ptr;if(First&&typeof First==="object")First=First.ptr;if(Last&&typeof Last==="object")Last=Last.ptr;if(Last===undefined){_emscripten_bind_BRep_Tool_Range_3(self,E,F,First);return}_emscripten_bind_BRep_Tool_Range_4(self,E,F,First,Last)};BRep_Tool.prototype["HasContinuity"]=BRep_Tool.prototype.HasContinuity=function(E,F1,F2){var self=this.ptr;if(E&&typeof E==="object")E=E.ptr;if(F1&&typeof F1==="object")F1=F1.ptr;if(F2&&typeof F2==="object")F2=F2.ptr;if(F1===undefined){return!!_emscripten_bind_BRep_Tool_HasContinuity_1(self,E)}if(F2===undefined){return!!_emscripten_bind_BRep_Tool_HasContinuity_2(self,E,F1)}return!!_emscripten_bind_BRep_Tool_HasContinuity_3(self,E,F1,F2)};BRep_Tool.prototype["Parameter"]=BRep_Tool.prototype.Parameter=function(V,E,F){var self=this.ptr;if(V&&typeof V==="object")V=V.ptr;if(E&&typeof E==="object")E=E.ptr;if(F&&typeof F==="object")F=F.ptr;if(F===undefined){return _emscripten_bind_BRep_Tool_Parameter_2(self,V,E)}return _emscripten_bind_BRep_Tool_Parameter_3(self,V,E,F)};BRep_Tool.prototype["Pnt"]=BRep_Tool.prototype.Pnt=function(V){var self=this.ptr;if(V&&typeof V==="object")V=V.ptr;return wrapPointer(_emscripten_bind_BRep_Tool_Pnt_1(self,V),gp_Pnt)};BRep_Tool.prototype["Parameters"]=BRep_Tool.prototype.Parameters=function(V,F){var self=this.ptr;if(V&&typeof V==="object")V=V.ptr;if(F&&typeof F==="object")F=F.ptr;return wrapPointer(_emscripten_bind_BRep_Tool_Parameters_2(self,V,F),gp_Pnt2d)};BRep_Tool.prototype["MaxTolerance"]=BRep_Tool.prototype.MaxTolerance=function(theShape,theSubShape){var self=this.ptr;if(theShape&&typeof theShape==="object")theShape=theShape.ptr;if(theSubShape&&typeof theSubShape==="object")theSubShape=theSubShape.ptr;return _emscripten_bind_BRep_Tool_MaxTolerance_2(self,theShape,theSubShape)};BRep_Tool.prototype["__destroy__"]=BRep_Tool.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRep_Tool___destroy___0(self)};function BRepMesh_IncrementalMesh(theShape,theLinDeflection,isRelative,theAngDeflection){if(theShape&&typeof theShape==="object")theShape=theShape.ptr;if(theLinDeflection&&typeof theLinDeflection==="object")theLinDeflection=theLinDeflection.ptr;if(isRelative&&typeof isRelative==="object")isRelative=isRelative.ptr;if(theAngDeflection&&typeof theAngDeflection==="object")theAngDeflection=theAngDeflection.ptr;if(theShape===undefined){this.ptr=_emscripten_bind_BRepMesh_IncrementalMesh_BRepMesh_IncrementalMesh_0();getCache(BRepMesh_IncrementalMesh)[this.ptr]=this;return}if(theLinDeflection===undefined){this.ptr=_emscripten_bind_BRepMesh_IncrementalMesh_BRepMesh_IncrementalMesh_1(theShape);getCache(BRepMesh_IncrementalMesh)[this.ptr]=this;return}if(isRelative===undefined){this.ptr=_emscripten_bind_BRepMesh_IncrementalMesh_BRepMesh_IncrementalMesh_2(theShape,theLinDeflection);getCache(BRepMesh_IncrementalMesh)[this.ptr]=this;return}if(theAngDeflection===undefined){this.ptr=_emscripten_bind_BRepMesh_IncrementalMesh_BRepMesh_IncrementalMesh_3(theShape,theLinDeflection,isRelative);getCache(BRepMesh_IncrementalMesh)[this.ptr]=this;return}this.ptr=_emscripten_bind_BRepMesh_IncrementalMesh_BRepMesh_IncrementalMesh_4(theShape,theLinDeflection,isRelative,theAngDeflection);getCache(BRepMesh_IncrementalMesh)[this.ptr]=this}BRepMesh_IncrementalMesh.prototype=Object.create(WrapperObject.prototype);BRepMesh_IncrementalMesh.prototype.constructor=BRepMesh_IncrementalMesh;BRepMesh_IncrementalMesh.prototype.__class__=BRepMesh_IncrementalMesh;BRepMesh_IncrementalMesh.__cache__={};Module["BRepMesh_IncrementalMesh"]=BRepMesh_IncrementalMesh;BRepMesh_IncrementalMesh.prototype["__destroy__"]=BRepMesh_IncrementalMesh.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepMesh_IncrementalMesh___destroy___0(self)};function Geom_Hyperbola(A2,MajorRadius,MinorRadius){if(A2&&typeof A2==="object")A2=A2.ptr;if(MajorRadius&&typeof MajorRadius==="object")MajorRadius=MajorRadius.ptr;if(MinorRadius&&typeof MinorRadius==="object")MinorRadius=MinorRadius.ptr;if(MajorRadius===undefined){this.ptr=_emscripten_bind_Geom_Hyperbola_Geom_Hyperbola_1(A2);getCache(Geom_Hyperbola)[this.ptr]=this;return}if(MinorRadius===undefined){this.ptr=_emscripten_bind_Geom_Hyperbola_Geom_Hyperbola_2(A2,MajorRadius);getCache(Geom_Hyperbola)[this.ptr]=this;return}this.ptr=_emscripten_bind_Geom_Hyperbola_Geom_Hyperbola_3(A2,MajorRadius,MinorRadius);getCache(Geom_Hyperbola)[this.ptr]=this}Geom_Hyperbola.prototype=Object.create(Geom_Conic.prototype);Geom_Hyperbola.prototype.constructor=Geom_Hyperbola;Geom_Hyperbola.prototype.__class__=Geom_Hyperbola;Geom_Hyperbola.__cache__={};Module["Geom_Hyperbola"]=Geom_Hyperbola;Geom_Hyperbola.prototype["MajorRadius"]=Geom_Hyperbola.prototype.MajorRadius=function(){var self=this.ptr;return _emscripten_bind_Geom_Hyperbola_MajorRadius_0(self)};Geom_Hyperbola.prototype["MinorRadius"]=Geom_Hyperbola.prototype.MinorRadius=function(){var self=this.ptr;return _emscripten_bind_Geom_Hyperbola_MinorRadius_0(self)};Geom_Hyperbola.prototype["Reverse"]=Geom_Hyperbola.prototype.Reverse=function(){var self=this.ptr;_emscripten_bind_Geom_Hyperbola_Reverse_0(self)};Geom_Hyperbola.prototype["ReversedParameter"]=Geom_Hyperbola.prototype.ReversedParameter=function(U){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;return _emscripten_bind_Geom_Hyperbola_ReversedParameter_1(self,U)};Geom_Hyperbola.prototype["TransformedParameter"]=Geom_Hyperbola.prototype.TransformedParameter=function(U,T){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(T&&typeof T==="object")T=T.ptr;return _emscripten_bind_Geom_Hyperbola_TransformedParameter_2(self,U,T)};Geom_Hyperbola.prototype["ParametricTransformation"]=Geom_Hyperbola.prototype.ParametricTransformation=function(T){var self=this.ptr;if(T&&typeof T==="object")T=T.ptr;return _emscripten_bind_Geom_Hyperbola_ParametricTransformation_1(self,T)};Geom_Hyperbola.prototype["Reversed"]=Geom_Hyperbola.prototype.Reversed=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Geom_Hyperbola_Reversed_0(self),Handle_Geom_Curve)};Geom_Hyperbola.prototype["FirstParameter"]=Geom_Hyperbola.prototype.FirstParameter=function(){var self=this.ptr;return _emscripten_bind_Geom_Hyperbola_FirstParameter_0(self)};Geom_Hyperbola.prototype["LastParameter"]=Geom_Hyperbola.prototype.LastParameter=function(){var self=this.ptr;return _emscripten_bind_Geom_Hyperbola_LastParameter_0(self)};Geom_Hyperbola.prototype["IsClosed"]=Geom_Hyperbola.prototype.IsClosed=function(){var self=this.ptr;return!!_emscripten_bind_Geom_Hyperbola_IsClosed_0(self)};Geom_Hyperbola.prototype["IsPeriodic"]=Geom_Hyperbola.prototype.IsPeriodic=function(){var self=this.ptr;return!!_emscripten_bind_Geom_Hyperbola_IsPeriodic_0(self)};Geom_Hyperbola.prototype["Period"]=Geom_Hyperbola.prototype.Period=function(){var self=this.ptr;return _emscripten_bind_Geom_Hyperbola_Period_0(self)};Geom_Hyperbola.prototype["IsCN"]=Geom_Hyperbola.prototype.IsCN=function(N){var self=this.ptr;if(N&&typeof N==="object")N=N.ptr;return!!_emscripten_bind_Geom_Hyperbola_IsCN_1(self,N)};Geom_Hyperbola.prototype["D0"]=Geom_Hyperbola.prototype.D0=function(U,P){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;_emscripten_bind_Geom_Hyperbola_D0_2(self,U,P)};Geom_Hyperbola.prototype["D1"]=Geom_Hyperbola.prototype.D1=function(U,P,V1){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;_emscripten_bind_Geom_Hyperbola_D1_3(self,U,P,V1)};Geom_Hyperbola.prototype["D2"]=Geom_Hyperbola.prototype.D2=function(U,P,V1,V2){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;if(V2&&typeof V2==="object")V2=V2.ptr;_emscripten_bind_Geom_Hyperbola_D2_4(self,U,P,V1,V2)};Geom_Hyperbola.prototype["D3"]=Geom_Hyperbola.prototype.D3=function(U,P,V1,V2,V3){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;if(V2&&typeof V2==="object")V2=V2.ptr;if(V3&&typeof V3==="object")V3=V3.ptr;_emscripten_bind_Geom_Hyperbola_D3_5(self,U,P,V1,V2,V3)};Geom_Hyperbola.prototype["DN"]=Geom_Hyperbola.prototype.DN=function(U,N){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(N&&typeof N==="object")N=N.ptr;_emscripten_bind_Geom_Hyperbola_DN_2(self,U,N)};Geom_Hyperbola.prototype["Value"]=Geom_Hyperbola.prototype.Value=function(U){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;return wrapPointer(_emscripten_bind_Geom_Hyperbola_Value_1(self,U),gp_Pnt)};Geom_Hyperbola.prototype["__destroy__"]=Geom_Hyperbola.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Geom_Hyperbola___destroy___0(self)};function BRepAlgoAPI_Cut(S1,S2){if(S1&&typeof S1==="object")S1=S1.ptr;if(S2&&typeof S2==="object")S2=S2.ptr;this.ptr=_emscripten_bind_BRepAlgoAPI_Cut_BRepAlgoAPI_Cut_2(S1,S2);getCache(BRepAlgoAPI_Cut)[this.ptr]=this}BRepAlgoAPI_Cut.prototype=Object.create(BRepAlgoAPI_BooleanOperation.prototype);BRepAlgoAPI_Cut.prototype.constructor=BRepAlgoAPI_Cut;BRepAlgoAPI_Cut.prototype.__class__=BRepAlgoAPI_Cut;BRepAlgoAPI_Cut.__cache__={};Module["BRepAlgoAPI_Cut"]=BRepAlgoAPI_Cut;BRepAlgoAPI_Cut.prototype["Shape"]=BRepAlgoAPI_Cut.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepAlgoAPI_Cut_Shape_0(self),TopoDS_Shape)};BRepAlgoAPI_Cut.prototype["__destroy__"]=BRepAlgoAPI_Cut.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepAlgoAPI_Cut___destroy___0(self)};function Geom_BSplineCurve(Poles,Weights,Knots,Multiplicities,Degree,Periodic,CheckRational){if(Poles&&typeof Poles==="object")Poles=Poles.ptr;if(Weights&&typeof Weights==="object")Weights=Weights.ptr;if(Knots&&typeof Knots==="object")Knots=Knots.ptr;if(Multiplicities&&typeof Multiplicities==="object")Multiplicities=Multiplicities.ptr;if(Degree&&typeof Degree==="object")Degree=Degree.ptr;if(Periodic&&typeof Periodic==="object")Periodic=Periodic.ptr;if(CheckRational&&typeof CheckRational==="object")CheckRational=CheckRational.ptr;if(Periodic===undefined){this.ptr=_emscripten_bind_Geom_BSplineCurve_Geom_BSplineCurve_5(Poles,Weights,Knots,Multiplicities,Degree);getCache(Geom_BSplineCurve)[this.ptr]=this;return}if(CheckRational===undefined){this.ptr=_emscripten_bind_Geom_BSplineCurve_Geom_BSplineCurve_6(Poles,Weights,Knots,Multiplicities,Degree,Periodic);getCache(Geom_BSplineCurve)[this.ptr]=this;return}this.ptr=_emscripten_bind_Geom_BSplineCurve_Geom_BSplineCurve_7(Poles,Weights,Knots,Multiplicities,Degree,Periodic,CheckRational);getCache(Geom_BSplineCurve)[this.ptr]=this}Geom_BSplineCurve.prototype=Object.create(Geom_Curve.prototype);Geom_BSplineCurve.prototype.constructor=Geom_BSplineCurve;Geom_BSplineCurve.prototype.__class__=Geom_BSplineCurve;Geom_BSplineCurve.__cache__={};Module["Geom_BSplineCurve"]=Geom_BSplineCurve;Geom_BSplineCurve.prototype["Reverse"]=Geom_BSplineCurve.prototype.Reverse=function(){var self=this.ptr;_emscripten_bind_Geom_BSplineCurve_Reverse_0(self)};Geom_BSplineCurve.prototype["ReversedParameter"]=Geom_BSplineCurve.prototype.ReversedParameter=function(U){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;return _emscripten_bind_Geom_BSplineCurve_ReversedParameter_1(self,U)};Geom_BSplineCurve.prototype["IsCN"]=Geom_BSplineCurve.prototype.IsCN=function(N){var self=this.ptr;if(N&&typeof N==="object")N=N.ptr;return!!_emscripten_bind_Geom_BSplineCurve_IsCN_1(self,N)};Geom_BSplineCurve.prototype["FirstParameter"]=Geom_BSplineCurve.prototype.FirstParameter=function(){var self=this.ptr;return _emscripten_bind_Geom_BSplineCurve_FirstParameter_0(self)};Geom_BSplineCurve.prototype["IsClosed"]=Geom_BSplineCurve.prototype.IsClosed=function(){var self=this.ptr;return!!_emscripten_bind_Geom_BSplineCurve_IsClosed_0(self)};Geom_BSplineCurve.prototype["IsPeriodic"]=Geom_BSplineCurve.prototype.IsPeriodic=function(){var self=this.ptr;return!!_emscripten_bind_Geom_BSplineCurve_IsPeriodic_0(self)};Geom_BSplineCurve.prototype["Period"]=Geom_BSplineCurve.prototype.Period=function(){var self=this.ptr;return _emscripten_bind_Geom_BSplineCurve_Period_0(self)};Geom_BSplineCurve.prototype["LastParameter"]=Geom_BSplineCurve.prototype.LastParameter=function(){var self=this.ptr;return _emscripten_bind_Geom_BSplineCurve_LastParameter_0(self)};Geom_BSplineCurve.prototype["StartPoint"]=Geom_BSplineCurve.prototype.StartPoint=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Geom_BSplineCurve_StartPoint_0(self),gp_Pnt)};Geom_BSplineCurve.prototype["D0"]=Geom_BSplineCurve.prototype.D0=function(U,P){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;_emscripten_bind_Geom_BSplineCurve_D0_2(self,U,P)};Geom_BSplineCurve.prototype["D1"]=Geom_BSplineCurve.prototype.D1=function(U,P,V1){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;_emscripten_bind_Geom_BSplineCurve_D1_3(self,U,P,V1)};Geom_BSplineCurve.prototype["D2"]=Geom_BSplineCurve.prototype.D2=function(U,P,V1,V2){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;if(V2&&typeof V2==="object")V2=V2.ptr;_emscripten_bind_Geom_BSplineCurve_D2_4(self,U,P,V1,V2)};Geom_BSplineCurve.prototype["D3"]=Geom_BSplineCurve.prototype.D3=function(U,P,V1,V2,V3){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;if(V2&&typeof V2==="object")V2=V2.ptr;if(V3&&typeof V3==="object")V3=V3.ptr;_emscripten_bind_Geom_BSplineCurve_D3_5(self,U,P,V1,V2,V3)};Geom_BSplineCurve.prototype["DN"]=Geom_BSplineCurve.prototype.DN=function(U,N){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(N&&typeof N==="object")N=N.ptr;return wrapPointer(_emscripten_bind_Geom_BSplineCurve_DN_2(self,U,N),gp_Vec)};Geom_BSplineCurve.prototype["Transform"]=Geom_BSplineCurve.prototype.Transform=function(T){var self=this.ptr;if(T&&typeof T==="object")T=T.ptr;_emscripten_bind_Geom_BSplineCurve_Transform_1(self,T)};Geom_BSplineCurve.prototype["Reversed"]=Geom_BSplineCurve.prototype.Reversed=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Geom_BSplineCurve_Reversed_0(self),Handle_Geom_Curve)};Geom_BSplineCurve.prototype["Value"]=Geom_BSplineCurve.prototype.Value=function(U){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;return wrapPointer(_emscripten_bind_Geom_BSplineCurve_Value_1(self,U),gp_Pnt)};Geom_BSplineCurve.prototype["__destroy__"]=Geom_BSplineCurve.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Geom_BSplineCurve___destroy___0(self)};function Handle_Geom_TrimmedCurve(thePtr){if(thePtr&&typeof thePtr==="object")thePtr=thePtr.ptr;if(thePtr===undefined){this.ptr=_emscripten_bind_Handle_Geom_TrimmedCurve_Handle_Geom_TrimmedCurve_0();getCache(Handle_Geom_TrimmedCurve)[this.ptr]=this;return}this.ptr=_emscripten_bind_Handle_Geom_TrimmedCurve_Handle_Geom_TrimmedCurve_1(thePtr);getCache(Handle_Geom_TrimmedCurve)[this.ptr]=this}Handle_Geom_TrimmedCurve.prototype=Object.create(WrapperObject.prototype);Handle_Geom_TrimmedCurve.prototype.constructor=Handle_Geom_TrimmedCurve;Handle_Geom_TrimmedCurve.prototype.__class__=Handle_Geom_TrimmedCurve;Handle_Geom_TrimmedCurve.__cache__={};Module["Handle_Geom_TrimmedCurve"]=Handle_Geom_TrimmedCurve;Handle_Geom_TrimmedCurve.prototype["IsNull"]=Handle_Geom_TrimmedCurve.prototype.IsNull=function(){var self=this.ptr;return!!_emscripten_bind_Handle_Geom_TrimmedCurve_IsNull_0(self)};Handle_Geom_TrimmedCurve.prototype["Nullify"]=Handle_Geom_TrimmedCurve.prototype.Nullify=function(){var self=this.ptr;_emscripten_bind_Handle_Geom_TrimmedCurve_Nullify_0(self)};Handle_Geom_TrimmedCurve.prototype["get"]=Handle_Geom_TrimmedCurve.prototype.get=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Handle_Geom_TrimmedCurve_get_0(self),Geom_TrimmedCurve)};Handle_Geom_TrimmedCurve.prototype["__destroy__"]=Handle_Geom_TrimmedCurve.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Handle_Geom_TrimmedCurve___destroy___0(self)};function GC_MakeCircle(A2,Radius){if(A2&&typeof A2==="object")A2=A2.ptr;if(Radius&&typeof Radius==="object")Radius=Radius.ptr;if(Radius===undefined){this.ptr=_emscripten_bind_GC_MakeCircle_GC_MakeCircle_1(A2);getCache(GC_MakeCircle)[this.ptr]=this;return}this.ptr=_emscripten_bind_GC_MakeCircle_GC_MakeCircle_2(A2,Radius);getCache(GC_MakeCircle)[this.ptr]=this}GC_MakeCircle.prototype=Object.create(WrapperObject.prototype);GC_MakeCircle.prototype.constructor=GC_MakeCircle;GC_MakeCircle.prototype.__class__=GC_MakeCircle;GC_MakeCircle.__cache__={};Module["GC_MakeCircle"]=GC_MakeCircle;GC_MakeCircle.prototype["Value"]=GC_MakeCircle.prototype.Value=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_GC_MakeCircle_Value_0(self),Handle_Geom_Circle)};GC_MakeCircle.prototype["__destroy__"]=GC_MakeCircle.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_GC_MakeCircle___destroy___0(self)};function Geom_CylindricalSurface(A3,Radius){if(A3&&typeof A3==="object")A3=A3.ptr;if(Radius&&typeof Radius==="object")Radius=Radius.ptr;this.ptr=_emscripten_bind_Geom_CylindricalSurface_Geom_CylindricalSurface_2(A3,Radius);getCache(Geom_CylindricalSurface)[this.ptr]=this}Geom_CylindricalSurface.prototype=Object.create(WrapperObject.prototype);Geom_CylindricalSurface.prototype.constructor=Geom_CylindricalSurface;Geom_CylindricalSurface.prototype.__class__=Geom_CylindricalSurface;Geom_CylindricalSurface.__cache__={};Module["Geom_CylindricalSurface"]=Geom_CylindricalSurface;Geom_CylindricalSurface.prototype["__destroy__"]=Geom_CylindricalSurface.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Geom_CylindricalSurface___destroy___0(self)};function GC_MakeHyperbola(A2,MajorRadius,MinorRadius){if(A2&&typeof A2==="object")A2=A2.ptr;if(MajorRadius&&typeof MajorRadius==="object")MajorRadius=MajorRadius.ptr;if(MinorRadius&&typeof MinorRadius==="object")MinorRadius=MinorRadius.ptr;if(MajorRadius===undefined){this.ptr=_emscripten_bind_GC_MakeHyperbola_GC_MakeHyperbola_1(A2);getCache(GC_MakeHyperbola)[this.ptr]=this;return}if(MinorRadius===undefined){this.ptr=_emscripten_bind_GC_MakeHyperbola_GC_MakeHyperbola_2(A2,MajorRadius);getCache(GC_MakeHyperbola)[this.ptr]=this;return}this.ptr=_emscripten_bind_GC_MakeHyperbola_GC_MakeHyperbola_3(A2,MajorRadius,MinorRadius);getCache(GC_MakeHyperbola)[this.ptr]=this}GC_MakeHyperbola.prototype=Object.create(WrapperObject.prototype);GC_MakeHyperbola.prototype.constructor=GC_MakeHyperbola;GC_MakeHyperbola.prototype.__class__=GC_MakeHyperbola;GC_MakeHyperbola.__cache__={};Module["GC_MakeHyperbola"]=GC_MakeHyperbola;GC_MakeHyperbola.prototype["Value"]=GC_MakeHyperbola.prototype.Value=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_GC_MakeHyperbola_Value_0(self),Handle_Geom_Hyperbola)};GC_MakeHyperbola.prototype["__destroy__"]=GC_MakeHyperbola.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_GC_MakeHyperbola___destroy___0(self)};function BRepPrim_Sphere(){throw"cannot construct a BRepPrim_Sphere, no constructor in IDL"}BRepPrim_Sphere.prototype=Object.create(WrapperObject.prototype);BRepPrim_Sphere.prototype.constructor=BRepPrim_Sphere;BRepPrim_Sphere.prototype.__class__=BRepPrim_Sphere;BRepPrim_Sphere.__cache__={};Module["BRepPrim_Sphere"]=BRepPrim_Sphere;BRepPrim_Sphere.prototype["__destroy__"]=BRepPrim_Sphere.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepPrim_Sphere___destroy___0(self)};function ShapeFix_Shell(shape){if(shape&&typeof shape==="object")shape=shape.ptr;if(shape===undefined){this.ptr=_emscripten_bind_ShapeFix_Shell_ShapeFix_Shell_0();getCache(ShapeFix_Shell)[this.ptr]=this;return}this.ptr=_emscripten_bind_ShapeFix_Shell_ShapeFix_Shell_1(shape);getCache(ShapeFix_Shell)[this.ptr]=this}ShapeFix_Shell.prototype=Object.create(WrapperObject.prototype);ShapeFix_Shell.prototype.constructor=ShapeFix_Shell;ShapeFix_Shell.prototype.__class__=ShapeFix_Shell;ShapeFix_Shell.__cache__={};Module["ShapeFix_Shell"]=ShapeFix_Shell;ShapeFix_Shell.prototype["Init"]=ShapeFix_Shell.prototype.Init=function(shell){var self=this.ptr;if(shell&&typeof shell==="object")shell=shell.ptr;_emscripten_bind_ShapeFix_Shell_Init_1(self,shell)};ShapeFix_Shell.prototype["Perform"]=ShapeFix_Shell.prototype.Perform=function(theProgress){var self=this.ptr;if(theProgress&&typeof theProgress==="object")theProgress=theProgress.ptr;if(theProgress===undefined){return!!_emscripten_bind_ShapeFix_Shell_Perform_0(self)}return!!_emscripten_bind_ShapeFix_Shell_Perform_1(self,theProgress)};ShapeFix_Shell.prototype["FixFaceOrientation"]=ShapeFix_Shell.prototype.FixFaceOrientation=function(shell,isAccountMultiConex,NonManifold){var self=this.ptr;if(shell&&typeof shell==="object")shell=shell.ptr;if(isAccountMultiConex&&typeof isAccountMultiConex==="object")isAccountMultiConex=isAccountMultiConex.ptr;if(NonManifold&&typeof NonManifold==="object")NonManifold=NonManifold.ptr;if(isAccountMultiConex===undefined){return!!_emscripten_bind_ShapeFix_Shell_FixFaceOrientation_1(self,shell)}if(NonManifold===undefined){return!!_emscripten_bind_ShapeFix_Shell_FixFaceOrientation_2(self,shell,isAccountMultiConex)}return!!_emscripten_bind_ShapeFix_Shell_FixFaceOrientation_3(self,shell,isAccountMultiConex,NonManifold)};ShapeFix_Shell.prototype["Shell"]=ShapeFix_Shell.prototype.Shell=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_ShapeFix_Shell_Shell_0(self),TopoDS_Shell)};ShapeFix_Shell.prototype["Shape"]=ShapeFix_Shell.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_ShapeFix_Shell_Shape_0(self),TopoDS_Shape)};ShapeFix_Shell.prototype["NbShells"]=ShapeFix_Shell.prototype.NbShells=function(){var self=this.ptr;return _emscripten_bind_ShapeFix_Shell_NbShells_0(self)};ShapeFix_Shell.prototype["ErrorFaces"]=ShapeFix_Shell.prototype.ErrorFaces=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_ShapeFix_Shell_ErrorFaces_0(self),TopoDS_Compound)};ShapeFix_Shell.prototype["Status"]=ShapeFix_Shell.prototype.Status=function(status){var self=this.ptr;if(status&&typeof status==="object")status=status.ptr;return!!_emscripten_bind_ShapeFix_Shell_Status_1(self,status)};ShapeFix_Shell.prototype["SetPrecision"]=ShapeFix_Shell.prototype.SetPrecision=function(preci){var self=this.ptr;if(preci&&typeof preci==="object")preci=preci.ptr;_emscripten_bind_ShapeFix_Shell_SetPrecision_1(self,preci)};ShapeFix_Shell.prototype["SetMinTolerance"]=ShapeFix_Shell.prototype.SetMinTolerance=function(mintol){var self=this.ptr;if(mintol&&typeof mintol==="object")mintol=mintol.ptr;_emscripten_bind_ShapeFix_Shell_SetMinTolerance_1(self,mintol)};ShapeFix_Shell.prototype["SetMaxTolerance"]=ShapeFix_Shell.prototype.SetMaxTolerance=function(maxtol){var self=this.ptr;if(maxtol&&typeof maxtol==="object")maxtol=maxtol.ptr;_emscripten_bind_ShapeFix_Shell_SetMaxTolerance_1(self,maxtol)};ShapeFix_Shell.prototype["FixFaceMode"]=ShapeFix_Shell.prototype.FixFaceMode=function(){var self=this.ptr;return _emscripten_bind_ShapeFix_Shell_FixFaceMode_0(self)};ShapeFix_Shell.prototype["FixOrientationMode"]=ShapeFix_Shell.prototype.FixOrientationMode=function(){var self=this.ptr;return _emscripten_bind_ShapeFix_Shell_FixOrientationMode_0(self)};ShapeFix_Shell.prototype["SetNonManifoldFlag"]=ShapeFix_Shell.prototype.SetNonManifoldFlag=function(isNonManifold){var self=this.ptr;if(isNonManifold&&typeof isNonManifold==="object")isNonManifold=isNonManifold.ptr;_emscripten_bind_ShapeFix_Shell_SetNonManifoldFlag_1(self,isNonManifold)};ShapeFix_Shell.prototype["__destroy__"]=ShapeFix_Shell.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_ShapeFix_Shell___destroy___0(self)};function BRepOffsetAPI_MakePipe(Spine,Profile){if(Spine&&typeof Spine==="object")Spine=Spine.ptr;if(Profile&&typeof Profile==="object")Profile=Profile.ptr;this.ptr=_emscripten_bind_BRepOffsetAPI_MakePipe_BRepOffsetAPI_MakePipe_2(Spine,Profile);getCache(BRepOffsetAPI_MakePipe)[this.ptr]=this}BRepOffsetAPI_MakePipe.prototype=Object.create(BRepBuilderAPI_MakeShape.prototype);BRepOffsetAPI_MakePipe.prototype.constructor=BRepOffsetAPI_MakePipe;BRepOffsetAPI_MakePipe.prototype.__class__=BRepOffsetAPI_MakePipe;BRepOffsetAPI_MakePipe.__cache__={};Module["BRepOffsetAPI_MakePipe"]=BRepOffsetAPI_MakePipe;BRepOffsetAPI_MakePipe.prototype["Build"]=BRepOffsetAPI_MakePipe.prototype.Build=function(){var self=this.ptr;_emscripten_bind_BRepOffsetAPI_MakePipe_Build_0(self)};BRepOffsetAPI_MakePipe.prototype["Generated"]=BRepOffsetAPI_MakePipe.prototype.Generated=function(SSpine,SProfile){var self=this.ptr;if(SSpine&&typeof SSpine==="object")SSpine=SSpine.ptr;if(SProfile&&typeof SProfile==="object")SProfile=SProfile.ptr;return wrapPointer(_emscripten_bind_BRepOffsetAPI_MakePipe_Generated_2(self,SSpine,SProfile),TopoDS_Shape)};BRepOffsetAPI_MakePipe.prototype["FirstShape"]=BRepOffsetAPI_MakePipe.prototype.FirstShape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepOffsetAPI_MakePipe_FirstShape_0(self),TopoDS_Shape)};BRepOffsetAPI_MakePipe.prototype["LastShape"]=BRepOffsetAPI_MakePipe.prototype.LastShape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepOffsetAPI_MakePipe_LastShape_0(self),TopoDS_Shape)};BRepOffsetAPI_MakePipe.prototype["ErrorOnSurface"]=BRepOffsetAPI_MakePipe.prototype.ErrorOnSurface=function(){var self=this.ptr;return _emscripten_bind_BRepOffsetAPI_MakePipe_ErrorOnSurface_0(self)};BRepOffsetAPI_MakePipe.prototype["Shape"]=BRepOffsetAPI_MakePipe.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepOffsetAPI_MakePipe_Shape_0(self),TopoDS_Shape)};BRepOffsetAPI_MakePipe.prototype["__destroy__"]=BRepOffsetAPI_MakePipe.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepOffsetAPI_MakePipe___destroy___0(self)};function Handle_Transfer_TransientProcess(thePtr){if(thePtr&&typeof thePtr==="object")thePtr=thePtr.ptr;if(thePtr===undefined){this.ptr=_emscripten_bind_Handle_Transfer_TransientProcess_Handle_Transfer_TransientProcess_0();getCache(Handle_Transfer_TransientProcess)[this.ptr]=this;return}this.ptr=_emscripten_bind_Handle_Transfer_TransientProcess_Handle_Transfer_TransientProcess_1(thePtr);getCache(Handle_Transfer_TransientProcess)[this.ptr]=this}Handle_Transfer_TransientProcess.prototype=Object.create(WrapperObject.prototype);Handle_Transfer_TransientProcess.prototype.constructor=Handle_Transfer_TransientProcess;Handle_Transfer_TransientProcess.prototype.__class__=Handle_Transfer_TransientProcess;Handle_Transfer_TransientProcess.__cache__={};Module["Handle_Transfer_TransientProcess"]=Handle_Transfer_TransientProcess;Handle_Transfer_TransientProcess.prototype["IsNull"]=Handle_Transfer_TransientProcess.prototype.IsNull=function(){var self=this.ptr;return!!_emscripten_bind_Handle_Transfer_TransientProcess_IsNull_0(self)};Handle_Transfer_TransientProcess.prototype["Nullify"]=Handle_Transfer_TransientProcess.prototype.Nullify=function(){var self=this.ptr;_emscripten_bind_Handle_Transfer_TransientProcess_Nullify_0(self)};Handle_Transfer_TransientProcess.prototype["get"]=Handle_Transfer_TransientProcess.prototype.get=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Handle_Transfer_TransientProcess_get_0(self),Transfer_TransientProcess)};Handle_Transfer_TransientProcess.prototype["__destroy__"]=Handle_Transfer_TransientProcess.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Handle_Transfer_TransientProcess___destroy___0(self)};function XSControl_WorkSession(){this.ptr=_emscripten_bind_XSControl_WorkSession_XSControl_WorkSession_0();getCache(XSControl_WorkSession)[this.ptr]=this}XSControl_WorkSession.prototype=Object.create(WrapperObject.prototype);XSControl_WorkSession.prototype.constructor=XSControl_WorkSession;XSControl_WorkSession.prototype.__class__=XSControl_WorkSession;XSControl_WorkSession.__cache__={};Module["XSControl_WorkSession"]=XSControl_WorkSession;XSControl_WorkSession.prototype["ClearData"]=XSControl_WorkSession.prototype.ClearData=function(theMode){var self=this.ptr;if(theMode&&typeof theMode==="object")theMode=theMode.ptr;_emscripten_bind_XSControl_WorkSession_ClearData_1(self,theMode)};XSControl_WorkSession.prototype["SelectNorm"]=XSControl_WorkSession.prototype.SelectNorm=function(theNormName){var self=this.ptr;ensureCache.prepare();if(theNormName&&typeof theNormName==="object")theNormName=theNormName.ptr;else theNormName=ensureString(theNormName);return!!_emscripten_bind_XSControl_WorkSession_SelectNorm_1(self,theNormName)};XSControl_WorkSession.prototype["ClearContext"]=XSControl_WorkSession.prototype.ClearContext=function(){var self=this.ptr;_emscripten_bind_XSControl_WorkSession_ClearContext_0(self)};XSControl_WorkSession.prototype["InitTransferReader"]=XSControl_WorkSession.prototype.InitTransferReader=function(theMode){var self=this.ptr;if(theMode&&typeof theMode==="object")theMode=theMode.ptr;_emscripten_bind_XSControl_WorkSession_InitTransferReader_1(self,theMode)};XSControl_WorkSession.prototype["MapReader"]=XSControl_WorkSession.prototype.MapReader=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_XSControl_WorkSession_MapReader_0(self),Handle_Transfer_TransientProcess)};XSControl_WorkSession.prototype["SetMapReader"]=XSControl_WorkSession.prototype.SetMapReader=function(theTP){var self=this.ptr;if(theTP&&typeof theTP==="object")theTP=theTP.ptr;return!!_emscripten_bind_XSControl_WorkSession_SetMapReader_1(self,theTP)};XSControl_WorkSession.prototype["TransferReadRoots"]=XSControl_WorkSession.prototype.TransferReadRoots=function(){var self=this.ptr;return _emscripten_bind_XSControl_WorkSession_TransferReadRoots_0(self)};XSControl_WorkSession.prototype["TransferWriteShape"]=XSControl_WorkSession.prototype.TransferWriteShape=function(theShape,theCompGraph){var self=this.ptr;if(theShape&&typeof theShape==="object")theShape=theShape.ptr;if(theCompGraph&&typeof theCompGraph==="object")theCompGraph=theCompGraph.ptr;if(theCompGraph===undefined){return _emscripten_bind_XSControl_WorkSession_TransferWriteShape_1(self,theShape)}return _emscripten_bind_XSControl_WorkSession_TransferWriteShape_2(self,theShape,theCompGraph)};XSControl_WorkSession.prototype["__destroy__"]=XSControl_WorkSession.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_XSControl_WorkSession___destroy___0(self)};function Handle_Geom_Ellipse(thePtr){if(thePtr&&typeof thePtr==="object")thePtr=thePtr.ptr;if(thePtr===undefined){this.ptr=_emscripten_bind_Handle_Geom_Ellipse_Handle_Geom_Ellipse_0();getCache(Handle_Geom_Ellipse)[this.ptr]=this;return}this.ptr=_emscripten_bind_Handle_Geom_Ellipse_Handle_Geom_Ellipse_1(thePtr);getCache(Handle_Geom_Ellipse)[this.ptr]=this}Handle_Geom_Ellipse.prototype=Object.create(WrapperObject.prototype);Handle_Geom_Ellipse.prototype.constructor=Handle_Geom_Ellipse;Handle_Geom_Ellipse.prototype.__class__=Handle_Geom_Ellipse;Handle_Geom_Ellipse.__cache__={};Module["Handle_Geom_Ellipse"]=Handle_Geom_Ellipse;Handle_Geom_Ellipse.prototype["IsNull"]=Handle_Geom_Ellipse.prototype.IsNull=function(){var self=this.ptr;return!!_emscripten_bind_Handle_Geom_Ellipse_IsNull_0(self)};Handle_Geom_Ellipse.prototype["Nullify"]=Handle_Geom_Ellipse.prototype.Nullify=function(){var self=this.ptr;_emscripten_bind_Handle_Geom_Ellipse_Nullify_0(self)};Handle_Geom_Ellipse.prototype["get"]=Handle_Geom_Ellipse.prototype.get=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Handle_Geom_Ellipse_get_0(self),Geom_Ellipse)};Handle_Geom_Ellipse.prototype["__destroy__"]=Handle_Geom_Ellipse.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Handle_Geom_Ellipse___destroy___0(self)};function GProp_GProps(SystemLocation){if(SystemLocation&&typeof SystemLocation==="object")SystemLocation=SystemLocation.ptr;if(SystemLocation===undefined){this.ptr=_emscripten_bind_GProp_GProps_GProp_GProps_0();getCache(GProp_GProps)[this.ptr]=this;return}this.ptr=_emscripten_bind_GProp_GProps_GProp_GProps_1(SystemLocation);getCache(GProp_GProps)[this.ptr]=this}GProp_GProps.prototype=Object.create(WrapperObject.prototype);GProp_GProps.prototype.constructor=GProp_GProps;GProp_GProps.prototype.__class__=GProp_GProps;GProp_GProps.__cache__={};Module["GProp_GProps"]=GProp_GProps;GProp_GProps.prototype["Mass"]=GProp_GProps.prototype.Mass=function(){var self=this.ptr;return _emscripten_bind_GProp_GProps_Mass_0(self)};GProp_GProps.prototype["CentreOfMass"]=GProp_GProps.prototype.CentreOfMass=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_GProp_GProps_CentreOfMass_0(self),gp_Pnt)};GProp_GProps.prototype["MomentOfInertia"]=GProp_GProps.prototype.MomentOfInertia=function(A1){var self=this.ptr;if(A1&&typeof A1==="object")A1=A1.ptr;return _emscripten_bind_GProp_GProps_MomentOfInertia_1(self,A1)};GProp_GProps.prototype["RadiusOfGyration"]=GProp_GProps.prototype.RadiusOfGyration=function(A){var self=this.ptr;if(A&&typeof A==="object")A=A.ptr;return _emscripten_bind_GProp_GProps_RadiusOfGyration_1(self,A)};GProp_GProps.prototype["StaticMoments"]=GProp_GProps.prototype.StaticMoments=function(Ix,Iy,Iz){var self=this.ptr;if(Ix&&typeof Ix==="object")Ix=Ix.ptr;if(Iy&&typeof Iy==="object")Iy=Iy.ptr;if(Iz&&typeof Iz==="object")Iz=Iz.ptr;_emscripten_bind_GProp_GProps_StaticMoments_3(self,Ix,Iy,Iz)};GProp_GProps.prototype["__destroy__"]=GProp_GProps.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_GProp_GProps___destroy___0(self)};function Poly_PolygonOnTriangulation(Nodes,Parameters){if(Nodes&&typeof Nodes==="object")Nodes=Nodes.ptr;if(Parameters&&typeof Parameters==="object")Parameters=Parameters.ptr;if(Parameters===undefined){this.ptr=_emscripten_bind_Poly_PolygonOnTriangulation_Poly_PolygonOnTriangulation_1(Nodes);getCache(Poly_PolygonOnTriangulation)[this.ptr]=this;return}this.ptr=_emscripten_bind_Poly_PolygonOnTriangulation_Poly_PolygonOnTriangulation_2(Nodes,Parameters);getCache(Poly_PolygonOnTriangulation)[this.ptr]=this}Poly_PolygonOnTriangulation.prototype=Object.create(WrapperObject.prototype);Poly_PolygonOnTriangulation.prototype.constructor=Poly_PolygonOnTriangulation;Poly_PolygonOnTriangulation.prototype.__class__=Poly_PolygonOnTriangulation;Poly_PolygonOnTriangulation.__cache__={};Module["Poly_PolygonOnTriangulation"]=Poly_PolygonOnTriangulation;Poly_PolygonOnTriangulation.prototype["Deflection"]=Poly_PolygonOnTriangulation.prototype.Deflection=function(D){var self=this.ptr;if(D&&typeof D==="object")D=D.ptr;_emscripten_bind_Poly_PolygonOnTriangulation_Deflection_1(self,D)};Poly_PolygonOnTriangulation.prototype["NbNodes"]=Poly_PolygonOnTriangulation.prototype.NbNodes=function(){var self=this.ptr;return _emscripten_bind_Poly_PolygonOnTriangulation_NbNodes_0(self)};Poly_PolygonOnTriangulation.prototype["Nodes"]=Poly_PolygonOnTriangulation.prototype.Nodes=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Poly_PolygonOnTriangulation_Nodes_0(self),TColStd_Array1OfInteger)};Poly_PolygonOnTriangulation.prototype["HasParameters"]=Poly_PolygonOnTriangulation.prototype.HasParameters=function(){var self=this.ptr;return!!_emscripten_bind_Poly_PolygonOnTriangulation_HasParameters_0(self)};Poly_PolygonOnTriangulation.prototype["__destroy__"]=Poly_PolygonOnTriangulation.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Poly_PolygonOnTriangulation___destroy___0(self)};function Poly_Connect(theTriangulation){if(theTriangulation&&typeof theTriangulation==="object")theTriangulation=theTriangulation.ptr;if(theTriangulation===undefined){this.ptr=_emscripten_bind_Poly_Connect_Poly_Connect_0();getCache(Poly_Connect)[this.ptr]=this;return}this.ptr=_emscripten_bind_Poly_Connect_Poly_Connect_1(theTriangulation);getCache(Poly_Connect)[this.ptr]=this}Poly_Connect.prototype=Object.create(WrapperObject.prototype);Poly_Connect.prototype.constructor=Poly_Connect;Poly_Connect.prototype.__class__=Poly_Connect;Poly_Connect.__cache__={};Module["Poly_Connect"]=Poly_Connect;Poly_Connect.prototype["Load"]=Poly_Connect.prototype.Load=function(theTriangulation){var self=this.ptr;if(theTriangulation&&typeof theTriangulation==="object")theTriangulation=theTriangulation.ptr;_emscripten_bind_Poly_Connect_Load_1(self,theTriangulation)};Poly_Connect.prototype["Triangulation"]=Poly_Connect.prototype.Triangulation=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Poly_Connect_Triangulation_0(self),Handle_Poly_Triangulation)};Poly_Connect.prototype["Triangle"]=Poly_Connect.prototype.Triangle=function(N){var self=this.ptr;if(N&&typeof N==="object")N=N.ptr;return _emscripten_bind_Poly_Connect_Triangle_1(self,N)};Poly_Connect.prototype["Triangles"]=Poly_Connect.prototype.Triangles=function(T,t1,t2,t3){var self=this.ptr;if(T&&typeof T==="object")T=T.ptr;if(t1&&typeof t1==="object")t1=t1.ptr;if(t2&&typeof t2==="object")t2=t2.ptr;if(t3&&typeof t3==="object")t3=t3.ptr;_emscripten_bind_Poly_Connect_Triangles_4(self,T,t1,t2,t3)};Poly_Connect.prototype["Nodes"]=Poly_Connect.prototype.Nodes=function(T,t1,t2,t3){var self=this.ptr;if(T&&typeof T==="object")T=T.ptr;if(t1&&typeof t1==="object")t1=t1.ptr;if(t2&&typeof t2==="object")t2=t2.ptr;if(t3&&typeof t3==="object")t3=t3.ptr;_emscripten_bind_Poly_Connect_Nodes_4(self,T,t1,t2,t3)};Poly_Connect.prototype["Initialize"]=Poly_Connect.prototype.Initialize=function(N){var self=this.ptr;if(N&&typeof N==="object")N=N.ptr;_emscripten_bind_Poly_Connect_Initialize_1(self,N)};Poly_Connect.prototype["More"]=Poly_Connect.prototype.More=function(){var self=this.ptr;return!!_emscripten_bind_Poly_Connect_More_0(self)};Poly_Connect.prototype["Next"]=Poly_Connect.prototype.Next=function(){var self=this.ptr;_emscripten_bind_Poly_Connect_Next_0(self)};Poly_Connect.prototype["Value"]=Poly_Connect.prototype.Value=function(){var self=this.ptr;return _emscripten_bind_Poly_Connect_Value_0(self)};Poly_Connect.prototype["__destroy__"]=Poly_Connect.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Poly_Connect___destroy___0(self)};function Handle_Geom_Circle(thePtr){if(thePtr&&typeof thePtr==="object")thePtr=thePtr.ptr;if(thePtr===undefined){this.ptr=_emscripten_bind_Handle_Geom_Circle_Handle_Geom_Circle_0();getCache(Handle_Geom_Circle)[this.ptr]=this;return}this.ptr=_emscripten_bind_Handle_Geom_Circle_Handle_Geom_Circle_1(thePtr);getCache(Handle_Geom_Circle)[this.ptr]=this}Handle_Geom_Circle.prototype=Object.create(WrapperObject.prototype);Handle_Geom_Circle.prototype.constructor=Handle_Geom_Circle;Handle_Geom_Circle.prototype.__class__=Handle_Geom_Circle;Handle_Geom_Circle.__cache__={};Module["Handle_Geom_Circle"]=Handle_Geom_Circle;Handle_Geom_Circle.prototype["IsNull"]=Handle_Geom_Circle.prototype.IsNull=function(){var self=this.ptr;return!!_emscripten_bind_Handle_Geom_Circle_IsNull_0(self)};Handle_Geom_Circle.prototype["Nullify"]=Handle_Geom_Circle.prototype.Nullify=function(){var self=this.ptr;_emscripten_bind_Handle_Geom_Circle_Nullify_0(self)};Handle_Geom_Circle.prototype["get"]=Handle_Geom_Circle.prototype.get=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Handle_Geom_Circle_get_0(self),Geom_Circle)};Handle_Geom_Circle.prototype["__destroy__"]=Handle_Geom_Circle.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Handle_Geom_Circle___destroy___0(self)};function Handle_Geom_Hyperbola(thePtr){if(thePtr&&typeof thePtr==="object")thePtr=thePtr.ptr;if(thePtr===undefined){this.ptr=_emscripten_bind_Handle_Geom_Hyperbola_Handle_Geom_Hyperbola_0();getCache(Handle_Geom_Hyperbola)[this.ptr]=this;return}this.ptr=_emscripten_bind_Handle_Geom_Hyperbola_Handle_Geom_Hyperbola_1(thePtr);getCache(Handle_Geom_Hyperbola)[this.ptr]=this}Handle_Geom_Hyperbola.prototype=Object.create(WrapperObject.prototype);Handle_Geom_Hyperbola.prototype.constructor=Handle_Geom_Hyperbola;Handle_Geom_Hyperbola.prototype.__class__=Handle_Geom_Hyperbola;Handle_Geom_Hyperbola.__cache__={};Module["Handle_Geom_Hyperbola"]=Handle_Geom_Hyperbola;Handle_Geom_Hyperbola.prototype["IsNull"]=Handle_Geom_Hyperbola.prototype.IsNull=function(){var self=this.ptr;return!!_emscripten_bind_Handle_Geom_Hyperbola_IsNull_0(self)};Handle_Geom_Hyperbola.prototype["Nullify"]=Handle_Geom_Hyperbola.prototype.Nullify=function(){var self=this.ptr;_emscripten_bind_Handle_Geom_Hyperbola_Nullify_0(self)};Handle_Geom_Hyperbola.prototype["get"]=Handle_Geom_Hyperbola.prototype.get=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Handle_Geom_Hyperbola_get_0(self),Geom_Hyperbola)};Handle_Geom_Hyperbola.prototype["__destroy__"]=Handle_Geom_Hyperbola.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Handle_Geom_Hyperbola___destroy___0(self)};function GC_MakeEllipse(A2,MajorRadius,MinorRadius){if(A2&&typeof A2==="object")A2=A2.ptr;if(MajorRadius&&typeof MajorRadius==="object")MajorRadius=MajorRadius.ptr;if(MinorRadius&&typeof MinorRadius==="object")MinorRadius=MinorRadius.ptr;if(MajorRadius===undefined){this.ptr=_emscripten_bind_GC_MakeEllipse_GC_MakeEllipse_1(A2);getCache(GC_MakeEllipse)[this.ptr]=this;return}if(MinorRadius===undefined){this.ptr=_emscripten_bind_GC_MakeEllipse_GC_MakeEllipse_2(A2,MajorRadius);getCache(GC_MakeEllipse)[this.ptr]=this;return}this.ptr=_emscripten_bind_GC_MakeEllipse_GC_MakeEllipse_3(A2,MajorRadius,MinorRadius);getCache(GC_MakeEllipse)[this.ptr]=this}GC_MakeEllipse.prototype=Object.create(WrapperObject.prototype);GC_MakeEllipse.prototype.constructor=GC_MakeEllipse;GC_MakeEllipse.prototype.__class__=GC_MakeEllipse;GC_MakeEllipse.__cache__={};Module["GC_MakeEllipse"]=GC_MakeEllipse;GC_MakeEllipse.prototype["Value"]=GC_MakeEllipse.prototype.Value=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_GC_MakeEllipse_Value_0(self),Handle_Geom_Ellipse)};GC_MakeEllipse.prototype["__destroy__"]=GC_MakeEllipse.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_GC_MakeEllipse___destroy___0(self)};function GeomAPI_PointsToBSpline(Points,DegMin,DegMax,Continuity,Tol3D){if(Points&&typeof Points==="object")Points=Points.ptr;if(DegMin&&typeof DegMin==="object")DegMin=DegMin.ptr;if(DegMax&&typeof DegMax==="object")DegMax=DegMax.ptr;if(Continuity&&typeof Continuity==="object")Continuity=Continuity.ptr;if(Tol3D&&typeof Tol3D==="object")Tol3D=Tol3D.ptr;if(DegMin===undefined){this.ptr=_emscripten_bind_GeomAPI_PointsToBSpline_GeomAPI_PointsToBSpline_1(Points);getCache(GeomAPI_PointsToBSpline)[this.ptr]=this;return}if(DegMax===undefined){this.ptr=_emscripten_bind_GeomAPI_PointsToBSpline_GeomAPI_PointsToBSpline_2(Points,DegMin);getCache(GeomAPI_PointsToBSpline)[this.ptr]=this;return}if(Continuity===undefined){this.ptr=_emscripten_bind_GeomAPI_PointsToBSpline_GeomAPI_PointsToBSpline_3(Points,DegMin,DegMax);getCache(GeomAPI_PointsToBSpline)[this.ptr]=this;return}if(Tol3D===undefined){this.ptr=_emscripten_bind_GeomAPI_PointsToBSpline_GeomAPI_PointsToBSpline_4(Points,DegMin,DegMax,Continuity);getCache(GeomAPI_PointsToBSpline)[this.ptr]=this;return}this.ptr=_emscripten_bind_GeomAPI_PointsToBSpline_GeomAPI_PointsToBSpline_5(Points,DegMin,DegMax,Continuity,Tol3D);getCache(GeomAPI_PointsToBSpline)[this.ptr]=this}GeomAPI_PointsToBSpline.prototype=Object.create(WrapperObject.prototype);GeomAPI_PointsToBSpline.prototype.constructor=GeomAPI_PointsToBSpline;GeomAPI_PointsToBSpline.prototype.__class__=GeomAPI_PointsToBSpline;GeomAPI_PointsToBSpline.__cache__={};Module["GeomAPI_PointsToBSpline"]=GeomAPI_PointsToBSpline;GeomAPI_PointsToBSpline.prototype["Curve"]=GeomAPI_PointsToBSpline.prototype.Curve=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_GeomAPI_PointsToBSpline_Curve_0(self),Handle_Geom_BSplineCurve)};GeomAPI_PointsToBSpline.prototype["IsDone"]=GeomAPI_PointsToBSpline.prototype.IsDone=function(){var self=this.ptr;return!!_emscripten_bind_GeomAPI_PointsToBSpline_IsDone_0(self)};GeomAPI_PointsToBSpline.prototype["__destroy__"]=GeomAPI_PointsToBSpline.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_GeomAPI_PointsToBSpline___destroy___0(self)};function BRep_Builder(){this.ptr=_emscripten_bind_BRep_Builder_BRep_Builder_0();getCache(BRep_Builder)[this.ptr]=this}BRep_Builder.prototype=Object.create(TopoDS_Builder.prototype);BRep_Builder.prototype.constructor=BRep_Builder;BRep_Builder.prototype.__class__=BRep_Builder;BRep_Builder.__cache__={};Module["BRep_Builder"]=BRep_Builder;BRep_Builder.prototype["MakeFace"]=BRep_Builder.prototype.MakeFace=function(F,T){var self=this.ptr;if(F&&typeof F==="object")F=F.ptr;if(T&&typeof T==="object")T=T.ptr;if(T===undefined){_emscripten_bind_BRep_Builder_MakeFace_1(self,F);return}_emscripten_bind_BRep_Builder_MakeFace_2(self,F,T)};BRep_Builder.prototype["UpdateFace"]=BRep_Builder.prototype.UpdateFace=function(F,T){var self=this.ptr;if(F&&typeof F==="object")F=F.ptr;if(T&&typeof T==="object")T=T.ptr;_emscripten_bind_BRep_Builder_UpdateFace_2(self,F,T)};BRep_Builder.prototype["NaturalRestriction"]=BRep_Builder.prototype.NaturalRestriction=function(F,N){var self=this.ptr;if(F&&typeof F==="object")F=F.ptr;if(N&&typeof N==="object")N=N.ptr;_emscripten_bind_BRep_Builder_NaturalRestriction_2(self,F,N)};BRep_Builder.prototype["MakeEdge"]=BRep_Builder.prototype.MakeEdge=function(E){var self=this.ptr;if(E&&typeof E==="object")E=E.ptr;_emscripten_bind_BRep_Builder_MakeEdge_1(self,E)};BRep_Builder.prototype["SameParameter"]=BRep_Builder.prototype.SameParameter=function(E,S){var self=this.ptr;if(E&&typeof E==="object")E=E.ptr;if(S&&typeof S==="object")S=S.ptr;_emscripten_bind_BRep_Builder_SameParameter_2(self,E,S)};BRep_Builder.prototype["SameRange"]=BRep_Builder.prototype.SameRange=function(E,S){var self=this.ptr;if(E&&typeof E==="object")E=E.ptr;if(S&&typeof S==="object")S=S.ptr;_emscripten_bind_BRep_Builder_SameRange_2(self,E,S)};BRep_Builder.prototype["Degenerated"]=BRep_Builder.prototype.Degenerated=function(E,D){var self=this.ptr;if(E&&typeof E==="object")E=E.ptr;if(D&&typeof D==="object")D=D.ptr;_emscripten_bind_BRep_Builder_Degenerated_2(self,E,D)};BRep_Builder.prototype["Range"]=BRep_Builder.prototype.Range=function(E,First,Last,Only3d){var self=this.ptr;if(E&&typeof E==="object")E=E.ptr;if(First&&typeof First==="object")First=First.ptr;if(Last&&typeof Last==="object")Last=Last.ptr;if(Only3d&&typeof Only3d==="object")Only3d=Only3d.ptr;if(Only3d===undefined){_emscripten_bind_BRep_Builder_Range_3(self,E,First,Last);return}_emscripten_bind_BRep_Builder_Range_4(self,E,First,Last,Only3d)};BRep_Builder.prototype["Transfert"]=BRep_Builder.prototype.Transfert=function(Ein,Eout,Vin,Vout){var self=this.ptr;if(Ein&&typeof Ein==="object")Ein=Ein.ptr;if(Eout&&typeof Eout==="object")Eout=Eout.ptr;if(Vin&&typeof Vin==="object")Vin=Vin.ptr;if(Vout&&typeof Vout==="object")Vout=Vout.ptr;if(Vin===undefined){_emscripten_bind_BRep_Builder_Transfert_2(self,Ein,Eout);return}if(Vout===undefined){_emscripten_bind_BRep_Builder_Transfert_3(self,Ein,Eout,Vin);return}_emscripten_bind_BRep_Builder_Transfert_4(self,Ein,Eout,Vin,Vout)};BRep_Builder.prototype["MakeVertex"]=BRep_Builder.prototype.MakeVertex=function(V,P,Tol){var self=this.ptr;if(V&&typeof V==="object")V=V.ptr;if(P&&typeof P==="object")P=P.ptr;if(Tol&&typeof Tol==="object")Tol=Tol.ptr;if(P===undefined){_emscripten_bind_BRep_Builder_MakeVertex_1(self,V);return}if(Tol===undefined){_emscripten_bind_BRep_Builder_MakeVertex_2(self,V,P);return}_emscripten_bind_BRep_Builder_MakeVertex_3(self,V,P,Tol)};BRep_Builder.prototype["UpdateVertex"]=BRep_Builder.prototype.UpdateVertex=function(Ve,U,V,F,Tol){var self=this.ptr;if(Ve&&typeof Ve==="object")Ve=Ve.ptr;if(U&&typeof U==="object")U=U.ptr;if(V&&typeof V==="object")V=V.ptr;if(F&&typeof F==="object")F=F.ptr;if(Tol&&typeof Tol==="object")Tol=Tol.ptr;if(V===undefined){_emscripten_bind_BRep_Builder_UpdateVertex_2(self,Ve,U);return}if(F===undefined){_emscripten_bind_BRep_Builder_UpdateVertex_3(self,Ve,U,V);return}if(Tol===undefined){_emscripten_bind_BRep_Builder_UpdateVertex_4(self,Ve,U,V,F);return}_emscripten_bind_BRep_Builder_UpdateVertex_5(self,Ve,U,V,F,Tol)};BRep_Builder.prototype["MakeWire"]=BRep_Builder.prototype.MakeWire=function(W){var self=this.ptr;if(W&&typeof W==="object")W=W.ptr;_emscripten_bind_BRep_Builder_MakeWire_1(self,W)};BRep_Builder.prototype["MakeCompound"]=BRep_Builder.prototype.MakeCompound=function(C){var self=this.ptr;if(C&&typeof C==="object")C=C.ptr;_emscripten_bind_BRep_Builder_MakeCompound_1(self,C)};BRep_Builder.prototype["Add"]=BRep_Builder.prototype.Add=function(S,C){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;if(C&&typeof C==="object")C=C.ptr;_emscripten_bind_BRep_Builder_Add_2(self,S,C)};BRep_Builder.prototype["Remove"]=BRep_Builder.prototype.Remove=function(S,C){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;if(C&&typeof C==="object")C=C.ptr;_emscripten_bind_BRep_Builder_Remove_2(self,S,C)};BRep_Builder.prototype["__destroy__"]=BRep_Builder.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRep_Builder___destroy___0(self)};function BRepBuilderAPI_Copy(S,copyGeom,copyMesh){if(S&&typeof S==="object")S=S.ptr;if(copyGeom&&typeof copyGeom==="object")copyGeom=copyGeom.ptr;if(copyMesh&&typeof copyMesh==="object")copyMesh=copyMesh.ptr;if(S===undefined){this.ptr=_emscripten_bind_BRepBuilderAPI_Copy_BRepBuilderAPI_Copy_0();getCache(BRepBuilderAPI_Copy)[this.ptr]=this;return}if(copyGeom===undefined){this.ptr=_emscripten_bind_BRepBuilderAPI_Copy_BRepBuilderAPI_Copy_1(S);getCache(BRepBuilderAPI_Copy)[this.ptr]=this;return}if(copyMesh===undefined){this.ptr=_emscripten_bind_BRepBuilderAPI_Copy_BRepBuilderAPI_Copy_2(S,copyGeom);getCache(BRepBuilderAPI_Copy)[this.ptr]=this;return}this.ptr=_emscripten_bind_BRepBuilderAPI_Copy_BRepBuilderAPI_Copy_3(S,copyGeom,copyMesh);getCache(BRepBuilderAPI_Copy)[this.ptr]=this}BRepBuilderAPI_Copy.prototype=Object.create(WrapperObject.prototype);BRepBuilderAPI_Copy.prototype.constructor=BRepBuilderAPI_Copy;BRepBuilderAPI_Copy.prototype.__class__=BRepBuilderAPI_Copy;BRepBuilderAPI_Copy.__cache__={};Module["BRepBuilderAPI_Copy"]=BRepBuilderAPI_Copy;BRepBuilderAPI_Copy.prototype["Perform"]=BRepBuilderAPI_Copy.prototype.Perform=function(S,copyGeom,copyMesh){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;if(copyGeom&&typeof copyGeom==="object")copyGeom=copyGeom.ptr;if(copyMesh&&typeof copyMesh==="object")copyMesh=copyMesh.ptr;if(copyGeom===undefined){_emscripten_bind_BRepBuilderAPI_Copy_Perform_1(self,S);return}if(copyMesh===undefined){_emscripten_bind_BRepBuilderAPI_Copy_Perform_2(self,S,copyGeom);return}_emscripten_bind_BRepBuilderAPI_Copy_Perform_3(self,S,copyGeom,copyMesh)};BRepBuilderAPI_Copy.prototype["__destroy__"]=BRepBuilderAPI_Copy.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepBuilderAPI_Copy___destroy___0(self)};function BRepPrimAPI_MakeSphere(Axis,R,angle1,angle2,angle3){if(Axis&&typeof Axis==="object")Axis=Axis.ptr;if(R&&typeof R==="object")R=R.ptr;if(angle1&&typeof angle1==="object")angle1=angle1.ptr;if(angle2&&typeof angle2==="object")angle2=angle2.ptr;if(angle3&&typeof angle3==="object")angle3=angle3.ptr;if(R===undefined){this.ptr=_emscripten_bind_BRepPrimAPI_MakeSphere_BRepPrimAPI_MakeSphere_1(Axis);getCache(BRepPrimAPI_MakeSphere)[this.ptr]=this;return}if(angle1===undefined){this.ptr=_emscripten_bind_BRepPrimAPI_MakeSphere_BRepPrimAPI_MakeSphere_2(Axis,R);getCache(BRepPrimAPI_MakeSphere)[this.ptr]=this;return}if(angle2===undefined){this.ptr=_emscripten_bind_BRepPrimAPI_MakeSphere_BRepPrimAPI_MakeSphere_3(Axis,R,angle1);getCache(BRepPrimAPI_MakeSphere)[this.ptr]=this;return}if(angle3===undefined){this.ptr=_emscripten_bind_BRepPrimAPI_MakeSphere_BRepPrimAPI_MakeSphere_4(Axis,R,angle1,angle2);getCache(BRepPrimAPI_MakeSphere)[this.ptr]=this;return}this.ptr=_emscripten_bind_BRepPrimAPI_MakeSphere_BRepPrimAPI_MakeSphere_5(Axis,R,angle1,angle2,angle3);getCache(BRepPrimAPI_MakeSphere)[this.ptr]=this}BRepPrimAPI_MakeSphere.prototype=Object.create(BRepPrimAPI_MakeOneAxis.prototype);BRepPrimAPI_MakeSphere.prototype.constructor=BRepPrimAPI_MakeSphere;BRepPrimAPI_MakeSphere.prototype.__class__=BRepPrimAPI_MakeSphere;BRepPrimAPI_MakeSphere.__cache__={};Module["BRepPrimAPI_MakeSphere"]=BRepPrimAPI_MakeSphere;BRepPrimAPI_MakeSphere.prototype["Sphere"]=BRepPrimAPI_MakeSphere.prototype.Sphere=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeSphere_Sphere_0(self),BRepPrim_Sphere)};BRepPrimAPI_MakeSphere.prototype["Shape"]=BRepPrimAPI_MakeSphere.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeSphere_Shape_0(self),TopoDS_Shape)};BRepPrimAPI_MakeSphere.prototype["Build"]=BRepPrimAPI_MakeSphere.prototype.Build=function(){var self=this.ptr;_emscripten_bind_BRepPrimAPI_MakeSphere_Build_0(self)};BRepPrimAPI_MakeSphere.prototype["Face"]=BRepPrimAPI_MakeSphere.prototype.Face=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeSphere_Face_0(self),TopoDS_Face)};BRepPrimAPI_MakeSphere.prototype["Shell"]=BRepPrimAPI_MakeSphere.prototype.Shell=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeSphere_Shell_0(self),TopoDS_Shell)};BRepPrimAPI_MakeSphere.prototype["Solid"]=BRepPrimAPI_MakeSphere.prototype.Solid=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeSphere_Solid_0(self),TopoDS_Solid)};BRepPrimAPI_MakeSphere.prototype["__destroy__"]=BRepPrimAPI_MakeSphere.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepPrimAPI_MakeSphere___destroy___0(self)};function Handle_Geom2d_Curve(thePtr){if(thePtr&&typeof thePtr==="object")thePtr=thePtr.ptr;if(thePtr===undefined){this.ptr=_emscripten_bind_Handle_Geom2d_Curve_Handle_Geom2d_Curve_0();getCache(Handle_Geom2d_Curve)[this.ptr]=this;return}this.ptr=_emscripten_bind_Handle_Geom2d_Curve_Handle_Geom2d_Curve_1(thePtr);getCache(Handle_Geom2d_Curve)[this.ptr]=this}Handle_Geom2d_Curve.prototype=Object.create(WrapperObject.prototype);Handle_Geom2d_Curve.prototype.constructor=Handle_Geom2d_Curve;Handle_Geom2d_Curve.prototype.__class__=Handle_Geom2d_Curve;Handle_Geom2d_Curve.__cache__={};Module["Handle_Geom2d_Curve"]=Handle_Geom2d_Curve;Handle_Geom2d_Curve.prototype["IsNull"]=Handle_Geom2d_Curve.prototype.IsNull=function(){var self=this.ptr;return!!_emscripten_bind_Handle_Geom2d_Curve_IsNull_0(self)};Handle_Geom2d_Curve.prototype["Nullify"]=Handle_Geom2d_Curve.prototype.Nullify=function(){var self=this.ptr;_emscripten_bind_Handle_Geom2d_Curve_Nullify_0(self)};Handle_Geom2d_Curve.prototype["get"]=Handle_Geom2d_Curve.prototype.get=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Handle_Geom2d_Curve_get_0(self),Geom2d_Curve)};Handle_Geom2d_Curve.prototype["__destroy__"]=Handle_Geom2d_Curve.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Handle_Geom2d_Curve___destroy___0(self)};function Handle_Geom_BezierCurve(thePtr){if(thePtr&&typeof thePtr==="object")thePtr=thePtr.ptr;if(thePtr===undefined){this.ptr=_emscripten_bind_Handle_Geom_BezierCurve_Handle_Geom_BezierCurve_0();getCache(Handle_Geom_BezierCurve)[this.ptr]=this;return}this.ptr=_emscripten_bind_Handle_Geom_BezierCurve_Handle_Geom_BezierCurve_1(thePtr);getCache(Handle_Geom_BezierCurve)[this.ptr]=this}Handle_Geom_BezierCurve.prototype=Object.create(WrapperObject.prototype);Handle_Geom_BezierCurve.prototype.constructor=Handle_Geom_BezierCurve;Handle_Geom_BezierCurve.prototype.__class__=Handle_Geom_BezierCurve;Handle_Geom_BezierCurve.__cache__={};Module["Handle_Geom_BezierCurve"]=Handle_Geom_BezierCurve;Handle_Geom_BezierCurve.prototype["IsNull"]=Handle_Geom_BezierCurve.prototype.IsNull=function(){var self=this.ptr;return!!_emscripten_bind_Handle_Geom_BezierCurve_IsNull_0(self)};Handle_Geom_BezierCurve.prototype["Nullify"]=Handle_Geom_BezierCurve.prototype.Nullify=function(){var self=this.ptr;_emscripten_bind_Handle_Geom_BezierCurve_Nullify_0(self)};Handle_Geom_BezierCurve.prototype["get"]=Handle_Geom_BezierCurve.prototype.get=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Handle_Geom_BezierCurve_get_0(self),Geom_BezierCurve)};Handle_Geom_BezierCurve.prototype["__destroy__"]=Handle_Geom_BezierCurve.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Handle_Geom_BezierCurve___destroy___0(self)};function TopoDS_Shell(T2){if(T2&&typeof T2==="object")T2=T2.ptr;if(T2===undefined){this.ptr=_emscripten_bind_TopoDS_Shell_TopoDS_Shell_0();getCache(TopoDS_Shell)[this.ptr]=this;return}this.ptr=_emscripten_bind_TopoDS_Shell_TopoDS_Shell_1(T2);getCache(TopoDS_Shell)[this.ptr]=this}TopoDS_Shell.prototype=Object.create(TopoDS_Shape.prototype);TopoDS_Shell.prototype.constructor=TopoDS_Shell;TopoDS_Shell.prototype.__class__=TopoDS_Shell;TopoDS_Shell.__cache__={};Module["TopoDS_Shell"]=TopoDS_Shell;TopoDS_Shell.prototype["IsNull"]=TopoDS_Shell.prototype.IsNull=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Shell_IsNull_0(self)};TopoDS_Shell.prototype["Nullify"]=TopoDS_Shell.prototype.Nullify=function(){var self=this.ptr;_emscripten_bind_TopoDS_Shell_Nullify_0(self)};TopoDS_Shell.prototype["Location"]=TopoDS_Shell.prototype.Location=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_Shell_Location_0(self),TopLoc_Location)};TopoDS_Shell.prototype["Located"]=TopoDS_Shell.prototype.Located=function(theLoc){var self=this.ptr;if(theLoc&&typeof theLoc==="object")theLoc=theLoc.ptr;return wrapPointer(_emscripten_bind_TopoDS_Shell_Located_1(self,theLoc),TopoDS_Shape)};TopoDS_Shell.prototype["Orientation"]=TopoDS_Shell.prototype.Orientation=function(){var self=this.ptr;return _emscripten_bind_TopoDS_Shell_Orientation_0(self)};TopoDS_Shell.prototype["Oriented"]=TopoDS_Shell.prototype.Oriented=function(theOrient){var self=this.ptr;if(theOrient&&typeof theOrient==="object")theOrient=theOrient.ptr;return wrapPointer(_emscripten_bind_TopoDS_Shell_Oriented_1(self,theOrient),TopoDS_Shape)};TopoDS_Shell.prototype["ShapeType"]=TopoDS_Shell.prototype.ShapeType=function(){var self=this.ptr;return _emscripten_bind_TopoDS_Shell_ShapeType_0(self)};TopoDS_Shell.prototype["Free"]=TopoDS_Shell.prototype.Free=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Shell_Free_0(self)};TopoDS_Shell.prototype["Locked"]=TopoDS_Shell.prototype.Locked=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Shell_Locked_0(self)};TopoDS_Shell.prototype["Modified"]=TopoDS_Shell.prototype.Modified=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Shell_Modified_0(self)};TopoDS_Shell.prototype["Checked"]=TopoDS_Shell.prototype.Checked=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Shell_Checked_0(self)};TopoDS_Shell.prototype["Orientable"]=TopoDS_Shell.prototype.Orientable=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Shell_Orientable_0(self)};TopoDS_Shell.prototype["Closed"]=TopoDS_Shell.prototype.Closed=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Shell_Closed_0(self)};TopoDS_Shell.prototype["Infinite"]=TopoDS_Shell.prototype.Infinite=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Shell_Infinite_0(self)};TopoDS_Shell.prototype["Convex"]=TopoDS_Shell.prototype.Convex=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Shell_Convex_0(self)};TopoDS_Shell.prototype["Move"]=TopoDS_Shell.prototype.Move=function(thePosition){var self=this.ptr;if(thePosition&&typeof thePosition==="object")thePosition=thePosition.ptr;_emscripten_bind_TopoDS_Shell_Move_1(self,thePosition)};TopoDS_Shell.prototype["Moved"]=TopoDS_Shell.prototype.Moved=function(thePosition){var self=this.ptr;if(thePosition&&typeof thePosition==="object")thePosition=thePosition.ptr;return wrapPointer(_emscripten_bind_TopoDS_Shell_Moved_1(self,thePosition),TopoDS_Shape)};TopoDS_Shell.prototype["Reverse"]=TopoDS_Shell.prototype.Reverse=function(){var self=this.ptr;_emscripten_bind_TopoDS_Shell_Reverse_0(self)};TopoDS_Shell.prototype["Reversed"]=TopoDS_Shell.prototype.Reversed=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_Shell_Reversed_0(self),TopoDS_Shape)};TopoDS_Shell.prototype["Complement"]=TopoDS_Shell.prototype.Complement=function(){var self=this.ptr;_emscripten_bind_TopoDS_Shell_Complement_0(self)};TopoDS_Shell.prototype["Complemented"]=TopoDS_Shell.prototype.Complemented=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_Shell_Complemented_0(self),TopoDS_Shape)};TopoDS_Shell.prototype["Compose"]=TopoDS_Shell.prototype.Compose=function(theOrient){var self=this.ptr;if(theOrient&&typeof theOrient==="object")theOrient=theOrient.ptr;_emscripten_bind_TopoDS_Shell_Compose_1(self,theOrient)};TopoDS_Shell.prototype["Composed"]=TopoDS_Shell.prototype.Composed=function(theOrient){var self=this.ptr;if(theOrient&&typeof theOrient==="object")theOrient=theOrient.ptr;return wrapPointer(_emscripten_bind_TopoDS_Shell_Composed_1(self,theOrient),TopoDS_Shape)};TopoDS_Shell.prototype["NbChildren"]=TopoDS_Shell.prototype.NbChildren=function(){var self=this.ptr;return _emscripten_bind_TopoDS_Shell_NbChildren_0(self)};TopoDS_Shell.prototype["IsPartner"]=TopoDS_Shell.prototype.IsPartner=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_Shell_IsPartner_1(self,theOther)};TopoDS_Shell.prototype["IsSame"]=TopoDS_Shell.prototype.IsSame=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_Shell_IsSame_1(self,theOther)};TopoDS_Shell.prototype["IsEqual"]=TopoDS_Shell.prototype.IsEqual=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_Shell_IsEqual_1(self,theOther)};TopoDS_Shell.prototype["IsNotEqual"]=TopoDS_Shell.prototype.IsNotEqual=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_Shell_IsNotEqual_1(self,theOther)};TopoDS_Shell.prototype["HashCode"]=TopoDS_Shell.prototype.HashCode=function(theUpperBound){var self=this.ptr;if(theUpperBound&&typeof theUpperBound==="object")theUpperBound=theUpperBound.ptr;return _emscripten_bind_TopoDS_Shell_HashCode_1(self,theUpperBound)};TopoDS_Shell.prototype["EmptyCopy"]=TopoDS_Shell.prototype.EmptyCopy=function(){var self=this.ptr;_emscripten_bind_TopoDS_Shell_EmptyCopy_0(self)};TopoDS_Shell.prototype["EmptyCopied"]=TopoDS_Shell.prototype.EmptyCopied=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_Shell_EmptyCopied_0(self),TopoDS_Shape)};TopoDS_Shell.prototype["__destroy__"]=TopoDS_Shell.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_TopoDS_Shell___destroy___0(self)};function Handle_Poly_PolygonOnTriangulation(thePtr){if(thePtr&&typeof thePtr==="object")thePtr=thePtr.ptr;if(thePtr===undefined){this.ptr=_emscripten_bind_Handle_Poly_PolygonOnTriangulation_Handle_Poly_PolygonOnTriangulation_0();getCache(Handle_Poly_PolygonOnTriangulation)[this.ptr]=this;return}this.ptr=_emscripten_bind_Handle_Poly_PolygonOnTriangulation_Handle_Poly_PolygonOnTriangulation_1(thePtr);getCache(Handle_Poly_PolygonOnTriangulation)[this.ptr]=this}Handle_Poly_PolygonOnTriangulation.prototype=Object.create(WrapperObject.prototype);Handle_Poly_PolygonOnTriangulation.prototype.constructor=Handle_Poly_PolygonOnTriangulation;Handle_Poly_PolygonOnTriangulation.prototype.__class__=Handle_Poly_PolygonOnTriangulation;Handle_Poly_PolygonOnTriangulation.__cache__={};Module["Handle_Poly_PolygonOnTriangulation"]=Handle_Poly_PolygonOnTriangulation;Handle_Poly_PolygonOnTriangulation.prototype["IsNull"]=Handle_Poly_PolygonOnTriangulation.prototype.IsNull=function(){var self=this.ptr;return!!_emscripten_bind_Handle_Poly_PolygonOnTriangulation_IsNull_0(self)};Handle_Poly_PolygonOnTriangulation.prototype["Nullify"]=Handle_Poly_PolygonOnTriangulation.prototype.Nullify=function(){var self=this.ptr;_emscripten_bind_Handle_Poly_PolygonOnTriangulation_Nullify_0(self)};Handle_Poly_PolygonOnTriangulation.prototype["get"]=Handle_Poly_PolygonOnTriangulation.prototype.get=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Handle_Poly_PolygonOnTriangulation_get_0(self),Poly_PolygonOnTriangulation)};Handle_Poly_PolygonOnTriangulation.prototype["__destroy__"]=Handle_Poly_PolygonOnTriangulation.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Handle_Poly_PolygonOnTriangulation___destroy___0(self)};function VoidPtr(){throw"cannot construct a VoidPtr, no constructor in IDL"}VoidPtr.prototype=Object.create(WrapperObject.prototype);VoidPtr.prototype.constructor=VoidPtr;VoidPtr.prototype.__class__=VoidPtr;VoidPtr.__cache__={};Module["VoidPtr"]=VoidPtr;VoidPtr.prototype["__destroy__"]=VoidPtr.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_VoidPtr___destroy___0(self)};function BRepFilletAPI_MakeFillet2d(F){if(F&&typeof F==="object")F=F.ptr;this.ptr=_emscripten_bind_BRepFilletAPI_MakeFillet2d_BRepFilletAPI_MakeFillet2d_1(F);getCache(BRepFilletAPI_MakeFillet2d)[this.ptr]=this}BRepFilletAPI_MakeFillet2d.prototype=Object.create(BRepBuilderAPI_MakeShape.prototype);BRepFilletAPI_MakeFillet2d.prototype.constructor=BRepFilletAPI_MakeFillet2d;BRepFilletAPI_MakeFillet2d.prototype.__class__=BRepFilletAPI_MakeFillet2d;BRepFilletAPI_MakeFillet2d.__cache__={};Module["BRepFilletAPI_MakeFillet2d"]=BRepFilletAPI_MakeFillet2d;BRepFilletAPI_MakeFillet2d.prototype["AddFillet"]=BRepFilletAPI_MakeFillet2d.prototype.AddFillet=function(V,Radius){var self=this.ptr;if(V&&typeof V==="object")V=V.ptr;if(Radius&&typeof Radius==="object")Radius=Radius.ptr;_emscripten_bind_BRepFilletAPI_MakeFillet2d_AddFillet_2(self,V,Radius)};BRepFilletAPI_MakeFillet2d.prototype["Status"]=BRepFilletAPI_MakeFillet2d.prototype.Status=function(){var self=this.ptr;return _emscripten_bind_BRepFilletAPI_MakeFillet2d_Status_0(self)};BRepFilletAPI_MakeFillet2d.prototype["Shape"]=BRepFilletAPI_MakeFillet2d.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepFilletAPI_MakeFillet2d_Shape_0(self),TopoDS_Shape)};BRepFilletAPI_MakeFillet2d.prototype["__destroy__"]=BRepFilletAPI_MakeFillet2d.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepFilletAPI_MakeFillet2d___destroy___0(self)};function BRepPrimAPI_MakeHalfSpace(Shell,RefPnt){if(Shell&&typeof Shell==="object")Shell=Shell.ptr;if(RefPnt&&typeof RefPnt==="object")RefPnt=RefPnt.ptr;this.ptr=_emscripten_bind_BRepPrimAPI_MakeHalfSpace_BRepPrimAPI_MakeHalfSpace_2(Shell,RefPnt);getCache(BRepPrimAPI_MakeHalfSpace)[this.ptr]=this}BRepPrimAPI_MakeHalfSpace.prototype=Object.create(BRepBuilderAPI_MakeShape.prototype);BRepPrimAPI_MakeHalfSpace.prototype.constructor=BRepPrimAPI_MakeHalfSpace;BRepPrimAPI_MakeHalfSpace.prototype.__class__=BRepPrimAPI_MakeHalfSpace;BRepPrimAPI_MakeHalfSpace.__cache__={};Module["BRepPrimAPI_MakeHalfSpace"]=BRepPrimAPI_MakeHalfSpace;BRepPrimAPI_MakeHalfSpace.prototype["Solid"]=BRepPrimAPI_MakeHalfSpace.prototype.Solid=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeHalfSpace_Solid_0(self),TopoDS_Solid)};BRepPrimAPI_MakeHalfSpace.prototype["Shape"]=BRepPrimAPI_MakeHalfSpace.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeHalfSpace_Shape_0(self),TopoDS_Shape)};BRepPrimAPI_MakeHalfSpace.prototype["IsDeleted"]=BRepPrimAPI_MakeHalfSpace.prototype.IsDeleted=function(S){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;return!!_emscripten_bind_BRepPrimAPI_MakeHalfSpace_IsDeleted_1(self,S)};BRepPrimAPI_MakeHalfSpace.prototype["__destroy__"]=BRepPrimAPI_MakeHalfSpace.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepPrimAPI_MakeHalfSpace___destroy___0(self)};function Poly_Triangle(N1,N2,N3){if(N1&&typeof N1==="object")N1=N1.ptr;if(N2&&typeof N2==="object")N2=N2.ptr;if(N3&&typeof N3==="object")N3=N3.ptr;if(N1===undefined){this.ptr=_emscripten_bind_Poly_Triangle_Poly_Triangle_0();getCache(Poly_Triangle)[this.ptr]=this;return}if(N2===undefined){this.ptr=_emscripten_bind_Poly_Triangle_Poly_Triangle_1(N1);getCache(Poly_Triangle)[this.ptr]=this;return}if(N3===undefined){this.ptr=_emscripten_bind_Poly_Triangle_Poly_Triangle_2(N1,N2);getCache(Poly_Triangle)[this.ptr]=this;return}this.ptr=_emscripten_bind_Poly_Triangle_Poly_Triangle_3(N1,N2,N3);getCache(Poly_Triangle)[this.ptr]=this}Poly_Triangle.prototype=Object.create(WrapperObject.prototype);Poly_Triangle.prototype.constructor=Poly_Triangle;Poly_Triangle.prototype.__class__=Poly_Triangle;Poly_Triangle.__cache__={};Module["Poly_Triangle"]=Poly_Triangle;Poly_Triangle.prototype["Set"]=Poly_Triangle.prototype.Set=function(N1,N2,N3){var self=this.ptr;if(N1&&typeof N1==="object")N1=N1.ptr;if(N2&&typeof N2==="object")N2=N2.ptr;if(N3&&typeof N3==="object")N3=N3.ptr;if(N3===undefined){_emscripten_bind_Poly_Triangle_Set_2(self,N1,N2);return}_emscripten_bind_Poly_Triangle_Set_3(self,N1,N2,N3)};Poly_Triangle.prototype["Value"]=Poly_Triangle.prototype.Value=function(Index){var self=this.ptr;if(Index&&typeof Index==="object")Index=Index.ptr;return _emscripten_bind_Poly_Triangle_Value_1(self,Index)};Poly_Triangle.prototype["ChangeValue"]=Poly_Triangle.prototype.ChangeValue=function(Index){var self=this.ptr;if(Index&&typeof Index==="object")Index=Index.ptr;return _emscripten_bind_Poly_Triangle_ChangeValue_1(self,Index)};Poly_Triangle.prototype["__destroy__"]=Poly_Triangle.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Poly_Triangle___destroy___0(self)};function gp_Dir(Xv,Yv,Zv){if(Xv&&typeof Xv==="object")Xv=Xv.ptr;if(Yv&&typeof Yv==="object")Yv=Yv.ptr;if(Zv&&typeof Zv==="object")Zv=Zv.ptr;if(Xv===undefined){this.ptr=_emscripten_bind_gp_Dir_gp_Dir_0();getCache(gp_Dir)[this.ptr]=this;return}if(Yv===undefined){this.ptr=_emscripten_bind_gp_Dir_gp_Dir_1(Xv);getCache(gp_Dir)[this.ptr]=this;return}if(Zv===undefined){this.ptr=_emscripten_bind_gp_Dir_gp_Dir_2(Xv,Yv);getCache(gp_Dir)[this.ptr]=this;return}this.ptr=_emscripten_bind_gp_Dir_gp_Dir_3(Xv,Yv,Zv);getCache(gp_Dir)[this.ptr]=this}gp_Dir.prototype=Object.create(WrapperObject.prototype);gp_Dir.prototype.constructor=gp_Dir;gp_Dir.prototype.__class__=gp_Dir;gp_Dir.__cache__={};Module["gp_Dir"]=gp_Dir;gp_Dir.prototype["SetCoord"]=gp_Dir.prototype.SetCoord=function(Xv,Yv,Zv){var self=this.ptr;if(Xv&&typeof Xv==="object")Xv=Xv.ptr;if(Yv&&typeof Yv==="object")Yv=Yv.ptr;if(Zv&&typeof Zv==="object")Zv=Zv.ptr;if(Zv===undefined){_emscripten_bind_gp_Dir_SetCoord_2(self,Xv,Yv);return}_emscripten_bind_gp_Dir_SetCoord_3(self,Xv,Yv,Zv)};gp_Dir.prototype["SetX"]=gp_Dir.prototype.SetX=function(X){var self=this.ptr;if(X&&typeof X==="object")X=X.ptr;_emscripten_bind_gp_Dir_SetX_1(self,X)};gp_Dir.prototype["SetY"]=gp_Dir.prototype.SetY=function(Y){var self=this.ptr;if(Y&&typeof Y==="object")Y=Y.ptr;_emscripten_bind_gp_Dir_SetY_1(self,Y)};gp_Dir.prototype["SetZ"]=gp_Dir.prototype.SetZ=function(Z){var self=this.ptr;if(Z&&typeof Z==="object")Z=Z.ptr;_emscripten_bind_gp_Dir_SetZ_1(self,Z)};gp_Dir.prototype["Coord"]=gp_Dir.prototype.Coord=function(Index){var self=this.ptr;if(Index&&typeof Index==="object")Index=Index.ptr;return _emscripten_bind_gp_Dir_Coord_1(self,Index)};gp_Dir.prototype["X"]=gp_Dir.prototype.X=function(){var self=this.ptr;return _emscripten_bind_gp_Dir_X_0(self)};gp_Dir.prototype["Y"]=gp_Dir.prototype.Y=function(){var self=this.ptr;return _emscripten_bind_gp_Dir_Y_0(self)};gp_Dir.prototype["Z"]=gp_Dir.prototype.Z=function(){var self=this.ptr;return _emscripten_bind_gp_Dir_Z_0(self)};gp_Dir.prototype["IsEqual"]=gp_Dir.prototype.IsEqual=function(Other,AngularTolerance){var self=this.ptr;if(Other&&typeof Other==="object")Other=Other.ptr;if(AngularTolerance&&typeof AngularTolerance==="object")AngularTolerance=AngularTolerance.ptr;return!!_emscripten_bind_gp_Dir_IsEqual_2(self,Other,AngularTolerance)};gp_Dir.prototype["IsNormal"]=gp_Dir.prototype.IsNormal=function(Other,AngularTolerance){var self=this.ptr;if(Other&&typeof Other==="object")Other=Other.ptr;if(AngularTolerance&&typeof AngularTolerance==="object")AngularTolerance=AngularTolerance.ptr;return!!_emscripten_bind_gp_Dir_IsNormal_2(self,Other,AngularTolerance)};gp_Dir.prototype["IsOpposite"]=gp_Dir.prototype.IsOpposite=function(Other,AngularTolerance){var self=this.ptr;if(Other&&typeof Other==="object")Other=Other.ptr;if(AngularTolerance&&typeof AngularTolerance==="object")AngularTolerance=AngularTolerance.ptr;return!!_emscripten_bind_gp_Dir_IsOpposite_2(self,Other,AngularTolerance)};gp_Dir.prototype["IsParallel"]=gp_Dir.prototype.IsParallel=function(Other,AngularTolerance){var self=this.ptr;if(Other&&typeof Other==="object")Other=Other.ptr;if(AngularTolerance&&typeof AngularTolerance==="object")AngularTolerance=AngularTolerance.ptr;return!!_emscripten_bind_gp_Dir_IsParallel_2(self,Other,AngularTolerance)};gp_Dir.prototype["Angle"]=gp_Dir.prototype.Angle=function(Other){var self=this.ptr;if(Other&&typeof Other==="object")Other=Other.ptr;return _emscripten_bind_gp_Dir_Angle_1(self,Other)};gp_Dir.prototype["AngleWithRef"]=gp_Dir.prototype.AngleWithRef=function(Other,VRef){var self=this.ptr;if(Other&&typeof Other==="object")Other=Other.ptr;if(VRef&&typeof VRef==="object")VRef=VRef.ptr;return _emscripten_bind_gp_Dir_AngleWithRef_2(self,Other,VRef)};gp_Dir.prototype["Cross"]=gp_Dir.prototype.Cross=function(Right){var self=this.ptr;if(Right&&typeof Right==="object")Right=Right.ptr;_emscripten_bind_gp_Dir_Cross_1(self,Right)};gp_Dir.prototype["Crossed"]=gp_Dir.prototype.Crossed=function(Right){var self=this.ptr;if(Right&&typeof Right==="object")Right=Right.ptr;return wrapPointer(_emscripten_bind_gp_Dir_Crossed_1(self,Right),gp_Dir)};gp_Dir.prototype["CrossCross"]=gp_Dir.prototype.CrossCross=function(V1,V2){var self=this.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;if(V2&&typeof V2==="object")V2=V2.ptr;_emscripten_bind_gp_Dir_CrossCross_2(self,V1,V2)};gp_Dir.prototype["CrossCrossed"]=gp_Dir.prototype.CrossCrossed=function(V1,V2){var self=this.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;if(V2&&typeof V2==="object")V2=V2.ptr;return wrapPointer(_emscripten_bind_gp_Dir_CrossCrossed_2(self,V1,V2),gp_Dir)};gp_Dir.prototype["Dot"]=gp_Dir.prototype.Dot=function(Other){var self=this.ptr;if(Other&&typeof Other==="object")Other=Other.ptr;return _emscripten_bind_gp_Dir_Dot_1(self,Other)};gp_Dir.prototype["DotCross"]=gp_Dir.prototype.DotCross=function(V1,V2){var self=this.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;if(V2&&typeof V2==="object")V2=V2.ptr;return _emscripten_bind_gp_Dir_DotCross_2(self,V1,V2)};gp_Dir.prototype["Reversed"]=gp_Dir.prototype.Reversed=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_gp_Dir_Reversed_0(self),gp_Dir)};gp_Dir.prototype["Mirror"]=gp_Dir.prototype.Mirror=function(V){var self=this.ptr;if(V&&typeof V==="object")V=V.ptr;_emscripten_bind_gp_Dir_Mirror_1(self,V)};gp_Dir.prototype["Mirrored"]=gp_Dir.prototype.Mirrored=function(V){var self=this.ptr;if(V&&typeof V==="object")V=V.ptr;return wrapPointer(_emscripten_bind_gp_Dir_Mirrored_1(self,V),gp_Dir)};gp_Dir.prototype["Rotate"]=gp_Dir.prototype.Rotate=function(A1,Ang){var self=this.ptr;if(A1&&typeof A1==="object")A1=A1.ptr;if(Ang&&typeof Ang==="object")Ang=Ang.ptr;_emscripten_bind_gp_Dir_Rotate_2(self,A1,Ang)};gp_Dir.prototype["Rotated"]=gp_Dir.prototype.Rotated=function(A1,Ang){var self=this.ptr;if(A1&&typeof A1==="object")A1=A1.ptr;if(Ang&&typeof Ang==="object")Ang=Ang.ptr;return wrapPointer(_emscripten_bind_gp_Dir_Rotated_2(self,A1,Ang),gp_Dir)};gp_Dir.prototype["Transform"]=gp_Dir.prototype.Transform=function(T){var self=this.ptr;if(T&&typeof T==="object")T=T.ptr;_emscripten_bind_gp_Dir_Transform_1(self,T)};gp_Dir.prototype["Transformed"]=gp_Dir.prototype.Transformed=function(T){var self=this.ptr;if(T&&typeof T==="object")T=T.ptr;return wrapPointer(_emscripten_bind_gp_Dir_Transformed_1(self,T),gp_Dir)};gp_Dir.prototype["__destroy__"]=gp_Dir.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_gp_Dir___destroy___0(self)};function GC_MakeSegment(Line,U1,U2){if(Line&&typeof Line==="object")Line=Line.ptr;if(U1&&typeof U1==="object")U1=U1.ptr;if(U2&&typeof U2==="object")U2=U2.ptr;if(U2===undefined){this.ptr=_emscripten_bind_GC_MakeSegment_GC_MakeSegment_2(Line,U1);getCache(GC_MakeSegment)[this.ptr]=this;return}this.ptr=_emscripten_bind_GC_MakeSegment_GC_MakeSegment_3(Line,U1,U2);getCache(GC_MakeSegment)[this.ptr]=this}GC_MakeSegment.prototype=Object.create(WrapperObject.prototype);GC_MakeSegment.prototype.constructor=GC_MakeSegment;GC_MakeSegment.prototype.__class__=GC_MakeSegment;GC_MakeSegment.__cache__={};Module["GC_MakeSegment"]=GC_MakeSegment;GC_MakeSegment.prototype["Value"]=GC_MakeSegment.prototype.Value=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_GC_MakeSegment_Value_0(self),Handle_Geom_TrimmedCurve)};GC_MakeSegment.prototype["__destroy__"]=GC_MakeSegment.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_GC_MakeSegment___destroy___0(self)};function Bnd_Box(theMin,theMax){if(theMin&&typeof theMin==="object")theMin=theMin.ptr;if(theMax&&typeof theMax==="object")theMax=theMax.ptr;if(theMin===undefined){this.ptr=_emscripten_bind_Bnd_Box_Bnd_Box_0();getCache(Bnd_Box)[this.ptr]=this;return}if(theMax===undefined){this.ptr=_emscripten_bind_Bnd_Box_Bnd_Box_1(theMin);getCache(Bnd_Box)[this.ptr]=this;return}this.ptr=_emscripten_bind_Bnd_Box_Bnd_Box_2(theMin,theMax);getCache(Bnd_Box)[this.ptr]=this}Bnd_Box.prototype=Object.create(WrapperObject.prototype);Bnd_Box.prototype.constructor=Bnd_Box;Bnd_Box.prototype.__class__=Bnd_Box;Bnd_Box.__cache__={};Module["Bnd_Box"]=Bnd_Box;Bnd_Box.prototype["SetWhole"]=Bnd_Box.prototype.SetWhole=function(){var self=this.ptr;_emscripten_bind_Bnd_Box_SetWhole_0(self)};Bnd_Box.prototype["SetVoid"]=Bnd_Box.prototype.SetVoid=function(){var self=this.ptr;_emscripten_bind_Bnd_Box_SetVoid_0(self)};Bnd_Box.prototype["Set"]=Bnd_Box.prototype.Set=function(P,D){var self=this.ptr;if(P&&typeof P==="object")P=P.ptr;if(D&&typeof D==="object")D=D.ptr;if(D===undefined){_emscripten_bind_Bnd_Box_Set_1(self,P);return}_emscripten_bind_Bnd_Box_Set_2(self,P,D)};Bnd_Box.prototype["Update"]=Bnd_Box.prototype.Update=function(aXMin,aYMin,aZMin,aXMax,aYMax,aZMax){var self=this.ptr;if(aXMin&&typeof aXMin==="object")aXMin=aXMin.ptr;if(aYMin&&typeof aYMin==="object")aYMin=aYMin.ptr;if(aZMin&&typeof aZMin==="object")aZMin=aZMin.ptr;if(aXMax&&typeof aXMax==="object")aXMax=aXMax.ptr;if(aYMax&&typeof aYMax==="object")aYMax=aYMax.ptr;if(aZMax&&typeof aZMax==="object")aZMax=aZMax.ptr;if(aXMax===undefined){_emscripten_bind_Bnd_Box_Update_3(self,aXMin,aYMin,aZMin);return}if(aYMax===undefined){_emscripten_bind_Bnd_Box_Update_4(self,aXMin,aYMin,aZMin,aXMax);return}if(aZMax===undefined){_emscripten_bind_Bnd_Box_Update_5(self,aXMin,aYMin,aZMin,aXMax,aYMax);return}_emscripten_bind_Bnd_Box_Update_6(self,aXMin,aYMin,aZMin,aXMax,aYMax,aZMax)};Bnd_Box.prototype["GetGap"]=Bnd_Box.prototype.GetGap=function(){var self=this.ptr;return _emscripten_bind_Bnd_Box_GetGap_0(self)};Bnd_Box.prototype["SetGap"]=Bnd_Box.prototype.SetGap=function(Tol){var self=this.ptr;if(Tol&&typeof Tol==="object")Tol=Tol.ptr;_emscripten_bind_Bnd_Box_SetGap_1(self,Tol)};Bnd_Box.prototype["Enlarge"]=Bnd_Box.prototype.Enlarge=function(Tol){var self=this.ptr;if(Tol&&typeof Tol==="object")Tol=Tol.ptr;_emscripten_bind_Bnd_Box_Enlarge_1(self,Tol)};Bnd_Box.prototype["GetXmin"]=Bnd_Box.prototype.GetXmin=function(){var self=this.ptr;return _emscripten_bind_Bnd_Box_GetXmin_0(self)};Bnd_Box.prototype["GetXmax"]=Bnd_Box.prototype.GetXmax=function(){var self=this.ptr;return _emscripten_bind_Bnd_Box_GetXmax_0(self)};Bnd_Box.prototype["GetYmin"]=Bnd_Box.prototype.GetYmin=function(){var self=this.ptr;return _emscripten_bind_Bnd_Box_GetYmin_0(self)};Bnd_Box.prototype["GetYmax"]=Bnd_Box.prototype.GetYmax=function(){var self=this.ptr;return _emscripten_bind_Bnd_Box_GetYmax_0(self)};Bnd_Box.prototype["GetZmin"]=Bnd_Box.prototype.GetZmin=function(){var self=this.ptr;return _emscripten_bind_Bnd_Box_GetZmin_0(self)};Bnd_Box.prototype["GetZmax"]=Bnd_Box.prototype.GetZmax=function(){var self=this.ptr;return _emscripten_bind_Bnd_Box_GetZmax_0(self)};Bnd_Box.prototype["CornerMin"]=Bnd_Box.prototype.CornerMin=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Bnd_Box_CornerMin_0(self),gp_Pnt)};Bnd_Box.prototype["CornerMax"]=Bnd_Box.prototype.CornerMax=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Bnd_Box_CornerMax_0(self),gp_Pnt)};Bnd_Box.prototype["OpenXmin"]=Bnd_Box.prototype.OpenXmin=function(){var self=this.ptr;_emscripten_bind_Bnd_Box_OpenXmin_0(self)};Bnd_Box.prototype["OpenXmax"]=Bnd_Box.prototype.OpenXmax=function(){var self=this.ptr;_emscripten_bind_Bnd_Box_OpenXmax_0(self)};Bnd_Box.prototype["OpenYmin"]=Bnd_Box.prototype.OpenYmin=function(){var self=this.ptr;_emscripten_bind_Bnd_Box_OpenYmin_0(self)};Bnd_Box.prototype["OpenYmax"]=Bnd_Box.prototype.OpenYmax=function(){var self=this.ptr;_emscripten_bind_Bnd_Box_OpenYmax_0(self)};Bnd_Box.prototype["OpenZmin"]=Bnd_Box.prototype.OpenZmin=function(){var self=this.ptr;_emscripten_bind_Bnd_Box_OpenZmin_0(self)};Bnd_Box.prototype["OpenZmax"]=Bnd_Box.prototype.OpenZmax=function(){var self=this.ptr;_emscripten_bind_Bnd_Box_OpenZmax_0(self)};Bnd_Box.prototype["IsOpen"]=Bnd_Box.prototype.IsOpen=function(){var self=this.ptr;return!!_emscripten_bind_Bnd_Box_IsOpen_0(self)};Bnd_Box.prototype["IsOpenXmin"]=Bnd_Box.prototype.IsOpenXmin=function(){var self=this.ptr;return!!_emscripten_bind_Bnd_Box_IsOpenXmin_0(self)};Bnd_Box.prototype["IsOpenXmax"]=Bnd_Box.prototype.IsOpenXmax=function(){var self=this.ptr;return!!_emscripten_bind_Bnd_Box_IsOpenXmax_0(self)};Bnd_Box.prototype["IsOpenYmin"]=Bnd_Box.prototype.IsOpenYmin=function(){var self=this.ptr;return!!_emscripten_bind_Bnd_Box_IsOpenYmin_0(self)};Bnd_Box.prototype["IsOpenYmax"]=Bnd_Box.prototype.IsOpenYmax=function(){var self=this.ptr;return!!_emscripten_bind_Bnd_Box_IsOpenYmax_0(self)};Bnd_Box.prototype["IsOpenZmin"]=Bnd_Box.prototype.IsOpenZmin=function(){var self=this.ptr;return!!_emscripten_bind_Bnd_Box_IsOpenZmin_0(self)};Bnd_Box.prototype["IsOpenZmax"]=Bnd_Box.prototype.IsOpenZmax=function(){var self=this.ptr;return!!_emscripten_bind_Bnd_Box_IsOpenZmax_0(self)};Bnd_Box.prototype["IsWhole"]=Bnd_Box.prototype.IsWhole=function(){var self=this.ptr;return!!_emscripten_bind_Bnd_Box_IsWhole_0(self)};Bnd_Box.prototype["IsVoid"]=Bnd_Box.prototype.IsVoid=function(){var self=this.ptr;return!!_emscripten_bind_Bnd_Box_IsVoid_0(self)};Bnd_Box.prototype["IsXThin"]=Bnd_Box.prototype.IsXThin=function(tol){var self=this.ptr;if(tol&&typeof tol==="object")tol=tol.ptr;return!!_emscripten_bind_Bnd_Box_IsXThin_1(self,tol)};Bnd_Box.prototype["IsYThin"]=Bnd_Box.prototype.IsYThin=function(tol){var self=this.ptr;if(tol&&typeof tol==="object")tol=tol.ptr;return!!_emscripten_bind_Bnd_Box_IsYThin_1(self,tol)};Bnd_Box.prototype["IsZThin"]=Bnd_Box.prototype.IsZThin=function(tol){var self=this.ptr;if(tol&&typeof tol==="object")tol=tol.ptr;return!!_emscripten_bind_Bnd_Box_IsZThin_1(self,tol)};Bnd_Box.prototype["IsThin"]=Bnd_Box.prototype.IsThin=function(tol){var self=this.ptr;if(tol&&typeof tol==="object")tol=tol.ptr;return!!_emscripten_bind_Bnd_Box_IsThin_1(self,tol)};Bnd_Box.prototype["Transformed"]=Bnd_Box.prototype.Transformed=function(T){var self=this.ptr;if(T&&typeof T==="object")T=T.ptr;return wrapPointer(_emscripten_bind_Bnd_Box_Transformed_1(self,T),Bnd_Box)};Bnd_Box.prototype["Add"]=Bnd_Box.prototype.Add=function(P,D){var self=this.ptr;if(P&&typeof P==="object")P=P.ptr;if(D&&typeof D==="object")D=D.ptr;if(D===undefined){_emscripten_bind_Bnd_Box_Add_1(self,P);return}_emscripten_bind_Bnd_Box_Add_2(self,P,D)};Bnd_Box.prototype["IsOut"]=Bnd_Box.prototype.IsOut=function(T1,Other,T2){var self=this.ptr;if(T1&&typeof T1==="object")T1=T1.ptr;if(Other&&typeof Other==="object")Other=Other.ptr;if(T2&&typeof T2==="object")T2=T2.ptr;if(Other===undefined){return!!_emscripten_bind_Bnd_Box_IsOut_1(self,T1)}if(T2===undefined){return!!_emscripten_bind_Bnd_Box_IsOut_2(self,T1,Other)}return!!_emscripten_bind_Bnd_Box_IsOut_3(self,T1,Other,T2)};Bnd_Box.prototype["Distance"]=Bnd_Box.prototype.Distance=function(Other){var self=this.ptr;if(Other&&typeof Other==="object")Other=Other.ptr;return _emscripten_bind_Bnd_Box_Distance_1(self,Other)};Bnd_Box.prototype["Dump"]=Bnd_Box.prototype.Dump=function(){var self=this.ptr;_emscripten_bind_Bnd_Box_Dump_0(self)};Bnd_Box.prototype["SquareExtent"]=Bnd_Box.prototype.SquareExtent=function(){var self=this.ptr;return _emscripten_bind_Bnd_Box_SquareExtent_0(self)};Bnd_Box.prototype["FinitePart"]=Bnd_Box.prototype.FinitePart=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Bnd_Box_FinitePart_0(self),Bnd_Box)};Bnd_Box.prototype["HasFinitePart"]=Bnd_Box.prototype.HasFinitePart=function(){var self=this.ptr;return!!_emscripten_bind_Bnd_Box_HasFinitePart_0(self)};Bnd_Box.prototype["__destroy__"]=Bnd_Box.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Bnd_Box___destroy___0(self)};function StlAPI_Reader(){this.ptr=_emscripten_bind_StlAPI_Reader_StlAPI_Reader_0();getCache(StlAPI_Reader)[this.ptr]=this}StlAPI_Reader.prototype=Object.create(WrapperObject.prototype);StlAPI_Reader.prototype.constructor=StlAPI_Reader;StlAPI_Reader.prototype.__class__=StlAPI_Reader;StlAPI_Reader.__cache__={};Module["StlAPI_Reader"]=StlAPI_Reader;StlAPI_Reader.prototype["Read"]=StlAPI_Reader.prototype.Read=function(theShape,theFileName){var self=this.ptr;ensureCache.prepare();if(theShape&&typeof theShape==="object")theShape=theShape.ptr;if(theFileName&&typeof theFileName==="object")theFileName=theFileName.ptr;else theFileName=ensureString(theFileName);return!!_emscripten_bind_StlAPI_Reader_Read_2(self,theShape,theFileName)};StlAPI_Reader.prototype["__destroy__"]=StlAPI_Reader.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_StlAPI_Reader___destroy___0(self)};function TopoDS_Solid(T2){if(T2&&typeof T2==="object")T2=T2.ptr;if(T2===undefined){this.ptr=_emscripten_bind_TopoDS_Solid_TopoDS_Solid_0();getCache(TopoDS_Solid)[this.ptr]=this;return}this.ptr=_emscripten_bind_TopoDS_Solid_TopoDS_Solid_1(T2);getCache(TopoDS_Solid)[this.ptr]=this}TopoDS_Solid.prototype=Object.create(TopoDS_Shape.prototype);TopoDS_Solid.prototype.constructor=TopoDS_Solid;TopoDS_Solid.prototype.__class__=TopoDS_Solid;TopoDS_Solid.__cache__={};Module["TopoDS_Solid"]=TopoDS_Solid;TopoDS_Solid.prototype["IsNull"]=TopoDS_Solid.prototype.IsNull=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Solid_IsNull_0(self)};TopoDS_Solid.prototype["Nullify"]=TopoDS_Solid.prototype.Nullify=function(){var self=this.ptr;_emscripten_bind_TopoDS_Solid_Nullify_0(self)};TopoDS_Solid.prototype["Location"]=TopoDS_Solid.prototype.Location=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_Solid_Location_0(self),TopLoc_Location)};TopoDS_Solid.prototype["Located"]=TopoDS_Solid.prototype.Located=function(theLoc){var self=this.ptr;if(theLoc&&typeof theLoc==="object")theLoc=theLoc.ptr;return wrapPointer(_emscripten_bind_TopoDS_Solid_Located_1(self,theLoc),TopoDS_Shape)};TopoDS_Solid.prototype["Orientation"]=TopoDS_Solid.prototype.Orientation=function(){var self=this.ptr;return _emscripten_bind_TopoDS_Solid_Orientation_0(self)};TopoDS_Solid.prototype["Oriented"]=TopoDS_Solid.prototype.Oriented=function(theOrient){var self=this.ptr;if(theOrient&&typeof theOrient==="object")theOrient=theOrient.ptr;return wrapPointer(_emscripten_bind_TopoDS_Solid_Oriented_1(self,theOrient),TopoDS_Shape)};TopoDS_Solid.prototype["ShapeType"]=TopoDS_Solid.prototype.ShapeType=function(){var self=this.ptr;return _emscripten_bind_TopoDS_Solid_ShapeType_0(self)};TopoDS_Solid.prototype["Free"]=TopoDS_Solid.prototype.Free=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Solid_Free_0(self)};TopoDS_Solid.prototype["Locked"]=TopoDS_Solid.prototype.Locked=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Solid_Locked_0(self)};TopoDS_Solid.prototype["Modified"]=TopoDS_Solid.prototype.Modified=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Solid_Modified_0(self)};TopoDS_Solid.prototype["Checked"]=TopoDS_Solid.prototype.Checked=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Solid_Checked_0(self)};TopoDS_Solid.prototype["Orientable"]=TopoDS_Solid.prototype.Orientable=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Solid_Orientable_0(self)};TopoDS_Solid.prototype["Closed"]=TopoDS_Solid.prototype.Closed=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Solid_Closed_0(self)};TopoDS_Solid.prototype["Infinite"]=TopoDS_Solid.prototype.Infinite=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Solid_Infinite_0(self)};TopoDS_Solid.prototype["Convex"]=TopoDS_Solid.prototype.Convex=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Solid_Convex_0(self)};TopoDS_Solid.prototype["Move"]=TopoDS_Solid.prototype.Move=function(thePosition){var self=this.ptr;if(thePosition&&typeof thePosition==="object")thePosition=thePosition.ptr;_emscripten_bind_TopoDS_Solid_Move_1(self,thePosition)};TopoDS_Solid.prototype["Moved"]=TopoDS_Solid.prototype.Moved=function(thePosition){var self=this.ptr;if(thePosition&&typeof thePosition==="object")thePosition=thePosition.ptr;return wrapPointer(_emscripten_bind_TopoDS_Solid_Moved_1(self,thePosition),TopoDS_Shape)};TopoDS_Solid.prototype["Reverse"]=TopoDS_Solid.prototype.Reverse=function(){var self=this.ptr;_emscripten_bind_TopoDS_Solid_Reverse_0(self)};TopoDS_Solid.prototype["Reversed"]=TopoDS_Solid.prototype.Reversed=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_Solid_Reversed_0(self),TopoDS_Shape)};TopoDS_Solid.prototype["Complement"]=TopoDS_Solid.prototype.Complement=function(){var self=this.ptr;_emscripten_bind_TopoDS_Solid_Complement_0(self)};TopoDS_Solid.prototype["Complemented"]=TopoDS_Solid.prototype.Complemented=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_Solid_Complemented_0(self),TopoDS_Shape)};TopoDS_Solid.prototype["Compose"]=TopoDS_Solid.prototype.Compose=function(theOrient){var self=this.ptr;if(theOrient&&typeof theOrient==="object")theOrient=theOrient.ptr;_emscripten_bind_TopoDS_Solid_Compose_1(self,theOrient)};TopoDS_Solid.prototype["Composed"]=TopoDS_Solid.prototype.Composed=function(theOrient){var self=this.ptr;if(theOrient&&typeof theOrient==="object")theOrient=theOrient.ptr;return wrapPointer(_emscripten_bind_TopoDS_Solid_Composed_1(self,theOrient),TopoDS_Shape)};TopoDS_Solid.prototype["NbChildren"]=TopoDS_Solid.prototype.NbChildren=function(){var self=this.ptr;return _emscripten_bind_TopoDS_Solid_NbChildren_0(self)};TopoDS_Solid.prototype["IsPartner"]=TopoDS_Solid.prototype.IsPartner=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_Solid_IsPartner_1(self,theOther)};TopoDS_Solid.prototype["IsSame"]=TopoDS_Solid.prototype.IsSame=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_Solid_IsSame_1(self,theOther)};TopoDS_Solid.prototype["IsEqual"]=TopoDS_Solid.prototype.IsEqual=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_Solid_IsEqual_1(self,theOther)};TopoDS_Solid.prototype["IsNotEqual"]=TopoDS_Solid.prototype.IsNotEqual=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_Solid_IsNotEqual_1(self,theOther)};TopoDS_Solid.prototype["HashCode"]=TopoDS_Solid.prototype.HashCode=function(theUpperBound){var self=this.ptr;if(theUpperBound&&typeof theUpperBound==="object")theUpperBound=theUpperBound.ptr;return _emscripten_bind_TopoDS_Solid_HashCode_1(self,theUpperBound)};TopoDS_Solid.prototype["EmptyCopy"]=TopoDS_Solid.prototype.EmptyCopy=function(){var self=this.ptr;_emscripten_bind_TopoDS_Solid_EmptyCopy_0(self)};TopoDS_Solid.prototype["EmptyCopied"]=TopoDS_Solid.prototype.EmptyCopied=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_Solid_EmptyCopied_0(self),TopoDS_Shape)};TopoDS_Solid.prototype["__destroy__"]=TopoDS_Solid.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_TopoDS_Solid___destroy___0(self)};function TopoDS_Edge(T2){if(T2&&typeof T2==="object")T2=T2.ptr;if(T2===undefined){this.ptr=_emscripten_bind_TopoDS_Edge_TopoDS_Edge_0();getCache(TopoDS_Edge)[this.ptr]=this;return}this.ptr=_emscripten_bind_TopoDS_Edge_TopoDS_Edge_1(T2);getCache(TopoDS_Edge)[this.ptr]=this}TopoDS_Edge.prototype=Object.create(TopoDS_Shape.prototype);TopoDS_Edge.prototype.constructor=TopoDS_Edge;TopoDS_Edge.prototype.__class__=TopoDS_Edge;TopoDS_Edge.__cache__={};Module["TopoDS_Edge"]=TopoDS_Edge;TopoDS_Edge.prototype["IsNull"]=TopoDS_Edge.prototype.IsNull=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Edge_IsNull_0(self)};TopoDS_Edge.prototype["Nullify"]=TopoDS_Edge.prototype.Nullify=function(){var self=this.ptr;_emscripten_bind_TopoDS_Edge_Nullify_0(self)};TopoDS_Edge.prototype["Location"]=TopoDS_Edge.prototype.Location=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_Edge_Location_0(self),TopLoc_Location)};TopoDS_Edge.prototype["Located"]=TopoDS_Edge.prototype.Located=function(theLoc){var self=this.ptr;if(theLoc&&typeof theLoc==="object")theLoc=theLoc.ptr;return wrapPointer(_emscripten_bind_TopoDS_Edge_Located_1(self,theLoc),TopoDS_Shape)};TopoDS_Edge.prototype["Orientation"]=TopoDS_Edge.prototype.Orientation=function(){var self=this.ptr;return _emscripten_bind_TopoDS_Edge_Orientation_0(self)};TopoDS_Edge.prototype["Oriented"]=TopoDS_Edge.prototype.Oriented=function(theOrient){var self=this.ptr;if(theOrient&&typeof theOrient==="object")theOrient=theOrient.ptr;return wrapPointer(_emscripten_bind_TopoDS_Edge_Oriented_1(self,theOrient),TopoDS_Shape)};TopoDS_Edge.prototype["ShapeType"]=TopoDS_Edge.prototype.ShapeType=function(){var self=this.ptr;return _emscripten_bind_TopoDS_Edge_ShapeType_0(self)};TopoDS_Edge.prototype["Free"]=TopoDS_Edge.prototype.Free=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Edge_Free_0(self)};TopoDS_Edge.prototype["Locked"]=TopoDS_Edge.prototype.Locked=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Edge_Locked_0(self)};TopoDS_Edge.prototype["Modified"]=TopoDS_Edge.prototype.Modified=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Edge_Modified_0(self)};TopoDS_Edge.prototype["Checked"]=TopoDS_Edge.prototype.Checked=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Edge_Checked_0(self)};TopoDS_Edge.prototype["Orientable"]=TopoDS_Edge.prototype.Orientable=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Edge_Orientable_0(self)};TopoDS_Edge.prototype["Closed"]=TopoDS_Edge.prototype.Closed=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Edge_Closed_0(self)};TopoDS_Edge.prototype["Infinite"]=TopoDS_Edge.prototype.Infinite=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Edge_Infinite_0(self)};TopoDS_Edge.prototype["Convex"]=TopoDS_Edge.prototype.Convex=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Edge_Convex_0(self)};TopoDS_Edge.prototype["Move"]=TopoDS_Edge.prototype.Move=function(thePosition){var self=this.ptr;if(thePosition&&typeof thePosition==="object")thePosition=thePosition.ptr;_emscripten_bind_TopoDS_Edge_Move_1(self,thePosition)};TopoDS_Edge.prototype["Moved"]=TopoDS_Edge.prototype.Moved=function(thePosition){var self=this.ptr;if(thePosition&&typeof thePosition==="object")thePosition=thePosition.ptr;return wrapPointer(_emscripten_bind_TopoDS_Edge_Moved_1(self,thePosition),TopoDS_Shape)};TopoDS_Edge.prototype["Reverse"]=TopoDS_Edge.prototype.Reverse=function(){var self=this.ptr;_emscripten_bind_TopoDS_Edge_Reverse_0(self)};TopoDS_Edge.prototype["Reversed"]=TopoDS_Edge.prototype.Reversed=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_Edge_Reversed_0(self),TopoDS_Shape)};TopoDS_Edge.prototype["Complement"]=TopoDS_Edge.prototype.Complement=function(){var self=this.ptr;_emscripten_bind_TopoDS_Edge_Complement_0(self)};TopoDS_Edge.prototype["Complemented"]=TopoDS_Edge.prototype.Complemented=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_Edge_Complemented_0(self),TopoDS_Shape)};TopoDS_Edge.prototype["Compose"]=TopoDS_Edge.prototype.Compose=function(theOrient){var self=this.ptr;if(theOrient&&typeof theOrient==="object")theOrient=theOrient.ptr;_emscripten_bind_TopoDS_Edge_Compose_1(self,theOrient)};TopoDS_Edge.prototype["Composed"]=TopoDS_Edge.prototype.Composed=function(theOrient){var self=this.ptr;if(theOrient&&typeof theOrient==="object")theOrient=theOrient.ptr;return wrapPointer(_emscripten_bind_TopoDS_Edge_Composed_1(self,theOrient),TopoDS_Shape)};TopoDS_Edge.prototype["NbChildren"]=TopoDS_Edge.prototype.NbChildren=function(){var self=this.ptr;return _emscripten_bind_TopoDS_Edge_NbChildren_0(self)};TopoDS_Edge.prototype["IsPartner"]=TopoDS_Edge.prototype.IsPartner=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_Edge_IsPartner_1(self,theOther)};TopoDS_Edge.prototype["IsSame"]=TopoDS_Edge.prototype.IsSame=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_Edge_IsSame_1(self,theOther)};TopoDS_Edge.prototype["IsEqual"]=TopoDS_Edge.prototype.IsEqual=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_Edge_IsEqual_1(self,theOther)};TopoDS_Edge.prototype["IsNotEqual"]=TopoDS_Edge.prototype.IsNotEqual=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_Edge_IsNotEqual_1(self,theOther)};TopoDS_Edge.prototype["HashCode"]=TopoDS_Edge.prototype.HashCode=function(theUpperBound){var self=this.ptr;if(theUpperBound&&typeof theUpperBound==="object")theUpperBound=theUpperBound.ptr;return _emscripten_bind_TopoDS_Edge_HashCode_1(self,theUpperBound)};TopoDS_Edge.prototype["EmptyCopy"]=TopoDS_Edge.prototype.EmptyCopy=function(){var self=this.ptr;_emscripten_bind_TopoDS_Edge_EmptyCopy_0(self)};TopoDS_Edge.prototype["EmptyCopied"]=TopoDS_Edge.prototype.EmptyCopied=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_Edge_EmptyCopied_0(self),TopoDS_Shape)};TopoDS_Edge.prototype["__destroy__"]=TopoDS_Edge.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_TopoDS_Edge___destroy___0(self)};function gp_Hypr(A2,MajorRadius,MinorRadius){if(A2&&typeof A2==="object")A2=A2.ptr;if(MajorRadius&&typeof MajorRadius==="object")MajorRadius=MajorRadius.ptr;if(MinorRadius&&typeof MinorRadius==="object")MinorRadius=MinorRadius.ptr;if(A2===undefined){this.ptr=_emscripten_bind_gp_Hypr_gp_Hypr_0();getCache(gp_Hypr)[this.ptr]=this;return}if(MajorRadius===undefined){this.ptr=_emscripten_bind_gp_Hypr_gp_Hypr_1(A2);getCache(gp_Hypr)[this.ptr]=this;return}if(MinorRadius===undefined){this.ptr=_emscripten_bind_gp_Hypr_gp_Hypr_2(A2,MajorRadius);getCache(gp_Hypr)[this.ptr]=this;return}this.ptr=_emscripten_bind_gp_Hypr_gp_Hypr_3(A2,MajorRadius,MinorRadius);getCache(gp_Hypr)[this.ptr]=this}gp_Hypr.prototype=Object.create(WrapperObject.prototype);gp_Hypr.prototype.constructor=gp_Hypr;gp_Hypr.prototype.__class__=gp_Hypr;gp_Hypr.__cache__={};Module["gp_Hypr"]=gp_Hypr;gp_Hypr.prototype["Eccentricity"]=gp_Hypr.prototype.Eccentricity=function(){var self=this.ptr;return _emscripten_bind_gp_Hypr_Eccentricity_0(self)};gp_Hypr.prototype["Focal"]=gp_Hypr.prototype.Focal=function(){var self=this.ptr;return _emscripten_bind_gp_Hypr_Focal_0(self)};gp_Hypr.prototype["MajorRadius"]=gp_Hypr.prototype.MajorRadius=function(){var self=this.ptr;return _emscripten_bind_gp_Hypr_MajorRadius_0(self)};gp_Hypr.prototype["MinorRadius"]=gp_Hypr.prototype.MinorRadius=function(){var self=this.ptr;return _emscripten_bind_gp_Hypr_MinorRadius_0(self)};gp_Hypr.prototype["__destroy__"]=gp_Hypr.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_gp_Hypr___destroy___0(self)};function BRepBuilderAPI_MakeEdge(L,S){if(L&&typeof L==="object")L=L.ptr;if(S&&typeof S==="object")S=S.ptr;if(S===undefined){this.ptr=_emscripten_bind_BRepBuilderAPI_MakeEdge_BRepBuilderAPI_MakeEdge_1(L);getCache(BRepBuilderAPI_MakeEdge)[this.ptr]=this;return}this.ptr=_emscripten_bind_BRepBuilderAPI_MakeEdge_BRepBuilderAPI_MakeEdge_2(L,S);getCache(BRepBuilderAPI_MakeEdge)[this.ptr]=this}BRepBuilderAPI_MakeEdge.prototype=Object.create(WrapperObject.prototype);BRepBuilderAPI_MakeEdge.prototype.constructor=BRepBuilderAPI_MakeEdge;BRepBuilderAPI_MakeEdge.prototype.__class__=BRepBuilderAPI_MakeEdge;BRepBuilderAPI_MakeEdge.__cache__={};Module["BRepBuilderAPI_MakeEdge"]=BRepBuilderAPI_MakeEdge;BRepBuilderAPI_MakeEdge.prototype["Edge"]=BRepBuilderAPI_MakeEdge.prototype.Edge=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepBuilderAPI_MakeEdge_Edge_0(self),TopoDS_Edge)};BRepBuilderAPI_MakeEdge.prototype["__destroy__"]=BRepBuilderAPI_MakeEdge.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepBuilderAPI_MakeEdge___destroy___0(self)};function BRepBuilderAPI_Sewing(tolerance,option1,option2,option3,option4){if(tolerance&&typeof tolerance==="object")tolerance=tolerance.ptr;if(option1&&typeof option1==="object")option1=option1.ptr;if(option2&&typeof option2==="object")option2=option2.ptr;if(option3&&typeof option3==="object")option3=option3.ptr;if(option4&&typeof option4==="object")option4=option4.ptr;if(tolerance===undefined){this.ptr=_emscripten_bind_BRepBuilderAPI_Sewing_BRepBuilderAPI_Sewing_0();getCache(BRepBuilderAPI_Sewing)[this.ptr]=this;return}if(option1===undefined){this.ptr=_emscripten_bind_BRepBuilderAPI_Sewing_BRepBuilderAPI_Sewing_1(tolerance);getCache(BRepBuilderAPI_Sewing)[this.ptr]=this;return}if(option2===undefined){this.ptr=_emscripten_bind_BRepBuilderAPI_Sewing_BRepBuilderAPI_Sewing_2(tolerance,option1);getCache(BRepBuilderAPI_Sewing)[this.ptr]=this;return}if(option3===undefined){this.ptr=_emscripten_bind_BRepBuilderAPI_Sewing_BRepBuilderAPI_Sewing_3(tolerance,option1,option2);getCache(BRepBuilderAPI_Sewing)[this.ptr]=this;return}if(option4===undefined){this.ptr=_emscripten_bind_BRepBuilderAPI_Sewing_BRepBuilderAPI_Sewing_4(tolerance,option1,option2,option3);getCache(BRepBuilderAPI_Sewing)[this.ptr]=this;return}this.ptr=_emscripten_bind_BRepBuilderAPI_Sewing_BRepBuilderAPI_Sewing_5(tolerance,option1,option2,option3,option4);getCache(BRepBuilderAPI_Sewing)[this.ptr]=this}BRepBuilderAPI_Sewing.prototype=Object.create(WrapperObject.prototype);BRepBuilderAPI_Sewing.prototype.constructor=BRepBuilderAPI_Sewing;BRepBuilderAPI_Sewing.prototype.__class__=BRepBuilderAPI_Sewing;BRepBuilderAPI_Sewing.__cache__={};Module["BRepBuilderAPI_Sewing"]=BRepBuilderAPI_Sewing;BRepBuilderAPI_Sewing.prototype["Init"]=BRepBuilderAPI_Sewing.prototype.Init=function(tolerance,option1,option2,option3,option4){var self=this.ptr;if(tolerance&&typeof tolerance==="object")tolerance=tolerance.ptr;if(option1&&typeof option1==="object")option1=option1.ptr;if(option2&&typeof option2==="object")option2=option2.ptr;if(option3&&typeof option3==="object")option3=option3.ptr;if(option4&&typeof option4==="object")option4=option4.ptr;if(tolerance===undefined){_emscripten_bind_BRepBuilderAPI_Sewing_Init_0(self);return}if(option1===undefined){_emscripten_bind_BRepBuilderAPI_Sewing_Init_1(self,tolerance);return}if(option2===undefined){_emscripten_bind_BRepBuilderAPI_Sewing_Init_2(self,tolerance,option1);return}if(option3===undefined){_emscripten_bind_BRepBuilderAPI_Sewing_Init_3(self,tolerance,option1,option2);return}if(option4===undefined){_emscripten_bind_BRepBuilderAPI_Sewing_Init_4(self,tolerance,option1,option2,option3);return}_emscripten_bind_BRepBuilderAPI_Sewing_Init_5(self,tolerance,option1,option2,option3,option4)};BRepBuilderAPI_Sewing.prototype["Load"]=BRepBuilderAPI_Sewing.prototype.Load=function(shape){var self=this.ptr;if(shape&&typeof shape==="object")shape=shape.ptr;_emscripten_bind_BRepBuilderAPI_Sewing_Load_1(self,shape)};BRepBuilderAPI_Sewing.prototype["Add"]=BRepBuilderAPI_Sewing.prototype.Add=function(shape){var self=this.ptr;if(shape&&typeof shape==="object")shape=shape.ptr;_emscripten_bind_BRepBuilderAPI_Sewing_Add_1(self,shape)};BRepBuilderAPI_Sewing.prototype["Perform"]=BRepBuilderAPI_Sewing.prototype.Perform=function(thePI){var self=this.ptr;if(thePI&&typeof thePI==="object")thePI=thePI.ptr;if(thePI===undefined){_emscripten_bind_BRepBuilderAPI_Sewing_Perform_0(self);return}_emscripten_bind_BRepBuilderAPI_Sewing_Perform_1(self,thePI)};BRepBuilderAPI_Sewing.prototype["SewedShape"]=BRepBuilderAPI_Sewing.prototype.SewedShape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepBuilderAPI_Sewing_SewedShape_0(self),TopoDS_Shape)};BRepBuilderAPI_Sewing.prototype["NbFreeEdges"]=BRepBuilderAPI_Sewing.prototype.NbFreeEdges=function(){var self=this.ptr;return _emscripten_bind_BRepBuilderAPI_Sewing_NbFreeEdges_0(self)};BRepBuilderAPI_Sewing.prototype["FreeEdge"]=BRepBuilderAPI_Sewing.prototype.FreeEdge=function(index){var self=this.ptr;if(index&&typeof index==="object")index=index.ptr;return wrapPointer(_emscripten_bind_BRepBuilderAPI_Sewing_FreeEdge_1(self,index),TopoDS_Edge)};BRepBuilderAPI_Sewing.prototype["NbMultipleEdges"]=BRepBuilderAPI_Sewing.prototype.NbMultipleEdges=function(){var self=this.ptr;return _emscripten_bind_BRepBuilderAPI_Sewing_NbMultipleEdges_0(self)};BRepBuilderAPI_Sewing.prototype["MultipleEdge"]=BRepBuilderAPI_Sewing.prototype.MultipleEdge=function(index){var self=this.ptr;if(index&&typeof index==="object")index=index.ptr;return wrapPointer(_emscripten_bind_BRepBuilderAPI_Sewing_MultipleEdge_1(self,index),TopoDS_Edge)};BRepBuilderAPI_Sewing.prototype["NbContigousEdges"]=BRepBuilderAPI_Sewing.prototype.NbContigousEdges=function(){var self=this.ptr;return _emscripten_bind_BRepBuilderAPI_Sewing_NbContigousEdges_0(self)};BRepBuilderAPI_Sewing.prototype["ContigousEdge"]=BRepBuilderAPI_Sewing.prototype.ContigousEdge=function(index){var self=this.ptr;if(index&&typeof index==="object")index=index.ptr;return wrapPointer(_emscripten_bind_BRepBuilderAPI_Sewing_ContigousEdge_1(self,index),TopoDS_Edge)};BRepBuilderAPI_Sewing.prototype["IsSectionBound"]=BRepBuilderAPI_Sewing.prototype.IsSectionBound=function(section){var self=this.ptr;if(section&&typeof section==="object")section=section.ptr;return!!_emscripten_bind_BRepBuilderAPI_Sewing_IsSectionBound_1(self,section)};BRepBuilderAPI_Sewing.prototype["SectionToBoundary"]=BRepBuilderAPI_Sewing.prototype.SectionToBoundary=function(section){var self=this.ptr;if(section&&typeof section==="object")section=section.ptr;return wrapPointer(_emscripten_bind_BRepBuilderAPI_Sewing_SectionToBoundary_1(self,section),TopoDS_Edge)};BRepBuilderAPI_Sewing.prototype["NbDegeneratedShapes"]=BRepBuilderAPI_Sewing.prototype.NbDegeneratedShapes=function(){var self=this.ptr;return _emscripten_bind_BRepBuilderAPI_Sewing_NbDegeneratedShapes_0(self)};BRepBuilderAPI_Sewing.prototype["DegeneratedShape"]=BRepBuilderAPI_Sewing.prototype.DegeneratedShape=function(index){var self=this.ptr;if(index&&typeof index==="object")index=index.ptr;return wrapPointer(_emscripten_bind_BRepBuilderAPI_Sewing_DegeneratedShape_1(self,index),TopoDS_Shape)};BRepBuilderAPI_Sewing.prototype["IsDegenerated"]=BRepBuilderAPI_Sewing.prototype.IsDegenerated=function(shape){var self=this.ptr;if(shape&&typeof shape==="object")shape=shape.ptr;return!!_emscripten_bind_BRepBuilderAPI_Sewing_IsDegenerated_1(self,shape)};BRepBuilderAPI_Sewing.prototype["IsModified"]=BRepBuilderAPI_Sewing.prototype.IsModified=function(shape){var self=this.ptr;if(shape&&typeof shape==="object")shape=shape.ptr;return!!_emscripten_bind_BRepBuilderAPI_Sewing_IsModified_1(self,shape)};BRepBuilderAPI_Sewing.prototype["Modified"]=BRepBuilderAPI_Sewing.prototype.Modified=function(shape){var self=this.ptr;if(shape&&typeof shape==="object")shape=shape.ptr;return wrapPointer(_emscripten_bind_BRepBuilderAPI_Sewing_Modified_1(self,shape),TopoDS_Shape)};BRepBuilderAPI_Sewing.prototype["IsModifiedSubShape"]=BRepBuilderAPI_Sewing.prototype.IsModifiedSubShape=function(shape){var self=this.ptr;if(shape&&typeof shape==="object")shape=shape.ptr;return!!_emscripten_bind_BRepBuilderAPI_Sewing_IsModifiedSubShape_1(self,shape)};BRepBuilderAPI_Sewing.prototype["ModifiedSubShape"]=BRepBuilderAPI_Sewing.prototype.ModifiedSubShape=function(shape){var self=this.ptr;if(shape&&typeof shape==="object")shape=shape.ptr;return wrapPointer(_emscripten_bind_BRepBuilderAPI_Sewing_ModifiedSubShape_1(self,shape),TopoDS_Shape)};BRepBuilderAPI_Sewing.prototype["Dump"]=BRepBuilderAPI_Sewing.prototype.Dump=function(){var self=this.ptr;_emscripten_bind_BRepBuilderAPI_Sewing_Dump_0(self)};BRepBuilderAPI_Sewing.prototype["NbDeletedFaces"]=BRepBuilderAPI_Sewing.prototype.NbDeletedFaces=function(){var self=this.ptr;return _emscripten_bind_BRepBuilderAPI_Sewing_NbDeletedFaces_0(self)};BRepBuilderAPI_Sewing.prototype["DeletedFace"]=BRepBuilderAPI_Sewing.prototype.DeletedFace=function(index){var self=this.ptr;if(index&&typeof index==="object")index=index.ptr;return wrapPointer(_emscripten_bind_BRepBuilderAPI_Sewing_DeletedFace_1(self,index),TopoDS_Face)};BRepBuilderAPI_Sewing.prototype["WhichFace"]=BRepBuilderAPI_Sewing.prototype.WhichFace=function(theEdg,index){var self=this.ptr;if(theEdg&&typeof theEdg==="object")theEdg=theEdg.ptr;if(index&&typeof index==="object")index=index.ptr;if(index===undefined){return wrapPointer(_emscripten_bind_BRepBuilderAPI_Sewing_WhichFace_1(self,theEdg),TopoDS_Face)}return wrapPointer(_emscripten_bind_BRepBuilderAPI_Sewing_WhichFace_2(self,theEdg,index),TopoDS_Face)};BRepBuilderAPI_Sewing.prototype["SameParameterMode"]=BRepBuilderAPI_Sewing.prototype.SameParameterMode=function(){var self=this.ptr;return!!_emscripten_bind_BRepBuilderAPI_Sewing_SameParameterMode_0(self)};BRepBuilderAPI_Sewing.prototype["SetSameParameterMode"]=BRepBuilderAPI_Sewing.prototype.SetSameParameterMode=function(SameParameterMode){var self=this.ptr;if(SameParameterMode&&typeof SameParameterMode==="object")SameParameterMode=SameParameterMode.ptr;_emscripten_bind_BRepBuilderAPI_Sewing_SetSameParameterMode_1(self,SameParameterMode)};BRepBuilderAPI_Sewing.prototype["Tolerance"]=BRepBuilderAPI_Sewing.prototype.Tolerance=function(){var self=this.ptr;return _emscripten_bind_BRepBuilderAPI_Sewing_Tolerance_0(self)};BRepBuilderAPI_Sewing.prototype["SetTolerance"]=BRepBuilderAPI_Sewing.prototype.SetTolerance=function(theToler){var self=this.ptr;if(theToler&&typeof theToler==="object")theToler=theToler.ptr;_emscripten_bind_BRepBuilderAPI_Sewing_SetTolerance_1(self,theToler)};BRepBuilderAPI_Sewing.prototype["MinTolerance"]=BRepBuilderAPI_Sewing.prototype.MinTolerance=function(){var self=this.ptr;return _emscripten_bind_BRepBuilderAPI_Sewing_MinTolerance_0(self)};BRepBuilderAPI_Sewing.prototype["SetMinTolerance"]=BRepBuilderAPI_Sewing.prototype.SetMinTolerance=function(theMinToler){var self=this.ptr;if(theMinToler&&typeof theMinToler==="object")theMinToler=theMinToler.ptr;_emscripten_bind_BRepBuilderAPI_Sewing_SetMinTolerance_1(self,theMinToler)};BRepBuilderAPI_Sewing.prototype["MaxTolerance"]=BRepBuilderAPI_Sewing.prototype.MaxTolerance=function(){var self=this.ptr;return _emscripten_bind_BRepBuilderAPI_Sewing_MaxTolerance_0(self)};BRepBuilderAPI_Sewing.prototype["SetMaxTolerance"]=BRepBuilderAPI_Sewing.prototype.SetMaxTolerance=function(theMaxToler){var self=this.ptr;if(theMaxToler&&typeof theMaxToler==="object")theMaxToler=theMaxToler.ptr;_emscripten_bind_BRepBuilderAPI_Sewing_SetMaxTolerance_1(self,theMaxToler)};BRepBuilderAPI_Sewing.prototype["FaceMode"]=BRepBuilderAPI_Sewing.prototype.FaceMode=function(){var self=this.ptr;return!!_emscripten_bind_BRepBuilderAPI_Sewing_FaceMode_0(self)};BRepBuilderAPI_Sewing.prototype["SetFaceMode"]=BRepBuilderAPI_Sewing.prototype.SetFaceMode=function(theFaceMode){var self=this.ptr;if(theFaceMode&&typeof theFaceMode==="object")theFaceMode=theFaceMode.ptr;_emscripten_bind_BRepBuilderAPI_Sewing_SetFaceMode_1(self,theFaceMode)};BRepBuilderAPI_Sewing.prototype["FloatingEdgesMode"]=BRepBuilderAPI_Sewing.prototype.FloatingEdgesMode=function(){var self=this.ptr;return!!_emscripten_bind_BRepBuilderAPI_Sewing_FloatingEdgesMode_0(self)};BRepBuilderAPI_Sewing.prototype["SetFloatingEdgesMode"]=BRepBuilderAPI_Sewing.prototype.SetFloatingEdgesMode=function(theFloatingEdgesMode){var self=this.ptr;if(theFloatingEdgesMode&&typeof theFloatingEdgesMode==="object")theFloatingEdgesMode=theFloatingEdgesMode.ptr;_emscripten_bind_BRepBuilderAPI_Sewing_SetFloatingEdgesMode_1(self,theFloatingEdgesMode)};BRepBuilderAPI_Sewing.prototype["LocalTolerancesMode"]=BRepBuilderAPI_Sewing.prototype.LocalTolerancesMode=function(){var self=this.ptr;return!!_emscripten_bind_BRepBuilderAPI_Sewing_LocalTolerancesMode_0(self)};BRepBuilderAPI_Sewing.prototype["SetLocalTolerancesMode"]=BRepBuilderAPI_Sewing.prototype.SetLocalTolerancesMode=function(theLocalTolerancesMode){var self=this.ptr;if(theLocalTolerancesMode&&typeof theLocalTolerancesMode==="object")theLocalTolerancesMode=theLocalTolerancesMode.ptr;_emscripten_bind_BRepBuilderAPI_Sewing_SetLocalTolerancesMode_1(self,theLocalTolerancesMode)};BRepBuilderAPI_Sewing.prototype["SetNonManifoldMode"]=BRepBuilderAPI_Sewing.prototype.SetNonManifoldMode=function(theNonManifoldMode){var self=this.ptr;if(theNonManifoldMode&&typeof theNonManifoldMode==="object")theNonManifoldMode=theNonManifoldMode.ptr;_emscripten_bind_BRepBuilderAPI_Sewing_SetNonManifoldMode_1(self,theNonManifoldMode)};BRepBuilderAPI_Sewing.prototype["NonManifoldMode"]=BRepBuilderAPI_Sewing.prototype.NonManifoldMode=function(){var self=this.ptr;return!!_emscripten_bind_BRepBuilderAPI_Sewing_NonManifoldMode_0(self)};BRepBuilderAPI_Sewing.prototype["__destroy__"]=BRepBuilderAPI_Sewing.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepBuilderAPI_Sewing___destroy___0(self)};function BRepFilletAPI_MakeChamfer(S){if(S&&typeof S==="object")S=S.ptr;this.ptr=_emscripten_bind_BRepFilletAPI_MakeChamfer_BRepFilletAPI_MakeChamfer_1(S);getCache(BRepFilletAPI_MakeChamfer)[this.ptr]=this}BRepFilletAPI_MakeChamfer.prototype=Object.create(BRepFilletAPI_LocalOperation.prototype);BRepFilletAPI_MakeChamfer.prototype.constructor=BRepFilletAPI_MakeChamfer;BRepFilletAPI_MakeChamfer.prototype.__class__=BRepFilletAPI_MakeChamfer;BRepFilletAPI_MakeChamfer.__cache__={};Module["BRepFilletAPI_MakeChamfer"]=BRepFilletAPI_MakeChamfer;BRepFilletAPI_MakeChamfer.prototype["Add"]=BRepFilletAPI_MakeChamfer.prototype.Add=function(Dis1,Dis2,E,F){var self=this.ptr;if(Dis1&&typeof Dis1==="object")Dis1=Dis1.ptr;if(Dis2&&typeof Dis2==="object")Dis2=Dis2.ptr;if(E&&typeof E==="object")E=E.ptr;if(F&&typeof F==="object")F=F.ptr;if(E===undefined){_emscripten_bind_BRepFilletAPI_MakeChamfer_Add_2(self,Dis1,Dis2);return}if(F===undefined){_emscripten_bind_BRepFilletAPI_MakeChamfer_Add_3(self,Dis1,Dis2,E);return}_emscripten_bind_BRepFilletAPI_MakeChamfer_Add_4(self,Dis1,Dis2,E,F)};BRepFilletAPI_MakeChamfer.prototype["Shape"]=BRepFilletAPI_MakeChamfer.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepFilletAPI_MakeChamfer_Shape_0(self),TopoDS_Shape)};BRepFilletAPI_MakeChamfer.prototype["__destroy__"]=BRepFilletAPI_MakeChamfer.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepFilletAPI_MakeChamfer___destroy___0(self)};function TColgp_Array1OfDir(theLower,theUpper){if(theLower&&typeof theLower==="object")theLower=theLower.ptr;if(theUpper&&typeof theUpper==="object")theUpper=theUpper.ptr;if(theLower===undefined){this.ptr=_emscripten_bind_TColgp_Array1OfDir_TColgp_Array1OfDir_0();getCache(TColgp_Array1OfDir)[this.ptr]=this;return}if(theUpper===undefined){this.ptr=_emscripten_bind_TColgp_Array1OfDir_TColgp_Array1OfDir_1(theLower);getCache(TColgp_Array1OfDir)[this.ptr]=this;return}this.ptr=_emscripten_bind_TColgp_Array1OfDir_TColgp_Array1OfDir_2(theLower,theUpper);getCache(TColgp_Array1OfDir)[this.ptr]=this}TColgp_Array1OfDir.prototype=Object.create(WrapperObject.prototype);TColgp_Array1OfDir.prototype.constructor=TColgp_Array1OfDir;TColgp_Array1OfDir.prototype.__class__=TColgp_Array1OfDir;TColgp_Array1OfDir.__cache__={};Module["TColgp_Array1OfDir"]=TColgp_Array1OfDir;TColgp_Array1OfDir.prototype["Length"]=TColgp_Array1OfDir.prototype.Length=function(){var self=this.ptr;return _emscripten_bind_TColgp_Array1OfDir_Length_0(self)};TColgp_Array1OfDir.prototype["Lower"]=TColgp_Array1OfDir.prototype.Lower=function(){var self=this.ptr;return _emscripten_bind_TColgp_Array1OfDir_Lower_0(self)};TColgp_Array1OfDir.prototype["Upper"]=TColgp_Array1OfDir.prototype.Upper=function(){var self=this.ptr;return _emscripten_bind_TColgp_Array1OfDir_Upper_0(self)};TColgp_Array1OfDir.prototype["Value"]=TColgp_Array1OfDir.prototype.Value=function(theIndex){var self=this.ptr;if(theIndex&&typeof theIndex==="object")theIndex=theIndex.ptr;return wrapPointer(_emscripten_bind_TColgp_Array1OfDir_Value_1(self,theIndex),gp_Dir)};TColgp_Array1OfDir.prototype["__destroy__"]=TColgp_Array1OfDir.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_TColgp_Array1OfDir___destroy___0(self)};function TopoDS_CompSolid(T2){if(T2&&typeof T2==="object")T2=T2.ptr;if(T2===undefined){this.ptr=_emscripten_bind_TopoDS_CompSolid_TopoDS_CompSolid_0();getCache(TopoDS_CompSolid)[this.ptr]=this;return}this.ptr=_emscripten_bind_TopoDS_CompSolid_TopoDS_CompSolid_1(T2);getCache(TopoDS_CompSolid)[this.ptr]=this}TopoDS_CompSolid.prototype=Object.create(TopoDS_Shape.prototype);TopoDS_CompSolid.prototype.constructor=TopoDS_CompSolid;TopoDS_CompSolid.prototype.__class__=TopoDS_CompSolid;TopoDS_CompSolid.__cache__={};Module["TopoDS_CompSolid"]=TopoDS_CompSolid;TopoDS_CompSolid.prototype["IsNull"]=TopoDS_CompSolid.prototype.IsNull=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_CompSolid_IsNull_0(self)};TopoDS_CompSolid.prototype["Nullify"]=TopoDS_CompSolid.prototype.Nullify=function(){var self=this.ptr;_emscripten_bind_TopoDS_CompSolid_Nullify_0(self)};TopoDS_CompSolid.prototype["Location"]=TopoDS_CompSolid.prototype.Location=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_CompSolid_Location_0(self),TopLoc_Location)};TopoDS_CompSolid.prototype["Located"]=TopoDS_CompSolid.prototype.Located=function(theLoc){var self=this.ptr;if(theLoc&&typeof theLoc==="object")theLoc=theLoc.ptr;return wrapPointer(_emscripten_bind_TopoDS_CompSolid_Located_1(self,theLoc),TopoDS_Shape)};TopoDS_CompSolid.prototype["Orientation"]=TopoDS_CompSolid.prototype.Orientation=function(){var self=this.ptr;return _emscripten_bind_TopoDS_CompSolid_Orientation_0(self)};TopoDS_CompSolid.prototype["Oriented"]=TopoDS_CompSolid.prototype.Oriented=function(theOrient){var self=this.ptr;if(theOrient&&typeof theOrient==="object")theOrient=theOrient.ptr;return wrapPointer(_emscripten_bind_TopoDS_CompSolid_Oriented_1(self,theOrient),TopoDS_Shape)};TopoDS_CompSolid.prototype["ShapeType"]=TopoDS_CompSolid.prototype.ShapeType=function(){var self=this.ptr;return _emscripten_bind_TopoDS_CompSolid_ShapeType_0(self)};TopoDS_CompSolid.prototype["Free"]=TopoDS_CompSolid.prototype.Free=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_CompSolid_Free_0(self)};TopoDS_CompSolid.prototype["Locked"]=TopoDS_CompSolid.prototype.Locked=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_CompSolid_Locked_0(self)};TopoDS_CompSolid.prototype["Modified"]=TopoDS_CompSolid.prototype.Modified=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_CompSolid_Modified_0(self)};TopoDS_CompSolid.prototype["Checked"]=TopoDS_CompSolid.prototype.Checked=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_CompSolid_Checked_0(self)};TopoDS_CompSolid.prototype["Orientable"]=TopoDS_CompSolid.prototype.Orientable=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_CompSolid_Orientable_0(self)};TopoDS_CompSolid.prototype["Closed"]=TopoDS_CompSolid.prototype.Closed=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_CompSolid_Closed_0(self)};TopoDS_CompSolid.prototype["Infinite"]=TopoDS_CompSolid.prototype.Infinite=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_CompSolid_Infinite_0(self)};TopoDS_CompSolid.prototype["Convex"]=TopoDS_CompSolid.prototype.Convex=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_CompSolid_Convex_0(self)};TopoDS_CompSolid.prototype["Move"]=TopoDS_CompSolid.prototype.Move=function(thePosition){var self=this.ptr;if(thePosition&&typeof thePosition==="object")thePosition=thePosition.ptr;_emscripten_bind_TopoDS_CompSolid_Move_1(self,thePosition)};TopoDS_CompSolid.prototype["Moved"]=TopoDS_CompSolid.prototype.Moved=function(thePosition){var self=this.ptr;if(thePosition&&typeof thePosition==="object")thePosition=thePosition.ptr;return wrapPointer(_emscripten_bind_TopoDS_CompSolid_Moved_1(self,thePosition),TopoDS_Shape)};TopoDS_CompSolid.prototype["Reverse"]=TopoDS_CompSolid.prototype.Reverse=function(){var self=this.ptr;_emscripten_bind_TopoDS_CompSolid_Reverse_0(self)};TopoDS_CompSolid.prototype["Reversed"]=TopoDS_CompSolid.prototype.Reversed=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_CompSolid_Reversed_0(self),TopoDS_Shape)};TopoDS_CompSolid.prototype["Complement"]=TopoDS_CompSolid.prototype.Complement=function(){var self=this.ptr;_emscripten_bind_TopoDS_CompSolid_Complement_0(self)};TopoDS_CompSolid.prototype["Complemented"]=TopoDS_CompSolid.prototype.Complemented=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_CompSolid_Complemented_0(self),TopoDS_Shape)};TopoDS_CompSolid.prototype["Compose"]=TopoDS_CompSolid.prototype.Compose=function(theOrient){var self=this.ptr;if(theOrient&&typeof theOrient==="object")theOrient=theOrient.ptr;_emscripten_bind_TopoDS_CompSolid_Compose_1(self,theOrient)};TopoDS_CompSolid.prototype["Composed"]=TopoDS_CompSolid.prototype.Composed=function(theOrient){var self=this.ptr;if(theOrient&&typeof theOrient==="object")theOrient=theOrient.ptr;return wrapPointer(_emscripten_bind_TopoDS_CompSolid_Composed_1(self,theOrient),TopoDS_Shape)};TopoDS_CompSolid.prototype["NbChildren"]=TopoDS_CompSolid.prototype.NbChildren=function(){var self=this.ptr;return _emscripten_bind_TopoDS_CompSolid_NbChildren_0(self)};TopoDS_CompSolid.prototype["IsPartner"]=TopoDS_CompSolid.prototype.IsPartner=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_CompSolid_IsPartner_1(self,theOther)};TopoDS_CompSolid.prototype["IsSame"]=TopoDS_CompSolid.prototype.IsSame=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_CompSolid_IsSame_1(self,theOther)};TopoDS_CompSolid.prototype["IsEqual"]=TopoDS_CompSolid.prototype.IsEqual=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_CompSolid_IsEqual_1(self,theOther)};TopoDS_CompSolid.prototype["IsNotEqual"]=TopoDS_CompSolid.prototype.IsNotEqual=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_CompSolid_IsNotEqual_1(self,theOther)};TopoDS_CompSolid.prototype["HashCode"]=TopoDS_CompSolid.prototype.HashCode=function(theUpperBound){var self=this.ptr;if(theUpperBound&&typeof theUpperBound==="object")theUpperBound=theUpperBound.ptr;return _emscripten_bind_TopoDS_CompSolid_HashCode_1(self,theUpperBound)};TopoDS_CompSolid.prototype["EmptyCopy"]=TopoDS_CompSolid.prototype.EmptyCopy=function(){var self=this.ptr;_emscripten_bind_TopoDS_CompSolid_EmptyCopy_0(self)};TopoDS_CompSolid.prototype["EmptyCopied"]=TopoDS_CompSolid.prototype.EmptyCopied=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_CompSolid_EmptyCopied_0(self),TopoDS_Shape)};TopoDS_CompSolid.prototype["__destroy__"]=TopoDS_CompSolid.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_TopoDS_CompSolid___destroy___0(self)};function BRepBuilderAPI_MakeSolid(S1,S2,S3){if(S1&&typeof S1==="object")S1=S1.ptr;if(S2&&typeof S2==="object")S2=S2.ptr;if(S3&&typeof S3==="object")S3=S3.ptr;if(S1===undefined){this.ptr=_emscripten_bind_BRepBuilderAPI_MakeSolid_BRepBuilderAPI_MakeSolid_0();getCache(BRepBuilderAPI_MakeSolid)[this.ptr]=this;return}if(S2===undefined){this.ptr=_emscripten_bind_BRepBuilderAPI_MakeSolid_BRepBuilderAPI_MakeSolid_1(S1);getCache(BRepBuilderAPI_MakeSolid)[this.ptr]=this;return}if(S3===undefined){this.ptr=_emscripten_bind_BRepBuilderAPI_MakeSolid_BRepBuilderAPI_MakeSolid_2(S1,S2);getCache(BRepBuilderAPI_MakeSolid)[this.ptr]=this;return}this.ptr=_emscripten_bind_BRepBuilderAPI_MakeSolid_BRepBuilderAPI_MakeSolid_3(S1,S2,S3);getCache(BRepBuilderAPI_MakeSolid)[this.ptr]=this}BRepBuilderAPI_MakeSolid.prototype=Object.create(WrapperObject.prototype);BRepBuilderAPI_MakeSolid.prototype.constructor=BRepBuilderAPI_MakeSolid;BRepBuilderAPI_MakeSolid.prototype.__class__=BRepBuilderAPI_MakeSolid;BRepBuilderAPI_MakeSolid.__cache__={};Module["BRepBuilderAPI_MakeSolid"]=BRepBuilderAPI_MakeSolid;BRepBuilderAPI_MakeSolid.prototype["Add"]=BRepBuilderAPI_MakeSolid.prototype.Add=function(S){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;_emscripten_bind_BRepBuilderAPI_MakeSolid_Add_1(self,S)};BRepBuilderAPI_MakeSolid.prototype["IsDone"]=BRepBuilderAPI_MakeSolid.prototype.IsDone=function(){var self=this.ptr;return!!_emscripten_bind_BRepBuilderAPI_MakeSolid_IsDone_0(self)};BRepBuilderAPI_MakeSolid.prototype["Solid"]=BRepBuilderAPI_MakeSolid.prototype.Solid=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepBuilderAPI_MakeSolid_Solid_0(self),TopoDS_Solid)};BRepBuilderAPI_MakeSolid.prototype["IsDeleted"]=BRepBuilderAPI_MakeSolid.prototype.IsDeleted=function(S){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;return!!_emscripten_bind_BRepBuilderAPI_MakeSolid_IsDeleted_1(self,S)};BRepBuilderAPI_MakeSolid.prototype["__destroy__"]=BRepBuilderAPI_MakeSolid.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepBuilderAPI_MakeSolid___destroy___0(self)};function TopoDS_Wire(T2){if(T2&&typeof T2==="object")T2=T2.ptr;if(T2===undefined){this.ptr=_emscripten_bind_TopoDS_Wire_TopoDS_Wire_0();getCache(TopoDS_Wire)[this.ptr]=this;return}this.ptr=_emscripten_bind_TopoDS_Wire_TopoDS_Wire_1(T2);getCache(TopoDS_Wire)[this.ptr]=this}TopoDS_Wire.prototype=Object.create(TopoDS_Shape.prototype);TopoDS_Wire.prototype.constructor=TopoDS_Wire;TopoDS_Wire.prototype.__class__=TopoDS_Wire;TopoDS_Wire.__cache__={};Module["TopoDS_Wire"]=TopoDS_Wire;TopoDS_Wire.prototype["IsNull"]=TopoDS_Wire.prototype.IsNull=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Wire_IsNull_0(self)};TopoDS_Wire.prototype["Nullify"]=TopoDS_Wire.prototype.Nullify=function(){var self=this.ptr;_emscripten_bind_TopoDS_Wire_Nullify_0(self)};TopoDS_Wire.prototype["Location"]=TopoDS_Wire.prototype.Location=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_Wire_Location_0(self),TopLoc_Location)};TopoDS_Wire.prototype["Located"]=TopoDS_Wire.prototype.Located=function(theLoc){var self=this.ptr;if(theLoc&&typeof theLoc==="object")theLoc=theLoc.ptr;return wrapPointer(_emscripten_bind_TopoDS_Wire_Located_1(self,theLoc),TopoDS_Shape)};TopoDS_Wire.prototype["Orientation"]=TopoDS_Wire.prototype.Orientation=function(){var self=this.ptr;return _emscripten_bind_TopoDS_Wire_Orientation_0(self)};TopoDS_Wire.prototype["Oriented"]=TopoDS_Wire.prototype.Oriented=function(theOrient){var self=this.ptr;if(theOrient&&typeof theOrient==="object")theOrient=theOrient.ptr;return wrapPointer(_emscripten_bind_TopoDS_Wire_Oriented_1(self,theOrient),TopoDS_Shape)};TopoDS_Wire.prototype["ShapeType"]=TopoDS_Wire.prototype.ShapeType=function(){var self=this.ptr;return _emscripten_bind_TopoDS_Wire_ShapeType_0(self)};TopoDS_Wire.prototype["Free"]=TopoDS_Wire.prototype.Free=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Wire_Free_0(self)};TopoDS_Wire.prototype["Locked"]=TopoDS_Wire.prototype.Locked=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Wire_Locked_0(self)};TopoDS_Wire.prototype["Modified"]=TopoDS_Wire.prototype.Modified=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Wire_Modified_0(self)};TopoDS_Wire.prototype["Checked"]=TopoDS_Wire.prototype.Checked=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Wire_Checked_0(self)};TopoDS_Wire.prototype["Orientable"]=TopoDS_Wire.prototype.Orientable=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Wire_Orientable_0(self)};TopoDS_Wire.prototype["Closed"]=TopoDS_Wire.prototype.Closed=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Wire_Closed_0(self)};TopoDS_Wire.prototype["Infinite"]=TopoDS_Wire.prototype.Infinite=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Wire_Infinite_0(self)};TopoDS_Wire.prototype["Convex"]=TopoDS_Wire.prototype.Convex=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Wire_Convex_0(self)};TopoDS_Wire.prototype["Move"]=TopoDS_Wire.prototype.Move=function(thePosition){var self=this.ptr;if(thePosition&&typeof thePosition==="object")thePosition=thePosition.ptr;_emscripten_bind_TopoDS_Wire_Move_1(self,thePosition)};TopoDS_Wire.prototype["Moved"]=TopoDS_Wire.prototype.Moved=function(thePosition){var self=this.ptr;if(thePosition&&typeof thePosition==="object")thePosition=thePosition.ptr;return wrapPointer(_emscripten_bind_TopoDS_Wire_Moved_1(self,thePosition),TopoDS_Shape)};TopoDS_Wire.prototype["Reverse"]=TopoDS_Wire.prototype.Reverse=function(){var self=this.ptr;_emscripten_bind_TopoDS_Wire_Reverse_0(self)};TopoDS_Wire.prototype["Reversed"]=TopoDS_Wire.prototype.Reversed=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_Wire_Reversed_0(self),TopoDS_Shape)};TopoDS_Wire.prototype["Complement"]=TopoDS_Wire.prototype.Complement=function(){var self=this.ptr;_emscripten_bind_TopoDS_Wire_Complement_0(self)};TopoDS_Wire.prototype["Complemented"]=TopoDS_Wire.prototype.Complemented=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_Wire_Complemented_0(self),TopoDS_Shape)};TopoDS_Wire.prototype["Compose"]=TopoDS_Wire.prototype.Compose=function(theOrient){var self=this.ptr;if(theOrient&&typeof theOrient==="object")theOrient=theOrient.ptr;_emscripten_bind_TopoDS_Wire_Compose_1(self,theOrient)};TopoDS_Wire.prototype["Composed"]=TopoDS_Wire.prototype.Composed=function(theOrient){var self=this.ptr;if(theOrient&&typeof theOrient==="object")theOrient=theOrient.ptr;return wrapPointer(_emscripten_bind_TopoDS_Wire_Composed_1(self,theOrient),TopoDS_Shape)};TopoDS_Wire.prototype["NbChildren"]=TopoDS_Wire.prototype.NbChildren=function(){var self=this.ptr;return _emscripten_bind_TopoDS_Wire_NbChildren_0(self)};TopoDS_Wire.prototype["IsPartner"]=TopoDS_Wire.prototype.IsPartner=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_Wire_IsPartner_1(self,theOther)};TopoDS_Wire.prototype["IsSame"]=TopoDS_Wire.prototype.IsSame=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_Wire_IsSame_1(self,theOther)};TopoDS_Wire.prototype["IsEqual"]=TopoDS_Wire.prototype.IsEqual=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_Wire_IsEqual_1(self,theOther)};TopoDS_Wire.prototype["IsNotEqual"]=TopoDS_Wire.prototype.IsNotEqual=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_Wire_IsNotEqual_1(self,theOther)};TopoDS_Wire.prototype["HashCode"]=TopoDS_Wire.prototype.HashCode=function(theUpperBound){var self=this.ptr;if(theUpperBound&&typeof theUpperBound==="object")theUpperBound=theUpperBound.ptr;return _emscripten_bind_TopoDS_Wire_HashCode_1(self,theUpperBound)};TopoDS_Wire.prototype["EmptyCopy"]=TopoDS_Wire.prototype.EmptyCopy=function(){var self=this.ptr;_emscripten_bind_TopoDS_Wire_EmptyCopy_0(self)};TopoDS_Wire.prototype["EmptyCopied"]=TopoDS_Wire.prototype.EmptyCopied=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_Wire_EmptyCopied_0(self),TopoDS_Shape)};TopoDS_Wire.prototype["__destroy__"]=TopoDS_Wire.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_TopoDS_Wire___destroy___0(self)};function TopoDS(){throw"cannot construct a TopoDS, no constructor in IDL"}TopoDS.prototype=Object.create(WrapperObject.prototype);TopoDS.prototype.constructor=TopoDS;TopoDS.prototype.__class__=TopoDS;TopoDS.__cache__={};Module["TopoDS"]=TopoDS;TopoDS.prototype["Vertex"]=TopoDS.prototype.Vertex=function(S){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;return wrapPointer(_emscripten_bind_TopoDS_Vertex_1(self,S),TopoDS_Vertex)};TopoDS.prototype["Edge"]=TopoDS.prototype.Edge=function(S){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;return wrapPointer(_emscripten_bind_TopoDS_Edge_1(self,S),TopoDS_Edge)};TopoDS.prototype["Wire"]=TopoDS.prototype.Wire=function(S){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;return wrapPointer(_emscripten_bind_TopoDS_Wire_1(self,S),TopoDS_Wire)};TopoDS.prototype["Face"]=TopoDS.prototype.Face=function(S){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;return wrapPointer(_emscripten_bind_TopoDS_Face_1(self,S),TopoDS_Face)};TopoDS.prototype["Shell"]=TopoDS.prototype.Shell=function(S){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;return wrapPointer(_emscripten_bind_TopoDS_Shell_1(self,S),TopoDS_Shell)};TopoDS.prototype["Solid"]=TopoDS.prototype.Solid=function(S){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;return wrapPointer(_emscripten_bind_TopoDS_Solid_1(self,S),TopoDS_Solid)};TopoDS.prototype["CompSolid"]=TopoDS.prototype.CompSolid=function(S){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;return wrapPointer(_emscripten_bind_TopoDS_CompSolid_1(self,S),TopoDS_CompSolid)};TopoDS.prototype["Compound"]=TopoDS.prototype.Compound=function(S){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;return wrapPointer(_emscripten_bind_TopoDS_Compound_1(self,S),TopoDS_Compound)};TopoDS.prototype["__destroy__"]=TopoDS.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_TopoDS___destroy___0(self)};function BRepPrimAPI_MakeCylinder(Axes,R,H,Angle){if(Axes&&typeof Axes==="object")Axes=Axes.ptr;if(R&&typeof R==="object")R=R.ptr;if(H&&typeof H==="object")H=H.ptr;if(Angle&&typeof Angle==="object")Angle=Angle.ptr;if(H===undefined){this.ptr=_emscripten_bind_BRepPrimAPI_MakeCylinder_BRepPrimAPI_MakeCylinder_2(Axes,R);getCache(BRepPrimAPI_MakeCylinder)[this.ptr]=this;return}if(Angle===undefined){this.ptr=_emscripten_bind_BRepPrimAPI_MakeCylinder_BRepPrimAPI_MakeCylinder_3(Axes,R,H);getCache(BRepPrimAPI_MakeCylinder)[this.ptr]=this;return}this.ptr=_emscripten_bind_BRepPrimAPI_MakeCylinder_BRepPrimAPI_MakeCylinder_4(Axes,R,H,Angle);getCache(BRepPrimAPI_MakeCylinder)[this.ptr]=this}BRepPrimAPI_MakeCylinder.prototype=Object.create(BRepPrimAPI_MakeOneAxis.prototype);BRepPrimAPI_MakeCylinder.prototype.constructor=BRepPrimAPI_MakeCylinder;BRepPrimAPI_MakeCylinder.prototype.__class__=BRepPrimAPI_MakeCylinder;BRepPrimAPI_MakeCylinder.__cache__={};Module["BRepPrimAPI_MakeCylinder"]=BRepPrimAPI_MakeCylinder;BRepPrimAPI_MakeCylinder.prototype["Shape"]=BRepPrimAPI_MakeCylinder.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeCylinder_Shape_0(self),TopoDS_Shape)};BRepPrimAPI_MakeCylinder.prototype["IsDeleted"]=BRepPrimAPI_MakeCylinder.prototype.IsDeleted=function(S){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;return!!_emscripten_bind_BRepPrimAPI_MakeCylinder_IsDeleted_1(self,S)};BRepPrimAPI_MakeCylinder.prototype["Build"]=BRepPrimAPI_MakeCylinder.prototype.Build=function(){var self=this.ptr;_emscripten_bind_BRepPrimAPI_MakeCylinder_Build_0(self)};BRepPrimAPI_MakeCylinder.prototype["Face"]=BRepPrimAPI_MakeCylinder.prototype.Face=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeCylinder_Face_0(self),TopoDS_Face)};BRepPrimAPI_MakeCylinder.prototype["Shell"]=BRepPrimAPI_MakeCylinder.prototype.Shell=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeCylinder_Shell_0(self),TopoDS_Shell)};BRepPrimAPI_MakeCylinder.prototype["Solid"]=BRepPrimAPI_MakeCylinder.prototype.Solid=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeCylinder_Solid_0(self),TopoDS_Solid)};BRepPrimAPI_MakeCylinder.prototype["__destroy__"]=BRepPrimAPI_MakeCylinder.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepPrimAPI_MakeCylinder___destroy___0(self)};function Handle_Standard_Type(thePtr){if(thePtr&&typeof thePtr==="object")thePtr=thePtr.ptr;if(thePtr===undefined){this.ptr=_emscripten_bind_Handle_Standard_Type_Handle_Standard_Type_0();getCache(Handle_Standard_Type)[this.ptr]=this;return}this.ptr=_emscripten_bind_Handle_Standard_Type_Handle_Standard_Type_1(thePtr);getCache(Handle_Standard_Type)[this.ptr]=this}Handle_Standard_Type.prototype=Object.create(WrapperObject.prototype);Handle_Standard_Type.prototype.constructor=Handle_Standard_Type;Handle_Standard_Type.prototype.__class__=Handle_Standard_Type;Handle_Standard_Type.__cache__={};Module["Handle_Standard_Type"]=Handle_Standard_Type;Handle_Standard_Type.prototype["IsNull"]=Handle_Standard_Type.prototype.IsNull=function(){var self=this.ptr;return!!_emscripten_bind_Handle_Standard_Type_IsNull_0(self)};Handle_Standard_Type.prototype["Nullify"]=Handle_Standard_Type.prototype.Nullify=function(){var self=this.ptr;_emscripten_bind_Handle_Standard_Type_Nullify_0(self)};Handle_Standard_Type.prototype["get"]=Handle_Standard_Type.prototype.get=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Handle_Standard_Type_get_0(self),Standard_Type)};Handle_Standard_Type.prototype["__destroy__"]=Handle_Standard_Type.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Handle_Standard_Type___destroy___0(self)};function STEPControl_Writer(){this.ptr=_emscripten_bind_STEPControl_Writer_STEPControl_Writer_0();getCache(STEPControl_Writer)[this.ptr]=this}STEPControl_Writer.prototype=Object.create(WrapperObject.prototype);STEPControl_Writer.prototype.constructor=STEPControl_Writer;STEPControl_Writer.prototype.__class__=STEPControl_Writer;STEPControl_Writer.__cache__={};Module["STEPControl_Writer"]=STEPControl_Writer;STEPControl_Writer.prototype["SetTolerance"]=STEPControl_Writer.prototype.SetTolerance=function(Tol){var self=this.ptr;if(Tol&&typeof Tol==="object")Tol=Tol.ptr;_emscripten_bind_STEPControl_Writer_SetTolerance_1(self,Tol)};STEPControl_Writer.prototype["UnsetTolerance"]=STEPControl_Writer.prototype.UnsetTolerance=function(){var self=this.ptr;_emscripten_bind_STEPControl_Writer_UnsetTolerance_0(self)};STEPControl_Writer.prototype["Transfer"]=STEPControl_Writer.prototype.Transfer=function(sh,mode,compgraph){var self=this.ptr;if(sh&&typeof sh==="object")sh=sh.ptr;if(mode&&typeof mode==="object")mode=mode.ptr;if(compgraph&&typeof compgraph==="object")compgraph=compgraph.ptr;if(compgraph===undefined){return _emscripten_bind_STEPControl_Writer_Transfer_2(self,sh,mode)}return _emscripten_bind_STEPControl_Writer_Transfer_3(self,sh,mode,compgraph)};STEPControl_Writer.prototype["Write"]=STEPControl_Writer.prototype.Write=function(filename){var self=this.ptr;ensureCache.prepare();if(filename&&typeof filename==="object")filename=filename.ptr;else filename=ensureString(filename);return _emscripten_bind_STEPControl_Writer_Write_1(self,filename)};STEPControl_Writer.prototype["PrintStatsTransfer"]=STEPControl_Writer.prototype.PrintStatsTransfer=function(what,mode){var self=this.ptr;if(what&&typeof what==="object")what=what.ptr;if(mode&&typeof mode==="object")mode=mode.ptr;if(mode===undefined){_emscripten_bind_STEPControl_Writer_PrintStatsTransfer_1(self,what);return}_emscripten_bind_STEPControl_Writer_PrintStatsTransfer_2(self,what,mode)};STEPControl_Writer.prototype["__destroy__"]=STEPControl_Writer.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_STEPControl_Writer___destroy___0(self)};function TColgp_Array1OfPnt(theLower,theUpper){if(theLower&&typeof theLower==="object")theLower=theLower.ptr;if(theUpper&&typeof theUpper==="object")theUpper=theUpper.ptr;if(theLower===undefined){this.ptr=_emscripten_bind_TColgp_Array1OfPnt_TColgp_Array1OfPnt_0();getCache(TColgp_Array1OfPnt)[this.ptr]=this;return}if(theUpper===undefined){this.ptr=_emscripten_bind_TColgp_Array1OfPnt_TColgp_Array1OfPnt_1(theLower);getCache(TColgp_Array1OfPnt)[this.ptr]=this;return}this.ptr=_emscripten_bind_TColgp_Array1OfPnt_TColgp_Array1OfPnt_2(theLower,theUpper);getCache(TColgp_Array1OfPnt)[this.ptr]=this}TColgp_Array1OfPnt.prototype=Object.create(WrapperObject.prototype);TColgp_Array1OfPnt.prototype.constructor=TColgp_Array1OfPnt;TColgp_Array1OfPnt.prototype.__class__=TColgp_Array1OfPnt;TColgp_Array1OfPnt.__cache__={};Module["TColgp_Array1OfPnt"]=TColgp_Array1OfPnt;TColgp_Array1OfPnt.prototype["Length"]=TColgp_Array1OfPnt.prototype.Length=function(){var self=this.ptr;return _emscripten_bind_TColgp_Array1OfPnt_Length_0(self)};TColgp_Array1OfPnt.prototype["Lower"]=TColgp_Array1OfPnt.prototype.Lower=function(){var self=this.ptr;return _emscripten_bind_TColgp_Array1OfPnt_Lower_0(self)};TColgp_Array1OfPnt.prototype["Upper"]=TColgp_Array1OfPnt.prototype.Upper=function(){var self=this.ptr;return _emscripten_bind_TColgp_Array1OfPnt_Upper_0(self)};TColgp_Array1OfPnt.prototype["Value"]=TColgp_Array1OfPnt.prototype.Value=function(theIndex){var self=this.ptr;if(theIndex&&typeof theIndex==="object")theIndex=theIndex.ptr;return wrapPointer(_emscripten_bind_TColgp_Array1OfPnt_Value_1(self,theIndex),gp_Pnt)};TColgp_Array1OfPnt.prototype["SetValue"]=TColgp_Array1OfPnt.prototype.SetValue=function(Index,Value){var self=this.ptr;if(Index&&typeof Index==="object")Index=Index.ptr;if(Value&&typeof Value==="object")Value=Value.ptr;_emscripten_bind_TColgp_Array1OfPnt_SetValue_2(self,Index,Value)};TColgp_Array1OfPnt.prototype["__destroy__"]=TColgp_Array1OfPnt.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_TColgp_Array1OfPnt___destroy___0(self)};function TColStd_Array1OfReal(theLower,theUpper){if(theLower&&typeof theLower==="object")theLower=theLower.ptr;if(theUpper&&typeof theUpper==="object")theUpper=theUpper.ptr;if(theLower===undefined){this.ptr=_emscripten_bind_TColStd_Array1OfReal_TColStd_Array1OfReal_0();getCache(TColStd_Array1OfReal)[this.ptr]=this;return}if(theUpper===undefined){this.ptr=_emscripten_bind_TColStd_Array1OfReal_TColStd_Array1OfReal_1(theLower);getCache(TColStd_Array1OfReal)[this.ptr]=this;return}this.ptr=_emscripten_bind_TColStd_Array1OfReal_TColStd_Array1OfReal_2(theLower,theUpper);getCache(TColStd_Array1OfReal)[this.ptr]=this}TColStd_Array1OfReal.prototype=Object.create(WrapperObject.prototype);TColStd_Array1OfReal.prototype.constructor=TColStd_Array1OfReal;TColStd_Array1OfReal.prototype.__class__=TColStd_Array1OfReal;TColStd_Array1OfReal.__cache__={};Module["TColStd_Array1OfReal"]=TColStd_Array1OfReal;TColStd_Array1OfReal.prototype["Length"]=TColStd_Array1OfReal.prototype.Length=function(){var self=this.ptr;return _emscripten_bind_TColStd_Array1OfReal_Length_0(self)};TColStd_Array1OfReal.prototype["Lower"]=TColStd_Array1OfReal.prototype.Lower=function(){var self=this.ptr;return _emscripten_bind_TColStd_Array1OfReal_Lower_0(self)};TColStd_Array1OfReal.prototype["Upper"]=TColStd_Array1OfReal.prototype.Upper=function(){var self=this.ptr;return _emscripten_bind_TColStd_Array1OfReal_Upper_0(self)};TColStd_Array1OfReal.prototype["Value"]=TColStd_Array1OfReal.prototype.Value=function(theIndex){var self=this.ptr;if(theIndex&&typeof theIndex==="object")theIndex=theIndex.ptr;return _emscripten_bind_TColStd_Array1OfReal_Value_1(self,theIndex)};TColStd_Array1OfReal.prototype["SetValue"]=TColStd_Array1OfReal.prototype.SetValue=function(Index,Value){var self=this.ptr;if(Index&&typeof Index==="object")Index=Index.ptr;if(Value&&typeof Value==="object")Value=Value.ptr;_emscripten_bind_TColStd_Array1OfReal_SetValue_2(self,Index,Value)};TColStd_Array1OfReal.prototype["__destroy__"]=TColStd_Array1OfReal.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_TColStd_Array1OfReal___destroy___0(self)};function Geom_Plane(){throw"cannot construct a Geom_Plane, no constructor in IDL"}Geom_Plane.prototype=Object.create(Geom_ElementarySurface.prototype);Geom_Plane.prototype.constructor=Geom_Plane;Geom_Plane.prototype.__class__=Geom_Plane;Geom_Plane.__cache__={};Module["Geom_Plane"]=Geom_Plane;Geom_Plane.prototype["Location"]=Geom_Plane.prototype.Location=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Geom_Plane_Location_0(self),gp_Pnt)};Geom_Plane.prototype["get_type_name"]=Geom_Plane.prototype.get_type_name=function(){var self=this.ptr;return UTF8ToString(_emscripten_bind_Geom_Plane_get_type_name_0(self))};Geom_Plane.prototype["DynamicType"]=Geom_Plane.prototype.DynamicType=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Geom_Plane_DynamicType_0(self),Handle_Standard_Type)};Geom_Plane.prototype["__destroy__"]=Geom_Plane.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Geom_Plane___destroy___0(self)};function gp_Lin(A1){if(A1&&typeof A1==="object")A1=A1.ptr;if(A1===undefined){this.ptr=_emscripten_bind_gp_Lin_gp_Lin_0();getCache(gp_Lin)[this.ptr]=this;return}this.ptr=_emscripten_bind_gp_Lin_gp_Lin_1(A1);getCache(gp_Lin)[this.ptr]=this}gp_Lin.prototype=Object.create(WrapperObject.prototype);gp_Lin.prototype.constructor=gp_Lin;gp_Lin.prototype.__class__=gp_Lin;gp_Lin.__cache__={};Module["gp_Lin"]=gp_Lin;gp_Lin.prototype["__destroy__"]=gp_Lin.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_gp_Lin___destroy___0(self)};function Handle_Message_ProgressIndicator(thePtr){if(thePtr&&typeof thePtr==="object")thePtr=thePtr.ptr;if(thePtr===undefined){this.ptr=_emscripten_bind_Handle_Message_ProgressIndicator_Handle_Message_ProgressIndicator_0();getCache(Handle_Message_ProgressIndicator)[this.ptr]=this;return}this.ptr=_emscripten_bind_Handle_Message_ProgressIndicator_Handle_Message_ProgressIndicator_1(thePtr);getCache(Handle_Message_ProgressIndicator)[this.ptr]=this}Handle_Message_ProgressIndicator.prototype=Object.create(WrapperObject.prototype);Handle_Message_ProgressIndicator.prototype.constructor=Handle_Message_ProgressIndicator;Handle_Message_ProgressIndicator.prototype.__class__=Handle_Message_ProgressIndicator;Handle_Message_ProgressIndicator.__cache__={};Module["Handle_Message_ProgressIndicator"]=Handle_Message_ProgressIndicator;Handle_Message_ProgressIndicator.prototype["IsNull"]=Handle_Message_ProgressIndicator.prototype.IsNull=function(){var self=this.ptr;return!!_emscripten_bind_Handle_Message_ProgressIndicator_IsNull_0(self)};Handle_Message_ProgressIndicator.prototype["Nullify"]=Handle_Message_ProgressIndicator.prototype.Nullify=function(){var self=this.ptr;_emscripten_bind_Handle_Message_ProgressIndicator_Nullify_0(self)};Handle_Message_ProgressIndicator.prototype["get"]=Handle_Message_ProgressIndicator.prototype.get=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Handle_Message_ProgressIndicator_get_0(self),Message_ProgressIndicator)};Handle_Message_ProgressIndicator.prototype["__destroy__"]=Handle_Message_ProgressIndicator.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Handle_Message_ProgressIndicator___destroy___0(self)};function GC_MakeArcOfParabola(Parab,Alpha1,Alpha2,Sense){if(Parab&&typeof Parab==="object")Parab=Parab.ptr;if(Alpha1&&typeof Alpha1==="object")Alpha1=Alpha1.ptr;if(Alpha2&&typeof Alpha2==="object")Alpha2=Alpha2.ptr;if(Sense&&typeof Sense==="object")Sense=Sense.ptr;this.ptr=_emscripten_bind_GC_MakeArcOfParabola_GC_MakeArcOfParabola_4(Parab,Alpha1,Alpha2,Sense);getCache(GC_MakeArcOfParabola)[this.ptr]=this}GC_MakeArcOfParabola.prototype=Object.create(WrapperObject.prototype);GC_MakeArcOfParabola.prototype.constructor=GC_MakeArcOfParabola;GC_MakeArcOfParabola.prototype.__class__=GC_MakeArcOfParabola;GC_MakeArcOfParabola.__cache__={};Module["GC_MakeArcOfParabola"]=GC_MakeArcOfParabola;GC_MakeArcOfParabola.prototype["Value"]=GC_MakeArcOfParabola.prototype.Value=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_GC_MakeArcOfParabola_Value_0(self),Handle_Geom_TrimmedCurve)};GC_MakeArcOfParabola.prototype["__destroy__"]=GC_MakeArcOfParabola.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_GC_MakeArcOfParabola___destroy___0(self)};function BRepBuilderAPI_MakePolygon(V1,V2,V3,V4,Close){if(V1&&typeof V1==="object")V1=V1.ptr;if(V2&&typeof V2==="object")V2=V2.ptr;if(V3&&typeof V3==="object")V3=V3.ptr;if(V4&&typeof V4==="object")V4=V4.ptr;if(Close&&typeof Close==="object")Close=Close.ptr;if(V1===undefined){this.ptr=_emscripten_bind_BRepBuilderAPI_MakePolygon_BRepBuilderAPI_MakePolygon_0();getCache(BRepBuilderAPI_MakePolygon)[this.ptr]=this;return}if(V2===undefined){this.ptr=_emscripten_bind_BRepBuilderAPI_MakePolygon_BRepBuilderAPI_MakePolygon_1(V1);getCache(BRepBuilderAPI_MakePolygon)[this.ptr]=this;return}if(V3===undefined){this.ptr=_emscripten_bind_BRepBuilderAPI_MakePolygon_BRepBuilderAPI_MakePolygon_2(V1,V2);getCache(BRepBuilderAPI_MakePolygon)[this.ptr]=this;return}if(V4===undefined){this.ptr=_emscripten_bind_BRepBuilderAPI_MakePolygon_BRepBuilderAPI_MakePolygon_3(V1,V2,V3);getCache(BRepBuilderAPI_MakePolygon)[this.ptr]=this;return}if(Close===undefined){this.ptr=_emscripten_bind_BRepBuilderAPI_MakePolygon_BRepBuilderAPI_MakePolygon_4(V1,V2,V3,V4);getCache(BRepBuilderAPI_MakePolygon)[this.ptr]=this;return}this.ptr=_emscripten_bind_BRepBuilderAPI_MakePolygon_BRepBuilderAPI_MakePolygon_5(V1,V2,V3,V4,Close);getCache(BRepBuilderAPI_MakePolygon)[this.ptr]=this}BRepBuilderAPI_MakePolygon.prototype=Object.create(BRepBuilderAPI_MakeShape.prototype);BRepBuilderAPI_MakePolygon.prototype.constructor=BRepBuilderAPI_MakePolygon;BRepBuilderAPI_MakePolygon.prototype.__class__=BRepBuilderAPI_MakePolygon;BRepBuilderAPI_MakePolygon.__cache__={};Module["BRepBuilderAPI_MakePolygon"]=BRepBuilderAPI_MakePolygon;BRepBuilderAPI_MakePolygon.prototype["Add"]=BRepBuilderAPI_MakePolygon.prototype.Add=function(V){var self=this.ptr;if(V&&typeof V==="object")V=V.ptr;_emscripten_bind_BRepBuilderAPI_MakePolygon_Add_1(self,V)};BRepBuilderAPI_MakePolygon.prototype["Added"]=BRepBuilderAPI_MakePolygon.prototype.Added=function(){var self=this.ptr;return!!_emscripten_bind_BRepBuilderAPI_MakePolygon_Added_0(self)};BRepBuilderAPI_MakePolygon.prototype["Close"]=BRepBuilderAPI_MakePolygon.prototype.Close=function(){var self=this.ptr;_emscripten_bind_BRepBuilderAPI_MakePolygon_Close_0(self)};BRepBuilderAPI_MakePolygon.prototype["FirstVertex"]=BRepBuilderAPI_MakePolygon.prototype.FirstVertex=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepBuilderAPI_MakePolygon_FirstVertex_0(self),TopoDS_Vertex)};BRepBuilderAPI_MakePolygon.prototype["LastVertex"]=BRepBuilderAPI_MakePolygon.prototype.LastVertex=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepBuilderAPI_MakePolygon_LastVertex_0(self),TopoDS_Vertex)};BRepBuilderAPI_MakePolygon.prototype["IsDone"]=BRepBuilderAPI_MakePolygon.prototype.IsDone=function(){var self=this.ptr;return!!_emscripten_bind_BRepBuilderAPI_MakePolygon_IsDone_0(self)};BRepBuilderAPI_MakePolygon.prototype["Edge"]=BRepBuilderAPI_MakePolygon.prototype.Edge=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepBuilderAPI_MakePolygon_Edge_0(self),TopoDS_Edge)};BRepBuilderAPI_MakePolygon.prototype["Wire"]=BRepBuilderAPI_MakePolygon.prototype.Wire=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepBuilderAPI_MakePolygon_Wire_0(self),TopoDS_Wire)};BRepBuilderAPI_MakePolygon.prototype["Shape"]=BRepBuilderAPI_MakePolygon.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepBuilderAPI_MakePolygon_Shape_0(self),TopoDS_Shape)};BRepBuilderAPI_MakePolygon.prototype["__destroy__"]=BRepBuilderAPI_MakePolygon.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepBuilderAPI_MakePolygon___destroy___0(self)};function gp_Circ(A2,Radius){if(A2&&typeof A2==="object")A2=A2.ptr;if(Radius&&typeof Radius==="object")Radius=Radius.ptr;if(A2===undefined){this.ptr=_emscripten_bind_gp_Circ_gp_Circ_0();getCache(gp_Circ)[this.ptr]=this;return}if(Radius===undefined){this.ptr=_emscripten_bind_gp_Circ_gp_Circ_1(A2);getCache(gp_Circ)[this.ptr]=this;return}this.ptr=_emscripten_bind_gp_Circ_gp_Circ_2(A2,Radius);getCache(gp_Circ)[this.ptr]=this}gp_Circ.prototype=Object.create(WrapperObject.prototype);gp_Circ.prototype.constructor=gp_Circ;gp_Circ.prototype.__class__=gp_Circ;gp_Circ.__cache__={};Module["gp_Circ"]=gp_Circ;gp_Circ.prototype["Radius"]=gp_Circ.prototype.Radius=function(){var self=this.ptr;return _emscripten_bind_gp_Circ_Radius_0(self)};gp_Circ.prototype["Length"]=gp_Circ.prototype.Length=function(){var self=this.ptr;return _emscripten_bind_gp_Circ_Length_0(self)};gp_Circ.prototype["Area"]=gp_Circ.prototype.Area=function(){var self=this.ptr;return _emscripten_bind_gp_Circ_Area_0(self)};gp_Circ.prototype["__destroy__"]=gp_Circ.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_gp_Circ___destroy___0(self)};function Handle_ShapeFix_Shell(){throw"cannot construct a Handle_ShapeFix_Shell, no constructor in IDL"}Handle_ShapeFix_Shell.prototype=Object.create(WrapperObject.prototype);Handle_ShapeFix_Shell.prototype.constructor=Handle_ShapeFix_Shell;Handle_ShapeFix_Shell.prototype.__class__=Handle_ShapeFix_Shell;Handle_ShapeFix_Shell.__cache__={};Module["Handle_ShapeFix_Shell"]=Handle_ShapeFix_Shell;Handle_ShapeFix_Shell.prototype["IsNull"]=Handle_ShapeFix_Shell.prototype.IsNull=function(){var self=this.ptr;return!!_emscripten_bind_Handle_ShapeFix_Shell_IsNull_0(self)};Handle_ShapeFix_Shell.prototype["get"]=Handle_ShapeFix_Shell.prototype.get=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Handle_ShapeFix_Shell_get_0(self),ShapeFix_Shell)};Handle_ShapeFix_Shell.prototype["__destroy__"]=Handle_ShapeFix_Shell.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Handle_ShapeFix_Shell___destroy___0(self)};function BRepPrimAPI_MakeRevolution(Axes,Meridian,VMin,VMax,angle){if(Axes&&typeof Axes==="object")Axes=Axes.ptr;if(Meridian&&typeof Meridian==="object")Meridian=Meridian.ptr;if(VMin&&typeof VMin==="object")VMin=VMin.ptr;if(VMax&&typeof VMax==="object")VMax=VMax.ptr;if(angle&&typeof angle==="object")angle=angle.ptr;if(Meridian===undefined){this.ptr=_emscripten_bind_BRepPrimAPI_MakeRevolution_BRepPrimAPI_MakeRevolution_1(Axes);getCache(BRepPrimAPI_MakeRevolution)[this.ptr]=this;return}if(VMin===undefined){this.ptr=_emscripten_bind_BRepPrimAPI_MakeRevolution_BRepPrimAPI_MakeRevolution_2(Axes,Meridian);getCache(BRepPrimAPI_MakeRevolution)[this.ptr]=this;return}if(VMax===undefined){this.ptr=_emscripten_bind_BRepPrimAPI_MakeRevolution_BRepPrimAPI_MakeRevolution_3(Axes,Meridian,VMin);getCache(BRepPrimAPI_MakeRevolution)[this.ptr]=this;return}if(angle===undefined){this.ptr=_emscripten_bind_BRepPrimAPI_MakeRevolution_BRepPrimAPI_MakeRevolution_4(Axes,Meridian,VMin,VMax);getCache(BRepPrimAPI_MakeRevolution)[this.ptr]=this;return}this.ptr=_emscripten_bind_BRepPrimAPI_MakeRevolution_BRepPrimAPI_MakeRevolution_5(Axes,Meridian,VMin,VMax,angle);getCache(BRepPrimAPI_MakeRevolution)[this.ptr]=this}BRepPrimAPI_MakeRevolution.prototype=Object.create(BRepPrimAPI_MakeOneAxis.prototype);BRepPrimAPI_MakeRevolution.prototype.constructor=BRepPrimAPI_MakeRevolution;BRepPrimAPI_MakeRevolution.prototype.__class__=BRepPrimAPI_MakeRevolution;BRepPrimAPI_MakeRevolution.__cache__={};Module["BRepPrimAPI_MakeRevolution"]=BRepPrimAPI_MakeRevolution;BRepPrimAPI_MakeRevolution.prototype["Shape"]=BRepPrimAPI_MakeRevolution.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeRevolution_Shape_0(self),TopoDS_Shape)};BRepPrimAPI_MakeRevolution.prototype["Build"]=BRepPrimAPI_MakeRevolution.prototype.Build=function(){var self=this.ptr;_emscripten_bind_BRepPrimAPI_MakeRevolution_Build_0(self)};BRepPrimAPI_MakeRevolution.prototype["Face"]=BRepPrimAPI_MakeRevolution.prototype.Face=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeRevolution_Face_0(self),TopoDS_Face)};BRepPrimAPI_MakeRevolution.prototype["Shell"]=BRepPrimAPI_MakeRevolution.prototype.Shell=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeRevolution_Shell_0(self),TopoDS_Shell)};BRepPrimAPI_MakeRevolution.prototype["Solid"]=BRepPrimAPI_MakeRevolution.prototype.Solid=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeRevolution_Solid_0(self),TopoDS_Solid)};BRepPrimAPI_MakeRevolution.prototype["__destroy__"]=BRepPrimAPI_MakeRevolution.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepPrimAPI_MakeRevolution___destroy___0(self)};function IGESControl_Reader(){this.ptr=_emscripten_bind_IGESControl_Reader_IGESControl_Reader_0();getCache(IGESControl_Reader)[this.ptr]=this}IGESControl_Reader.prototype=Object.create(XSControl_Reader.prototype);IGESControl_Reader.prototype.constructor=IGESControl_Reader;IGESControl_Reader.prototype.__class__=IGESControl_Reader;IGESControl_Reader.__cache__={};Module["IGESControl_Reader"]=IGESControl_Reader;IGESControl_Reader.prototype["SetNorm"]=IGESControl_Reader.prototype.SetNorm=function(norm){var self=this.ptr;ensureCache.prepare();if(norm&&typeof norm==="object")norm=norm.ptr;else norm=ensureString(norm);return!!_emscripten_bind_IGESControl_Reader_SetNorm_1(self,norm)};IGESControl_Reader.prototype["SetWS"]=IGESControl_Reader.prototype.SetWS=function(WS,scratch){var self=this.ptr;if(WS&&typeof WS==="object")WS=WS.ptr;if(scratch&&typeof scratch==="object")scratch=scratch.ptr;if(scratch===undefined){_emscripten_bind_IGESControl_Reader_SetWS_1(self,WS);return}_emscripten_bind_IGESControl_Reader_SetWS_2(self,WS,scratch)};IGESControl_Reader.prototype["WS"]=IGESControl_Reader.prototype.WS=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_IGESControl_Reader_WS_0(self),Handle_XSControl_WorkSession)};IGESControl_Reader.prototype["ReadFile"]=IGESControl_Reader.prototype.ReadFile=function(filename){var self=this.ptr;ensureCache.prepare();if(filename&&typeof filename==="object")filename=filename.ptr;else filename=ensureString(filename);return _emscripten_bind_IGESControl_Reader_ReadFile_1(self,filename)};IGESControl_Reader.prototype["NbRootsForTransfer"]=IGESControl_Reader.prototype.NbRootsForTransfer=function(){var self=this.ptr;return _emscripten_bind_IGESControl_Reader_NbRootsForTransfer_0(self)};IGESControl_Reader.prototype["TransferOneRoot"]=IGESControl_Reader.prototype.TransferOneRoot=function(num){var self=this.ptr;if(num&&typeof num==="object")num=num.ptr;if(num===undefined){return!!_emscripten_bind_IGESControl_Reader_TransferOneRoot_0(self)}return!!_emscripten_bind_IGESControl_Reader_TransferOneRoot_1(self,num)};IGESControl_Reader.prototype["TransferOne"]=IGESControl_Reader.prototype.TransferOne=function(num){var self=this.ptr;if(num&&typeof num==="object")num=num.ptr;return!!_emscripten_bind_IGESControl_Reader_TransferOne_1(self,num)};IGESControl_Reader.prototype["TransferRoots"]=IGESControl_Reader.prototype.TransferRoots=function(){var self=this.ptr;return _emscripten_bind_IGESControl_Reader_TransferRoots_0(self)};IGESControl_Reader.prototype["ClearShapes"]=IGESControl_Reader.prototype.ClearShapes=function(){var self=this.ptr;_emscripten_bind_IGESControl_Reader_ClearShapes_0(self)};IGESControl_Reader.prototype["NbShapes"]=IGESControl_Reader.prototype.NbShapes=function(){var self=this.ptr;return _emscripten_bind_IGESControl_Reader_NbShapes_0(self)};IGESControl_Reader.prototype["Shape"]=IGESControl_Reader.prototype.Shape=function(num){var self=this.ptr;if(num&&typeof num==="object")num=num.ptr;if(num===undefined){return wrapPointer(_emscripten_bind_IGESControl_Reader_Shape_0(self),TopoDS_Shape)}return wrapPointer(_emscripten_bind_IGESControl_Reader_Shape_1(self,num),TopoDS_Shape)};IGESControl_Reader.prototype["OneShape"]=IGESControl_Reader.prototype.OneShape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_IGESControl_Reader_OneShape_0(self),TopoDS_Shape)};IGESControl_Reader.prototype["PrintStatsTransfer"]=IGESControl_Reader.prototype.PrintStatsTransfer=function(what,mode){var self=this.ptr;if(what&&typeof what==="object")what=what.ptr;if(mode&&typeof mode==="object")mode=mode.ptr;if(mode===undefined){_emscripten_bind_IGESControl_Reader_PrintStatsTransfer_1(self,what);return}_emscripten_bind_IGESControl_Reader_PrintStatsTransfer_2(self,what,mode)};IGESControl_Reader.prototype["__destroy__"]=IGESControl_Reader.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_IGESControl_Reader___destroy___0(self)};function BRepPrimAPI_MakeBox(Axes,dx,dy,dz){if(Axes&&typeof Axes==="object")Axes=Axes.ptr;if(dx&&typeof dx==="object")dx=dx.ptr;if(dy&&typeof dy==="object")dy=dy.ptr;if(dz&&typeof dz==="object")dz=dz.ptr;if(dy===undefined){this.ptr=_emscripten_bind_BRepPrimAPI_MakeBox_BRepPrimAPI_MakeBox_2(Axes,dx);getCache(BRepPrimAPI_MakeBox)[this.ptr]=this;return}if(dz===undefined){this.ptr=_emscripten_bind_BRepPrimAPI_MakeBox_BRepPrimAPI_MakeBox_3(Axes,dx,dy);getCache(BRepPrimAPI_MakeBox)[this.ptr]=this;return}this.ptr=_emscripten_bind_BRepPrimAPI_MakeBox_BRepPrimAPI_MakeBox_4(Axes,dx,dy,dz);getCache(BRepPrimAPI_MakeBox)[this.ptr]=this}BRepPrimAPI_MakeBox.prototype=Object.create(BRepBuilderAPI_MakeShape.prototype);BRepPrimAPI_MakeBox.prototype.constructor=BRepPrimAPI_MakeBox;BRepPrimAPI_MakeBox.prototype.__class__=BRepPrimAPI_MakeBox;BRepPrimAPI_MakeBox.__cache__={};Module["BRepPrimAPI_MakeBox"]=BRepPrimAPI_MakeBox;BRepPrimAPI_MakeBox.prototype["Build"]=BRepPrimAPI_MakeBox.prototype.Build=function(){var self=this.ptr;_emscripten_bind_BRepPrimAPI_MakeBox_Build_0(self)};BRepPrimAPI_MakeBox.prototype["Shell"]=BRepPrimAPI_MakeBox.prototype.Shell=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeBox_Shell_0(self),TopoDS_Shell)};BRepPrimAPI_MakeBox.prototype["Solid"]=BRepPrimAPI_MakeBox.prototype.Solid=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeBox_Solid_0(self),TopoDS_Solid)};BRepPrimAPI_MakeBox.prototype["BottomFace"]=BRepPrimAPI_MakeBox.prototype.BottomFace=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeBox_BottomFace_0(self),TopoDS_Face)};BRepPrimAPI_MakeBox.prototype["BackFace"]=BRepPrimAPI_MakeBox.prototype.BackFace=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeBox_BackFace_0(self),TopoDS_Face)};BRepPrimAPI_MakeBox.prototype["FrontFace"]=BRepPrimAPI_MakeBox.prototype.FrontFace=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeBox_FrontFace_0(self),TopoDS_Face)};BRepPrimAPI_MakeBox.prototype["LeftFace"]=BRepPrimAPI_MakeBox.prototype.LeftFace=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeBox_LeftFace_0(self),TopoDS_Face)};BRepPrimAPI_MakeBox.prototype["RightFace"]=BRepPrimAPI_MakeBox.prototype.RightFace=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeBox_RightFace_0(self),TopoDS_Face)};BRepPrimAPI_MakeBox.prototype["TopFace"]=BRepPrimAPI_MakeBox.prototype.TopFace=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeBox_TopFace_0(self),TopoDS_Face)};BRepPrimAPI_MakeBox.prototype["Shape"]=BRepPrimAPI_MakeBox.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeBox_Shape_0(self),TopoDS_Shape)};BRepPrimAPI_MakeBox.prototype["IsDeleted"]=BRepPrimAPI_MakeBox.prototype.IsDeleted=function(S){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;return!!_emscripten_bind_BRepPrimAPI_MakeBox_IsDeleted_1(self,S)};BRepPrimAPI_MakeBox.prototype["__destroy__"]=BRepPrimAPI_MakeBox.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepPrimAPI_MakeBox___destroy___0(self)};function Handle_Geom_Surface(thePtr){if(thePtr&&typeof thePtr==="object")thePtr=thePtr.ptr;if(thePtr===undefined){this.ptr=_emscripten_bind_Handle_Geom_Surface_Handle_Geom_Surface_0();getCache(Handle_Geom_Surface)[this.ptr]=this;return}this.ptr=_emscripten_bind_Handle_Geom_Surface_Handle_Geom_Surface_1(thePtr);getCache(Handle_Geom_Surface)[this.ptr]=this}Handle_Geom_Surface.prototype=Object.create(WrapperObject.prototype);Handle_Geom_Surface.prototype.constructor=Handle_Geom_Surface;Handle_Geom_Surface.prototype.__class__=Handle_Geom_Surface;Handle_Geom_Surface.__cache__={};Module["Handle_Geom_Surface"]=Handle_Geom_Surface;Handle_Geom_Surface.prototype["IsNull"]=Handle_Geom_Surface.prototype.IsNull=function(){var self=this.ptr;return!!_emscripten_bind_Handle_Geom_Surface_IsNull_0(self)};Handle_Geom_Surface.prototype["Nullify"]=Handle_Geom_Surface.prototype.Nullify=function(){var self=this.ptr;_emscripten_bind_Handle_Geom_Surface_Nullify_0(self)};Handle_Geom_Surface.prototype["get"]=Handle_Geom_Surface.prototype.get=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Handle_Geom_Surface_get_0(self),Geom_Surface)};Handle_Geom_Surface.prototype["__destroy__"]=Handle_Geom_Surface.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Handle_Geom_Surface___destroy___0(self)};function gp_Vec(Xv,Yv,Zv){if(Xv&&typeof Xv==="object")Xv=Xv.ptr;if(Yv&&typeof Yv==="object")Yv=Yv.ptr;if(Zv&&typeof Zv==="object")Zv=Zv.ptr;this.ptr=_emscripten_bind_gp_Vec_gp_Vec_3(Xv,Yv,Zv);getCache(gp_Vec)[this.ptr]=this}gp_Vec.prototype=Object.create(WrapperObject.prototype);gp_Vec.prototype.constructor=gp_Vec;gp_Vec.prototype.__class__=gp_Vec;gp_Vec.__cache__={};Module["gp_Vec"]=gp_Vec;gp_Vec.prototype["X"]=gp_Vec.prototype.X=function(){var self=this.ptr;return _emscripten_bind_gp_Vec_X_0(self)};gp_Vec.prototype["Y"]=gp_Vec.prototype.Y=function(){var self=this.ptr;return _emscripten_bind_gp_Vec_Y_0(self)};gp_Vec.prototype["Z"]=gp_Vec.prototype.Z=function(){var self=this.ptr;return _emscripten_bind_gp_Vec_Z_0(self)};gp_Vec.prototype["__destroy__"]=gp_Vec.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_gp_Vec___destroy___0(self)};function TopExp_Explorer(S,ToFind,ToAvoid){if(S&&typeof S==="object")S=S.ptr;if(ToFind&&typeof ToFind==="object")ToFind=ToFind.ptr;if(ToAvoid&&typeof ToAvoid==="object")ToAvoid=ToAvoid.ptr;if(S===undefined){this.ptr=_emscripten_bind_TopExp_Explorer_TopExp_Explorer_0();getCache(TopExp_Explorer)[this.ptr]=this;return}if(ToFind===undefined){this.ptr=_emscripten_bind_TopExp_Explorer_TopExp_Explorer_1(S);getCache(TopExp_Explorer)[this.ptr]=this;return}if(ToAvoid===undefined){this.ptr=_emscripten_bind_TopExp_Explorer_TopExp_Explorer_2(S,ToFind);getCache(TopExp_Explorer)[this.ptr]=this;return}this.ptr=_emscripten_bind_TopExp_Explorer_TopExp_Explorer_3(S,ToFind,ToAvoid);getCache(TopExp_Explorer)[this.ptr]=this}TopExp_Explorer.prototype=Object.create(WrapperObject.prototype);TopExp_Explorer.prototype.constructor=TopExp_Explorer;TopExp_Explorer.prototype.__class__=TopExp_Explorer;TopExp_Explorer.__cache__={};Module["TopExp_Explorer"]=TopExp_Explorer;TopExp_Explorer.prototype["Init"]=TopExp_Explorer.prototype.Init=function(S,ToFind,ToAvoid){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;if(ToFind&&typeof ToFind==="object")ToFind=ToFind.ptr;if(ToAvoid&&typeof ToAvoid==="object")ToAvoid=ToAvoid.ptr;if(ToAvoid===undefined){_emscripten_bind_TopExp_Explorer_Init_2(self,S,ToFind);return}_emscripten_bind_TopExp_Explorer_Init_3(self,S,ToFind,ToAvoid)};TopExp_Explorer.prototype["More"]=TopExp_Explorer.prototype.More=function(){var self=this.ptr;return!!_emscripten_bind_TopExp_Explorer_More_0(self)};TopExp_Explorer.prototype["Next"]=TopExp_Explorer.prototype.Next=function(){var self=this.ptr;_emscripten_bind_TopExp_Explorer_Next_0(self)};TopExp_Explorer.prototype["Current"]=TopExp_Explorer.prototype.Current=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopExp_Explorer_Current_0(self),TopoDS_Shape)};TopExp_Explorer.prototype["ReInit"]=TopExp_Explorer.prototype.ReInit=function(){var self=this.ptr;_emscripten_bind_TopExp_Explorer_ReInit_0(self)};TopExp_Explorer.prototype["Depth"]=TopExp_Explorer.prototype.Depth=function(){var self=this.ptr;return _emscripten_bind_TopExp_Explorer_Depth_0(self)};TopExp_Explorer.prototype["Clear"]=TopExp_Explorer.prototype.Clear=function(){var self=this.ptr;_emscripten_bind_TopExp_Explorer_Clear_0(self)};TopExp_Explorer.prototype["Destroy"]=TopExp_Explorer.prototype.Destroy=function(){var self=this.ptr;_emscripten_bind_TopExp_Explorer_Destroy_0(self)};TopExp_Explorer.prototype["__destroy__"]=TopExp_Explorer.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_TopExp_Explorer___destroy___0(self)};function Poly_Array1OfTriangle(theLower,theUpper){if(theLower&&typeof theLower==="object")theLower=theLower.ptr;if(theUpper&&typeof theUpper==="object")theUpper=theUpper.ptr;if(theLower===undefined){this.ptr=_emscripten_bind_Poly_Array1OfTriangle_Poly_Array1OfTriangle_0();getCache(Poly_Array1OfTriangle)[this.ptr]=this;return}if(theUpper===undefined){this.ptr=_emscripten_bind_Poly_Array1OfTriangle_Poly_Array1OfTriangle_1(theLower);getCache(Poly_Array1OfTriangle)[this.ptr]=this;return}this.ptr=_emscripten_bind_Poly_Array1OfTriangle_Poly_Array1OfTriangle_2(theLower,theUpper);getCache(Poly_Array1OfTriangle)[this.ptr]=this}Poly_Array1OfTriangle.prototype=Object.create(WrapperObject.prototype);Poly_Array1OfTriangle.prototype.constructor=Poly_Array1OfTriangle;Poly_Array1OfTriangle.prototype.__class__=Poly_Array1OfTriangle;Poly_Array1OfTriangle.__cache__={};Module["Poly_Array1OfTriangle"]=Poly_Array1OfTriangle;Poly_Array1OfTriangle.prototype["Length"]=Poly_Array1OfTriangle.prototype.Length=function(){var self=this.ptr;return _emscripten_bind_Poly_Array1OfTriangle_Length_0(self)};Poly_Array1OfTriangle.prototype["Lower"]=Poly_Array1OfTriangle.prototype.Lower=function(){var self=this.ptr;return _emscripten_bind_Poly_Array1OfTriangle_Lower_0(self)};Poly_Array1OfTriangle.prototype["Upper"]=Poly_Array1OfTriangle.prototype.Upper=function(){var self=this.ptr;return _emscripten_bind_Poly_Array1OfTriangle_Upper_0(self)};Poly_Array1OfTriangle.prototype["Value"]=Poly_Array1OfTriangle.prototype.Value=function(theIndex){var self=this.ptr;if(theIndex&&typeof theIndex==="object")theIndex=theIndex.ptr;return wrapPointer(_emscripten_bind_Poly_Array1OfTriangle_Value_1(self,theIndex),Poly_Triangle)};Poly_Array1OfTriangle.prototype["SetValue"]=Poly_Array1OfTriangle.prototype.SetValue=function(Index,Value){var self=this.ptr;if(Index&&typeof Index==="object")Index=Index.ptr;if(Value&&typeof Value==="object")Value=Value.ptr;_emscripten_bind_Poly_Array1OfTriangle_SetValue_2(self,Index,Value)};Poly_Array1OfTriangle.prototype["__destroy__"]=Poly_Array1OfTriangle.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Poly_Array1OfTriangle___destroy___0(self)};function Geom2d_Ellipse(MajorAxis,MajorRadius,MinorRadius,Sense){if(MajorAxis&&typeof MajorAxis==="object")MajorAxis=MajorAxis.ptr;if(MajorRadius&&typeof MajorRadius==="object")MajorRadius=MajorRadius.ptr;if(MinorRadius&&typeof MinorRadius==="object")MinorRadius=MinorRadius.ptr;if(Sense&&typeof Sense==="object")Sense=Sense.ptr;if(Sense===undefined){this.ptr=_emscripten_bind_Geom2d_Ellipse_Geom2d_Ellipse_3(MajorAxis,MajorRadius,MinorRadius);getCache(Geom2d_Ellipse)[this.ptr]=this;return}this.ptr=_emscripten_bind_Geom2d_Ellipse_Geom2d_Ellipse_4(MajorAxis,MajorRadius,MinorRadius,Sense);getCache(Geom2d_Ellipse)[this.ptr]=this}Geom2d_Ellipse.prototype=Object.create(Geom2d_Conic.prototype);Geom2d_Ellipse.prototype.constructor=Geom2d_Ellipse;Geom2d_Ellipse.prototype.__class__=Geom2d_Ellipse;Geom2d_Ellipse.__cache__={};Module["Geom2d_Ellipse"]=Geom2d_Ellipse;Geom2d_Ellipse.prototype["Period"]=Geom2d_Ellipse.prototype.Period=function(){var self=this.ptr;return _emscripten_bind_Geom2d_Ellipse_Period_0(self)};Geom2d_Ellipse.prototype["Value"]=Geom2d_Ellipse.prototype.Value=function(U){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;return wrapPointer(_emscripten_bind_Geom2d_Ellipse_Value_1(self,U),gp_Pnt2d)};Geom2d_Ellipse.prototype["__destroy__"]=Geom2d_Ellipse.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Geom2d_Ellipse___destroy___0(self)};function BRepOffsetAPI_MakePipeShell(Spine){if(Spine&&typeof Spine==="object")Spine=Spine.ptr;this.ptr=_emscripten_bind_BRepOffsetAPI_MakePipeShell_BRepOffsetAPI_MakePipeShell_1(Spine);getCache(BRepOffsetAPI_MakePipeShell)[this.ptr]=this}BRepOffsetAPI_MakePipeShell.prototype=Object.create(WrapperObject.prototype);BRepOffsetAPI_MakePipeShell.prototype.constructor=BRepOffsetAPI_MakePipeShell;BRepOffsetAPI_MakePipeShell.prototype.__class__=BRepOffsetAPI_MakePipeShell;BRepOffsetAPI_MakePipeShell.__cache__={};Module["BRepOffsetAPI_MakePipeShell"]=BRepOffsetAPI_MakePipeShell;BRepOffsetAPI_MakePipeShell.prototype["SetMode"]=BRepOffsetAPI_MakePipeShell.prototype.SetMode=function(AuxiliarySpine,CurvilinearEquivalence,KeepContact){var self=this.ptr;if(AuxiliarySpine&&typeof AuxiliarySpine==="object")AuxiliarySpine=AuxiliarySpine.ptr;if(CurvilinearEquivalence&&typeof CurvilinearEquivalence==="object")CurvilinearEquivalence=CurvilinearEquivalence.ptr;if(KeepContact&&typeof KeepContact==="object")KeepContact=KeepContact.ptr;if(KeepContact===undefined){_emscripten_bind_BRepOffsetAPI_MakePipeShell_SetMode_2(self,AuxiliarySpine,CurvilinearEquivalence);return}_emscripten_bind_BRepOffsetAPI_MakePipeShell_SetMode_3(self,AuxiliarySpine,CurvilinearEquivalence,KeepContact)};BRepOffsetAPI_MakePipeShell.prototype["Add"]=BRepOffsetAPI_MakePipeShell.prototype.Add=function(Profile,WithContact,WithCorrection){var self=this.ptr;if(Profile&&typeof Profile==="object")Profile=Profile.ptr;if(WithContact&&typeof WithContact==="object")WithContact=WithContact.ptr;if(WithCorrection&&typeof WithCorrection==="object")WithCorrection=WithCorrection.ptr;if(WithContact===undefined){_emscripten_bind_BRepOffsetAPI_MakePipeShell_Add_1(self,Profile);return}if(WithCorrection===undefined){_emscripten_bind_BRepOffsetAPI_MakePipeShell_Add_2(self,Profile,WithContact);return}_emscripten_bind_BRepOffsetAPI_MakePipeShell_Add_3(self,Profile,WithContact,WithCorrection)};BRepOffsetAPI_MakePipeShell.prototype["Build"]=BRepOffsetAPI_MakePipeShell.prototype.Build=function(){var self=this.ptr;_emscripten_bind_BRepOffsetAPI_MakePipeShell_Build_0(self)};BRepOffsetAPI_MakePipeShell.prototype["MakeSolid"]=BRepOffsetAPI_MakePipeShell.prototype.MakeSolid=function(){var self=this.ptr;return!!_emscripten_bind_BRepOffsetAPI_MakePipeShell_MakeSolid_0(self)};BRepOffsetAPI_MakePipeShell.prototype["Generated"]=BRepOffsetAPI_MakePipeShell.prototype.Generated=function(S){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;return wrapPointer(_emscripten_bind_BRepOffsetAPI_MakePipeShell_Generated_1(self,S),TopTools_ListOfShape)};BRepOffsetAPI_MakePipeShell.prototype["FirstShape"]=BRepOffsetAPI_MakePipeShell.prototype.FirstShape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepOffsetAPI_MakePipeShell_FirstShape_0(self),TopoDS_Shape)};BRepOffsetAPI_MakePipeShell.prototype["LastShape"]=BRepOffsetAPI_MakePipeShell.prototype.LastShape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepOffsetAPI_MakePipeShell_LastShape_0(self),TopoDS_Shape)};BRepOffsetAPI_MakePipeShell.prototype["Shape"]=BRepOffsetAPI_MakePipeShell.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepOffsetAPI_MakePipeShell_Shape_0(self),TopoDS_Shape)};BRepOffsetAPI_MakePipeShell.prototype["ErrorOnSurface"]=BRepOffsetAPI_MakePipeShell.prototype.ErrorOnSurface=function(){var self=this.ptr;return _emscripten_bind_BRepOffsetAPI_MakePipeShell_ErrorOnSurface_0(self)};BRepOffsetAPI_MakePipeShell.prototype["GetStatus"]=BRepOffsetAPI_MakePipeShell.prototype.GetStatus=function(){var self=this.ptr;return _emscripten_bind_BRepOffsetAPI_MakePipeShell_GetStatus_0(self)};BRepOffsetAPI_MakePipeShell.prototype["IsReady"]=BRepOffsetAPI_MakePipeShell.prototype.IsReady=function(){var self=this.ptr;return!!_emscripten_bind_BRepOffsetAPI_MakePipeShell_IsReady_0(self)};BRepOffsetAPI_MakePipeShell.prototype["__destroy__"]=BRepOffsetAPI_MakePipeShell.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepOffsetAPI_MakePipeShell___destroy___0(self)};function BRepBuilderAPI_MakeFace(F,W){if(F&&typeof F==="object")F=F.ptr;if(W&&typeof W==="object")W=W.ptr;if(W===undefined){this.ptr=_emscripten_bind_BRepBuilderAPI_MakeFace_BRepBuilderAPI_MakeFace_1(F);getCache(BRepBuilderAPI_MakeFace)[this.ptr]=this;return}this.ptr=_emscripten_bind_BRepBuilderAPI_MakeFace_BRepBuilderAPI_MakeFace_2(F,W);getCache(BRepBuilderAPI_MakeFace)[this.ptr]=this}BRepBuilderAPI_MakeFace.prototype=Object.create(WrapperObject.prototype);BRepBuilderAPI_MakeFace.prototype.constructor=BRepBuilderAPI_MakeFace;BRepBuilderAPI_MakeFace.prototype.__class__=BRepBuilderAPI_MakeFace;BRepBuilderAPI_MakeFace.__cache__={};Module["BRepBuilderAPI_MakeFace"]=BRepBuilderAPI_MakeFace;BRepBuilderAPI_MakeFace.prototype["Face"]=BRepBuilderAPI_MakeFace.prototype.Face=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepBuilderAPI_MakeFace_Face_0(self),TopoDS_Face)};BRepBuilderAPI_MakeFace.prototype["Add"]=BRepBuilderAPI_MakeFace.prototype.Add=function(W){var self=this.ptr;if(W&&typeof W==="object")W=W.ptr;_emscripten_bind_BRepBuilderAPI_MakeFace_Add_1(self,W)};BRepBuilderAPI_MakeFace.prototype["Error"]=BRepBuilderAPI_MakeFace.prototype.Error=function(){var self=this.ptr;return _emscripten_bind_BRepBuilderAPI_MakeFace_Error_0(self)};BRepBuilderAPI_MakeFace.prototype["__destroy__"]=BRepBuilderAPI_MakeFace.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepBuilderAPI_MakeFace___destroy___0(self)};function BRepAlgoAPI_Fuse(S1,S2){if(S1&&typeof S1==="object")S1=S1.ptr;if(S2&&typeof S2==="object")S2=S2.ptr;this.ptr=_emscripten_bind_BRepAlgoAPI_Fuse_BRepAlgoAPI_Fuse_2(S1,S2);getCache(BRepAlgoAPI_Fuse)[this.ptr]=this}BRepAlgoAPI_Fuse.prototype=Object.create(BRepAlgoAPI_BooleanOperation.prototype);BRepAlgoAPI_Fuse.prototype.constructor=BRepAlgoAPI_Fuse;BRepAlgoAPI_Fuse.prototype.__class__=BRepAlgoAPI_Fuse;BRepAlgoAPI_Fuse.__cache__={};Module["BRepAlgoAPI_Fuse"]=BRepAlgoAPI_Fuse;BRepAlgoAPI_Fuse.prototype["Shape"]=BRepAlgoAPI_Fuse.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepAlgoAPI_Fuse_Shape_0(self),TopoDS_Shape)};BRepAlgoAPI_Fuse.prototype["__destroy__"]=BRepAlgoAPI_Fuse.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepAlgoAPI_Fuse___destroy___0(self)};function Handle_Geom2d_TrimmedCurve(thePtr){if(thePtr&&typeof thePtr==="object")thePtr=thePtr.ptr;if(thePtr===undefined){this.ptr=_emscripten_bind_Handle_Geom2d_TrimmedCurve_Handle_Geom2d_TrimmedCurve_0();getCache(Handle_Geom2d_TrimmedCurve)[this.ptr]=this;return}this.ptr=_emscripten_bind_Handle_Geom2d_TrimmedCurve_Handle_Geom2d_TrimmedCurve_1(thePtr);getCache(Handle_Geom2d_TrimmedCurve)[this.ptr]=this}Handle_Geom2d_TrimmedCurve.prototype=Object.create(WrapperObject.prototype);Handle_Geom2d_TrimmedCurve.prototype.constructor=Handle_Geom2d_TrimmedCurve;Handle_Geom2d_TrimmedCurve.prototype.__class__=Handle_Geom2d_TrimmedCurve;Handle_Geom2d_TrimmedCurve.__cache__={};Module["Handle_Geom2d_TrimmedCurve"]=Handle_Geom2d_TrimmedCurve;Handle_Geom2d_TrimmedCurve.prototype["IsNull"]=Handle_Geom2d_TrimmedCurve.prototype.IsNull=function(){var self=this.ptr;return!!_emscripten_bind_Handle_Geom2d_TrimmedCurve_IsNull_0(self)};Handle_Geom2d_TrimmedCurve.prototype["Nullify"]=Handle_Geom2d_TrimmedCurve.prototype.Nullify=function(){var self=this.ptr;_emscripten_bind_Handle_Geom2d_TrimmedCurve_Nullify_0(self)};Handle_Geom2d_TrimmedCurve.prototype["get"]=Handle_Geom2d_TrimmedCurve.prototype.get=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Handle_Geom2d_TrimmedCurve_get_0(self),Geom2d_TrimmedCurve)};Handle_Geom2d_TrimmedCurve.prototype["__destroy__"]=Handle_Geom2d_TrimmedCurve.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Handle_Geom2d_TrimmedCurve___destroy___0(self)};function gp_Parab(A2,Focal){if(A2&&typeof A2==="object")A2=A2.ptr;if(Focal&&typeof Focal==="object")Focal=Focal.ptr;if(A2===undefined){this.ptr=_emscripten_bind_gp_Parab_gp_Parab_0();getCache(gp_Parab)[this.ptr]=this;return}if(Focal===undefined){this.ptr=_emscripten_bind_gp_Parab_gp_Parab_1(A2);getCache(gp_Parab)[this.ptr]=this;return}this.ptr=_emscripten_bind_gp_Parab_gp_Parab_2(A2,Focal);getCache(gp_Parab)[this.ptr]=this}gp_Parab.prototype=Object.create(WrapperObject.prototype);gp_Parab.prototype.constructor=gp_Parab;gp_Parab.prototype.__class__=gp_Parab;gp_Parab.__cache__={};Module["gp_Parab"]=gp_Parab;gp_Parab.prototype["Focal"]=gp_Parab.prototype.Focal=function(){var self=this.ptr;return _emscripten_bind_gp_Parab_Focal_0(self)};gp_Parab.prototype["__destroy__"]=gp_Parab.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_gp_Parab___destroy___0(self)};function gp_XYZ(X,Y,Z){if(X&&typeof X==="object")X=X.ptr;if(Y&&typeof Y==="object")Y=Y.ptr;if(Z&&typeof Z==="object")Z=Z.ptr;this.ptr=_emscripten_bind_gp_XYZ_gp_XYZ_3(X,Y,Z);getCache(gp_XYZ)[this.ptr]=this}gp_XYZ.prototype=Object.create(WrapperObject.prototype);gp_XYZ.prototype.constructor=gp_XYZ;gp_XYZ.prototype.__class__=gp_XYZ;gp_XYZ.__cache__={};Module["gp_XYZ"]=gp_XYZ;gp_XYZ.prototype["SetCoord"]=gp_XYZ.prototype.SetCoord=function(Xp,Yp,Zp){var self=this.ptr;if(Xp&&typeof Xp==="object")Xp=Xp.ptr;if(Yp&&typeof Yp==="object")Yp=Yp.ptr;if(Zp&&typeof Zp==="object")Zp=Zp.ptr;_emscripten_bind_gp_XYZ_SetCoord_3(self,Xp,Yp,Zp)};gp_XYZ.prototype["SetX"]=gp_XYZ.prototype.SetX=function(X){var self=this.ptr;if(X&&typeof X==="object")X=X.ptr;_emscripten_bind_gp_XYZ_SetX_1(self,X)};gp_XYZ.prototype["SetY"]=gp_XYZ.prototype.SetY=function(Y){var self=this.ptr;if(Y&&typeof Y==="object")Y=Y.ptr;_emscripten_bind_gp_XYZ_SetY_1(self,Y)};gp_XYZ.prototype["SetZ"]=gp_XYZ.prototype.SetZ=function(Z){var self=this.ptr;if(Z&&typeof Z==="object")Z=Z.ptr;_emscripten_bind_gp_XYZ_SetZ_1(self,Z)};gp_XYZ.prototype["Coord"]=gp_XYZ.prototype.Coord=function(Index){var self=this.ptr;if(Index&&typeof Index==="object")Index=Index.ptr;return _emscripten_bind_gp_XYZ_Coord_1(self,Index)};gp_XYZ.prototype["X"]=gp_XYZ.prototype.X=function(){var self=this.ptr;return _emscripten_bind_gp_XYZ_X_0(self)};gp_XYZ.prototype["Y"]=gp_XYZ.prototype.Y=function(){var self=this.ptr;return _emscripten_bind_gp_XYZ_Y_0(self)};gp_XYZ.prototype["Z"]=gp_XYZ.prototype.Z=function(){var self=this.ptr;return _emscripten_bind_gp_XYZ_Z_0(self)};gp_XYZ.prototype["IsEqual"]=gp_XYZ.prototype.IsEqual=function(Other,Tolerance){var self=this.ptr;if(Other&&typeof Other==="object")Other=Other.ptr;if(Tolerance&&typeof Tolerance==="object")Tolerance=Tolerance.ptr;return!!_emscripten_bind_gp_XYZ_IsEqual_2(self,Other,Tolerance)};gp_XYZ.prototype["__destroy__"]=gp_XYZ.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_gp_XYZ___destroy___0(self)};function BRepAdaptor_Surface(F,R){if(F&&typeof F==="object")F=F.ptr;if(R&&typeof R==="object")R=R.ptr;if(F===undefined){this.ptr=_emscripten_bind_BRepAdaptor_Surface_BRepAdaptor_Surface_0();getCache(BRepAdaptor_Surface)[this.ptr]=this;return}if(R===undefined){this.ptr=_emscripten_bind_BRepAdaptor_Surface_BRepAdaptor_Surface_1(F);getCache(BRepAdaptor_Surface)[this.ptr]=this;return}this.ptr=_emscripten_bind_BRepAdaptor_Surface_BRepAdaptor_Surface_2(F,R);getCache(BRepAdaptor_Surface)[this.ptr]=this}BRepAdaptor_Surface.prototype=Object.create(WrapperObject.prototype);BRepAdaptor_Surface.prototype.constructor=BRepAdaptor_Surface;BRepAdaptor_Surface.prototype.__class__=BRepAdaptor_Surface;BRepAdaptor_Surface.__cache__={};Module["BRepAdaptor_Surface"]=BRepAdaptor_Surface;BRepAdaptor_Surface.prototype["Initialize"]=BRepAdaptor_Surface.prototype.Initialize=function(F,R){var self=this.ptr;if(F&&typeof F==="object")F=F.ptr;if(R&&typeof R==="object")R=R.ptr;if(R===undefined){_emscripten_bind_BRepAdaptor_Surface_Initialize_1(self,F);return}_emscripten_bind_BRepAdaptor_Surface_Initialize_2(self,F,R)};BRepAdaptor_Surface.prototype["Trsf"]=BRepAdaptor_Surface.prototype.Trsf=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepAdaptor_Surface_Trsf_0(self),gp_Trsf)};BRepAdaptor_Surface.prototype["Face"]=BRepAdaptor_Surface.prototype.Face=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepAdaptor_Surface_Face_0(self),TopoDS_Face)};BRepAdaptor_Surface.prototype["Tolerance"]=BRepAdaptor_Surface.prototype.Tolerance=function(){var self=this.ptr;return _emscripten_bind_BRepAdaptor_Surface_Tolerance_0(self)};BRepAdaptor_Surface.prototype["FirstUParameter"]=BRepAdaptor_Surface.prototype.FirstUParameter=function(){var self=this.ptr;return _emscripten_bind_BRepAdaptor_Surface_FirstUParameter_0(self)};BRepAdaptor_Surface.prototype["LastUParameter"]=BRepAdaptor_Surface.prototype.LastUParameter=function(){var self=this.ptr;return _emscripten_bind_BRepAdaptor_Surface_LastUParameter_0(self)};BRepAdaptor_Surface.prototype["FirstVParameter"]=BRepAdaptor_Surface.prototype.FirstVParameter=function(){var self=this.ptr;return _emscripten_bind_BRepAdaptor_Surface_FirstVParameter_0(self)};BRepAdaptor_Surface.prototype["LastVParameter"]=BRepAdaptor_Surface.prototype.LastVParameter=function(){var self=this.ptr;return _emscripten_bind_BRepAdaptor_Surface_LastVParameter_0(self)};BRepAdaptor_Surface.prototype["IsUClosed"]=BRepAdaptor_Surface.prototype.IsUClosed=function(){var self=this.ptr;return!!_emscripten_bind_BRepAdaptor_Surface_IsUClosed_0(self)};BRepAdaptor_Surface.prototype["IsVClosed"]=BRepAdaptor_Surface.prototype.IsVClosed=function(){var self=this.ptr;return!!_emscripten_bind_BRepAdaptor_Surface_IsVClosed_0(self)};BRepAdaptor_Surface.prototype["IsUPeriodic"]=BRepAdaptor_Surface.prototype.IsUPeriodic=function(){var self=this.ptr;return!!_emscripten_bind_BRepAdaptor_Surface_IsUPeriodic_0(self)};BRepAdaptor_Surface.prototype["UPeriod"]=BRepAdaptor_Surface.prototype.UPeriod=function(){var self=this.ptr;return _emscripten_bind_BRepAdaptor_Surface_UPeriod_0(self)};BRepAdaptor_Surface.prototype["IsVPeriodic"]=BRepAdaptor_Surface.prototype.IsVPeriodic=function(){var self=this.ptr;return!!_emscripten_bind_BRepAdaptor_Surface_IsVPeriodic_0(self)};BRepAdaptor_Surface.prototype["VPeriod"]=BRepAdaptor_Surface.prototype.VPeriod=function(){var self=this.ptr;return _emscripten_bind_BRepAdaptor_Surface_VPeriod_0(self)};BRepAdaptor_Surface.prototype["Value"]=BRepAdaptor_Surface.prototype.Value=function(U,V){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(V&&typeof V==="object")V=V.ptr;return wrapPointer(_emscripten_bind_BRepAdaptor_Surface_Value_2(self,U,V),gp_Pnt)};BRepAdaptor_Surface.prototype["D0"]=BRepAdaptor_Surface.prototype.D0=function(U,V,P){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(V&&typeof V==="object")V=V.ptr;if(P&&typeof P==="object")P=P.ptr;_emscripten_bind_BRepAdaptor_Surface_D0_3(self,U,V,P)};BRepAdaptor_Surface.prototype["D1"]=BRepAdaptor_Surface.prototype.D1=function(U,V,P,D1U,D1V){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(V&&typeof V==="object")V=V.ptr;if(P&&typeof P==="object")P=P.ptr;if(D1U&&typeof D1U==="object")D1U=D1U.ptr;if(D1V&&typeof D1V==="object")D1V=D1V.ptr;_emscripten_bind_BRepAdaptor_Surface_D1_5(self,U,V,P,D1U,D1V)};BRepAdaptor_Surface.prototype["D2"]=BRepAdaptor_Surface.prototype.D2=function(U,V,P,D1U,D1V,D2U,D2V,D2UV){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(V&&typeof V==="object")V=V.ptr;if(P&&typeof P==="object")P=P.ptr;if(D1U&&typeof D1U==="object")D1U=D1U.ptr;if(D1V&&typeof D1V==="object")D1V=D1V.ptr;if(D2U&&typeof D2U==="object")D2U=D2U.ptr;if(D2V&&typeof D2V==="object")D2V=D2V.ptr;if(D2UV&&typeof D2UV==="object")D2UV=D2UV.ptr;_emscripten_bind_BRepAdaptor_Surface_D2_8(self,U,V,P,D1U,D1V,D2U,D2V,D2UV)};BRepAdaptor_Surface.prototype["D3"]=BRepAdaptor_Surface.prototype.D3=function(U,V,P,D1U,D1V,D2U,D2V,D2UV,D3U,D3V,D3UUV,D3UVV){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(V&&typeof V==="object")V=V.ptr;if(P&&typeof P==="object")P=P.ptr;if(D1U&&typeof D1U==="object")D1U=D1U.ptr;if(D1V&&typeof D1V==="object")D1V=D1V.ptr;if(D2U&&typeof D2U==="object")D2U=D2U.ptr;if(D2V&&typeof D2V==="object")D2V=D2V.ptr;if(D2UV&&typeof D2UV==="object")D2UV=D2UV.ptr;if(D3U&&typeof D3U==="object")D3U=D3U.ptr;if(D3V&&typeof D3V==="object")D3V=D3V.ptr;if(D3UUV&&typeof D3UUV==="object")D3UUV=D3UUV.ptr;if(D3UVV&&typeof D3UVV==="object")D3UVV=D3UVV.ptr;_emscripten_bind_BRepAdaptor_Surface_D3_12(self,U,V,P,D1U,D1V,D2U,D2V,D2UV,D3U,D3V,D3UUV,D3UVV)};BRepAdaptor_Surface.prototype["DN"]=BRepAdaptor_Surface.prototype.DN=function(U,V,Nu,Nv){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(V&&typeof V==="object")V=V.ptr;if(Nu&&typeof Nu==="object")Nu=Nu.ptr;if(Nv&&typeof Nv==="object")Nv=Nv.ptr;return wrapPointer(_emscripten_bind_BRepAdaptor_Surface_DN_4(self,U,V,Nu,Nv),gp_Vec)};BRepAdaptor_Surface.prototype["UResolution"]=BRepAdaptor_Surface.prototype.UResolution=function(R3d){var self=this.ptr;if(R3d&&typeof R3d==="object")R3d=R3d.ptr;return _emscripten_bind_BRepAdaptor_Surface_UResolution_1(self,R3d)};BRepAdaptor_Surface.prototype["VResolution"]=BRepAdaptor_Surface.prototype.VResolution=function(R3d){var self=this.ptr;if(R3d&&typeof R3d==="object")R3d=R3d.ptr;return _emscripten_bind_BRepAdaptor_Surface_VResolution_1(self,R3d)};BRepAdaptor_Surface.prototype["GetType"]=BRepAdaptor_Surface.prototype.GetType=function(){var self=this.ptr;return _emscripten_bind_BRepAdaptor_Surface_GetType_0(self)};BRepAdaptor_Surface.prototype["Plane"]=BRepAdaptor_Surface.prototype.Plane=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepAdaptor_Surface_Plane_0(self),gp_Pln)};BRepAdaptor_Surface.prototype["UDegree"]=BRepAdaptor_Surface.prototype.UDegree=function(){var self=this.ptr;return _emscripten_bind_BRepAdaptor_Surface_UDegree_0(self)};BRepAdaptor_Surface.prototype["NbUPoles"]=BRepAdaptor_Surface.prototype.NbUPoles=function(){var self=this.ptr;return _emscripten_bind_BRepAdaptor_Surface_NbUPoles_0(self)};BRepAdaptor_Surface.prototype["VDegree"]=BRepAdaptor_Surface.prototype.VDegree=function(){var self=this.ptr;return _emscripten_bind_BRepAdaptor_Surface_VDegree_0(self)};BRepAdaptor_Surface.prototype["NbVPoles"]=BRepAdaptor_Surface.prototype.NbVPoles=function(){var self=this.ptr;return _emscripten_bind_BRepAdaptor_Surface_NbVPoles_0(self)};BRepAdaptor_Surface.prototype["NbUKnots"]=BRepAdaptor_Surface.prototype.NbUKnots=function(){var self=this.ptr;return _emscripten_bind_BRepAdaptor_Surface_NbUKnots_0(self)};BRepAdaptor_Surface.prototype["NbVKnots"]=BRepAdaptor_Surface.prototype.NbVKnots=function(){var self=this.ptr;return _emscripten_bind_BRepAdaptor_Surface_NbVKnots_0(self)};BRepAdaptor_Surface.prototype["IsURational"]=BRepAdaptor_Surface.prototype.IsURational=function(){var self=this.ptr;return!!_emscripten_bind_BRepAdaptor_Surface_IsURational_0(self)};BRepAdaptor_Surface.prototype["IsVRational"]=BRepAdaptor_Surface.prototype.IsVRational=function(){var self=this.ptr;return!!_emscripten_bind_BRepAdaptor_Surface_IsVRational_0(self)};BRepAdaptor_Surface.prototype["AxeOfRevolution"]=BRepAdaptor_Surface.prototype.AxeOfRevolution=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepAdaptor_Surface_AxeOfRevolution_0(self),gp_Ax1)};BRepAdaptor_Surface.prototype["Direction"]=BRepAdaptor_Surface.prototype.Direction=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepAdaptor_Surface_Direction_0(self),gp_Dir)};BRepAdaptor_Surface.prototype["OffsetValue"]=BRepAdaptor_Surface.prototype.OffsetValue=function(){var self=this.ptr;return _emscripten_bind_BRepAdaptor_Surface_OffsetValue_0(self)};BRepAdaptor_Surface.prototype["__destroy__"]=BRepAdaptor_Surface.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepAdaptor_Surface___destroy___0(self)};function BRepPrimAPI_MakeWedge(Axes,dx,dy,dz,xmin,zmin,xmax,zmax){if(Axes&&typeof Axes==="object")Axes=Axes.ptr;if(dx&&typeof dx==="object")dx=dx.ptr;if(dy&&typeof dy==="object")dy=dy.ptr;if(dz&&typeof dz==="object")dz=dz.ptr;if(xmin&&typeof xmin==="object")xmin=xmin.ptr;if(zmin&&typeof zmin==="object")zmin=zmin.ptr;if(xmax&&typeof xmax==="object")xmax=xmax.ptr;if(zmax&&typeof zmax==="object")zmax=zmax.ptr;if(xmin===undefined){this.ptr=_emscripten_bind_BRepPrimAPI_MakeWedge_BRepPrimAPI_MakeWedge_4(Axes,dx,dy,dz);getCache(BRepPrimAPI_MakeWedge)[this.ptr]=this;return}if(zmin===undefined){this.ptr=_emscripten_bind_BRepPrimAPI_MakeWedge_BRepPrimAPI_MakeWedge_5(Axes,dx,dy,dz,xmin);getCache(BRepPrimAPI_MakeWedge)[this.ptr]=this;return}if(xmax===undefined){this.ptr=_emscripten_bind_BRepPrimAPI_MakeWedge_BRepPrimAPI_MakeWedge_6(Axes,dx,dy,dz,xmin,zmin);getCache(BRepPrimAPI_MakeWedge)[this.ptr]=this;return}if(zmax===undefined){this.ptr=_emscripten_bind_BRepPrimAPI_MakeWedge_BRepPrimAPI_MakeWedge_7(Axes,dx,dy,dz,xmin,zmin,xmax);getCache(BRepPrimAPI_MakeWedge)[this.ptr]=this;return}this.ptr=_emscripten_bind_BRepPrimAPI_MakeWedge_BRepPrimAPI_MakeWedge_8(Axes,dx,dy,dz,xmin,zmin,xmax,zmax);getCache(BRepPrimAPI_MakeWedge)[this.ptr]=this}BRepPrimAPI_MakeWedge.prototype=Object.create(BRepBuilderAPI_MakeShape.prototype);BRepPrimAPI_MakeWedge.prototype.constructor=BRepPrimAPI_MakeWedge;BRepPrimAPI_MakeWedge.prototype.__class__=BRepPrimAPI_MakeWedge;BRepPrimAPI_MakeWedge.__cache__={};Module["BRepPrimAPI_MakeWedge"]=BRepPrimAPI_MakeWedge;BRepPrimAPI_MakeWedge.prototype["Build"]=BRepPrimAPI_MakeWedge.prototype.Build=function(){var self=this.ptr;_emscripten_bind_BRepPrimAPI_MakeWedge_Build_0(self)};BRepPrimAPI_MakeWedge.prototype["Shell"]=BRepPrimAPI_MakeWedge.prototype.Shell=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeWedge_Shell_0(self),TopoDS_Shell)};BRepPrimAPI_MakeWedge.prototype["Solid"]=BRepPrimAPI_MakeWedge.prototype.Solid=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeWedge_Solid_0(self),TopoDS_Solid)};BRepPrimAPI_MakeWedge.prototype["Shape"]=BRepPrimAPI_MakeWedge.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeWedge_Shape_0(self),TopoDS_Shape)};BRepPrimAPI_MakeWedge.prototype["__destroy__"]=BRepPrimAPI_MakeWedge.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepPrimAPI_MakeWedge___destroy___0(self)};function Geom_BezierCurve(CurvePoles,PoleWeights){if(CurvePoles&&typeof CurvePoles==="object")CurvePoles=CurvePoles.ptr;if(PoleWeights&&typeof PoleWeights==="object")PoleWeights=PoleWeights.ptr;if(PoleWeights===undefined){this.ptr=_emscripten_bind_Geom_BezierCurve_Geom_BezierCurve_1(CurvePoles);getCache(Geom_BezierCurve)[this.ptr]=this;return}this.ptr=_emscripten_bind_Geom_BezierCurve_Geom_BezierCurve_2(CurvePoles,PoleWeights);getCache(Geom_BezierCurve)[this.ptr]=this}Geom_BezierCurve.prototype=Object.create(Geom_Curve.prototype);Geom_BezierCurve.prototype.constructor=Geom_BezierCurve;Geom_BezierCurve.prototype.__class__=Geom_BezierCurve;Geom_BezierCurve.__cache__={};Module["Geom_BezierCurve"]=Geom_BezierCurve;Geom_BezierCurve.prototype["Reverse"]=Geom_BezierCurve.prototype.Reverse=function(){var self=this.ptr;_emscripten_bind_Geom_BezierCurve_Reverse_0(self)};Geom_BezierCurve.prototype["ReversedParameter"]=Geom_BezierCurve.prototype.ReversedParameter=function(U){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;return _emscripten_bind_Geom_BezierCurve_ReversedParameter_1(self,U)};Geom_BezierCurve.prototype["IsCN"]=Geom_BezierCurve.prototype.IsCN=function(N){var self=this.ptr;if(N&&typeof N==="object")N=N.ptr;return!!_emscripten_bind_Geom_BezierCurve_IsCN_1(self,N)};Geom_BezierCurve.prototype["FirstParameter"]=Geom_BezierCurve.prototype.FirstParameter=function(){var self=this.ptr;return _emscripten_bind_Geom_BezierCurve_FirstParameter_0(self)};Geom_BezierCurve.prototype["IsClosed"]=Geom_BezierCurve.prototype.IsClosed=function(){var self=this.ptr;return!!_emscripten_bind_Geom_BezierCurve_IsClosed_0(self)};Geom_BezierCurve.prototype["IsPeriodic"]=Geom_BezierCurve.prototype.IsPeriodic=function(){var self=this.ptr;return!!_emscripten_bind_Geom_BezierCurve_IsPeriodic_0(self)};Geom_BezierCurve.prototype["Period"]=Geom_BezierCurve.prototype.Period=function(){var self=this.ptr;return _emscripten_bind_Geom_BezierCurve_Period_0(self)};Geom_BezierCurve.prototype["LastParameter"]=Geom_BezierCurve.prototype.LastParameter=function(){var self=this.ptr;return _emscripten_bind_Geom_BezierCurve_LastParameter_0(self)};Geom_BezierCurve.prototype["StartPoint"]=Geom_BezierCurve.prototype.StartPoint=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Geom_BezierCurve_StartPoint_0(self),gp_Pnt)};Geom_BezierCurve.prototype["D0"]=Geom_BezierCurve.prototype.D0=function(U,P){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;_emscripten_bind_Geom_BezierCurve_D0_2(self,U,P)};Geom_BezierCurve.prototype["D1"]=Geom_BezierCurve.prototype.D1=function(U,P,V1){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;_emscripten_bind_Geom_BezierCurve_D1_3(self,U,P,V1)};Geom_BezierCurve.prototype["D2"]=Geom_BezierCurve.prototype.D2=function(U,P,V1,V2){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;if(V2&&typeof V2==="object")V2=V2.ptr;_emscripten_bind_Geom_BezierCurve_D2_4(self,U,P,V1,V2)};Geom_BezierCurve.prototype["D3"]=Geom_BezierCurve.prototype.D3=function(U,P,V1,V2,V3){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;if(V2&&typeof V2==="object")V2=V2.ptr;if(V3&&typeof V3==="object")V3=V3.ptr;_emscripten_bind_Geom_BezierCurve_D3_5(self,U,P,V1,V2,V3)};Geom_BezierCurve.prototype["DN"]=Geom_BezierCurve.prototype.DN=function(U,N){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(N&&typeof N==="object")N=N.ptr;return wrapPointer(_emscripten_bind_Geom_BezierCurve_DN_2(self,U,N),gp_Vec)};Geom_BezierCurve.prototype["Transform"]=Geom_BezierCurve.prototype.Transform=function(T){var self=this.ptr;if(T&&typeof T==="object")T=T.ptr;_emscripten_bind_Geom_BezierCurve_Transform_1(self,T)};Geom_BezierCurve.prototype["Reversed"]=Geom_BezierCurve.prototype.Reversed=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Geom_BezierCurve_Reversed_0(self),Handle_Geom_Curve)};Geom_BezierCurve.prototype["Value"]=Geom_BezierCurve.prototype.Value=function(U){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;return wrapPointer(_emscripten_bind_Geom_BezierCurve_Value_1(self,U),gp_Pnt)};Geom_BezierCurve.prototype["__destroy__"]=Geom_BezierCurve.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Geom_BezierCurve___destroy___0(self)};function GCE2d_MakeSegment(P1,P2){if(P1&&typeof P1==="object")P1=P1.ptr;if(P2&&typeof P2==="object")P2=P2.ptr;this.ptr=_emscripten_bind_GCE2d_MakeSegment_GCE2d_MakeSegment_2(P1,P2);getCache(GCE2d_MakeSegment)[this.ptr]=this}GCE2d_MakeSegment.prototype=Object.create(WrapperObject.prototype);GCE2d_MakeSegment.prototype.constructor=GCE2d_MakeSegment;GCE2d_MakeSegment.prototype.__class__=GCE2d_MakeSegment;GCE2d_MakeSegment.__cache__={};Module["GCE2d_MakeSegment"]=GCE2d_MakeSegment;GCE2d_MakeSegment.prototype["Value"]=GCE2d_MakeSegment.prototype.Value=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_GCE2d_MakeSegment_Value_0(self),Handle_Geom2d_TrimmedCurve)};GCE2d_MakeSegment.prototype["__destroy__"]=GCE2d_MakeSegment.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_GCE2d_MakeSegment___destroy___0(self)};function Geom_Ellipse(A2,MajorRadius,MinorRadius){if(A2&&typeof A2==="object")A2=A2.ptr;if(MajorRadius&&typeof MajorRadius==="object")MajorRadius=MajorRadius.ptr;if(MinorRadius&&typeof MinorRadius==="object")MinorRadius=MinorRadius.ptr;if(MajorRadius===undefined){this.ptr=_emscripten_bind_Geom_Ellipse_Geom_Ellipse_1(A2);getCache(Geom_Ellipse)[this.ptr]=this;return}if(MinorRadius===undefined){this.ptr=_emscripten_bind_Geom_Ellipse_Geom_Ellipse_2(A2,MajorRadius);getCache(Geom_Ellipse)[this.ptr]=this;return}this.ptr=_emscripten_bind_Geom_Ellipse_Geom_Ellipse_3(A2,MajorRadius,MinorRadius);getCache(Geom_Ellipse)[this.ptr]=this}Geom_Ellipse.prototype=Object.create(Geom_Conic.prototype);Geom_Ellipse.prototype.constructor=Geom_Ellipse;Geom_Ellipse.prototype.__class__=Geom_Ellipse;Geom_Ellipse.__cache__={};Module["Geom_Ellipse"]=Geom_Ellipse;Geom_Ellipse.prototype["MajorRadius"]=Geom_Ellipse.prototype.MajorRadius=function(){var self=this.ptr;return _emscripten_bind_Geom_Ellipse_MajorRadius_0(self)};Geom_Ellipse.prototype["MinorRadius"]=Geom_Ellipse.prototype.MinorRadius=function(){var self=this.ptr;return _emscripten_bind_Geom_Ellipse_MinorRadius_0(self)};Geom_Ellipse.prototype["Reverse"]=Geom_Ellipse.prototype.Reverse=function(){var self=this.ptr;_emscripten_bind_Geom_Ellipse_Reverse_0(self)};Geom_Ellipse.prototype["ReversedParameter"]=Geom_Ellipse.prototype.ReversedParameter=function(U){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;return _emscripten_bind_Geom_Ellipse_ReversedParameter_1(self,U)};Geom_Ellipse.prototype["TransformedParameter"]=Geom_Ellipse.prototype.TransformedParameter=function(U,T){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(T&&typeof T==="object")T=T.ptr;return _emscripten_bind_Geom_Ellipse_TransformedParameter_2(self,U,T)};Geom_Ellipse.prototype["ParametricTransformation"]=Geom_Ellipse.prototype.ParametricTransformation=function(T){var self=this.ptr;if(T&&typeof T==="object")T=T.ptr;return _emscripten_bind_Geom_Ellipse_ParametricTransformation_1(self,T)};Geom_Ellipse.prototype["Reversed"]=Geom_Ellipse.prototype.Reversed=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Geom_Ellipse_Reversed_0(self),Handle_Geom_Curve)};Geom_Ellipse.prototype["FirstParameter"]=Geom_Ellipse.prototype.FirstParameter=function(){var self=this.ptr;return _emscripten_bind_Geom_Ellipse_FirstParameter_0(self)};Geom_Ellipse.prototype["LastParameter"]=Geom_Ellipse.prototype.LastParameter=function(){var self=this.ptr;return _emscripten_bind_Geom_Ellipse_LastParameter_0(self)};Geom_Ellipse.prototype["IsClosed"]=Geom_Ellipse.prototype.IsClosed=function(){var self=this.ptr;return!!_emscripten_bind_Geom_Ellipse_IsClosed_0(self)};Geom_Ellipse.prototype["IsPeriodic"]=Geom_Ellipse.prototype.IsPeriodic=function(){var self=this.ptr;return!!_emscripten_bind_Geom_Ellipse_IsPeriodic_0(self)};Geom_Ellipse.prototype["Period"]=Geom_Ellipse.prototype.Period=function(){var self=this.ptr;return _emscripten_bind_Geom_Ellipse_Period_0(self)};Geom_Ellipse.prototype["IsCN"]=Geom_Ellipse.prototype.IsCN=function(N){var self=this.ptr;if(N&&typeof N==="object")N=N.ptr;return!!_emscripten_bind_Geom_Ellipse_IsCN_1(self,N)};Geom_Ellipse.prototype["D0"]=Geom_Ellipse.prototype.D0=function(U,P){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;_emscripten_bind_Geom_Ellipse_D0_2(self,U,P)};Geom_Ellipse.prototype["D1"]=Geom_Ellipse.prototype.D1=function(U,P,V1){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;_emscripten_bind_Geom_Ellipse_D1_3(self,U,P,V1)};Geom_Ellipse.prototype["D2"]=Geom_Ellipse.prototype.D2=function(U,P,V1,V2){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;if(V2&&typeof V2==="object")V2=V2.ptr;_emscripten_bind_Geom_Ellipse_D2_4(self,U,P,V1,V2)};Geom_Ellipse.prototype["D3"]=Geom_Ellipse.prototype.D3=function(U,P,V1,V2,V3){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;if(V2&&typeof V2==="object")V2=V2.ptr;if(V3&&typeof V3==="object")V3=V3.ptr;_emscripten_bind_Geom_Ellipse_D3_5(self,U,P,V1,V2,V3)};Geom_Ellipse.prototype["DN"]=Geom_Ellipse.prototype.DN=function(U,N){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(N&&typeof N==="object")N=N.ptr;_emscripten_bind_Geom_Ellipse_DN_2(self,U,N)};Geom_Ellipse.prototype["Value"]=Geom_Ellipse.prototype.Value=function(U){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;return wrapPointer(_emscripten_bind_Geom_Ellipse_Value_1(self,U),gp_Pnt)};Geom_Ellipse.prototype["__destroy__"]=Geom_Ellipse.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Geom_Ellipse___destroy___0(self)};function TopoDS_Compound(T2){if(T2&&typeof T2==="object")T2=T2.ptr;if(T2===undefined){this.ptr=_emscripten_bind_TopoDS_Compound_TopoDS_Compound_0();getCache(TopoDS_Compound)[this.ptr]=this;return}this.ptr=_emscripten_bind_TopoDS_Compound_TopoDS_Compound_1(T2);getCache(TopoDS_Compound)[this.ptr]=this}TopoDS_Compound.prototype=Object.create(TopoDS_Shape.prototype);TopoDS_Compound.prototype.constructor=TopoDS_Compound;TopoDS_Compound.prototype.__class__=TopoDS_Compound;TopoDS_Compound.__cache__={};Module["TopoDS_Compound"]=TopoDS_Compound;TopoDS_Compound.prototype["IsNull"]=TopoDS_Compound.prototype.IsNull=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Compound_IsNull_0(self)};TopoDS_Compound.prototype["Nullify"]=TopoDS_Compound.prototype.Nullify=function(){var self=this.ptr;_emscripten_bind_TopoDS_Compound_Nullify_0(self)};TopoDS_Compound.prototype["Location"]=TopoDS_Compound.prototype.Location=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_Compound_Location_0(self),TopLoc_Location)};TopoDS_Compound.prototype["Located"]=TopoDS_Compound.prototype.Located=function(theLoc){var self=this.ptr;if(theLoc&&typeof theLoc==="object")theLoc=theLoc.ptr;return wrapPointer(_emscripten_bind_TopoDS_Compound_Located_1(self,theLoc),TopoDS_Shape)};TopoDS_Compound.prototype["Orientation"]=TopoDS_Compound.prototype.Orientation=function(){var self=this.ptr;return _emscripten_bind_TopoDS_Compound_Orientation_0(self)};TopoDS_Compound.prototype["Oriented"]=TopoDS_Compound.prototype.Oriented=function(theOrient){var self=this.ptr;if(theOrient&&typeof theOrient==="object")theOrient=theOrient.ptr;return wrapPointer(_emscripten_bind_TopoDS_Compound_Oriented_1(self,theOrient),TopoDS_Shape)};TopoDS_Compound.prototype["ShapeType"]=TopoDS_Compound.prototype.ShapeType=function(){var self=this.ptr;return _emscripten_bind_TopoDS_Compound_ShapeType_0(self)};TopoDS_Compound.prototype["Free"]=TopoDS_Compound.prototype.Free=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Compound_Free_0(self)};TopoDS_Compound.prototype["Locked"]=TopoDS_Compound.prototype.Locked=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Compound_Locked_0(self)};TopoDS_Compound.prototype["Modified"]=TopoDS_Compound.prototype.Modified=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Compound_Modified_0(self)};TopoDS_Compound.prototype["Checked"]=TopoDS_Compound.prototype.Checked=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Compound_Checked_0(self)};TopoDS_Compound.prototype["Orientable"]=TopoDS_Compound.prototype.Orientable=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Compound_Orientable_0(self)};TopoDS_Compound.prototype["Closed"]=TopoDS_Compound.prototype.Closed=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Compound_Closed_0(self)};TopoDS_Compound.prototype["Infinite"]=TopoDS_Compound.prototype.Infinite=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Compound_Infinite_0(self)};TopoDS_Compound.prototype["Convex"]=TopoDS_Compound.prototype.Convex=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Compound_Convex_0(self)};TopoDS_Compound.prototype["Move"]=TopoDS_Compound.prototype.Move=function(thePosition){var self=this.ptr;if(thePosition&&typeof thePosition==="object")thePosition=thePosition.ptr;_emscripten_bind_TopoDS_Compound_Move_1(self,thePosition)};TopoDS_Compound.prototype["Moved"]=TopoDS_Compound.prototype.Moved=function(thePosition){var self=this.ptr;if(thePosition&&typeof thePosition==="object")thePosition=thePosition.ptr;return wrapPointer(_emscripten_bind_TopoDS_Compound_Moved_1(self,thePosition),TopoDS_Shape)};TopoDS_Compound.prototype["Reverse"]=TopoDS_Compound.prototype.Reverse=function(){var self=this.ptr;_emscripten_bind_TopoDS_Compound_Reverse_0(self)};TopoDS_Compound.prototype["Reversed"]=TopoDS_Compound.prototype.Reversed=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_Compound_Reversed_0(self),TopoDS_Shape)};TopoDS_Compound.prototype["Complement"]=TopoDS_Compound.prototype.Complement=function(){var self=this.ptr;_emscripten_bind_TopoDS_Compound_Complement_0(self)};TopoDS_Compound.prototype["Complemented"]=TopoDS_Compound.prototype.Complemented=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_Compound_Complemented_0(self),TopoDS_Shape)};TopoDS_Compound.prototype["Compose"]=TopoDS_Compound.prototype.Compose=function(theOrient){var self=this.ptr;if(theOrient&&typeof theOrient==="object")theOrient=theOrient.ptr;_emscripten_bind_TopoDS_Compound_Compose_1(self,theOrient)};TopoDS_Compound.prototype["Composed"]=TopoDS_Compound.prototype.Composed=function(theOrient){var self=this.ptr;if(theOrient&&typeof theOrient==="object")theOrient=theOrient.ptr;return wrapPointer(_emscripten_bind_TopoDS_Compound_Composed_1(self,theOrient),TopoDS_Shape)};TopoDS_Compound.prototype["NbChildren"]=TopoDS_Compound.prototype.NbChildren=function(){var self=this.ptr;return _emscripten_bind_TopoDS_Compound_NbChildren_0(self)};TopoDS_Compound.prototype["IsPartner"]=TopoDS_Compound.prototype.IsPartner=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_Compound_IsPartner_1(self,theOther)};TopoDS_Compound.prototype["IsSame"]=TopoDS_Compound.prototype.IsSame=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_Compound_IsSame_1(self,theOther)};TopoDS_Compound.prototype["IsEqual"]=TopoDS_Compound.prototype.IsEqual=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_Compound_IsEqual_1(self,theOther)};TopoDS_Compound.prototype["IsNotEqual"]=TopoDS_Compound.prototype.IsNotEqual=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_Compound_IsNotEqual_1(self,theOther)};TopoDS_Compound.prototype["HashCode"]=TopoDS_Compound.prototype.HashCode=function(theUpperBound){var self=this.ptr;if(theUpperBound&&typeof theUpperBound==="object")theUpperBound=theUpperBound.ptr;return _emscripten_bind_TopoDS_Compound_HashCode_1(self,theUpperBound)};TopoDS_Compound.prototype["EmptyCopy"]=TopoDS_Compound.prototype.EmptyCopy=function(){var self=this.ptr;_emscripten_bind_TopoDS_Compound_EmptyCopy_0(self)};TopoDS_Compound.prototype["EmptyCopied"]=TopoDS_Compound.prototype.EmptyCopied=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_Compound_EmptyCopied_0(self),TopoDS_Shape)};TopoDS_Compound.prototype["__destroy__"]=TopoDS_Compound.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_TopoDS_Compound___destroy___0(self)};function BRepOffsetAPI_ThruSections(isSolid,ruled,pres3d){if(isSolid&&typeof isSolid==="object")isSolid=isSolid.ptr;if(ruled&&typeof ruled==="object")ruled=ruled.ptr;if(pres3d&&typeof pres3d==="object")pres3d=pres3d.ptr;if(isSolid===undefined){this.ptr=_emscripten_bind_BRepOffsetAPI_ThruSections_BRepOffsetAPI_ThruSections_0();getCache(BRepOffsetAPI_ThruSections)[this.ptr]=this;return}if(ruled===undefined){this.ptr=_emscripten_bind_BRepOffsetAPI_ThruSections_BRepOffsetAPI_ThruSections_1(isSolid);getCache(BRepOffsetAPI_ThruSections)[this.ptr]=this;return}if(pres3d===undefined){this.ptr=_emscripten_bind_BRepOffsetAPI_ThruSections_BRepOffsetAPI_ThruSections_2(isSolid,ruled);getCache(BRepOffsetAPI_ThruSections)[this.ptr]=this;return}this.ptr=_emscripten_bind_BRepOffsetAPI_ThruSections_BRepOffsetAPI_ThruSections_3(isSolid,ruled,pres3d);getCache(BRepOffsetAPI_ThruSections)[this.ptr]=this}BRepOffsetAPI_ThruSections.prototype=Object.create(BRepBuilderAPI_MakeShape.prototype);BRepOffsetAPI_ThruSections.prototype.constructor=BRepOffsetAPI_ThruSections;BRepOffsetAPI_ThruSections.prototype.__class__=BRepOffsetAPI_ThruSections;BRepOffsetAPI_ThruSections.__cache__={};Module["BRepOffsetAPI_ThruSections"]=BRepOffsetAPI_ThruSections;BRepOffsetAPI_ThruSections.prototype["AddWire"]=BRepOffsetAPI_ThruSections.prototype.AddWire=function(wire){var self=this.ptr;if(wire&&typeof wire==="object")wire=wire.ptr;_emscripten_bind_BRepOffsetAPI_ThruSections_AddWire_1(self,wire)};BRepOffsetAPI_ThruSections.prototype["CheckCompatibility"]=BRepOffsetAPI_ThruSections.prototype.CheckCompatibility=function(check){var self=this.ptr;if(check&&typeof check==="object")check=check.ptr;if(check===undefined){_emscripten_bind_BRepOffsetAPI_ThruSections_CheckCompatibility_0(self);return}_emscripten_bind_BRepOffsetAPI_ThruSections_CheckCompatibility_1(self,check)};BRepOffsetAPI_ThruSections.prototype["Shape"]=BRepOffsetAPI_ThruSections.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepOffsetAPI_ThruSections_Shape_0(self),TopoDS_Shape)};BRepOffsetAPI_ThruSections.prototype["__destroy__"]=BRepOffsetAPI_ThruSections.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepOffsetAPI_ThruSections___destroy___0(self)};function BRepPrimAPI_MakeCone(Axes,R1,R2,H,angle){if(Axes&&typeof Axes==="object")Axes=Axes.ptr;if(R1&&typeof R1==="object")R1=R1.ptr;if(R2&&typeof R2==="object")R2=R2.ptr;if(H&&typeof H==="object")H=H.ptr;if(angle&&typeof angle==="object")angle=angle.ptr;if(H===undefined){this.ptr=_emscripten_bind_BRepPrimAPI_MakeCone_BRepPrimAPI_MakeCone_3(Axes,R1,R2);getCache(BRepPrimAPI_MakeCone)[this.ptr]=this;return}if(angle===undefined){this.ptr=_emscripten_bind_BRepPrimAPI_MakeCone_BRepPrimAPI_MakeCone_4(Axes,R1,R2,H);getCache(BRepPrimAPI_MakeCone)[this.ptr]=this;return}this.ptr=_emscripten_bind_BRepPrimAPI_MakeCone_BRepPrimAPI_MakeCone_5(Axes,R1,R2,H,angle);getCache(BRepPrimAPI_MakeCone)[this.ptr]=this}BRepPrimAPI_MakeCone.prototype=Object.create(BRepPrimAPI_MakeOneAxis.prototype);BRepPrimAPI_MakeCone.prototype.constructor=BRepPrimAPI_MakeCone;BRepPrimAPI_MakeCone.prototype.__class__=BRepPrimAPI_MakeCone;BRepPrimAPI_MakeCone.__cache__={};Module["BRepPrimAPI_MakeCone"]=BRepPrimAPI_MakeCone;BRepPrimAPI_MakeCone.prototype["Shape"]=BRepPrimAPI_MakeCone.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeCone_Shape_0(self),TopoDS_Shape)};BRepPrimAPI_MakeCone.prototype["IsDeleted"]=BRepPrimAPI_MakeCone.prototype.IsDeleted=function(S){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;return!!_emscripten_bind_BRepPrimAPI_MakeCone_IsDeleted_1(self,S)};BRepPrimAPI_MakeCone.prototype["Build"]=BRepPrimAPI_MakeCone.prototype.Build=function(){var self=this.ptr;_emscripten_bind_BRepPrimAPI_MakeCone_Build_0(self)};BRepPrimAPI_MakeCone.prototype["Face"]=BRepPrimAPI_MakeCone.prototype.Face=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeCone_Face_0(self),TopoDS_Face)};BRepPrimAPI_MakeCone.prototype["Shell"]=BRepPrimAPI_MakeCone.prototype.Shell=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeCone_Shell_0(self),TopoDS_Shell)};BRepPrimAPI_MakeCone.prototype["Solid"]=BRepPrimAPI_MakeCone.prototype.Solid=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeCone_Solid_0(self),TopoDS_Solid)};BRepPrimAPI_MakeCone.prototype["__destroy__"]=BRepPrimAPI_MakeCone.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepPrimAPI_MakeCone___destroy___0(self)};function Handle_Geom_BSplineCurve(thePtr){if(thePtr&&typeof thePtr==="object")thePtr=thePtr.ptr;if(thePtr===undefined){this.ptr=_emscripten_bind_Handle_Geom_BSplineCurve_Handle_Geom_BSplineCurve_0();getCache(Handle_Geom_BSplineCurve)[this.ptr]=this;return}this.ptr=_emscripten_bind_Handle_Geom_BSplineCurve_Handle_Geom_BSplineCurve_1(thePtr);getCache(Handle_Geom_BSplineCurve)[this.ptr]=this}Handle_Geom_BSplineCurve.prototype=Object.create(WrapperObject.prototype);Handle_Geom_BSplineCurve.prototype.constructor=Handle_Geom_BSplineCurve;Handle_Geom_BSplineCurve.prototype.__class__=Handle_Geom_BSplineCurve;Handle_Geom_BSplineCurve.__cache__={};Module["Handle_Geom_BSplineCurve"]=Handle_Geom_BSplineCurve;Handle_Geom_BSplineCurve.prototype["IsNull"]=Handle_Geom_BSplineCurve.prototype.IsNull=function(){var self=this.ptr;return!!_emscripten_bind_Handle_Geom_BSplineCurve_IsNull_0(self)};Handle_Geom_BSplineCurve.prototype["Nullify"]=Handle_Geom_BSplineCurve.prototype.Nullify=function(){var self=this.ptr;_emscripten_bind_Handle_Geom_BSplineCurve_Nullify_0(self)};Handle_Geom_BSplineCurve.prototype["get"]=Handle_Geom_BSplineCurve.prototype.get=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Handle_Geom_BSplineCurve_get_0(self),Geom_BSplineCurve)};Handle_Geom_BSplineCurve.prototype["__destroy__"]=Handle_Geom_BSplineCurve.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Handle_Geom_BSplineCurve___destroy___0(self)};function TColStd_Array1OfInteger(theLower,theUpper){if(theLower&&typeof theLower==="object")theLower=theLower.ptr;if(theUpper&&typeof theUpper==="object")theUpper=theUpper.ptr;if(theLower===undefined){this.ptr=_emscripten_bind_TColStd_Array1OfInteger_TColStd_Array1OfInteger_0();getCache(TColStd_Array1OfInteger)[this.ptr]=this;return}if(theUpper===undefined){this.ptr=_emscripten_bind_TColStd_Array1OfInteger_TColStd_Array1OfInteger_1(theLower);getCache(TColStd_Array1OfInteger)[this.ptr]=this;return}this.ptr=_emscripten_bind_TColStd_Array1OfInteger_TColStd_Array1OfInteger_2(theLower,theUpper);getCache(TColStd_Array1OfInteger)[this.ptr]=this}TColStd_Array1OfInteger.prototype=Object.create(WrapperObject.prototype);TColStd_Array1OfInteger.prototype.constructor=TColStd_Array1OfInteger;TColStd_Array1OfInteger.prototype.__class__=TColStd_Array1OfInteger;TColStd_Array1OfInteger.__cache__={};Module["TColStd_Array1OfInteger"]=TColStd_Array1OfInteger;TColStd_Array1OfInteger.prototype["Length"]=TColStd_Array1OfInteger.prototype.Length=function(){var self=this.ptr;return _emscripten_bind_TColStd_Array1OfInteger_Length_0(self)};TColStd_Array1OfInteger.prototype["Lower"]=TColStd_Array1OfInteger.prototype.Lower=function(){var self=this.ptr;return _emscripten_bind_TColStd_Array1OfInteger_Lower_0(self)};TColStd_Array1OfInteger.prototype["Upper"]=TColStd_Array1OfInteger.prototype.Upper=function(){var self=this.ptr;return _emscripten_bind_TColStd_Array1OfInteger_Upper_0(self)};TColStd_Array1OfInteger.prototype["Value"]=TColStd_Array1OfInteger.prototype.Value=function(theIndex){var self=this.ptr;if(theIndex&&typeof theIndex==="object")theIndex=theIndex.ptr;return _emscripten_bind_TColStd_Array1OfInteger_Value_1(self,theIndex)};TColStd_Array1OfInteger.prototype["SetValue"]=TColStd_Array1OfInteger.prototype.SetValue=function(Index,Value){var self=this.ptr;if(Index&&typeof Index==="object")Index=Index.ptr;if(Value&&typeof Value==="object")Value=Value.ptr;_emscripten_bind_TColStd_Array1OfInteger_SetValue_2(self,Index,Value)};TColStd_Array1OfInteger.prototype["__destroy__"]=TColStd_Array1OfInteger.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_TColStd_Array1OfInteger___destroy___0(self)};function gp_Trsf(){this.ptr=_emscripten_bind_gp_Trsf_gp_Trsf_0();getCache(gp_Trsf)[this.ptr]=this}gp_Trsf.prototype=Object.create(WrapperObject.prototype);gp_Trsf.prototype.constructor=gp_Trsf;gp_Trsf.prototype.__class__=gp_Trsf;gp_Trsf.__cache__={};Module["gp_Trsf"]=gp_Trsf;gp_Trsf.prototype["SetMirror"]=gp_Trsf.prototype.SetMirror=function(A1){var self=this.ptr;if(A1&&typeof A1==="object")A1=A1.ptr;_emscripten_bind_gp_Trsf_SetMirror_1(self,A1)};gp_Trsf.prototype["SetTranslation"]=gp_Trsf.prototype.SetTranslation=function(V){var self=this.ptr;if(V&&typeof V==="object")V=V.ptr;_emscripten_bind_gp_Trsf_SetTranslation_1(self,V)};gp_Trsf.prototype["SetTranslationPart"]=gp_Trsf.prototype.SetTranslationPart=function(V){var self=this.ptr;if(V&&typeof V==="object")V=V.ptr;_emscripten_bind_gp_Trsf_SetTranslationPart_1(self,V)};gp_Trsf.prototype["SetRotation"]=gp_Trsf.prototype.SetRotation=function(A1,Ang){var self=this.ptr;if(A1&&typeof A1==="object")A1=A1.ptr;if(Ang&&typeof Ang==="object")Ang=Ang.ptr;_emscripten_bind_gp_Trsf_SetRotation_2(self,A1,Ang)};gp_Trsf.prototype["SetScaleFactor"]=gp_Trsf.prototype.SetScaleFactor=function(S){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;_emscripten_bind_gp_Trsf_SetScaleFactor_1(self,S)};gp_Trsf.prototype["Multiply"]=gp_Trsf.prototype.Multiply=function(T){var self=this.ptr;if(T&&typeof T==="object")T=T.ptr;_emscripten_bind_gp_Trsf_Multiply_1(self,T)};gp_Trsf.prototype["PreMultiply"]=gp_Trsf.prototype.PreMultiply=function(T){var self=this.ptr;if(T&&typeof T==="object")T=T.ptr;_emscripten_bind_gp_Trsf_PreMultiply_1(self,T)};gp_Trsf.prototype["Value"]=gp_Trsf.prototype.Value=function(Row,Col){var self=this.ptr;if(Row&&typeof Row==="object")Row=Row.ptr;if(Col&&typeof Col==="object")Col=Col.ptr;return _emscripten_bind_gp_Trsf_Value_2(self,Row,Col)};gp_Trsf.prototype["Inverted"]=gp_Trsf.prototype.Inverted=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_gp_Trsf_Inverted_0(self),gp_Trsf)};gp_Trsf.prototype["TranslationPart"]=gp_Trsf.prototype.TranslationPart=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_gp_Trsf_TranslationPart_0(self),gp_XYZ)};gp_Trsf.prototype["ScaleFactor"]=gp_Trsf.prototype.ScaleFactor=function(){var self=this.ptr;return _emscripten_bind_gp_Trsf_ScaleFactor_0(self)};gp_Trsf.prototype["Multiplied"]=gp_Trsf.prototype.Multiplied=function(T){var self=this.ptr;if(T&&typeof T==="object")T=T.ptr;return wrapPointer(_emscripten_bind_gp_Trsf_Multiplied_1(self,T),gp_Trsf)};gp_Trsf.prototype["__destroy__"]=gp_Trsf.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_gp_Trsf___destroy___0(self)};function BRepLib(){throw"cannot construct a BRepLib, no constructor in IDL"}BRepLib.prototype=Object.create(WrapperObject.prototype);BRepLib.prototype.constructor=BRepLib;BRepLib.prototype.__class__=BRepLib;BRepLib.__cache__={};Module["BRepLib"]=BRepLib;BRepLib.prototype["BuildCurve3d"]=BRepLib.prototype.BuildCurve3d=function(E,Tolerance,Continuity,MaxDegree,MaxSegment){var self=this.ptr;if(E&&typeof E==="object")E=E.ptr;if(Tolerance&&typeof Tolerance==="object")Tolerance=Tolerance.ptr;if(Continuity&&typeof Continuity==="object")Continuity=Continuity.ptr;if(MaxDegree&&typeof MaxDegree==="object")MaxDegree=MaxDegree.ptr;if(MaxSegment&&typeof MaxSegment==="object")MaxSegment=MaxSegment.ptr;if(Tolerance===undefined){return!!_emscripten_bind_BRepLib_BuildCurve3d_1(self,E)}if(Continuity===undefined){return!!_emscripten_bind_BRepLib_BuildCurve3d_2(self,E,Tolerance)}if(MaxDegree===undefined){return!!_emscripten_bind_BRepLib_BuildCurve3d_3(self,E,Tolerance,Continuity)}if(MaxSegment===undefined){return!!_emscripten_bind_BRepLib_BuildCurve3d_4(self,E,Tolerance,Continuity,MaxDegree)}return!!_emscripten_bind_BRepLib_BuildCurve3d_5(self,E,Tolerance,Continuity,MaxDegree,MaxSegment)};BRepLib.prototype["BuildCurves3d"]=BRepLib.prototype.BuildCurves3d=function(S){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;return!!_emscripten_bind_BRepLib_BuildCurves3d_1(self,S)};BRepLib.prototype["__destroy__"]=BRepLib.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepLib___destroy___0(self)};function Handle_Geom_Curve(thePtr){if(thePtr&&typeof thePtr==="object")thePtr=thePtr.ptr;if(thePtr===undefined){this.ptr=_emscripten_bind_Handle_Geom_Curve_Handle_Geom_Curve_0();getCache(Handle_Geom_Curve)[this.ptr]=this;return}this.ptr=_emscripten_bind_Handle_Geom_Curve_Handle_Geom_Curve_1(thePtr);getCache(Handle_Geom_Curve)[this.ptr]=this}Handle_Geom_Curve.prototype=Object.create(WrapperObject.prototype);Handle_Geom_Curve.prototype.constructor=Handle_Geom_Curve;Handle_Geom_Curve.prototype.__class__=Handle_Geom_Curve;Handle_Geom_Curve.__cache__={};Module["Handle_Geom_Curve"]=Handle_Geom_Curve;Handle_Geom_Curve.prototype["IsNull"]=Handle_Geom_Curve.prototype.IsNull=function(){var self=this.ptr;return!!_emscripten_bind_Handle_Geom_Curve_IsNull_0(self)};Handle_Geom_Curve.prototype["Nullify"]=Handle_Geom_Curve.prototype.Nullify=function(){var self=this.ptr;_emscripten_bind_Handle_Geom_Curve_Nullify_0(self)};Handle_Geom_Curve.prototype["get"]=Handle_Geom_Curve.prototype.get=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Handle_Geom_Curve_get_0(self),Geom_Curve)};Handle_Geom_Curve.prototype["__destroy__"]=Handle_Geom_Curve.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Handle_Geom_Curve___destroy___0(self)};function Handle_Poly_Triangulation(thePtr){if(thePtr&&typeof thePtr==="object")thePtr=thePtr.ptr;if(thePtr===undefined){this.ptr=_emscripten_bind_Handle_Poly_Triangulation_Handle_Poly_Triangulation_0();getCache(Handle_Poly_Triangulation)[this.ptr]=this;return}this.ptr=_emscripten_bind_Handle_Poly_Triangulation_Handle_Poly_Triangulation_1(thePtr);getCache(Handle_Poly_Triangulation)[this.ptr]=this}Handle_Poly_Triangulation.prototype=Object.create(WrapperObject.prototype);Handle_Poly_Triangulation.prototype.constructor=Handle_Poly_Triangulation;Handle_Poly_Triangulation.prototype.__class__=Handle_Poly_Triangulation;Handle_Poly_Triangulation.__cache__={};Module["Handle_Poly_Triangulation"]=Handle_Poly_Triangulation;Handle_Poly_Triangulation.prototype["IsNull"]=Handle_Poly_Triangulation.prototype.IsNull=function(){var self=this.ptr;return!!_emscripten_bind_Handle_Poly_Triangulation_IsNull_0(self)};Handle_Poly_Triangulation.prototype["Nullify"]=Handle_Poly_Triangulation.prototype.Nullify=function(){var self=this.ptr;_emscripten_bind_Handle_Poly_Triangulation_Nullify_0(self)};Handle_Poly_Triangulation.prototype["get"]=Handle_Poly_Triangulation.prototype.get=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Handle_Poly_Triangulation_get_0(self),Poly_Triangulation)};Handle_Poly_Triangulation.prototype["__destroy__"]=Handle_Poly_Triangulation.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Handle_Poly_Triangulation___destroy___0(self)};function GC_MakeArcOfCircle(Circ,Alpha1,Alpha2,Sense){if(Circ&&typeof Circ==="object")Circ=Circ.ptr;if(Alpha1&&typeof Alpha1==="object")Alpha1=Alpha1.ptr;if(Alpha2&&typeof Alpha2==="object")Alpha2=Alpha2.ptr;if(Sense&&typeof Sense==="object")Sense=Sense.ptr;if(Sense===undefined){this.ptr=_emscripten_bind_GC_MakeArcOfCircle_GC_MakeArcOfCircle_3(Circ,Alpha1,Alpha2);getCache(GC_MakeArcOfCircle)[this.ptr]=this;return}this.ptr=_emscripten_bind_GC_MakeArcOfCircle_GC_MakeArcOfCircle_4(Circ,Alpha1,Alpha2,Sense);getCache(GC_MakeArcOfCircle)[this.ptr]=this}GC_MakeArcOfCircle.prototype=Object.create(WrapperObject.prototype);GC_MakeArcOfCircle.prototype.constructor=GC_MakeArcOfCircle;GC_MakeArcOfCircle.prototype.__class__=GC_MakeArcOfCircle;GC_MakeArcOfCircle.__cache__={};Module["GC_MakeArcOfCircle"]=GC_MakeArcOfCircle;GC_MakeArcOfCircle.prototype["Value"]=GC_MakeArcOfCircle.prototype.Value=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_GC_MakeArcOfCircle_Value_0(self),Handle_Geom_TrimmedCurve)};GC_MakeArcOfCircle.prototype["__destroy__"]=GC_MakeArcOfCircle.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_GC_MakeArcOfCircle___destroy___0(self)};function Handle_Geom_Plane(thePtr){if(thePtr&&typeof thePtr==="object")thePtr=thePtr.ptr;if(thePtr===undefined){this.ptr=_emscripten_bind_Handle_Geom_Plane_Handle_Geom_Plane_0();getCache(Handle_Geom_Plane)[this.ptr]=this;return}this.ptr=_emscripten_bind_Handle_Geom_Plane_Handle_Geom_Plane_1(thePtr);getCache(Handle_Geom_Plane)[this.ptr]=this}Handle_Geom_Plane.prototype=Object.create(WrapperObject.prototype);Handle_Geom_Plane.prototype.constructor=Handle_Geom_Plane;Handle_Geom_Plane.prototype.__class__=Handle_Geom_Plane;Handle_Geom_Plane.__cache__={};Module["Handle_Geom_Plane"]=Handle_Geom_Plane;Handle_Geom_Plane.prototype["IsNull"]=Handle_Geom_Plane.prototype.IsNull=function(){var self=this.ptr;return!!_emscripten_bind_Handle_Geom_Plane_IsNull_0(self)};Handle_Geom_Plane.prototype["Nullify"]=Handle_Geom_Plane.prototype.Nullify=function(){var self=this.ptr;_emscripten_bind_Handle_Geom_Plane_Nullify_0(self)};Handle_Geom_Plane.prototype["get"]=Handle_Geom_Plane.prototype.get=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Handle_Geom_Plane_get_0(self),Geom_Plane)};Handle_Geom_Plane.prototype["__destroy__"]=Handle_Geom_Plane.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Handle_Geom_Plane___destroy___0(self)};function Standard_Type(){throw"cannot construct a Standard_Type, no constructor in IDL"}Standard_Type.prototype=Object.create(Standard_Transient.prototype);Standard_Type.prototype.constructor=Standard_Type;Standard_Type.prototype.__class__=Standard_Type;Standard_Type.__cache__={};Module["Standard_Type"]=Standard_Type;Standard_Type.prototype["Name"]=Standard_Type.prototype.Name=function(){var self=this.ptr;return UTF8ToString(_emscripten_bind_Standard_Type_Name_0(self))};Standard_Type.prototype["get_type_name"]=Standard_Type.prototype.get_type_name=function(){var self=this.ptr;return UTF8ToString(_emscripten_bind_Standard_Type_get_type_name_0(self))};Standard_Type.prototype["DynamicType"]=Standard_Type.prototype.DynamicType=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Standard_Type_DynamicType_0(self),Handle_Standard_Type)};Standard_Type.prototype["__destroy__"]=Standard_Type.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Standard_Type___destroy___0(self)};function TopoDS_Face(T2){if(T2&&typeof T2==="object")T2=T2.ptr;if(T2===undefined){this.ptr=_emscripten_bind_TopoDS_Face_TopoDS_Face_0();getCache(TopoDS_Face)[this.ptr]=this;return}this.ptr=_emscripten_bind_TopoDS_Face_TopoDS_Face_1(T2);getCache(TopoDS_Face)[this.ptr]=this}TopoDS_Face.prototype=Object.create(TopoDS_Shape.prototype);TopoDS_Face.prototype.constructor=TopoDS_Face;TopoDS_Face.prototype.__class__=TopoDS_Face;TopoDS_Face.__cache__={};Module["TopoDS_Face"]=TopoDS_Face;TopoDS_Face.prototype["IsNull"]=TopoDS_Face.prototype.IsNull=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Face_IsNull_0(self)};TopoDS_Face.prototype["Nullify"]=TopoDS_Face.prototype.Nullify=function(){var self=this.ptr;_emscripten_bind_TopoDS_Face_Nullify_0(self)};TopoDS_Face.prototype["Location"]=TopoDS_Face.prototype.Location=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_Face_Location_0(self),TopLoc_Location)};TopoDS_Face.prototype["Located"]=TopoDS_Face.prototype.Located=function(theLoc){var self=this.ptr;if(theLoc&&typeof theLoc==="object")theLoc=theLoc.ptr;return wrapPointer(_emscripten_bind_TopoDS_Face_Located_1(self,theLoc),TopoDS_Shape)};TopoDS_Face.prototype["Orientation"]=TopoDS_Face.prototype.Orientation=function(){var self=this.ptr;return _emscripten_bind_TopoDS_Face_Orientation_0(self)};TopoDS_Face.prototype["Oriented"]=TopoDS_Face.prototype.Oriented=function(theOrient){var self=this.ptr;if(theOrient&&typeof theOrient==="object")theOrient=theOrient.ptr;return wrapPointer(_emscripten_bind_TopoDS_Face_Oriented_1(self,theOrient),TopoDS_Shape)};TopoDS_Face.prototype["ShapeType"]=TopoDS_Face.prototype.ShapeType=function(){var self=this.ptr;return _emscripten_bind_TopoDS_Face_ShapeType_0(self)};TopoDS_Face.prototype["Free"]=TopoDS_Face.prototype.Free=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Face_Free_0(self)};TopoDS_Face.prototype["Locked"]=TopoDS_Face.prototype.Locked=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Face_Locked_0(self)};TopoDS_Face.prototype["Modified"]=TopoDS_Face.prototype.Modified=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Face_Modified_0(self)};TopoDS_Face.prototype["Checked"]=TopoDS_Face.prototype.Checked=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Face_Checked_0(self)};TopoDS_Face.prototype["Orientable"]=TopoDS_Face.prototype.Orientable=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Face_Orientable_0(self)};TopoDS_Face.prototype["Closed"]=TopoDS_Face.prototype.Closed=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Face_Closed_0(self)};TopoDS_Face.prototype["Infinite"]=TopoDS_Face.prototype.Infinite=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Face_Infinite_0(self)};TopoDS_Face.prototype["Convex"]=TopoDS_Face.prototype.Convex=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Face_Convex_0(self)};TopoDS_Face.prototype["Move"]=TopoDS_Face.prototype.Move=function(thePosition){var self=this.ptr;if(thePosition&&typeof thePosition==="object")thePosition=thePosition.ptr;_emscripten_bind_TopoDS_Face_Move_1(self,thePosition)};TopoDS_Face.prototype["Moved"]=TopoDS_Face.prototype.Moved=function(thePosition){var self=this.ptr;if(thePosition&&typeof thePosition==="object")thePosition=thePosition.ptr;return wrapPointer(_emscripten_bind_TopoDS_Face_Moved_1(self,thePosition),TopoDS_Shape)};TopoDS_Face.prototype["Reverse"]=TopoDS_Face.prototype.Reverse=function(){var self=this.ptr;_emscripten_bind_TopoDS_Face_Reverse_0(self)};TopoDS_Face.prototype["Reversed"]=TopoDS_Face.prototype.Reversed=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_Face_Reversed_0(self),TopoDS_Shape)};TopoDS_Face.prototype["Complement"]=TopoDS_Face.prototype.Complement=function(){var self=this.ptr;_emscripten_bind_TopoDS_Face_Complement_0(self)};TopoDS_Face.prototype["Complemented"]=TopoDS_Face.prototype.Complemented=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_Face_Complemented_0(self),TopoDS_Shape)};TopoDS_Face.prototype["Compose"]=TopoDS_Face.prototype.Compose=function(theOrient){var self=this.ptr;if(theOrient&&typeof theOrient==="object")theOrient=theOrient.ptr;_emscripten_bind_TopoDS_Face_Compose_1(self,theOrient)};TopoDS_Face.prototype["Composed"]=TopoDS_Face.prototype.Composed=function(theOrient){var self=this.ptr;if(theOrient&&typeof theOrient==="object")theOrient=theOrient.ptr;return wrapPointer(_emscripten_bind_TopoDS_Face_Composed_1(self,theOrient),TopoDS_Shape)};TopoDS_Face.prototype["NbChildren"]=TopoDS_Face.prototype.NbChildren=function(){var self=this.ptr;return _emscripten_bind_TopoDS_Face_NbChildren_0(self)};TopoDS_Face.prototype["IsPartner"]=TopoDS_Face.prototype.IsPartner=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_Face_IsPartner_1(self,theOther)};TopoDS_Face.prototype["IsSame"]=TopoDS_Face.prototype.IsSame=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_Face_IsSame_1(self,theOther)};TopoDS_Face.prototype["IsEqual"]=TopoDS_Face.prototype.IsEqual=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_Face_IsEqual_1(self,theOther)};TopoDS_Face.prototype["IsNotEqual"]=TopoDS_Face.prototype.IsNotEqual=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_Face_IsNotEqual_1(self,theOther)};TopoDS_Face.prototype["HashCode"]=TopoDS_Face.prototype.HashCode=function(theUpperBound){var self=this.ptr;if(theUpperBound&&typeof theUpperBound==="object")theUpperBound=theUpperBound.ptr;return _emscripten_bind_TopoDS_Face_HashCode_1(self,theUpperBound)};TopoDS_Face.prototype["EmptyCopy"]=TopoDS_Face.prototype.EmptyCopy=function(){var self=this.ptr;_emscripten_bind_TopoDS_Face_EmptyCopy_0(self)};TopoDS_Face.prototype["EmptyCopied"]=TopoDS_Face.prototype.EmptyCopied=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_Face_EmptyCopied_0(self),TopoDS_Shape)};TopoDS_Face.prototype["__destroy__"]=TopoDS_Face.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_TopoDS_Face___destroy___0(self)};function gp_Pln(P,V){if(P&&typeof P==="object")P=P.ptr;if(V&&typeof V==="object")V=V.ptr;if(P===undefined){this.ptr=_emscripten_bind_gp_Pln_gp_Pln_0();getCache(gp_Pln)[this.ptr]=this;return}if(V===undefined){this.ptr=_emscripten_bind_gp_Pln_gp_Pln_1(P);getCache(gp_Pln)[this.ptr]=this;return}this.ptr=_emscripten_bind_gp_Pln_gp_Pln_2(P,V);getCache(gp_Pln)[this.ptr]=this}gp_Pln.prototype=Object.create(WrapperObject.prototype);gp_Pln.prototype.constructor=gp_Pln;gp_Pln.prototype.__class__=gp_Pln;gp_Pln.__cache__={};Module["gp_Pln"]=gp_Pln;gp_Pln.prototype["Coefficients"]=gp_Pln.prototype.Coefficients=function(A,B,C,D){var self=this.ptr;if(A&&typeof A==="object")A=A.ptr;if(B&&typeof B==="object")B=B.ptr;if(C&&typeof C==="object")C=C.ptr;if(D&&typeof D==="object")D=D.ptr;_emscripten_bind_gp_Pln_Coefficients_4(self,A,B,C,D)};gp_Pln.prototype["SetAxis"]=gp_Pln.prototype.SetAxis=function(A1){var self=this.ptr;if(A1&&typeof A1==="object")A1=A1.ptr;_emscripten_bind_gp_Pln_SetAxis_1(self,A1)};gp_Pln.prototype["SetLocation"]=gp_Pln.prototype.SetLocation=function(Loc){var self=this.ptr;if(Loc&&typeof Loc==="object")Loc=Loc.ptr;_emscripten_bind_gp_Pln_SetLocation_1(self,Loc)};gp_Pln.prototype["UReverse"]=gp_Pln.prototype.UReverse=function(){var self=this.ptr;_emscripten_bind_gp_Pln_UReverse_0(self)};gp_Pln.prototype["VReverse"]=gp_Pln.prototype.VReverse=function(){var self=this.ptr;_emscripten_bind_gp_Pln_VReverse_0(self)};gp_Pln.prototype["Direct"]=gp_Pln.prototype.Direct=function(){var self=this.ptr;return!!_emscripten_bind_gp_Pln_Direct_0(self)};gp_Pln.prototype["Axis"]=gp_Pln.prototype.Axis=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_gp_Pln_Axis_0(self),gp_Ax1)};gp_Pln.prototype["Location"]=gp_Pln.prototype.Location=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_gp_Pln_Location_0(self),gp_Pnt)};gp_Pln.prototype["Distance"]=gp_Pln.prototype.Distance=function(P){var self=this.ptr;if(P&&typeof P==="object")P=P.ptr;return _emscripten_bind_gp_Pln_Distance_1(self,P)};gp_Pln.prototype["SquareDistance"]=gp_Pln.prototype.SquareDistance=function(P){var self=this.ptr;if(P&&typeof P==="object")P=P.ptr;return _emscripten_bind_gp_Pln_SquareDistance_1(self,P)};gp_Pln.prototype["XAxis"]=gp_Pln.prototype.XAxis=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_gp_Pln_XAxis_0(self),gp_Ax1)};gp_Pln.prototype["YAxis"]=gp_Pln.prototype.YAxis=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_gp_Pln_YAxis_0(self),gp_Ax1)};gp_Pln.prototype["Contains"]=gp_Pln.prototype.Contains=function(L,LinearTolerance,AngularTolerance){var self=this.ptr;if(L&&typeof L==="object")L=L.ptr;if(LinearTolerance&&typeof LinearTolerance==="object")LinearTolerance=LinearTolerance.ptr;if(AngularTolerance&&typeof AngularTolerance==="object")AngularTolerance=AngularTolerance.ptr;if(AngularTolerance===undefined){return!!_emscripten_bind_gp_Pln_Contains_2(self,L,LinearTolerance)}return!!_emscripten_bind_gp_Pln_Contains_3(self,L,LinearTolerance,AngularTolerance)};gp_Pln.prototype["Mirror"]=gp_Pln.prototype.Mirror=function(P){var self=this.ptr;if(P&&typeof P==="object")P=P.ptr;_emscripten_bind_gp_Pln_Mirror_1(self,P)};gp_Pln.prototype["Mirrored"]=gp_Pln.prototype.Mirrored=function(P){var self=this.ptr;if(P&&typeof P==="object")P=P.ptr;return wrapPointer(_emscripten_bind_gp_Pln_Mirrored_1(self,P),gp_Pln)};gp_Pln.prototype["Rotate"]=gp_Pln.prototype.Rotate=function(A1,Ang){var self=this.ptr;if(A1&&typeof A1==="object")A1=A1.ptr;if(Ang&&typeof Ang==="object")Ang=Ang.ptr;_emscripten_bind_gp_Pln_Rotate_2(self,A1,Ang)};gp_Pln.prototype["Rotated"]=gp_Pln.prototype.Rotated=function(A1,Ang){var self=this.ptr;if(A1&&typeof A1==="object")A1=A1.ptr;if(Ang&&typeof Ang==="object")Ang=Ang.ptr;return wrapPointer(_emscripten_bind_gp_Pln_Rotated_2(self,A1,Ang),gp_Pln)};gp_Pln.prototype["Scale"]=gp_Pln.prototype.Scale=function(P,S){var self=this.ptr;if(P&&typeof P==="object")P=P.ptr;if(S&&typeof S==="object")S=S.ptr;_emscripten_bind_gp_Pln_Scale_2(self,P,S)};gp_Pln.prototype["Scaled"]=gp_Pln.prototype.Scaled=function(P,S){var self=this.ptr;if(P&&typeof P==="object")P=P.ptr;if(S&&typeof S==="object")S=S.ptr;return wrapPointer(_emscripten_bind_gp_Pln_Scaled_2(self,P,S),gp_Pln)};gp_Pln.prototype["Transform"]=gp_Pln.prototype.Transform=function(T){var self=this.ptr;if(T&&typeof T==="object")T=T.ptr;_emscripten_bind_gp_Pln_Transform_1(self,T)};gp_Pln.prototype["Transformed"]=gp_Pln.prototype.Transformed=function(T){var self=this.ptr;if(T&&typeof T==="object")T=T.ptr;return wrapPointer(_emscripten_bind_gp_Pln_Transformed_1(self,T),gp_Pln)};gp_Pln.prototype["Translate"]=gp_Pln.prototype.Translate=function(P1,P2){var self=this.ptr;if(P1&&typeof P1==="object")P1=P1.ptr;if(P2&&typeof P2==="object")P2=P2.ptr;if(P2===undefined){_emscripten_bind_gp_Pln_Translate_1(self,P1);return}_emscripten_bind_gp_Pln_Translate_2(self,P1,P2)};gp_Pln.prototype["Translated"]=gp_Pln.prototype.Translated=function(P1,P2){var self=this.ptr;if(P1&&typeof P1==="object")P1=P1.ptr;if(P2&&typeof P2==="object")P2=P2.ptr;if(P2===undefined){return wrapPointer(_emscripten_bind_gp_Pln_Translated_1(self,P1),gp_Pln)}return wrapPointer(_emscripten_bind_gp_Pln_Translated_2(self,P1,P2),gp_Pln)};gp_Pln.prototype["__destroy__"]=gp_Pln.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_gp_Pln___destroy___0(self)};function BRepOffsetAPI_MakeThickSolid(){this.ptr=_emscripten_bind_BRepOffsetAPI_MakeThickSolid_BRepOffsetAPI_MakeThickSolid_0();getCache(BRepOffsetAPI_MakeThickSolid)[this.ptr]=this}BRepOffsetAPI_MakeThickSolid.prototype=Object.create(BRepOffsetAPI_MakeOffsetShape.prototype);BRepOffsetAPI_MakeThickSolid.prototype.constructor=BRepOffsetAPI_MakeThickSolid;BRepOffsetAPI_MakeThickSolid.prototype.__class__=BRepOffsetAPI_MakeThickSolid;BRepOffsetAPI_MakeThickSolid.__cache__={};Module["BRepOffsetAPI_MakeThickSolid"]=BRepOffsetAPI_MakeThickSolid;BRepOffsetAPI_MakeThickSolid.prototype["MakeThickSolidByJoin"]=BRepOffsetAPI_MakeThickSolid.prototype.MakeThickSolidByJoin=function(S,ClosingFaces,Offset,Tol){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;if(ClosingFaces&&typeof ClosingFaces==="object")ClosingFaces=ClosingFaces.ptr;if(Offset&&typeof Offset==="object")Offset=Offset.ptr;if(Tol&&typeof Tol==="object")Tol=Tol.ptr;_emscripten_bind_BRepOffsetAPI_MakeThickSolid_MakeThickSolidByJoin_4(self,S,ClosingFaces,Offset,Tol)};BRepOffsetAPI_MakeThickSolid.prototype["PerformBySimple"]=BRepOffsetAPI_MakeThickSolid.prototype.PerformBySimple=function(theS,theOffsetValue){var self=this.ptr;if(theS&&typeof theS==="object")theS=theS.ptr;if(theOffsetValue&&typeof theOffsetValue==="object")theOffsetValue=theOffsetValue.ptr;_emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformBySimple_2(self,theS,theOffsetValue)};BRepOffsetAPI_MakeThickSolid.prototype["PerformByJoin"]=BRepOffsetAPI_MakeThickSolid.prototype.PerformByJoin=function(S,Offset,Tol,Mode,Intersection,SelfInter,Join,RemoveIntEdges){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;if(Offset&&typeof Offset==="object")Offset=Offset.ptr;if(Tol&&typeof Tol==="object")Tol=Tol.ptr;if(Mode&&typeof Mode==="object")Mode=Mode.ptr;if(Intersection&&typeof Intersection==="object")Intersection=Intersection.ptr;if(SelfInter&&typeof SelfInter==="object")SelfInter=SelfInter.ptr;if(Join&&typeof Join==="object")Join=Join.ptr;if(RemoveIntEdges&&typeof RemoveIntEdges==="object")RemoveIntEdges=RemoveIntEdges.ptr;if(Mode===undefined){_emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformByJoin_3(self,S,Offset,Tol);return}if(Intersection===undefined){_emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformByJoin_4(self,S,Offset,Tol,Mode);return}if(SelfInter===undefined){_emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformByJoin_5(self,S,Offset,Tol,Mode,Intersection);return}if(Join===undefined){_emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformByJoin_6(self,S,Offset,Tol,Mode,Intersection,SelfInter);return}if(RemoveIntEdges===undefined){_emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformByJoin_7(self,S,Offset,Tol,Mode,Intersection,SelfInter,Join);return}_emscripten_bind_BRepOffsetAPI_MakeThickSolid_PerformByJoin_8(self,S,Offset,Tol,Mode,Intersection,SelfInter,Join,RemoveIntEdges)};BRepOffsetAPI_MakeThickSolid.prototype["Shape"]=BRepOffsetAPI_MakeThickSolid.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepOffsetAPI_MakeThickSolid_Shape_0(self),TopoDS_Shape)};BRepOffsetAPI_MakeThickSolid.prototype["__destroy__"]=BRepOffsetAPI_MakeThickSolid.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepOffsetAPI_MakeThickSolid___destroy___0(self)};function ShapeFix_Face(face){if(face&&typeof face==="object")face=face.ptr;if(face===undefined){this.ptr=_emscripten_bind_ShapeFix_Face_ShapeFix_Face_0();getCache(ShapeFix_Face)[this.ptr]=this;return}this.ptr=_emscripten_bind_ShapeFix_Face_ShapeFix_Face_1(face);getCache(ShapeFix_Face)[this.ptr]=this}ShapeFix_Face.prototype=Object.create(WrapperObject.prototype);ShapeFix_Face.prototype.constructor=ShapeFix_Face;ShapeFix_Face.prototype.__class__=ShapeFix_Face;ShapeFix_Face.__cache__={};Module["ShapeFix_Face"]=ShapeFix_Face;ShapeFix_Face.prototype["ClearModes"]=ShapeFix_Face.prototype.ClearModes=function(){var self=this.ptr;_emscripten_bind_ShapeFix_Face_ClearModes_0(self)};ShapeFix_Face.prototype["Init"]=ShapeFix_Face.prototype.Init=function(face){var self=this.ptr;if(face&&typeof face==="object")face=face.ptr;_emscripten_bind_ShapeFix_Face_Init_1(self,face)};ShapeFix_Face.prototype["SetPrecision"]=ShapeFix_Face.prototype.SetPrecision=function(preci){var self=this.ptr;if(preci&&typeof preci==="object")preci=preci.ptr;_emscripten_bind_ShapeFix_Face_SetPrecision_1(self,preci)};ShapeFix_Face.prototype["SetMinTolerance"]=ShapeFix_Face.prototype.SetMinTolerance=function(mintol){var self=this.ptr;if(mintol&&typeof mintol==="object")mintol=mintol.ptr;_emscripten_bind_ShapeFix_Face_SetMinTolerance_1(self,mintol)};ShapeFix_Face.prototype["SetMaxTolerance"]=ShapeFix_Face.prototype.SetMaxTolerance=function(maxtol){var self=this.ptr;if(maxtol&&typeof maxtol==="object")maxtol=maxtol.ptr;_emscripten_bind_ShapeFix_Face_SetMaxTolerance_1(self,maxtol)};ShapeFix_Face.prototype["FixWireMode"]=ShapeFix_Face.prototype.FixWireMode=function(){var self=this.ptr;return _emscripten_bind_ShapeFix_Face_FixWireMode_0(self)};ShapeFix_Face.prototype["FixOrientationMode"]=ShapeFix_Face.prototype.FixOrientationMode=function(){var self=this.ptr;return _emscripten_bind_ShapeFix_Face_FixOrientationMode_0(self)};ShapeFix_Face.prototype["FixAddNaturalBoundMode"]=ShapeFix_Face.prototype.FixAddNaturalBoundMode=function(){var self=this.ptr;return _emscripten_bind_ShapeFix_Face_FixAddNaturalBoundMode_0(self)};ShapeFix_Face.prototype["FixMissingSeamMode"]=ShapeFix_Face.prototype.FixMissingSeamMode=function(){var self=this.ptr;return _emscripten_bind_ShapeFix_Face_FixMissingSeamMode_0(self)};ShapeFix_Face.prototype["FixSmallAreaWireMode"]=ShapeFix_Face.prototype.FixSmallAreaWireMode=function(){var self=this.ptr;return _emscripten_bind_ShapeFix_Face_FixSmallAreaWireMode_0(self)};ShapeFix_Face.prototype["RemoveSmallAreaFaceMode"]=ShapeFix_Face.prototype.RemoveSmallAreaFaceMode=function(){var self=this.ptr;return _emscripten_bind_ShapeFix_Face_RemoveSmallAreaFaceMode_0(self)};ShapeFix_Face.prototype["FixIntersectingWiresMode"]=ShapeFix_Face.prototype.FixIntersectingWiresMode=function(){var self=this.ptr;return _emscripten_bind_ShapeFix_Face_FixIntersectingWiresMode_0(self)};ShapeFix_Face.prototype["FixLoopWiresMode"]=ShapeFix_Face.prototype.FixLoopWiresMode=function(){var self=this.ptr;return _emscripten_bind_ShapeFix_Face_FixLoopWiresMode_0(self)};ShapeFix_Face.prototype["FixSplitFaceMode"]=ShapeFix_Face.prototype.FixSplitFaceMode=function(){var self=this.ptr;return _emscripten_bind_ShapeFix_Face_FixSplitFaceMode_0(self)};ShapeFix_Face.prototype["AutoCorrectPrecisionMode"]=ShapeFix_Face.prototype.AutoCorrectPrecisionMode=function(){var self=this.ptr;return _emscripten_bind_ShapeFix_Face_AutoCorrectPrecisionMode_0(self)};ShapeFix_Face.prototype["FixPeriodicDegeneratedMode"]=ShapeFix_Face.prototype.FixPeriodicDegeneratedMode=function(){var self=this.ptr;return _emscripten_bind_ShapeFix_Face_FixPeriodicDegeneratedMode_0(self)};ShapeFix_Face.prototype["Face"]=ShapeFix_Face.prototype.Face=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_ShapeFix_Face_Face_0(self),TopoDS_Face)};ShapeFix_Face.prototype["Result"]=ShapeFix_Face.prototype.Result=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_ShapeFix_Face_Result_0(self),TopoDS_Shape)};ShapeFix_Face.prototype["Add"]=ShapeFix_Face.prototype.Add=function(wire){var self=this.ptr;if(wire&&typeof wire==="object")wire=wire.ptr;_emscripten_bind_ShapeFix_Face_Add_1(self,wire)};ShapeFix_Face.prototype["Perform"]=ShapeFix_Face.prototype.Perform=function(){var self=this.ptr;return!!_emscripten_bind_ShapeFix_Face_Perform_0(self)};ShapeFix_Face.prototype["FixOrientation"]=ShapeFix_Face.prototype.FixOrientation=function(){var self=this.ptr;return!!_emscripten_bind_ShapeFix_Face_FixOrientation_0(self)};ShapeFix_Face.prototype["FixAddNaturalBound"]=ShapeFix_Face.prototype.FixAddNaturalBound=function(){var self=this.ptr;return!!_emscripten_bind_ShapeFix_Face_FixAddNaturalBound_0(self)};ShapeFix_Face.prototype["FixMissingSeam"]=ShapeFix_Face.prototype.FixMissingSeam=function(){var self=this.ptr;return!!_emscripten_bind_ShapeFix_Face_FixMissingSeam_0(self)};ShapeFix_Face.prototype["FixSmallAreaWire"]=ShapeFix_Face.prototype.FixSmallAreaWire=function(theIsRemoveSmallFace){var self=this.ptr;if(theIsRemoveSmallFace&&typeof theIsRemoveSmallFace==="object")theIsRemoveSmallFace=theIsRemoveSmallFace.ptr;return!!_emscripten_bind_ShapeFix_Face_FixSmallAreaWire_1(self,theIsRemoveSmallFace)};ShapeFix_Face.prototype["FixIntersectingWires"]=ShapeFix_Face.prototype.FixIntersectingWires=function(){var self=this.ptr;return!!_emscripten_bind_ShapeFix_Face_FixIntersectingWires_0(self)};ShapeFix_Face.prototype["FixWiresTwoCoincEdges"]=ShapeFix_Face.prototype.FixWiresTwoCoincEdges=function(){var self=this.ptr;return!!_emscripten_bind_ShapeFix_Face_FixWiresTwoCoincEdges_0(self)};ShapeFix_Face.prototype["FixPeriodicDegenerated"]=ShapeFix_Face.prototype.FixPeriodicDegenerated=function(){var self=this.ptr;return!!_emscripten_bind_ShapeFix_Face_FixPeriodicDegenerated_0(self)};ShapeFix_Face.prototype["__destroy__"]=ShapeFix_Face.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_ShapeFix_Face___destroy___0(self)};function Geom_Parabola(A2,Focal){if(A2&&typeof A2==="object")A2=A2.ptr;if(Focal&&typeof Focal==="object")Focal=Focal.ptr;if(Focal===undefined){this.ptr=_emscripten_bind_Geom_Parabola_Geom_Parabola_1(A2);getCache(Geom_Parabola)[this.ptr]=this;return}this.ptr=_emscripten_bind_Geom_Parabola_Geom_Parabola_2(A2,Focal);getCache(Geom_Parabola)[this.ptr]=this}Geom_Parabola.prototype=Object.create(Geom_Conic.prototype);Geom_Parabola.prototype.constructor=Geom_Parabola;Geom_Parabola.prototype.__class__=Geom_Parabola;Geom_Parabola.__cache__={};Module["Geom_Parabola"]=Geom_Parabola;Geom_Parabola.prototype["Focal"]=Geom_Parabola.prototype.Focal=function(){var self=this.ptr;return _emscripten_bind_Geom_Parabola_Focal_0(self)};Geom_Parabola.prototype["Reverse"]=Geom_Parabola.prototype.Reverse=function(){var self=this.ptr;_emscripten_bind_Geom_Parabola_Reverse_0(self)};Geom_Parabola.prototype["ReversedParameter"]=Geom_Parabola.prototype.ReversedParameter=function(U){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;return _emscripten_bind_Geom_Parabola_ReversedParameter_1(self,U)};Geom_Parabola.prototype["TransformedParameter"]=Geom_Parabola.prototype.TransformedParameter=function(U,T){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(T&&typeof T==="object")T=T.ptr;return _emscripten_bind_Geom_Parabola_TransformedParameter_2(self,U,T)};Geom_Parabola.prototype["ParametricTransformation"]=Geom_Parabola.prototype.ParametricTransformation=function(T){var self=this.ptr;if(T&&typeof T==="object")T=T.ptr;return _emscripten_bind_Geom_Parabola_ParametricTransformation_1(self,T)};Geom_Parabola.prototype["Reversed"]=Geom_Parabola.prototype.Reversed=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Geom_Parabola_Reversed_0(self),Handle_Geom_Curve)};Geom_Parabola.prototype["FirstParameter"]=Geom_Parabola.prototype.FirstParameter=function(){var self=this.ptr;return _emscripten_bind_Geom_Parabola_FirstParameter_0(self)};Geom_Parabola.prototype["LastParameter"]=Geom_Parabola.prototype.LastParameter=function(){var self=this.ptr;return _emscripten_bind_Geom_Parabola_LastParameter_0(self)};Geom_Parabola.prototype["IsClosed"]=Geom_Parabola.prototype.IsClosed=function(){var self=this.ptr;return!!_emscripten_bind_Geom_Parabola_IsClosed_0(self)};Geom_Parabola.prototype["IsPeriodic"]=Geom_Parabola.prototype.IsPeriodic=function(){var self=this.ptr;return!!_emscripten_bind_Geom_Parabola_IsPeriodic_0(self)};Geom_Parabola.prototype["Period"]=Geom_Parabola.prototype.Period=function(){var self=this.ptr;return _emscripten_bind_Geom_Parabola_Period_0(self)};Geom_Parabola.prototype["IsCN"]=Geom_Parabola.prototype.IsCN=function(N){var self=this.ptr;if(N&&typeof N==="object")N=N.ptr;return!!_emscripten_bind_Geom_Parabola_IsCN_1(self,N)};Geom_Parabola.prototype["D0"]=Geom_Parabola.prototype.D0=function(U,P){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;_emscripten_bind_Geom_Parabola_D0_2(self,U,P)};Geom_Parabola.prototype["D1"]=Geom_Parabola.prototype.D1=function(U,P,V1){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;_emscripten_bind_Geom_Parabola_D1_3(self,U,P,V1)};Geom_Parabola.prototype["D2"]=Geom_Parabola.prototype.D2=function(U,P,V1,V2){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;if(V2&&typeof V2==="object")V2=V2.ptr;_emscripten_bind_Geom_Parabola_D2_4(self,U,P,V1,V2)};Geom_Parabola.prototype["D3"]=Geom_Parabola.prototype.D3=function(U,P,V1,V2,V3){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;if(V2&&typeof V2==="object")V2=V2.ptr;if(V3&&typeof V3==="object")V3=V3.ptr;_emscripten_bind_Geom_Parabola_D3_5(self,U,P,V1,V2,V3)};Geom_Parabola.prototype["DN"]=Geom_Parabola.prototype.DN=function(U,N){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(N&&typeof N==="object")N=N.ptr;_emscripten_bind_Geom_Parabola_DN_2(self,U,N)};Geom_Parabola.prototype["Value"]=Geom_Parabola.prototype.Value=function(U){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;return wrapPointer(_emscripten_bind_Geom_Parabola_Value_1(self,U),gp_Pnt)};Geom_Parabola.prototype["__destroy__"]=Geom_Parabola.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Geom_Parabola___destroy___0(self)};function gp_Elips(A2,MajorRadius,MinorRadius){if(A2&&typeof A2==="object")A2=A2.ptr;if(MajorRadius&&typeof MajorRadius==="object")MajorRadius=MajorRadius.ptr;if(MinorRadius&&typeof MinorRadius==="object")MinorRadius=MinorRadius.ptr;if(A2===undefined){this.ptr=_emscripten_bind_gp_Elips_gp_Elips_0();getCache(gp_Elips)[this.ptr]=this;return}if(MajorRadius===undefined){this.ptr=_emscripten_bind_gp_Elips_gp_Elips_1(A2);getCache(gp_Elips)[this.ptr]=this;return}if(MinorRadius===undefined){this.ptr=_emscripten_bind_gp_Elips_gp_Elips_2(A2,MajorRadius);getCache(gp_Elips)[this.ptr]=this;return}this.ptr=_emscripten_bind_gp_Elips_gp_Elips_3(A2,MajorRadius,MinorRadius);getCache(gp_Elips)[this.ptr]=this}gp_Elips.prototype=Object.create(WrapperObject.prototype);gp_Elips.prototype.constructor=gp_Elips;gp_Elips.prototype.__class__=gp_Elips;gp_Elips.__cache__={};Module["gp_Elips"]=gp_Elips;gp_Elips.prototype["Eccentricity"]=gp_Elips.prototype.Eccentricity=function(){var self=this.ptr;return _emscripten_bind_gp_Elips_Eccentricity_0(self)};gp_Elips.prototype["Focal"]=gp_Elips.prototype.Focal=function(){var self=this.ptr;return _emscripten_bind_gp_Elips_Focal_0(self)};gp_Elips.prototype["Area"]=gp_Elips.prototype.Area=function(){var self=this.ptr;return _emscripten_bind_gp_Elips_Area_0(self)};gp_Elips.prototype["MajorRadius"]=gp_Elips.prototype.MajorRadius=function(){var self=this.ptr;return _emscripten_bind_gp_Elips_MajorRadius_0(self)};gp_Elips.prototype["MinorRadius"]=gp_Elips.prototype.MinorRadius=function(){var self=this.ptr;return _emscripten_bind_gp_Elips_MinorRadius_0(self)};gp_Elips.prototype["__destroy__"]=gp_Elips.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_gp_Elips___destroy___0(self)};function Geom2d_TrimmedCurve(C,U1,U2,Sense,theAdjustPeriodic){if(C&&typeof C==="object")C=C.ptr;if(U1&&typeof U1==="object")U1=U1.ptr;if(U2&&typeof U2==="object")U2=U2.ptr;if(Sense&&typeof Sense==="object")Sense=Sense.ptr;if(theAdjustPeriodic&&typeof theAdjustPeriodic==="object")theAdjustPeriodic=theAdjustPeriodic.ptr;if(Sense===undefined){this.ptr=_emscripten_bind_Geom2d_TrimmedCurve_Geom2d_TrimmedCurve_3(C,U1,U2);getCache(Geom2d_TrimmedCurve)[this.ptr]=this;return}if(theAdjustPeriodic===undefined){this.ptr=_emscripten_bind_Geom2d_TrimmedCurve_Geom2d_TrimmedCurve_4(C,U1,U2,Sense);getCache(Geom2d_TrimmedCurve)[this.ptr]=this;return}this.ptr=_emscripten_bind_Geom2d_TrimmedCurve_Geom2d_TrimmedCurve_5(C,U1,U2,Sense,theAdjustPeriodic);getCache(Geom2d_TrimmedCurve)[this.ptr]=this}Geom2d_TrimmedCurve.prototype=Object.create(Geom2d_BoundedCurve.prototype);Geom2d_TrimmedCurve.prototype.constructor=Geom2d_TrimmedCurve;Geom2d_TrimmedCurve.prototype.__class__=Geom2d_TrimmedCurve;Geom2d_TrimmedCurve.__cache__={};Module["Geom2d_TrimmedCurve"]=Geom2d_TrimmedCurve;Geom2d_TrimmedCurve.prototype["Period"]=Geom2d_TrimmedCurve.prototype.Period=function(){var self=this.ptr;return _emscripten_bind_Geom2d_TrimmedCurve_Period_0(self)};Geom2d_TrimmedCurve.prototype["Value"]=Geom2d_TrimmedCurve.prototype.Value=function(U){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;return wrapPointer(_emscripten_bind_Geom2d_TrimmedCurve_Value_1(self,U),gp_Pnt2d)};Geom2d_TrimmedCurve.prototype["__destroy__"]=Geom2d_TrimmedCurve.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Geom2d_TrimmedCurve___destroy___0(self)};function BRepPrimAPI_MakeRevol(S,A,D,Copy){if(S&&typeof S==="object")S=S.ptr;if(A&&typeof A==="object")A=A.ptr;if(D&&typeof D==="object")D=D.ptr;if(Copy&&typeof Copy==="object")Copy=Copy.ptr;if(Copy===undefined){this.ptr=_emscripten_bind_BRepPrimAPI_MakeRevol_BRepPrimAPI_MakeRevol_3(S,A,D);getCache(BRepPrimAPI_MakeRevol)[this.ptr]=this;return}this.ptr=_emscripten_bind_BRepPrimAPI_MakeRevol_BRepPrimAPI_MakeRevol_4(S,A,D,Copy);getCache(BRepPrimAPI_MakeRevol)[this.ptr]=this}BRepPrimAPI_MakeRevol.prototype=Object.create(BRepPrimAPI_MakeSweep.prototype);BRepPrimAPI_MakeRevol.prototype.constructor=BRepPrimAPI_MakeRevol;BRepPrimAPI_MakeRevol.prototype.__class__=BRepPrimAPI_MakeRevol;BRepPrimAPI_MakeRevol.__cache__={};Module["BRepPrimAPI_MakeRevol"]=BRepPrimAPI_MakeRevol;BRepPrimAPI_MakeRevol.prototype["Build"]=BRepPrimAPI_MakeRevol.prototype.Build=function(){var self=this.ptr;_emscripten_bind_BRepPrimAPI_MakeRevol_Build_0(self)};BRepPrimAPI_MakeRevol.prototype["Generated"]=BRepPrimAPI_MakeRevol.prototype.Generated=function(S){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeRevol_Generated_1(self,S),TopTools_ListOfShape)};BRepPrimAPI_MakeRevol.prototype["IsDeleted"]=BRepPrimAPI_MakeRevol.prototype.IsDeleted=function(S){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;return!!_emscripten_bind_BRepPrimAPI_MakeRevol_IsDeleted_1(self,S)};BRepPrimAPI_MakeRevol.prototype["FirstShape"]=BRepPrimAPI_MakeRevol.prototype.FirstShape=function(theShape){var self=this.ptr;if(theShape&&typeof theShape==="object")theShape=theShape.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeRevol_FirstShape_1(self,theShape),TopoDS_Shape)};BRepPrimAPI_MakeRevol.prototype["LastShape"]=BRepPrimAPI_MakeRevol.prototype.LastShape=function(theShape){var self=this.ptr;if(theShape&&typeof theShape==="object")theShape=theShape.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeRevol_LastShape_1(self,theShape),TopoDS_Shape)};BRepPrimAPI_MakeRevol.prototype["HasDegenerated"]=BRepPrimAPI_MakeRevol.prototype.HasDegenerated=function(){var self=this.ptr;return!!_emscripten_bind_BRepPrimAPI_MakeRevol_HasDegenerated_0(self)};BRepPrimAPI_MakeRevol.prototype["Degenerated"]=BRepPrimAPI_MakeRevol.prototype.Degenerated=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeRevol_Degenerated_0(self),TopTools_ListOfShape)};BRepPrimAPI_MakeRevol.prototype["Shape"]=BRepPrimAPI_MakeRevol.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeRevol_Shape_0(self),TopoDS_Shape)};BRepPrimAPI_MakeRevol.prototype["__destroy__"]=BRepPrimAPI_MakeRevol.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepPrimAPI_MakeRevol___destroy___0(self)};function gp_Ax3(){this.ptr=_emscripten_bind_gp_Ax3_gp_Ax3_0();getCache(gp_Ax3)[this.ptr]=this}gp_Ax3.prototype=Object.create(WrapperObject.prototype);gp_Ax3.prototype.constructor=gp_Ax3;gp_Ax3.prototype.__class__=gp_Ax3;gp_Ax3.__cache__={};Module["gp_Ax3"]=gp_Ax3;gp_Ax3.prototype["__destroy__"]=gp_Ax3.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_gp_Ax3___destroy___0(self)};function gp_Ax2(P,V){if(P&&typeof P==="object")P=P.ptr;if(V&&typeof V==="object")V=V.ptr;if(P===undefined){this.ptr=_emscripten_bind_gp_Ax2_gp_Ax2_0();getCache(gp_Ax2)[this.ptr]=this;return}if(V===undefined){this.ptr=_emscripten_bind_gp_Ax2_gp_Ax2_1(P);getCache(gp_Ax2)[this.ptr]=this;return}this.ptr=_emscripten_bind_gp_Ax2_gp_Ax2_2(P,V);getCache(gp_Ax2)[this.ptr]=this}gp_Ax2.prototype=Object.create(WrapperObject.prototype);gp_Ax2.prototype.constructor=gp_Ax2;gp_Ax2.prototype.__class__=gp_Ax2;gp_Ax2.__cache__={};Module["gp_Ax2"]=gp_Ax2;gp_Ax2.prototype["__destroy__"]=gp_Ax2.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_gp_Ax2___destroy___0(self)};function gp_Ax1(P,V){if(P&&typeof P==="object")P=P.ptr;if(V&&typeof V==="object")V=V.ptr;if(P===undefined){this.ptr=_emscripten_bind_gp_Ax1_gp_Ax1_0();getCache(gp_Ax1)[this.ptr]=this;return}if(V===undefined){this.ptr=_emscripten_bind_gp_Ax1_gp_Ax1_1(P);getCache(gp_Ax1)[this.ptr]=this;return}this.ptr=_emscripten_bind_gp_Ax1_gp_Ax1_2(P,V);getCache(gp_Ax1)[this.ptr]=this}gp_Ax1.prototype=Object.create(WrapperObject.prototype);gp_Ax1.prototype.constructor=gp_Ax1;gp_Ax1.prototype.__class__=gp_Ax1;gp_Ax1.__cache__={};Module["gp_Ax1"]=gp_Ax1;gp_Ax1.prototype["__destroy__"]=gp_Ax1.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_gp_Ax1___destroy___0(self)};function gp_Ax2d(P,V){if(P&&typeof P==="object")P=P.ptr;if(V&&typeof V==="object")V=V.ptr;if(P===undefined){this.ptr=_emscripten_bind_gp_Ax2d_gp_Ax2d_0();getCache(gp_Ax2d)[this.ptr]=this;return}if(V===undefined){this.ptr=_emscripten_bind_gp_Ax2d_gp_Ax2d_1(P);getCache(gp_Ax2d)[this.ptr]=this;return}this.ptr=_emscripten_bind_gp_Ax2d_gp_Ax2d_2(P,V);getCache(gp_Ax2d)[this.ptr]=this}gp_Ax2d.prototype=Object.create(WrapperObject.prototype);gp_Ax2d.prototype.constructor=gp_Ax2d;gp_Ax2d.prototype.__class__=gp_Ax2d;gp_Ax2d.__cache__={};Module["gp_Ax2d"]=gp_Ax2d;gp_Ax2d.prototype["__destroy__"]=gp_Ax2d.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_gp_Ax2d___destroy___0(self)};function Transfer_TransientProcess(nb){if(nb&&typeof nb==="object")nb=nb.ptr;if(nb===undefined){this.ptr=_emscripten_bind_Transfer_TransientProcess_Transfer_TransientProcess_0();getCache(Transfer_TransientProcess)[this.ptr]=this;return}this.ptr=_emscripten_bind_Transfer_TransientProcess_Transfer_TransientProcess_1(nb);getCache(Transfer_TransientProcess)[this.ptr]=this}Transfer_TransientProcess.prototype=Object.create(Transfer_ProcessForTransient.prototype);Transfer_TransientProcess.prototype.constructor=Transfer_TransientProcess;Transfer_TransientProcess.prototype.__class__=Transfer_TransientProcess;Transfer_TransientProcess.__cache__={};Module["Transfer_TransientProcess"]=Transfer_TransientProcess;Transfer_TransientProcess.prototype["HasGraph"]=Transfer_TransientProcess.prototype.HasGraph=function(){var self=this.ptr;return!!_emscripten_bind_Transfer_TransientProcess_HasGraph_0(self)};Transfer_TransientProcess.prototype["GetProgress"]=Transfer_TransientProcess.prototype.GetProgress=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Transfer_TransientProcess_GetProgress_0(self),Handle_Message_ProgressIndicator)};Transfer_TransientProcess.prototype["SetProgress"]=Transfer_TransientProcess.prototype.SetProgress=function(theProgess){var self=this.ptr;if(theProgess&&typeof theProgess==="object")theProgess=theProgess.ptr;_emscripten_bind_Transfer_TransientProcess_SetProgress_1(self,theProgess)};Transfer_TransientProcess.prototype["__destroy__"]=Transfer_TransientProcess.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Transfer_TransientProcess___destroy___0(self)};function BRepOffsetAPI_MakeOffset(Spine,Join,IsOpenResult){if(Spine&&typeof Spine==="object")Spine=Spine.ptr;if(Join&&typeof Join==="object")Join=Join.ptr;if(IsOpenResult&&typeof IsOpenResult==="object")IsOpenResult=IsOpenResult.ptr;if(Spine===undefined){this.ptr=_emscripten_bind_BRepOffsetAPI_MakeOffset_BRepOffsetAPI_MakeOffset_0();getCache(BRepOffsetAPI_MakeOffset)[this.ptr]=this;return}if(Join===undefined){this.ptr=_emscripten_bind_BRepOffsetAPI_MakeOffset_BRepOffsetAPI_MakeOffset_1(Spine);getCache(BRepOffsetAPI_MakeOffset)[this.ptr]=this;return}if(IsOpenResult===undefined){this.ptr=_emscripten_bind_BRepOffsetAPI_MakeOffset_BRepOffsetAPI_MakeOffset_2(Spine,Join);getCache(BRepOffsetAPI_MakeOffset)[this.ptr]=this;return}this.ptr=_emscripten_bind_BRepOffsetAPI_MakeOffset_BRepOffsetAPI_MakeOffset_3(Spine,Join,IsOpenResult);getCache(BRepOffsetAPI_MakeOffset)[this.ptr]=this}BRepOffsetAPI_MakeOffset.prototype=Object.create(BRepBuilderAPI_MakeShape.prototype);BRepOffsetAPI_MakeOffset.prototype.constructor=BRepOffsetAPI_MakeOffset;BRepOffsetAPI_MakeOffset.prototype.__class__=BRepOffsetAPI_MakeOffset;BRepOffsetAPI_MakeOffset.__cache__={};Module["BRepOffsetAPI_MakeOffset"]=BRepOffsetAPI_MakeOffset;BRepOffsetAPI_MakeOffset.prototype["AddWire"]=BRepOffsetAPI_MakeOffset.prototype.AddWire=function(Spine){var self=this.ptr;if(Spine&&typeof Spine==="object")Spine=Spine.ptr;_emscripten_bind_BRepOffsetAPI_MakeOffset_AddWire_1(self,Spine)};BRepOffsetAPI_MakeOffset.prototype["Perform"]=BRepOffsetAPI_MakeOffset.prototype.Perform=function(Offset,Alt){var self=this.ptr;if(Offset&&typeof Offset==="object")Offset=Offset.ptr;if(Alt&&typeof Alt==="object")Alt=Alt.ptr;if(Alt===undefined){_emscripten_bind_BRepOffsetAPI_MakeOffset_Perform_1(self,Offset);return}_emscripten_bind_BRepOffsetAPI_MakeOffset_Perform_2(self,Offset,Alt)};BRepOffsetAPI_MakeOffset.prototype["Shape"]=BRepOffsetAPI_MakeOffset.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepOffsetAPI_MakeOffset_Shape_0(self),TopoDS_Shape)};BRepOffsetAPI_MakeOffset.prototype["__destroy__"]=BRepOffsetAPI_MakeOffset.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepOffsetAPI_MakeOffset___destroy___0(self)};function BRepPrimAPI_MakePrism(S,V,Copy,Canonize){if(S&&typeof S==="object")S=S.ptr;if(V&&typeof V==="object")V=V.ptr;if(Copy&&typeof Copy==="object")Copy=Copy.ptr;if(Canonize&&typeof Canonize==="object")Canonize=Canonize.ptr;if(Copy===undefined){this.ptr=_emscripten_bind_BRepPrimAPI_MakePrism_BRepPrimAPI_MakePrism_2(S,V);getCache(BRepPrimAPI_MakePrism)[this.ptr]=this;return}if(Canonize===undefined){this.ptr=_emscripten_bind_BRepPrimAPI_MakePrism_BRepPrimAPI_MakePrism_3(S,V,Copy);getCache(BRepPrimAPI_MakePrism)[this.ptr]=this;return}this.ptr=_emscripten_bind_BRepPrimAPI_MakePrism_BRepPrimAPI_MakePrism_4(S,V,Copy,Canonize);getCache(BRepPrimAPI_MakePrism)[this.ptr]=this}BRepPrimAPI_MakePrism.prototype=Object.create(BRepPrimAPI_MakeSweep.prototype);BRepPrimAPI_MakePrism.prototype.constructor=BRepPrimAPI_MakePrism;BRepPrimAPI_MakePrism.prototype.__class__=BRepPrimAPI_MakePrism;BRepPrimAPI_MakePrism.__cache__={};Module["BRepPrimAPI_MakePrism"]=BRepPrimAPI_MakePrism;BRepPrimAPI_MakePrism.prototype["Build"]=BRepPrimAPI_MakePrism.prototype.Build=function(){var self=this.ptr;_emscripten_bind_BRepPrimAPI_MakePrism_Build_0(self)};BRepPrimAPI_MakePrism.prototype["Generated"]=BRepPrimAPI_MakePrism.prototype.Generated=function(S){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakePrism_Generated_1(self,S),TopTools_ListOfShape)};BRepPrimAPI_MakePrism.prototype["IsDeleted"]=BRepPrimAPI_MakePrism.prototype.IsDeleted=function(S){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;return!!_emscripten_bind_BRepPrimAPI_MakePrism_IsDeleted_1(self,S)};BRepPrimAPI_MakePrism.prototype["FirstShape"]=BRepPrimAPI_MakePrism.prototype.FirstShape=function(theShape){var self=this.ptr;if(theShape&&typeof theShape==="object")theShape=theShape.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakePrism_FirstShape_1(self,theShape),TopoDS_Shape)};BRepPrimAPI_MakePrism.prototype["LastShape"]=BRepPrimAPI_MakePrism.prototype.LastShape=function(theShape){var self=this.ptr;if(theShape&&typeof theShape==="object")theShape=theShape.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakePrism_LastShape_1(self,theShape),TopoDS_Shape)};BRepPrimAPI_MakePrism.prototype["Shape"]=BRepPrimAPI_MakePrism.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakePrism_Shape_0(self),TopoDS_Shape)};BRepPrimAPI_MakePrism.prototype["__destroy__"]=BRepPrimAPI_MakePrism.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepPrimAPI_MakePrism___destroy___0(self)};function BRepBuilderAPI_Transform(S,T,Copy){if(S&&typeof S==="object")S=S.ptr;if(T&&typeof T==="object")T=T.ptr;if(Copy&&typeof Copy==="object")Copy=Copy.ptr;if(Copy===undefined){this.ptr=_emscripten_bind_BRepBuilderAPI_Transform_BRepBuilderAPI_Transform_2(S,T);getCache(BRepBuilderAPI_Transform)[this.ptr]=this;return}this.ptr=_emscripten_bind_BRepBuilderAPI_Transform_BRepBuilderAPI_Transform_3(S,T,Copy);getCache(BRepBuilderAPI_Transform)[this.ptr]=this}BRepBuilderAPI_Transform.prototype=Object.create(BRepBuilderAPI_ModifyShape.prototype);BRepBuilderAPI_Transform.prototype.constructor=BRepBuilderAPI_Transform;BRepBuilderAPI_Transform.prototype.__class__=BRepBuilderAPI_Transform;BRepBuilderAPI_Transform.__cache__={};Module["BRepBuilderAPI_Transform"]=BRepBuilderAPI_Transform;BRepBuilderAPI_Transform.prototype["Shape"]=BRepBuilderAPI_Transform.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepBuilderAPI_Transform_Shape_0(self),TopoDS_Shape)};BRepBuilderAPI_Transform.prototype["__destroy__"]=BRepBuilderAPI_Transform.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepBuilderAPI_Transform___destroy___0(self)};function BRepBuilderAPI_MakeVertex(P){if(P&&typeof P==="object")P=P.ptr;this.ptr=_emscripten_bind_BRepBuilderAPI_MakeVertex_BRepBuilderAPI_MakeVertex_1(P);getCache(BRepBuilderAPI_MakeVertex)[this.ptr]=this}BRepBuilderAPI_MakeVertex.prototype=Object.create(BRepBuilderAPI_MakeShape.prototype);BRepBuilderAPI_MakeVertex.prototype.constructor=BRepBuilderAPI_MakeVertex;BRepBuilderAPI_MakeVertex.prototype.__class__=BRepBuilderAPI_MakeVertex;BRepBuilderAPI_MakeVertex.__cache__={};Module["BRepBuilderAPI_MakeVertex"]=BRepBuilderAPI_MakeVertex;BRepBuilderAPI_MakeVertex.prototype["Vertex"]=BRepBuilderAPI_MakeVertex.prototype.Vertex=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepBuilderAPI_MakeVertex_Vertex_0(self),TopoDS_Vertex)};BRepBuilderAPI_MakeVertex.prototype["Shape"]=BRepBuilderAPI_MakeVertex.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepBuilderAPI_MakeVertex_Shape_0(self),TopoDS_Shape)};BRepBuilderAPI_MakeVertex.prototype["__destroy__"]=BRepBuilderAPI_MakeVertex.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepBuilderAPI_MakeVertex___destroy___0(self)};function BRepAdaptor_Curve(E,F){if(E&&typeof E==="object")E=E.ptr;if(F&&typeof F==="object")F=F.ptr;if(E===undefined){this.ptr=_emscripten_bind_BRepAdaptor_Curve_BRepAdaptor_Curve_0();getCache(BRepAdaptor_Curve)[this.ptr]=this;return}if(F===undefined){this.ptr=_emscripten_bind_BRepAdaptor_Curve_BRepAdaptor_Curve_1(E);getCache(BRepAdaptor_Curve)[this.ptr]=this;return}this.ptr=_emscripten_bind_BRepAdaptor_Curve_BRepAdaptor_Curve_2(E,F);getCache(BRepAdaptor_Curve)[this.ptr]=this}BRepAdaptor_Curve.prototype=Object.create(Adaptor3d_Curve.prototype);BRepAdaptor_Curve.prototype.constructor=BRepAdaptor_Curve;BRepAdaptor_Curve.prototype.__class__=BRepAdaptor_Curve;BRepAdaptor_Curve.__cache__={};Module["BRepAdaptor_Curve"]=BRepAdaptor_Curve;BRepAdaptor_Curve.prototype["Reset"]=BRepAdaptor_Curve.prototype.Reset=function(){var self=this.ptr;_emscripten_bind_BRepAdaptor_Curve_Reset_0(self)};BRepAdaptor_Curve.prototype["Initialize"]=BRepAdaptor_Curve.prototype.Initialize=function(E,F){var self=this.ptr;if(E&&typeof E==="object")E=E.ptr;if(F&&typeof F==="object")F=F.ptr;if(F===undefined){_emscripten_bind_BRepAdaptor_Curve_Initialize_1(self,E);return}_emscripten_bind_BRepAdaptor_Curve_Initialize_2(self,E,F)};BRepAdaptor_Curve.prototype["Trsf"]=BRepAdaptor_Curve.prototype.Trsf=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepAdaptor_Curve_Trsf_0(self),gp_Trsf)};BRepAdaptor_Curve.prototype["Is3DCurve"]=BRepAdaptor_Curve.prototype.Is3DCurve=function(){var self=this.ptr;return!!_emscripten_bind_BRepAdaptor_Curve_Is3DCurve_0(self)};BRepAdaptor_Curve.prototype["IsCurveOnSurface"]=BRepAdaptor_Curve.prototype.IsCurveOnSurface=function(){var self=this.ptr;return!!_emscripten_bind_BRepAdaptor_Curve_IsCurveOnSurface_0(self)};BRepAdaptor_Curve.prototype["Edge"]=BRepAdaptor_Curve.prototype.Edge=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepAdaptor_Curve_Edge_0(self),TopoDS_Edge)};BRepAdaptor_Curve.prototype["Tolerance"]=BRepAdaptor_Curve.prototype.Tolerance=function(){var self=this.ptr;return _emscripten_bind_BRepAdaptor_Curve_Tolerance_0(self)};BRepAdaptor_Curve.prototype["FirstParameter"]=BRepAdaptor_Curve.prototype.FirstParameter=function(){var self=this.ptr;return _emscripten_bind_BRepAdaptor_Curve_FirstParameter_0(self)};BRepAdaptor_Curve.prototype["LastParameter"]=BRepAdaptor_Curve.prototype.LastParameter=function(){var self=this.ptr;return _emscripten_bind_BRepAdaptor_Curve_LastParameter_0(self)};BRepAdaptor_Curve.prototype["IsClosed"]=BRepAdaptor_Curve.prototype.IsClosed=function(){var self=this.ptr;return!!_emscripten_bind_BRepAdaptor_Curve_IsClosed_0(self)};BRepAdaptor_Curve.prototype["IsPeriodic"]=BRepAdaptor_Curve.prototype.IsPeriodic=function(){var self=this.ptr;return!!_emscripten_bind_BRepAdaptor_Curve_IsPeriodic_0(self)};BRepAdaptor_Curve.prototype["Period"]=BRepAdaptor_Curve.prototype.Period=function(){var self=this.ptr;return _emscripten_bind_BRepAdaptor_Curve_Period_0(self)};BRepAdaptor_Curve.prototype["Value"]=BRepAdaptor_Curve.prototype.Value=function(U){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;return wrapPointer(_emscripten_bind_BRepAdaptor_Curve_Value_1(self,U),gp_Pnt)};BRepAdaptor_Curve.prototype["D0"]=BRepAdaptor_Curve.prototype.D0=function(U,P){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;_emscripten_bind_BRepAdaptor_Curve_D0_2(self,U,P)};BRepAdaptor_Curve.prototype["D1"]=BRepAdaptor_Curve.prototype.D1=function(U,P,V1){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;_emscripten_bind_BRepAdaptor_Curve_D1_3(self,U,P,V1)};BRepAdaptor_Curve.prototype["D2"]=BRepAdaptor_Curve.prototype.D2=function(U,P,V1,V2){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;if(V2&&typeof V2==="object")V2=V2.ptr;_emscripten_bind_BRepAdaptor_Curve_D2_4(self,U,P,V1,V2)};BRepAdaptor_Curve.prototype["D3"]=BRepAdaptor_Curve.prototype.D3=function(U,P,V1,V2,V3){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;if(V2&&typeof V2==="object")V2=V2.ptr;if(V3&&typeof V3==="object")V3=V3.ptr;_emscripten_bind_BRepAdaptor_Curve_D3_5(self,U,P,V1,V2,V3)};BRepAdaptor_Curve.prototype["DN"]=BRepAdaptor_Curve.prototype.DN=function(U,N){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(N&&typeof N==="object")N=N.ptr;_emscripten_bind_BRepAdaptor_Curve_DN_2(self,U,N)};BRepAdaptor_Curve.prototype["Resolution"]=BRepAdaptor_Curve.prototype.Resolution=function(R3d){var self=this.ptr;if(R3d&&typeof R3d==="object")R3d=R3d.ptr;return _emscripten_bind_BRepAdaptor_Curve_Resolution_1(self,R3d)};BRepAdaptor_Curve.prototype["Line"]=BRepAdaptor_Curve.prototype.Line=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepAdaptor_Curve_Line_0(self),gp_Lin)};BRepAdaptor_Curve.prototype["Circle"]=BRepAdaptor_Curve.prototype.Circle=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepAdaptor_Curve_Circle_0(self),gp_Circ)};BRepAdaptor_Curve.prototype["Degree"]=BRepAdaptor_Curve.prototype.Degree=function(){var self=this.ptr;return _emscripten_bind_BRepAdaptor_Curve_Degree_0(self)};BRepAdaptor_Curve.prototype["IsRational"]=BRepAdaptor_Curve.prototype.IsRational=function(){var self=this.ptr;return!!_emscripten_bind_BRepAdaptor_Curve_IsRational_0(self)};BRepAdaptor_Curve.prototype["NbPoles"]=BRepAdaptor_Curve.prototype.NbPoles=function(){var self=this.ptr;return _emscripten_bind_BRepAdaptor_Curve_NbPoles_0(self)};BRepAdaptor_Curve.prototype["NbKnots"]=BRepAdaptor_Curve.prototype.NbKnots=function(){var self=this.ptr;return _emscripten_bind_BRepAdaptor_Curve_NbKnots_0(self)};BRepAdaptor_Curve.prototype["Bezier"]=BRepAdaptor_Curve.prototype.Bezier=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepAdaptor_Curve_Bezier_0(self),Handle_Geom_BezierCurve)};BRepAdaptor_Curve.prototype["BSpline"]=BRepAdaptor_Curve.prototype.BSpline=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepAdaptor_Curve_BSpline_0(self),Handle_Geom_BSplineCurve)};BRepAdaptor_Curve.prototype["__destroy__"]=BRepAdaptor_Curve.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepAdaptor_Curve___destroy___0(self)};function gp_Pnt2d(Xp,Yp){if(Xp&&typeof Xp==="object")Xp=Xp.ptr;if(Yp&&typeof Yp==="object")Yp=Yp.ptr;if(Xp===undefined){this.ptr=_emscripten_bind_gp_Pnt2d_gp_Pnt2d_0();getCache(gp_Pnt2d)[this.ptr]=this;return}if(Yp===undefined){this.ptr=_emscripten_bind_gp_Pnt2d_gp_Pnt2d_1(Xp);getCache(gp_Pnt2d)[this.ptr]=this;return}this.ptr=_emscripten_bind_gp_Pnt2d_gp_Pnt2d_2(Xp,Yp);getCache(gp_Pnt2d)[this.ptr]=this}gp_Pnt2d.prototype=Object.create(WrapperObject.prototype);gp_Pnt2d.prototype.constructor=gp_Pnt2d;gp_Pnt2d.prototype.__class__=gp_Pnt2d;gp_Pnt2d.__cache__={};Module["gp_Pnt2d"]=gp_Pnt2d;gp_Pnt2d.prototype["X"]=gp_Pnt2d.prototype.X=function(){var self=this.ptr;return _emscripten_bind_gp_Pnt2d_X_0(self)};gp_Pnt2d.prototype["Y"]=gp_Pnt2d.prototype.Y=function(){var self=this.ptr;return _emscripten_bind_gp_Pnt2d_Y_0(self)};gp_Pnt2d.prototype["__destroy__"]=gp_Pnt2d.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_gp_Pnt2d___destroy___0(self)};function BRepBuilderAPI_MakeWire(E1,E2,E3){if(E1&&typeof E1==="object")E1=E1.ptr;if(E2&&typeof E2==="object")E2=E2.ptr;if(E3&&typeof E3==="object")E3=E3.ptr;if(E1===undefined){this.ptr=_emscripten_bind_BRepBuilderAPI_MakeWire_BRepBuilderAPI_MakeWire_0();getCache(BRepBuilderAPI_MakeWire)[this.ptr]=this;return}if(E2===undefined){this.ptr=_emscripten_bind_BRepBuilderAPI_MakeWire_BRepBuilderAPI_MakeWire_1(E1);getCache(BRepBuilderAPI_MakeWire)[this.ptr]=this;return}if(E3===undefined){this.ptr=_emscripten_bind_BRepBuilderAPI_MakeWire_BRepBuilderAPI_MakeWire_2(E1,E2);getCache(BRepBuilderAPI_MakeWire)[this.ptr]=this;return}this.ptr=_emscripten_bind_BRepBuilderAPI_MakeWire_BRepBuilderAPI_MakeWire_3(E1,E2,E3);getCache(BRepBuilderAPI_MakeWire)[this.ptr]=this}BRepBuilderAPI_MakeWire.prototype=Object.create(BRepBuilderAPI_MakeShape.prototype);BRepBuilderAPI_MakeWire.prototype.constructor=BRepBuilderAPI_MakeWire;BRepBuilderAPI_MakeWire.prototype.__class__=BRepBuilderAPI_MakeWire;BRepBuilderAPI_MakeWire.__cache__={};Module["BRepBuilderAPI_MakeWire"]=BRepBuilderAPI_MakeWire;BRepBuilderAPI_MakeWire.prototype["Add"]=BRepBuilderAPI_MakeWire.prototype.Add=function(W){var self=this.ptr;if(W&&typeof W==="object")W=W.ptr;_emscripten_bind_BRepBuilderAPI_MakeWire_Add_1(self,W)};BRepBuilderAPI_MakeWire.prototype["Wire"]=BRepBuilderAPI_MakeWire.prototype.Wire=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepBuilderAPI_MakeWire_Wire_0(self),TopoDS_Wire)};BRepBuilderAPI_MakeWire.prototype["Shape"]=BRepBuilderAPI_MakeWire.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepBuilderAPI_MakeWire_Shape_0(self),TopoDS_Shape)};BRepBuilderAPI_MakeWire.prototype["__destroy__"]=BRepBuilderAPI_MakeWire.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepBuilderAPI_MakeWire___destroy___0(self)};function StdPrs_ToolTriangulatedShape(){this.ptr=_emscripten_bind_StdPrs_ToolTriangulatedShape_StdPrs_ToolTriangulatedShape_0();getCache(StdPrs_ToolTriangulatedShape)[this.ptr]=this}StdPrs_ToolTriangulatedShape.prototype=Object.create(WrapperObject.prototype);StdPrs_ToolTriangulatedShape.prototype.constructor=StdPrs_ToolTriangulatedShape;StdPrs_ToolTriangulatedShape.prototype.__class__=StdPrs_ToolTriangulatedShape;StdPrs_ToolTriangulatedShape.__cache__={};Module["StdPrs_ToolTriangulatedShape"]=StdPrs_ToolTriangulatedShape;StdPrs_ToolTriangulatedShape.prototype["IsTriangulated"]=StdPrs_ToolTriangulatedShape.prototype.IsTriangulated=function(theShape){var self=this.ptr;if(theShape&&typeof theShape==="object")theShape=theShape.ptr;return!!_emscripten_bind_StdPrs_ToolTriangulatedShape_IsTriangulated_1(self,theShape)};StdPrs_ToolTriangulatedShape.prototype["IsClosed"]=StdPrs_ToolTriangulatedShape.prototype.IsClosed=function(theShape){var self=this.ptr;if(theShape&&typeof theShape==="object")theShape=theShape.ptr;return!!_emscripten_bind_StdPrs_ToolTriangulatedShape_IsClosed_1(self,theShape)};StdPrs_ToolTriangulatedShape.prototype["ComputeNormals"]=StdPrs_ToolTriangulatedShape.prototype.ComputeNormals=function(theFace,theTris,thePolyConnect){var self=this.ptr;if(theFace&&typeof theFace==="object")theFace=theFace.ptr;if(theTris&&typeof theTris==="object")theTris=theTris.ptr;if(thePolyConnect&&typeof thePolyConnect==="object")thePolyConnect=thePolyConnect.ptr;if(thePolyConnect===undefined){_emscripten_bind_StdPrs_ToolTriangulatedShape_ComputeNormals_2(self,theFace,theTris);return}_emscripten_bind_StdPrs_ToolTriangulatedShape_ComputeNormals_3(self,theFace,theTris,thePolyConnect)};StdPrs_ToolTriangulatedShape.prototype["Normal"]=StdPrs_ToolTriangulatedShape.prototype.Normal=function(theFace,thePolyConnect,theNormals){var self=this.ptr;if(theFace&&typeof theFace==="object")theFace=theFace.ptr;if(thePolyConnect&&typeof thePolyConnect==="object")thePolyConnect=thePolyConnect.ptr;if(theNormals&&typeof theNormals==="object")theNormals=theNormals.ptr;_emscripten_bind_StdPrs_ToolTriangulatedShape_Normal_3(self,theFace,thePolyConnect,theNormals)};StdPrs_ToolTriangulatedShape.prototype["__destroy__"]=StdPrs_ToolTriangulatedShape.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_StdPrs_ToolTriangulatedShape___destroy___0(self)};function BRepPrimAPI_MakeTorus(Axes,R1,R2,angle1,angle2,angle){if(Axes&&typeof Axes==="object")Axes=Axes.ptr;if(R1&&typeof R1==="object")R1=R1.ptr;if(R2&&typeof R2==="object")R2=R2.ptr;if(angle1&&typeof angle1==="object")angle1=angle1.ptr;if(angle2&&typeof angle2==="object")angle2=angle2.ptr;if(angle&&typeof angle==="object")angle=angle.ptr;if(angle1===undefined){this.ptr=_emscripten_bind_BRepPrimAPI_MakeTorus_BRepPrimAPI_MakeTorus_3(Axes,R1,R2);getCache(BRepPrimAPI_MakeTorus)[this.ptr]=this;return}if(angle2===undefined){this.ptr=_emscripten_bind_BRepPrimAPI_MakeTorus_BRepPrimAPI_MakeTorus_4(Axes,R1,R2,angle1);getCache(BRepPrimAPI_MakeTorus)[this.ptr]=this;return}if(angle===undefined){this.ptr=_emscripten_bind_BRepPrimAPI_MakeTorus_BRepPrimAPI_MakeTorus_5(Axes,R1,R2,angle1,angle2);getCache(BRepPrimAPI_MakeTorus)[this.ptr]=this;return}this.ptr=_emscripten_bind_BRepPrimAPI_MakeTorus_BRepPrimAPI_MakeTorus_6(Axes,R1,R2,angle1,angle2,angle);getCache(BRepPrimAPI_MakeTorus)[this.ptr]=this}BRepPrimAPI_MakeTorus.prototype=Object.create(BRepPrimAPI_MakeOneAxis.prototype);BRepPrimAPI_MakeTorus.prototype.constructor=BRepPrimAPI_MakeTorus;BRepPrimAPI_MakeTorus.prototype.__class__=BRepPrimAPI_MakeTorus;BRepPrimAPI_MakeTorus.__cache__={};Module["BRepPrimAPI_MakeTorus"]=BRepPrimAPI_MakeTorus;BRepPrimAPI_MakeTorus.prototype["Shape"]=BRepPrimAPI_MakeTorus.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeTorus_Shape_0(self),TopoDS_Shape)};BRepPrimAPI_MakeTorus.prototype["Build"]=BRepPrimAPI_MakeTorus.prototype.Build=function(){var self=this.ptr;_emscripten_bind_BRepPrimAPI_MakeTorus_Build_0(self)};BRepPrimAPI_MakeTorus.prototype["Face"]=BRepPrimAPI_MakeTorus.prototype.Face=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeTorus_Face_0(self),TopoDS_Face)};BRepPrimAPI_MakeTorus.prototype["Shell"]=BRepPrimAPI_MakeTorus.prototype.Shell=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeTorus_Shell_0(self),TopoDS_Shell)};BRepPrimAPI_MakeTorus.prototype["Solid"]=BRepPrimAPI_MakeTorus.prototype.Solid=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepPrimAPI_MakeTorus_Solid_0(self),TopoDS_Solid)};BRepPrimAPI_MakeTorus.prototype["__destroy__"]=BRepPrimAPI_MakeTorus.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepPrimAPI_MakeTorus___destroy___0(self)};function BRepFilletAPI_MakeFillet(S){if(S&&typeof S==="object")S=S.ptr;this.ptr=_emscripten_bind_BRepFilletAPI_MakeFillet_BRepFilletAPI_MakeFillet_1(S);getCache(BRepFilletAPI_MakeFillet)[this.ptr]=this}BRepFilletAPI_MakeFillet.prototype=Object.create(BRepFilletAPI_LocalOperation.prototype);BRepFilletAPI_MakeFillet.prototype.constructor=BRepFilletAPI_MakeFillet;BRepFilletAPI_MakeFillet.prototype.__class__=BRepFilletAPI_MakeFillet;BRepFilletAPI_MakeFillet.__cache__={};Module["BRepFilletAPI_MakeFillet"]=BRepFilletAPI_MakeFillet;BRepFilletAPI_MakeFillet.prototype["Add"]=BRepFilletAPI_MakeFillet.prototype.Add=function(Radius,E){var self=this.ptr;if(Radius&&typeof Radius==="object")Radius=Radius.ptr;if(E&&typeof E==="object")E=E.ptr;_emscripten_bind_BRepFilletAPI_MakeFillet_Add_2(self,Radius,E)};BRepFilletAPI_MakeFillet.prototype["Shape"]=BRepFilletAPI_MakeFillet.prototype.Shape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_BRepFilletAPI_MakeFillet_Shape_0(self),TopoDS_Shape)};BRepFilletAPI_MakeFillet.prototype["__destroy__"]=BRepFilletAPI_MakeFillet.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepFilletAPI_MakeFillet___destroy___0(self)};function STEPControl_Reader(){this.ptr=_emscripten_bind_STEPControl_Reader_STEPControl_Reader_0();getCache(STEPControl_Reader)[this.ptr]=this}STEPControl_Reader.prototype=Object.create(XSControl_Reader.prototype);STEPControl_Reader.prototype.constructor=STEPControl_Reader;STEPControl_Reader.prototype.__class__=STEPControl_Reader;STEPControl_Reader.__cache__={};Module["STEPControl_Reader"]=STEPControl_Reader;STEPControl_Reader.prototype["SetNorm"]=STEPControl_Reader.prototype.SetNorm=function(norm){var self=this.ptr;ensureCache.prepare();if(norm&&typeof norm==="object")norm=norm.ptr;else norm=ensureString(norm);return!!_emscripten_bind_STEPControl_Reader_SetNorm_1(self,norm)};STEPControl_Reader.prototype["SetWS"]=STEPControl_Reader.prototype.SetWS=function(WS,scratch){var self=this.ptr;if(WS&&typeof WS==="object")WS=WS.ptr;if(scratch&&typeof scratch==="object")scratch=scratch.ptr;if(scratch===undefined){_emscripten_bind_STEPControl_Reader_SetWS_1(self,WS);return}_emscripten_bind_STEPControl_Reader_SetWS_2(self,WS,scratch)};STEPControl_Reader.prototype["WS"]=STEPControl_Reader.prototype.WS=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_STEPControl_Reader_WS_0(self),Handle_XSControl_WorkSession)};STEPControl_Reader.prototype["ReadFile"]=STEPControl_Reader.prototype.ReadFile=function(filename){var self=this.ptr;ensureCache.prepare();if(filename&&typeof filename==="object")filename=filename.ptr;else filename=ensureString(filename);return _emscripten_bind_STEPControl_Reader_ReadFile_1(self,filename)};STEPControl_Reader.prototype["NbRootsForTransfer"]=STEPControl_Reader.prototype.NbRootsForTransfer=function(){var self=this.ptr;return _emscripten_bind_STEPControl_Reader_NbRootsForTransfer_0(self)};STEPControl_Reader.prototype["TransferOneRoot"]=STEPControl_Reader.prototype.TransferOneRoot=function(num){var self=this.ptr;if(num&&typeof num==="object")num=num.ptr;if(num===undefined){return!!_emscripten_bind_STEPControl_Reader_TransferOneRoot_0(self)}return!!_emscripten_bind_STEPControl_Reader_TransferOneRoot_1(self,num)};STEPControl_Reader.prototype["TransferOne"]=STEPControl_Reader.prototype.TransferOne=function(num){var self=this.ptr;if(num&&typeof num==="object")num=num.ptr;return!!_emscripten_bind_STEPControl_Reader_TransferOne_1(self,num)};STEPControl_Reader.prototype["TransferRoots"]=STEPControl_Reader.prototype.TransferRoots=function(){var self=this.ptr;return _emscripten_bind_STEPControl_Reader_TransferRoots_0(self)};STEPControl_Reader.prototype["ClearShapes"]=STEPControl_Reader.prototype.ClearShapes=function(){var self=this.ptr;_emscripten_bind_STEPControl_Reader_ClearShapes_0(self)};STEPControl_Reader.prototype["NbShapes"]=STEPControl_Reader.prototype.NbShapes=function(){var self=this.ptr;return _emscripten_bind_STEPControl_Reader_NbShapes_0(self)};STEPControl_Reader.prototype["Shape"]=STEPControl_Reader.prototype.Shape=function(num){var self=this.ptr;if(num&&typeof num==="object")num=num.ptr;if(num===undefined){return wrapPointer(_emscripten_bind_STEPControl_Reader_Shape_0(self),TopoDS_Shape)}return wrapPointer(_emscripten_bind_STEPControl_Reader_Shape_1(self,num),TopoDS_Shape)};STEPControl_Reader.prototype["OneShape"]=STEPControl_Reader.prototype.OneShape=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_STEPControl_Reader_OneShape_0(self),TopoDS_Shape)};STEPControl_Reader.prototype["PrintStatsTransfer"]=STEPControl_Reader.prototype.PrintStatsTransfer=function(what,mode){var self=this.ptr;if(what&&typeof what==="object")what=what.ptr;if(mode&&typeof mode==="object")mode=mode.ptr;if(mode===undefined){_emscripten_bind_STEPControl_Reader_PrintStatsTransfer_1(self,what);return}_emscripten_bind_STEPControl_Reader_PrintStatsTransfer_2(self,what,mode)};STEPControl_Reader.prototype["__destroy__"]=STEPControl_Reader.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_STEPControl_Reader___destroy___0(self)};function Handle_Poly_Polygon3D(thePtr){if(thePtr&&typeof thePtr==="object")thePtr=thePtr.ptr;if(thePtr===undefined){this.ptr=_emscripten_bind_Handle_Poly_Polygon3D_Handle_Poly_Polygon3D_0();getCache(Handle_Poly_Polygon3D)[this.ptr]=this;return}this.ptr=_emscripten_bind_Handle_Poly_Polygon3D_Handle_Poly_Polygon3D_1(thePtr);getCache(Handle_Poly_Polygon3D)[this.ptr]=this}Handle_Poly_Polygon3D.prototype=Object.create(WrapperObject.prototype);Handle_Poly_Polygon3D.prototype.constructor=Handle_Poly_Polygon3D;Handle_Poly_Polygon3D.prototype.__class__=Handle_Poly_Polygon3D;Handle_Poly_Polygon3D.__cache__={};Module["Handle_Poly_Polygon3D"]=Handle_Poly_Polygon3D;Handle_Poly_Polygon3D.prototype["IsNull"]=Handle_Poly_Polygon3D.prototype.IsNull=function(){var self=this.ptr;return!!_emscripten_bind_Handle_Poly_Polygon3D_IsNull_0(self)};Handle_Poly_Polygon3D.prototype["Nullify"]=Handle_Poly_Polygon3D.prototype.Nullify=function(){var self=this.ptr;_emscripten_bind_Handle_Poly_Polygon3D_Nullify_0(self)};Handle_Poly_Polygon3D.prototype["get"]=Handle_Poly_Polygon3D.prototype.get=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Handle_Poly_Polygon3D_get_0(self),Poly_Polygon3D)};Handle_Poly_Polygon3D.prototype["__destroy__"]=Handle_Poly_Polygon3D.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Handle_Poly_Polygon3D___destroy___0(self)};function Geom_Circle(A2,Radius){if(A2&&typeof A2==="object")A2=A2.ptr;if(Radius&&typeof Radius==="object")Radius=Radius.ptr;if(Radius===undefined){this.ptr=_emscripten_bind_Geom_Circle_Geom_Circle_1(A2);getCache(Geom_Circle)[this.ptr]=this;return}this.ptr=_emscripten_bind_Geom_Circle_Geom_Circle_2(A2,Radius);getCache(Geom_Circle)[this.ptr]=this}Geom_Circle.prototype=Object.create(Geom_Conic.prototype);Geom_Circle.prototype.constructor=Geom_Circle;Geom_Circle.prototype.__class__=Geom_Circle;Geom_Circle.__cache__={};Module["Geom_Circle"]=Geom_Circle;Geom_Circle.prototype["Radius"]=Geom_Circle.prototype.Radius=function(){var self=this.ptr;return _emscripten_bind_Geom_Circle_Radius_0(self)};Geom_Circle.prototype["Reverse"]=Geom_Circle.prototype.Reverse=function(){var self=this.ptr;_emscripten_bind_Geom_Circle_Reverse_0(self)};Geom_Circle.prototype["ReversedParameter"]=Geom_Circle.prototype.ReversedParameter=function(U){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;return _emscripten_bind_Geom_Circle_ReversedParameter_1(self,U)};Geom_Circle.prototype["TransformedParameter"]=Geom_Circle.prototype.TransformedParameter=function(U,T){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(T&&typeof T==="object")T=T.ptr;return _emscripten_bind_Geom_Circle_TransformedParameter_2(self,U,T)};Geom_Circle.prototype["ParametricTransformation"]=Geom_Circle.prototype.ParametricTransformation=function(T){var self=this.ptr;if(T&&typeof T==="object")T=T.ptr;return _emscripten_bind_Geom_Circle_ParametricTransformation_1(self,T)};Geom_Circle.prototype["Reversed"]=Geom_Circle.prototype.Reversed=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Geom_Circle_Reversed_0(self),Handle_Geom_Curve)};Geom_Circle.prototype["FirstParameter"]=Geom_Circle.prototype.FirstParameter=function(){var self=this.ptr;return _emscripten_bind_Geom_Circle_FirstParameter_0(self)};Geom_Circle.prototype["LastParameter"]=Geom_Circle.prototype.LastParameter=function(){var self=this.ptr;return _emscripten_bind_Geom_Circle_LastParameter_0(self)};Geom_Circle.prototype["IsClosed"]=Geom_Circle.prototype.IsClosed=function(){var self=this.ptr;return!!_emscripten_bind_Geom_Circle_IsClosed_0(self)};Geom_Circle.prototype["IsPeriodic"]=Geom_Circle.prototype.IsPeriodic=function(){var self=this.ptr;return!!_emscripten_bind_Geom_Circle_IsPeriodic_0(self)};Geom_Circle.prototype["Period"]=Geom_Circle.prototype.Period=function(){var self=this.ptr;return _emscripten_bind_Geom_Circle_Period_0(self)};Geom_Circle.prototype["IsCN"]=Geom_Circle.prototype.IsCN=function(N){var self=this.ptr;if(N&&typeof N==="object")N=N.ptr;return!!_emscripten_bind_Geom_Circle_IsCN_1(self,N)};Geom_Circle.prototype["D0"]=Geom_Circle.prototype.D0=function(U,P){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;_emscripten_bind_Geom_Circle_D0_2(self,U,P)};Geom_Circle.prototype["D1"]=Geom_Circle.prototype.D1=function(U,P,V1){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;_emscripten_bind_Geom_Circle_D1_3(self,U,P,V1)};Geom_Circle.prototype["D2"]=Geom_Circle.prototype.D2=function(U,P,V1,V2){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;if(V2&&typeof V2==="object")V2=V2.ptr;_emscripten_bind_Geom_Circle_D2_4(self,U,P,V1,V2)};Geom_Circle.prototype["D3"]=Geom_Circle.prototype.D3=function(U,P,V1,V2,V3){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(P&&typeof P==="object")P=P.ptr;if(V1&&typeof V1==="object")V1=V1.ptr;if(V2&&typeof V2==="object")V2=V2.ptr;if(V3&&typeof V3==="object")V3=V3.ptr;_emscripten_bind_Geom_Circle_D3_5(self,U,P,V1,V2,V3)};Geom_Circle.prototype["DN"]=Geom_Circle.prototype.DN=function(U,N){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;if(N&&typeof N==="object")N=N.ptr;_emscripten_bind_Geom_Circle_DN_2(self,U,N)};Geom_Circle.prototype["Value"]=Geom_Circle.prototype.Value=function(U){var self=this.ptr;if(U&&typeof U==="object")U=U.ptr;return wrapPointer(_emscripten_bind_Geom_Circle_Value_1(self,U),gp_Pnt)};Geom_Circle.prototype["__destroy__"]=Geom_Circle.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Geom_Circle___destroy___0(self)};function BRepBndLib(){this.ptr=_emscripten_bind_BRepBndLib_BRepBndLib_0();getCache(BRepBndLib)[this.ptr]=this}BRepBndLib.prototype=Object.create(WrapperObject.prototype);BRepBndLib.prototype.constructor=BRepBndLib;BRepBndLib.prototype.__class__=BRepBndLib;BRepBndLib.__cache__={};Module["BRepBndLib"]=BRepBndLib;BRepBndLib.prototype["Add"]=BRepBndLib.prototype.Add=function(S,B,useTriangulation){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;if(B&&typeof B==="object")B=B.ptr;if(useTriangulation&&typeof useTriangulation==="object")useTriangulation=useTriangulation.ptr;if(useTriangulation===undefined){_emscripten_bind_BRepBndLib_Add_2(self,S,B);return}_emscripten_bind_BRepBndLib_Add_3(self,S,B,useTriangulation)};BRepBndLib.prototype["AddClose"]=BRepBndLib.prototype.AddClose=function(S,B){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;if(B&&typeof B==="object")B=B.ptr;_emscripten_bind_BRepBndLib_AddClose_2(self,S,B)};BRepBndLib.prototype["AddOptimal"]=BRepBndLib.prototype.AddOptimal=function(S,B,useTriangulation,useShapeToerance){var self=this.ptr;if(S&&typeof S==="object")S=S.ptr;if(B&&typeof B==="object")B=B.ptr;if(useTriangulation&&typeof useTriangulation==="object")useTriangulation=useTriangulation.ptr;if(useShapeToerance&&typeof useShapeToerance==="object")useShapeToerance=useShapeToerance.ptr;if(useTriangulation===undefined){_emscripten_bind_BRepBndLib_AddOptimal_2(self,S,B);return}if(useShapeToerance===undefined){_emscripten_bind_BRepBndLib_AddOptimal_3(self,S,B,useTriangulation);return}_emscripten_bind_BRepBndLib_AddOptimal_4(self,S,B,useTriangulation,useShapeToerance)};BRepBndLib.prototype["AddOBB"]=BRepBndLib.prototype.AddOBB=function(theS,theOBB,theIsTriangulationUsed,theIsOptimal,theIsShapeToleranceUsed){var self=this.ptr;if(theS&&typeof theS==="object")theS=theS.ptr;if(theOBB&&typeof theOBB==="object")theOBB=theOBB.ptr;if(theIsTriangulationUsed&&typeof theIsTriangulationUsed==="object")theIsTriangulationUsed=theIsTriangulationUsed.ptr;if(theIsOptimal&&typeof theIsOptimal==="object")theIsOptimal=theIsOptimal.ptr;if(theIsShapeToleranceUsed&&typeof theIsShapeToleranceUsed==="object")theIsShapeToleranceUsed=theIsShapeToleranceUsed.ptr;if(theIsTriangulationUsed===undefined){_emscripten_bind_BRepBndLib_AddOBB_2(self,theS,theOBB);return}if(theIsOptimal===undefined){_emscripten_bind_BRepBndLib_AddOBB_3(self,theS,theOBB,theIsTriangulationUsed);return}if(theIsShapeToleranceUsed===undefined){_emscripten_bind_BRepBndLib_AddOBB_4(self,theS,theOBB,theIsTriangulationUsed,theIsOptimal);return}_emscripten_bind_BRepBndLib_AddOBB_5(self,theS,theOBB,theIsTriangulationUsed,theIsOptimal,theIsShapeToleranceUsed)};BRepBndLib.prototype["__destroy__"]=BRepBndLib.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_BRepBndLib___destroy___0(self)};function Message_ProgressIndicator(){throw"cannot construct a Message_ProgressIndicator, no constructor in IDL"}Message_ProgressIndicator.prototype=Object.create(WrapperObject.prototype);Message_ProgressIndicator.prototype.constructor=Message_ProgressIndicator;Message_ProgressIndicator.prototype.__class__=Message_ProgressIndicator;Message_ProgressIndicator.__cache__={};Module["Message_ProgressIndicator"]=Message_ProgressIndicator;Message_ProgressIndicator.prototype["GetPosition"]=Message_ProgressIndicator.prototype.GetPosition=function(){var self=this.ptr;return _emscripten_bind_Message_ProgressIndicator_GetPosition_0(self)};Message_ProgressIndicator.prototype["GetValue"]=Message_ProgressIndicator.prototype.GetValue=function(){var self=this.ptr;return _emscripten_bind_Message_ProgressIndicator_GetValue_0(self)};Message_ProgressIndicator.prototype["NewScope"]=Message_ProgressIndicator.prototype.NewScope=function(span,name){var self=this.ptr;ensureCache.prepare();if(span&&typeof span==="object")span=span.ptr;if(name&&typeof name==="object")name=name.ptr;else name=ensureString(name);if(name===undefined){return!!_emscripten_bind_Message_ProgressIndicator_NewScope_1(self,span)}return!!_emscripten_bind_Message_ProgressIndicator_NewScope_2(self,span,name)};Message_ProgressIndicator.prototype["EndScope"]=Message_ProgressIndicator.prototype.EndScope=function(){var self=this.ptr;return!!_emscripten_bind_Message_ProgressIndicator_EndScope_0(self)};Message_ProgressIndicator.prototype["Reset"]=Message_ProgressIndicator.prototype.Reset=function(){var self=this.ptr;_emscripten_bind_Message_ProgressIndicator_Reset_0(self)};Message_ProgressIndicator.prototype["__destroy__"]=Message_ProgressIndicator.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Message_ProgressIndicator___destroy___0(self)};function Poly_Polygon3D(Nodes,Parameters){if(Nodes&&typeof Nodes==="object")Nodes=Nodes.ptr;if(Parameters&&typeof Parameters==="object")Parameters=Parameters.ptr;if(Parameters===undefined){this.ptr=_emscripten_bind_Poly_Polygon3D_Poly_Polygon3D_1(Nodes);getCache(Poly_Polygon3D)[this.ptr]=this;return}this.ptr=_emscripten_bind_Poly_Polygon3D_Poly_Polygon3D_2(Nodes,Parameters);getCache(Poly_Polygon3D)[this.ptr]=this}Poly_Polygon3D.prototype=Object.create(WrapperObject.prototype);Poly_Polygon3D.prototype.constructor=Poly_Polygon3D;Poly_Polygon3D.prototype.__class__=Poly_Polygon3D;Poly_Polygon3D.__cache__={};Module["Poly_Polygon3D"]=Poly_Polygon3D;Poly_Polygon3D.prototype["Copy"]=Poly_Polygon3D.prototype.Copy=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Poly_Polygon3D_Copy_0(self),Handle_Poly_Polygon3D)};Poly_Polygon3D.prototype["Deflection"]=Poly_Polygon3D.prototype.Deflection=function(){var self=this.ptr;return _emscripten_bind_Poly_Polygon3D_Deflection_0(self)};Poly_Polygon3D.prototype["NbNodes"]=Poly_Polygon3D.prototype.NbNodes=function(){var self=this.ptr;return _emscripten_bind_Poly_Polygon3D_NbNodes_0(self)};Poly_Polygon3D.prototype["Nodes"]=Poly_Polygon3D.prototype.Nodes=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Poly_Polygon3D_Nodes_0(self),TColgp_Array1OfPnt)};Poly_Polygon3D.prototype["HasParameters"]=Poly_Polygon3D.prototype.HasParameters=function(){var self=this.ptr;return!!_emscripten_bind_Poly_Polygon3D_HasParameters_0(self)};Poly_Polygon3D.prototype["Parameters"]=Poly_Polygon3D.prototype.Parameters=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Poly_Polygon3D_Parameters_0(self),TColStd_Array1OfReal)};Poly_Polygon3D.prototype["ChangeParameters"]=Poly_Polygon3D.prototype.ChangeParameters=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Poly_Polygon3D_ChangeParameters_0(self),TColStd_Array1OfReal)};Poly_Polygon3D.prototype["__destroy__"]=Poly_Polygon3D.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Poly_Polygon3D___destroy___0(self)};function gp_Dir2d(Xv,Yv){if(Xv&&typeof Xv==="object")Xv=Xv.ptr;if(Yv&&typeof Yv==="object")Yv=Yv.ptr;if(Xv===undefined){this.ptr=_emscripten_bind_gp_Dir2d_gp_Dir2d_0();getCache(gp_Dir2d)[this.ptr]=this;return}if(Yv===undefined){this.ptr=_emscripten_bind_gp_Dir2d_gp_Dir2d_1(Xv);getCache(gp_Dir2d)[this.ptr]=this;return}this.ptr=_emscripten_bind_gp_Dir2d_gp_Dir2d_2(Xv,Yv);getCache(gp_Dir2d)[this.ptr]=this}gp_Dir2d.prototype=Object.create(WrapperObject.prototype);gp_Dir2d.prototype.constructor=gp_Dir2d;gp_Dir2d.prototype.__class__=gp_Dir2d;gp_Dir2d.__cache__={};Module["gp_Dir2d"]=gp_Dir2d;gp_Dir2d.prototype["__destroy__"]=gp_Dir2d.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_gp_Dir2d___destroy___0(self)};function TopoDS_Vertex(T2){if(T2&&typeof T2==="object")T2=T2.ptr;if(T2===undefined){this.ptr=_emscripten_bind_TopoDS_Vertex_TopoDS_Vertex_0();getCache(TopoDS_Vertex)[this.ptr]=this;return}this.ptr=_emscripten_bind_TopoDS_Vertex_TopoDS_Vertex_1(T2);getCache(TopoDS_Vertex)[this.ptr]=this}TopoDS_Vertex.prototype=Object.create(TopoDS_Shape.prototype);TopoDS_Vertex.prototype.constructor=TopoDS_Vertex;TopoDS_Vertex.prototype.__class__=TopoDS_Vertex;TopoDS_Vertex.__cache__={};Module["TopoDS_Vertex"]=TopoDS_Vertex;TopoDS_Vertex.prototype["IsNull"]=TopoDS_Vertex.prototype.IsNull=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Vertex_IsNull_0(self)};TopoDS_Vertex.prototype["Nullify"]=TopoDS_Vertex.prototype.Nullify=function(){var self=this.ptr;_emscripten_bind_TopoDS_Vertex_Nullify_0(self)};TopoDS_Vertex.prototype["Location"]=TopoDS_Vertex.prototype.Location=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_Vertex_Location_0(self),TopLoc_Location)};TopoDS_Vertex.prototype["Located"]=TopoDS_Vertex.prototype.Located=function(theLoc){var self=this.ptr;if(theLoc&&typeof theLoc==="object")theLoc=theLoc.ptr;return wrapPointer(_emscripten_bind_TopoDS_Vertex_Located_1(self,theLoc),TopoDS_Shape)};TopoDS_Vertex.prototype["Orientation"]=TopoDS_Vertex.prototype.Orientation=function(){var self=this.ptr;return _emscripten_bind_TopoDS_Vertex_Orientation_0(self)};TopoDS_Vertex.prototype["Oriented"]=TopoDS_Vertex.prototype.Oriented=function(theOrient){var self=this.ptr;if(theOrient&&typeof theOrient==="object")theOrient=theOrient.ptr;return wrapPointer(_emscripten_bind_TopoDS_Vertex_Oriented_1(self,theOrient),TopoDS_Shape)};TopoDS_Vertex.prototype["ShapeType"]=TopoDS_Vertex.prototype.ShapeType=function(){var self=this.ptr;return _emscripten_bind_TopoDS_Vertex_ShapeType_0(self)};TopoDS_Vertex.prototype["Free"]=TopoDS_Vertex.prototype.Free=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Vertex_Free_0(self)};TopoDS_Vertex.prototype["Locked"]=TopoDS_Vertex.prototype.Locked=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Vertex_Locked_0(self)};TopoDS_Vertex.prototype["Modified"]=TopoDS_Vertex.prototype.Modified=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Vertex_Modified_0(self)};TopoDS_Vertex.prototype["Checked"]=TopoDS_Vertex.prototype.Checked=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Vertex_Checked_0(self)};TopoDS_Vertex.prototype["Orientable"]=TopoDS_Vertex.prototype.Orientable=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Vertex_Orientable_0(self)};TopoDS_Vertex.prototype["Closed"]=TopoDS_Vertex.prototype.Closed=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Vertex_Closed_0(self)};TopoDS_Vertex.prototype["Infinite"]=TopoDS_Vertex.prototype.Infinite=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Vertex_Infinite_0(self)};TopoDS_Vertex.prototype["Convex"]=TopoDS_Vertex.prototype.Convex=function(){var self=this.ptr;return!!_emscripten_bind_TopoDS_Vertex_Convex_0(self)};TopoDS_Vertex.prototype["Move"]=TopoDS_Vertex.prototype.Move=function(thePosition){var self=this.ptr;if(thePosition&&typeof thePosition==="object")thePosition=thePosition.ptr;_emscripten_bind_TopoDS_Vertex_Move_1(self,thePosition)};TopoDS_Vertex.prototype["Moved"]=TopoDS_Vertex.prototype.Moved=function(thePosition){var self=this.ptr;if(thePosition&&typeof thePosition==="object")thePosition=thePosition.ptr;return wrapPointer(_emscripten_bind_TopoDS_Vertex_Moved_1(self,thePosition),TopoDS_Shape)};TopoDS_Vertex.prototype["Reverse"]=TopoDS_Vertex.prototype.Reverse=function(){var self=this.ptr;_emscripten_bind_TopoDS_Vertex_Reverse_0(self)};TopoDS_Vertex.prototype["Reversed"]=TopoDS_Vertex.prototype.Reversed=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_Vertex_Reversed_0(self),TopoDS_Shape)};TopoDS_Vertex.prototype["Complement"]=TopoDS_Vertex.prototype.Complement=function(){var self=this.ptr;_emscripten_bind_TopoDS_Vertex_Complement_0(self)};TopoDS_Vertex.prototype["Complemented"]=TopoDS_Vertex.prototype.Complemented=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_Vertex_Complemented_0(self),TopoDS_Shape)};TopoDS_Vertex.prototype["Compose"]=TopoDS_Vertex.prototype.Compose=function(theOrient){var self=this.ptr;if(theOrient&&typeof theOrient==="object")theOrient=theOrient.ptr;_emscripten_bind_TopoDS_Vertex_Compose_1(self,theOrient)};TopoDS_Vertex.prototype["Composed"]=TopoDS_Vertex.prototype.Composed=function(theOrient){var self=this.ptr;if(theOrient&&typeof theOrient==="object")theOrient=theOrient.ptr;return wrapPointer(_emscripten_bind_TopoDS_Vertex_Composed_1(self,theOrient),TopoDS_Shape)};TopoDS_Vertex.prototype["NbChildren"]=TopoDS_Vertex.prototype.NbChildren=function(){var self=this.ptr;return _emscripten_bind_TopoDS_Vertex_NbChildren_0(self)};TopoDS_Vertex.prototype["IsPartner"]=TopoDS_Vertex.prototype.IsPartner=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_Vertex_IsPartner_1(self,theOther)};TopoDS_Vertex.prototype["IsSame"]=TopoDS_Vertex.prototype.IsSame=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_Vertex_IsSame_1(self,theOther)};TopoDS_Vertex.prototype["IsEqual"]=TopoDS_Vertex.prototype.IsEqual=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_Vertex_IsEqual_1(self,theOther)};TopoDS_Vertex.prototype["IsNotEqual"]=TopoDS_Vertex.prototype.IsNotEqual=function(theOther){var self=this.ptr;if(theOther&&typeof theOther==="object")theOther=theOther.ptr;return!!_emscripten_bind_TopoDS_Vertex_IsNotEqual_1(self,theOther)};TopoDS_Vertex.prototype["HashCode"]=TopoDS_Vertex.prototype.HashCode=function(theUpperBound){var self=this.ptr;if(theUpperBound&&typeof theUpperBound==="object")theUpperBound=theUpperBound.ptr;return _emscripten_bind_TopoDS_Vertex_HashCode_1(self,theUpperBound)};TopoDS_Vertex.prototype["EmptyCopy"]=TopoDS_Vertex.prototype.EmptyCopy=function(){var self=this.ptr;_emscripten_bind_TopoDS_Vertex_EmptyCopy_0(self)};TopoDS_Vertex.prototype["EmptyCopied"]=TopoDS_Vertex.prototype.EmptyCopied=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_TopoDS_Vertex_EmptyCopied_0(self),TopoDS_Shape)};TopoDS_Vertex.prototype["__destroy__"]=TopoDS_Vertex.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_TopoDS_Vertex___destroy___0(self)};function Handle_XSControl_WorkSession(thePtr){if(thePtr&&typeof thePtr==="object")thePtr=thePtr.ptr;if(thePtr===undefined){this.ptr=_emscripten_bind_Handle_XSControl_WorkSession_Handle_XSControl_WorkSession_0();getCache(Handle_XSControl_WorkSession)[this.ptr]=this;return}this.ptr=_emscripten_bind_Handle_XSControl_WorkSession_Handle_XSControl_WorkSession_1(thePtr);getCache(Handle_XSControl_WorkSession)[this.ptr]=this}Handle_XSControl_WorkSession.prototype=Object.create(WrapperObject.prototype);Handle_XSControl_WorkSession.prototype.constructor=Handle_XSControl_WorkSession;Handle_XSControl_WorkSession.prototype.__class__=Handle_XSControl_WorkSession;Handle_XSControl_WorkSession.__cache__={};Module["Handle_XSControl_WorkSession"]=Handle_XSControl_WorkSession;Handle_XSControl_WorkSession.prototype["IsNull"]=Handle_XSControl_WorkSession.prototype.IsNull=function(){var self=this.ptr;return!!_emscripten_bind_Handle_XSControl_WorkSession_IsNull_0(self)};Handle_XSControl_WorkSession.prototype["Nullify"]=Handle_XSControl_WorkSession.prototype.Nullify=function(){var self=this.ptr;_emscripten_bind_Handle_XSControl_WorkSession_Nullify_0(self)};Handle_XSControl_WorkSession.prototype["get"]=Handle_XSControl_WorkSession.prototype.get=function(){var self=this.ptr;return wrapPointer(_emscripten_bind_Handle_XSControl_WorkSession_get_0(self),XSControl_WorkSession)};Handle_XSControl_WorkSession.prototype["__destroy__"]=Handle_XSControl_WorkSession.prototype.__destroy__=function(){var self=this.ptr;_emscripten_bind_Handle_XSControl_WorkSession___destroy___0(self)};(function(){function setupEnums(){Module["BRepBuilderAPI_PipeDone"]=_emscripten_enum_BRepBuilderAPI_PipeError_BRepBuilderAPI_PipeDone();Module["BRepBuilderAPI_PipeNotDone"]=_emscripten_enum_BRepBuilderAPI_PipeError_BRepBuilderAPI_PipeNotDone();Module["BRepBuilderAPI_PlaneNotIntersectGuide"]=_emscripten_enum_BRepBuilderAPI_PipeError_BRepBuilderAPI_PlaneNotIntersectGuide();Module["BRepBuilderAPI_ImpossibleContact"]=_emscripten_enum_BRepBuilderAPI_PipeError_BRepBuilderAPI_ImpossibleContact();Module["TopAbs_FORWARD"]=_emscripten_enum_TopAbs_Orientation_TopAbs_FORWARD();Module["TopAbs_REVERSED"]=_emscripten_enum_TopAbs_Orientation_TopAbs_REVERSED();Module["TopAbs_INTERNAL"]=_emscripten_enum_TopAbs_Orientation_TopAbs_INTERNAL();Module["TopAbs_EXTERNAL"]=_emscripten_enum_TopAbs_Orientation_TopAbs_EXTERNAL();Module["TopAbs_COMPOUND"]=_emscripten_enum_TopAbs_ShapeEnum_TopAbs_COMPOUND();Module["TopAbs_COMPSOLID"]=_emscripten_enum_TopAbs_ShapeEnum_TopAbs_COMPSOLID();Module["TopAbs_SOLID"]=_emscripten_enum_TopAbs_ShapeEnum_TopAbs_SOLID();Module["TopAbs_SHELL"]=_emscripten_enum_TopAbs_ShapeEnum_TopAbs_SHELL();Module["TopAbs_FACE"]=_emscripten_enum_TopAbs_ShapeEnum_TopAbs_FACE();Module["TopAbs_WIRE"]=_emscripten_enum_TopAbs_ShapeEnum_TopAbs_WIRE();Module["TopAbs_EDGE"]=_emscripten_enum_TopAbs_ShapeEnum_TopAbs_EDGE();Module["TopAbs_VERTEX"]=_emscripten_enum_TopAbs_ShapeEnum_TopAbs_VERTEX();Module["TopAbs_SHAPE"]=_emscripten_enum_TopAbs_ShapeEnum_TopAbs_SHAPE();Module["GeomAbs_C0"]=_emscripten_enum_GeomAbs_Shape_GeomAbs_C0();Module["GeomAbs_G1"]=_emscripten_enum_GeomAbs_Shape_GeomAbs_G1();Module["GeomAbs_C1"]=_emscripten_enum_GeomAbs_Shape_GeomAbs_C1();Module["GeomAbs_G2"]=_emscripten_enum_GeomAbs_Shape_GeomAbs_G2();Module["GeomAbs_C2"]=_emscripten_enum_GeomAbs_Shape_GeomAbs_C2();Module["GeomAbs_C3"]=_emscripten_enum_GeomAbs_Shape_GeomAbs_C3();Module["GeomAbs_CN"]=_emscripten_enum_GeomAbs_Shape_GeomAbs_CN();Module["BRepOffset_Skin"]=_emscripten_enum_BRepOffset_Mode_BRepOffset_Skin();Module["BRepOffset_Pipe"]=_emscripten_enum_BRepOffset_Mode_BRepOffset_Pipe();Module["BRepOffset_RectoVerso"]=_emscripten_enum_BRepOffset_Mode_BRepOffset_RectoVerso();Module["ChFi2d_NotPlanar"]=_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_NotPlanar();Module["ChFi2d_NoFace"]=_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_NoFace();Module["ChFi2d_InitialisationError"]=_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_InitialisationError();Module["ChFi2d_ParametersError"]=_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_ParametersError();Module["ChFi2d_Ready"]=_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_Ready();Module["ChFi2d_IsDone"]=_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_IsDone();Module["ChFi2d_ComputationError"]=_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_ComputationError();Module["ChFi2d_ConnexionError"]=_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_ConnexionError();Module["ChFi2d_TangencyError"]=_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_TangencyError();Module["ChFi2d_FirstEdgeDegenerated"]=_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_FirstEdgeDegenerated();Module["ChFi2d_LastEdgeDegenerated"]=_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_LastEdgeDegenerated();Module["ChFi2d_BothEdgesDegenerated"]=_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_BothEdgesDegenerated();Module["ChFi2d_NotAuthorized"]=_emscripten_enum_ChFi2d_ConstructionError_ChFi2d_NotAuthorized();Module["GeomAbs_Arc"]=_emscripten_enum_GeomAbs_JoinType_GeomAbs_Arc();Module["GeomAbs_Tangent"]=_emscripten_enum_GeomAbs_JoinType_GeomAbs_Tangent();Module["GeomAbs_Intersection"]=_emscripten_enum_GeomAbs_JoinType_GeomAbs_Intersection();Module["IFSelect_RetVoid"]=_emscripten_enum_IFSelect_ReturnStatus_IFSelect_RetVoid();Module["IFSelect_RetDone"]=_emscripten_enum_IFSelect_ReturnStatus_IFSelect_RetDone();Module["IFSelect_RetError"]=_emscripten_enum_IFSelect_ReturnStatus_IFSelect_RetError();Module["IFSelect_RetFail"]=_emscripten_enum_IFSelect_ReturnStatus_IFSelect_RetFail();Module["IFSelect_RetStop"]=_emscripten_enum_IFSelect_ReturnStatus_IFSelect_RetStop();Module["ShapeExtend_OK"]=_emscripten_enum_ShapeExtend_Status_ShapeExtend_OK();Module["ShapeExtend_DONE1"]=_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE1();Module["ShapeExtend_DONE2"]=_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE2();Module["ShapeExtend_DONE3"]=_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE3();Module["ShapeExtend_DONE4"]=_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE4();Module["ShapeExtend_DONE5"]=_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE5();Module["ShapeExtend_DONE6"]=_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE6();Module["ShapeExtend_DONE7"]=_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE7();Module["ShapeExtend_DONE8"]=_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE8();Module["ShapeExtend_DONE"]=_emscripten_enum_ShapeExtend_Status_ShapeExtend_DONE();Module["ShapeExtend_FAIL1"]=_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL1();Module["ShapeExtend_FAIL2"]=_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL2();Module["ShapeExtend_FAIL3"]=_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL3();Module["ShapeExtend_FAIL4"]=_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL4();Module["ShapeExtend_FAIL5"]=_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL5();Module["ShapeExtend_FAIL6"]=_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL6();Module["ShapeExtend_FAIL7"]=_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL7();Module["ShapeExtend_FAIL8"]=_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL8();Module["ShapeExtend_FAIL"]=_emscripten_enum_ShapeExtend_Status_ShapeExtend_FAIL();Module["GeomAbs_Plane"]=_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_Plane();Module["GeomAbs_Cylinder"]=_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_Cylinder();Module["GeomAbs_Cone"]=_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_Cone();Module["GeomAbs_Sphere"]=_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_Sphere();Module["GeomAbs_Torus"]=_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_Torus();Module["GeomAbs_BezierSurface"]=_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_BezierSurface();Module["GeomAbs_BSplineSurface"]=_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_BSplineSurface();Module["GeomAbs_SurfaceOfRevolution"]=_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_SurfaceOfRevolution();Module["GeomAbs_SurfaceOfExtrusion"]=_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_SurfaceOfExtrusion();Module["GeomAbs_OffsetSurface"]=_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_OffsetSurface();Module["GeomAbs_OtherSurface"]=_emscripten_enum_GeomAbs_SurfaceType_GeomAbs_OtherSurface();Module["BRepBuilderAPI_FaceDone"]=_emscripten_enum_BRepBuilderAPI_FaceError_BRepBuilderAPI_FaceDone();Module["BRepBuilderAPI_NoFace"]=_emscripten_enum_BRepBuilderAPI_FaceError_BRepBuilderAPI_NoFace();Module["BRepBuilderAPI_NotPlanar"]=_emscripten_enum_BRepBuilderAPI_FaceError_BRepBuilderAPI_NotPlanar();Module["BRepBuilderAPI_CurveProjectionFailed"]=_emscripten_enum_BRepBuilderAPI_FaceError_BRepBuilderAPI_CurveProjectionFailed();Module["BRepBuilderAPI_ParametersOutOfRange"]=_emscripten_enum_BRepBuilderAPI_FaceError_BRepBuilderAPI_ParametersOutOfRange();Module["STEPControl_AsIs"]=_emscripten_enum_STEPControl_StepModelType_STEPControl_AsIs();Module["STEPControl_ManifoldSolidBrep"]=_emscripten_enum_STEPControl_StepModelType_STEPControl_ManifoldSolidBrep();Module["STEPControl_BrepWithVoids"]=_emscripten_enum_STEPControl_StepModelType_STEPControl_BrepWithVoids();Module["STEPControl_FacetedBrep"]=_emscripten_enum_STEPControl_StepModelType_STEPControl_FacetedBrep();Module["STEPControl_FacetedBrepAndBrepWithVoids"]=_emscripten_enum_STEPControl_StepModelType_STEPControl_FacetedBrepAndBrepWithVoids();Module["STEPControl_ShellBasedSurfaceModel"]=_emscripten_enum_STEPControl_StepModelType_STEPControl_ShellBasedSurfaceModel();Module["STEPControl_GeometricCurveSet"]=_emscripten_enum_STEPControl_StepModelType_STEPControl_GeometricCurveSet();Module["STEPControl_Hybrid"]=_emscripten_enum_STEPControl_StepModelType_STEPControl_Hybrid();Module["BRepFill_NoContact"]=_emscripten_enum_BRepFill_TypeOfContact_BRepFill_NoContact();Module["BRepFill_Contact"]=_emscripten_enum_BRepFill_TypeOfContact_BRepFill_Contact();Module["BRepFill_ContactOnBorder"]=_emscripten_enum_BRepFill_TypeOfContact_BRepFill_ContactOnBorder()}if(runtimeInitialized)setupEnums();else addOnPreMain(setupEnums)})();this["opencascade"]=Module;


  return opencascade.ready
}
);
})();
export default opencascade;